<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
if (!defined ('_OPN_UPDATE_CLASS_INCLUDED') ) {
	include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.update.php');
}
global $opnConfig;

include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_vcs.php');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
include_once (_OPN_ROOT_PATH . 'include/opn_admin_functions.php');
$opnConfig['permission']->HasRight ('admin/modulinfos', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/modulinfos', true);

function sortboxarray ($a, $b) {

	$a1 = $a['name'];
	$b1 = $b['name'];
	return strcollcase ($a1, $b1);

}

function get_modulinfos ($plug = '') {

	$mytypearr = array ();
	foreach ($plug as $var1) {
		if (file_exists (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/version/index.php') ) {
			include_once (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/version/index.php');
			$myfunc = $var1['module'] . '_getversion';
			$help = array ();
			$myfunc ($help);
			$name = $var1['plugin'];
			$desc = $help['prog'];
			$version = $help['version'];
			$mytypearr[$name] = array ('version' => $version,
						'desc' => $desc,
						'plugin' => $var1['plugin'],
						'name' => $name,
						'module' => $var1['module']);
		}
	}
	return $mytypearr;

}

function modulinfosAdmin () {

	global $opnConfig;

	$opnConfig['opnSQL']->opn_dbcoreloader ('sql.opninit.php');
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$plug = array();
	$opnConfig['installedPlugins']->getplugin ($plug, 'version');
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$reccount = count ($plug);
	$plug = array_slice ($plug, $offset, $maxperpage);
	$modulinfos = get_modulinfos ($plug);
	usort ($modulinfos, 'sortboxarray');
	$table = & new opn_TableClass ('alternator');
	$table->InitTable ();
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol (_MODIF_MODULE, 'left');
	$table->AddHeaderCol (_MODIF_NAME, 'center');
	$table->AddHeaderCol (_MODIF_VERSION, 'center');
	$table->AddHeaderCol (_MODIF_SPEICHER, 'right');
	if ( ($opnConfig['permission']->UserInfo ('uid') == 2) && ($opnConfig['opn_multihome'] == 1) ) {
		$table->AddHeaderCol (_MODIF_MH_ACCESS, 'center');
		$opnConfig['webinclude'] = & new update_module ();
	}
	$table->AddCloseRow ();
	$i = 1;
	$module = & new MyModules;
	$gesamt = 0;
	foreach ($modulinfos as $page) {
		$i++;
		$module->SetModuleName ($page['module']);
		$module->LoadPrivateSettings ();
		$table->AddOpenRow ();
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
											'fct' => 'modulinfos',
											'op' => 'modulinfosShow',
											'module' => $page['module'],
											'plugin' => $page['plugin']) ) . '">' . $page['name'] . '</a>');
		$table->AddDataCol ($page['desc'], 'center');
		$table->AddDataCol ($page['version'], 'center');
		$total = getDirList (_OPN_ROOT_PATH . $page['plugin']);
		$gesamt = $gesamt+ $total;
		$table->AddDataCol (number_format ($total, 0, _DEC_POINT, _THOUSANDS_SEP), 'right');
		if ( ($opnConfig['permission']->UserInfo ('uid') == 2) && ($opnConfig['opn_multihome'] == 1) ) {
			if ($opnConfig['webinclude']->mhfix_check_module ($page['name']) == 0) {
				$table->AddDataCol (_NO, 'center');
			} else {
				$table->AddDataCol (_YES, 'center');
			}
		}
		$table->AddCloseRow ();
	}
	$table->AddOpenRow ();
	$table->AddDataCol ('&nbsp;');
	$table->AddDataCol ('&nbsp;');
	$table->AddDataCol (_MODIF_TOTAL, 'right');
	$table->AddDataCol (number_format ($gesamt, 0, _DEC_POINT, _THOUSANDS_SEP), 'right');
	$table->AddCloseRow ();
	$help = '';
	$table->GetTable ($help);
	$help .= '<br />';
	$help .= build_pagebar (array ($opnConfig['opn_url'] . '/admin.php',
					'fct' => 'modulinfos',
					'op' => 'show'),
					$reccount,
					$maxperpage,
					$offset,
					_MODIF_ALLINOURDATABASEARE);
	$help .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MODULINFOS_40_';
	$_display_dat['module'] = 'admin/modulinfos';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MODIF_ADMIN, $help);

}

function modulinfosShow () {

	global $opnConfig, $opnTables;

	$boxtxt = '<a class="opncenterbox" href="' . encodeurl (array($opnConfig['opn_url'] . '/admin.php', 'fct' => 'modulinfos') ) . '">' . _MODIF_BACKTOOVERVIEW . '</a><br /><br />';
	$module = '';
	get_var ('module', $module, 'both', _OOBJ_DTYPE_CLEAN);
	$plugin = '';
	get_var ('plugin', $plugin, 'both', _OOBJ_DTYPE_CLEAN);
	$function = '';
	get_var ('updatecheck', $function, 'form', _OOBJ_DTYPE_CLEAN);
	$thismodule['plugin'] = $plugin;
	$thismodule['module'] = $module;
	$version = & new OPN_VersionsControllSystem ('');
	$version->SetModulename ($plugin);
	$vcs_dbversion = $version->GetDBversion ();
	$vcs_fileversion = $version->GetFileversion ();
	$version->ReadVersionFileIntoArray ();
	$actualversion = $version->GetVersionFromArray ();
	$actualdbversion = $version->GetDBVersionFromArray ();
	$actualfileversion = $version->GetFileVersionFromArray ();
	$desc = $version->GetProgNameFromArray ();
	$additionalinfos = $version->GetAdditionalInfoFromArray ();
	$name = $plugin;
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_ADMIN_MODULINFOS_50_', 'moduleinfos');
	$form->Init ($opnConfig['opn_url'] . '/admin.php', 'post');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddText (_MODIF_MODULE);
	$form->AddText ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/admin.php',
									'fct' => 'modulinfos',
									'op' => 'modulinfosShow',
									'module' => $module,
									'plugin' => $name) ) . '">' . $name . '</a>');
	$form->AddChangeRow ();
	$form->AddText (_MODIF_VERSION);
	$form->AddText ($actualversion);
	$form->AddChangeRow ();
	$form->AddText (_MODIF_NAME);
	$form->AddText ($desc);
	$form->AddChangeRow ();
	$form->AddText (_MODIF_VERSION_DB);
	$form->AddText ($actualdbversion . ' (' . _MODIF_VERSION_DB_INST . ': ' . $vcs_dbversion . ')');
	$form->AddChangeRow ();
	$form->AddText (_MODIF_VERSION_FILE);
	$form->AddText ($actualfileversion . ' (' . _MODIF_VERSION_FILE_INST . ': ' . $vcs_fileversion . ')');
	$form->AddChangeRow ();
	foreach ($additionalinfos as $key => $value) {
		$form->AddText ('' . ucfirst ($key) );
		$form->AddText ($value);
		$form->AddChangeRow ();
	}
	$admin_item = explode ('/', $name);
	$folder = _OPN_ROOT_PATH . $name;
	$wfolder = $admin_item[0];
	$update = false;
	$admin_item_array = get_plugins ($folder, $admin_item[1], TRUE, $wfolder, $update);
	$missing = '';
	if (is_array ($admin_item_array) ) {
		if ( (isset ($admin_item_array['need']) ) && ($admin_item_array['need'] != '') ) {
			$need = explode (',', $admin_item_array['need']);
			$max = count ($need);
			for ($i = 0; $i< $max; $i++) {
				$missing .= $need[$i] . '<br />';
			}
		}
		if ($missing != '') {
			$form->AddText (_MODIF_MODUL_NEED);
			$form->AddText ($missing);
			$form->AddChangeRow ();
		}
		$missing = '';
		if ( (isset ($admin_item_array['nicetohave']) ) && ($admin_item_array['nicetohave'] != '') ) {
			$need = explode (',', $admin_item_array['nicetohave']);
			$max = count ($need);
			for ($i = 0; $i< $max; $i++) {
				$missing .= $need[$i] . '<br />';
			}
		}
		if ($missing != '') {
			$form->AddText (_MODIF_MODUL_NICETOHAVE);
			$form->AddText ($missing);
			$form->AddChangeRow ();
		}
	}

	$_exception = '';
	$_shared_opn_class = '';

	$o_module = $opnConfig['opnSQL']->qstr ($plugin);
	$sql = 'SELECT id, shared_opn_class, options FROM ' . $opnTables['opn_class_register']. ' WHERE (module='.$o_module.') AND (shared_opn_class<>\'\')';
	$info = &$opnConfig['database']->Execute ($sql);
	while (! $info->EOF) {
		$myoptions = unserialize ($info->fields['options']);
		if (isset($myoptions['field'])) {
			$myfield = $myoptions['field'];
		} else {
			$myfield = '';
		}
		$_shared_opn_class .= $info->fields['shared_opn_class'].' ('.$myfield.')<br />';
		$info->MoveNext ();
	}
	$sql = 'SELECT id, exception_name, exception_point, function_name FROM ' . $opnTables['opn_exception_register']. ' WHERE (module='.$o_module.') AND (exception_name<>\'\')';
	$info = &$opnConfig['database']->Execute ($sql);
	while (! $info->EOF) {
		$_exception .= $info->fields['exception_name'].': '.$info->fields['exception_point'].' -> '.$info->fields['function_name'];
		$info->MoveNext ();
	}

	$form->AddText (_MODIF_MODUL_USED_REGISTER_CLASS);
	$form->AddText ($_shared_opn_class);
	$form->AddChangeRow ();

	$form->AddText (_MODIF_MODUL_USED_REGISTER_EXCEPTION);
	$form->AddText ($_exception);
	$form->AddChangeRow ();

	$form->SetSameCol ();
	$form->AddHidden ('fct', 'modulinfos');
	$form->AddHidden ('op', 'modulinfosShow');
	$form->AddHidden ('module', $module);
	$form->AddHidden ('plugin', $plugin);
	$form->AddHidden ('show', 1);
	$form->SetEndCol ();
	if (!$version->IsAnyVersionNewer () ) {
		$form->AddSubmit ('updatecheck', _MODIF_UPDATECHECK);
	} else {
		$form->AddSubmit ('updatecheck', _MODIF_INSTALLUPDATE);
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MODULINFOS_60_';
	$_display_dat['module'] = 'admin/modulinfos';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_MODIF_ADMIN, $boxtxt);
	if ($function == _MODIF_INSTALLUPDATE) {

		$infoarr = array ();
		$version->UpdateModule ($infoarr, $thismodule);
		switch ($infoarr['status']) {
			case 0:
				$thetext = _MODIF_STATUS0 . ' (' . $infoarr['whathasbeendone'] . ')';
				break;
			case 1:
				$thetext = _MODIF_STATUS1 . ' (' . $infoarr['whathasbeendone'] . ')';
				break;
			case 2:
				$thetext = _MODIF_STATUS2 . ' (' . $infoarr['whathasbeendone'] . ')';
				break;
			default:
				$thetext = '';
			}
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MODULINFOS_70_';
			$_display_dat['module'] = 'admin/modulinfos';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_MODIF_ADMIN, $thetext);
		}
		if ($function == _MODIF_UPDATECHECK) {

			$opnConfig['update'] = & new opn_update ();
			$send['op'] = 'project_info';
			$send['prog'] = 'opn_forge';
			$send['vari'] = $plugin . '++' . _get_core_major_version ();
			$opnConfig['update']->_insert ('updateserver', 'http://www.openphpnuke.net');
			$opnConfig['update']->_insert ('prog', 'masterinterface.php');
			$data = $opnConfig['update']->calling_server ($send);
			$data = explode ('++', $data);
			$remoteinfo = array ('version' => 0,
					'fileversion' => 0,
					'dbversion' => 0);
			$counted = count ($data);
			for ($k = 0; $k<$counted; $k++) {
				$vordaten = explode ('::', $data[$k]);
				if ( (isset ($vordaten[0]) ) && (isset ($vordaten[1]) ) ) {
					if (substr_count ($vordaten[0], 'PROJECT_')>0) {
						$vordaten[0] = str_replace ('PROJECT_', '', $vordaten[0]);
					}
					$remoteinfo[$vordaten[0]] = $vordaten[1];
					if ($vordaten[0] != strtoupper ($vordaten[0]) ) {
						$showinfo[$vordaten[0]] = $vordaten[1];
					}
				}
			}
			if ( (isset ($remoteinfo['INTERN']) ) && ($remoteinfo['INTERN'] == $name) ) {
				$form->Init ($opnConfig['opn_url'] . '/admin.php', 'post');
				$form->AddTable ();
				$form->AddCols (array ('10%', '90%') );
				$x = 0;
				foreach ($showinfo as $key => $value) {
					if ($x == 0) {
						$form->AddOpenRow ();
						$x++;
					} else {
						$form->AddChangeRow ();
					}
					$form->AddText ('' . ucfirst ($key) );
					$form->AddText ($value);
				}
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$data = '<span class="normaltext">' . _MODIF_UPDATECHECKSUBTITLE . '</span>';
				$form->GetFormular ($data);

				#$data .= print_array($showinfo);

				#$data .= print_array($remoteinfo);

				/*
				sollte der User selber entscheiden. Daher derzeit nur Anzeige der gelieferten Daten
				if ((($vcs_fileversion < $remoteinfo['fileversion']) || ($vcs_dbversion < $remoteinfo['dbversion']) || ($actualversion < $remoteinfo['version']) ) &&
				(($remoteinfo['fileversion'] != 'N/V') || ($remoteinfo['dbversion'] != 'N/V') && ($remoteinfo['version'] != 'N/V') ) ) {

				$data .= '<br />';
				$data .= 'Hier Zip ist hier?';
				} else {
				$data .= '<br />';
				$data .= 'Kein Update vorhanden';
				}
				*/
			} else {
				$data = '<span class="alerttext">' . _MODINF_MODULEDATADOESNTMATCH . '</span>';
			}

			/*
			$opnConfig['update'] = & new opn_update();
			$checkversion='';
			$opnConfig['update']->vcsopn_get_fileversion ($plugin,$checkversion);

			include_once(_OPN_ROOT_PATH.'admin/updatemanager/index.php');
			_upd_getmodulupdate ($plugin);
			$btxt = '';
			if (function_exists('re_getmodulupdate')) {
			$new_help='';
			re_getmodulupdate ($new_help);


			$myhelp = '';
			$opnConfig['update'] = & new opn_update();
			$opnConfig['update']->vcsopn_get_fileversion_last ($new_help,$help,$myhelp);

			if ((isset($myhelp)) && (is_array($myhelp)) && (isset($myhelp['fileversion']))) {
			$btxt = _MODIF_NEW_VERSION_FOUND.'&nbsp;'._MODIF_PLEASE_LOAD_HIER.' '.'<a class="opncenterbox" href="'.$myhelp ['fileversion_url'] .'">'._MODIF_VERSION.' '.$myhelp ['fileversion'] .'</a>';
			} else {
			$btxt = _MODIF_SORRY_NO_NEW_VERSION_FOUND;
			}
			$_display_dat = array();
			$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MODULINFOS_80_';
			$_display_dat['module'] = 'admin/modulinfos';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_MODIF_ADMIN, $btxt);
			} else {
			*/

			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_ADMIN_MODULINFOS_90_';
			$_display_dat['module'] = 'admin/modulinfos';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_MODIF_UPDATECHECKTITLE, $data);
			// }
		}
	}

	function getDirList ($dirName) {

		$total = 0;
		if (fileperms ($dirName)>16639) {
			$d = @opendir ($dirName);
			while ($entry = readdir ($d) ) {
				if ($entry != '.' && $entry != '..') {
					if (@is_dir ($dirName . '/' . $entry) ) {
						$total = $total+@getDirList ($dirName . '/' . $entry);
					} else {
						$filesize = @filesize ($dirName . '/' . $entry);
						$total = $total+ $filesize;
					}
				}
			}
			closedir ($d);
		}
		return $total;

}

?>