<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function user_group_repair_sql_table () {

	global $opnConfig;

	$opn_plugin_sql_table['table']['user_group']['gid'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group']['user_group_id'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group']['user_group_text'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 100, "");
	$opn_plugin_sql_table['table']['user_group']['user_group_members'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_BLOB);
	$opn_plugin_sql_table['table']['user_group']['user_group_webmaster'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group']['user_group_orgtext'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 100, "");
	$opn_plugin_sql_table['table']['user_group']['___opn_key1'] = $opnConfig['opnSQL']->GetPrimaryKey (Array ('gid'),
														'user_group');
	$opn_plugin_sql_table['table']['user_group_rights']['perm_id'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group_rights']['perm_user_group'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group_rights']['perm_module'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 100, "");
	$opn_plugin_sql_table['table']['user_group_rights']['perm_rights'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 35, '00000X00000X00000X00000X00000X00000');
	$opn_plugin_sql_table['table']['user_group_rights']['___opn_key1'] = $opnConfig['opnSQL']->GetPrimaryKey (Array ('perm_id'),
															'user_group_rights');
	$opn_plugin_sql_table['table']['user_group_users']['ugu_id'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group_users']['ugu_gid'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group_users']['ugu_uid'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['user_group_users']['___opn_key1'] = $opnConfig['opnSQL']->GetPrimaryKey (Array ('ugu_id'),
															'user_group_users');
	return $opn_plugin_sql_table;

}

function user_group_repair_sql_index () {

	$opn_plugin_sql_index['index']['user_group']['___opn_key1'] = 'user_group_id';
	$opn_plugin_sql_index['index']['user_group']['___opn_key2'] = 'user_group_text';
	$opn_plugin_sql_index['index']['user_group']['___opn_key3'] = 'user_group_orgtext';
	$opn_plugin_sql_index['index']['user_group_rights']['___opn_key1'] = 'perm_user_group';
	$opn_plugin_sql_index['index']['user_group_rights']['___opn_key2'] = 'perm_module';
	$opn_plugin_sql_index['index']['user_group_rights']['___opn_key3'] = 'perm_user_group,perm_module';
	$opn_plugin_sql_index['index']['user_group_users']['___opn_key1'] = 'ugu_uid';
	$opn_plugin_sql_index['index']['user_group_users']['___opn_key2'] = 'ugu_gid';
	return $opn_plugin_sql_index;

}

function user_group_repair_sql_data () {

	$opn_plugin_sql_data['data']['user_group'][] = "1, 0, 'Anonymous', '',0, 'Anonymous'";
	$opn_plugin_sql_data['data']['user_group'][] = "2, 1, 'User', 'a:1:{i:0;i:0;}',0, 'User'";
	$opn_plugin_sql_data['data']['user_group'][] = "3, 2, 'Author', '',0, 'Author'";
	$opn_plugin_sql_data['data']['user_group'][] = "4, 3, 'Moderator', '',0, 'Moderator'";
	$opn_plugin_sql_data['data']['user_group'][] = "5, 4, 'Super Moderator', '',0, 'Super Moderator'";
	$opn_plugin_sql_data['data']['user_group'][] = "6, 5, 'Customer', '',0, 'Customer'";
	$opn_plugin_sql_data['data']['user_group'][] = "7, 6, 'B2C Customer', '',0, 'B2C Customer'";
	$opn_plugin_sql_data['data']['user_group'][] = "8, 7, 'B2B Customer', '',0, 'B2B Customer'";
	$opn_plugin_sql_data['data']['user_group'][] = "9, 8, 'Reseller', '',0, 'Reseller'";
	$opn_plugin_sql_data['data']['user_group'][] = "10, 9, 'Administrator', '',0, 'Administrator'";
	$opn_plugin_sql_data['data']['user_group'][] = "11, 10, 'Webmaster', 'a:1:{i:0;i:1;}',1, 'Webmaster'";
	$opn_plugin_sql_data['data']['user_group'][] = "12, 11, 'Reserve 11', '',0, 'Reserve 11'";
	$opn_plugin_sql_data['data']['user_group'][] = "13, 12, 'Reserve 12', '',0, 'Reserve 12'";
	$opn_plugin_sql_data['data']['user_group'][] = "14, 13, 'Reserve 13', '',0, 'Reserve 13'";
	$opn_plugin_sql_data['data']['user_group'][] = "15, 14, 'Reserve 14', '',0, 'Reserve 14'";
	$opn_plugin_sql_data['data']['user_group'][] = "16, 15, 'Reserve 15', '',0, 'Reserve 15'";
	$opn_plugin_sql_data['data']['user_group'][] = "17, 16, 'Reserve 16', '',0, 'Reserve 16'";
	$opn_plugin_sql_data['data']['user_group'][] = "18, 17, 'Reserve 17', '',0, 'Reserve 17'";
	$opn_plugin_sql_data['data']['user_group'][] = "19, 18, 'Reserve 18', '',0, 'Reserve 18'";
	$opn_plugin_sql_data['data']['user_group'][] = "20, 19, 'Reserve 19', '',0, 'Reserve 19'";
	$opn_plugin_sql_data['data']['user_group'][] = "21, 20, 'Reserve 20', '',0, 'Reserve 20'";
	$opn_plugin_sql_data['data']['user_group_rights'][] = "1, 0, 'system/user', '00000X00000X00000X00000X00000X00263'";
	$opn_plugin_sql_data['data']['user_group_rights'][] = "2, 0, 'system/onlinehilfe', '00000X00000X00000X00000X00000X00001'";
	return $opn_plugin_sql_data;

}

?>