<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'admin/useradmin/language/');
include_once (_OPN_ROOT_PATH . 'include/opn_admin_functions.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.adminmenu.php');
$opnConfig['permission']->HasRight ('admin/useradmin', _PERM_ADMIN);
$opnConfig['module']->InitModule ('admin/useradmin', true);
$pubsettings = $opnConfig['module']->GetPublicSettings ();
$privsettings = $opnConfig['module']->GetPrivateSettings ();
$opnConfig['opnOutput']->SetDisplayToAdminDisplay ();
getLanguageDef (_OPN_ROOT_PATH . 'admin/useradmin/language/');

function useradmin_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _USERADMIN_SAVE_CHANGES);
	return $values;

}

function useradmin_makenavbar ($nonav) {

	$nav[_USERADMIN_NAVGENERAL] = _USERADMIN_NAVGENERAL;
	$nav[_USERADMIN_NAVAOUS] = _USERADMIN_NAVAOUS;
	$nav[_USERADMIN_ADMIN] = _USERADMIN_ADMIN;
	$nav[$nonav] = '';
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function usersettings () {

	global $opnConfig, $pubsettings, $privsettings;

	$set = & new MySettings;
	$set->SetModule = 'admin/useradmin';
	$set->SetHelpID ('_OPNDOCID_ADMIN_USERADMIN_USERSETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _USERADMIN_GENERAL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_ALLOWEMAILCHANGEBYUSER,
			'name' => 'user_home_allowemailchangebyuser',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['user_home_allowemailchangebyuser'] == 1?true : false),
			 ($pubsettings['user_home_allowemailchangebyuser'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_ALLOWETHEMECHANGEBYUSER,
			'name' => 'user_home_allowethemechangebyuser',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['user_home_allowethemechangebyuser'] == 1?true : false),
			 ($pubsettings['user_home_allowethemechangebyuser'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_ALLOWETHEMEGROUPCHANGEBYUSER,
			'name' => 'user_home_allowethemegroupchangebyuser',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['user_home_allowethemegroupchangebyuser'] == 1?true : false),
			 ($pubsettings['user_home_allowethemegroupchangebyuser'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_ADMINMAILIFUSERDEL,
			'name' => 'user_delmailtoadmin',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['user_delmailtoadmin'] == 1?true : false),
			 ($privsettings['user_delmailtoadmin'] == 0?true : false) ) );
	if ($opnConfig['opn_activatetype']>0) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _USERADMIN_ADMINDELETEREAL,
				'name' => 'user_deletereal',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($privsettings['user_deletereal'] == 1?true : false),
				 ($privsettings['user_deletereal'] == 0?true : false) ) );
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'user_deletereal',
				'value' => 0);
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_adress') ) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _USERADMIN_DISPLAY_ON_REGISTER,
				'name' => 'display_on_register',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($privsettings['display_on_register'] == 1?true : false),
				 ($privsettings['display_on_register'] == 0?true : false) ) );
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'display_on_register',
				'value' => 1);
	}
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_ALLOWEUSERREG,
			'name' => 'user_reg_allownewuser',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['user_reg_allownewuser'] == 1?true : false),
			 ($privsettings['user_reg_allownewuser'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _USERADMIN_ALLOWEUSERREGDISABLE,
			'name' => 'user_reg_disallownewuser_txt',
			'value' => $privsettings['user_reg_disallownewuser_txt'],
			'wrap' => '',
			'cols' => 80,
			'rows' => 8);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_ALLOWLOSTPASSWORDLINK,
			'name' => 'user_reg_allowlostpasswordlink',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['user_reg_allowlostpasswordlink'] == 1?true : false),
			 ($privsettings['user_reg_allowlostpasswordlink'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_USERREGSUPPORTMODE,
			'name' => 'user_reg_usesupportmode',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['user_reg_usesupportmode'] == 1?true : false),
			 ($pubsettings['user_reg_usesupportmode'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _USERADMIN_USERREGSUPPORTMODEMSG,
			'name' => 'user_reg_usesupportmode_txt',
			'value' => $privsettings['user_reg_usesupportmode_txt'],
			'wrap' => '',
			'cols' => 80,
			'rows' => 8);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _USERADMIN_TITLEFORNEWUSER,
			'name' => 'user_reg_newusermessage_title',
			'value' => $privsettings['user_reg_newusermessage_title'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _USERADMIN_MESSAGEFORNEWUSER,
			'name' => 'user_reg_newusermessage_txt',
			'value' => $privsettings['user_reg_newusermessage_txt'],
			'wrap' => '',
			'cols' => 80,
			'rows' => 8);
	$options = array ();
	$options[$opnConfig['opn_anonymous_name']] = 1;
	$result = $opnConfig['permission']->GetSelectUserList ();
	if ($result !== false) {
		while (! $result->EOF) {
			$options[$result->fields['uname']] = $result->fields['uid'];
			$result->MoveNext ();
		}
		$result->Close ();
	}
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _USERADMIN_FROMUSERFORNEWUSER,
			'name' => 'user_reg_newusermessage_fromuser',
			'options' => $options,
			'selected' => $privsettings['user_reg_newusermessage_fromuser']);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_USERASBLACKLIST,
			'rowspan' => 2,
			'name' => 'user_reg_new_user_userasblacklist',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($opnConfig['user_reg_new_user_userasblacklist'] == 1?true : false),
			 ($opnConfig['user_reg_new_user_userasblacklist'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _USERADMIN_USERASBLACKLISTINFO);
	if ( (!isset ($opnConfig['user_reg_list_username']) ) || !is_array ($opnConfig['user_reg_list_username']) ) {
		$opnConfig['user_reg_list_username'] = array ();
	}
	foreach ($opnConfig['user_reg_list_username'] as $key => $value) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _USERADMIN_USERTITLE,
				'name' => 'listusername_' . $key,
				'value' => $value,
				'size' => 40,
				'maxlength' => 60);
	}
	$mycount = count ($opnConfig['user_reg_list_username'])+1;
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _USERADMIN_USERTITLE,
			'name' => 'listusername_' . $mycount,
			'value' => '',
			'size' => 40,
			'maxlength' => 60);
	$values = array_merge ($values, useradmin_makenavbar (_USERADMIN_NAVGENERAL) );
	$values = array_merge ($values, useradmin_allhiddens (_USERADMIN_NAVGENERAL) );
	$set->GetTheForm (_USERADMIN_SETTINGS, $opnConfig['opn_url'] . '/admin/useradmin/settings.php', $values);

}

function aoussettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$set->SetModule = 'admin/useradmin';
	$set->SetHelpID ('_OPNDOCID_ADMIN_USERADMIN_AOUSSETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _USERADMIN_NAVAOUS);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _USERADMIN_USERAOUS_OPN,
			'name' => 'opn_user_aous_opn',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['opn_user_aous_opn'] == 1?true : false),
			 ($pubsettings['opn_user_aous_opn'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_BLANKLINE);
	if ($pubsettings['opn_user_aous_opn'] == 1) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _USERADMIN_USERMASTER_OPN,
				'name' => 'opn_user_master_opn',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($pubsettings['opn_user_master_opn'] == 1?true : false),
				 ($pubsettings['opn_user_master_opn'] == 0?true : false) ) );
		if ($pubsettings['opn_user_master_opn'] == 1) {
			$values[] = array ('type' => _INPUT_TEXT,
					'display' => _USERADMIN_USERMASTER_SENDTOMAIL_OPN,
					'name' => 'opn_user_master_sendtomail_opn',
					'value' => $pubsettings['opn_user_master_sendtomail_opn'],
					'size' => 40,
					'maxlength' => 100);
			$values[] = array ('type' => _INPUT_TEXT,
					'display' => _USERADMIN_USERMASTER_SENDTOPASS_OPN,
					'name' => 'opn_user_master_sendtopass_opn',
					'value' => $pubsettings['opn_user_master_sendtopass_opn'],
					'size' => 40,
					'maxlength' => 100);
			$values[] = array ('type' => _INPUT_RADIO,
					'display' => _USERADMIN_USERMASTER_SENDTOREG_OPN,
					'name' => 'opn_user_master_sendtoreg_opn',
					'values' => array (1,
					0),
					'titles' => array (_YES,
					_NO),
					'checked' => array ( ($pubsettings['opn_user_master_sendtoreg_opn'] == 1?true : false),
					 ($pubsettings['opn_user_master_sendtoreg_opn'] == 0?true : false) ) );
			$values[] = array ('type' => _INPUT_RADIO,
					'display' => _USERADMIN_USERMASTER_SENDTOEDIT_OPN,
					'name' => 'opn_user_master_sendtoedit_opn',
					'values' => array (1,
					0),
					'titles' => array (_YES,
					_NO),
					'checked' => array ( ($pubsettings['opn_user_master_sendtoedit_opn'] == 1?true : false),
					 ($pubsettings['opn_user_master_sendtoedit_opn'] == 0?true : false) ) );
			$values[] = array ('type' => _INPUT_TEXT,
					'display' => _USERADMIN_USERMASTER_SENDTO_EMAILS,
					'name' => 'opn_user_master_emails',
					'value' => $pubsettings['opn_user_master_emails'],
					'size' => 4,
					'maxlength' => 4);
		} else {
			$values[] = array ('type' => _INPUT_HIDDEN,
					'name' => 'opn_user_master_sendtomail_opn',
					'value' => $pubsettings['opn_user_master_sendtomail_opn']);
			$values[] = array ('type' => _INPUT_HIDDEN,
					'name' => 'opn_user_master_sendtopass_opn',
					'value' => $pubsettings['opn_user_master_sendtopass_opn']);
			$values[] = array ('type' => _INPUT_HIDDEN,
					'name' => 'opn_user_master_sendtoreg_opn',
					'value' => $pubsettings['opn_user_master_sendtoreg_opn']);
			$values[] = array ('type' => _INPUT_HIDDEN,
					'name' => 'opn_user_master_sendtoedit_opn',
					'value' => $pubsettings['opn_user_master_sendtoedit_opn']);
			$values[] = array ('type' => _INPUT_HIDDEN,
					'name' => 'opn_user_master_emails',
					'value' => $pubsettings['opn_user_master_emails']);
		}
		$values[] = array ('type' => _INPUT_BLANKLINE);
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _USERADMIN_USERCLIENT_OPN,
				'name' => 'opn_user_client_opn',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($pubsettings['opn_user_client_opn'] == 1?true : false),
				 ($pubsettings['opn_user_client_opn'] == 0?true : false) ) );
		if ($pubsettings['opn_user_client_opn'] == 1) {
			$values[] = array ('type' => _INPUT_TEXT,
					'display' => _USERADMIN_USERCLIENT_PASS_OPN,
					'name' => 'opn_user_client_pass_opn',
					'value' => $pubsettings['opn_user_client_pass_opn'],
					'size' => 40,
					'maxlength' => 100);
		} else {
			$values[] = array ('type' => _INPUT_HIDDEN,
					'name' => 'opn_user_client_pass_opn',
					'value' => $pubsettings['opn_user_client_pass_opn']);
		}
		$values[] = array ('type' => _INPUT_BLANKLINE);
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_master_opn',
				'value' => 0);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_master_sendtomail_opn',
				'value' => $pubsettings['opn_user_master_sendtomail_opn']);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_master_sendtopass_opn',
				'value' => $pubsettings['opn_user_master_sendtopass_opn']);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_master_sendtoreg_opn',
				'value' => $pubsettings['opn_user_master_sendtoreg_opn']);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_master_sendtoedit_opn',
				'value' => $pubsettings['opn_user_master_sendtoedit_opn']);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_client_opn',
				'value' => 0);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_client_pass_opn',
				'value' => $pubsettings['opn_user_client_pass_opn']);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_user_master_emails',
				'value' => $pubsettings['opn_user_master_emails']);
	}
	$values = array_merge ($values, useradmin_makenavbar (_USERADMIN_NAVAOUS) );
	$values = array_merge ($values, useradmin_allhiddens (_USERADMIN_NAVAOUS) );
	$set->GetTheForm (_USERADMIN_SETTINGS, $opnConfig['opn_url'] . '/admin/useradmin/settings.php', $values);

}

function useradmin_dosavesettings () {

	global $opnConfig, $privsettings, $pubsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();
	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePublicSettings ();

}

function useradmin_dosaveuser ($vars) {

	global $pubsettings, $privsettings, $opnConfig;

	$pubsettings['user_home_allowemailchangebyuser'] = $vars['user_home_allowemailchangebyuser'];
	$pubsettings['user_home_allowethemechangebyuser'] = $vars['user_home_allowethemechangebyuser'];
	$pubsettings['user_home_allowethemegroupchangebyuser'] = $vars['user_home_allowethemegroupchangebyuser'];
	$privsettings['user_delmailtoadmin'] = $vars['user_delmailtoadmin'];
	$privsettings['user_deletereal'] = $vars['user_deletereal'];
	$privsettings['user_reg_allownewuser'] = $vars['user_reg_allownewuser'];
	$privsettings['user_reg_disallownewuser_txt'] = $vars['user_reg_disallownewuser_txt'];
	$pubsettings['user_reg_usesupportmode'] = $vars['user_reg_usesupportmode'];
	$privsettings['user_reg_usesupportmode_txt'] = $vars['user_reg_usesupportmode_txt'];
	if ($vars['user_reg_usesupportmode']) {
		include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_activation.php');
		if (!defined ('_OPN_MAILER_INCLUDED') ) {
			include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
		}
		$uid = $opnConfig['permission']->Userinfo ('uid');
		$email = $opnConfig['permission']->Userinfo ('email');
		$activation = & new OPNActivation ();
		$activation->InitActivation ();
		$activation->BuildActivationKey ();
		$activation->SetActdata ($uid);
		$key = $activation->GetActivationKey ();
		$activation->SaveActivation ();
		$url = array ($opnConfig['opn_url'] . '/system/user/index.php',
				'code' => $key,
				'uid' => $uid,
				'op' => 'deactsupport');
		$vars['{URL1}'] = encodeurl ($url, false);
		$url = array ($opnConfig['opn_url'] . '/system/user/index.php',
				'code' => $key,
				'uid' => $uid,
				'op' => 'actlogin');
		$vars['{URL2}'] = encodeurl ($url, false);
		$from = $opnConfig['adminmail'];
		$mail = & new opn_mailer ();
		$mail->opn_mail_fill ($email, _USERADMIN_MAINTENANCE_SUBJECT, 'admin/useradmin', 'support', $vars, $opnConfig['opn_webmaster_name'], $from);
		$mail->send ();
		$mail->init ();
	}
	$privsettings['user_reg_allowlostpasswordlink'] = $vars['user_reg_allowlostpasswordlink'];
	$privsettings['display_on_register'] = $vars['display_on_register'];
	$privsettings['user_reg_newusermessage_title'] = $vars['user_reg_newusermessage_title'];
	$privsettings['user_reg_newusermessage_txt'] = $vars['user_reg_newusermessage_txt'];
	$privsettings['user_reg_newusermessage_fromuser'] = $vars['user_reg_newusermessage_fromuser'];
	$privsettings['user_reg_new_user_userasblacklist'] = $vars['user_reg_new_user_userasblacklist'];
	$privsettings['user_reg_list_username'] = array ();
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'listusername')>0) {
			if ($value != '') {
				$privsettings['user_reg_list_username'][] = $value;
			}
		}
	}
	useradmin_dosavesettings ();

}

function useradmin_dosaveaous ($vars) {

	global $pubsettings;

	$pubsettings['opn_user_aous_opn'] = $vars['opn_user_aous_opn'];
	$pubsettings['opn_user_master_opn'] = $vars['opn_user_master_opn'];
	$pubsettings['opn_user_master_sendtomail_opn'] = $vars['opn_user_master_sendtomail_opn'];
	$pubsettings['opn_user_master_sendtopass_opn'] = $vars['opn_user_master_sendtopass_opn'];
	$pubsettings['opn_user_master_sendtoreg_opn'] = $vars['opn_user_master_sendtoreg_opn'];
	$pubsettings['opn_user_master_sendtoedit_opn'] = $vars['opn_user_master_sendtoedit_opn'];
	$pubsettings['opn_user_master_emails'] = $vars['opn_user_master_emails'];
	$pubsettings['opn_user_client_opn'] = $vars['opn_user_client_opn'];
	$pubsettings['opn_user_client_pass_opn'] = $vars['opn_user_client_pass_opn'];
	useradmin_dosavesettings ();

}

function useradmin_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _USERADMIN_NAVGENERAL:
			useradmin_dosaveuser ($returns);
			break;
		case _USERADMIN_NAVAOUS:
			useradmin_dosaveaous ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		useradmin_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _USERADMIN_SAVE_CHANGES:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/admin/useradmin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _USERADMIN_ADMIN:
		$opnConfig['opnOutput']->Redirect ($opnConfig['opn_url'] . '/admin/useradmin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	case _USERADMIN_NAVAOUS:
		aoussettings ();
		break;
	default:
		usersettings ();
		break;
}

?>