<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_CODE_FILTER_INCLUDED') ) {
	define ('_OPN_CLASS_CODE_FILTER_INCLUDED', 1);

	class OPN_code_filter {

		/*<{php4}>
		var $parserLocation;
		var $parserFilters = array();
		<{php4/}>*/

		/*<{php5}>
		public $parserLocation;
		public $parserFilters = array();
		<{php5/}>*/

		/*<{delete}>*/
		var $parserLocation;
		var $parserFilters = array();
		/*<{delete/}>*/

		function OPN_code_filter ($location = './') {

			$this->parserLocation = $location;
			$this->_loadCodes ();

		}

		function _loadCodes () {

			$dir2scan = $this->parserLocation . 'filters/';
			$filterDir = opendir ($dir2scan);
			while ($filterDirEntry = readdir ($filterDir) ) {
				if ( (is_file ($dir2scan . $filterDirEntry) ) && (substr_count ($dir2scan . $filterDirEntry, '.class.php')>0) ) {
					include ($dir2scan . $filterDirEntry);
					$filterName = explode ('.', $filterDirEntry);
					$className = 'OPN_FILTER_' . $filterName[0];
					if (class_exists ($className) == true) {
						$this->parserFilters[] =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $className;
					}
				}
			}
			closedir ($filterDir);

		}

		function getParsedText ($text) {

			foreach ($this->parserFilters as $k => $v) {
				$text = $v->parse ($text);
			}
			return $text;

		}

		function getReversedParsedText ($text) {

			foreach ($this->parserFilters as $k => $v) {
				$text = $v->parseReverse ($text);
			}
			return $text;

		}

	}
}

?>