<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_CODE_MACRO_INCLUDED') ) {
	define ('_OPN_CLASS_CODE_MACRO_INCLUDED', 1);

	class OPN_code_macro {

		/*<{php4}>
		var $parserLocation;
		var $parserFilters = array();
		var $parserFiltersXL = array();
		<{php4/}>*/

		/*<{php5}>
		public $parserLocation;
		public $parserFilters = array();
		public $parserFiltersXL = array();
		<{php5/}>*/

		/*<{delete}>*/
		var $parserLocation;
		var $parserFilters = array();
		var $parserFiltersXL = array();
		/*<{delete/}>*/

		function OPN_code_macro ($location = './') {

			global $opnConfig;

			$plug = array();
			$opnConfig['installedPlugins']->getplugin ($plug, 'macrofilter_xt');
			foreach ($plug as $var) {
				$this->parserLocation = _OPN_ROOT_PATH . $var['plugin'] . '/plugin/';
				$this->_loadCodes ();
			}
			$this->parserLocation = $location;
			$this->_loadCodes ();

		}

		function _loadCodes () {

			global $opnConfig;

			$dir2scan = $this->parserLocation . 'macros/';
			$filterDir = opendir ($dir2scan);
			while ($filterDirEntry = readdir ($filterDir) ) {
				if ( (is_file ($dir2scan . $filterDirEntry) ) && (substr_count ($dir2scan . $filterDirEntry, '.class.php')>0) ) {
					$filterName = explode ('.', $filterDirEntry);
					if ( (isset ($opnConfig['_opn_marco_' . $filterName[0]]) ) && ($opnConfig['_opn_marco_' . $filterName[0]] == 1) ) {
						include ($dir2scan . $filterDirEntry);
						$className = 'OPN_MACRO_' . $filterName[0];
						if (class_exists ($className) ) {
							$this->parserFilters[$filterName[0]] =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $className;
						} else {
							$className = 'OPN_MACRO_XL_' . $filterName[0];
							if (class_exists ($className) ) {
								$this->parserFiltersXL[$filterName[0]] =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ $className;
							}
						}
					}
				}
			}
			closedir ($filterDir);

		}

		function _get_tags(&$str, $tag, &$tagarray) {
	// preg_match_all("=\/\*<\{\b".$tag."\b[^\}>]*\}>(.*)<\{".$tag."\/\}>\*\/=siU", $str, $tagarray);

//			preg_match_all("=<\b".$tag."\b[^>]*>(.*)<\/".$tag.">=siU", $str, $tagarray);

			preg_match_all("=<\b".$tag."(.*)<\/".$tag.">=siU", $str, $tagarray);
			$max=count($tagarray[0]);
			for ($i=0; $i<$max; $i++) {
				$str = preg_replace('='.preg_quote($tagarray[0][$i]).'=siU', ':'.$tag.$i.':', $str);
			}
		}

		function _set_tags(&$str, $replacment, $tagarray) {
			$max=count($tagarray[0]);
			for ($i=0; $i<$max; $i++) {
				$str = preg_replace('='.preg_quote(':'.$replacment.$i.':').'=siU', $tagarray[1][$i], $str);
			}
		}

		function ParseText ($text, $option = false) {

			$parsed = $text;
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
			$ubb =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ UBBCode;
			$ubb->Replace_SpecialCodes ($parsed);

			$opntags=array();
			$this->_get_tags($parsed,'textarea',$opntags);

			$help = preg_split ('/\[([A-Za-z0-9]+)=([^\]]+)\]/', $text);
			foreach ($help as $value) {
				$matches = '';
				if (preg_match ('/\[([A-Za-z0-9]+)=([^\]]+)\]/', $parsed, $matches) ) {
					list ($foo, $command, $options) = $matches;
					$t = $foo;
					$optionlist = explode (';', $options);
					if (isset ($this->parserFilters[$command]) ) {
						$wert = $this->parserFilters[$command]->parse ($optionlist, $parsed, $option);
						$parsed = preg_replace ('/\[([A-Za-z0-9]+)=([^\]]+)\]/', $wert, $parsed, 1);
					}
				}
			}
			foreach ($this->parserFiltersXL as $k => $var) {
				$this->parserFiltersXL[$k]->parse ($parsed);
			}
			$max=count($opntags[1]);
			for ($i=0; $i<$max; $i++) {
				$opntags[1][$i] = '<textarea'.$opntags[1][$i].'</textarea>';
			}
			$this->_set_tags($parsed,'textarea',$opntags);

			$ubb->Restore_SpecialCodes ($parsed);
			unset ($ubb);
			return ($parsed);

		}

	}
}

?>