<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_FILE_INCLUDED') ) {
	define ('_OPN_CLASS_FILE_INCLUDED', 1);

	class opnFile {

		/**
		* opnFile::$ERROR (string)
		*
		* This variable contains the text of the last test ERROR encountered.
		* If a test fails, the text description of why the test failed can
		* be retrieved by grabbing this variable.
		*/

		/*<{php4}>
		var $ERROR = '';
		<{php4/}>*/

		/*<{php5}>
		public $ERROR = '';
		<{php5/}>*/

		/*<{delete}>*/
		var $ERROR = '';
		/*<{delete/}>*/

		/**
		* opnFile::$BUFFER (integer, default -1)
		*
		* This is the BUFFER used when performing an strip_read() call.
		* It defaults to the size of the file unless you override it.
		* For the most part you shouldn't need to change the buffer size.
		*/

		/*<{php4}>
		var $BUFFER = -1;
		<{php4/}>*/

		/*<{php5}>
		public $BUFFER = -1;
		<{php5/}>*/

		/*<{delete}>*/
		var $BUFFER = -1;
		/*<{delete/}>*/

		/**
		* opnFile::$STATCACHE (array, default NULL)
		*
		* After any call to is_owner() or is_inGroup(),
		* this variable will contain the returned stat() array.
		* You can clear this variable on the fly by calling the clear_cache() method.
		*/

		/*<{php4}>
		var $STATCACHE = array();
		<{php4/}>*/

		/*<{php5}>
		public $STATCACHE = array();
		<{php5/}>*/

		/*<{delete}>*/
		var $STATCACHE = array();
		/*<{delete/}>*/

		/**
		* opnFile::$TEMPDIR (string, default '/tmp')
		*
		* The temporary directory used by the class when making temp files.
		* The class needs to be able to create temporary files.
		* By default it will create those files in '/tmp' unless you specify
		* otherwise by overriding this variable, for example;
		*		   include("class.File.php3");
		*		   $File = & new opnFile;
		*		   $File->TEMPDIR = 'C:\WINDOWS\TEMP';
		*/

		/*<{php4}>
		var $TEMPDIR = '';
		<{php4/}>*/

		/*<{php5}>
		public $TEMPDIR = '';
		<{php5/}>*/

		/*<{delete}>*/
		var $TEMPDIR = '';
		/*<{delete/}>*/

		/**
		* opnFile::$REALUID  (integer, default -1)
		*
		* This variable will contain the cached results of a get_real_uid() or get_real_gid() call.
		* The UID of the process is stored in this variable.
		*/

		/*<{php4}>
		var $REALUID = -1;
		<{php4/}>*/

		/*<{php5}>
		public $REALUID = -1;
		<{php5/}>*/

		/*<{delete}>*/
		var $REALUID = -1;
		/*<{delete/}>*/

		/**
		* opnFile::$REALGID (integer, default -1)
		*
		* Identical to REALUID, except of course this is the group ID of the current process.
		*/

		/*<{php4}>
		var $REALGID = -1;
		<{php4/}>*/

		/*<{php5}>
		public $REALGID = -1;
		<{php5/}>*/

		/*<{delete}>*/
		var $REALGID = -1;
		/*<{delete/}>*/

		/**
		* opnFile::opnFile()
		*
		* To create a new File object, simply call new File without arguments.
		*
		*/

		function opnFile () {

			global $opnConfig;

			$this->SetTempdir ($opnConfig['root_path_datasave']);
			if ($opnConfig['opn_dirmanage'] == 2) {
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ftp_real.php');
			} elseif ($opnConfig['opn_dirmanage'] == 3) {
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ftp_emulated.php');
			}

		}

		function SetTempdir ($dir) {

			$this->TEMPDIR = $dir;

		}

		/**
		* opnFile::clear_cache()
		*
		* Any time a stat() is performed on a file (usually during an is_owner() or is_inGroup() call,
		* the stat() results are stored in the STATCACHE variable. Calling clear_cache() forces
		* the class to clear the cached data.
		*
		* @return true
		*/

		function clear_cache () {

			unset ($this->STATCACHE);
			$this->STATCACHE = array ();
			return true;

		}

		/**
		* opnFile::is_sane()
		*
		* The is_sane() method performs several checks on a given file.
		*
		* The checks are performed based upon the values given in the must_exist,
		* noSymLinks, and noDirs flags. If all three flags are set to zero, the method
		* automatically assumes the file is sane and returns true. If any of the flags
		* are set to a value other than zero, that check must be true for is_sane() to return true.
		* Here's an example;
		*
		*		   $File->is_sane($fileName,1,0,0)
		*		   // will return true if a file, directory,
		*		   // or symlink exists with that name.
		*
		*		   $File->is_sane($fileName,1,0,1)
		*		   // will return true if a file or symlink with that
		*		   // name exists, but will return false of the filename
		*		   // is a directory or doesn't exist
		*
		*		   $File->is_sane($fileName,1,1,1)
		*		   // will return true if the file exists, but will return
		*		   // false if the file is a symlink or a directory.
		*
		*		   $File->is_sane($fileName,0,1,1)
		*		   // will return true so long as the name does not point
		*		   // to a symlink or a directory, regardless if a file
		*		   // exists by that name.
		*
		* is_sane() will set the ERROR variable if any of the checks fail,
		* so be sure to check it if is_sane() fails.
		*
		* @param string $fileName Check for this
		* @param integer $must_exist If set to a value other than zero, that check must be true for this
		* @param integer $noSymLinks If set to a value other than zero, that check must be true for this
		* @param integer $noDirs If set to a value other than zero, that check must be true for this
		* @return bool
		*/

		function is_sane ($fileName = '', $must_exist = 0, $noSymLinks = 0, $noDirs = 0) {
			if (empty ($fileName) ) {
				return false;
			}
			clearstatcache ();
			if ($must_exist != 0) {
				if (!file_exists ($fileName) ) {
					$this->ERROR .= 'is_sane: ' . sprintf (_FILE_FILE_NOT_EXISTS, $fileName) . '<br />';
					return false;
				}
				if (!is_readable ($fileName) ) {
					$this->ERROR .= 'is_sane: ' . sprintf (_FILE_FILE_NOT_READABLE, $fileName) . '<br />';
					return false;
				}
			}
			if ($noDirs != 0) {
				if (is_dir ($fileName) ) {
					$this->ERROR .= 'is_sane: ' . sprintf (_FILE_FILE_IS_DIR, $fileName) . '<br />';
					return false;
				}
			}
			if ($noSymLinks != 0) {
				if (file_exists ($fileName) ) {
					if (is_link ($fileName) ) {
						$this->ERROR .= 'is_sane: ' . sprintf (_FILE_FILE_IS_SYMLINK, $fileName) . '<br />';
						return false;
					}
				}
			}
			return true;

		}

		/**
		* opnFile::make_ftpdirs()
		*
		*
		* @param  $dirname
		* @param  &$ftpdir
		* @param  &$newdir
		*/

		function make_ftpdirs ($dirname, &$ftpdir, &$newdir) {

			global $opnConfig;

			$pos = strrpos ($dirname, '/');
			if ($pos !== false) {
				if ($pos == strlen ($dirname)-1) {
					$dirname = substr ($dirname, 0, $pos);
				}
			}
			$help = str_replace (_OPN_ROOT_PATH, '', $dirname);
			$help = explode ('/', $help);
			$newdir = $help[count ($help)-1];
			$ftpdir = $opnConfig['opn_ftpdir'];
			for ($i = 0, $max = count ($help)-1; $i< $max; $i++) {
				$ftpdir .= '/' . $help[$i];
			}

		}

		/**
		* opnFile::delete_dir()
		*
		* Deletes the given $dirname
		* Returns Error messages to describe the problem
		* or TRUE if it was deleted succesfull
		*
		* @param  $dirname
		* @return bool
		*/

		function delete_dir ($dirname) {

			global $opnConfig;
			if ($dirname == '') {
				$this->ERROR .= 'delete_dir: ' . _FILE_FILE_NO_DIRNAME . '<br />';
			} else {
				if (!$this->is_sane ($dirname, 1, 0, 0) ) {
					$this->ERROR .= 'delete_dir: ' . sprintf (_FILE_FILE_NOT_EXISTS, $dirname) . '<br />';
				} else {

					/* may be removed later - just for error prevention on unclean upgrades */
					if (!isset ($opnConfig['opn_dirmanage']) ) {
						$opnConfig['opn_dirmanage'] = $opnConfig['opn_use_perl_mkdir'];
					}

					/* end of removed later */

					$dh = opendir ($dirname);
					while ($file = readdir ($dh) ) {
						if ( ($file != '.') && ($file != '..') ) {
							$fullpath = $dirname . "/" . $file;
							if (!is_dir ($fullpath) ) {
								$this->delete_file ($fullpath);
							} else {
								$this->delete_dir ($fullpath);
							}
						}
					}
					closedir ($dh);
					if ($this->ERROR == '') {
						switch ($opnConfig['opn_dirmanage']) {
							case 0:

								/* native php file functions */
								if (rmdir ($dirname) ) {
									return true;
								}
								$this->ERROR .= $this->ERROR .= sprintf (_FILE_FILE_NO_DIR_DELETE, 'delete_dir(php)', $dirname) . '<br />';
								return false;
							case 1:

								/* use perl functions */

								$ausgabe = $opnConfig['opn_url_cgi'] . '/cgi-bin/rmdir.pl?action=rmdir&dopath=' . $dirname . '&opnpath=' . $opnConfig['root_path_base'];
								$ret = @file ($ausgabe);
								if (is_dir ($dirname) ) {
									return true;
								}
								$this->ERROR .= sprintf (_FILE_FILE_NO_DIR_DELETE, 'delete_dir(pl)', $dirname) . '<br />';
								return false;
							case 2:

								/* use php ftp functions */
							case 3:

								/* use emulated ftp functions */
								$basedir = '';
								$newdirname = '';
								$this->make_ftpdirs ($dirname, $basedir, $newdirname);
								$error = '';
								$ftpconn =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_ftp ($error);
								$done = false;
								if ($error == '') {
									$ftpconn->cd ($error, $basedir);
									$ftpconn->rm_dir ($error, $newdirname);
									if ($error == '') {
										$done = true;
									}
									$ftpconn->close ($error);
								}
								if ( ($done) && ($error == '') ) {
									return true;
								}
								if ($opnConfig['opn_dirmanage'] == 2) {
									$this->ERROR .= $this->ERROR .= sprintf (_FILE_FILE_NO_DIR_DELETE, 'delete_dir(php ftp)', $dirname) . '<br />' . $error . '<br />';
								} elseif ($opnConfig['opn_dirmanage'] == 3) {
									$this->ERROR .= $this->ERROR .= sprintf (_FILE_FILE_NO_DIR_DELETE, 'delete_dir(emul ftp)', $dirname) . '<br />' . $error . '<br />';
								}
								if ($done) {
									return true;
								}
								break;
						}
					}
				}
			}
			return false;

		}

		/**
		* opnFile::make_dir()
		*
		* Creates the given $dirname
		* Returns Error messages to describe the problem
		* or TRUE if it was created succesfull
		*
		* @param  $dirname
		* @return bool
		*/

		function make_dir ($dirname, $rights = 0777) {

			global $opnConfig;
			if ($dirname == '') {
				$this->ERROR .= 'make_dir: ' . _FILE_FILE_NO_DIRNAME . '<br />';
			} else {
				$dirname = str_replace ('//', '/', $dirname);
				if ($this->is_sane ($dirname, 1, 0, 0) ) {
					$this->ERROR .= 'make_dir: ' . _FILE_FILE_DIR_EXISTS . '<br />';
				} else {
					$this->ERROR = '';
					umask (000);

					/* may be removed later - just for error prevention on unclean upgrades */
					if (!isset ($opnConfig['opn_dirmanage']) ) {
						$opnConfig['opn_dirmanage'] = $opnConfig['opn_use_perl_mkdir'];
					}

					/* end of removed later */
					switch ($opnConfig['opn_dirmanage']) {
						case 0:

							/* native php file functions */

							$ret = @mkdir ($dirname, $rights);
							if ($ret) {
								return true;
							}
							$this->ERROR .= sprintf (_FILE_FILE_NO_DIR_CREATE, 'make_dir(php)', $dirname) . '<br />';
							break;
						case 1:

							/* use perl functions */

							$ausgabe = $opnConfig['opn_url_cgi'] . '/cgi-bin/mkdir.pl?action=mkdir&dopath=' . $dirname . '&opnpath=' . $opnConfig['root_path_base'];
							$ret = @file ($ausgabe);
							if (is_dir ($dirname) ) {
								return true;
							}
							$this->ERROR .= sprintf (_FILE_FILE_NO_DIR_CREATE, 'make_dir(pl)', $dirname) . '<br />';
							break;
						case 2:

							/* use php ftp functions */
						case 3:

							/* use emulated ftp functions */
							$basedir = '';
							$newdirname = '';
							$this->make_ftpdirs ($dirname, $basedir, $newdirname);
							$error = '';
							$ftpconn =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_ftp ($error);
							$done = false;
							if ($error == '') {
								$ftpconn->cd ($error, $basedir);
								$ftpconn->mk_dir ($error, $newdirname);
								if ($error == '') {
									$done = true;
								}
								if ($opnConfig['opn_ftpchmod'] != '') {
									$ftpconn->ch_mod ($error, $newdirname, $opnConfig['opn_ftpchmod']);
								}
								$ftpconn->close ($error);
							}
							if ( ($done) AND ($error == '') ) {
								return true;
							}
							if ($opnConfig['opn_dirmanage'] == 2) {
								$this->ERROR .= $this->ERROR .= sprintf (_FILE_FILE_NO_DIR_CREATE, 'make_dir(php ftp)', $dirname) . '<br />' . $error . '<br />';
							} elseif ($opnConfig['opn_dirmanage'] == 3) {
								$this->ERROR .= $this->ERROR .= sprintf (_FILE_FILE_NO_DIR_CREATE, 'make_dir(emul ftp)', $dirname) . '<br />' . $error . '<br />';
							}
							if ($done) {
								return true;
							}
							break;
					}
					// switch
				}
			}
			return false;

		}

		/**
		* opnFile::delete_file($fileName)
		*
		* Deletes the given $fileName
		* Returns Error messages to describe the problem
		* or TRUE if it was deleted succesfull
		*
		* @param  $fileName
		* @return bool
		*/

		function delete_File ($fileName) {

			global $opnConfig;
			if ($fileName == '') {
				$this->ERROR .= 'delete_File: No filename specified<br />';
			} else {
				if (!$this->is_sane ($fileName, 1, 0, 0) ) {
					$this->ERROR .= 'delete_File: ' . sprintf (_FILE_FILE_NOT_EXISTS, $fileName) . '<br />';
				} else {
					if ($opnConfig['opn_dirmanage'] >= 2) {
						$error = '';
						$ftpconn =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_ftp ($error);
						if ($error == '') {
							$ftpconn->delete_file ($error, $fileName);
						}
						$ftpconn->close ($error);
						if ($error == '') {
							clearstatcache ();
							return true;
						}
						$this->ERROR .= sprintf (_FILE_FILE_NO_FILE_DELETE, 'delete_File', $fileName) . '<br />';
						return false;
					}
					$ret = @unlink ($fileName);
					if ($ret) {
						clearstatcache ();
						return true;
					}
					$this->ERROR .= sprintf (_FILE_FILE_NO_FILE_DELETE, 'delete_File', $fileName) . '<br />';
					return false;
				}
			}
			return false;

		}

		/**
		* opnFile::read_file()
		*
		* This method returns the raw file contents,
		* or null on failure.
		* It will not read directories but symlinks are considered ``ok''.
		*
		* @param string $fileName
		* @return mixed
		*/

		function read_file ($fileName = '', $extramode = '') {

			global $php_errormsg;

			$contents = '';
			if (empty ($fileName) ) {
				$this->ERROR .= 'read_file: No file specified<br />';
				return false;
			}
			if (!$this->is_sane ($fileName, 1, 0, 1) ) {
				// Preserve the is_sane() error msg
				return false;
			}
			$fd = @fopen ($fileName, 'r' . $extramode);
			if ( (!$fd) || (empty ($fd) ) ) {
				$this->ERROR .= 'read_file: File error: [' . $php_errormsg . ']' . '<br />';
				return false;
			}
			$contents = fread ($fd, filesize ($fileName) );
			fclose ($fd);
			return $contents;

		}

		/**
		* opnFile::strip_read()
		*
		* This reads the file and performs an fgetss() on the file contents,
		* stripping any HTML and PHP tags from the file,
		* leaving (for the most part) plain text.
		* Returns the results or null on failure.
		*
		* @param string $fileName
		* @param integer $strip_cr
		* @return mixed
		*/

		function strip_read ($fileName = '', $strip_cr = 0) {

			global $php_errormsg;
			if (empty ($fileName) ) {
				$this->ERROR .= 'strip_read: No file specified<br />';
				return false;
			}
			if (!$this->is_sane ($fileName, 1, 0, 1) ) {
				// Preserve the error
				return false;
			}
			if ($this->BUFFER>0) {
				$buffer = $this->BUFFER;
			} else {
				$buffer = filesize ($fileName);
			}
			$contents = '';
			$fd = @fopen ($fileName, 'r');
			if ( (!$fd) || (empty ($fd) ) ) {
				$this->ERROR .= 'strip_read: File error: [' . $php_errormsg . ']' . '<br />';
				return false;
			}
			while (!feof ($fd) ) {
				if ($strip_cr) {
					$contents .= fgetss ($fd, $buffer);
				} else {
					$contents .= fgets ($fd, $buffer);
				}
			}
			fclose ($fd);
			return $contents;

		}

		function create_file ($filename) {

			global $opnConfig;
			if (!file_exists ($filename) ) {
				$this->copy_file ($opnConfig['root_path_datasave'] . 'copy.txt', $filename, $opnConfig['opn_server_chmod']);
			}

		}

		/**
		* opnFile::write_file()
		*
		* Saves the contents of $data to the file specified.
		* Returns true on success, false on failure.
		* If the file pointed to by $fileName already exists,
		* the class first copies that file to a temporary file,
		* appends the data to the temporary file, and then tries to copy
		* the temporary file over the original.
		* This is the best method I can think of to preserve the original
		* file's integrity should a conflict or error occur.
		* This method should be relatively safe from process conflicts.
		* (more than one process trying to write the file at one time.)
		*
		* @param  $fileName
		* @param  $Data
		* @return bool
		*/

		function write_file ($fileName, $Data, $extramode = '', $overwrite = false) {

			global $php_errormsg, $opnConfig;

			$tempDir = $this->TEMPDIR;
			$tempfile = $this->makeTempFile ($tempDir, 'cdi');
			$this->create_file ($tempfile);
			if (!$this->copy_file ($fileName, $tempfile, '0777') ) {
				$this->ERROR .= 'write_file: cannot create backup file [' . $tempfile . '] :  [' . $php_errormsg . ']' . '<br />';
				if ($this->is_sane ($fileName, 1, 0, 1) ) {
					return false;
				}
				$fd = @fopen ($fileName, 'w' . $extramode);
				if ( (!$fd) or (empty ($fd) ) ) {
					$myerror = $php_errormsg;
					$this->delete_File ($fileName);
					$this->ERROR .= 'write_file: [' . $fileName . '] access error [' . $myerror . ']' . '<br />';
					return false;
				}
				fwrite ($fd, $Data);
				fclose ($fd);
			}
			if (!$overwrite) {
				$fd = @fopen ($tempfile, 'a' . $extramode);
			} else {
				$fd = @fopen ($tempfile, 'w' . $extramode);
			}
			if ( (!$fd) or (empty ($fd) ) ) {
				$myerror = $php_errormsg;
				$this->delete_File ($tempfile);
				$this->ERROR .= 'write_file: [' . $tempfile . '] access error [' . $myerror . ']' . '<br />';
				return false;
			}
			fwrite ($fd, $Data);
			fclose ($fd);
			if (!$this->copy_file ($tempfile, $fileName, $opnConfig['opn_server_chmod']) ) {
				$myerror = $php_errormsg;
				// Stash the error, see above
				$this->delete_File ($tempfile);
				$this->ERROR .= 'write_file: Cannot copy file [' . $fileName . '] [' . $myerror . ']' . '<br />';
				return false;
			}
			$this->delete_File ($tempfile);
			if (file_exists ($tempfile) ) {
				// Not fatal but it should be noted
				$this->ERROR .= 'write_file: Could not unlink [' . $tempfile . '] : [' . $php_errormsg . ']' . '<br />';
			}
			return true;

		}
		// **************************************************************

		/**
		* opnFile::overwrite_file()
		*
		* Write the contents $Data to a file, even if this already exists.
		* The File $fileName will be overwritten.
		*
		* @param  $fileName
		* @param  $Data
		* @return bool
		*/

		function overwrite_file ($fileName, $Data, $extramode = '') {

			global $php_errormsg;
			// $tempDir = $this->TEMPDIR;
			// $tempfile = $this->makeTempFile($tempDir, 'cdi').'.tmp';
			$this->create_file ($fileName);

			/*
			if (!$this->copy_file($fileName, $tempfile, $opnConfig['opn_server_chmod'])) {
			$this->ERROR .= 'overwrite_file: cannot create backup file [' . $tempfile . '] :  [' . $php_errormsg . ']' . '<br />';
			return false;
			}
			*/
			// $fd = @fopen($tempfile, 'w' . $extramode);
			$fd = @fopen ($fileName, 'w' . $extramode);
			if ( (!$fd) or (empty ($fd) ) ) {
				$myerror = $php_errormsg;
				// $this->delete_File($fileName);
				$this->ERROR .= 'overwrite_file: [' . $fileName . '] access error [' . $myerror . ']' . '<br />';
				return false;
			}
			fwrite ($fd, $Data);
			fclose ($fd);

			/*
			if (!$this->copy_file($tempfile, $fileName, $opnConfig['opn_server_chmod'])) {
			$myerror = $php_errormsg; // Stash the error, see above
			$this->delete_File($tempfile);
			$this->ERROR .= 'overwrite_file: Cannot copy file [' . $fileName . '] [' . $myerror . ']' . '<br />';
			return false;
			}
			*/
			// $this->delete_File($tempfile);

			/*
			if (file_exists($tempfile)) {
			// Not fatal but it should be noted
			$this->ERROR .= 'overwrite_file: Could not unlink [' . $tempfile . '] : [' . $php_errormsg . ']' . '<br />';
			}
			*/
			return true;

		}

		/**
		* opnFile::copy_file()
		*
		* Saves the contents of $oldFile as $newFile.
		* If the old file does not exist or if the new file already exists,
		* this method will abort and return false.
		*
		* @param string $oldFile
		* @param string $newFile
		* @return bool
		*/

		function copy_file ($oldFile = '', $newFile = '', $rights = '0644') {

			global $php_errormsg, $opnConfig;
			if ( ($opnConfig['opn_dirmanage'] >= 2) && ($rights == '0644') ) {
				$rights = '0666';
			}
			if (empty ($oldFile) ) {
				$this->ERROR .= 'copy_file: oldFile not specified<br />';
				return false;
			}
			if (empty ($newFile) ) {
				$this->ERROR .= 'copy_file: newFile not specified<br />';
				return false;
			}
			if (!$this->is_sane ($oldFile, 1, 0, 1) ) {
				// preserve the error
				$this->ERROR .= 'copy_file: oldFile does not exists<br />';
				return false;
			}
			if (!$this->is_sane ($newFile, 0, 1, 1) ) {
				// preserve it
				return false;
			}
			if ($opnConfig['opn_dirmanage'] >= 2) {
				$error = '';
				$ftpconn =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_ftp ($error);
				if ($error == '') {
					$ftpconn->copy_file ($error, $oldFile, $newFile, $rights);
				}
				$ftpconn->close ($error);
				if ($error == '') {
					clearstatcache ();
					return true;
				}
				$this->ERROR .= 'copy_file: cannot copy file [' . $oldFile . ']' . '<br />';
				return false;
			}
			if (! (@copy ($oldFile, $newFile) ) ) {
				$this->ERROR .= 'copy_file: cannot copy file [' . $oldFile . '] to [' . $newFile . '] [' . $php_errormsg . ']' . '<br />';
				return false;
			}
			clearstatcache ();
			chmod ($newFile, octdec ($rights) );
			clearstatcache ();
			return true;

		}

		/**
		* opnFile::renames_file()
		*
		* Renames $oldFile to $newFile.
		* If the old file does not exist or if the new file already exists,
		* this method will abort and return false.
		*
		* @param $oldFile
		* @param $newFile
		* @param $rights
		* @return boolean
		*/

		function rename_file ($oldFile = '', $newFile = '', $rights = '0644') {

			global $php_errormsg, $opnConfig;
			if ( ($opnConfig['opn_dirmanage'] >= 2) && ($rights == '0644') ) {
				$rights = '0666';
			}
			if (empty ($oldFile) ) {
				$this->ERROR .= 'rename_file: oldFile not specified<br />';
				return false;
			}
			if (empty ($newFile) ) {
				$this->ERROR .= 'rename_file: newFile not specified<br />';
				return false;
			}
			if (!$this->is_sane ($oldFile, 1, 0, 1) ) {
				// preserve the error
				$this->ERROR .= 'rename_file: oldFile does not exists<br />';
				return false;
			}
			if (!$this->is_sane ($newFile, 0, 1, 1) ) {
				// preserve it
				return false;
			}
			if ($opnConfig['opn_dirmanage'] >= 2) {
				$error = '';
				$ftpconn =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_ftp ($error);
				if ($error == '') {
					$newFile = basename ($newFile);
					$ftpconn->rename_file ($error, $oldFile, $newFile, $rights);
				}
				$ftpconn->close ($error);
				if ($error == '') {
					clearstatcache ();
					return true;
				}
				$this->ERROR .= 'rename_file: cannot rename file [' . $oldFile . ']' . '<br />';
				return false;
			}
			if (! (@rename ($oldFile, $newFile) ) ) {
				$this->ERROR .= 'rename_file: cannot rename file [' . $oldFile . '] to [' . $newFile . '] [' . $php_errormsg . ']' . '<br />';
				return false;
			}
			clearstatcache ();
			@chmod ($newFile, octdec ($rights) );
			clearstatcache ();
			return true;

		}

		/**
		* opnFile::move_file()
		*
		* Move $oldFile to $newFile.
		* If the old file does not exist or if the new file already exists,
		* this method will abort and return false.
		*
		* @param $oldFile
		* @param $newFile
		* @param $rights
		* @return boolean
		*/

		function move_file ($oldFile = '', $newFile = '', $rights = '0644') {

			global $php_errormsg, $opnConfig;
			if ( ($opnConfig['opn_dirmanage'] >= 2) && ($rights == '0644') ) {
				$rights = '0666';
			}
			if (empty ($oldFile) ) {
				$this->ERROR .= 'move_file: oldFile not specified<br />';
				return false;
			}
			if (empty ($newFile) ) {
				$this->ERROR .= 'move_file: newFile not specified<br />';
				return false;
			}
			if (!$this->is_sane ($oldFile, 1, 0, 1) ) {
				// preserve the error
				$this->ERROR .= 'move_file: oldFile does not exists<br />';
				return false;
			}
			if (!$this->is_sane ($newFile, 0, 1, 1) ) {
				// preserve it
				return false;
			}
			if ($opnConfig['opn_dirmanage'] >= 2) {
				$error = '';
				$ftpconn =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_ftp ($error);
				if ($error == '') {
					$ftpconn->move_file ($error, $oldFile, $newFile, $rights);
				}
				$ftpconn->close ($error);
				if ($error == '') {
					clearstatcache ();
					return true;
				}
				$this->ERROR .= 'move_file: cannot move file [' . $oldFile . ']' . '<br />';
				return false;
			}
			if (! (@rename ($oldFile, $newFile) ) ) {
				$this->ERROR .= 'move_file: cannot move file [' . $oldFile . '] to [' . $newFile . '] [' . $php_errormsg . ']' . '<br />';
				return false;
			}
			clearstatcache ();
			@chmod ($newFile, octdec ($rights) );
			clearstatcache ();
			return true;

		}

		/**
		* opnFile::rm_dir()
		*
		*
		* @param  $dirname
		*/

		function rm_dir ($dirname) {

			global $opnConfig;
			if ($opnConfig['opn_dirmanage'] >= 2) {
				$error = '';
				$ftpconn =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_ftp ($error);
				if ($error != '') {
					$newdirname = '';
					$basedir = '';
					$this->make_ftpdirs ($dirname, $basedir, $newdirname);
					$ftpconn->cd ($error, $basedir);
					$ftpconn->rm_dir ($error, $newdirname);
					$ftpconn->close ($error);
				}
			} else {
				rmdir ($dirname);
			}

		}

		/**
		* opnFile::get_files()
		*
		* This method will gather a listing of all files matching $fileExt
		* and return the results as an array, WHERE each element in the array
		* will be a file name. (sans path). If $fileExt is not specified,
		* returns all files found.
		* This method, in order to prevent infinite loops,
		* will IGNORE sub and parent directories.
		* Only the directory pointed to by $path will be read.
		* Returns null if unable to read the contents of the directory.
		*
		* @param  $root_dir
		* @param string $fileExt
		* @return mixed
		*/

		function get_files ($root_dir, $fileExt = 'ALL_FILES') {

			global $php_errormsg;

			$fileList = array ();
			if (!is_dir ($root_dir) ) {
				$this->ERROR .= 'get_files: Sorry, [' . $root_dir . '] is not a directory' . '<br />';
				return false;
			}
			if (empty ($fileExt) ) {
				$this->ERROR .= 'get_files: No file extensions specified<br />';
				return false;
			}
			$open_dir = @opendir ($root_dir);
			if ( (!$open_dir) or (empty ($open_dir) ) ) {
				$this->ERROR .= 'get_files: Failed to open dir [' . $root_dir . '] : ' . $php_errormsg . '<br />';
				return false;
			}
			$fileCount = 0;
			while ( ($file = readdir ($open_dir) ) !== false) {
				if ( (!@is_dir ($root_dir . '/' . $file) ) && (!empty ($file) ) ) {
					if ($fileExt == 'ALL_FILES') {
						$fileList[$fileCount] = $file;
						$fileCount++;
					} else {
						if (preg_match ('/.\.(' . $fileExt . ')$/i', $file) ) {
							$fileList[$fileCount] = $file;
							$fileCount++;
						}
					}
				}
			}
			closedir ($open_dir);
			return $fileList;

		}
		// end get_files

		/**
		* opnFile::is_owner()
		*
		* Given a user ID, will return true if that user id owns the specified file.
		* If UID is not specified, the method assumes itself. (ie, it will check to see
		* if the PHP process UID owns the filename) This is very usefull, since the built
		* in PHP methods is_readable() and is_writeable() routinely lie about read and
		* write capabilities.
		* (They return true if the read and write bits on the file are set,
		* regardless of whether the process can actually read or write to those files.
		* (Which make is_readble() and is_writeable() completely useless IMHO).
		* If the UID is specified, will return true of that UID is the owner of the
		* specified file, false otherwise. See also get_real_uid() since this method uses that.
		*
		* @param  $fileName
		* @param string $uid
		* @return mixed
		*/

		function is_owner ($fileName, $uid = '') {
			if (empty ($uid) ) {
				if ($this->REALUID<0) {
					$tempDir = $this->TEMPDIR;
					$tempFile = $this->makeTempFile ($tempDir, 'cdi');
					if (!touch ($tempFile) ) {
						$this->ERROR .= 'is_owner: Unable to create [' . $tempFile . ']' . '<br />';
						return false;
					}
					$stats = stat ($tempFile);
					$this->delete_File ($tempFile);
					$uid = $stats[4];
				} else {
					$uid = $this->REALUID;
				}
			}
			$fileStats = stat ($fileName);
			if ( (empty ($fileStats) ) or (!$fileStats) ) {
				$this->ERROR .= 'is_owner: Unable to stat [' . $fileName . ']' . '<br />';
				return false;
			}
			$this->STATCACHE = $fileStats;
			$owner = $fileStats[4];
			if ($owner == $uid) {
				return $owner;
			}
			$this->ERROR .= 'is_owner: Owner [' . $owner . '] Uid [' . $uid . '] FAILED' . '<br />';
			return false;

		}

		/**
		* opnFile::is_inGroup()
		*
		* Identical to is_owner() except that it works on the GID instead of the UID.
		*
		* @param  $fileName
		* @param string $gid
		* @return mixed
		*/

		function is_inGroup ($fileName, $gid = '') {
			if (empty ($gid) ) {
				if ($this->REALGID<0) {
					$tempDir = $this->TEMPDIR;
					$tempFile = $this->makeTempFile ($tempDir, 'cdi');
					if (!touch ($tempFile) ) {
						$this->ERROR .= 'is_inGroup: Unable to create [' . $tempFile . ']' . '<br />';
						return false;
					}
					$stats = stat ($tempFile);
					$this->delete_File ($tempFile);
					$gid = $stats[5];
				} else {
					$gid = $this->REALGID;
				}
			}
			$fileStats = stat ($fileName);
			if ( (empty ($fileStats) ) or (!$fileStats) ) {
				$this->ERROR .= 'is_inGroup: Unable to stat [' . $fileName . ']' . '<br />';
				return false;
			}
			$this->STATCACHE = $fileStats;
			$group = $fileStats[5];
			if ($group == $gid) {
				return $group;
			}
			$this->ERROR .= 'is_inGroup: Group [' . $group . '] Gid [' . $gid . '] FAILED' . '<br />';
			return false;

		}

		/**
		* opnFile::get_real_uid()
		*
		* This method will return the user ID of the PHP process itself.
		* It does not use the built in php method getmyuid(),
		* which is 99% of the time a lieing sack of puss that is best ignored.
		* This method determines it's user id by creating a temporary file,
		* and then performing a stat() check on the file. The results of this
		* method are cached by the class for more efficient results.
		* (So if you call this method right after a new(), the class will perform a teensy-bit faster)
		*
		* @return mixed
		*/

		function get_real_uid () {

			$tempDir = $this->TEMPDIR;
			$tempFile = $this->makeTempFile ($tempDir, 'cdi');
			if (!touch ($tempFile) ) {
				$this->ERROR .= 'is_owner: Unable to create [' . $tempFile . ']' . '<br />';
				return false;
			}
			$stats = stat ($tempFile);
			$this->delete_File ($tempFile);
			$uid = $stats[4];
			$gid = $stats[5];
			$this->REALUID = $uid;
			$this->REALGID = $gid;
			return $uid;

		}

		/**
		* opnFile::get_real_gid()
		*
		* Identical (literally) to a get_real_uid() call.
		* It returns the group ID of the process that's running.
		* I cheated here. When get_real_uid() is called, it sets two global variables REALUID and REALGID.
		* You can save yourself a function call here.
		* If get_real_uid() has already been called in your program,
		* just grab the contents of REALGID instead of calling this method.
		*
		* @return int
		*/

		function get_real_gid () {

			$uid = $this->get_real_uid ();
			if ( (!$uid) or (empty ($uid) ) ) {
				return false;
			}
			return $this->REALGID;

		}

		/**
		* opnFile::get_file_ext()
		*
		*
		* @return string
		*/

		function get_file_ext ($fn) {
			return (strstr ($fn, '.')?strtolower (substr (strrchr ($fn, '.'), 1) ) : '');

		}

		/**
		* opnFile::get_file_size()
		*
		*
		* @return string
		*/

		function get_file_size ($fn) {
			return max (0, filesize ($fn) );

		}

		/**
		* opnFile::get_file_size()
		*
		*
		* @return string $tmp
		*/

		function makeTempFile ($dir, $prefix) {

			mt_srand ((double)microtime ()*1000000);
			$loop = mt_rand (5, 50);
			for ($i = 1; $i<= $loop; $i++) {
				mt_srand ((double)microtime ()*1000000);
				$id = uniqid (mt_rand (), true);
			}
			unset ($loop);
			unset ($i);
			$tmp = $dir . $prefix . md5 ($id);

			#			$tmp = 'test';
			return $tmp;

		}

	}
	// end class File
}

?>