<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_FILEUPLOAD_INCLUDED') ) {
	define ('_OPN_CLASS_FILEUPLOAD_INCLUDED', 1);

	class file_upload_class {

		/*<{php4}>
		var $file = array();
		var $errors = array();
		var $accepted;
		var $new_file;
		var $max_filesize;
		var $max_image_width;
		var $max_image_height;
		var $_prefix = '';
		var $_unique = false;
		<{php4/}>*/

		/*<{php5}>
		public $file = array();
		public $errors = array();
		public $accepted;
		public $new_file;
		public $max_filesize;
		public $max_image_width;
		public $max_image_height;
		public $_prefix = '';
		public $_unique = false;
		<{php5/}>*/

		/*<{delete}>*/
		var $file = array();
		var $errors = array();
		var $accepted;
		var $new_file;
		var $max_filesize;
		var $max_image_width;
		var $max_image_height;
		var $_prefix = '';
		var $_unique = false;
		/*<{delete/}>*/

		function max_filesize ($file_size) {

			$this->max_filesize = $file_size;

		}

		function max_image_size ($image_width, $image_height) {

			$this->max_image_width = $image_width;
			$this->max_image_height = $image_height;

		}

		function SetPrefix ($prefix) {

			$this->_prefix = $prefix;

		}

		function SetUnique () {

			$this->_unique = true;

		}

		function BuildFilename (&$new_name) {
			if ($this->_unique) {
				$unique = uniqid (rand () . $this->_prefix);
				// Use a prefix to make things even more unique
			} else {
				$unique = '';
			}
			if ($this->_prefix != '') {
				$this->_prefix .= '_';
			}
			$prefix = $this->proper_filename ($this->_prefix . $unique);
			$prefix = preg_replace ('=[^a-z0-9._]=si', '', str_replace ( array (' ', '%20'), array ('', ''), $prefix));
			$new_name = $prefix . '_' . $new_name;

		}

		function upload ($file_name, $only_to_use_type, $file_extention) {
			// get all the properties of the file
			$this->accepted = false;
			// oh i do not like this
			// but have someone a other way?
			$userupload = array ();
			get_var ($file_name, $userupload, 'file');
			if ( (!is_array ($userupload) ) || (count ($userupload) == 0) ) {
				$this->file['file'] = 'none';
			} else {
				$this->file['file'] = $userupload['tmp_name'];
				$this->file['name'] = $userupload['name'];
				$this->file['size'] = $userupload['size'];
				$this->file['type'] = $userupload['type'];
			}
			if ($this->file['file'] && $this->file['file'] != 'none') {
				// now we must test the max size
				if ($this->max_filesize && $this->file['size']>$this->max_filesize) {
					$this->errors[] = sprintf (_FILE_UPLOAD_MAX_FILESIZE, $this->max_filesize/1024);
					return false;
				}
				if (substr_count ($this->file['type'], 'image') > 0) {
					$image = getimagesize ($this->file['file']);
					$this->file['width'] = $image[0];
					$this->file['height'] = $image[1];
					// now we must test the max image size
					if ( (isset ($this->max_image_width) || isset ($this->max_image_height) ) && ( ($this->file['width']>$this->max_image_width) || ($this->file['height']>$this->max_image_height) ) ) {
						$this->errors[] = sprintf (_FILE_UPLOAD_MAX_PIXELS, $this->max_image_width, $this->max_image_height);
						return false;
					}
					switch ($image[2]) {
						case 1:
							$this->file['extention'] = '.gif';
							break;
						case 2:
							$ext = explode ('.', $this->file['name']);
							$ext = end ($ext);
							if ($ext <> 'jpeg') {
								$this->file['extention'] = '.jpg';
							} else {
								$this->file['extention'] = '.jpeg';
							}
							break;
						case 3:
							$this->file['extention'] = '.png';
							break;
						default:
							$this->file['extention'] = $file_extention;
							break;
					}
				} elseif (!preg_match ('/(\.)([a-z0-9]{3,5})$/', $this->file['name']) && ! $file_extention) {
					// some time we can add new mime types here
					switch ($this->file['type']) {
						case 'text/plain':
							$this->file['extention'] = '.txt';
							break;
						case 'text/csv':
							$this->file['extention'] = '.csv';
							break;
						default:
							break;
					}
				} else {
					$this->file['extention'] = $file_extention;
				}
				// check to see if the file is of type specified
				if ($only_to_use_type != '') {
					if (preg_match ('/' . $only_to_use_type . '/', $this->file['type']) ) {
						$this->accepted = true;
					} else {
						$this->errors[] = sprintf (_FILE_UPLOAD_ONLY_FILES, preg_replace ('/\|/', ' or ', $only_to_use_type) );
					}
				} else {
					$this->accepted = true;
				}
			} else {
				$this->errors[] = _FILE_NO_UPLOAD;
			}
			return $this->accepted;

		}

		function proper_filename ($filename) {

			$filename = stripslashes ($filename);
			$filename = str_replace ("'", "", $filename);
			$filename = str_replace ("\"", "", $filename);
			$filename = str_replace ("&", "", $filename);
			$filename = str_replace (",", "", $filename);
			$filename = str_replace (";", "", $filename);
			$filename = str_replace ("/", "", $filename);
			$filename = str_replace (_OPN_SLASH, "", $filename);
			$filename = str_replace ("`", "", $filename);
			$filename = str_replace ("<", "", $filename);
			$filename = str_replace (">", "", $filename);
			$filename = str_replace ("_", "", $filename);
			$filename = str_replace ("-", "", $filename);
			$filename = str_replace (" ", "", $filename);
			$filename = str_replace ("%", "", $filename);
			$filename = str_replace ("?", "", $filename);
			$filename = str_replace (":", "", $filename);
			$filename = str_replace ("*", "", $filename);
			$filename = str_replace ("|", "", $filename);
			$filename = str_replace ("?", "", $filename);
			$filename = str_replace ("", "e", $filename);
			$filename = str_replace ("", "e", $filename);
			$filename = str_replace ("", "c", $filename);
			$filename = str_replace ("@", "", $filename);
			$filename = str_replace ("", "a", $filename);
			$filename = str_replace ("", "e", $filename);
			$filename = str_replace ("", "i", $filename);
			$filename = str_replace ("", "o", $filename);
			$filename = str_replace ("", "u", $filename);
			$filename = str_replace ("", "u", $filename);
			$filename = str_replace ("", "a", $filename);
			$filename = str_replace ("!", "", $filename);
			$filename = str_replace ("", "", $filename);
			$filename = str_replace ("+", "", $filename);
			$filename = str_replace ("^", "", $filename);
			$filename = str_replace ("(", "", $filename);
			$filename = str_replace (")", "", $filename);
			$filename = str_replace ("#", "", $filename);
			$filename = str_replace ("=", "", $filename);
			$filename = str_replace ("$", "", $filename);
			$filename = str_replace ("%", "", $filename);
			$filename = str_replace ("", "ae", $filename);
			$filename = str_replace ("", "Ae", $filename);
			$filename = str_replace ("", "oe", $filename);
			$filename = str_replace ("", "Oe", $filename);
			$filename = str_replace ("", "ue", $filename);
			$filename = str_replace ("", "Ue", $filename);
			$filename = str_replace ("", "ss", $filename);
			return $filename;

		}

		function make_ftpdirs ($dirname, &$ftpdir) {

			global $opnConfig;

			$help = str_replace (_OPN_ROOT_PATH, '', $dirname);
			$help = explode ('/', $help);

			#		$newdir = $help[count($help)-1];

			$ftpdir = $opnConfig['opn_ftpdir'];
			for ($i = 0, $max = count ($help)-1; $i< $max; $i++) {
				$ftpdir .= '/' . $help[$i];
			}

		}

		function ftp_upload ($path, $mode) {

			global $NEW_NAME, $opnConfig;
			if ($this->accepted) {
				// very strict naming of file.. only lowercase letters, numbers and underscores
				$new_name = $this->proper_filename ($this->file['name']);
				$new_name = preg_replace ('=[^a-z0-9._]=si', '', str_replace ( array (' ', '%20'), array ('', ''), $new_name));
				// check for extention and remove
				$ext = substr ($new_name, (strrpos ($new_name, '.')+1) );
				$ext2 = strtolower ($ext);
				if ($ext != $ext2) {
					$new_name = substr ($new_name, 0, strlen ( ($new_name) )-strlen ($ext) ) . $ext2;
					$ext = $ext2;
				}
				if (preg_match ('/(\.)([a-z0-9]{3,5})$/', $new_name) ) {
					$pos = strrpos ($new_name, '.');
					if (!$this->file['extention']) {
						$this->file['extention'] = substr ($new_name, $pos, strlen ($new_name) );
					}
					$new_name = substr ($new_name, 0, $pos);
				}
				if ( ($this->_prefix != '') || ($this->_unique) ) {
					$this->BuildFilename ($new_name);
				}
				$this->new_file = $path . $new_name . $this->file['extention'];
				$new_file1 = $new_name . $this->file['extention'];
				if ($this->file['name'] != $new_name . $this->file['extention']) {
					$this->file['name'] = $new_name . $this->file['extention'];
				}
				$NEW_NAME = $new_name . $this->file['extention'];
				if ($opnConfig['opn_dirmanage'] == 2) {
					include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ftp_real.php');
				} elseif ($opnConfig['opn_dirmanage'] == 3) {
					include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ftp_emulated.php');
				}
				$error = '';
				$ftpconn = & new opn_ftp ($error, $opnConfig['opn_ftpmode']);
				$basedir = '';
				$this->make_ftpdirs ($path, $basedir);
				switch ($this->file['type']) {
					case 'text/plain':
					case 'text/csv':
						$ftpconn->FTP_MODE = FTP_ASCII;
						break;
					default:
						$ftpconn->FTP_MODE = FTP_BINARY;
						break;
				}
				$var_ok = true;
				if ($error == '') {
					$ftpconn->cd ($error, $basedir);
					switch ($mode) {
						case 1:
							// overwrite file
							$ftpconn->upload_file ($error, $new_file1, $this->file['file']);
							break;
						case 2:
							// create new with incremental extention
							$copy = '';
							$n = 0;
							while (file_exists ($path . $new_name . $copy . $this->file['extention']) ) {
								$copy = '_copy' . $n;
								$n++;
							}
							$this->new_file = $path . $new_name . $copy . $this->file['extention'];
							$new_file1 = $new_name . $copy . $this->file['extention'];
							$this->file['name'] = $new_file1;
							$ftpconn->upload_file ($error, $new_file1, $this->file['file']);
							break;
						case 3:
							// so do nothing if the file exists
							clearstatcache ();
							if (file_exists ($this->new_file) ) {
								$this->errors[] = sprintf (_FILE_UPLOAD_FILE_EXISTS, $this->new_file);
							} else {

								/* $var_ok = rename($this->file['file'], $this->new_file);*/

								$ftpconn->upload_file ($error, $new_file1, $this->file['file']);
								if (!isset ($opnConfig['opn_server_chmod']) ) {
									$opnConfig['opn_server_chmod'] = '0644';
								}
								$ftpconn->ch_mod ($error, $new_file1, $opnConfig['opn_server_chmod']);
								if ($error != '') {
									$this->errors[] = sprintf (_FILE_UPLOAD_NO_CHMOD, $this->new_file);
									$var_ok = FALSE;
								}
							}
							break;
						default:
							break;
					}
					$ftpconn->close ($error);
				}
				if (!$var_ok) {
					unset ($this->new_file);
				} elseif ($error != '') {
					$errors = explode ('<br />', $error);
					$this->errors = array_merge ($this->errors, $errors);
					$var_ok = false;
				}
				return $var_ok;
			}
			return false;

		}

		function save_file ($path, $mode, $strict = true, $clearext = false) {

			global $NEW_NAME;
			// if ($opnConfig['opn_dirmanage'] < 2) {
			if ($this->accepted) {
				// very strict naming of file.. only lowercase letters, numbers and underscores
				if (!isset ($this->file['extention']) ) {
					$this->file['extention'] = '';
				}
				if ($strict) {
					$new_name = $this->proper_filename ($this->file['name']);
					$new_name = preg_replace ('=[^a-z0-9._]=si', '', str_replace ( array (' ', '%20'), array ('', ''), $new_name));
				} else {
					$new_name = $this->file['name'];
				}
				if (!$clearext) {
					// check for extention and remove
					$ext = substr ($new_name, (strrpos ($new_name, '.')+1) );
					$ext2 = strtolower ($ext);
					if ($ext != $ext2) {
						$new_name = substr ($new_name, 0, strlen ( ($new_name) )-strlen ($ext) ) . $ext2;
						$ext = $ext2;
					}
					if (preg_match ('/(\.)([a-z0-9]+)$/', $new_name) ) {
						$pos = strrpos ($new_name, '.');
						if (!$this->file['extention']) {
							$this->file['extention'] = substr ($new_name, $pos, strlen ($new_name) );
						}
						$new_name = substr ($new_name, 0, $pos);
					}
				} else {
					$this->file['extention'] = '';
				}
				if ( ($this->_prefix != '') || ($this->_unique) ) {
					$this->BuildFilename ($new_name);
				}
				$this->new_file = $path . $new_name . $this->file['extention'];
				if ($this->file['name'] != $new_name . $this->file['extention']) {
					$this->file['name'] = $new_name . $this->file['extention'];
				}
				$NEW_NAME = $new_name . $this->file['extention'];
				switch ($mode) {
					case 1:
						// overwrite file
						$var_ok = $this->_move_uploaded_file ();
						break;
					case 2:
						// create new with incremental extention
						$n = 0;
						$copy = '';
						while (file_exists ($path . $new_name . $copy . $this->file['extention']) ) {
							$copy = '_copy' . $n;
							$n++;
						}
						$this->new_file = $path . $new_name . $copy . $this->file['extention'];
						$var_ok = $this->_move_uploaded_file ();
						break;
					case 3:
						// so do nothing if the file exists
						clearstatcache ();
						if (file_exists ($this->new_file) ) {
							$this->errors[] = sprintf (_FILE_UPLOAD_FILE_EXISTS, $this->new_file);
						} else {
							$var_ok = $this->_move_uploaded_file ();
						}
						break;
					default:
						break;
				}
				if (!isset ($var_ok) ) {
					unset ($this->new_file);
					$var_ok = '';
				}
				return $var_ok;
			}
			return false;
			// } else {
			// return $this->ftp_upload($path,$mode);
			// }

		}

		function _move_uploaded_file () {

			global $opnConfig;

			$var_ok = move_uploaded_file ($this->file['file'], $this->new_file);
			if ($var_ok) {
				if (!isset ($opnConfig['opn_server_chmod']) ) {
					$opnConfig['opn_server_chmod'] = '0666';
				}
				if (chmod ($this->new_file, octdec ($opnConfig['opn_server_chmod']) ) == FALSE) {
					$this->errors[] = sprintf (_FILE_UPLOAD_NO_CHMOD, $this->new_file);
					$var_ok = FALSE;
				}
			}
			return $var_ok;

		}

	}
}

?>