<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_REAL_FTP_INCLUDED') ) {
	define ('_OPN_CLASS_REAL_FTP_INCLUDED', 1);

	class opn_ftp {

		/*<{php4}>
		var $con_id;
		var $pw;
		var $host;
		var $port;
		var $cwd;
		var $pasv;
		var $user;
		var $FTP_MODE=FTP_BINARY;// FTP_ASCII or FTP_BINARY
		<{php4/}>*/

		/*<{php5}>
		public $con_id;
		public $pw;
		public $host;
		public $port;
		public $cwd;
		public $pasv;
		public $user;
		public $FTP_MODE=FTP_BINARY;// FTP_ASCII or FTP_BINARY
		<{php5/}>*/

		/*<{delete}>*/
		var $con_id;
		var $pw;
		var $host;
		var $port;
		var $cwd;
		var $pasv;
		var $user;
		var $FTP_MODE=FTP_BINARY;// FTP_ASCII or FTP_BINARY
		/*<{delete/}>*/

		/* constructor */

		function opn_ftp (&$error, $ftpmode = 1, $autoconnect = true) {

			global $opnConfig;

			$this->FTP_MODE = $ftpmode;
			if ($autoconnect) {
				$this->host = $opnConfig['opn_ftphost'];
				$this->user = $opnConfig['opn_ftpusername'];
				$this->pw = open_the_secret (md5 ($opnConfig['encoder']), $opnConfig['opn_ftppassword']);
				$this->port = $opnConfig['opn_ftpport'];
				$this->pasv = $opnConfig['opn_ftppasv'];
				$myerror = '';
				$this->connectftpreal ($myerror);
				if ($myerror == '') {
					$this->cwd = @ftp_pwd ($this->con_id);
				}
				$error = $myerror;
			}

		}

		function connectftpreal (&$error) {
			if ($this->con_id = ftp_connect ($this->host, $this->port) ) {
				if (@ftp_login ($this->con_id, $this->user, $this->pw) ) {
					@ftp_pasv ($this->con_id, $this->pasv);
					return;
				}
				$error .= 'User ' . $this->user . ' cannot login to host ' . $this->host . '<br />';
			} else {
				$error .= 'Connection with host ' . $this->host . ' failed!<br />';
			}

		}

		function close (&$error) {

			$error .= '';
			ftp_quit ($this->con_id);

		}

		function cd (&$error, $dir) {

			$error .= '';
			if (substr_count ($dir, '/')>0) {
				$d = explode ('/', $dir);
				$max = count ($d);
				for ($i = 0; $i< $max; $i++) {
					if (trim ($d[$i]) != '') {
						@ftp_chdir ($this->con_id, $d[$i]);
					}
				}
			} else {
				@ftp_chdir ($this->con_id, $dir);
			}
			$this->cwd = @ftp_pwd ($this->con_id);

		}

		function cd_up (&$error) {

			$temp = @ftp_cdup ($this->con_id);
			if (!$temp) {
				$error .= 'Cannont go up<br />';
			}

		}

		function mk_dir (&$error, $name) {

			$temp = @ftp_mkdir ($this->con_id, $name);
			if (!$temp) {
				$error .= 'Cannot create directory ' . $name . '<br />';
			}

		}

		function rm_dir (&$error, $deldir) {

			$temp = @ftp_rmdir ($this->con_id, $deldir);
			if (!$temp) {
				$error .= 'Cannont delete directory ' . $deldir . '<br />';
			}

		}

		function upload_file (&$error, $filename, $source) {
			if (! (@ftp_put ($this->con_id, $filename, $source, $this->FTP_MODE) ) ) {
				$error .= 'Can not upload file' . $source . '<br />';
			}

		}

		function ch_mod (&$error, $obj, $num) {
			if ( (!function_exists ('ftp_chmod') ) OR (!@ftp_chmod ($this->con_id, $num, $obj) ) ) {
				$chmod_cmd = 'CHMOD ' . $num . ' ' . $obj;
				if (!$this->site ($error, $chmod_cmd) ) {
					$error .= 'Cannot change permissions of object ' . $obj . '<br />';
				}
			}

		}

		function get_dir (&$error, $dir) {

			$error .= '';
			$filelist = array ();
			$files = ftp_nlist ($this->con_id, $dir);
			foreach ($files as $file) {
				$isfile = ftp_size ($this->con_id, $file);
				if ($isfile != '-1') {
					$filelist[] = $file;
				}
			}
			return $filelist;

		}

		function site (&$error, $cmd) {
			if (!@ftp_site ($this->con_id, $cmd) ) {
				$error .= 'Cannot use site command ' . $cmd . '<br />';
				return false;
			}
			return true;

		}

		function make_ftpdir ($dirname, &$ftpdir) {

			global $opnConfig;

			$help = str_replace (_OPN_ROOT_PATH, '', $dirname);
			$help = explode ('/', $help);
			$newdir = $help[count ($help)-1];
			$ftpdir = $opnConfig['opn_ftpdir'];
			for ($i = 0, $max = count ($help)-1; $i< $max; $i++) {
				$ftpdir .= '/' . $help[$i];
			}
			return $newdir;

		}

		function copy_file (&$error, $source, $dest, $num = '') {

			$dirname = dirname ($dest) . '/';
			$filename = basename ($dest);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			$this->upload_file ($error, $filename, $source);
			if ($num != '') {
				$this->ch_mod ($error, $filename, $num);
			}
			usleep (2);

		}

		function rename_file (&$error, $source, $dest, $num = '') {

			$dirname = dirname ($source) . '/';
			$filename = basename ($source);
			$dest = basename ($dest);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			if (!ftp_rename ($this->con_id, $filename, $dest)) {
				$error .= 'Can not rename file ' . $source . '<br />';
			} else {
				if ($num != '') {
					$this->ch_mod ($error, $dest, $num);
				}
			}
			usleep (2);
		}

		function move_file (&$error, $source, $dest, $num = '') {

			global $opnConfig;

			$dirname = dirname ($source) . '/';
			$filename = basename ($source);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$dest = str_replace($opnConfig['root_path_datasave'], '../', $dest);
			$this->cd ($error, $basedir);
			if (!ftp_rename ($this->con_id, $filename, $dest)) {
				$error .= 'Can not rename file ' . $source . '<br />';
			} else {
				if ($num != '') {
					$this->ch_mod ($error, $dest, $num);
				}
			}
			usleep (2);

		}

		function delete_file (&$error, $source) {

			$dirname = dirname ($source) . '/';
			$filename = basename ($source);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			if (!ftp_delete ($this->con_id, $filename) ) {
				$error .= 'Can not delete file ' . $source . '<br />';
			}

		}

		function chmod (&$error, $obj, $num) {

			$dirname = dirname ($obj) . '/';
			$filename = basename ($obj);
			$basedir = '';
			$this->make_ftpdir ($dirname, $basedir);
			$this->cd ($error, $basedir);
			$this->ch_mod ($error, $filename, $num);

		}

		function get_filesize (&$error, $file) {

			$error .= '';
			$filesize = @ftp_size ($this->con_id, urldecode ($file) );
			return $filesize;

		}

	}
}

?>