<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_MYFUNCTIONS_INCLUDED') ) {
	define ('_OPN_CLASS_MYFUNCTIONS_INCLUDED', 1);

	class MyFunctions {

		/*<{php4}>
		var $table = ''; //table with parent-child structure
		var $id = ''; //unique id for records in table $table
		var $pid = 'pid';  // name of parent id used in table $table
		var $pos = ''; // name for pos field
		var $where = '';
		var $itemtable = '';  //items table with each item associated with an id in table $table
		var $itemid=''; //unique id for records in table $itemtable
		var $itemlink='';
		var $itemwhere = '';
		var $title ='title'; // name of a column in table $table which will be used for ordering queried results and creating selection box
		var $ratingtable=''; // table storing rating information for each item in itemtable
		var $_ispos = false;
		<{php4/}>*/

		/*<{php5}>
		public $table = ''; //table with parent-child structure
		public $id = ''; //unique id for records in table $table
		public $pid = 'pid';  // name of parent id used in table $table
		public $pos = ''; // name for pos field
		public $where = '';
		public $itemtable = '';  //items table with each item associated with an id in table $table
		public $itemid=''; //unique id for records in table $itemtable
		public $itemlink='';
		public $itemwhere = '';
		public $title ='title'; // name of a column in table $table which will be used for ordering queried results and creating selection box
		public $ratingtable=''; // table storing rating information for each item in itemtable
		public $_ispos = false;
		<{php5/}>*/

		/*<{delete}>*/
		var $table = ''; //table with parent-child structure
		var $id = ''; //unique id for records in table $table
		var $pid = 'pid';  // name of parent id used in table $table
		var $pos = ''; // name for pos field
		var $where = '';
		var $itemtable = '';  //items table with each item associated with an id in table $table
		var $itemid=''; //unique id for records in table $itemtable
		var $itemlink='';
		var $itemwhere = '';
		var $title ='title'; // name of a column in table $table which will be used for ordering queried results and creating selection box
		var $ratingtable=''; // table storing rating information for each item in itemtable
		var $_ispos = false;
		/*<{delete/}>*/

		/**
		* Returns an array of all first child of a given id
		*
		* @param int $sel_id
		* @return array
		**/

		function getFirstChildArray ($sel_id) {

			global $opnConfig;

			$arr = array ();
			$orderby = '';
			if ($this->_ispos == true) {
				$orderby = ' ORDER BY ' . $this->pos;
			}
			$where = '';
			if ($this->where != '') {
				$where = ' AND ' . $this->where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT * from ' . $this->table . ' WHERE ' . $this->pid . '=' . $sel_id . $where . $orderby);
			if ($result !== false) {
				$count = $result->RecordCount ();
				if ($count == 0) {
					$result->Close ();
					return 0;
				}
				while (! $result->EOF) {
					$myrow = $result->GetRowAssoc ('0');
					array_push ($arr, $myrow);
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $arr;

		}

		/**
		* returns an array of all first child IDs of a given id
		*
		* @param int $sel_id
		* @return array
		**/

		function getFirstChildIds ($sel_id) {

			global $opnConfig;

			$arr = array ();
			$order = '';
			if ($this->pos != '') {
				$order = ' ORDER BY ' . $this->pos;
			}
			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ' from ' . $this->table . ' WHERE ' . $this->pid . '=' . $sel_id . $order);
			if ($result !== false) {
				while (! $result->EOF) {
					array_push ($arr, $result->fields[$this->id]);
					$result->MoveNext ();
				}
				$result->Close ();
				return $arr;
			}
			return 0;

		}

		/**
		* returns an array of all child category ids for a given table $table id
		*
		* @param int $sel_id
		* @param array $idarray
		* @return array
		**/

		function getAllChildId ($sel_id, $idarray = array () ) {

			global $opnConfig;
			if ($sel_id == '') {
				return $idarray;
			}
			$order = ' ORDER BY ' . $this->title;
			if ($this->pos != '') {
				$order = ' ORDER BY ' . $this->pos;
			}
			$where = '';
			if ($this->where != '') {
				$where = ' AND ' . $this->where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ' FROM ' . $this->table . ' WHERE ' . $this->pid . '=' . $sel_id . $where . $order);
			if ($result !== false) {
				while (! $result->EOF) {
					array_push ($idarray, $result->fields[$this->id]);
					$idarray = $this->getAllChildId ($result->fields[$this->id], $idarray);
					$result->MoveNext ();
				}
				$result->Close ();
				return $idarray;
			}
			return $idarray;

		}

		/**
		* returns the total number of items in items table that
		* are accociated with a given table $table id
		*
		* @param int $sel_id
		* @param string $status
		* @return int
		**/

		function getTotalItems ($sel_id, $status = '') {

			global $opnConfig;

			$count = 0;
			$arr = array ();
			if ($this->itemlink == '') {
				$link = $this->id;
			} else {
				$link = $this->itemlink;
			}
			$where = '';
			if ($this->itemwhere != '') {
				$where = ' AND ' . $this->itemwhere;
			}
			$query = 'SELECT COUNT(' . $this->itemid . ') AS counter from ' . $this->itemtable . ' WHERE ' . $link . '=' . $sel_id;
			$query .= $where;
			if ($status != '') {
				$query .= ' AND status>=' . $status;
			}
			$result = &$opnConfig['database']->Execute ($query);
			if ($result !== false) {
				if ( ($result->fields !== false) && (isset ($result->fields['counter']) ) ) {
					$count = $result->fields['counter'];
					$result->Close ();
				}
			}
			$arr = $this->getAllChildId ($sel_id);
			$max = sizeof ($arr);
			for ($i = 0; $i< $max; $i++) {
				$query2 = 'SELECT COUNT(' . $this->itemid . ') AS counter from ' . $this->itemtable . ' WHERE ' . $link . '=' . $arr[$i];
				$query2 .= $where;
				if ($status != '') {
					$query2 .= ' AND status>=' . $status;
				}
				$result2 = &$opnConfig['database']->Execute ($query2);
				if (isset ($result2->fields['counter']) ) {
					$thing = $result2->fields['counter'];
				} else {
					$thing = 0;
				}
				$result2->Close ();
				$count += $thing;
			}
			return $count;

		}

		/**
		* generates path from the root id to a given id
		* the path is delimetered with "/"
		*
		* @param int $sel_id
		* @param string $path
		* @return string
		**/

		function getPathFromId ($sel_id, $path = '') {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->pid . ', ' . $this->title . ' from ' . $this->table . ' WHERE ' . $this->id . '=' . $sel_id);
			if ($result === false) {
				return $path;
			}
			$parentid = $result->fields[$this->pid];
			$name = $result->fields[$this->title];
			$result->Close ();
			opn_nl2br ($name);
			$path = '/' . $name . $path;
			if ($parentid == 0) {
				return $path;
			}
			$path = $this->getPathFromId ($parentid, $path);
			return $path;

		}

		/**
		* makes a nicely ordered selection box
		* $preset_id is used to specify a preselected item
		* set $none to 1 to add a option with value 0
		*
		* @param int $preset_id
		* @param object $form
		* @param int $none
		* @param string $selname
		* @param bool $ownid
		* @return bool $hasitems - success
		**/

		function makeMySelBox ($preset_id = 0, &$form, $none = 0, $selname = '', $ownid = false) {

			global $opnConfig;
			if ($selname == '') {
				$selname = $this->id;
			}
			$where = '';
			if ($this->where != '') {
				$where = ' AND ' . $this->where;
			}
			if ($this->pid == $this->id) {
				$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ', ' . $this->title . ' from ' . $this->table . ' WHERE ' . $this->pid . '>0 ' . $where . ' ORDER BY ' . $this->title);
			} else {
				$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ', ' . $this->title . ' from ' . $this->table . ' WHERE ' . $this->pid . '=0 ' . $where . ' ORDER BY ' . $this->title);
			}
			$options = array ();
			if ($none == 1) {
				$options[0] = 'none';
			}
			if ($none == 2) {
				$options[0] = _SEARCH_ALL;
			}
			$selected = '';
			$hasitems = false;
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields[$this->id];
					if ( ($ownid === false) || ($ownid != intval ($catid) ) ) {
						$name = $result->fields[$this->title];
						$options[$catid] = $name;
						if ($catid == $preset_id) {
							$selected = $catid;
						}
						if ($this->pid != $this->id) {
							$arr = $this->getChildTreeArray ($catid);
							$max = count ($arr);
							for ($i = 0; $i< $max; $i++) {
								if ( ($ownid === false) || ($ownid != intval ($arr[$i][2]) ) ) {
									$catpath = $this->getPathFromId ($arr[$i][2]);
									$catpath = substr ($catpath, 1);
									$options[$arr[$i][2]] = $catpath;
									if ($arr[$i][2] == $preset_id) {
										$selected = $arr[$i][2];
									}
								}
							}
						}
						$hasitems = true;
					}
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$form->AddSelect ($selname, $options, $selected);
			return $hasitems;

		}

		function getIdFromName ($name = '') {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ' from ' . $this->table . ' WHERE ' . $this->title . '=' . $name);
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields[$this->id];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $catid;

		}

		/**
		* generates nicely formatted linked path from the root id to a given id
		*
		* @param int $sel_id
		* @param string $funcURL
		* @param string $funcurlVar
		* @param string $path
		* @param string $css
		* @return string
		**/

		function getNicePathFromId ($sel_id, $funcURL, $funcurlVar, $path = '', $css = 'opncenterbox') {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->pid . ', ' . $this->title . ' from ' . $this->table . ' WHERE ' . $this->id . '=' . $sel_id);
			if ($result !== false) {
				if ($result->RecordCount () == 0) {
					$result->Close ();
					return $path;
				}
				$parentid = $result->fields[$this->pid];
				$name = $result->fields[$this->title];
				$result->Close ();
			}
			opn_nl2br ($name);
			$funcurlVar[0] = $funcURL;
			$funcurlVar[$this->id] = $sel_id;
			$path = '<a class="' . $css . '" href="' . encodeurl ($funcurlVar) . '">' . $name . '</a>&nbsp;:&nbsp;' . $path . _OPN_HTML_NL;
			if ( (!isset ($parentid) ) OR ($parentid == 0) ) {
				return $path;
			}
			$path = $this->getNicePathFromId ($parentid, $funcURL, $funcurlVar, $path, $css);
			return $path;

		}

		/**
		* generates id path from the root id to a given id
		* the path is delimetered with "/"
		*
		* @param int $sel_id
		* @param string $path
		* @return string
		**/

		function getIdPathFromId ($sel_id, $path = '') {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->pid . ' from ' . $this->table . ' WHERE ' . $this->id . '=' . $sel_id);
			if ($result === false) {
				return $path;
			}
			$parentid = $result->fields[$this->pid];
			$result->Close ();
			$path = '/' . $sel_id . $path;
			if ($parentid == 0) {
				return $path;
			}
			$path = $this->getIdPathFromId ($parentid, $path);
			return $path;

		}

		/**
		*
		*
		* @param int $sel_id
		* @param string $path
		* @return string
		**/

		function getParents ($sel_id, $path = array () ) {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->pid . ', ' . $this->title . ' from ' . $this->table . ' WHERE ' . $this->id . '=' . $sel_id);
			if ($result === false) {
				return $path;
			}
			$parentid = $result->fields[$this->pid];
			$title = $result->fields[$this->title];
			$result->Close ();
			array_push ($path, array ('id' => $sel_id,
						'title' => $title) );
			// $path[] = $sel_id;
			if ($parentid == 0) {
				return $path;
			}
			$path = $this->getParents ($parentid, $path);
			return $path;

		}

		/**
		* updates rating data in itemtable for a given item
		*
		* @param int $sel_itemid
		* @return void
		**/

		function updaterating ($sel_itemid) {

			global $opnConfig;

			$query = 'SELECT rating FROM ' . $this->ratingtable . ' WHERE ' . $this->itemid . '=' . $sel_itemid;
			$voteresult = &$opnConfig['database']->Execute ($query);
			$votesDB = $voteresult->RecordCount ();
			$totalrating = 0;
			while (! $voteresult->EOF) {
				$totalrating += $voteresult->fields['rating'];
				$voteresult->MoveNext ();
			}
			$voteresult->Close ();
			if ($votesDB>0) {
				$finalrating = $totalrating/ $votesDB;
			} else {
				$finalrating = 0;
			}
			$finalrating = number_format ($finalrating, 4);
			$query = 'UPDATE ' . $this->itemtable . " SET rating=$finalrating, votes=$votesDB WHERE " . $this->itemid . " = $sel_itemid";
			$opnConfig['database']->Execute ($query);

		}

		/**
		*
		*
		* @param bool $ispos1
		* @return void
		**/

		function IsPos ($ispos1 = false) {

			$this->_ispos = $ispos1;

		}

		/**
		*
		*
		* @param int $sel_id
		* @param array $parray
		* @param string $r_prefix
		* @return array
		**/

		function getChildTreeArray ($sel_id, $parray = array (), $r_prefix = '') {

			global $opnConfig;
			if ($this->pos != '') {
				$order = ' ORDER BY ' . $this->pos;
			} else {
				$order = ' ORDER BY ' . $this->title;
			}
			$where = '';
			if ($this->where != '') {
				$where = ' AND ' . $this->where;
			}
			$posfield = '';
			if ($this->_ispos == true) {
				$posfield = ', ' . $this->pos;
			}
			$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ', ' . $this->title . $posfield . ' FROM ' . $this->table . ' WHERE ' . $this->pid . '=' . $sel_id . $where . $order);
			if ( ($result === false) or ($result->fields === false) ) {
				return $parray;
			}
			while (! $result->EOF) {
				$r_id = $result->fields[$this->id];
				$title = $result->fields[$this->title];
				$prefix = $r_prefix . '.';
				if (!$this->_ispos) {
					$helper = array ($prefix,
							$title,
							$r_id);
				} else {
					$pos = $result->fields[$this->pos];
					$helper = array ($prefix,
							$title,
							$r_id,
							$pos);
				}
				array_push ($parray, $helper);
				unset ($helper);
				$parray = $this->getChildTreeArray ($r_id, $parray, $prefix);
				$result->MoveNext ();
			}
			$result->Close ();
			return $parray;

		}

		/**
		* returns a array with all categories
		*
		* @param string $posfield - if set, this would be used for order by...
		* @return array $categories - all category items as array */

		function composeCatArray ($posfield = '') {

			global $opnConfig;

			$where = '';
			if ($this->where != '') {
				$where = ' AND ' . $this->where;
			}
			if ($posfield != '') {
				$this->pos = $posfield;
			}
			if ($this->pos != '') {
				$order = ' ORDER BY ' . $this->pos;
			} else {
				$order = ' ORDER BY ' . $this->title;
			}
			if ($this->pid == $this->id) {
				$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ', ' . $this->title . ' from ' . $this->table . ' WHERE ' . $this->pid . '>0 ' . $where . ' ' . $order);
			} else {
				$result = &$opnConfig['database']->Execute ('SELECT ' . $this->id . ', ' . $this->title . ' from ' . $this->table . ' WHERE ' . $this->pid . '=0 ' . $where . ' ' . $order);
			}
			$categories = array ();
			$item = 0;
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields[$this->id];
					$name = $result->fields[$this->title];
					$item = $catid;
					$categories[$item]['catid'] = $catid;
					$categories[$item]['name'] = $name;
					$categories[$item]['level'] = 0;
					if ($this->pid != $this->id) {
						$arr = $this->getChildTreeArray ($catid);
						$max = count ($arr);
						for ($i = 0; $i< $max; $i++) {
							$item = $arr[$i][2];
							$categories[$item]['catid'] = $arr[$i][2];
							$categories[$item]['name'] = $arr[$i][1];
							$categories[$item]['level'] = substr_count ($arr[$i][0], '.');
						}
					}
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $categories;

		}

	}
}

?>