<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPN_ACTIVATION_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_ACTIVATION_INCLUDED', 1);

	class OPNActivation {

		/*<{php4}>
		var $_class_data = array(
		<{php4/}>*/

		/*<{php5}>
		public $_class_data = array(
		<{php5/}>*/

		/*<{delete}>*/
		var $_class_data = array(
		/*<{delete/}>*/

		'activationkey' => '', 'url' => '', 'actdata' => '', 'extradata' => '', 'fieldname' => '', 'fielddescritpion' => '', 'fieldlength' => '', 'fieldmaxlength' => '', 'submitname' => '', 'sethelpto' => '');

		function OPNActivation () {

			global $opnConfig, $opnTables, $ininstall;
			if (!$ininstall) {
				$opnConfig['opndate']->now ();
				$opnConfig['opndate']->subInterval ('3 DAYS');
				$now = 0;
				$opnConfig['opndate']->opnDataTosql ($now);
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_activation'] . ' WHERE actdate<' . $now);
				$this->InitActivation ();
			}

		}

		function _insert ($key, $value) {

			$this->_class_data[$key] = $value;

		}

		function property ($p = null) {
			if ($p == null) {
				return $this->_class_data;
			}
			return $this->_class_data[strtolower ($p)];

		}

		function InitActivation () {

			$this->SetActivationKey ('');
			$this->SetActdata ('');
			$this->SetExtraData ('');
			$this->SetUrl ('');
			$this->SetFielddescription ('');
			$this->SetFieldname ('');
			$this->SetFieldlength (0);
			$this->SetFieldmaxlength (0);
			$this->SetSubmitname ('');
			$this->SetHelp ('');

		}

		function SetUrl ($url) {

			$this->_insert ('url', $url);

		}

		function GetUrl () {
			return $this->property ('url');

		}

		function SetSubmitname ($name) {

			$this->_insert ('submitname', $name);

		}

		function GetSubmitname () {
			return $this->property ('submitname');

		}

		function SetActdata ($data) {

			$this->_insert ('actdata', $data);

		}

		function GetActdata () {
			return $this->property ('actdata');

		}

		function SetExtraData ($data) {
			return $this->_insert ('extradata', $data);

		}

		function GetExtraData () {
			return $this->property ('extradata');

		}

		function SetFieldname ($name) {

			$this->_insert ('fieldname', $name);

		}

		function GetFieldname () {
			return $this->property ('fieldname');

		}

		function SetFielddescription ($description) {

			$this->_insert ('fielddescription', $description);

		}

		function GetFielddescription () {
			return $this->property ('fielddescription');

		}

		function SetFieldlength ($length) {

			$this->_insert ('fieldlength', $length);

		}

		function GetFieldlength () {
			return $this->property ('fieldlength');

		}

		function SetFieldmaxlength ($maxlength) {

			$this->_insert ('fieldmaxlength', $maxlength);

		}

		function GetFieldmaxlength () {
			return $this->property ('fieldmaxlength');

		}

		function SetHelp ($help) {

			$this->_insert ('sethelpto', $help);

		}

		function GetHelp () {

			$this->property ('sethelpto');

		}

		function BuildActivationKey () {

			global $opnConfig;

			$key = md5 (microtime () );
			$keylen = ((int) $opnConfig['opn_safetyadjustment']+1)*10;
			$maxstart = 32- $keylen;
			$start = rand (0, $maxstart);
			$key = substr ($key, $start, $keylen);
			$this->_insert ('activationkey', $key);

		}

		function SetActivationKey ($key) {

			$this->_insert ('activationkey', $key);

		}

		function GetActivationKey () {
			return $this->property ('activationkey');

		}

		function CheckActivation ($key, $data, $checkdata = true) {
			if ($checkdata) {
				if ( (trim ($this->GetActivationKey () ) == trim ($key) ) && (trim ($this->GetActdata () ) == trim ($data) ) ) {
					return true;
				}
			} else {
				if ( (trim ($this->GetActivationKey () ) == trim ($key) ) ) {
					return true;
				}
			}
			return false;

		}

		function DeleteActivation () {

			global $opnConfig, $opnTables;

			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['opn_activation'] . " WHERE actkey='" . $this->GetActivationKey () . "'");

		}

		function LoadActivation () {

			global $opnConfig, $opnTables;

			$result = &$opnConfig['database']->SelectLimit ('SELECT actdata, extradata FROM ' . $opnTables['opn_activation'] . " WHERE actkey='" . $this->GetActivationKey () . "'");
			$row = $result->GetRowAssoc ('0');
			$this->SetActdata ($row['actdata']);
			$this->SetExtraData ($row['extradata']);
			$result->Close ();
			unset ($result);

		}

		function SaveActivation () {

			global $opnConfig, $opnTables;

			$key = $opnConfig['opnSQL']->qstr ($this->GetActivationKey () );
			$actdata = $opnConfig['opnSQL']->qstr ($this->GetActdata (), 'actdata');
			$extradata = $opnConfig['opnSQL']->qstr ($this->GetExtraData (), 'extradata');
			$opnConfig['opndate']->now ();
			$now = 0;
			$opnConfig['opndate']->opnDataTosql ($now);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['opn_activation'] . " VALUES ($key, $now, $actdata, $extradata)");
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_activation'], "actkey= $key");

		}

		function BuildFormular () {

			global $opnConfig;

			$form =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_FormularClass ('default');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('opn_zzz_yyy', $this->GetHelp () );
			$form->Init (encodeurl ($this->GetUrl () ) );
			$form->AddTable ();
			$form->AddCols (array ('20%', '80%') );
			$form->AddOpenRow ();
			$form->AddLabel ('data', $this->GetFielddescription () );
			$form->AddTextfield ($this->GetFieldname (), $this->GetFieldlength (), $this->GetFieldmaxlength () );
			$form->AddChangeRow ();
			$form->AddLabel ('actkey', _ACTIVATION_KEY);
			$form->AddTextfield ('actkey', 32, 32);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddNewline (2);
			$form->AddSubmit ('submit', $this->GetSubmitname () );
			$form->AddFormEnd ();
			$help = '';
			$form->GetFormular ($help);
			return $help;

		}

	}
}

?>