<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_CATFUNCTIONS_INCLUDED') ) {
	define ('_OPN_CLASS_CATFUNCTIONS_INCLUDED', 1);

	class CatFunctions {

		/*<{php4}>
		var $table = ''; //table with parent-child structure
		var $_where = '';
		var $itemtable = '';  //items table with each item associated with an id in table $table
		var $itemid=''; //unique id for records in table $itemtable
		var $itemlink='';
		var $itemwhere = '';
		var $ratingtable=''; // table storing rating information for each item in itemtable
		var $texttable = ''; // table storing text information for each item in itemtable
		var $textlink = '';
		var $textfields = array();
		<{php4/}>*/

		/*<{php5}>
		public $table = ''; //table with parent-child structure
		public $_where = '';
		public $itemtable = '';  //items table with each item associated with an id in table $table
		public $itemid=''; //unique id for records in table $itemtable
		public $itemlink='';
		public $itemwhere = '';
		public $ratingtable=''; // table storing rating information for each item in itemtable
		public $texttable = ''; // table storing text information for each item in itemtable
		public $textlink = '';
		public $textfields = array();
		<{php5/}>*/

		/*<{delete}>*/
		var $table = ''; //table with parent-child structure
		var $_where = '';
		var $itemtable = '';  //items table with each item associated with an id in table $table
		var $itemid=''; //unique id for records in table $itemtable
		var $itemlink='';
		var $itemwhere = '';
		var $ratingtable=''; // table storing rating information for each item in itemtable
		var $texttable = ''; // table storing text information for each item in itemtable
		var $textlink = '';
		var $textfields = array();
		/*<{delete/}>*/

		function CatFunctions ($module, $where = true, $themegroup = false) {

			global $opnTables;
			if (isset ($opnTables[$module . '_cats']) ) {
				$this->table = $opnTables[$module . '_cats'];
			}
			if ($where) {
				$this->_buildwhere ($themegroup);
			}

		}

		/**
		* Returns an array of all first child of a given id
		*
		* @param int $sel_id
		* @return array
		**/

		function getFirstChildArray ($sel_id) {

			global $opnConfig;

			$arr = array ();
			$orderby = '';
			$orderby = ' ORDER BY cat_pos';
			$where = '';
			if ($this->_where != '') {
				$where = ' AND ' . $this->_where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT * from ' . $this->table . ' WHERE cat_pid=' . $sel_id . $where . $orderby);
			if ($result !== false) {
				$count = $result->RecordCount ();
				if ($count == 0) {
					$result->Close ();
					return 0;
				}
				while (! $result->EOF) {
					$myrow = $result->GetRowAssoc ('0');
					array_push ($arr, $myrow);
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $arr;

		}

		/**
		* returns an array of all first child IDs of a given id
		*
		* @param int $sel_id
		* @return array
		**/

		function getFirstChildIds ($sel_id) {

			global $opnConfig;

			$arr = array ();
			$order = '';
			$order = ' ORDER BY cat_pos';
			$result = &$opnConfig['database']->Execute ('SELECT cat_id from ' . $this->table . ' WHERE cat_pid=' . $sel_id . $order);
			if ($result !== false) {
				while (! $result->EOF) {
					array_push ($arr, $result->fields['cat_id']);
					$result->MoveNext ();
				}
				$result->Close ();
				return $arr;
			}
			return 0;

		}

		/**
		* returns an array of all child category ids for a given table $table id
		*
		* @param int $sel_id
		* @param array $idarray
		* @return array
		**/

		function getAllChildId ($sel_id, $idarray = array () ) {

			global $opnConfig;
			if ($sel_id == '') {
				return $idarray;
			}
			$order = ' ORDER BY cat_pos';
			$where = '';
			if ($this->_where != '') {
				$where = ' AND ' . $this->_where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT cat_id FROM ' . $this->table . ' WHERE cat_pid=' . $sel_id . $where . $order);
			if ($result !== false) {
				while (! $result->EOF) {
					array_push ($idarray, $result->fields['cat_id']);
					$idarray = $this->getAllChildId ($result->fields['cat_id'], $idarray);
					$result->MoveNext ();
				}
				$result->Close ();
				return $idarray;
			}
			return $idarray;

		}

		/**
		* returns the total number of items in items table that
		* are accociated with a given table $table id
		*
		* @param int $sel_id
		* @param string $status
		* @return int
		**/

		function getTotalItems ($sel_id, $status = '') {

			global $opnConfig;

			$count = 0;
			$arr = array ();
			if ($this->itemlink == '') {
				$link = 'cat_id';
			} else {
				$link = $this->itemlink;
			}
			$where = '';
			if ($this->itemwhere != '') {
				$where = ' AND ' . $this->itemwhere;
			}
			$query = 'SELECT COUNT(' . $this->itemid . ') AS counter from ' . $this->itemtable . ' WHERE ' . $link . '=' . $sel_id;
			$query .= $where;
			if ($status != '') {
				$query .= ' AND status>=' . $status;
			}
			$result = &$opnConfig['database']->Execute ($query);
			if ($result !== false) {
				if ( ($result->fields !== false) && (isset ($result->fields['counter']) ) ) {
					$count = $result->fields['counter'];
					$result->Close ();
				}
			}
			$arr = $this->getAllChildId ($sel_id);
			$max = sizeof ($arr);
			for ($i = 0; $i< $max; $i++) {
				$query2 = 'SELECT COUNT(' . $this->itemid . ') AS counter from ' . $this->itemtable . ' WHERE ' . $link . '=' . $arr[$i];
				$query2 .= $where;
				if ($status != '') {
					$query2 .= ' AND status>=' . $status;
				}
				$result2 = &$opnConfig['database']->Execute ($query2);
				if (isset ($result2->fields['counter']) ) {
					$thing = $result2->fields['counter'];
				} else {
					$thing = 0;
				}
				$result2->Close ();
				$count += $thing;
			}
			return $count;

		}

		/**
		* generates path from the root id to a given id
		* the path is delimetered with "/"
		*
		* @param int $sel_id
		* @param string $path
		* @return string
		**/

		function getPathFromId ($sel_id, $path = '') {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT cat_pid, cat_name from ' . $this->table . ' WHERE cat_id=' . $sel_id);
			if ($result === false) {
				return $path;
			}
			$parentid = $result->fields['cat_pid'];
			$name = $result->fields['cat_name'];
			$result->Close ();
			opn_nl2br ($name);
			$path = '/' . $name . $path;
			if ($parentid == 0) {
				return $path;
			}
			$path = $this->getPathFromId ($parentid, $path);
			return $path;

		}

		/**
		* makes a nicely ordered selection box
		* $preset_id is used to specify a preselected item
		* set $none to 1 to add a option with value 0
		*
		* @param int $preset_id
		* @param object $form
		* @param int $none
		* @param string $selname
		* @param bool $ownid
		* @return bool $hasitems - success
		**/

		function makeMySelBox ($preset_id = 0, &$form, $none = 0, $selname = '', $ownid = false) {

			global $opnConfig;
			if ($selname == '') {
				$selname = 'cat_id';
			}
			$where = '';
			if ($this->_where != '') {
				$where = ' AND ' . $this->_where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat_name from ' . $this->table . ' WHERE cat_pid=0 ' . $where . ' ORDER BY cat_pos');
			$options = array ();
			if ($none == 1) {
				$options[0] = 'none';
			}
			if ($none == 2) {
				$options[0] = _SEARCH_ALL;
			}
			$selected = '';
			$hasitems = false;
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['cat_id'];
					if ( ($ownid === false) || ($ownid != intval ($catid) ) ) {
						$name = $result->fields['cat_name'];
						$options[$catid] = $name;
						if ($catid == $preset_id) {
							$selected = $catid;
						}
						$arr = $this->getChildTreeArray ($catid);
						$max = count ($arr);
						for ($i = 0; $i< $max; $i++) {
							if ( ($ownid === false) || ($ownid != intval ($arr[$i][2]) ) ) {
								$catpath = $this->getPathFromId ($arr[$i][2]);
								$catpath = substr ($catpath, 1);
								$options[$arr[$i][2]] = $catpath;
								if ($arr[$i][2] == $preset_id) {
									$selected = $arr[$i][2];
								}
							}
						}
						$hasitems = true;
					}
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$form->AddSelect ($selname, $options, $selected);
			return $hasitems;

		}

		function getIdFromName ($name = '') {

			global $opnConfig;

			$catid = false;
			$result = &$opnConfig['database']->Execute ('SELECT cat_id from ' . $this->table . ' WHERE cat_name=' . $name);
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['cat_id'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $catid;

		}

		function getNameFromId ($id) {

			global $opnConfig;

			$name = '';
			$result = $opnConfig['database']->Execute ('SELECT cat_name FROM ' . $this->table . ' WHERE cat_id=' . $id);
			if ($result !== false) {
				while (!$result->EOF) {
					$name = $result->fields['cat_name'];
					$result->MoveNext();
				}
				$result->Close ();
			}
			return $name;

		}

		/**
		* generates nicely formatted linked path from the root id to a given id
		*
		* @param int $sel_id
		* @param string $funcURL
		* @param string $funcurlVar
		* @param string $path
		* @param string $css
		* @return string
		**/

		function getNicePathFromId ($sel_id, $funcURL, $funcurlVar, $path = '', $css = 'opncenterbox') {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT cat_pid, cat_name from ' . $this->table . ' WHERE cat_id=' . $sel_id);
			if ($result !== false) {
				if ($result->RecordCount () == 0) {
					$result->Close ();
					return $path;
				}
				$parentid = $result->fields['cat_pid'];
				$name = $result->fields['cat_name'];
				$result->Close ();
			}
			opn_nl2br ($name);
			$funcurlVar[0] = $funcURL;
			$funcurlVar['cat_id'] = $sel_id;
			$path = '<a class="' . $css . '" href="' . encodeurl ($funcurlVar) . '">' . $name . '</a>&nbsp;:&nbsp;' . $path . _OPN_HTML_NL;
			if ( (!isset ($parentid) ) OR ($parentid == 0) ) {
				return $path;
			}
			$path = $this->getNicePathFromId ($parentid, $funcURL, $funcurlVar, $path, $css);
			return $path;

		}

		/**
		* generates a array with the compelte category tree for sel_id
		*
		* @param int	$sel_id
		* @param array	$resultarr
		* @return array
		**/

		function GetParentArray ($sel_id, $resultarr) {

			global $opnConfig;

			$item = count ($resultarr);
			$result = &$opnConfig['database']->Execute ('SELECT cat_pid, cat_name from ' . $this->table . ' WHERE cat_id=' . $sel_id);
			if ($result !== false) {
				if ($result->RecordCount () == 0) {
					$result->Close ();
					return $resultarr;
				}
				$parentid = $result->fields['cat_pid'];
				$name = $result->fields['cat_name'];
				$result->Close ();
			}
			$resultarr[$item]['cid'] = $sel_id;
			$resultarr[$item]['name'] = $name;
			if ( (!isset ($parentid) ) OR ($parentid == 0) ) {
				return $resultarr;
			}
			$resultarr = $this->GetParentArray ($parentid, $resultarr);
			return $resultarr;

		}

		/**
		* generates id path from the root id to a given id
		* the path is delimetered with "/"
		*
		* @param int $sel_id
		* @param string $path
		* @return string
		**/

		function getIdPathFromId ($sel_id, $path = '') {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT cat_pid from ' . $this->table . ' WHERE cat_id=' . $sel_id);
			if ($result === false) {
				return $path;
			}
			$parentid = $result->fields['cat_pid'];
			$result->Close ();
			$path = '/' . $sel_id . $path;
			if ($parentid == 0) {
				return $path;
			}
			$path = $this->getIdPathFromId ($parentid, $path);
			return $path;

		}

		/**
		*
		*
		* @param int $sel_id
		* @param string $path
		* @return string
		**/

		function getParents ($sel_id, $path = array () ) {

			global $opnConfig;

			$result = &$opnConfig['database']->Execute ('SELECT cat_pid, cat_name from ' . $this->table . ' WHERE cat_id=' . $sel_id);
			if ($result === false) {
				return $path;
			}
			$parentid = $result->fields['cat_pid'];
			$title = $result->fields['cat_name'];
			$result->Close ();
			array_push ($path, array ('id' => $sel_id,
						'title' => $title) );
			// $path[] = $sel_id;
			if ($parentid == 0) {
				return $path;
			}
			$path = $this->getParents ($parentid, $path);
			return $path;

		}

		/**
		* updates rating data in itemtable for a given item
		*
		* @param int $sel_itemid
		* @return void
		**/

		function updaterating ($sel_itemid) {

			global $opnConfig;

			$query = 'SELECT rating FROM ' . $this->ratingtable . ' WHERE ' . $this->itemid . '=' . $sel_itemid;
			$voteresult = &$opnConfig['database']->Execute ($query);
			$votesDB = $voteresult->RecordCount ();
			$totalrating = 0;
			while (! $voteresult->EOF) {
				$totalrating += $voteresult->fields['rating'];
				$voteresult->MoveNext ();
			}
			$voteresult->Close ();
			if ($votesDB>0) {
				$finalrating = $totalrating/ $votesDB;
			} else {
				$finalrating = 0;
			}
			$finalrating = number_format ($finalrating, 4);
			$query = 'UPDATE ' . $this->itemtable . " SET rating=$finalrating, votes=$votesDB WHERE " . $this->itemid . " = $sel_itemid";
			$opnConfig['database']->Execute ($query);

		}

		/**
		*
		*
		* @param int $sel_id
		* @param array $parray
		* @param string $r_prefix
		* @return array
		**/

		function getChildTreeArray ($sel_id, $parray = array (), $r_prefix = '') {

			global $opnConfig;

			$order = ' ORDER BY cat_pos';
			$where = '';
			if ($this->_where != '') {
				$where = ' AND ' . $this->_where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat_name, cat_pos FROM ' . $this->table . ' WHERE cat_pid=' . $sel_id . $where . $order);
			if ( ($result === false) or ($result->fields === false) ) {
				return $parray;
			}
			while (! $result->EOF) {
				$r_id = $result->fields['cat_id'];
				$title = $result->fields['cat_name'];
				$prefix = $r_prefix . '.';
				$pos = $result->fields['cat_pos'];
				$helper = array ($prefix,
						$title,
						$r_id,
						$pos);
				array_push ($parray, $helper);
				unset ($helper);
				$parray = $this->getChildTreeArray ($r_id, $parray, $prefix);
				$result->MoveNext ();
			}
			$result->Close ();
			return $parray;

		}

		/**
		* returns a array with all categories
		*
		* @param string $posfield - if set, this would be used for order by...
		* @return array $categories - all category items as array */

		function composeCatArray ($cat_id = 0) {

			global $opnConfig;

			$where = ' WHERE ';
			if ($cat_id>0) {
				$where .= ' cat_id =' . $cat_id;
			} else {
				$where .= ' cat_pid=0';
			}
			if ($this->_where != '') {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY cat_pos';
			$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat_name from ' . $this->table . $where . ' ' . $order);
			$categories = array ();
			$item = 0;
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['cat_id'];
					$name = $result->fields['cat_name'];
					$item = $catid;
					$categories[$item]['catid'] = $catid;
					$categories[$item]['name'] = $name;
					$categories[$item]['level'] = 0;
					$arr = $this->getChildTreeArray ($catid);
					$max = count ($arr);
					for ($i = 0; $i< $max; $i++) {
						$item = $arr[$i][2];
						$categories[$item]['catid'] = $arr[$i][2];
						$categories[$item]['name'] = $arr[$i][1];
						$categories[$item]['level'] = substr_count ($arr[$i][0], '.');
					}
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $categories;

		}

		/**
		* Returns a comma separeted list with the visible categories
		*
		* @return string
		*/

		function GetCatList ($cat_id = 0) {

			global $opnConfig;

			$where = ' WHERE ';
			if ($cat_id>0) {
				$where .= ' cat_id =' . $cat_id;
			} else {
				$where .= ' cat_pid=0';
			}
			if ($this->_where != '') {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY cat_id';
			$result = &$opnConfig['database']->Execute ('SELECT cat_id FROM ' . $this->table . $where . ' ' . $order);
			$categories = array ();
			$item = 0;
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['cat_id'];
					$categories[] = $catid;
					$arr = $this->getChildTreeArray ($catid);
					$max = count ($arr);
					for ($i = 0; $i< $max; $i++) {
						$categories[] = $arr[$i][2];
					}
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return implode (',', $categories);

		}

		/**
		* Returns an array with the first cats or with the first childcats for pid
		*
		* @param string default_image
		* @param string image_url
		* @param int 	$pid
		* @param object	$albums
		* @return array
		*/

		function GetCatsTemplate ($default_image, $image_url, $url, $pid = 0, $albums) {

			global $opnConfig;

			$where = ' WHERE ';
			if ($pid>0) {
				$where .= ' cat_pid =' . $pid;
			} else {
				$where .= ' cat_pid=0';
			}
			if ($this->_where != '') {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY cat_pos';
			$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat_name, cat_image, cat_desc from ' . $this->table . $where . ' ' . $order);
			$categories = array ();
			$item = 0;
			if ($result !== false) {
				$item = 0;
				while (! $result->EOF) {
					$catid = $result->fields['cat_id'];
					$name = $result->fields['cat_name'];
					$image = $result->fields['cat_image'];
					$desc = $result->fields['cat_desc'];
					opn_nl2br ($desc);
					if (!$image) {
						$image = $default_image;
					}
					if ($image) {
						$image = urldecode ($image);
						if (substr_count ($image, 'http://') == 0) {
							$image = $image_url . '/' . $image;
						}
					}
					$url['cat_id'] = $catid;
					$categories[$item]['url'] = $url;
					$categories[$item]['name'] = $name;
					$categories[$item]['image'] = $image;
					$categories[$item]['description'] = $desc;
					$countalb = $this->getTotalItems ($catid);
					$categories[$item]['countalbums'] = $countalb;
					$cats = array();
					$cats[] = $catid;
					$arr = $this->getChildTreeArray ($catid);
					$max = count ($arr);
					for ($i = 0; $i< $max; $i++) {
						$cats[] = $arr[$i][2];
					}
					$cats = implode (',', $cats);
					if ($cats == '') {
						$cats = 0;
					}
					$albs = $albums->GetAlbumListCat ($cats);
					$newest = $albums->GetItemNewest ('i.aid IN (' . $albs . ') AND approved=1');
					$counter = $albums->GetItemCount ('i.aid IN (' . $albs . ') AND approved=1');
					$opnConfig['opndate']->sqlToopnData ($newest);
					$datetime = '';
					$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_DATESTRING5);
					$newest = buildnewtag ($newest);
					$categories[$item]['countmedia'] = $counter;
					$categories[$item]['datetime'] = $datetime;
					$categories[$item]['newest'] = $newest;
					$item++;
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $categories;

		}

		/**
		* returns a array for the sitemap
		*
		* @param 	array	$hlp1		The returnarray
		* @param 	int		$indent		The starting indent
		* @param	array	$url		The navurl
		* @param 	string	$item		The Itemname
		* @param    string  $idfield	The fieldname for the url
		*/

		function BuildSitemap (&$hlp1, $indent, $url, $item, $idfield) {

			global $opnConfig;

			$where = '';
			if ($this->_where != '') {
				$where = ' AND ' . $this->_where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat_name FROM ' . $this->table . ' WHERE cat_id>0 and cat_pid=0' . $where . ' ORDER BY cat_pos');
			while (! $result->EOF) {
				$id = $result->fields['cat_id'];
				$name = $result->fields['cat_name'];
				$childs = $this->getChildTreeArray ($id);
				$count = $this->getTotalItems ($id);
				if ($count>0) {
					$url[$idfield] = $id;
					$hlp1[] = array ('url' => $url,
							'name' => $name,
							'item' => $item . $id,
							'indent' => $indent,
							'id' => $id);
					$max = count ($childs);
					for ($i = 0; $i< $max; $i++) {
						if ($this->getTotalItems ($childs[$i][2]) ) {
							$indent1 = $indent+substr_count ($childs[$i][0], '.');
							$url[$idfield] = $childs[$i][2];
							$hlp1[] = array ('url' => $url,
									'name' => $childs[$i][1],
									'item' => $item . $childs[$i][2],
									'indent' => $indent1,
									'id' => $childs[$i][2]);
						}
					}
				}
				$result->MoveNext ();
			}
			$result->Close ();

		}

		/**
		* Returns the Itemresultset.
		*
		* @param 	array	$fields		The fieldlist
		* @param 	array	$orderby	The Order By fields
		* @param 	string	$where		The Itemwehere clausel
		* @return 	object	The Resultset
		*/

		function &GetItemResult ($fields, $orderby, $where = '', $group = '') {

			global $opnConfig;

			$sql = '';
			$this->_buildsql ($sql, $fields, $orderby, $where, $group);
			$result = $opnConfig['database']->Execute ($sql);
			$o = &$result;
			return $o;

		}

		/**
		* Returns the Itemresultset via SelectLimit
		*
		* @param 	array	$fields		The Fieldlist
		* @param 	array	$orderby	The Order By fields
		* @param 	int		$limit		The Limit
		* @param 	string	$where		The Itemwhere clausel
		* @param	int		offset		The offset
		* @return 	object	The Resultset
		*/

		function &GetItemLimit ($fields, $orderby, $limit, $where = '', $offset = 0) {

			global $opnConfig;

			$sql = '';
			$this->_buildsql ($sql, $fields, $orderby, $where);
			$result = $opnConfig['database']->SelectLimit ($sql, $limit, $offset);
			$o = &$result;
			return $o;

		}

		/**
		* Returns the Itemcounter
		*
		* @return int	The Itemcounter
		*/

		function GetItemCount ($itemwhere = '') {

			global $opnConfig;

			$sql = '';
			$this->_buildsql ($sql, '', array (),
								$itemwhere,
								'',
								true);
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$dnum = $result->fields['counter'];
				$result->Close ();
			} else {
				$dnum = 0;
			}
			return $dnum;

		}

		/**
		* Count the cats.
		*
		* @return int	The Catcount
		*/

		function GetCatCount () {

			global $opnConfig;

			$where = '';
			if ($this->_where != '') {
				$where = ' WHERE ' . $this->_where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT COUNT(cat_id) AS counter FROM ' . $this->table . $where);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$cat = $result->fields['counter'];
				$result->Close ();
			} else {
				$cat = 0;
			}
			return $cat;

		}

		/**
		* Generate the Item SQL Statement
		*
		* @param 	string	$sql		Holds the SQL Statement
		* @param 	array	$fields		The Fieldlist
		* @param 	array	$orderby	The Order By fields
		* @param 	string	$itemwhere	The Itemwhere Clausel
		*/

		function _buildsql (&$sql, $fields, $orderby, $itemwhere, $group = '', $count = false) {

			global $opnConfig;

			$where = '';
			$this->_builditemwhere ($where, $itemwhere);
			if (!$count) {
				$max = count ($fields);
				for ($i = 0; $i< $max; $i++) {
					$fields[$i] = 'i.' . $fields[$i] . ' AS ' . $fields[$i];
				}
				$fieldlist = implode (',', $fields);
				if (is_array($this->texttable)) {
					foreach ($this->texttable as $value) {
						$fields1 = array ();
						$max = count ($this->textfields[$value]);
						for ($i = 0; $i< $max; $i++) {
							$fields1[$i] = $value.'t.' . $this->textfields[$value][$i] . ' AS ' . $this->textfields[$value][$i];
						}
						$fieldlist .= ',' . implode (',', $fields1);
					}
				} elseif ( (!is_array($this->texttable)) && ($this->texttable != '') ) {
					$fields1 = array ();
					$max = count ($this->textfields);
					for ($i = 0; $i< $max; $i++) {
						$fields1[$i] = 't.' . $this->textfields[$i] . ' AS ' . $this->textfields[$i];
					}
					$fieldlist .= ',' . implode (',', $fields1);
				}
				if ( (count ($orderby) ) && ($orderby != '') ) {
					$orderlist = implode (',', $orderby);
				}
				$sql = 'SELECT ' . $fieldlist . ' FROM ' . $this->itemtable . ' i';
			} else {
				$sql = 'SELECT COUNT(i.' . $this->itemid . ') AS counter FROM ' . $this->itemtable . ' i';
			}
			if (is_array($this->texttable)) {
				foreach ($this->texttable as $value) {
					$sql .= ', ' . $value . ' '.$value.'t ';
				}
			} elseif ( (!is_array($this->texttable)) && ($this->texttable != '') ) {
				$sql .= ', ' . $this->texttable . ' t ';
			}
			// TODO : Should be changed in the next version.
			if ($opnConfig['permission']->IsWebmaster () ) {
				$sql .= $where . ' ';
			} else {
				$sql .= ', ' . $this->table . ' c ' . $where;
			}
			if ($group != '') {
				$sql .= ' GROUP BY ' . $group;
			}
			if ( (count ($orderby) ) && ($orderby != '') ) {
				$sql .= ' ORDER BY ' . $orderlist;
			}
			unset ($where);

		}

		function _checkand (&$where) {
			if ($where != ' WHERE ') {
				$where .= ' AND ';
			}

		}

		/**
		* Build the Wherestatement for the Itemquery
		*
		* @param	string	$where		The Where Statement
		* @param 	string	$itemwhere	The Itemwhereclausel
		*/

		function _builditemwhere (&$where, $itemwhere) {

			global $opnConfig;

			$where = ' WHERE ';
			// TODO : Should be changed in the next version.
			if (!$opnConfig['permission']->IsWebmaster () ) {
				$where .= 'i.' . $this->itemlink . '=c.cat_id';
			}
			if (is_array($this->texttable)) {
				foreach ($this->texttable as $value) {
					$this->_checkand ($where);
					$where .= $value.'t.' . $this->textlink . '=' . 'i.' . $this->itemid;
				}
			} elseif ( (!is_array($this->texttable)) && ($this->texttable != '') ) {
				$this->_checkand ($where);
				$where .= 't.' . $this->textlink . '=' . 'i.' . $this->itemid;
			}
			if ($itemwhere != '') {
				$this->_checkand ($where);
				$where .= $itemwhere;
			}
			if ($this->itemwhere != '') {
				$this->_checkand ($where);
				$where .= $this->itemwhere;
			}
			// TODO : Should be changed in the next version.
			if ( ($this->_where != '') && (!$opnConfig['permission']->IsWebmaster () ) ) {
				$checkerlist = $opnConfig['permission']->GetUserGroups ();
				$this->_checkand ($where);
				$where .= '(c.cat_usergroup IN (' . $checkerlist . '))';
				if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
					$this->_checkand ($where);
					$where .= "((c.cat_theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (c.cat_theme_group=0))";
				}
				unset ($checkerlist);
			}
			if ($where == ' WHERE ') {
				$where = '';
			}

		}

		/**
		* Generate the Where Statement for the SQL querys.
		*
		*/

		function _buildwhere ($themegroup = false) {

			global $opnConfig;

			$this->_where = '';
			if ($themegroup) {
				if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
					$this->_where .= "((cat_theme_group='" . $opnConfig['opnOption']['themegroup'] . "') OR (cat_theme_group=0))";
				}
			}
			$checkerlist = $opnConfig['permission']->GetUserGroups ();
			if ($this->_where != '') {
				$this->_where .= ' AND ';
			}
			$this->_where .= '(cat_usergroup IN (' . $checkerlist . '))';
			unset ($checkerlist);

		}

	}
}

?>