<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CSS_PARSER_INCLUDE') ) {
	define ('_OPN_CSS_PARSER_INCLUDE', 1);

	class opn_cssparser {

		/*<{php4}>
		var $css;
		var $html;
		<{php4/}>*/

		/*<{php5}>
		public $css;
		public $html;
		<{php5/}>*/

		/*<{delete}>*/
		var $css;
		var $html;
		/*<{delete/}>*/

		function opn_cssparser ($html = false) {
			// Register "destructor"
			register_shutdown_function (array (&$this, "finalize") );
			$this->html = ($html != false);
			$this->Clear ();

		}

		function finalize () {

			unset ($this->css);

		}

		function Clear () {

			unset ($this->css);
			$this->css = array ();
			if ($this->html) {
				$this->Add ('ADDRESS', '');
				$this->Add ('APPLET', '');
				$this->Add ('AREA', '');
				$this->Add ('A', 'text-decoration : underline; color : Blue;');
				$this->Add ('A:visited', 'color : Purple;');
				$this->Add ('BASE', '');
				$this->Add ('BASEFONT', '');
				$this->Add ('BIG', '');
				$this->Add ('BLOCKQUOTE', '');
				$this->Add ('BODY', '');
				$this->Add ('BR', '');
				$this->Add ('B', 'font-weight: bold;');
				$this->Add ('CAPTION', '');
				$this->Add ('CENTER', '');
				$this->Add ('CITE', '');
				$this->Add ('CODE', '');
				$this->Add ('DD', '');
				$this->Add ('DFN', '');
				$this->Add ('DIR', '');
				$this->Add ('DIV', '');
				$this->Add ('DL', '');
				$this->Add ('DT', '');
				$this->Add ('EM', '');
				$this->Add ('FONT', '');
				$this->Add ('FORM', '');
				$this->Add ('H1', '');
				$this->Add ('H2', '');
				$this->Add ('H3', '');
				$this->Add ('H4', '');
				$this->Add ('H5', '');
				$this->Add ('H6', '');
				$this->Add ('HEAD', '');
				$this->Add ('HR', '');
				$this->Add ('HTML', '');
				$this->Add ('IMG', '');
				$this->Add ('INPUT', '');
				$this->Add ('ISINDEX', '');
				$this->Add ('I', 'font-style: italic;');
				$this->Add ('KBD', '');
				$this->Add ('LINK', '');
				$this->Add ('LI', '');
				$this->Add ('MAP', '');
				$this->Add ('MENU', '');
				$this->Add ('META', '');
				$this->Add ('OL', '');
				$this->Add ('OPTION', '');
				$this->Add ('PARAM', '');
				$this->Add ('PRE', '');
				$this->Add ('P', '');
				$this->Add ('SAMP', '');
				$this->Add ('SCRIPT', '');
				$this->Add ('SELECT', '');
				$this->Add ('SMALL', '');
				$this->Add ('STRIKE', '');
				$this->Add ('STRONG', '');
				$this->Add ('STYLE', '');
				$this->Add ('SUB', '');
				$this->Add ('SUP', '');
				$this->Add ('TABLE', '');
				$this->Add ('TD', '');
				$this->Add ('TEXTAREA', '');
				$this->Add ('TH', '');
				$this->Add ('TITLE', '');
				$this->Add ('TR', '');
				$this->Add ('TT', '');
				$this->Add ('UL', '');
				$this->Add ('U', 'text-decoration : underline;');
				$this->Add ('VAR', '');
			}

		}

		function SetHTML ($html) {

			$this->html = ($html != false);

		}

		function Add ($key, $codestr) {

			$key = strtolower ($key);
			$codestr = strtolower ($codestr);
			if (!isset ($this->css[$key]) ) {
				$this->css[$key] = array ();
			}
			$codes = explode (';', $codestr);
			if (count ($codes)>0) {
				foreach ($codes as $code) {
					$code = trim ($code);
					if ($code != '') {
						list ($codekey, $codevalue) = explode (':', $code);
						if (strlen ($codekey)>0) {
							$this->css[$key][trim ($codekey)] = trim ($codevalue);
						}
					}
				}
			}

		}

		function Get ($key, $property) {

			$key = strtolower ($key);
			$property = strtolower ($property);
			if (substr_count ($key, ':')>0) {
				list ($tag, $subtag) = explode (':', $key);
			} else {
				$tag = $key;
				$subtag = '';
			}
			list ($tag, $class) = explode ('.', $tag);
			if (substr_count ($tag, '#')>0) {
				list ($tag, $id) = explode ('#', $tag);
			} else {
				$id = '';
			}
			$result = '';
			foreach ($this->css as $_tag => $value) {
				if (substr_count ($_tag, ':')>0) {
					list ($_tag, $_subtag) = explode (':', $_tag);
				} else {
					$_subtag = '';
				}
				if (substr_count ($_tag, '.')>0) {
					list ($_tag, $_class) = explode ('.', $_tag);
				} else {
					$_class = '';
				}
				if (substr_count ($_tag, '#')>0) {
					list ($_tag, $_id) = explode ('#', $_tag);
				} else {
					$_id = '';
				}
				$tagmatch = (strcmp ($tag, $_tag) == 0)| (strlen ($_tag) == 0);
				$subtagmatch = (strcmp ($subtag, $_subtag) == 0)| (strlen ($_subtag) == 0);
				$classmatch = (strcmp ($class, $_class) == 0)| (strlen ($_class) == 0);
				$idmatch = (strcmp ($id, $_id) == 0);
				if ($tagmatch&$subtagmatch&$classmatch&$idmatch) {
					$temp = $_tag;
					if ( (strlen ($temp)>0)& (strlen ($_class)>0) ) {
						$temp .= '.' . $_class;
					} elseif (strlen ($temp) == 0) {
						$temp = '.' . $_class;
					}
					if ( (strlen ($temp)>0)& (strlen ($_subtag)>0) ) {
						$temp .= ':' . $_subtag;
					} elseif (strlen ($temp) == 0) {
						$temp = ':' . $_subtag;
					}
					if (isset ($this->css[$temp][$property]) ) {
						$result = $this->css[$temp][$property];
					}
				}
			}
			return $result;

		}

		function GetSection ($key) {

			$key = strtolower ($key);
			if (substr_count ($key, ':')>0) {
				list ($tag, $subtag) = explode (':', $key);
			} else {
				$tag = $key;
				$subtag = '';
			}
			list ($tag, $class) = explode ('.', $tag);
			if (substr_count ($tag, '#')>0) {
				list ($tag, $id) = explode ('#', $tag);
			} else {
				$id = '';
			}
			$result = array ();
			foreach ($this->css as $_tag => $value) {
				if (substr_count ($_tag, ':')>0) {
					list ($_tag, $_subtag) = explode (':', $_tag);
				} else {
					$_subtag = '';
				}
				if (substr_count ($_tag, '.')>0) {
					list ($_tag, $_class) = explode ('.', $_tag);
				} else {
					$_class = '';
				}
				if (substr_count ($_tag, '#')>0) {
					list ($_tag, $_id) = explode ('#', $_tag);
				} else {
					$_id = '';
				}
				$tagmatch = (strcmp ($tag, $_tag) == 0)| (strlen ($_tag) == 0);
				$subtagmatch = (strcmp ($subtag, $_subtag) == 0)| (strlen ($_subtag) == 0);
				$classmatch = (strcmp ($class, $_class) == 0)| (strlen ($_class) == 0);
				$idmatch = (strcmp ($id, $_id) == 0);
				if ($tagmatch&$subtagmatch&$classmatch&$idmatch) {
					$temp = $_tag;
					if ( (strlen ($temp)>0)& (strlen ($_class)>0) ) {
						$temp .= '.' . $_class;
					} elseif (strlen ($temp) == 0) {
						$temp = '.' . $_class;
					}
					if ( (strlen ($temp)>0)& (strlen ($_subtag)>0) ) {
						$temp .= ':' . $_subtag;
					} elseif (strlen ($temp) == 0) {
						$temp = ':' . $_subtag;
					}
					foreach ($this->css[$temp] as $property => $value) {
						$result[$property] = $value;
					}
				}
			}
			return $result;

		}

		function ParseStr ($str) {

			$this->Clear ();
			// Remove comments
			$str = preg_replace ("/\/\*(.*)?\*\//Usi", '', $str);
			// Parse this damn csscode
			$parts = explode ('}', $str);
			if (count ($parts)>0) {
				foreach ($parts as $part) {
					$part = trim ($part);
					if ($part != '') {
						list ($keystr, $codestr) = explode ('{', $part);
						$keys = explode (',', trim ($keystr) );
						if (count ($keys)>0) {
							foreach ($keys as $key) {
								if (strlen ($key)>0) {
									$key = str_replace ("\n", '', $key);
									$key = str_replace ("\\", '', $key);
									$this->Add ($key, trim ($codestr) );
								}
							}
						}
					}
				}
			}
			//
			return (count ($this->css)>0);

		}

		function ParseImport ($filename, $content) {

			$contents = '';
			$help = '';
			$parts = explode ('.css);', $content);
			if (count ($parts) ) {
				$dirname = dirname ($filename);
				foreach ($parts as $part) {
					$part = trim ($part);
					if ($part != '') {
						$code = explode ('import url(', $part);
						if (count ($code) == 2) {
							$help .= file_get_contents ($dirname . '/' . $code[1] . '.css');
						} else {
							$contents .= $code[0];
						}
					}
				}
				$contents .= $help;
			} else {
				$contents = $content;
			}
			return $this->ParseStr ($contents);

		}

		function Parse ($filename) {

			$this->Clear ();
			if (file_exists ($filename) ) {
				return $this->ParseImport ($filename, file_get_contents ($filename) );
			}
			return false;

		}

		function GetCSS () {

			$result = '';
			foreach ($this->css as $key => $values) {
				$result .= $key . ' {' . _OPN_HTML_NL;
				foreach ($values as $key => $value) {
					$result .= '  ' . $key . ': ' . $value . ';' . _OPN_HTML_NL;
				}
				$result .= '}' . _OPN_HTML_NL . _OPN_HTML_NL;
			}
			return $result;

		}

	}
}

?>