<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('OPN_CLASS_OPN_META_TYPE_INCLUDE') ) {
	define ('OPN_CLASS_META_TYPE_INCLUDE', 1);

	class opn_meta_type {

		function opn_meta_type () {

		}

		function get_file_icon ($ext) {

			global $opnConfig;
			if ( (isset ($opnConfig['opn_meta_file_icon_set']) ) && ($opnConfig['opn_meta_file_icon_set'] != '') ) {
				$imagepath = $opnConfig['opn_meta_file_icon_set'];
			} else {
				$imagepath = $opnConfig['opn_default_images'] . 'meta_file_icon_set/default/';
			}
			if ($ext == '') {
				$icon = 'generic';
			} else {
				$icon = 'unknown';
				static $types = null;
				if ($types === null) {
					$types = array ('binary' => array ('exe',
									'bin',
									'msi'),
									'binhex' => array ('hqx'),
							'cd' => array ('cue',
							'mds',
							'iso',
							'nrg',
							'mdf',
							'ccd',
							'bwt',
							'cdi',
							'img'),
							'dll' => array ('dll',
							'386',
							'db',
							'ocx',
							'sdb',
							'vxd'),
							'tar' => array ('tar'),
							'doc' => array ('doc',
							'rtf',
							'wri',
							'dif',
							'cwk',
							'ans',
							'mcw',
							'wps'),
							'xls' => array ('xla',
							'xls',
							'xlt',
							'xlw',
							'csv',
							'dbf',
							'prn'),
							'ppt' => array ('ppt',
							'pps',
							'pot',
							'ppa',
							'emf'),
							'ps' => array ('ps'),
							'pdf' => array ('pdf',
							'edn',
							'pdx',
							'pdp'),
							'java' => array ('jar',
							'java',
							'jtk',
							'class'),
							'js' => array ('js',
							'jse',
							'vbs',
							'ebs',
							'wsc',
							'wsf',
							'wsh'),
							'compressed' => array ('zip',
								'z',
								'tgz',
								'gz',
								'rar',
								'bz2',
								'7z',
								'ace',
								'lzh',
								'xxe',
								'sit',
								'arc',
								'taz',
								'tbz',
								'tbz2',
								'deb',
								'rpm',
								'cab',
								'zoo',
								'arj',
								'lha',
								'a'),
								'image' => array ('jpg',
							'png',
							'bmp',
							'gif',
							'tif',
							'tga',
							'jpeg',
							'tiff',
							'psd',
							'jpc',
							'jp2',
							'jpx',
							'swc',
							'jfif',
							'art',
							'ico',
							'jpe',
							'jif'),
							'movie' => array ('mpg',
							'avi',
							'divx',
							'mpeg',
							'ram',
							'wmv',
							'mpe',
							'asf',
							'mkv',
							'asx',
							'ogm'),
							'mov' => array ('mov',
							'qt',
							'mac',
							'mpg4',
							'pct',
							'pic',
							'pict',
							'pnt',
							'pntg',
							'qti',
							'qtif',
							'qtl',
							'qts',
							'qtx'),
							'sound' => array ('mp3',
							'mp2',
							'ogg',
							'wav',
							'mpc',
							'flac',
							'ape',
							'aac',
							'mp4',
							'aif',
							'aiff',
							'au',
							'mid',
							'midi',
							'vqf',
							'mod',
							'wma',
							'voc',
							'mp+',
							'mpp',
							'bonk',
							'ofr',
							'shn',
							'lqt',
							'mpga',
							'ra',
							'pac',
							'wv',
							'mka',
							'mp1',
							'spc',
							'rmjb',
							'rm',
							'm4a',
							'wave',
							'pcm',
							'la'),
							'uu' => array ('uue',
							'uu',
							'uud'),
							'text' => array ('txt',
							'md5',
							'sfv',
							'c',
							'cpp',
							'h',
							'm3u',
							'cc',
							'cp'),
							'comp' => array ('nfo',
							'ini',
							'inf',
							'cfg',
							'log',
							'conf',
							'reg'),
							'web' => array ('html',
							'htm',
							'asp',
							'css',
							'shtml',
							'pl',
							'perl',
							'swf',
							'cgi',
							'mht',
							'mhtml',
							'xml',
							'rss',
							'dtd',
							'jsp',
							'com',
							'org',
							'net'),
							'php' => array ('php',
							'phps',
							'php3',
							'php4',
							'phtml'),
							'key' => array ('pgp',
							'asc',
							'ppk',
							'key') );
				}
				foreach ($types as $png_name => $exts) {
					if (in_array ($ext, $exts) ) {
						$icon = $png_name;
						break;
					}
				}
			}
			return '<img class="imgtag" alt="[' . $ext . ']" height="16" width="16" src="' . $imagepath . $icon . '.png" /> ';

		}

	}
}

?>