<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_OPN_XML_INCLUDED') ) {
	define ('_OPN_OPN_XML_INCLUDED', 1);

	class opn_xml {
		// The object of the parser is to determine the "State" of the XML
		// and set up the class to respond accordingly. The critical information.

		/*<{php4}>
		var $URL;	   // The location of the external feed.
		var $contents;  // The RSS/XML from the feed
		var $items = array();	// The channelitems
		var $index = array();	// The Tag indices
		var $xml_list_elements = array();
		var $encoding = '';		// The enconding of the XML file;
		var $getattributes = false;
		<{php4/}>*/

		/*<{php5}>
		public $URL;	   // The location of the external feed.
		public $contents;  // The RSS/XML from the feed
		public $items = array();	// The channelitems
		public $index = array();	// The Tag indices
		public $xml_list_elements = array();
		public $encoding = '';		// The enconding of the XML file;
		public $getattributes = false;
		<{php5/}>*/

		/*<{delete}>*/
		var $URL;	   // The location of the external feed.
		var $contents;  // The RSS/XML from the feed
		var $items = array();	// The channelitems
		var $index = array();	// The Tag indices
		var $xml_list_elements = array();
		var $encoding = '';		// The enconding of the XML file;
		var $getattributes = false;
		/*<{delete/}>*/
		// Define the functions required for handling the different pieces.

		function opn_xml () {
			// Constructor
			$this->contents = '';
			$this->encoding = '';
			$this->items = array ();
			$this->index = array ();
			$this->xml_list_elements = array ();
			$this->getattributes = false;

		}
		// METHODS AND PROPERTIES *****************************************

		function Set_Listelement ($element) {

			$this->xml_list_elements[count ($this->xml_list_elements)] = $element;

		}

		function Set_URL ($url) {
			// This is the URL to the feed. The class expects that RSS/XML will
			// be returned.
			$this->URL = $url;
			// Knowing this, we can get the feed contents now.
			// Get the RSS/XML from the feed URL
			$this->_load_file ();
			$this->_parse ();

		}

		function GetAttributes ($bool) {

			$this->getattributes = $bool;

		}

		function _parse () {
			if ($this->contents != '') {
				$c = substr ($this->contents, strpos ($this->contents, '<?xml'), strlen ($this->contents) );
				$x = strrpos ($c, '>');
				$len = strlen ($c);
				if ($x< ($len-1) ) {
					$c = substr ($c, 0, $x+1);
				}
				// Determine encoding
				$this->encoding = 'iso-8859-1';
				$sarr = '';
				preg_match ('/encoding=\"(.*?)\"/i', $c, $sarr);
				if (count ($sarr) ) {
					$this->encoding = strtolower ($sarr[1]);
				}
				$parser = xml_parser_create (strtoupper ($this->encoding));
				xml_parser_set_option ($parser, XML_OPTION_CASE_FOLDING, 0);
				$values = '';
				$tags = '';
				xml_parse_into_struct ($parser, $c, $values, $tags);
				xml_parser_free ($parser);
				// we store our path here
				$hash_stack = array ();
				// this is our target
				foreach ($values as $key => $val) {
					switch ($val['type']) {
						case 'open':
							array_push ($hash_stack, $val['tag']);
							if ( (isset ($val['attributes']) ) && ($this->getattributes) ) {
								$this->items = $this->composeArray ($this->items, $hash_stack, $val['attributes']);
							} else {
								$this->items = $this->composeArray ($this->items, $hash_stack);
							}
							break;
						case 'close':
							array_pop ($hash_stack);
							break;
						case 'complete':
							array_push ($hash_stack, $val['tag']);
							if (isset ($val['value']) ) {
								$this->items = $this->composeArray ($this->items, $hash_stack, $val['value']);
							} else {
								$this->items = $this->composeArray ($this->items, $hash_stack, '');
							}
							array_pop ($hash_stack);
							// handle attributes
							if ( (isset ($val['attributes']) ) && ($this->getattributes) ) {
								while (list ($a_k, $a_v) = each ($val['attributes']) ) {
									$hash_stack[] = $val['tag'] . "_attribute_" . $a_k;
									$this->items = $this->composeArray ($this->items, $hash_stack, $a_v);
									array_pop ($hash_stack);
								}
							}
							break;
					}
				}
				$this->index = $tags;
				unset ($values);
				unset ($tags);
				unset ($hash_stack);
				unset ($c);
			}

		}

		function _load_file () {
			// Get the raw feed from the URL. Because this uses a URL as the feed source
			// it can be used to process an RSS/XML feed from any web site, including local.
			if (substr_count ($this->URL, '://')>0) {
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_http.php');
				$http =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ http ();
				$status = $http->get ($this->URL);
				if ($status == HTTP_STATUS_OK) {
					$this->contents = $http->get_response_body ();
				} else {
					$this->contents = 'received status ' . $status . ' -- ' . $this->URL;
				}
				$http->disconnect ();
			} else {
				$this->contents = file_get_contents ($this->URL);
			}

		}

		function &composeArray ($array, $elements, $value = array () ) {
			// get current element
			$element = array_shift ($elements);
			// does the current element refer to a list
			if (in_array ($element, $this->xml_list_elements) ) {
				// more elements?
				if (sizeof ($elements)>0) {
					$array[$element][sizeof ($array[$element])-1] = &$this->composeArray ($array[$element][sizeof ($array[$element])-1], $elements, $value);
				} else {
					// if (is_array($value))
					if (isset ($array[$element]) ) {
						$array[$element][sizeof ($array[$element])] = $value;
					} else {
						$array[$element][0] = $value;
					}
				}
			} else {
				// more elements?
				if (sizeof ($elements)>0) {
					$array[$element] = &$this->composeArray ($array[$element], $elements, $value);
				} else {
					$array[$element] = $value;
				}
			}
			$o = &$array;
			return $o;

		}

	}
	// end of class
}
// if

?>