<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_SETTINGS_RIGHTS_INCLUDED') ) {
	define ('_OPN_CLASS_SETTINGS_RIGHTS_INCLUDED', 1);
	if (!defined ('_OPN_CLASS_SETTINGS_RIGHTS_PHP_INCLUDED') ) {
		define ('_OPN_CLASS_SETTINGS_RIGHTS_PHP_INCLUDED', 1);

		class MySettings_Rights extends MySettings {

			function GetRightsForm ($name, $right, $rights, $rightstext) {

				global $opnConfig;

				$values[] = array ('type' => _INPUT_TITLE,
						'title' => sprintf (_ADMIN_PERM_RIGHTS,
						$name) );
				$values[] = array ('type' => _INPUT_BLANKLINE);
				$max = count ($rights);
				for ($i = 0; $i< $max; $i++) {
					$values[] = array ('type' => _INPUT_CHECKBOX,
							'display' => $rightstext[$i],
							'name' => 'right' . $i,
							'value' => $rights[$i]+1,
							'checked' => $opnConfig['permission']->IsRightSet ($right,
							$rights[$i],
							$i . '/' . $i) );
				}
				return $values;

			}

			function UpdateGroupRight ($gid, $module, $rights) {

				global $opnConfig, $opnTables;

				$right = 0;
				$this->BuildRight ($right, $rights);
				$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_group_rights'] . " SET perm_rights='" . $right . "' WHERE perm_user_group=" . $gid . " and perm_module='" . $module . "'");

			}

			function UpdateUserRight ($uid, $module, $rights) {

				global $opnConfig, $opnTables;

				$right = 0;
				$this->BuildRight ($right, $rights);
				$opnConfig['database']->Execute ('UPDATE ' . $opnTables['user_rights'] . " SET perm_rights='" . $right . "' WHERE perm_uid=" . $uid . " and perm_module='" . $module . "'");

			}

			function InsertGroupRight ($gid, $module, $rights) {

				global $opnConfig, $opnTables;

				$right = '';
				$this->BuildRight ($right, $rights);
				$pid = $opnConfig['opnSQL']->get_new_number ('user_group_rights', 'perm_id');
				$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_group_rights'] . " values (" . $pid . "," . $gid. ",'" . $module . "','" . $right . "')");

			}

			function InsertUserRight ($uid, $module, $rights) {

				global $opnConfig, $opnTables;

				$right = '';
				$this->BuildRight ($right, $rights);
				$pid = $opnConfig['opnSQL']->get_new_number ('user_rights', 'perm_id');
				$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_rights'] . " values ($pid,$uid,'$module','$right')");

			}

			function SetSingleGroupRight ($gid, $module, $fullright, $right) {

				global $opnConfig, $opnTables;

				$opnConfig['permission']->SetSingleRight ($fullright, $right);
				$select = 'SELECT perm_id FROM ' . $opnTables['user_group_rights'] . ' WHERE perm_user_group=' . $gid . " and perm_module='$module'";
				$update = 'UPDATE ' . $opnTables['user_group_rights'] . " SET perm_rights='$fullright' WHERE perm_user_group=" . $gid . " and perm_module='$module'";
				$insert = 'INSERT INTO ' . $opnTables['user_group_rights'] . " values (%s,$gid,'$module','$fullright')";
				$opnConfig['opnSQL']->ensure_dbwrite ($select, $update, $insert, 'user_group_rights', 'perm_id');

			}

			function SetUnsetSingleUserRight ($uid, $module, $fullright, $right, $unset = false) {

				global $opnConfig, $opnTables;
				if ($unset) {
					$opnConfig['permission']->UnsetSingleRight ($fullright, $right);
				} else {
					$opnConfig['permission']->SetSingleRight ($fullright, $right);
				}
				$select = 'SELECT perm_id FROM ' . $opnTables['user_rights'] . ' WHERE perm_uid=' . $uid . " and perm_module='$module'";
				$update = 'UPDATE ' . $opnTables['user_rights'] . " SET perm_rights='$fullright' WHERE perm_uid=" . $uid . " and perm_module='$module'";
				$insert = 'INSERT INTO ' . $opnTables['user_rights'] . " values (%s,$uid,'$module','$fullright')";
				$opnConfig['opnSQL']->ensure_dbwrite ($select, $update, $insert, 'user_rights', 'perm_id');

			}

			function UnsetSingleGroupRight ($gid, $module, $fullright, $right) {

				global $opnConfig, $opnTables;

				$opnConfig['permission']->UnsetSingleRight ($fullright, $right);
				$select = 'SELECT perm_id FROM ' . $opnTables['user_group_rights'] . ' WHERE perm_user_group=' . $gid . " and perm_module='$module'";
				$update = 'UPDATE ' . $opnTables['user_group_rights'] . " SET perm_rights='$fullright' WHERE perm_user_group=" . $gid . " and perm_module='$module'";
				$insert = 'INSERT INTO ' . $opnTables['user_group_rights'] . " values (%s,$gid,'$module','$fullright')";
				$opnConfig['opnSQL']->ensure_dbwrite ($select, $update, $insert, 'user_group_rights', 'perm_id');

			}

			function DeleteGroupRight ($gid, $module) {

				global $opnConfig, $opnTables;

				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_group_rights'] . ' WHERE perm_user_group=' . $gid . " and perm_module='" . $module . "'");

			}

			function DeleteUserRight ($uid, $module) {

				global $opnConfig, $opnTables;

				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['user_rights'] . ' WHERE perm_uid=' . $uid . " and perm_module='" . $module . "'");

			}

			function BuildRight (&$right, $rights) {

				global $opnConfig;

				$right = '';
				$new = array ();
				$max = count ($rights);
				for ($i = 0; $i< $max; $i++) {
					$right1 = 0;
					get_var ('right' . $i, $right1, 'form', _OOBJ_DTYPE_INT);
					if ($right1) {
						$new[] = $right1-1;
					}
				}
				if (count ($new) ) {
					$opnConfig['permission']->BuildFlag ($right, $new);
				} else {
					$right = '00000X00000X00000X00000X00000X00000';
				}

			}

			function BuildDisplayRights ($module, $filepath, &$rights, &$rightstext) {

				global $opnConfig;

				$file = $filepath . '/plugin/userrights/index.php';
				if (file_exists ($file) ) {
					include_once ($file);
					$myfunc = $module . '_get_rights';
					if (function_exists ($myfunc) ) {
						$rights = array () ;
						$myfunc ($rights);
					}
					$myfunc = $module . '_get_rightstext';
					if (function_exists ($myfunc) ) {
						$rightstext = array () ;
						$myfunc ($rightstext);
					}
				}

			}

			function BuildDisplayUserRights ($module, &$rights, &$rightstext) {

				$myfunc = $module . '_get_userrights';
				if (function_exists ($myfunc) ) {
					$rights = array () ;
					$myfunc ($rights);
				}
				$myfunc = $module . '_get_userrightstext';
				if (function_exists ($myfunc) ) {
					$rightstext = array () ;
					$myfunc ($rightstext);
				}

			}

			function BuildDisplayAdminRights ($module, &$rights, &$rightstext) {

				$myfunc = $module . '_get_adminrights';
				if (function_exists ($myfunc) ) {
					$rights = array () ;
					$myfunc ($rights);
				}
				$myfunc = $module . '_get_adminrightstext';
				if (function_exists ($myfunc) ) {
					$rightstext = array () ;
					$myfunc ($rightstext);
				}

			}

		}
	}
}

?>