<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_TEXT_INCLUDED') ) {
	define ('_OPN_CLASS_TEXT_INCLUDED', 1);

	class opnSystemText {

		function opnSystemText () {
			// Build restricted Tags

		}

		function makeClickable ($text) {

			$patterns = array ("/([^]_a-z0-9-=\"'\/])([a-z]+?):\/\/([^, \r\n\"\(\)'<>]+)/i",
					"/([^]_a-z0-9-=\"'\/\.])www\.([a-z0-9\-]+)\.([^, \r\n\"\(\)'<>]+)/i",
					"/([^]_a-z0-9-=\"'\/])ftp\.([a-z0-9\-]+)\.([^, \r\n\"\(\)'<>]+)/i",
					"/(?<!href=\")([^]_a-z0-9-=\"'\/:])(([^]_a-z0-9-=\"'\/:])([a-z0-9\-_.]+?)@([^, \r\n\"\(\)'<>]+))/i");
			$replacements = array ("\\1<a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a>",
						"\\1<a href=\"http://www.\\2.\\3\" target=\"_blank\">www.\\2.\\3</a>",
						"\\1<a href=\"ftp://ftp.\\2.\\3\" target=\"_blank\">ftp.\\2.\\3</a>",
						"\\3<a href=\"mailto:\\4@\\5\">\\4@\\5</a>");
			return preg_replace ($patterns, $replacements, $text);

		}

		/* i remove it later +stefan */

		function make_clickable ($text) {

			$ret = preg_replace ('#(^|[^\"=]{1})(http://|ftp://|mailto:|news:)([^\s<>]+)([\s\n<>]|$)#sm', '\\1<a class="opncenterbox" href="\\2\\3" target="_blank">\\2\\3</a>\\4', $text);
			return ($ret);

		}

		/**
		* Convert HTML entities to all applicable characters
		*
		* @access public
		* @param string $string
		* @return void
		**/

		function un_htmlentities (&$string) {

			$ts = array_flip (get_html_translation_table (HTML_ENTITIES) );
			$string = strtr ($string, $ts);

		}

		function FixQuotes ($what = '') {
			if (get_magic_quotes_gpc () ) {
				$what = str_replace ('\\"', '"', $what);
				$what = stripslashes ($what);
			}
			return $what;

		}

		function formatURL (&$url) {

			$url = trim ($url);
			if ( ($url == 'http://') OR ($url == 'https://') ) {
				$url = '';
			} else {
				if ( (!stristr ($url, 'http://') ) && (!stristr ($url, 'https://') ) ) {
					if ( (strpos ($url, '/') ) === 0) {
						$url = 'http:/' . $url;
					} else {
						$url = 'http://' . $url;
					}
				}
			}

		}

		function htmlwrap1 ($str, $cols, $cut) {

			$tag_open = '<';
			$tag_close = '>';
			$count = 0;
			$in_tag = 0;
			$str_len = strlen ($str);
			$segment_width = 0;
			for ($i = 0; $i< $str_len; $i++) {
				if ($str{$i} == $tag_open) {
					$in_tag++;
				} elseif ($str{$i} == $tag_close) {
					if ($in_tag>0) {
						$in_tag--;
					}
				} else {
					if ($in_tag == 0) {
						$segment_width++;
						if ( ($segment_width>$cols) && ($str{$i} != " ") ) {
							$str = substr ($str, 0, $i-1) . $cut . substr ($str, $i-1, $str_len-1);
							$i += strlen ($cut);
							$str_len = strlen ($str);
							$segment_width = 0;
						}
					}
				}
			}
			return $str;

		}

		function OPNformatURL (&$url) {

			global $opnConfig;

			$url = trim ($url);
			if ( ($url == 'http://') OR ($url == 'https://') ) {
				$url = '';
			} else {
				if (!stristr ($url, '://') ) {
					if ( (strpos ($url, '/') ) === 0) {
						$sep = '';
					} else {
						$sep = '/';
					}
					if (substr_count ($url, 'opnparams') == 0) {
						if (substr_count ($url, '?')>0) {
							$hurl = array ();
							$hurl[0] = $opnConfig['opn_url'] . $sep;
							$hlp = explode ('?', $url);
							$hurl[0] .= $hlp[0];
							if (substr_count ($hlp[1], '&')>0) {
								$hlp1 = explode ('&', $hlp[1]);
								$keys = array_keys ($hlp1);
								foreach ($keys as $key) {
									$hlp2 = explode ('=', $hlp1[$key]);
									if (isset ($hlp2[1]) ) {
										$hurl[$hlp2[0]] = $hlp2[1];
									} else {
										$hurl[$hlp2[0]] = '';
									}
								}
								unset ($hlp2);
							} else {
								$hlp1 = explode ('=', $hlp[1]);
								$hurl[$hlp1[0]] = $hlp1[1];
							}
							unset ($hlp1);
							unset ($hlp);
						} else {
							$hurl = $opnConfig['opn_url'] . $sep . $url;
						}
						$url = encodeurl ($hurl);
						unset ($hurl);
					} else {
						$url = $opnConfig['opn_url'] . $sep . $url;
					}
				} else {
					$url = htmlspecialchars ($url);
				}
			}

		}

		function var_possible_check (&$str, $possible_var) {

			if (is_array($possible_var)) {

				foreach ($possible_var as $ourvar) {
					if (substr_count ($str, $ourvar)>0) {
						$str = $ourvar;
						return true;
					}
				}

			} else {
				$str = '';
				return false;
			}
			$str = '';
			return true;

		}

		function restrictedHTML (&$html, $tags = 'br') {

			$html = preg_replace ('/<([' . $tags . '])[^>]*>/i', '<\1>', $html);

		}

		function check_html (&$str, $strip = '') {

			global $opnConfig;
			if ($strip == 'nohtml') {
				$str = strip_tags ($str);
			}
			if ($strip == 'recodehtml') {
				$str = str_replace ('<', '&lt;', $str);
				$str = str_replace ('&lt;br />', '<br />', $str);
			}
			if ($strip == '') {
				$str = preg_replace ("/<\s*([^>]*)\s*>/i", "<\\1>", $str);
				$tmp = '';
				$search = array ("# onclick=\"(.*?)\"#si",
						"# ondblclick=\"(.*?)\"#si",
						"# onmousedown=\"(.*?)\"#si",
						"# onmouseup=\"(.*?)\"#si",
						"# onmouseover=\"(.*?)\"#si",
						"# onmousemove=\"(.*?)\"#si",
						"# onmouseout=\"(.*?)\"#si",
						"# onkeypress=\"(.*?)\"#si",
						"# onkeyup=\"(.*?)\"#si",
						"# onkeydown=\"(.*?)\"#si",
						"# onblur=\"(.*?)\"#si",
						"# onfocus=\"(.*?)\"#si",
						"# onload=\"(.*?)\"#si",
						"# onunload=\"(.*?)\"#si",
						"# onreset=\"(.*?)\"#si",
						"# onsubmit=\"(.*?)\"#si",
						"# onerror=\"(.*?)\"#si",
						"# onchange=\"(.*?)\"#si",
						"# onselect=\"(.*?)\"#si");
				$replace = array ('',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'');
				$reg = '';
				while (preg_match ("/<([^> ]*)([^>]*)>/i", $str, $reg) ) {
					$i = strpos ($str, $reg[0]);
					$l = strlen ($reg[0]);
					if ($reg[1]{0} == '/') {
						$tag = strtolower (substr ($reg[1], 1) );
					} else {
						$tag = strtolower ($reg[1]);
					}
					if (isset ($opnConfig['AllowableHTML'][$tag]) ) {
						$a = $opnConfig['AllowableHTML'][$tag];
						if ($reg[1]{0} == '/') {
							$tag = '</' . $tag . '>';
						} elseif ($a == 1) {
							$tag = '<' . $tag . '>';
						} elseif ($a == 2) {
							$tag = '<' . $tag . preg_replace ($search, $replace, $reg[2]) . '>';
						} else {
							$tag = '<' . $tag . $reg[2] . '>';
						}
					} else {
						$tag = '';
					}
					$tmp .= substr ($str, 0, $i) . $tag;
					$str = substr ($str, $i+ $l);
				}
				unset ($search);
				unset ($replace);
				$str = $tmp . $str;
				unset ($tmp);
				unset ($reg);
				// Squash PHP tags unconditionally
				$str = preg_replace ('/<\?/', '', $str);
				$str = str_replace ('<br>', '<br />', $str);
			}

		}

		function check_words (&$Message) {

			global $opnConfig;
			if ($opnConfig['CensorMode'] == 1) {
				$max = count ($opnConfig['CensorList']);
				for ($i = 0; $i< $max; $i++) {
					$bad = $opnConfig['CensorList'][$i];
					$replacement = $opnConfig['ReplacementList'][$i];
					$bad = quotemeta ($bad);
					$patterns[] = "/(\s)" . $bad . "/siU";
					$replacements[] = "\\1" . $replacement;
					$patterns[] = "/^" . $bad . "/siU";
					$replacements[] = $replacement;
					$patterns[] = "/(\n)" . $bad . "/siU";
					$replacements[] = "\\1" . $replacement;
					$patterns[] = "/]" . $bad . "/siU";
					$replacements[] = "]" . $replacement;
					$Message = preg_replace ($patterns, $replacements, $Message);
				}
			}

		}

		function CheckMessage (&$message) {

			global $opnConfig;
			if (!isset ($opnConfig['safety_filtersetting']) ) {
				$opnConfig['safety_filtersetting'] = 2;
			}
			if ($opnConfig['safety_filtersetting'] == 1) {
				if (is_array ($opnConfig['safety_filtersetting_list']) ) {
					$search = array ();
					$replace = array ();
					$max = count ($opnConfig['safety_filtersetting_list']);
					for ($i = 0; $i< $max; $i++) {
						if ( (isset ($opnConfig['safety_filtersetting_list'][$i]) ) && ($opnConfig['safety_filtersetting_list'][$i] != '') ) {
							$search[] = '|<\s*' . strtoupper ($opnConfig['safety_filtersetting_list'][$i]) . '.*?|si';
							$replace[] = '&lt;' . strtolower ($opnConfig['safety_filtersetting_list'][$i]);
						}
					}
					$message = preg_replace ($search, $replace, $message);
					$message = str_replace ('javascript:eval', '', $message);
				}
			} elseif ($opnConfig['safety_filtersetting'] == 2) {
				$search = array ('|<\s*SCRIPT.*?|si',
						'|<\s*FRAME.*?|si',
						'|<\s*OBJECT.*?|si',
						'|<\s*META.*?|si',
						'|<\s*APPLET.*>|si',
						'|<\s*LINK.*?|si',
						'|<\s*IFRAME.*?|si',
						'|<\s*/SCRIPT.*?|si',
						'|<\s*BODY.*?|si',
						'|<\s*/BODY.*?|si',
						'|<\s*FORM.*?|si',
						'|<\s*/FORM.*?|si',
						'|<\s*HTML.*?|si',
						'|<\s*/HTML.*?|si',
						'|<\s*HEAD.*?|si',
						'|<\s*/HEAD.*?|si',
						'|<\s*TEXTAREA.*?|si',
						'|<\s*/TEXTAREA.*?|si',
						'|<\s*INPUT.*?|si',
						'|<\s*SELECT.*?|si',
						'|<\s*/SELECT.*?|si',
						'|<\s*BASE.*?|si',
						'|<\s*PARAM.*?|si',
						'|<\s*AREA.*?|si',
						'|<\s*MAP.*?|si',
						'|<\s*/MAP.*?|si',
						'|<\s*\?.*?|si',
						'|\?\s*>.*?|si',
						'|<\s*OPTION.*?|si',
						'|<\s*/OPTION.*?|si',
						'|<\s*/APPLET.*>|si',
						'|<\s*/OBJECT.*?|si',
						'|<\s*FRAMESET.*?|si',
						'|<\s*/FRAMESET.*?|si',
						'|<\s*TITLE.*?|si',
						'|<\s*/TITLE.*?|si',
						'|\s*WINDOW.OPEN|si',
						'|\s*DOCUMENT.OPEN|si',
						'|\s*DOCUMENT.WRITE|si',
						'|\s*DOCUMENT.COOKIE|si');
				$replace = array ('&lt;script',
						'&lt;frame',
						'&lt;object',
						'&lt;meta',
						'&lt;applet',
						'&lt;link',
						'&lt;iframe',
						'&lt;/script',
						'&lt;body',
						'&lt;/body',
						'&lt;form',
						'&lt;/form',
						'&lt;html',
						'&lt;/html',
						'&lt;head',
						'&lt;/head',
						'&lt;textarea',
						'&lt;/textarea',
						'&lt;input',
						'&lt;select',
						'&lt;/select',
						'&lt;base',
						'&lt;param',
						'&lt;area',
						'&lt;map',
						'&lt;/map',
						'&lt;?',
						'?&gt;',
						'&lt;option',
						'&lt;/option',
						'&lt;/applet',
						'&lt;/object',
						'&lt;frameset',
						'&lt;/frameset',
						'&lt;title',
						'&lt;/title',
						'#window.open',
						'#document.open',
						'#document.write',
						'#document.cookie');
				$message = preg_replace ($search, $replace, $message);
				$message = str_replace ('javascript:eval', '', $message);
			}

		}

		function hilight_text (&$text, $s, $useclass = 'alerttext', $usetag = 'span') {

			$highlight = '<' . $usetag . ' class="' . $useclass . '">\1</' . $usetag . '>';
			$text = str_highlight ($text, $s, 0, $highlight);

		}
		// function

		function filter_text (&$msg, $checkwords = false, $checkhtml = false, $strip = '') {

			global $opnConfig;
			if (!isset ($opnConfig['block_filter']) ) {
				$opnConfig['block_filter'] = 0;
			}
			$doit = true;
			if ( ($opnConfig['block_filter']) && ($opnConfig['permission']->IsWebmaster () ) ) {
				$doit = false;
			}
			if (isset ($opnConfig['opnOutput']) ) {
				$page = $opnConfig['opnOutput']->getMetaPageName ();
			} else {
				$page = 'opnindex';
			}
			if ( (!isset ($opnConfig['_opn_basehtmlfilter_' . $page]) ) OR ($opnConfig['_opn_basehtmlfilter_' . $page] == 0) ) {
				if ($doit) {
					if ($checkwords) {
						$this->check_words ($msg);
					}
					$this->CheckMessage ($msg);
					if ($checkhtml) {
						$this->check_html ($msg, $strip);
					}
				}
			} else {
				// echo 'no filter';
			}
			return $msg;

		}

		function filter_searchtext (&$msg) {

			$msg = stripslashes ($msg);
			$this->filter_text ($msg, true, true, 'nohtml');
			return $msg;

		}

		function filter_emailtext (&$msg) {

			$msg = stripslashes ($msg);
			$this->filter_text ($msg, true, true, 'nohtml');
			return $msg;

		}

		function filter_urltext (&$msg) {

			$msg = stripslashes ($msg);
			$this->filter_text ($msg, true, true, 'nohtml');
			return $msg;

		}

		function filter_cleantext (&$msg) {

			$msg = stripslashes ($msg);
			$this->filter_text ($msg, true, true, 'recodehtml');
			return $msg;

		}

		function filter_normtext (&$msg) {

			$msg = stripslashes ($msg);
			$this->filter_text ($msg, true, true, '');
			return $msg;

		}

		function recode_charset ($string, $cs_from, $cs_to) {

			$trans_tbl['ASCII'] = array ('<',
						'>',
						'&',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						chr (173),
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'',
						'');
			$trans_tbl['UNICODE'] = array ('&#x60;',
							'&#x62;',
							'&#x26;',
							'&#161;',
							'&#162;',
							'&#163;',
							'&#164;',
							'&#165;',
							'&#166;',
							'&#167;',
							'&#168;',
							'&#169;',
							'&#170;',
							'&#171;',
							'&#172;',
							'&#173;',
							'&#174;',
							'&#175;',
							'&#176;',
							'&#177;',
							'&#178;',
							'&#179;',
							'&#180;',
							'&#181;',
							'&#182;',
							'&#183;',
							'&#184;',
							'&#185;',
							'&#186;',
							'&#187;',
							'&#188;',
							'&#189;',
							'&#190;',
							'&#191;',
							'&#192;',
							'&#193;',
							'&#194;',
							'&#195;',
							'&#196;',
							'&#197;',
							'&#198;',
							'&#199;',
							'&#200;',
							'&#201;',
							'&#202;',
							'&#203;',
							'&#204;',
							'&#205;',
							'&#206;',
							'&#207;',
							'&#208;',
							'&#209;',
							'&#210;',
							'&#211;',
							'&#212;',
							'&#213;',
							'&#214;',
							'&#215;',
							'&#216;',
							'&#217;',
							'&#218;',
							'&#219;',
							'&#220;',
							'&#221;',
							'&#222;',
							'&#223;',
							'&#224;',
							'&#225;',
							'&#226;',
							'&#227;',
							'&#228;',
							'&#229;',
							'&#230;',
							'&#231;',
							'&#232;',
							'&#233;',
							'&#234;',
							'&#235;',
							'&#236;',
							'&#237;',
							'&#238;',
							'&#239;',
							'&#240;',
							'&#241;',
							'&#242;',
							'&#243;',
							'&#244;',
							'&#245;',
							'&#246;',
							'&#247;',
							'&#248;',
							'&#249;',
							'&#250;',
							'&#251;',
							'&#252;',
							'&#253;',
							'&#254;',
							'&#255;');
			$trans_tbl['HTML'] = array ('<',
						'>',
						'&amp;',
						'&iexcl;',
						'&cent;',
						'&pound;',
						'&curren;',
						'&yen;',
						'&brvbar;',
						'&sect;',
						'&uml;',
						'&copy;',
						'&ordf;',
						'&laquo;',
						'&not;',
						'&shy;',
						'&reg;',
						'&macr;',
						'&deg;',
						'&plusmn;',
						'&sup2;',
						'&sup3;',
						'&acute;',
						'&micro;',
						'&para;',
						'&middot;',
						'&cedil;',
						'&sup1;',
						'&ordm;',
						'&raquo;',
						'&frac14;',
						'&frac12;',
						'&frac34;',
						'&iquest;',
						'&Agrave;',
						'&Aacute;',
						'&Acirc;',
						'&Atilde;',
						'&Auml;',
						'&Aring;',
						'&AElig;',
						'&Ccedil;',
						'&Egrave;',
						'&Eacute;',
						'&Ecirc;',
						'&Euml;',
						'&Igrave;',
						'&Iacute;',
						'&Icirc;',
						'&Iuml;',
						'&ETH;',
						'&Ntilde;',
						'&Ograve;',
						'&Oacute;',
						'&Ocirc;',
						'&Otilde;',
						'&Ouml;',
						'&times;',
						'&Oslash;',
						'&Ugrave;',
						'&Uacute;',
						'&Ucirc;',
						'&Uuml;',
						'&Yacute;',
						'&THORN;',
						'&szlig;',
						'&agrave;',
						'&aacute;',
						'&acirc;',
						'&atilde;',
						'&auml;',
						'&aring;',
						'&aelig;',
						'&ccedil;',
						'&egrave;',
						'&eacute;',
						'&ecirc;',
						'&euml;',
						'&igrave;',
						'&iacute;',
						'&icirc;',
						'&iuml;',
						'&eth;',
						'&ntilde;',
						'&ograve;',
						'&oacute;',
						'&ocirc;',
						'&otilde;',
						'&ouml;',
						'&divide;',
						'&oslash;',
						'&ugrave;',
						'&uacute;',
						'&ucirc;',
						'&uuml;',
						'&yacute;',
						'&thorn;',
						'&yuml;');
			return str_replace ($trans_tbl[$cs_from], $trans_tbl[$cs_to], $string);

		}

		function decode_mime_string (&$string) {
			if (preg_match ("/=?([A-Z,0-9,-]+)?([A-Z,0-9,-]+)?([A-Z,0-9,-,=,_]+)?=/i", $string) ) {
				$string = str_replace ('=?', ' =?', $string);
				$string = str_replace ('  =?', ' =?', $string);
				$coded_strings = explode (' =?', $string);
				$counter = 1;
				$string = $coded_strings[0];

				/* add non encoded text that is before the encoding */

				while ($counter<sizeof ($coded_strings) ) {
					$elements = explode ('?', $coded_strings[$counter]);

					/* part 0 = charset */

					/* part 1 == encoding */

					/* part 2 == encoded part */

					/* part 3 == unencoded part beginning with a = */

					/* How can we use the charset information? */
					if (preg_match ('/q/i', $elements[1]) ) {
						$elements[2] = str_replace ('_', ' ', $elements[2]);
						$elements[2] = preg_replace ("/=([A-F,0-9]{2})/i", "%\\1", $elements[2]);
						$string .= urldecode ($elements[2]);
					} else {

						/* we should check for B the only valid encoding other then Q */

						$elements[2] = str_replace ('=', '', $elements[2]);
						if ($elements[2]) {
							$string .= base64_decode ($elements[2]);
						}
					}
					if (isset ($elements[3]) && $elements[3] != '') {
						$elements[3] = preg_replace ("/^=/", '', $elements[3]);
						$string .= $elements[3];
					}
					$counter++;
				}
			}

		}

		/**
		* Cut a string at or near maxlength (user $flexiblecut to keep words together)
		* and add ... at the end of string if truncated. It will count just on pure text
		* and will preserver cutting ina tag. Also, if there is still one or more tag opened
		* they will be automaticly closed.
		* returns true if $text has been truncated otherwise false
		*
		* @access private
		* @param string $text - variable to get and send the modified string
		* @param int $maxlength - desired length of the string (inluding the ...)
		* @param bool $flexiblecut - should words be kept togehter or should the "cut" be inside a word
		* @param bool $stripnontext - strips all tags and linebreaks
		* @return bool
		**/

		function opn_shortentext (&$text, $maxlength = 30, $flexiblecut = true, $stripnontext = false) {

			$maxlength = intval ($maxlength)+1;

			# +1 because of zero based counting

			$temptext = strip_tags ($text);
			$temptext = str_replace ("\r", ' ', $temptext);
			$temptext = str_replace (_OPN_HTML_NL, ' ', $temptext);
			$noTagLength = strlen ($temptext);
			if ($stripnontext) {
				$text = $temptext;
			}
			if ($noTagLength>$maxlength) {
				$maxlenght = $maxlength-3;

				# is -3 (for the ...)

				$origTextLength = strlen ($text);
				$return = '';
				$i = 0;
				$tagLevel = 0;
				$isText = true;
				$isSpecialchar = false;
				$specCharend = 0;
				$currentTag = '';
				$tagsArray = array ();
				$lastSpacePosition = -1;
				for ($pos = 0; $pos< $origTextLength; $pos++) {
					$currentChar = $text[$pos];
					$return .= $currentChar;
					if ($currentChar == '<') {
						$isText = false;
					}
					if ($currentChar == '&') {
						for ($temppos = $pos; $temppos< $origTextLength; $temppos++) {
							if ($text[$temppos] == ';') {
								$isSpecialchar = true;
								$specCharend = $temppos;
								break;
							}
							if ($text[$temppos] == ' ') {
								$isSpecialchar = false;
								break;
							}
						}
					}
					if ($isText) {
						if ($currentChar == ' ') {
							$lastSpacePosition = $pos;
							$isSpecialchar = false;
						} else {
							$lastChar = $currentChar;
						}
						$i++;
					} else {
						$currentTag .= $currentChar;
					}
					if ($currentChar == '>') {
						$isText = true;
						if ( (substr ($currentTag, 0, 1) == '<') && (substr ($currentTag, -1, -2) != '/>') && (substr ($currentTag, 0, 2) != '</') ) {
							$parampos = strpos ($currentTag, ' ');
							if ($parampos !== false) {
								$currentTag = substr ($currentTag, 1, $parampos-1);
							} else {
								$currentTag = substr ($currentTag, 1, -1);
							}
							if ( ($currentTag != 'br') && ($currentTag != 'img') && ($currentTag != 'input') && ($currentTag != 'hr') ) {
								$tagsArray[$tagLevel] = $currentTag;
								$tagLevel++;
							}
						} elseif (preg_match ('/<\//i', $currentTag) ) {
							$tagsArray[$tagLevel-1] = null;
							$tagLevel--;
						}
						$currentTag = '';
					}
					if ($i == $maxlength) {
						break;
					}
				}
				if ($maxlength<$noTagLength) {
					if ( ($lastSpacePosition != -1) && ($flexiblecut) ) {
						$r = substr ($text, 0, $lastSpacePosition);
					} else {
						$add = 0;
						if ($isSpecialchar === true) {
							$add = $specCharend- $pos+1;
						}
						$r = substr ($text, 0, $pos+ $add);
					}
				}
				for ($a = (count ($tagsArray)-1); $a >= 0; $a--) {
					if ($tagsArray[$a] != null) {
						$r .= '</' . $tagsArray[$a] . '>';
					}
				}
				if ($maxlength<$noTagLength) {
					if ( (!isset ($lastChar) ) OR ($lastChar != '.') ) {
						$r .= '...';
					} else {
						$r .= '..';
					}
				}
				$text = $r;
				return true;
			}
			return false;

		}

		/*
		* if magic_quotes_gpc is on, stirip back slashes
		*
		* @param	string  $text
		*
		* @return string
		*/

		function &stripSlashesGPC ($text) {
			if (get_magic_quotes_gpc () ) {
				$text = &stripslashes ($text);
			}
			return $text;

		}

		/*
		*  for displaying data in html textbox forms
		*
		* @param	string  $text
		*
		* @return string
		*/

		function &htmlSpecialChars ($text) {
			return preg_replace (array ("/&amp;/i",
						"/&nbsp;/i"),
						array ('&',
				'&amp;nbsp;'),
				htmlspecialchars ($text,
				ENT_QUOTES) );

		}

		/**
		* Reverses {@link htmlSpecialChars()}
		*
		* @param   string  $text
		* @return  string
		**/

		function &undoHtmlSpecialChars (&$text) {
			return preg_replace (array ("/&gt;/i",
						"/&lt;/i",
						"/&quot;/i",
						"/&#039;/i"),
						array (">",
				"<",
				"\"",
				"'"),
				$text);

		}

		function TextToReadyText (&$message, $options = false) {

			global $opnConfig;
			if ($options === false) {
				$options = array ();
				$options[_OOBJ_DTYPE_HTML] = true;
				$options[_OOBJ_DTYPE_BBCODE] = true;
				$options[_OOBJ_DTYPE_CBR] = true;
				$options[_OOBJ_DTYPE_SMILE] = true;
				$options[_OOBJ_DTYPE_UIMAGES] = true;
				$options[_OOBJ_DTYPE_SIG] = true;
			}
			$message = $this->FixQuotes ($message);
			if ($options[_OOBJ_DTYPE_HTML]) {
				$message = htmlspecialchars ($message);
			}
			if ($options[_OOBJ_DTYPE_BBCODE]) {
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
				$ubb =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ UBBCode;
				$ubb->ubbencode ($message);
			}
			if ($options[_OOBJ_DTYPE_CBR]) {
				opn_nl2br ($message);
			}
			if ($options[_OOBJ_DTYPE_SMILE]) {
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
					include_once (_OPN_ROOT_PATH . 'system/smilies/smilies.php');
					$message = smilies_smile ($message);
				}
			}
			if ($options[_OOBJ_DTYPE_UIMAGES]) {
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
					include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
					$message = make_user_images ($message);
				}
			}
			if ($options[_OOBJ_DTYPE_SIG]) {
			}

		}

		function ReadyTextToText (&$message, $options = false) {

			global $opnConfig;
			if ($options === false) {
				$options = array ();
				$options[_OOBJ_DTYPE_HTML] = true;
				$options[_OOBJ_DTYPE_BBCODE] = true;
				$options[_OOBJ_DTYPE_CBR] = true;
				$options[_OOBJ_DTYPE_SMILE] = true;
				$options[_OOBJ_DTYPE_UIMAGES] = true;
				$options[_OOBJ_DTYPE_SIG] = true;
			}
			if ($options[_OOBJ_DTYPE_CBR]) {
				$message = str_replace ('<br>', _OPN_HTML_NL, $message);
				$message = str_replace ('<br />', _OPN_HTML_NL, $message);
			}
			if ($options[_OOBJ_DTYPE_UIMAGES]) {
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
					include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
					$oldmessage = $message;
					$message = de_make_user_images ($message);
					if ($oldmessage == $message) {
						$disableuserimages = TRUE;
					} else {
						$disableuserimages = FALSE;
					}
				}
			}
			if ($options[_OOBJ_DTYPE_SMILE]) {
				$oldmessage = $message;
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
					include_once (_OPN_ROOT_PATH . 'system/smilies/smilies.php');
					$message = smilies_desmile ($message);
				}
				if ($oldmessage == $message) {
					$disablesmilies = TRUE;
				} else {
					$disablesmilies = FALSE;
				}
			}
			if ($options[_OOBJ_DTYPE_BBCODE]) {
				include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
				$ubb =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ UBBCode;
				$ubb->ubbdecode ($message);
			}
			if ($options[_OOBJ_DTYPE_SIG]) {
				if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_sig') ) {
					$message = preg_replace ('/\[addsig]/i', '', $message);
					$message = preg_replace ('/\[\'addsig\']/i', '', $message);
				}
			}

		}
		// function ReadyTextFeld (&$options) {
		//
		// global $opnConfig;
		//
		// if ($options === false) {
		// $options = array();
		// $options[_OOBJ_DTYPE_HTML] = true;
		// $options[_OOBJ_DTYPE_BBCODE] = true;
		// $options[_OOBJ_DTYPE_CBR] = true;
		// $options[_OOBJ_DTYPE_SMILE] = true;
		// $options[_OOBJ_DTYPE_UIMAGES] = true;
		// $options[_OOBJ_DTYPE_SIG] = true;
		//
		// $options[_OOBJ_FTYPE_CAPTION] = 'test';
		// $options[_OOBJ_FTYPE_NAME] = 'test';
		// $options[_OOBJ_FTYPE_PREFIX] = 'imp_';
		//
		// $options[_OOBJ_FTYPE_TEXTAREA] = true;
		// }
		//
		// $message='';
		// get_var (_OOBJ_FTYPE_PREFIX._OOBJ_FTYPE_NAME,$message,'form',_OOBJ_DTYPE_CHECK);
		//
		// $image_subject='blank.gif';
		// get_var ('image_subject',$image_subject,'form',_OOBJ_DTYPE_CLEAN);
		// $html=0;
		// get_var (_OOBJ_FTYPE_PREFIX.'html',$html,'form',_OOBJ_DTYPE_INT);
		// $bbcode=0;
		// get_var (_OOBJ_FTYPE_PREFIX.'bbcode',$bbcode,'form',_OOBJ_DTYPE_INT);
		// $smile=0;
		// get_var (_OOBJ_FTYPE_PREFIX.'smile',$smile,'form',_OOBJ_DTYPE_INT);
		// $user_images=0;
		// get_var (_OOBJ_FTYPE_PREFIX.'user_images',$user_images,'form',_OOBJ_DTYPE_INT);
		// $sig='';
		// get_var (_OOBJ_FTYPE_PREFIX.'sig',$sig,'form',_OOBJ_DTYPE_CLEAN);

		/*
		$userdata = $this->property('userdata');
		$forum = $this->property('forum');

		if ( ($sig == '') && (isset($userdata['attachsig'])) ) {
		$sig = $userdata['attachsig'];
		}
		*/
		// $message = $this->FixQuotes($message);
		//
		// $boxtxt = '';
		// TODO : Stefan woher soll das kommen?.
		// if ($preview != 0) {
		// // Build_Preview($boxtxt,$forumconfig,$userdata,$message,$subject,$image_subject,$html,$bbcode,$sig,$smile,$user_images,$polldata);
		// }
		//
		// $form->AddChangeRow();
		// $form->SetSameCol();
		// $form->AddLabel('message',_FORUM_MSG);
		//
		// $form->AddText('<br /><br />'._FORUM_HTML);
		// TODO : Stefan woher soll das kommen?.
		// if ($forumconfig['allow_html'] == 1) {
		// $form->AddText(_FORUM_ON.'<br />');
		// } else {
		// $form->AddText(_FORUM_OFF.'<br />');
		// }
		// $form->AddText('<a class="listalternator" href="'.encodeurl(array($opnConfig['opn_url'].'/include/bbcode_ref.php','module'=>'system/forum')).'" target="_blank">'._FORUM_BBCODE.'</a> : ');
		// TODO : Stefan woher soll das kommen?.
		// if ($forumconfig['allow_bbcode'] == 1) {
		// $form->AddText(_FORUM_ON.'<br />');
		// } else {
		// $form->AddText(_FORUM_OFF.'<br />');
		// }
		//
		// $form->AddText('<br />');
		//
		// $form->AddText('&nbsp;');
		// $form->SetEndCol();
		// $form->SetSameCol();
		//
		//
		// $form->AddTextarea('message',0,0,'',$message,'storeCaret(this)','storeCaret(this)','storeCaret(this)');
		//
		// $form->AddNewline(2);
		// TODO : Stefan woher soll das kommen?.
		// $form->AddText(putitems($forum));
		//
		// $form->AddText('&nbsp;');
		// $form->SetEndCol();
		//
		//
		// $form->AddCheckbox('html',1, $html);
		// $form->AddLabel('html',_FORUM_DISABLEHTML,1);
		// $form->AddNewline(2);
		//
		// $form->AddCheckbox('bbcode',1, $bbcode);
		// $form->AddLabel('bbcode',_FORUM_DISABLE.' <a class="%alternate%" href="'.encodeurl(array($opnConfig['opn_url'].'/include/bbcode_ref.php','module'=>'system/forum')).'" target="_blank">'._FORUM_BBCODE.'</a> '._FORUM_ONPOST,1);
		// $form->AddNewline(2);
		//
		// if ($opnConfig['installedPlugins']->isplugininstalled('system/smilies')) {
		// $form->AddCheckbox('smile',1, $smile);
		// $form->AddLabel('smile',_FORUM_DISABLE.' <a class="%alternate%" href="'.$opnConfig['opn_url'].'/system/smilies/index.php" target="_blank">'._FORUM_SMILIES.'</a> '._FORUM_ONPOST,1);
		// $form->AddNewline(2);
		// }
		// if ($opnConfig['installedPlugins']->isplugininstalled('system/user_images')) {
		// $form->AddCheckbox('user_images',1,$user_images);
		// $form->AddLabel('user_images',_FORUM_DISABLE.' <a class="%alternate%" href="'.$opnConfig['opn_url'].'/system/user_images/index.php" target="_blank">'._FORUM_USERIMAGES.'</a> '._FORUM_ONPOST,1);
		// $form->AddNewline(2);
		// }
		// if ($opnConfig['installedPlugins']->isplugininstalled('system/user_sig')) {
		// if (($forumconfig['allow_sig'] == 1) && (isset($userdata['attachsig']))) {
		// $form->AddCheckbox('sig',1, $sig);
		// $form->AddLabel('sig',_FORUM_SHOWSIG.' ('._FORUM_ADDPROFILE.')',1);
		// $form->AddNewline(2);
		// }
		// }
		//
		// $form->AddText('&nbsp;');
		// $form->SetEndCol();
		// $form->AddChangeRow();
		// $form->SetSameCol();
		// $form->SetEndCol();
		// $form->SetSameCol();
		// $help = '';
		// $form->SetEndCol();
		// }

		/* **************************************************************
		* htmlwrap() function - v1.1
		* Copyright (c) 2004 Brian Huisman AKA GreyWyvern
		*
		* This program may be distributed under the terms of the GPL
		*   - http://www.gnu.org/licenses/gpl.txt
		*
		*
		* htmlwrap -- Safely wraps a string containing HTML formatted text (not
		* a full HTML document) to a specified width
		*
		*
		* Changelog
		* 1.1  - Now optionally works with multi-byte characters
		*
		*
		* Description
		*
		* string htmlwrap ( string str [, int width [, string break [, string
		* nobreak [, string nobr [, bool utf]]]]])
		*
		* htmlwrap() is a function which wraps HTML by breaking long words and
		* preventing them from damaging your layout.  This function will NOT
		* insert <br /> tags every "width" characters as in the PHP wordwrap()
		* function.  HTML wraps automatically, so this function only ensures
		* wrapping at "width" characters is possible.  Use in places where a
		* page will accept user input in order to create HTML output like in
		* forums or blog comments.
		*
		* htmlwrap() won't break text within HTML tags and also preserves any
		* existing HTML entities within the string, like &nbsp; and &lt;  It
		* will only count these entities as one character.  Output is auto-
		* matically nl2br()'ed.
		*
		* The function also allows you to specify "protected" elements, where
		* line-breaks, block-returns or both are not inserted.  This is useful
		* for elements like <pre> where you don't want the code to be damaged
		* by the insertion of HTML block-returns.  Add the names of the
		* elements you wish to protect from line-breaks (nobreak) and/or block-
		* returns (nobr) as space separated lists.  Only names of valid HTML
		* tags are accepted.  (eg. "code pre blockquote")
		*
		* The optional "utf" parameter enables the function to treat multi-
		* byte characters in UTF-8 as single characters.  The default is false.
		* "This modifier is available from PHP 4.1.0 or greater on Unix and
		* from PHP 4.2.3 on win32."
		*  - http://www.php.net/manual/en/reference.pcre.pattern.modifiers.php
		*
		* htmlwrap() will *always* break long strings of characters at the
		* specified width.  In this way, the function behaves as if the
		* wordwrap() "cut" flag is always set.  However, the function will try
		* to find "safe" characters within strings it breaks, where inserting a
		* line-break would make more sense.  You may edit these characters by
		* adding or removing them from the $lbrks variable.
		*
		* htmlwrap() is safe to use on strings containing multi-byte
		* characters as of version 1.1.
		*
		* See the inline comments and http://www.greywyvern.com/php.php
		* for more info
		******************************************************************** */

		function htmlwrap ($str, $width = 60, $break = "\n", $nobreak = "", $nobr = "pre", $utf = false) {
			// Split HTML content into an array delimited by < and >
			// The flags save the delimeters and remove empty variables
			$content = preg_split ("/([<>])/", $str, -1, PREG_SPLIT_DELIM_CAPTURE|PREG_SPLIT_NO_EMPTY);
			// Transform protected element lists into arrays
			$nobreak = explode (" ", $nobreak);
			$nobr = explode (" ", $nobr);
			// Variable setup
			$intag = false;
			$innbk = array ();
			$innbr = array ();
			$drain = "";
			$utf = ($utf)?"u" : "";
			// List of characters it is "safe" to insert line-breaks at
			// Do not add ampersand (&) as it will mess up HTML Entities
			// It is not necessary to add < and >
			$lbrks = "/?!%)-}]\\\"':;";
			// We use \r for adding <br /> in the right spots so just switch to \n
			if ($break == "\r") {
				$break = "\n";
			}
			while (list (, $value) = each ($content) ) {
				switch ($value) {
					// If a < is encountered, set the "in-tag" flag
					case "<":
						$intag = true;
						break;
					// If a > is encountered, remove the flag
					case ">":
						$intag = false;
						break;
					default:
						// If we are currently within a tag...
						if ($intag) {
							// If the first character is not a / then this is an opening tag
							if ($value{0} != "/") {
								// Collect the tag name
								preg_match ("/^(.*?)(\s|$)/$utf", $value, $t);
								// If this is a protected element, activate the associated protection flag
								if ( (!count ($innbk) && in_array ($t[1], $nobreak) ) || in_array ($t[1], $innbk) ) {
									$innbk[] = $t[1];
								}
								if ( (!count ($innbr) && in_array ($t[1], $nobr) ) || in_array ($t[1], $innbr) ) {
									$innbr[] = $t[1];
								}
								// Otherwise this is a closing tag
							} else {
								// If this is a closing tag for a protected element, unset the flag
								if (in_array (substr ($value, 1), $innbk) ) {
									unset ($innbk[count ($innbk)]);
								}
								if (in_array (substr ($value, 1), $innbr) ) {
									unset ($innbr[count ($innbr)]);
								}
							}
							// Else if we're outside any tags...
						} elseif ($value) {
							// If unprotected, remove all existing \r, replace all existing \n with \r
							if (!count ($innbr) ) {
								$value = str_replace ("\n", "\r", str_replace ("\r", "", $value) );
							}
							// If unprotected, enter the line-break loop
							if (!count ($innbk) ) {
								do {
									$store = $value;
									// Find the first stretch of characters over the $width limit
									if (preg_match ("/^(.*?\s|^)(([^\s&]|&(\w{2,5}|#\d{2,4});) {" . $width . "})(?!(" . preg_quote ($break, "/") . "|\s))(.*)$/s$utf", $value, $match) ) {
										// Determine the last "safe line-break" character within this match
										$ledge = 0;
										$max = strlen ($lbrks);
										for ($x = 0; $x< $max; $x++) {
											$ledge = max ($ledge, strrpos ($match[2], $lbrks{$x}) );
										}
										if (!$ledge) {
											$ledge = strlen ($match[2])-1;
										}
										// Insert the modified string
										$value = $match[1] . substr ($match[2], 0, $ledge+1) . $break . substr ($match[2], $ledge+1) . $match[6];
									}
									// Loop while overlimit strings are still being found
								}
								while ($store != $value);
							}
							// If unprotected, replace all \r with <br />\n to finish
							if (!count ($innbr) ) {
								$value = str_replace ("\r", "<br />\n", $value);
							}
						}
					}
					// Send the modified segment down the drain
					$drain .= $value;
				}
				// Return contents of the drain
				return $drain;

		}

	}
}

?>