<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* Initialize of the $opnTables variable -
* fills with the known opn tables
*
* @access private
* @return void
**/

function dbconf_get_tables (&$opnTables, &$opnConfig) {

	$dbcat = & new catalog ($opnConfig, 'dbcat');
	if (is_array ($dbcat->catlist) ) {
		foreach ($dbcat->catlist as $value) {
			$opnTables[$value] = $opnConfig['tableprefix'] . $value;
		}
	}
	$dbcat->destroy ();
	unset ($dbcat);

}

/**
* Initialize of the $opnConfig['datasave'] variable -
* fills with the known opn datasaves
*
* @access private
* @return void
**/

function dbconf_get_DataSave () {

	global $opnDataSave, $opnConfig;

	$dbcat = & new catalog ($opnConfig, 'opn_datasavecat');
	$opnDataSave = array ();
	if (is_array ($dbcat->catlist) ) {
		foreach ($dbcat->catlist as $key => $value) {
			$opnDataSave[$key] = $value;
			if (substr_count ($value, $opnConfig['root_path_datasave'])>0) {
				$value = str_replace ($opnConfig['root_path_datasave'], '', $value);
				$value = str_replace ('/', '', $value);
				$opnConfig['datasave'][$key]['url'] = $opnConfig['url_datasave'] . '/' . $value;
				$opnConfig['datasave'][$key]['path'] = $opnConfig['root_path_datasave'] . $value . '/';
			} else {
				$value = str_replace (_OPN_ROOT_PATH, '', $value);
				$opnConfig['datasave'][$key]['url'] = $opnConfig['opn_url'] . '/' . $value;
				$opnConfig['datasave'][$key]['path'] = _OPN_ROOT_PATH . $value;
			}
		}
	}
	$dbcat->destroy ();
	unset ($dbcat);

}

function test_eintrag () {
	// echo 'Hier ist eine eigene Function';

}

/**
* Initialize of the $opnConfig variable -
* fills with the basic settings stored in database
*
* @access private
* @return void
**/

function retrieveconfig () {

	global $opnConfig, $opnTables, $ininstall;

	if (isset($opnTables['configs'])) {
		$modules = "'admin/openphpnuke'";
		$plug=array();
		$opnConfig['installedPlugins']->getplugin($plug, 'config');
		if (is_array($plug)) {
			foreach($plug as $var) {
				if ($var['plugin']!='admin/openphpnuke') {
					$modules .= ", '".$var['plugin']."'";
				}
			}
		}
		unset($plug);
		$result = &$opnConfig['database']->Execute('SELECT settings, modulename FROM '.$opnTables['configs'].' WHERE modulename IN ('.$modules.')');
		while(!$result->EOF) {
			$settings = stripslashesinarray(unserialize($result->fields['settings']));
			if(is_array($settings)) {
				$opnConfig = array_merge($opnConfig,$settings);
			} else {
				opnErrorHandler (E_WARNING,'Module: '.$result->fields['modulename'].' returns string:'.$result->fields['settings']);
			}
			$result->MoveNext();
		}
		$result->Close();
		unset($result);
		unset($settings);
	}

	if (!isset($opnConfig['opn_url_cgi'])) { $opnConfig['opn_url_cgi'] = $opnConfig['opn_url']; }
	if (!isset($opnConfig['opn_time_prefix'])) { $opnConfig['opn_time_prefix'] = ''; }
	if ((!isset($opnConfig['opn_charset_encoding'])) || ($opnConfig['opn_charset_encoding'] == '')) {
		$opnConfig['opn_charset_encoding'] = 'iso-8859-1';
	}
	if (!isset($ininstall)) {
		$result = &$opnConfig['database']->Execute('SELECT number FROM '.$opnConfig['tableprefix']."opn_privat_donotchangeoruse WHERE opnupdate='storeuid'");
		if($result!==false) {
			$opnConfig['encoder'] = $result->fields['number'];
			$result->Close();
		}
		unset($result);
		if ($opnConfig['exception_register'] !== false) {
			$sql = 'SELECT id, exception_name, exception_point, function_name, function_file FROM ' . $opnTables['opn_exception_register']. ' WHERE ( (function_name<>\'\') AND (exception_name<>\'\') )';
			$result = &$opnConfig['database']->Execute ($sql);
			if($result!==false) {
				while (! $result->EOF) {
					if ($result->fields['function_file'] != '') {
						include_once(_OPN_ROOT_PATH.$result->fields['function_file']);
					}
					$opnConfig['exception_register'][$result->fields['exception_point']] = $result->fields['function_name'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$opnConfig['exception_register']['phpinfo'] = 'test_eintrag';
			$opnConfig['exception_register']['phpinfo']();
		}
	}

}

/**
 * Initialize of the $opnConfig['theme_nav'] variable -
 * fills with the known opn theme navigation elements
 * and includes the /plugin/theme/index.php from each
 * module that provides one
 *
 * @access private
 * @return void
 **/
function retrieve_theme_nav_config() {
	global $opnConfig, $ininstall;

	if (isset ($opnConfig['opnOption']['themegroup'])) {
		$themegroup = $opnConfig['opnOption']['themegroup'];
	} else {
		$themegroup = 0;
	}

	if (!isset($ininstall)) {
		$opnConfig['opnSQL']->opn_dbcoreloader ('plugin.themenav', 0);

		$hlp = array();
		$plug=array();
		$opnConfig['installedPlugins']->getplugin($plug, 'themenav');
		foreach ($plug as $var) {
			if ( (!isset($opnConfig[$var['plugin'].'_THEMENAV_PR'])) OR ($opnConfig['permission']->CheckUserGroup($opnConfig[$var['plugin'].'_THEMENAV_PR'])) ) {

			if ( (!isset($opnConfig[$var['plugin'].'_THEMENAV_THEME'])) OR ($themegroup == 0) OR ($opnConfig[$var['plugin'].'_THEMENAV_THEME'] == $themegroup) ) {

				if (!defined('_OPN_DBCORELOADER_CODE_plugin.themenav')) {
					include_once(_OPN_ROOT_PATH.$var['plugin'].'/plugin/theme/index.php');
				}
				$myfunc = $var['module'].'_get_nav';
				if (function_exists($myfunc)) {
					$hlp='';
					$myfunc($hlp);
					if (is_array ($hlp)) {
						$max=count($hlp);
						for ($i=0; $i<$max; $i++) {
							if (!isset($hlp[$i]['img'])) { $hlp[$i]['img'] =''; }
							if (!isset($hlp[$i]['target'])) { $hlp[$i]['target'] =0; }
							if (!isset($hlp[$i]['css'])) { $hlp[$i]['css'] =''; }
							if (!isset($hlp[$i]['title'])) { $hlp[$i]['title'] =''; }
							$opnConfig['theme_nav'][$var['plugin']][$i]['img'] = $hlp[$i]['img'];
							$opnConfig['theme_nav'][$var['plugin']][$i]['url'] = $hlp[$i]['url'];
							$opnConfig['theme_nav'][$var['plugin']][$i]['urltext'] = $hlp[$i]['urltext'];
							$opnConfig['theme_nav'][$var['plugin']][$i]['show'] = $hlp[$i]['show'];
							$opnConfig['theme_nav'][$var['plugin']][$i]['target'] = $hlp[$i]['target'];
							$opnConfig['theme_nav'][$var['plugin']][$i]['css'] = $hlp[$i]['css'];
							$opnConfig['theme_nav'][$var['plugin']][$i]['title'] = $hlp[$i]['title'];
						}
					}
					unset ($hlp);
				}
			}

			}
		}
	}
}


if (!function_exists('_get_var')) {
	/**
	 * get global vars with additional check of its contents
	 * possible type values are:
	 * - url - variable has been submitted via URL
	 * - form - variable has been submitted via web form
	 * - both - variable has been submitted in either one of the above
	 * - server - variable is stored within the server enviroment
	 * - cookie - variable is stored in a cookie
	 * - session - variable is stored within the PHP session
	 * - env - variable is stored within the enviroment
	 * - file - variable has been submitted via web form and is type of uploaded file
	 *
	 * possible check values are
	 * - EMAIL - returned string looks like a valid email adress
	 * - URL - returned string looks like a valid URL
	 * - CLEAN - returned string is pure text
	 * - CHECK - returned string is text with only the allowed tags
	 * - INT - return type is an Integer
	 *
	 * @access public
	 * @param string $key - name of the variable you want to receive
	 * @param mixed $value - return received content into this variable
	 * @param string $type - the type, where the variable could be found
	 * @param string $check - check the variable content
	 * @param bool $prefix -
	 * @return void
	 **/
	function _get_var($key, &$value, $type, $check='', $prefix=false) {
		global $opnConfig, ${$opnConfig['opn_post_vars']},${$opnConfig['opn_get_vars']}, ${$opnConfig['opn_server_vars']}, ${$opnConfig['opn_file_vars']},
			${$opnConfig['opn_cookie_vars']},${$opnConfig['opn_session_vars']},${$opnConfig['opn_request_vars']},${$opnConfig['opn_env_vars']};

		$vars = array();
		switch($type){
			case 'url':
				$vars = ${$opnConfig['opn_get_vars']};
				break;
			case 'form':
				$vars = ${$opnConfig['opn_post_vars']};
				break;
			case 'both':
				$vars = ${$opnConfig['opn_request_vars']};
				if (!isset($vars[$key])) {
					$vars = ${$opnConfig['opn_get_vars']};
					if (!isset($vars[$key])) {
						$vars = ${$opnConfig['opn_post_vars']};
					} //if
				} //if
				break;
			case 'server':
				$vars = ${$opnConfig['opn_server_vars']};
				break;
			case 'cookie':
				$vars = ${$opnConfig['opn_cookie_vars']};
				break;
			case 'session':
				$vars = ${$opnConfig['opn_session_vars']};
				break;
			case 'env':
				$temp = $value;
				$value = getenv($key);
				if($value === false) { $value = $temp; }
				break;
			case 'file':
				$vars = ${$opnConfig['opn_file_vars']};
				break;
		} // switch
		$val = $value;
		if ($prefix === true) {
			$val = array();
			foreach ($vars as $keyword=>$vl) {
				if (substr_count($keyword, $key)) {
					$val[$keyword] = $vl;
				}
			}
		} else {
			if (isset($vars[$key])) {
				$val = $vars[$key];
			}
		}
		switch($check) {
			case _OOBJ_DTYPE_EMAIL:
				if (!is_array($val)) {
					$value = $opnConfig['cleantext']->filter_emailtext($val);
				} else {
					$max=count($val);
					for ($i=0; $i<$max; $i++) {
						$val[$i] = $opnConfig['cleantext']->filter_emailtext($val[$i]);
					}
					$value = $val;
				}
				break;
			case _OOBJ_DTYPE_URL:
				if (!is_array($val)) {
					$value = $opnConfig['cleantext']->filter_urltext($val);
				} else {
					$max=count($val);
					for ($i=0; $i<$max; $i++) {
						$val[$i] = $opnConfig['cleantext']->filter_urltext($val[$i]);
					}
					$value = $val;
				}
				break;
			case _OOBJ_DTYPE_CLEAN:
				if (!is_array($val)) {
					$value = $opnConfig['cleantext']->filter_cleantext($val);
				} else {
					$max=count($val);
					for ($i=0; $i<$max; $i++) {
						$val[$i] = $opnConfig['cleantext']->filter_cleantext($val[$i]);
					}
					$value = $val;
				}
				break;
			case _OOBJ_DTYPE_CHECK:
				if (!is_array($val)) {
					$value = $opnConfig['cleantext']->filter_normtext($val);
				} else {
					$max=count($val);
					for ($i=0; $i<$max; $i++) {
						$val[$i] = $opnConfig['cleantext']->filter_normtext($val[$i]);
					}
					$value = $val;
				}
				break;
			case _OOBJ_DTYPE_INT:
				if (!is_array($val)) {
					$value = intval($val);
				} else {
					$max=count($val);
					for ($i=0; $i<$max; $i++) {
						$val[$i] = intval($val[$i]);
					}
					$value = $val;
				}
				break;
			default:
				$value = $val;
				break;
		}
		unset($vars);
	}
}

if (!function_exists('get_var')) {

	function get_var($key, &$value, $type, $check='', $prefix=false, $key_prefix='') {

		if (!is_array($key)) {
			_get_var($key, $value, $type, $check, $prefix);
		} else {
			foreach ($key as $ourvar) {
				$dummy='';
				_get_var($key_prefix.$ourvar, $dummy, $type, $check, $prefix);
				$value[$ourvar] = $dummy;
			}
		}
	}
}

function opn_get_var ($key) {

	$rt = '';
	get_var ($key, $rt, 'url', _OOBJ_DTYPE_CHECK);
	return $rt;

}

function check_upload($userupload) {
	if (is_array($userupload)) {
		if (isset($userupload['error'])) {
			if ($userupload['error'] !=0) {
				$userupload = 'none';
			}
		} elseif ($userupload['name'] == '') {
			$userupload = 'none';
		}
	}
	return $userupload;
}

function _opn_qstr (&$value, $key, $blobfield) {
	global $opnConfig;

	if (is_array($blobfield)) {
		if (in_array($key,$blobfield)) {
			$value = $opnConfig['opnSQL']->qstr($value,$blobfield[$key]);
		} else {
			$value = $opnConfig['opnSQL']->qstr($value);
		}
	} else {
		$value = $opnConfig['opnSQL']->qstr($value);
	}
}

/**
 * Initialize of the $opnConfig['database'] variable
 * as an SQLLayer object and connects to the configured database
 *
 * @access private
 * @param array $opnConfig - variable to store the connection
 * @param bool $makesqldebug - should SQLLayer run in debug mode
 * @param bool $forceNewConnect - Forced a new connection
 * @return void
 **/
function dbconnect(&$opnConfig, $makesqldebug, $forceNewConnect = false) {

	$opnConfig['database'] = &loadSQLLayer($opnConfig['dbdriver']);
	$sqlname=_OPN_ROOT_PATH.'cache/pconnect';
	$error=false;
	switch ($opnConfig['dbdriver']) {
		case 'ibase':
		case 'firebird':
		case 'borland_ibase':
			$opnConfig['database']->SetCharset($opnConfig['dbcharset']);
			$opnConfig['database']->SetDialect($opnConfig['dbdialect']);
			break;
	} //switch
	$opnConfig['database']->SetForceNewConnect($forceNewConnect);
	if (file_exists($sqlname)) {
		if(!($opnConfig['database']->PConnect($opnConfig['dbhost'],$opnConfig['dbuname'],$opnConfig['dbpass'],$opnConfig['dbname']))) {
			$error = true;
		}
	} else {
		if(!($opnConfig['database']->Connect($opnConfig['dbhost'],$opnConfig['dbuname'],$opnConfig['dbpass'],$opnConfig['dbname']))) {
			$error = true;
		}
	}
	if ($error) {
		if (file_exists(_OPN_ROOT_PATH.'include/fallback.php')) {
			include_once(_OPN_ROOT_PATH.'include/fallback.php');
			fallback('db');
			die();
		} else {
			opn_reload_Header ('html/error_db.html');
		}
	} else {
		$sql = & new OPN_SQL;
		$opnConfig['opnSQL']= $sql->loadDriver($opnConfig['dbdriver']);
		unset($sql);
	}
	if (!defined('OPN_USE_SQLLAYER')) {
		$opnConfig['database']->SetDebug($makesqldebug);
	}
	unset ($opnConfig['dbuname']);
	unset ($opnConfig['dbpass']);
	unset ($opnConfig['dbhost']);
}

/**
 * unset of the $opnConfig['database'] variable
  *
 * @access private
 * @param array $opnConfig - variable to store the connection
  * @return void
 **/
function CloseTheOpnDB (&$opnConfig) {
	if ( (isset($opnConfig['database'])) && ((defined('_OPN_ALLISDONE')) OR (!defined('_OPN_HEADER_REDIRECT')))) {
		$plug=array();
		$opnConfig['installedPlugins']->getplugin($plug, 'session');
		$plug[] = array('module' => '_opn_core_management');
		if (is_array($plug)) {
			foreach ($plug as $var) {
				if (isset($opnConfig[$var['module'].'_sessionnames'])) {
					$varstosave = $opnConfig[$var['module'].'_sessionnames'];
					$varstosave = explode(',', $varstosave);
					foreach ($varstosave as $var) {
						global ${$var};
						if(isset($var)) {
							set_var($var, ${$var}, 'session');
						} else {
							set_var($var, '', 'session');
						}
					}
				}
			}
		}

		$opnConfig['database']->Close();
		unset ($opnConfig['database']);
	}
}

/**
 * sorts box position information - used by usort
 *
 * @access private
 * @param array $a
 * @param array $b
 * @return string
 **/
function sortboxposarray($a,$b) {
	$a1 = $a['boxpos'];
	$b1 = $b['boxpos'];
	return strcollcase($a1,$b1);
}

/**
 * execute the modules autostart function
 *
 * @access private
 * @param array $mywayboxpos
 * @return void
 **/
function exec_autostart($mywayboxpos) {
	global $opnConfig;

	foreach($mywayboxpos as $boxpos) {
		$temp = $boxpos['boxpos'];
		$temp1 = $boxpos['function'];
		if (function_exists($temp1)) {
			$opnConfig['theme_aktuell_centerbox_pos'] = $temp;
			$temp1();
		}
	}
}

/**
 * execute the modules autostart function
 * possible modus values are
 * - only_first_header
 * - every_header
 * - first_block
 * - middle_block
 * - last_block
 * - every_footer
 *
 * @access private
 * @param string $modus
 * @return void
 **/
function autostart_module_interface ($modus) {
	global $opnConfig;

	$mywayboxpos=array();
	$mywaynum = -1;
	$plug=array();
	$opnConfig['installedPlugins']->getplugin($plug,'autostart');
	if(is_array($plug)) {
		foreach ($plug as $var) {
			if ( (!isset($opnConfig['_opn_autostart_'.$var['plugin']])) ||
				($opnConfig['_opn_autostart_'.$var['plugin']] == 1) ) {
				$theautostartfile = $var['plugin'].'/plugin/autostart/index.php';
				if(!defined($theautostartfile)) {
					define($theautostartfile,1);
					include(_OPN_ROOT_PATH.$theautostartfile);
				}
				$myfunc = $var['module'].'_'.$modus;
				if (function_exists($myfunc)) {
					$mywaynum++;
					$mywayboxpos[$mywaynum]['function'] = $myfunc;
					$myfuncII = $var['module'].'_'.$modus.'_box_pos';
					$mywayboxpos[$mywaynum]['boxpos'] = $myfuncII();
				}
				unset($myfunc);
				unset($myfuncII);
			}
		}
	}
	if ($mywaynum >=0) {
		usort($mywayboxpos,'sortboxposarray');
		exec_autostart($mywayboxpos);
	}
	unset($plug);
	unset($mywayboxpos);
	unset($mywaynum);
}

/**
 * Initialize of the $opnConfig['theme_groups'] variable -
 * fills with the stored themegroups from database
 *
 * @access private
 * @return void
 **/
function getThemeGroups() {
	global $opnConfig, $opnTables;

	$opnConfig['theme_groups'][0]=array('theme_group_id'=>0, 'theme_group_text'=>_SEARCH_ALL, 'theme_group_imgurl'=>'', 'theme_group_pos'=>0, 'theme_group_css'=>'', 'theme_group_usergroup'=>0);
	if (isset($opnTables['opn_theme_group'])) {

		$checkerlist = $opnConfig['permission']->GetUserGroups();
		$query = &$opnConfig['database']->Execute('SELECT theme_group_id, theme_group_text, theme_group_imgurl,theme_group_visible, theme_group_pos, theme_group_css, theme_group_usergroup, theme_group_lang FROM '.$opnTables['opn_theme_group'].' WHERE (theme_group_id>0) AND theme_group_usergroup IN ('.$checkerlist.') AND (theme_group_lang=\'\' OR theme_group_lang=\'0\' OR theme_group_lang=\''.$opnConfig['language'].'\') ORDER BY theme_group_pos');
		if ($query) {
			if ($query->fields !== false) {
				while (!$query->EOF) {
					$opnConfig['theme_groups'][$query->fields['theme_group_id']] = $query->GetRowAssoc ('0');
					$query->MoveNext();
				}
				$query->Close();
				unset($query);
			}
		}
	}
}

/**
 * gets the language dependend defines in dir $wichDir
 * the correct language is taken from opn generel setting
 * it also checks that there is no double include of such a
 * file
 *
 * @access public
 * @param string $wichDir
 * @return void
 **/
function getLanguageDef ($wichDir='language/') {
	global $opnConfig;

	$langFile = $wichDir.'lang-'.$opnConfig['language'].'.php';
	if (!defined($langFile)) {
		if (file_exists($wichDir.'lang-'.$opnConfig['language'].'.php')) {
			// echo $langFile.'<br />';
			define($langFile, 1);
			include ($langFile);
		} else {
			$langFile = $wichDir.'lang-english.php';
			if(!defined($langFile)) {
				// echo $langFile.'<br />';
				define($langFile,1);
				include ($langFile);
			}
		}
	}
}

/**
 * gets the content for a box
 *
 * @access private
 * @param string $boxpath
 * @param array $boxoptions
 * @param string $scope
 * @param string $page
 * @return void
 **/
function easybox ($boxpath, $boxoptions, $scope='side', $page = ''){
	global $opnConfig;

	if ($opnConfig['permission']->HasRight('admin', _PERM_ADMIN, true)) {
		$userinfo = $opnConfig['permission']->GetUserinfo();
		if ($userinfo['user_debug'] == 6) {
			$opnConfig['option']['debugbenchmark']->set_debugbenchmark($boxpath.'_START');
		}
	}

	$_box_array_dat=array();
	$_box_array_dat['box_options'] = $boxoptions;
	$_box_array_dat['box_result'] = array();

	$lastpart = substr($boxpath, strrpos($boxpath, '/')+1);
	$theboxfile = $boxpath.'/main.php';
	if(!defined($theboxfile)) {
		define($theboxfile, 1);
		include(_OPN_ROOT_PATH.$theboxfile);
	}
//	if (isset($_box_array_dat['box_options']['use_tpl'])) {
		include_once(_OPN_ROOT_PATH.'include/module.boxtpl.php');
//	}
	if (substr_count($boxpath,'sidebox/')>0) {
		$myfunc = $lastpart.'_get_sidebox_result';
	} else {
		$myfunc = $lastpart.'_get_middlebox_result';
	}
	if (function_exists($myfunc)) {
		$myfunc($_box_array_dat);
	} else {
		$myfunc = $lastpart.'_get_'.'opnbox_result';
		if (function_exists($myfunc)) {
			$myfunc($_box_array_dat);
		} else {
			$_box_array_dat['box_result']['skip'] = TRUE;
		}
	}

	$boxoptions = $_box_array_dat['box_options'];
	$myboxresult = $_box_array_dat['box_result'];

	unset ($_box_array_dat);

	$_arr = array();
	if (!$myboxresult['skip']) {
		if (!isset($myboxresult['title'])) {
			$myboxresult['title'] = '';
		} else {
			// $myboxresult['title'] = str_replace("'",'"',$myboxresult['title']);
		}

		if (($scope =='side') && ($page == '')) {
			$opnConfig['theme_aktuell_sidebox_pos']++;
			themesidebox($myboxresult['title'], $myboxresult['content']);
		} elseif (($scope =='side') && ($page !='') && ($opnConfig['opnOption']['show_tplblock'] == 0) ) {
			$opnConfig['theme_aktuell_sidebox_pos']++;
			themesidebox($myboxresult['title'], $myboxresult['content']);
		} elseif (($scope =='side') && ($page !='')) {
			$opnConfig['theme_aktuell_centerbox_pos']++;
			$opnConfig['opnOutput']->DisplayCenterbox ($myboxresult['title'], $myboxresult['content']);
		} elseif ($scope =='custom_box') {
			$_arr['title'] = $myboxresult['title'];
			$_arr['content'] = $myboxresult['content'];
		} elseif ($scope =='opn') {
			$opnConfig['theme_aktuell_opnbox_pos']++;
			$txt = themebox($myboxresult['title'], $myboxresult['content'],'');

			$opnConfig['opnOption']['opnbox']->set_var(array('[sid]' => $txt));
			$opnConfig['opnOption']['opnbox']->parse('out', 'status');
		} else {
			$opnConfig['theme_aktuell_middlebox_pos']++;
			$opnConfig['theme_aktuell_centerbox_pos']++;
			$opnConfig['opnOutput']->DisplayCenterbox ($myboxresult['title'], $myboxresult['content']);
		}
	}
	unset($myboxresult);
	unset($myfunc);
	unset($theboxfile);
	if ($opnConfig['permission']->HasRight('admin', _PERM_ADMIN, true)) {
		if ($userinfo['user_debug'] == 6) {
			$opnConfig['option']['debugbenchmark']->set_debugbenchmark($boxpath.'_ENDE');
		}
	}
	if ($scope =='custom_box') {
		return $_arr;
	}
	return '';
}

/**
 * check for a correct date
 *
 * @access private
 * @param array $myparameters
 * @param string $boxtype
 * @param int $tyear
 * @param int $ttmon
 * @param int $tday
 * @param int $thour
 * @param int $tmin
 * @return void
 **/
function boxcheckdate(&$myparameters, $boxtype, $tyear, $ttmon, $tday, $thour, $tmin) {
	if ( (!isset($myparameters[$boxtype.'_default_from_year'])) OR  ($myparameters[$boxtype.'_default_from_year']=='')  ) { $myparameters[$boxtype.'_default_from_year'] =$tyear-1; }
	if ( (!isset($myparameters[$boxtype.'_default_from_month'])) OR ($myparameters[$boxtype.'_default_from_month']=='') ) { $myparameters[$boxtype.'_default_from_month']= $ttmon; }
	if ( (!isset($myparameters[$boxtype.'_default_from_day'])) OR   ($myparameters[$boxtype.'_default_from_day']=='')   ) { $myparameters[$boxtype.'_default_from_day']= $tday; }
	if ( (!isset($myparameters[$boxtype.'_default_from_hour'])) OR  ($myparameters[$boxtype.'_default_from_hour']=='')  ) { $myparameters[$boxtype.'_default_from_hour']= $thour; }
	if ( (!isset($myparameters[$boxtype.'_default_from_min'])) OR   ($myparameters[$boxtype.'_default_from_min']=='')   ) { $myparameters[$boxtype.'_default_from_min']= $tmin; }

	if (!isset($myparameters[$boxtype.'_default_to_year'])) { $myparameters[$boxtype.'_default_to_year']=''; }
	if (!isset($myparameters[$boxtype.'_default_to_month'])) { $myparameters[$boxtype.'_default_to_month']=''; }
	if (!isset($myparameters[$boxtype.'_default_to_day'])) { $myparameters[$boxtype.'_default_to_day']=''; }
	if (!isset($myparameters[$boxtype.'_default_to_hour'])) { $myparameters[$boxtype.'_default_to_hour']=''; }
	if (!isset($myparameters[$boxtype.'_default_to_min'])) { $myparameters[$boxtype.'_default_to_min']=''; }

	if ($myparameters[$boxtype.'_default_to_year']=='') { $myparameters[$boxtype.'_default_to_year']=9999; }
	if ($myparameters[$boxtype.'_default_to_month']=='') { $myparameters[$boxtype.'_default_to_month']=$ttmon; }
	if ($myparameters[$boxtype.'_default_to_day']=='') { $myparameters[$boxtype.'_default_to_day']=$tday; }
	if ($myparameters[$boxtype.'_default_to_hour']=='') { $myparameters[$boxtype.'_default_to_hour']=$thour; }
	if ($myparameters[$boxtype.'_default_to_min']=='') { $myparameters[$boxtype.'_default_to_min']=$tmin; }
}

/**
 * calculate a valid box date
 *
 * @access private
 * @param double $from
 * @param double $to
 * @param string $boxtype
 * @param array $myparamters
 * @param string $boxtype
 * @param double $now2
 * @param double $now
 * @param double $now1
 * @return void
 **/
function buildboxdate(&$from, &$to, $myparameters, $boxtype, &$now2, $now, $now1) {
	global $opnConfig;

	if (($myparameters[$boxtype.'_default_from_year'] == 9999) && ($myparameters[$boxtype.'_default_to_year'])) {
		if ($myparameters[$boxtype.'_default_to_hour'] < $myparameters[$boxtype.'_default_from_hour']) {
			$from1 = $myparameters[$boxtype.'_default_from_year'].'-'.$myparameters[$boxtype.'_default_from_month'].'-'.$myparameters[$boxtype.'_default_from_day'];
			$opnConfig['opndate']->setTimestamp($from1);
			$opnConfig['opndate']->subInterval('1 DAYS');
			$from1='';
			$opnConfig['opndate']->formatTimestamp($from1,'%Y-%m-%d');
			$from1 = $from1.' '.$myparameters[$boxtype.'_default_from_hour'].':'.$myparameters[$boxtype.'_default_from_min'].':00';
			$to1 = $myparameters[$boxtype.'_default_to_year'].'-'.$myparameters[$boxtype.'_default_to_month'].'-'.$myparameters[$boxtype.'_default_to_day'].' '.$myparameters[$boxtype.'_default_to_hour'].':'.$myparameters[$boxtype.'_default_to_min'].':00';
			$opnConfig['opndate']->sqlToopnData($now1);
			$time2 = '';
			$opnConfig['opndate']->formatTimestamp($time2, '%H:%M:%S');
			$time2 = $myparameters[$boxtype.'_default_to_year'].'-'.$myparameters[$boxtype.'_default_to_month'].'-'.$myparameters[$boxtype.'_default_to_day'].' '.$time2;
			$opnConfig['opndate']->setTimestamp($time2);
			$now2='';
			$opnConfig['opndate']->opnDataTosql($now2);
		} else {
			$from1 = $myparameters[$boxtype.'_default_from_hour'].':'.$myparameters[$boxtype.'_default_from_min'].':00';
			$to1 = $myparameters[$boxtype.'_default_to_hour'].':'.$myparameters[$boxtype.'_default_to_min'].':00';
			$now2 = $now1;
		}
	} else {
		$from1 = $myparameters[$boxtype.'_default_from_year'].'-'.$myparameters[$boxtype.'_default_from_month'].'-'.$myparameters[$boxtype.'_default_from_day'].' '.$myparameters[$boxtype.'_default_from_hour'].':'.$myparameters[$boxtype.'_default_from_min'].':00';
		$to1 = $myparameters[$boxtype.'_default_to_year'].'-'.$myparameters[$boxtype.'_default_to_month'].'-'.$myparameters[$boxtype.'_default_to_day'].' '.$myparameters[$boxtype.'_default_to_hour'].':'.$myparameters[$boxtype.'_default_to_min'].':00';
		$now2 = $now;
	}
	$opnConfig['opndate']->setTimestamp($from1);
	$from='';
	$opnConfig['opndate']->opnDataTosql($from);
	$opnConfig['opndate']->setTimestamp($to1);
	$to='';
	$opnConfig['opndate']->opnDataTosql($to);
}

/**
 * loads a box
 *
 * @access private
 * @param string $side
 * @param string $scope
 * @return void
 **/
function make_box ($side, $scope='side') {
	global $opnTables, $opnConfig;

	$opnConfig['opndate']->now();
	$jetzt='';
	$tday='';
	$ttmon='';
	$tyear='';
	$thour='';
	$tmin='';
	$opnConfig['opndate']->opnDataTosql($jetzt);
	$opnConfig['opndate']->getDay($tday);
	$opnConfig['opndate']->getMonth($ttmon);
	$opnConfig['opndate']->getYear($tyear);
	$opnConfig['opndate']->getHour($thour);
	$opnConfig['opndate']->getMinute($tmin);
	$opnConfig['opndate']->setTimestamp($thour.':'.$tmin.':00');
	$jetzt1='';
	$opnConfig['opndate']->opnDataTosql($jetzt1);

	$checkerlist = $opnConfig['permission']->GetUserGroups();
	$thepage = $opnConfig['opnOutput']->GetDisplay ();
	$opnConfig['opnOutput']->SetDisplaySide ($scope);

	if (($side == 'l') or ($side == 'left') or ($side == '0')) {
		$side = 0;
		$opnConfig['theme_aktuell_'.$scope.'box_side'] = 'left';
		$dummy = $opnConfig['opnOutput']->GetAdminSideboxModernArt();
		if ($dummy != '') {
			themesidebox('Admin', $dummy);
		}
	} elseif (($side == 'r') or ($side == 'right') or ($side == '1')) {
		$side = 1;
		$opnConfig['theme_aktuell_'.$scope.'box_side'] = 'right';
	} elseif (($side != 0) && ($side != 1)) {
		echo 'error: don\'t know how to handle side='.$side;
	}

	if ((isset($opnConfig['opnOption']['themegroup'])) && ($opnConfig['opnOption']['themegroup']>=1)) {
		$like_search = $opnConfig['opnSQL']->AddLike ('-'.$opnConfig['opnOption']['themegroup'].'-');
		// $websitetheme = "((themegroup='".$opnConfig['opnOption']['themegroup']."') OR (themegroup=0)) AND ";
		$websitetheme = "((themegroup='".$opnConfig['opnOption']['themegroup']."') OR (themegroup='0') OR (themegroup='-0-') OR (themegroup LIKE $like_search) ) AND ";
	} else {
		$websitetheme = '';
	}

	if ($thepage == '') {
		$where = "(module='') AND (side=$side) AND (visible=1) AND ";
	} else {
		$opnConfig['centerbox']->_insert('use_tpl','1');
		$opnConfig['centerbox']->_insert('use_tpl_box',$scope);
		$where = "( (module='$thepage') OR (module='') ) AND (visible=1) AND ";
	}
	if ($scope == 'side') {
		// sidebox

		$opnConfig['theme_aktuell_sidebox_pos'] = 0;
		if (!isset($opnConfig['theme_aktuell_centerbox_pos'])) $opnConfig['theme_aktuell_centerbox_pos'] = 0;

		if ($thepage != '') {
			$where .= "(side=$side) AND ";
		}
		$mksbsql = 'SELECT sbpath, options, sbid, module, themegroup FROM '.$opnTables['opn_sidebox']." WHERE ".$websitetheme.$where."(seclevel IN (".$checkerlist.")) ORDER BY position1";
		$mksbresult = &$opnConfig['database']->Execute($mksbsql);

		if ($mksbresult !== false) {
			while (!$mksbresult->EOF) {
				$myparameters = stripslashesinarray(unserialize($mksbresult->fields['options']));
				$myparameters['boxid'] = 'side'.$mksbresult->fields['sbid'];
				$opnConfig['current_websitetheme'] = $mksbresult->fields['themegroup'];

				boxcheckdate($myparameters, 'opn_sidebox', $tyear, $ttmon, $tday, $thour, $tmin);

				$von=0;
				$zu=0;
				$jetzt2=0;
				buildboxdate($von, $zu, $myparameters, 'opn_sidebox', $jetzt2 ,$jetzt, $jetzt1);

				if ( ($von <= $jetzt2) && ($zu >= $jetzt2)) {

					if ( (!isset($myparameters['box_use_lang'])) OR ($myparameters['box_use_lang']=='') ) { $myparameters['box_use_lang']='0'; }
					if ( (!isset($myparameters['box_use_login'])) OR ($myparameters['box_use_login']=='') ) { $myparameters['box_use_login']='0'; }

					if ($opnConfig['opnOption']['user_login']) {
						$lg=2;
					} else {
						$lg=1;
					}
					if ( (!isset($myparameters['box_use_bot_view'])) OR ($myparameters['box_use_bot_view']=='0') OR ($myparameters['box_use_bot_view']=='') ) {
						$mybotview = true;
					} else {
						if (
							($myparameters['box_use_bot_view'] == 1) &&
							(trim($opnConfig['opnOption']['client']->_browser_info['browser']) == 'bot')
								) {
							$mybotview = false;
						} elseif (
							($myparameters['box_use_bot_view'] == 2) &&
							(trim($opnConfig['opnOption']['client']->_browser_info['browser']) != 'bot')
								)
							{
							$mybotview = false;
						}
						$mybotview = true;
					}
					if ( (!isset($myparameters['box_use_random'])) OR ($myparameters['box_use_random']=='0') ) {
						$myrandom = true;
					} else {
						srand((double)microtime() * 1000000);
						$random = rand(0, 10);
						if ($random <= $myparameters['box_use_random']) {
							$myrandom = true;
						} else {
							$myrandom = false;
						}
					}
					if ( ($myrandom == true) && ($mybotview == true) &&
						( ($myparameters['box_use_lang'] == '0') OR ($myparameters['box_use_lang'] == $opnConfig['language']) ) &&
						( ($myparameters['box_use_login'] == '0') OR ($myparameters['box_use_login'] == $lg) )
						) {
						if ( (isset($myparameters['themeid'])) && ($myparameters['themeid'] != '') ) {
							$opnConfig['current_sb_themeid'] = $myparameters['themeid'];
							if ($mksbresult->fields['module'] == '') {
								if ($side == 0) {
									$opnConfig['centerbox']->SetTplId('IDALLLEFT');
								} else {
									$opnConfig['centerbox']->SetTplId('IDALLRIGHT');
								}
							} else {
								$opnConfig['centerbox']->SetTplId($myparameters['themeid']);
							}
						} else {
							$opnConfig['current_sb_themeid'] = '';
							if ($mksbresult->fields['module'] == '') {
								if ($side == 0) {
									$opnConfig['centerbox']->SetTplId('IDALLLEFT');
								} else {
									$opnConfig['centerbox']->SetTplId('IDALLRIGHT');
								}
							} else {
								$opnConfig['centerbox']->SetTplId('S'.$mksbresult->fields['sbid']);
							}
						}
						$myparameters['opnbox_class'] = 'side';
						easybox($mksbresult->fields['sbpath'], $myparameters, 'side', $thepage);
					}
				}
				unset($myparameters);
				$mksbresult->MoveNext();
			}
			$mksbresult->Close();
			unset($mksbresult);
		}
		if (isset($opnConfig['current_sb_themeid'])) { unset($opnConfig['current_sb_themeid']); }

	} elseif ($scope == 'opn') {
		// opnbox

		$opnConfig['theme_aktuell_opnbox_pos'] = 0;

		$mksbsql = 'SELECT sbpath, options, sbid FROM '.$opnTables['opn_opnbox']." WHERE ".$websitetheme.$where."(seclevel IN (".$checkerlist.")) ORDER BY position1";
		$mksbresult = &$opnConfig['database']->Execute($mksbsql);
		if ($mksbresult !== false) {
			while (!$mksbresult->EOF) {
				$myparameters = stripslashesinarray(unserialize($mksbresult->fields['options']));
				$myparameters['boxid'] = 'opn'.$mksbresult->fields['sbid'];

				boxcheckdate($myparameters, 'opn_opnbox', $tyear, $ttmon, $tday, $thour, $tmin);

				$von=0;
				$zu=0;
				$jetzt2=0;
				buildboxdate($von, $zu, $myparameters, 'opn_opnbox', $jetzt2, $jetzt, $jetzt1);

				if ( ($von <= $jetzt2) && ($zu >= $jetzt2)) {

					if ( (!isset($myparameters['box_use_lang'])) OR ($myparameters['box_use_lang']=='') ) { $myparameters['box_use_lang']='0'; }
					if ( (!isset($myparameters['box_use_login'])) OR ($myparameters['box_use_login']=='') ) { $myparameters['box_use_login']='0'; }

					if ($opnConfig['opnOption']['user_login']) {
						$lg=2;
					} else {
						$lg=1;
					}
					if (
						( ($myparameters['box_use_lang'] == '0') OR ($myparameters['box_use_lang'] == $opnConfig['language']) ) &&
						( ($myparameters['box_use_login'] == '0') OR ($myparameters['box_use_login'] == $lg) )
						) {
						if (isset($myparameters['themeid'])) {
							$opnConfig['current_ob_themeid'] = $myparameters['themeid'];
						} else {
							$opnConfig['current_ob_themeid'] = '';
						}
						if ($mksbresult->fields['module'] == '' OR ($opnConfig['current_ob_themeid'] == '') ) {
							$opnConfig['centerbox']->SetTplId('ALLCENTER');
						} else {
							$opnConfig['centerbox']->SetTplId($opnConfig['current_ob_themeid']);
						}
						$myparameters['opnbox_class'] = 'opn';

						easybox($mksbresult->fields['sbpath'], $myparameters, 'opn');
					}
				}
				$mksbresult->MoveNext();
			}
			$mksbresult->Close();
			unset($mksbresult);
		}
		if (isset($opnConfig['current_ob_themeid'])) { unset($opnConfig['current_ob_themeid']); }

	} else {
		// middlebox

		$opnConfig['opnOption']['isInCenterbox'] = true;
		if ($thepage != '') {
			$where = "( (module='$thepage') OR (module='') ) AND (visible=1) AND ";
		} else {
			$where = "(module='') AND (visible=1) AND ";
		}
		$opnConfig['centerbox']->_insert('no_center','0');
		$opnConfig['centerbox']->_start_center ();
		$opnConfig['theme_aktuell_centerbox_pos'] = 0;
		$opnConfig['theme_aktuell_middlebox_pos'] = 0;

		$mksbsql = 'SELECT sbpath, options, side, anker, width, sbid, module, themegroup FROM '.$opnTables['opn_middlebox']." WHERE ".$websitetheme.$where."(seclevel IN (".$checkerlist.")) ORDER BY position1";
		$mksbresult = &$opnConfig['database']->Execute($mksbsql);
		if ($mksbresult !== false) {
			while (!$mksbresult->EOF) {
				$myparameters = stripslashesinarray(unserialize($mksbresult->fields['options']));
				$myparameters['boxid'] = 'center'.$mksbresult->fields['sbid'];

				$opnConfig['current_websitetheme'] = $mksbresult->fields['themegroup'];

				$opnConfig['centerbox']->_insert('side',$mksbresult->fields['side']);
				$opnConfig['centerbox']->_insert('anker',$mksbresult->fields['anker']);
				$opnConfig['centerbox']->_insert('width',$mksbresult->fields['width']);

				if ($mksbresult->fields['module'] == '') {
					$opnConfig['centerbox']->SetTplId('ALLCENTER');
				} else {
					$opnConfig['centerbox']->SetTplId($mksbresult->fields['sbid']);
				}
				boxcheckdate($myparameters, 'opn_middlebox', $tyear, $ttmon, $tday, $thour, $tmin);

				$von=0;
				$zu=0;
				$jetzt2=0;
				buildboxdate($von, $zu, $myparameters, 'opn_middlebox', $jetzt2, $jetzt, $jetzt1);

				if ( ($von <= $jetzt2) && ($zu >= $jetzt2)) {

					if ( (!isset($myparameters['box_use_lang'])) OR ($myparameters['box_use_lang']=='') ) { $myparameters['box_use_lang']='0'; }
					if ( (!isset($myparameters['box_use_login'])) OR ($myparameters['box_use_login']=='') ) { $myparameters['box_use_login']='0'; }

					if ($opnConfig['opnOption']['user_login']) {
						$lg=2;
					} else {
						$lg=1;
					}
					if ( (!isset($myparameters['box_use_bot_view'])) OR ($myparameters['box_use_bot_view']=='0') OR ($myparameters['box_use_bot_view']=='') ) {
						$mybotview = true;
					} else {
						if (
							($myparameters['box_use_bot_view'] == 1) &&
							(trim($opnConfig['opnOption']['client']->_browser_info['browser']) == 'bot')
								) {
							$mybotview = false;
						} elseif (
							($myparameters['box_use_bot_view'] == 2) &&
							(trim($opnConfig['opnOption']['client']->_browser_info['browser']) != 'bot')
								)
							{
							$mybotview = false;
						}
						$mybotview = true;
					}
					if ( (!isset($myparameters['box_use_random'])) OR ($myparameters['box_use_random']=='0') ) {
						$myrandom = true;
					} else {
						srand((double)microtime() * 1000000);
						$random = rand(0, 10);
						if ($random <= $myparameters['box_use_random']) {
							$myrandom = true;
						} else {
							$myrandom = false;
						}
					}
					if (	($myrandom == true) && ($mybotview == true) &&
						( ($myparameters['box_use_lang'] == '0') OR ($myparameters['box_use_lang'] == $opnConfig['language']) ) &&
						( ($myparameters['box_use_login'] == '0') OR ($myparameters['box_use_login'] == $lg) )
						) {
							if ( (isset($myparameters['themeid'])) && ($myparameters['themeid'] != '') ) {
								$opnConfig['current_mb_themeid'] = $myparameters['themeid'];
								if ($mksbresult->fields['module'] == '') {
									$opnConfig['centerbox']->SetTplId('ALLCENTER');
								} else {
									$opnConfig['centerbox']->SetTplId($myparameters['themeid']);
								}
							} else {
								$opnConfig['current_mb_themeid'] = '';
								if ($mksbresult->fields['module'] == '') {
									$opnConfig['centerbox']->SetTplId('ALLCENTER');
								} else {
									$opnConfig['centerbox']->SetTplId('C'.$mksbresult->fields['sbid']);
								}
							}
							$myparameters['opnbox_class'] = 'center';
							easybox($mksbresult->fields['sbpath'], $myparameters, 'middle');
					}
				}
				$mksbresult->MoveNext();
			}
			$mksbresult->Close();
			unset($mksbresult);
		}
		$opnConfig['centerbox']->_insert('no_center', '1');
		$opnConfig['centerbox']->stop_center ('1');
		if (isset($opnConfig['current_mb_themeid'])) { unset($opnConfig['current_mb_themeid']); }
		$opnConfig['opnOption']['isInCenterbox'] = false;
	}
	$opnConfig['centerbox']->_insert('use_tpl', '0');
}

/**
 * filters an array
 *
 * @access public
 * @param array $help
 * @param array $input
 * @param string $callback - the name of the callback function
 * @param string $param
 * @return void
 **/
function arrayfilter(&$help, $input, $callback, $parm='DUMMY') {
	global $opnConfig;

	if(!isset($opnConfig['remember']['usearray_filter'])) {
		if (function_exists('array_filter')) {
			$opnConfig['remember']['usearray_filter'] = TRUE;
		} else {
			$opnConfig['remember']['usearray_filter'] = FALSE;
		}
	}

	$help=array();

	if ((is_string($parm)) && ($parm=='DUMMY')) {
		if ($opnConfig['remember']['usearray_filter']) {
			$help = array_filter($input, $callback);
		} else {
			foreach ($input as $var) {
				if ($callback($var)) {
					$help[]=$var;
				}
			}
		}
	} else {
		if (is_string($parm)) {
			$parm2 = strlen ($parm);
		} else {
			$parm2 = 0;
		}
		foreach ($input as $var) {
			if ($callback($var, $parm, $parm2)) {
				$help[]=$var;
			}
		}
	}
}

/**
 * Locale based case sensitive string comparison
 *
 * @access public
 * @param string $a
 * @param string $b
 * @return string
 **/
function strcollcase($a, $b) {
	global $opnConfig;

	if(!isset($opnConfig['remember']['usestrcoll'])) {
		if (((substr_count(strtolower(PHP_OS),'win')>0) && (phpversion() < '4.2.3')) || (phpversion() < '4.0.5')) {
			$opnConfig['remember']['usestrcoll'] = FALSE;
		} else {
			$opnConfig['remember']['usestrcoll'] = TRUE;
		}
	}
	if ($opnConfig['remember']['usestrcoll']) {
		return strcoll(strtolower($a), strtolower($b));
	}
	return strnatcasecmp(strtolower($a), strtolower($b));

}

/**
 * returns an array of dirnames for $wichdir
 *
 * @access public
 * @param string $wichDir
 * @param string $excludeDir
 * @param string $preg
 * @return array
 **/
function get_dir_list($wichDir, $excludeDir='', $preg='') {
	$handle = opendir($wichDir);
	$dirlist = '';
	while ($file = readdir($handle)) {
		if ($preg != '') {
			$matches='';
			if (preg_match($preg, $file, $matches)) {
				$dirlist .= $matches[1].' ';
			}
		} elseif ( (!preg_match('/[.]/',$file)) ) {
			if ($excludeDir != '') {
				if ($file != $excludeDir) {
					$dirlist .= $file.' ';
				}
			} else {
				$dirlist .= $file.' ';
			}
		}
	}
	closedir($handle);
	$dirlist = explode(' ', rtrim($dirlist));
	return $dirlist;
}

/**
 * returns an array of filenames for $wichdir
 *
 * @access public
 * @param string $wichDir
 * @param array $notshow
 * @return array
 **/
function get_file_list($wichDir, $notshow = array()) {
	$filelist = array();
	if(file_exists($wichDir)) {
		$handle=opendir($wichDir);
		while ($file = readdir($handle)) {
			$max=sizeof($notshow);
			for ($i=0; $i < $max; $i++) {
				if (substr_count($file, $notshow[$i])>0) {
					$file = 'index.html';
				}
			}
			if (($file != '.') && ($file != '..') && ($file != 'index.html')) {
				$filelist[] = $file;
			}
		}
		closedir($handle);
	}
	return $filelist;
}

/**
 * returns $var from enviroment vars
 *
 * @access public
 * @param string $var
 * @return mixed
 **/
function get_env($var) {
	global $opnConfig;

	if ($opnConfig['opn_host_use_safemode']==1) {
		return getenv('PHP_'.$var);
	}
	return getenv($var);

}

/**
 * sets enviroment var $var to $value
 *
 * @access public
 * @param string $var
 * @param mixed $value
 * @return void
 **/
function put_env($var, $value) {
	global $opnConfig;

	if ($opnConfig['opn_host_use_safemode']==1) {
		putenv('PHP_'.$var.'='.$value);
	} else {
		putenv($var.'='.$value);
	}
}

/**
 * show help text for $fieldname
 *
 * @access public
 * @param string $fieldname
 * @param string $fieldtype
 * @param string $txt
 * @param string $class
 * @return string
 **/
function showhelp ($fieldname, $fieldtype, $txt, $class) {
	global $opnConfig;

	if ($opnConfig['user_online_help'] == 1) {
		return $opnConfig['opnOption']['opn_onlinehelp']->Show_Help_Symbol ($fieldname, $fieldtype, $txt, $class);
	}
	return $txt;
}

/**
 * extract ip from a string
 *
 * @access public
 * @param string $ip
 * @return string
 **/
function extractIP($ip) {
	$array='';
	$b = preg_match ('/^([0-9]{1,3}\.){3,3}[0-9]{1,3}/', $ip, $array);
	if ($b) return $array;
	return false;
}

/**
 * returns ip from server remote information
 *
 * @access public
 * @return string
 **/
function get_IP() {

	$remote='';
	get_var('REMOTE_HOST', $remote, 'server');
	if($remote!='') {
		$array = extractIP($remote);
		if ($array && count($array) >= 1) {
			return $array[0]; // first IP in the list
		}
	}
	$remote='';
	get_var('REMOTE_ADDR', $remote, 'server');
	return $remote;
}

/**
 * returns the real IP if hidden by proxy from server remote information
 *
 * @access public
 * @return string
 **/
function get_real_IP() {

	$array='';
	$HTTP_X_FORWARDED_FOR='';
	get_var('HTTP_X_FORWARDED_FOR', $HTTP_X_FORWARDED_FOR, 'server');
	if($HTTP_X_FORWARDED_FOR!='') { // case 1.A: proxy && HTTP_X_FORWARDED_FOR is defined
		$array = extractIP($HTTP_X_FORWARDED_FOR);
	}
	$HTTP_X_FORWARDED='';
	get_var('HTTP_X_FORWARDED', $HTTP_X_FORWARDED, 'server');
	if($HTTP_X_FORWARDED!='') { // case 1.B: proxy && HTTP_X_FORWARDED is defined
		$array = extractIP($HTTP_X_FORWARDED);
	}
	$HTTP_FORWARDED_FOR='';
	get_var('HTTP_FORWARDED_FOR', $HTTP_FORWARDED_FOR, 'server');
	if($HTTP_FORWARDED_FOR!='') { // case 1.C: proxy && HTTP_FORWARDED_FOR is defined
		$array = extractIP($HTTP_FORWARDED_FOR);
	}
	$HTTP_FORWARDED='';
	get_var('HTTP_FORWARDED', $HTTP_FORWARDED, 'server');
	if($HTTP_FORWARDED!='') { // case 1.D: proxy && HTTP_FORWARDED is defined
		$array = extractIP($HTTP_FORWARDED);
	}
	$HTTP_CLIENT_IP='';
	get_var('HTTP_CLIENT_IP', $HTTP_CLIENT_IP, 'server');
	if($HTTP_CLIENT_IP!='') { // case 1.E: proxy && HTTP_CLIENT_IP is defined
		$array = extractIP($HTTP_CLIENT_IP);
	}
	/*
	if($HTTP_VIA) {
	// case 2:
	// proxy && HTTP_(X_) FORWARDED (_FOR) not defined && HTTP_VIA defined
	// other exotic variables may be defined
	return ( $HTTP_VIA .
			'_' . $HTTP_X_COMING_FROM .
			'_' . $HTTP_COMING_FROM
		  ) ;
	}
	if( $HTTP_X_COMING_FROM || $HTTP_COMING_FROM ) {
	// case 3: proxy && only exotic variables defined
	// the exotic variables are not enough, we add the REMOTE_ADDR of the proxy
	return ( $REMOTE_ADDR .
			'_' . $HTTP_X_COMING_FROM .
			'_' . $HTTP_COMING_FROM
		  ) ;
	}
	*/

	// case 4: no proxy (or tricky case: proxy+refresh)
	$REMOTE_HOST='';
	get_var('REMOTE_HOST', $REMOTE_HOST, 'server');
	if($REMOTE_HOST!='') {
		$array = extractIP($REMOTE_HOST);
	}

	if ($array && count($array) >= 1) {
		return $array[0]; // first IP in the list
	}
	$REMOTE_ADDR='';
	get_var('REMOTE_ADDR', $REMOTE_ADDR, 'server');
	return $REMOTE_ADDR;

}

/**
 * strips slashes in an array
 *
 * @access public
 * @param array $myarray
 * @return array
 **/
function stripslashesinarray ($myarray){
	if (is_array($myarray)) {
		foreach ($myarray as $k=>$myfield) {
			if (is_array($myfield)) {
				$mycleanparameter[$k] = stripslashesinarray($myfield);
			} else {
				if (strpos($myfield,_OPN_SLASH)===FALSE) {
					$mycleanparameter[$k] = $myfield;
				} else {
					$mycleanparameter[$k] = stripslashes($myfield);
				}
			}
		}
		if (isset($mycleanparameter)) { return $mycleanparameter; }
	} else {
		$mycleanparameter = stripslashes($myarray);
		if (isset($mycleanparameter)) { return $mycleanparameter; }
	}
	return '';
}

/**
 * adds slashes in an array
 *
 * @access public
 * @param array $myarray
 * @return array
 **/
function addslashesinarray($myarray){
	$search = array(_OPN_SLASH.'"',_OPN_SLASH._OPN_SLASH,_OPN_SLASH."'");
	$replace = array('"',_OPN_SLASH,"'");
	if (is_array($myarray)) {
		foreach ($myarray as $k=>$myfield) {
			if (is_array($myfield)) {
				$mycleanparameter[$k] = addslashesinarray($myfield);
			} else {
				$s = str_replace($search,$replace,$myfield);
				$myfield = addslashes($s);
				$mycleanparameter[$k] = str_replace("\'","'",$myfield);
			}
		}
		unset($search);
		unset($replace);
		if (isset($mycleanparameter)) { return $mycleanparameter; }
	} else {
		$s = str_replace($search, $replace, $myarray);
		$myarray = addslashes($s);
		$myarray = addslashes($myarray);
		$mycleanparameter = str_replace("\'", "'", $myarray);
		unset($search);
		unset($replace);
		if (isset($mycleanparameter)) { return $mycleanparameter; }
	}
	return '';
}

/**
 * replaces tag
 *
 * @access public
 * @param string $str
 * @param string $tag
 * @param array $tagarray
 * @return void
 **/
function replace_tag(&$str, $tag, &$tagarray) {
	preg_match_all("=<".$tag."[^>]*>(.*)</".$tag.">=siU", $str, $tagarray);
//	preg_match_all("=<".$tag.".*>(.*)</".$tag.">=siU", $str, $tagarray);
	$max=count($tagarray[0]);
	for ($i=0; $i<$max; $i++) {
//		$str = preg_replace('='.preg_quote($tagarray[0][$i]).'=siU', ':'.$tag.$i.':', $str);
		$str = preg_replace('=<'.$tag.'.*>.*</'.$tag.'>=siU', ':'.$tag.$i.':', $str,1);
	}
}

/**
 * Replace attribute values
 * 
 * @param $str
 * @param $attrib
 * @param $attribarray
 * @return void
 */
function replace_attribute (&$str, $attrib, &$attribarray) {
	preg_match_all('=<.*' . $attrib .'\="(.*)".*>=siU', $str, $attribarray);
	$max=count($attribarray[1]);
	for ($i=0; $i<$max; $i++) {
		$str = preg_replace('=' . $attrib . '\="'. preg_quote($attribarray[1][$i]).'"=siU', ':'.$attrib.$i.':', $str);
	}
}
/**
 * restores tag
 *
 * @access public
 * @param string $str
 * @param string $replacment
 * @param array $tagarray
 * @return void
 **/
function restore_tag(&$str, $replacment, $tagarray) {
	$max=count($tagarray[0]);
	for ($i=0; $i<$max; $i++) {
		$str = preg_replace('='.preg_quote(':'.$replacment.$i.':').'=siU', $tagarray[0][$i], $str);
	}
}

/**
 * Restores attribute values
 * 
 * @param $str
 * @param $attrib
 * @param $attribarray
 * @return void
 */
function restore_attribute (&$str, $attrib, $attribarray) {
	$max=count($attribarray[1]);
	for ($i=0; $i<$max; $i++) {
		$str = preg_replace('='.preg_quote(':'.$attrib.$i.':').'=siU', $attrib .'="' . $attribarray[1][$i] . '"', $str);
	}
}
/**
 * replaces newlines and tabs with html elements
 *
 * @access public
 * @param string $str
 * @return void
 **/
function opn_nl2br(&$str) {
	$hastable = false;
	$hasul = false;
	$hasol = false;
	$hasdl = false;
	$hasscript = false;
	if ((substr_count(strtolower($str),'<table') > 0)) {
		$hastable = true;
		$tables = array();
		replace_tag($str, 'table', $tables);
	}
	if ((substr_count(strtolower($str),'<script') > 0)) {
		$hasscript = true;
		$scripts = array();
		replace_tag($str, 'script', $scripts);
	}
	if ((substr_count(strtolower($str),'<ul') > 0)) {
		$hasul = true;
		$uls = array();
		replace_tag($str, 'ul', $uls);
	}
	if ((substr_count(strtolower($str),'<dl') > 0)) {
		$hasdl = true;
		$dls = array();
		replace_tag($str, 'dl', $dls);
	}
	if ((substr_count(strtolower($str),'<ol') > 0)) {
		$hasol = true;
		$ols = array();
		replace_tag($str, 'ol', $ols);
	}
	$search = array('<br>', _OPN_HTML_NL, _OPN_HTML_TAB);
	$replace = array('<br />', '<br />', '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
	$str = str_replace($search, $replace, $str);
	if ($hastable) {
		restore_tag($str, 'table', $tables);
		unset($tables);
	}
	if ($hasscript) {
		restore_tag($str, 'script', $scripts);
		unset($scripts);
	}
	if ($hasul) {
		restore_tag($str, 'ul', $uls);
		unset($uls);
	}
	if ($hasdl) {
		restore_tag($str, 'dl', $dls);
		unset($dls);
	}
	if ($hasol) {
		restore_tag($str, 'ol', $ols);
		unset($ols);
	}
	unset($hastable);
	unset($hasul);
	unset($hasol);
	unset($search);
	unset($replace);
}

/**
 * replaces html <br /> with newlines
 *
 * @access public
 * @param string $str
 * @return string
 **/
function opn_br2nl($str) {
	return str_replace('<br />', _OPN_HTML_NL, $str);
}

/**
 * ???
 *
 * @access public
 * @param string $string
 * @param string $insert
 * @param string $increment
 * @return void
 **/
function sow(&$string, $insert, $increment){
	$insert_len = strlen($insert);
	$string_len = strlen($string);

	$string_len_ending = $string_len + intval( $insert_len * ($string_len / $increment));

	$i = $increment - 1;

	while($string_len_ending > $i) {
		$string = substr($string, 0, $i).$insert.substr($string, $i);
		$i = $i + $increment + $insert_len;
	}
}

/**
 * parse encoded url and extract its elements
 *
 * @access public
 * @param string $url
 * @param string $debut
 * @param string $param
 * @param string $sep
 * @param string $fin
 * @param string $jump
 * @return void
 **/
function parseencurl($url, &$debut, &$param, &$sep, &$fin, &$jump) {
	$pos_debut = strpos($url, '?');
	$sep = '';
	if($pos_debut === FALSE){ $sep='&'; }
	$pos_long = strlen($url)-$pos_debut-1;
	$fin = '';
	$debut = substr($url, 0 , $pos_debut+1);
	$param = substr($url, $pos_debut+1, $pos_long);
	$pos_jump = strrpos($param, '#');
	$jump = '';
	if($pos_jump!==FALSE) {
		$jump = substr($param, $pos_jump);
		$param = substr($param, 0, $pos_jump);
	}
}

$linknummer = 0;

/**
 * encode an URL
 *
 * @access public
 * @param string $url
 * @param bool $dohtmlent
 * @param bool $dosession
 * @return string
 **/
function encodeurl($url, $dohtmlent=true, $dosession=true,  $param = false, $jump='') {
	global $opnConfig, $linknummer;

	if (is_array($url)) {
		$hlp = $url[0];
		if (!isset($url[0])) { echo print_r($url); }
		unset($url[0]);
		if (substr_count($hlp,'?') == 0) {
			$hlp .= '?';
		}
		foreach($url as $k => $a) {
			$hlp .= $k.'='.rawurlencode($a).'&';
		}
		$url = substr($hlp,0,-1);
		unset($hlp);
	} elseif (is_array($param)) {
		foreach($param as $k => $a) {
				$url .= $k.'='.rawurlencode($a).'&';
		}
		$url = substr($url,0,-1);
	}
	$url .= $jump;
	$linknummer++;
	if (!isset($opnConfig['encodeurl'])) {
		$opnConfig['encodeurl'] = 0;
	}
	if (!isset($opnConfig['opn_cryptadjustment'])) {
		$opnConfig['opn_cryptadjustment'] = 2;
	}

	$help = $url;
	if (strpos($url,'amp;')) {
		opnErrorHandler (E_WARNING,'Found an old style &amp;amp; "encodeurl"', $help , '');
	}
	if ($opnConfig['encodeurl'] > 0) {
		if (substr_count($url, 'opnparams') > 0) {
			$hlp = 'found a double "encodeurl';
			if ($opnConfig['encodeurl'] == 2) {
				$hlp .= ' (session)';
			}
			$hlp .= '"';
			opnErrorHandler (E_WARNING, $hlp, $help, '');
			if ($dohtmlent) { $help = htmlentities($url); }
		} elseif (substr_count($url,'?') > 0) {
			$debut='';
			$param='';
			$sep='';
			$fin='';
			$jump='';
			parseencurl($url, $debut, $param, $sep, $fin, $jump);
			if ($opnConfig['encodeurl'] == 3) {
				$code = trim($param);
				$search = array('/', '=', '&');
				$replace = array('X1X', '1X1', 'X2X');
				$code=str_replace ($search,$replace,$code);
			} else {
				$code = make_the_secret(md5($opnConfig['encoder']), trim($param),$opnConfig['opn_cryptadjustment']);
				$code = rtrim($code, '=');
			}
			if ($opnConfig['encodeurl'] == 1) {
				$code = rawurlencode($code);
				$help = $debut.$sep.'opnparams='.$code.$fin.$jump;
			} elseif ($opnConfig['encodeurl'] == 3) {
				$help = $debut.$sep.'opnparams='.$code.$fin.$jump;

				$in =  array("'.php\?opnparams=(.*)'si", );
				$out = array("opnparams\\1.html", );
				$help = preg_replace($in, $out, $help);
			} else {
				$opnConfig['opnOption']['opnsession']->set_var('_OPNLINKNR_'.$linknummer, $code);
				$code = make_the_secret(md5($opnConfig['encoder']), trim($linknummer),$opnConfig['opn_cryptadjustment']);
				$help = $debut.$sep.'opnparams='.$code.$fin.$jump;
				$help = $debut.$sep.$opnConfig['opnOption']['opnsession']->get_sid_string().'&'.'opnparams='.$code.$fin.$jump;
				if ($dohtmlent) { $help = htmlentities($help); }
			}
		} else {
			if ($opnConfig['encodeurl'] == 2) {
				if ($dosession) {
					$url .= '?'.$opnConfig['opnOption']['opnsession']->get_sid_string();
				}
				if ($dohtmlent) { $help = htmlentities($url); }
			}
		}
	} else {
		if (substr_count($url, '?') > 0) {
			$debut='';
			$param='';
			$sep='';
			$fin='';
			$jump='';
			parseencurl($url, $debut, $param, $sep, $fin, $jump);
			if ($dosession) {
				$help = $debut.$sep.$param.$fin.$jump;
			} else {
				$help = $debut.$sep.'&'.$param.$fin.$jump;
			}
			if ($dohtmlent) { $help = htmlentities($help); }
		} else {
			if ($opnConfig['encodeurl'] == 2) {
				if ($dosession) {
					$url .= '?'.$opnConfig['opnOption']['opnsession']->get_sid_string();
				}
				if ($dohtmlent) { $help = htmlentities($url); }
			}
		}
	}
	if ($opnConfig['centerbox']->property('subdomain') != '') {
		$help = str_replace('://','://'.$opnConfig['centerbox']->property('subdomain').'.', $help);
	}
	return $help;
}

/**
 * creates the url theme group parameter
 *
 * @access public
 * @param string $id
 * @return string
 **/
function getThemeGroupUrl ($id) {
	global $opnConfig;

	$url = '?webthemegroupchoose='.$id;
	if ( (isset($opnConfig['opn_'.$opnConfig['encoder']])) && (is_array($opnConfig['opn_'.$opnConfig['encoder']])) ) {
		reset($opnConfig['opn_'.$opnConfig['encoder']]);
		foreach($opnConfig['opn_'.$opnConfig['encoder']] as $k=>$v){
			if ($k != 'webthemegroupchoose') {
				$url .= '&'.$k.'='.$v;
			}
		}
	}
	return $url;
}

/**
 * decodes the encoded url parameters and sets the var
 *
 * @access public
 * @param string $inputurl
 * @return void
 **/
function decodeurl($inputurl='') {
	global $opnConfig, ${$opnConfig['opn_request_vars']}, ${$opnConfig['opn_server_vars']},${$opnConfig['opn_get_vars']};

	if (!isset($opnConfig['encodeurl'])) {
		$opnConfig['encodeurl'] = 0;
	}

	if ( (!defined('_OPN_NO_URL_DECODE')) OR ($opnConfig['encodeurl'] == 3) ) {
		if ($opnConfig['encodeurl'] > 0) {

			$request = ${$opnConfig['opn_request_vars']};
			$server = ${$opnConfig['opn_server_vars']};
			$get = ${$opnConfig['opn_get_vars']};

			if ( (substr_count($server['REQUEST_URI'],'?') > 0) OR ( (substr_count($server['REQUEST_URI'],'1X1') > 0) && ($opnConfig['encodeurl'] == 3) ) ){
				if(isset($request['opnparams'])){

					$cc = explode ('opnparams',$server['REQUEST_URI']);
					if ( (isset($cc[1])) && ( (substr_count($cc['1'],'+') > 0) OR (substr_count($cc['1'],'/') > 0) ) ) {
						$request['opnparams'] = rawurlencode($request['opnparams']);
						// echo $request['opnparams'].'<br />';
					}
					if ($opnConfig['encodeurl'] == 1) {
						$decode_url = open_the_secret(md5($opnConfig['encoder']),rawurldecode($request['opnparams']));
					} elseif ($opnConfig['encodeurl'] == 3) {
						$replace = array('/', '=', '&');
						$search = array('X1X', '1X1', 'X2X');
						$decode_url = str_replace ($search,$replace,$request['opnparams']);
					} else {
						$linknummer = open_the_secret(md5($opnConfig['encoder']),$request['opnparams']);
						$decode_url = open_the_secret(md5($opnConfig['encoder']),$opnConfig['opnOption']['opnsession']->get_var('_OPNLINKNR_'.$linknummer));
					}
					$opnConfig['opn_'.$opnConfig['encoder']] = '';
					parse_str($decode_url, $opnConfig['opn_'.$opnConfig['encoder']]);
					foreach($opnConfig['opn_'.$opnConfig['encoder']] as $k=>$v){
						if (is_string($v)) {
							$request[$k]=rawurldecode($v);
							$get[$k]=rawurldecode($v);
						}
					}
					if($inputurl=='') {
						${$opnConfig['opn_request_vars']} = $request;
						${$opnConfig['opn_get_vars']} = $get;
					} else {
						return $decode_url;
					}
				} elseif (isset($request[session_name()])) {
				} else {
					// $bots = rtrim($server['REQUEST_URI'], '?');
					// if ( (substr_count($bots,'?') > 0) ) {
						define('_OPN_CALL_THE_ERROR_', 'OPN_0003');
					// }
				}
			}
		} else {
			$server = ${$opnConfig['opn_server_vars']};
			if (substr_count($server['REQUEST_URI'], '?') > 0) {
				$decode_url = explode('?', $server['REQUEST_URI']);

				/* nicht gut da ich die ursache nicht sehe */
				/* TODO: Ist nur zur Sicherheit da. falls in den URL params ein &amp; auftauchen sollte,
						 wird dieses in & gewandhelt. Damit urldecode und parse_str richtig funkttionieren. */
				$decode_url[1] = str_replace ('&amp;', '&', $decode_url[1]);

				$opnConfig['opn_'.$opnConfig['encoder']]='';
				parse_str(urldecode($decode_url[1]), $opnConfig['opn_'.$opnConfig['encoder']]);
				foreach($opnConfig['opn_'.$opnConfig['encoder']] as $k=>$v){
					if (!is_array($v)) {
						$request[$k]=rawurldecode($v);
						$get[$k]=rawurldecode($v);
					} else {
						$request[$k]=$v;
						$get[$k]=$v;
					}
				}
			}
		}
	}
	global ${$opnConfig['opn_session_vars']};
	if ( (isset(${$opnConfig['opn_session_vars']})) && is_array(${$opnConfig['opn_session_vars']})) {
		$a = ${$opnConfig['opn_session_vars']};
		foreach ($a as $key=>$value) {
			if (!(substr_count($key,'_OPNLINKNR_') > 0)) {
				global ${$key};
				${$key}=$value;
			}
		}
	}
	if (isset($opnConfig['opnOption']['opnsession'])) {
		$opnConfig['opnOption']['opnsession']->ses_unset_session();
	}
	return '';
}

/**
 * helper function for the emulation of the php trim function for versions <4.1.0
 *
 * @access private
 * @param string $haystack
 * @param string $needle
 * @return string
 **/
function opn_trim_helper($haystack, $needle) {
	$pos = strpos($haystack, $needle);
	while($pos !== false){
		$haystack = substr_replace($haystack, '', 0, strlen($needle));
		$pos = strpos($haystack,$needle);
	}
	return $haystack;
}

/**
 * emulates the php trim function for versions <4.1.0
 *
 * @access public
 * @param string $str
 * @param string $charlist
 * @param string $side
 * @return string
 **/
function opn_trim($str, $charlist, $side='') {
	if (phpversion() >= '4.1.0') {
		switch($side){
			case 'l':
				$str = ltrim($str, $charlist);
				break;
			case 'r':
				$str = rtrim($str, $charlist);
				break;
			default:
				$str = trim($str, $charlist);
				break;
		} // switch
	} else {
		switch($side){
			case 'l':
				$str = opn_trim_helper($str, $charlist);
				break;
			case 'r':
				$str = strrev($str);
				$str = opn_trim_helper($str, $charlist);
				$str = strrev($str);
				break;
			default:
				$str = opn_trim_helper($str, $charlist);
				$str = strrev($str);
				$str = opn_trim_helper($str, $charlist);
				$str = strrev($str);
				break;
		} // switch
	}
	return $str;
}

/**
 * 
 * @param $name
 * @param $plugin
 * @param $optional
 * @return object opn_Object
 */
function &opn_gethandler($name, $plugin, $optional = false ) {

	global $opnConfig;

	static $handlers;

	if (!defined('_OPN_OBJECTMASTER_INCLUDED')) {

		define('_OPN_OBJECTMASTER_INCLUDED',1);
		include _OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/object.php';
		include _OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/sql_statement.php';

	}

	$name = strtolower(trim($name));
	if (!isset($handlers[$name])) {
		$hnd_file = _OPN_ROOT_PATH.$plugin.'/plugin/objects/'.$name.'.php';
		if (file_exists($hnd_file)) {
			require_once $hnd_file;
		} else {
			echo $hnd_file;
		}
		$class = 'opn_'.$name.'_object';
		if (class_exists($class)) {
			$handlers[$name] = & new $class();
		}
	}
	if (!isset($handlers[$name]) && !$optional ) {
		trigger_error('Class <b>'.$class.'</b> does not exist<br />Handler Name: '.$name, E_USER_ERROR);
	}
	if (isset($handlers[$name])) {
		return $handlers[$name];
	}
	return false;
}

function opn_start_engine ($name) {

	global $opnConfig;

	if ($name == 'form_engine') {

		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/form.php');
		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formelement.php');

		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/tableform.php');

		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formbutton.php');
		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formhidden.php');
		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formtextarea.php');
		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formtext.php');

		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formopndate.php');
		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formthemegroup.php');
		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/form_engine/formuserformsetting.php');

	}

	if ($name == 'template') {

		include _OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'engine/template.php';

		$opnConfig['opntpl'] = & new template(_OPN_ROOT_PATH);

	}
}

/**
 * returns the new tag img tag, if the module newtag is installed
 *
 * @access public
 * @param float $objecttime
 * @return string
 **/
function buildnewtag ($objecttime){
	global $opnConfig;

	if($opnConfig['installedPlugins']->isplugininstalled('system/new_tag')){
		include_once(_OPN_ROOT_PATH.'system/new_tag/functions.php');
		$my_new_tag = new_tag_build_tag($objecttime);
	} else {
		$my_new_tag = '';
	}
	return $my_new_tag;
}

/**
	 * set global var $key with value $value
	 * possible type values are:
	 * - url - variable has been submitted via URL
	 * - form - variable has been submitted via web form
	 * - both - variable has been submitted in either one of the above
	 * - server - variable is stored within the server enviroment
	 * - cookie - variable is stored in a cookie
	 * - session - variable is stored within the PHP session
	 * - env - variable is stored within the enviroment
	 * - file - variable has been submitted via web form and is type of uploaded file
	 *
	 * @access public
	 * @param string $key - name of the variable you want to receive
	 * @param mixed $value - return received content into this variable
	 * @param string $type - the type, where the variable could be found
	 * @return void
	 **/
function set_var($key, $value, $type) {
	global $opnConfig, ${$opnConfig['opn_post_vars']},${$opnConfig['opn_get_vars']}, ${$opnConfig['opn_server_vars']}, ${$opnConfig['opn_file_vars']},
		${$opnConfig['opn_cookie_vars']},${$opnConfig['opn_session_vars']},${$opnConfig['opn_request_vars']},${$opnConfig['opn_env_vars']};

	$vars = array();
	switch($type){
		case 'url':
			$vars = ${$opnConfig['opn_get_vars']};
			break;
		case 'form':
			$vars = ${$opnConfig['opn_post_vars']};
			break;
		case 'both':
			$vars = ${$opnConfig['opn_request_vars']};
			break;
		case 'server':
			$vars = ${$opnConfig['opn_server_vars']};
			break;
		case 'cookie':
			$vars = ${$opnConfig['opn_cookie_vars']};
			break;
		case 'session':
			$vars = ${$opnConfig['opn_session_vars']};
			break;
		case 'env':
			$vars = ${$opnConfig['opn_env_vars']};
			break;
		case 'file':
			$vars = ${$opnConfig['opn_file_vars']};
			break;
	} // switch
	$vars[$key] = $value;
	switch($type){
		case 'url':
			${$opnConfig['opn_get_vars']} = $vars;
			break;
		case 'form':
			${$opnConfig['opn_post_vars']} = $vars;
			break;
		case 'both':
			${$opnConfig['opn_request_vars']} = $vars;
			break;
		case 'server':
			${$opnConfig['opn_server_vars']}  = $vars;
			break;
		case 'cookie':
			${$opnConfig['opn_cookie_vars']} = $vars;
			break;
		case 'session':
			${$opnConfig['opn_session_vars']} = $vars;
			break;
		case 'env':
			${$opnConfig['opn_env_vars']} = $vars;
			break;
		case 'file':
			${$opnConfig['opn_file_vars']} = $vars;
			break;
	} // switch
}

/**
	 * unset global var $key
	 * possible type values are:
	 * - url - variable has been submitted via URL
	 * - form - variable has been submitted via web form
	 * - both - variable has been submitted in either one of the above
	 * - server - variable is stored within the server enviroment
	 * - cookie - variable is stored in a cookie
	 * - session - variable is stored within the PHP session
	 * - env - variable is stored within the enviroment
	 * - file - variable has been submitted via web form and is type of uploaded file
	 *
	 * @access public
	 * @param string $key - name of the variable you want to receive
	 * @param string $type - the type, where the variable could be found
	 * @return void
	 **/
function unset_var($key, $type) {
	global $opnConfig, ${$opnConfig['opn_post_vars']},${$opnConfig['opn_get_vars']}, ${$opnConfig['opn_server_vars']}, ${$opnConfig['opn_file_vars']},
		${$opnConfig['opn_cookie_vars']},${$opnConfig['opn_session_vars']},${$opnConfig['opn_request_vars']},${$opnConfig['opn_env_vars']};

	$vars = array();
	switch($type){
		case 'url':
			$vars = ${$opnConfig['opn_get_vars']};
			break;
		case 'form':
			$vars = ${$opnConfig['opn_post_vars']};
			break;
		case 'both':
			$vars = ${$opnConfig['opn_request_vars']};
			break;
		case 'server':
			$vars = ${$opnConfig['opn_server_vars']};
			break;
		case 'cookie':
			$vars = ${$opnConfig['opn_cookie_vars']};
			break;
		case 'session':
			$vars = ${$opnConfig['opn_session_vars']};
			break;
		case 'env':
			$vars = ${$opnConfig['opn_env_vars']};
			break;
		case 'file':
			$vars = ${$opnConfig['opn_file_vars']};
			break;
	} // switch
	unset($vars[$key]);
	switch($type){
		case 'url':
			${$opnConfig['opn_get_vars']} = $vars;
			break;
		case 'form':
			${$opnConfig['opn_post_vars']} = $vars;
			break;
		case 'both':
			${$opnConfig['opn_request_vars']} = $vars;
			break;
		case 'server':
			${$opnConfig['opn_server_vars']}  = $vars;
			break;
		case 'cookie':
			${$opnConfig['opn_cookie_vars']} = $vars;
			break;
		case 'session':
			${$opnConfig['opn_session_vars']} = $vars;
			break;
		case 'env':
			${$opnConfig['opn_env_vars']} = $vars;
			break;
		case 'file':
			${$opnConfig['opn_file_vars']} = $vars;
			break;
	} // switch
}

/**
 * searches for $needle in an array $haystack - returs key on success
 *
 * @access public
 * @param string $needle
 * @param array $needle
 * @return mixed
 **/
function opn_array_search($needle, $haystack) {
	$found = false;
	$max=count($haystack);
	for ($x=0; $x<$max; $x++) {
		if ($haystack[$x] === $needle) {
			$ret = $x;
			$found = true;
			break;
		}
	}
	if ($found) {
		return $ret;
	}
	return false;
}

/**
 * checks if user has the right for sitemap in module $module
 *
 * @access public
 * @param string $module
 * @return bool
 **/
function CheckSitemap($module) {
	global $opnConfig;

	if ($opnConfig['permission']->HasRights($module, array(_PERM_READ,_PERM_BOT), true)) {
		return true;
	}
	return false;
}

/**
 * sets html header refresh
 *
 * @access privat
 * @param string $url
 * @return void
 **/
function opn_reload_Header ($url) {
	global $opnConfig;

	$myurl = 'Refresh: 3; url='.$opnConfig['opn_url'].'/'.$url;
	Header($myurl);
}

function opn_getimagesize ($image) {
	if (substr_count($image,'http://') > 0) {
		include_once (_OPN_ROOT_PATH._OPN_CLASS_SOURCE_PATH.'class.opn_http.php');
		$http = & new http();
		$http->set_timeout(20);
		$status = $http->get($image,false);
		$info[0] = 0;
		$info[1] = 0;
		$info[3] = '';
		if (($status == HTTP_STATUS_OK)) {
			$output = $http->get_response_body();
			$http->disconnect();
			$im = @imagecreatefromstring($output);
			if ($im) {
				$info[0] = imagesx($im);
				$info[1] = imagesy($im);
				$info[3] = 'height ="'.$info[1].'" width="'.$info[0].'"';
				imagedestroy($im);
			}
		}
		unset($http);
		unset($output);
	} else {
		$info = @getimagesize($image);
	}
	return $info;
}

/**
 * Quotes a string for the preg functions
 * 
 * @param $str
 * @return string
 */
function opn_preg_quote ($str) {

	return preg_quote ($str, '#=/');

}
?>