<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* A button
*
* @author		Stefan Kaletta
*
* @package engine
* @subpackage form
*/

class opnFormButton extends opnFormElement {

	/**
	* Value
	* @var string
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_value;

	/**
	* Type	of the button. This	could be either	"button", "submit", or "reset"
	* @var string
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_type;

	/**
	* Constructor
	*
	* @param	string	$caption	Caption
	* @param	string	$name
	* @param	string	$value
	* @param	string	$type		Type of	the	button.
	* This	could be either	"button", "submit", or "reset"
	*/

	function opnFormButton ($caption, $name, $value = '', $type = 'button') {

		$this->setCaption ($caption);
		$this->setName ($name);
		$this->_type = $type;
		$this->setValue ($value);

	}

	/**
	* Get the initial value
	*
	* @return string
	*/

	function getValue () {
		return $this->_value;

	}

	/**
	* Set the initial value
	*
	* @return string
	*/

	function setValue ($value) {

		$this->_value = $value;

	}

	/**
	* Get the type
	*
	* @return string
	*/

	function getType () {
		return $this->_type;

	}

	/**
	* prepare HTML	for	output
	*
	* @return string
	*/

	function render (&$form) {
		// $this->getExtra()
		if ($this->getCaption () != '') {
			$form->AddLabel ($this->getName (), $this->getCaption () );
		} else {
			$form->AddText ('&nbsp;');
		}
		if ($this->getType () == 'submit') {
			$form->AddSubmit ($this->getName (), $this->getValue () );
		}
		if ($this->getType () == 'button') {
			$form->AddButton ($this->getName (), $this->getValue (), $this->getCaption () );
		}
		if ($this->getType () == 'reset') {
			$form->AddReset ($this->getName (), $this->getValue () );
		}

	}

}

?>