<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
*
* select for themegroup field
*
* @package engine
* @subpackage form
*
* @author Stefan Kaletta stefan@kaletta.de
*
*/

class opnFormThemegroup extends opnFormElement {

	/**
	* Initial text
	* @var string
	* @access private
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_value;

	/**
	* Constructor
	*
	* @param	string	$caption	Caption
	* @param	string	$name		"name" attribute
	* @param	string	$value		Initial	text
	*/

	function opnFormThemegroup ($caption, $name, $value = '') {

		$this->setCaption ($caption);
		$this->setName ($name);
		$this->setValue ($value);

	}

	/**
	* Get initial text value
	*
	* @return string
	*/

	function getValue () {
		return $this->_value;

	}

	/**
	* Set initial text	value
	*
	* @param	$value	string
	*/

	function setValue ($value) {

		$this->_value = $value;

	}

	/**
	* Prepare HTML	for	output
	*
	* @return string	HTML
	*/

	function render (&$form) {

		global $opnConfig;

		$options = array ();
		$groups = $opnConfig['theme_groups'];
		foreach ($groups as $group) {
			$options[$group['theme_group_id']] = $group['theme_group_text'];
		}
		$form->AddLabel ($this->getName (), $this->getCaption () );
		$form->AddSelect ($this->getName (), $options, $this->getValue () );

	}

}

?>