<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
*
* A user formular setting line
*
* @package	 engine
* @subpackage  form
*
* @author		Stefan Kaletta	stefan@kaletta.de
*
*/

class opnFormUserFormSetting extends opnFormElement {

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_ui = array ();

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $_savelink = '';

	/**
	* Constuctor
	*
	* @param	array  $ui	user info array
	*/

	function opnFormUserFormSetting ($ui, $savelink) {

		$this->_ui = $ui;
		$this->_savelink = $savelink;

	}

	/**
	* prepare HTML for output
	*
	* @return	sting HTML
	*/

	function render (&$form) {

		global $opnConfig;

		$opnConfig['permission']->LoadUserSettings (__USER_CONFIG__);
		$options = false;
		if ($options === false) {
			$options = array ();
			$options[_OOBJ_DTYPE_HTML] = true;
			$options[_OOBJ_DTYPE_BBCODE] = true;
			$options[_OOBJ_DTYPE_CBR] = true;
			$options[_OOBJ_DTYPE_SMILE] = true;
			$options[_OOBJ_DTYPE_UIMAGES] = true;
			$options[_OOBJ_DTYPE_SIG] = true;
		}
		$form->SetSameCol ();
		$form->AddText ('&nbsp;');
		$form->SetEndCol ();
		$form->SetSameCol ();
		$options[_OOBJ_DTYPE_HTML] = $opnConfig['permission']->GetUserSetting (_USER_CONFIG_FORM_HTML_, __USER_CONFIG__, 0);
		$options[_OOBJ_DTYPE_SMILE] = $opnConfig['permission']->GetUserSetting (_USER_CONFIG_FORM_SMILE_, __USER_CONFIG__, 0);
		$options[_OOBJ_DTYPE_UIMAGES] = $opnConfig['permission']->GetUserSetting (_USER_CONFIG_FORM_UIMAGES_, __USER_CONFIG__, 0);
		$form->AddHidden ('opnformuserformsetting_use_save', 'opn');
		$form->AddLabel (_USER_CONFIG_FORM_HTML_, _OPN_ENGINE_FORM_USE_HTML);
		$form->AddCheckbox (_USER_CONFIG_FORM_HTML_, 1, $options[_OOBJ_DTYPE_HTML]);
		$form->AddNewline (1);
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
			$form->AddLabel (_USER_CONFIG_FORM_SMILE_, _OPN_ENGINE_FORM_USE_SMILIES);
			$form->AddCheckbox (_USER_CONFIG_FORM_SMILE_, 1, $options[_OOBJ_DTYPE_SMILE]);
			$form->AddNewline (1);
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			$form->AddLabel (_USER_CONFIG_FORM_UIMAGES_, _OPN_ENGINE_FORM_USE_UIMAGES);
			$form->AddCheckbox (_USER_CONFIG_FORM_UIMAGES_, 1, $options[_OOBJ_DTYPE_UIMAGES]);
			$form->AddNewline (1);
		}
		$form->SetEndCol ();

	}

}

?>