<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* a sql_statement class for a database	query.
*
* @author		Stefan Kaletta
*
*/

class sql_statement_element {

	/**
	* Sort	order
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $order = 'ASC';

	/**
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $sort = '';

	/**
	* Number of records to	retrieve
	* @var int
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $limit = 0;

	/**
	* Offset of first record
	* @var int
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $start = 0;

	/**
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $groupby = '';

	/**
	* Constructor
	**/

	function sql_statement_element () {

	}

	/**
	* Render the sql_statement_ element
	*/

	function render () {

	}

	/**
	* Accessor
	* @param	string	$sort
	*/

	function setSort ($sort) {

		$this->sort = $sort;

	}

	/**
	* @return string
	*/

	function getSort () {
		return $this->sort;

	}

	/**
	* @param	string	$order
	*/

	function setOrder ($order) {
		if ('DESC' == strtoupper ($order) ) {
			$this->order = 'DESC';
		}

	}

	/**
	* @return string
	*/

	function getOrder () {
		return $this->order;

	}

	/**
	* @param	int	$limit
	*/

	function setLimit ($limit = 0) {

		$this->limit = intval ($limit);

	}

	/**
	* @return	int
	*/

	function getLimit () {
		return $this->limit;

	}

	/**
	* @param	int	$start
	*/

	function setStart ($start = 0) {

		$this->start = intval ($start);

	}

	/**
	* @return	int
	*/

	function getStart () {
		return $this->start;

	}

	/**
	* @param	string	$group
	*/

	function setGroupby ($group) {

		$this->groupby = $group;

	}

	/**
	* @return string
	*/

	function getGroupby () {
		return ' GROUP BY ' . $this->groupby;

	}

}

/**
* Collection of multiple {@link sql_statement_element}s
*
* @author		Stefan Kaletta
*
*/

class sql_statement_compo extends sql_statement_element {

	/**
	* The elements	of the collection
	* @var array	Array of {@link	sql_statement_element} objects
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $sql_statement_elements = array ();

	/**
	* Conditions
	* @var array
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $conditions = array ();

	/**
	* Constructor
	*
	* @param	object	$ele
	* @param	string	$condition
	**/

	function sql_statement_compo ($ele = null, $condition = 'AND') {
		if (isset ($ele) && is_object ($ele) ) {
			$this->add ($ele, $condition);
		}

	}

	/**
	* Add an element
	*
	* @param	object	&$sql_statement_element
	* @param	string	$condition
	*
	* @return	object	reference to this collection
	**/

	function &add (&$sql_statement_element, $condition = 'AND') {

		$this->sql_statement_elements[] = &$sql_statement_element;
		$this->conditions[] = $condition;
		return $this;

	}

	/**
	* Make	the	sql_statement into a query string
	*
	* @return string
	*/

	function render () {

		$ret = '';
		$count = count ($this->sql_statement_elements);
		if ($count>0) {
			$ret = '(' . $this->sql_statement_elements[0]->render ();
			for ($i = 1; $i< $count; $i++) {
				$ret .= ' ' . $this->conditions[$i] . '	' . $this->sql_statement_elements[$i]->render ();
			}
			$ret .= ')';
		}
		return $ret;

	}

	/**
	* Make	the	sql_statement into a SQL "WHERE" clause
	*
	* @return string
	*/

	function renderWhere () {

		$ret = $this->render ();
		$ret = ($ret != '')?'WHERE ' . $ret : $ret;
		return $ret;

	}

}

/**
* a single	sql_statement
*
* @author		Stefan Kaletta
*
*/

class sql_statement extends sql_statement_element {

	/**
	* @var string
	*/

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $prefix;

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $function;

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $column;

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $operator;

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $value;

	/**
	* Constructor
	*
	* @param	string	$column
	* @param	string	$value
	* @param	string	$operator
	**/

	function sql_statement ($column, $value = '', $operator = '=', $prefix = '', $function = '') {

		$this->prefix = $prefix;
		$this->function = $function;
		$this->column = $column;
		$this->value = $value;
		$this->operator = $operator;

	}

	/**
	* Make	a sql condition	string
	*
	* @return string
	**/

	function render () {
		if (is_numeric ($this->value) || strtoupper ($this->operator) == 'IN') {
			$value = $this->value;
		} else {
			if ('' === ($value = trim ($this->value) ) ) {
				return '';
			}
			if ( (substr ($value, 0, 1) != '`') && (substr ($value, -1) != '`') ) {
				$value = "' $value'";
			}
		}
		if (!empty ($this->prefix) ) {
			$clause = $this->prefix . '.' . $this->column;
		} else {
			$clause = $this->column;
		}
		if (!empty ($this->function) ) {
			$clause = sprintf ($this->function, $clause);
		}
		$clause .= ' ' . $this->operator . ' ' . $value;
		return $clause;

	}

	/**
	* Make	a SQL "WHERE" clause
	*
	* @return string
	*/

	function renderWhere () {

		$cond = $this->render ();
		return empty ($cond)?'' : 'WHERE ' . $cond;

	}

}

?>