<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

class template {

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $base_path = '.';

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $reset_vars = TRUE;
	// Delimeters for regular tags

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $ldelim = '{';

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $rdelim = ' /}';
	// Delimeters for beginnings of loops

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $BAldelim = '{';

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $BArdelim = '}';
	// Delimeters for ends of loops

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $EAldelim = '{/';

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $EArdelim = '}';
	// Internal variables

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $scalars = array ();

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $arrays = array ();

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $carrays = array ();

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $ifs = array ();

	/*<{4php5}>var !!public <{4php5/}>*//*<{delete}>*/var /*<{delete/}>*/ $cachefile = '';

	function template ($base_path = NULL, $reset_vars = TRUE) {
		if ($base_path) {
			$this->base_path = $base_path;
		}
		$this->reset_vars = $reset_vars;
		$base_path = str_replace (_OPN_ROOT_PATH, '', $base_path);
		$this->cachefile = str_replace ('/', '_', $base_path);

	}

	/*
	Method: set()
	Sets all types of variables (scalar, loop, hash).
	*/

	function set ($tag, $var, $if = NULL) {
		if (is_array ($var) ) {
			$this->arrays[$tag] = $var;
			if ($if) {
				$result = $var?TRUE : FALSE;
				$this->ifs[] = $tag;
				$this->scalars[$tag] = $result;
			}
		} else {
			$this->scalars[$tag] = $var;
			if ($if) {
				$this->ifs[] = $tag;
			}
		}

	}

	function assign ($keys) {
		if (is_array ($keys) ) {
			foreach ($keys as $key => $value) {
				$this->set ('[' . $key . ']', $value);
			}
		}

	}

	/*
	Method: set_cloop()
	Sets a cloop (case loop).
	*/

	function set_cloop ($tag, $array, $cases) {

		$keys = array_keys ($array);
		foreach ($keys as $key) {
			if (substr_count ($array[$key]['topic'], '%alternate%')>0) {
				$array[$key]['topic'] = str_replace ('%alternate%', 'alternator' . $array[$key]['alternator'], $array[$key]['topic']);
			}
		}
		$this->carrays[$tag] = array ('array' => $array,
						'cases' => $cases);

	}

	/*
	Method: reset_vars()
	Resets the template variables.
	*/

	function reset_vars ($scalars, $arrays, $carrays, $ifs) {
		if ($scalars) {
			$this->scalars = array ();
		}
		if ($arrays) {
			$this->arrays = array ();
		}
		if ($carrays) {
			$this->carrays = array ();
		}
		if ($ifs) {
			$this->ifs = array ();
		}

	}

	/*
	Method: get_tags()
	Formats the tags & returns a two-element array.
	*/

	function get_tags ($tag, $directive) {

		$tags['b'] = $this->BAldelim . $directive . $tag . $this->BArdelim;
		$tags['e'] = $this->EAldelim . $directive . $tag . $this->EArdelim;
		return $tags;

	}

	/*
	Method: get_tag()
	Formats a tag for a scalar.
	*/

	function get_tag ($tag) {
		return $this->ldelim . 'tag:' . $tag . $this->rdelim;

	}

	/*
	Method: get_statement()
	Extracts a portion of a template.
	*/

	function get_statement ($t, &$contents) {
		// Locate the statement
		$tag_length = strlen ($t['b']);
		$fpos = strpos ($contents, $t['b'])+ $tag_length;
		$lpos = strpos ($contents, $t['e']);
		$length = $lpos- $fpos;
		// Extract & return the statement
		return substr ($contents, $fpos, $length);

	}

	/*
	Method: parse()
	Parses all variables into the template.
	*/

	function parse ($contents) {
		// Process the ifs
		if (!empty ($this->ifs) ) {
			foreach ($this->ifs as $value) {
				$contents = $this->parse_if ($value, $contents);
			}
		}
		// Process the scalars
		foreach ($this->scalars as $key => $value) {
			$contents = str_replace ($this->get_tag ($key), $value, $contents);
		}
		// Process the arrays
		foreach ($this->arrays as $key => $array) {
			$contents = $this->parse_loop ($key, $array, $contents);
		}
		// Process the carrays
		foreach ($this->carrays as $key => $array) {
			$contents = $this->parse_cloop ($key, $array, $contents);
		}
		// Reset the arrays
		if ($this->reset_vars) {
			$this->reset_vars (FALSE, TRUE, TRUE, FALSE);
		}
		// Return the contents
		return $contents;

	}

	/*
	Method: parse_if ()
	Parses a simple if statement.
	*/

	function parse_if ($tag, $contents) {
		// Get the tags
		$t = $this->get_tags ($tag, 'if:');
		// Get the entire statement
		$entire_statement = $this->get_statement ($t, $contents);
		// Get the else tag
		$tags['b'] = NULL;
		$tags['e'] = $this->BAldelim . 'else:' . $tag . $this->BArdelim;
		// See if there's an else statement
		if ( ($else = strpos ($entire_statement, $tags['e']) ) ) {
			// Get the if statement
			$if = $this->get_statement ($tags, $entire_statement);
			// Get the else statement
			$else = substr ($entire_statement, $else+strlen ($tags['e']) );
		} else {
			$else = NULL;
			$if = $entire_statement;
		}
		// Process the if statement
		$this->scalars[$tag]? $replace = $if : $replace = $else;
		// Parse & return the template
		return str_replace ($t['b'] . $entire_statement . $t['e'], $replace, $contents);

	}

	/*
	Method: parse_loop()
	Parses a loop (recursive function).
	*/

	function parse_loop ($tag, $array, $contents) {
		// Get the tags & loop
		$t = $this->get_tags ($tag, 'loop:');
		$loop = $this->get_statement ($t, $contents);
		$parsed = NULL;
		// Process the loop
		foreach ($array as $key => $value) {
			if (is_numeric ($key) && is_array ($value) ) {
				$i = $loop;
				foreach ($value as $key2 => $value2) {
					if (!is_array ($value2) ) {
						// Replace associative array tags
						$i = str_replace ($this->get_tag ($tag . '[].' . $key2), $value2, $i);
					} else {
						// Check to see if it's a nested loop
						$i = $this->parse_loop ($tag . '[].' . $key2, $value2, $i);
					}
				}
			} elseif (is_string ($key) && !is_array ($value) ) {
				$contents = str_replace ($this->get_tag ($tag . '.' . $key), $value, $contents);
			} elseif (!is_array ($value) ) {
				$i = str_replace ($this->get_tag ($tag . '[]'), $value, $loop);
			}
			// Add the parsed iteration
			if (isset ($i) ) {
				$parsed .= rtrim ($i);
			}
		}
		// Parse & return the final loop
		return str_replace ($t['b'] . $loop . $t['e'], $parsed, $contents);

	}

	/*
	Method: parse_cloop()
	Parses a cloop (case loop) (recursive function -i love it-).
	*/

	function parse_cloop ($tag, $array, $contents) {
		// Get the tags & loop
		$t = $this->get_tags ($tag, 'cloop:');
		$loop = $this->get_statement ($t, $contents);
		// Set up the cases
		$array['cases'][] = 'default';
		$case_content = array ();
		$parsed = NULL;
		// Get the case strings
		foreach ($array['cases'] as $case) {
			$ctags[$case] = $this->get_tags ($case, 'case:');
			$case_content[$case] = $this->get_statement ($ctags[$case], $loop);
		}
		// Process the loop
		foreach ($array['array'] as $key => $value) {
			if (is_numeric ($key) && is_array ($value) ) {
				// Set up the cases
				if (isset ($value['case']) ) {
					$current_case = $value['case'];
				} else {
					$current_case = 'default';
				}
				unset ($value['case']);
				$i = $case_content[$current_case];
				// Loop through each value
				foreach ($value as $key2 => $value2) {
					if (is_array ($value2) ) {
						$i = $this->parse_loop ($tag . '[].' . $key2, $value2, $i);
					} else {
						$i = str_replace ($this->get_tag ($tag . '[].' . $key2), $value2, $i);
					}
				}
			}
			// Add the parsed iteration
			$parsed .= rtrim ($i);
		}
		// Parse & return the final loop
		return str_replace ($t['b'] . $loop . $t['e'], $parsed, $contents);

	}

	/*
	Method: fetch()
	Returns the parsed contents of the specified template.
	*/

	function fetch ($filename, $module) {

		global $opnConfig, $opnTables;

		$result = &$opnConfig['database']->Execute ('SELECT source FROM ' . $opnTables['customizer_opn_tplsource'] . ' WHERE (filename=\'' . $filename . '\') AND (module =\'' . $module . '\')');
		if ( (is_object ($result) ) && (isset ($result->fields['source']) ) ) {
			$source = $result->fields['source'];
			$result->Close ();
		} else {
			include_once (_OPN_ROOT_PATH . 'admin/customizer/api/compile_template.php');
			$file = _OPN_ROOT_PATH . $module . '/plugin/templates/_otp_' . $filename . '.php';
			// Open the file
			$fp = fopen ($file, 'rb');
			if (!$fp) {
				return FALSE;
			}
			// Read the file
			$source = fread ($fp, filesize ($file) );
			// Close the file
			fclose ($fp);
			compile_template ($source);
		}
		// Parse and return the contents
		$content = $this->parse ($source);
		ob_start ();
		eval (' ?>' . $content . '<?php ');
		$content = ob_get_contents ();
		ob_end_clean ();
		return $content;

	}

	function cache ($cachefile) {

		global $opnConfig;

		clearstatcache ();
		$cachefile = $opnConfig['root_path_datasave'] . 'opncache.' . $cachefile . '.php';
		if (file_exists ($cachefile) ) {
			if ( (time ()-filemtime ($cachefile) ) >= 60) {
				return false;
			}
			if ($f = fopen ($cachefile, 'r') ) {
				$content = fread ($f, filesize ($cachefile) );
				fclose ($f);
				return $content;
			}
		}
		return false;

	}

	function update ($cachefile, $content) {

		global $opnConfig;

		$cachefile = $opnConfig['root_path_datasave'] . 'opncache.' . $cachefile . '.php';
		echo $cachefile;
		if ($w = fopen ($cachefile, 'w') ) {
			fwrite ($w, $content);
			fclose ($w);
		} else {
			echo 'Unable to open the cachefile for writing';
		}

	}

}

?>