<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_OPN_MAIL_POP_INCLUDED') ) {
	define ('_OPN_CLASS_OPN_MAIL_POP_INCLUDED', 1);

	class opn_mail_pop {
		var $_data = array ('phelo' => '',
				'decode' => '',
				'error' => '',
				'warn' => '',
				'update' => 0,
				'debug' => 0,
				'port' => 110);

		/*
		*	 clean the last error
		*/

		function clear_error () {

			$this->_insert ('error', '');

		}

		/*
		*	 class input
		*/

		function _insert ($k, $v) {

			$this->_data[strtolower ($k)] = $v;

		}

		/*
		*	 class output
		*/

		function property ($p = null) {
			if ($p == null) {
				return $this->_data;
			}
			return $this->_data[strtolower ($p)];

		}
		var $hostname = '';
		var $quit_handshake = 0;
		var $state = 'DISCONNECTED';
		var $next_token = '';
		var $connection = 0;

		function Tag (&$txt, $content, $separtor) {

			$separtor = $separtor . ']';
			$taglen = strlen ('[' . $separtor);
			$start = strpos ($content, '[' . $separtor)+ $taglen;
			$ende = strpos ($content, '[/' . $separtor);
			$txt = substr ($content, $start, $ende- $start);

		}

		function Splitter ($string, $separator = '') {
			if (!strcmp ($separator, '') ) {
				$separator = $string;
				$string = $this->next_token;
			}
			$found = null;
			$seplen = strlen ($separator);
			for ($character = 0; $character<$seplen; $character++) {
				if (gettype ($position = strpos ($string, $separator[$character]) ) == 'integer') {
					$found = (!is_null ($found)?min ($found, $position) : $position);
				}
			}
			if (!is_null ($found) ) {
				$this->next_token = substr ($string, $found+1);
				return (substr ($string, 0, $found) );
			}
			$this->next_token = '';
			return ($string);

		}

		function DebugEcho ($message) {

			echo $message . _OPN_HTML_NL;
			$this->_insert ('warn', $message);

		}

		function GetData () {

			for ($line = '';; ) {
				if (feof ($this->connection) ) {
					return (0);
				}
				$line .= fgets ($this->connection, 100);
				$length = strlen ($line);
				if ( ($length >= 2) && (substr ($line, $length-2, 2) == _OPN_HTML_CRLF) ) {
					$line = substr ($line, 0, $length-2);
					if ($this->property ('debug') ) {
						$this->DebugEcho ('< ' . $line);
					}
					return $line;
				}
			}
			return '';

		}

		function SendData ($line) {
			if ($this->property ('debug') ) {
				$this->DebugEcho ('> ' . $line);
			}
			return (fputs ($this->connection, $line . _OPN_HTML_CRLF) );

		}

		function OpenConnection () {
			if ($this->hostname == '') {
				return ('2 it was not specified a valid hostname');
			}
			if ($this->property ('debug') ) {
				$this->DebugEcho ('Connecting to ' . $this->hostname . ' ...');
			}
			$error = '';
			if ( ($this->connection = fsockopen ($this->hostname, $this->property ('port'), $error) ) == 0) {
				switch ($error) {
					case -3:
						return ('-3 socket could not be created');
					case -4:
						return ('-4 dns lookup on hostname "' . $this->hostname . '" failed');
					case -5:
						return ('-5 connection refused or timed out');
					case -6:
						return ('-6 fdopen() call failed');
					case -7:
						return ('-7 setvbuf() call failed');
					default:
						return ($error . ' could not connect to the host "' . $this->hostname . '"');
					}
				}
				return '';

		}

		function CloseConnection () {
			if ($this->property ('debug') ) {
				$this->DebugEcho ('Closing connection.');
			}
			if ($this->connection != 0) {
				fclose ($this->connection);
				$this->connection = 0;
			}

		}

		function Open () {
			if ($this->state != 'DISCONNECTED') {
				return ('1 a connection is already opened');
			}
			if ( ($error = $this->OpenConnection () ) != '') {
				return ($error);
			}
			$this->_insert ('phelo', $this->GetData () );
			if (gettype ($this->property ('phelo') ) != 'string' || $this->Splitter ($this->property ('phelo'), ' ') != '+OK') {
				$this->CloseConnection ();
				return ('3 POP3 server phelo was not found');
			}
			$this->Splitter ('<');
			$this->_insert ('update', 0);
			$this->state = 'AUTHORIZATION';
			return '';

		}

		function Close () {
			if ($this->state == 'DISCONNECTED') {
				return ('no connection was opened');
			}
			if ($this->property ('update') || $this->quit_handshake) {
				if ($this->SendData ('QUIT') == 0) {
					return ('Could not send the QUIT command');
				}
				$popresult = $this->GetData ();
				if (gettype ($popresult) != 'string') {
					return ('Could not get quit command response');
				}
				if ($this->Splitter ($popresult, ' ') != '+OK') {
					return ('Could not quit the connection: ' . $this->Splitter (_OPN_HTML_CRLF) );
				}
			}
			$this->CloseConnection ();
			$this->state = 'DISCONNECTED';
			return '';

		}

		function Login ($user, $password, $apop) {
			if ($this->state != 'AUTHORIZATION') {
				return ('connection is not in AUTHORIZATION state');
			}
			if (!$apop) {
				if ($this->SendData ('USER ' . $user) == 0) {
					return ('Could not send the USER command');
				}
				$popresult = $this->GetData ();
				if (gettype ($popresult) != 'string') {
					return ('Could not get user login entry response');
				}
				if ($this->Splitter ($popresult, ' ') != '+OK') {
					return ('User error: ' . $this->Splitter (_OPN_HTML_CRLF) );
				}
				if ($this->SendData ('PASS ' . $password) == 0) {
					return ('Could not send the PASS command');
				}
				$popresult = $this->GetData ();
				if (gettype ($popresult) != 'string') {
					return ('Could not get login password entry response');
				}
				if ($this->Splitter ($popresult, ' ') != '+OK') {
					return ('Password error: ' . $this->Splitter (_OPN_HTML_CRLF) );
				}
			} else {
				if (!strcmp ($this->property ('phelo'), '') ) {
					return ('Server does not seem to support APOP authentication');
				}
				if ($this->SendData ('APOP ' . $user . ' ' . md5 ('<' . $this->property ('phelo') . '>' . $password) ) == 0) {
					return ('Could not send the APOP command');
				}
				$popresult = $this->GetData ();
				if (gettype ($popresult) != 'string') {
					return ('Could not get APOP login command response');
				}
				if ($this->Splitter ($popresult, ' ') != '+OK') {
					return ('APOP login failed: ' . $this->Splitter (_OPN_HTML_CRLF) );
				}
			}
			$this->state = 'TRANSACTION';
			return '';

		}

		function RetrieveMessage ($message, &$headers, &$body, $lines) {
			if ($this->state != 'TRANSACTION') {
				return ('connection is not in TRANSACTION state');
			}
			if ($lines<0) {
				$command = 'RETR';
				$arguments = $message;
			} else {
				$command = 'TOP';
				$arguments = $message . ' ' . $lines;
			}
			if ($this->SendData ($command . ' ' . $arguments) == 0) {
				return ('Could not send the ' . $command . ' command');
			}
			$popresult = $this->GetData ();
			if (gettype ($popresult) != 'string') {
				return ('Could not get message retrieval command response');
			}
			if ($this->Splitter ($popresult, ' ') != '+OK') {
				return ('Could not retrieve the message: ' . $this->Splitter (_OPN_HTML_CRLF) );
			}
			for ($headers = $body = array (),
							$line = 0;; $line++) {
				$popresult = $this->GetData ();
				if (gettype ($popresult) != 'string') {
					return ('Could not retrieve the message');
				}
				switch ($popresult) {
					case '.':
						return '';
					case '':
						break 2;
					default:
						if (substr ($popresult, 0, 1) == '.') {
							$popresult = substr ($popresult, 1, strlen ($popresult)-1);
						}
						break;
				}
				$headers[$line] = $popresult;
			}
			for ($line = 0;; $line++) {
				$popresult = $this->GetData ();
				if (gettype ($popresult) != 'string') {
					return ('Could not retrieve the message');
				}
				switch ($popresult) {
					case '.':
						return '';
					default:
						if (substr ($popresult, 0, 1) == '.') {
							$popresult = substr ($popresult, 1, strlen ($popresult)-1);
						}
						break;
				}
				$body[$line] = $popresult;
			}
			return '';

		}

		/*
		$header_array['head'] = the whole mails header in one string
		$header_array['from'] = the complete sender ('OPN Team' <info@openphpnuke.info>)
		$header_array['from_name'] = the senders Name ('OPN Team')
		$header_array['from_addr'] = the sender mailaddr (test@test.de)
		$header_array['cc'] = the complete Cc ('CC' <cc-info@openphpnuke.info>)
		$header_array['to'] = the complete Recipient-Line ('OPN Team' <info@openphpnuke.info>)
		$header_array['date'] = the time the mail was sent
		$header_array['subject'] = the mails subject
		$header_array['anh'] = are there attachements? (0 | 1)
		*/

		function SplitHeader ($headers, &$header_array) {

			$header_array['head'] = '';
			$header_array['from'] = '';
			$header_array['from_name'] = '';
			$header_array['from_addr'] = '';
			$header_array['cc'] = '';
			$header_array['to'] = '';
			$header_array['date'] = '';
			$header_array['subject'] = '';
			$header_array['anh'] = 0;
			$i = 0;
			$n_headers = array ();
			foreach ($headers as $value) {
				$z1 = substr ($value, 0, 1);
				if ($z1 == "\t") {
					$n_headers[$i] .= " " . trim ($value);
				} else {
					$i = $i+1;
					$n_headers[$i] = trim ($value);
				}
			}
			$headers = $n_headers;
			$header_array['head'] = join ($headers, "\n");
			$subj = preg_grep ("/^Subject: (.*)$/", $headers);
			$subj = join ($subj, "\n");
			$header_array['subject'] = trim ($this->decode_mime_string (quoted_printable_decode (str_replace ("\"", "'", (str_replace ('Subject: ', '', $subj) ) ) ) ) );
			$to = preg_grep ("/^To: (.*)$/", $headers);
			$to = join ($to, "\n");
			$header_array['to'] = trim ($this->decode_mime_string (str_replace ("\"", "'", (str_replace ('To: ', '', $to) ) ) ) );
			$cc = preg_grep ("/^Cc: (.*)$/", $headers);
			$cc = join ($cc, "\n");
			$header_array['cc'] = trim ($this->decode_mime_string (str_replace ("\"", "'", (str_replace ('Cc: ', '', $cc) ) ) ) );
			$from = preg_grep ("/^From: (.*)$/", $headers);
			$from = join ($from, "\n");
			$from_org = str_replace ('From: ', '', $from);
			$header_array['from'] = $from_org;
			$from23 = str_replace ('<', '', $header_array['from']);
			$from23 = str_replace ('>', '', $from23);
			$from2 = preg_split ("/[\s,]+/", $from23);
			$countfrom2 = count ($from2);
			for ($z = 0; $z<$countfrom2; $z++) {
				if (preg_match ("/(\S*)@(\S*)/", $from2[$z]) ) {
					$header_array['from_addr'] = trim ($this->decode_mime_string ($from2[$z]) );
				} else {
					$header_array['from_name'] .= trim ($this->decode_mime_string ($from2[$z]) ) . " ";
				}
			}
			$header_array['from_name'] = trim ($header_array['from_name']);
			$header_array['from'] = trim ($this->decode_mime_string ($from_org) );
			$date = preg_grep ("/^Date: (.*)$/", $headers);
			$date = join ($date, "\n");
			$header_array['date'] = trim ($this->decode_mime_string (str_replace ('Date: ', '', $date) ) );
			$headers = join ($headers, "\n");
			if (eregi ("Content-Type: multipart", $headers) ) {
				$header_array['anh'] = 1;
			} else {
				$header_array['anh'] = 0;
			}

		}

		function decode_mime_string ($string, $headers = '') {

			$this->_insert ('decode', 'none');
			if (eregi ("=\?([A-Z,0-9,-]+)?([A-Z,0-9,-]+)?([A-Z,0-9,-,=,_]+)\?=", $string) ) {
				$this->_insert ('decode', '');
				// if (ereg("^=?", $string)) $string = ' ' . $string;
				$string = str_replace ('=?', ' =?', $string);
				$string = str_replace ('  =?', ' =?', $string);
				if ( (substr_count ($string, 'Content-Transfer-Encoding:')>0) && (substr_count ($string, 'base64')>0) ) {
					$coded_strings = explode ('----=', $string);
					$coded_strings[1] = str_replace ('-', '', $coded_strings[1]);
					$coded_strings[1] = str_replace ('=', '', $coded_strings[1]);
					$cstring = explode ('base64', $coded_strings[1]);
					$this->_insert ('decode', 'base64');
					return base64_decode ($cstring[1]);
				}
				if ( (substr_count ($string, 'Content-Transfer-Encoding:')>0) && (substr_count ($string, 'quoted-printable')>0) ) {
					$coded_strings = explode ('----=', $string);
					$coded_strings[1] = str_replace ('-', '', $coded_strings[1]);
					$coded_strings[1] = str_replace ('=', '', $coded_strings[1]);
					$cstring = explode ('quoted-printable', $coded_strings[1]);
					$this->_insert ('decode', 'quoted-printable');
					return quoted_printable_decode ($cstring[1]);
				}
				$coded_strings = explode (' =?', $string);
				$counter = 1;
				$string = $coded_strings[0];

				/* add non encoded text that is before the encoding */

				while ($counter<sizeof ($coded_strings) ) {
					$elements = explode ('?', $coded_strings[$counter]);

					/* part 0 = charset */

					/* part 1 == encoding */

					/* part 2 == encoded part */

					/* part 3 == unencoded part beginning with a = */

					/* How can we use the charset information? */
					// Keine ahnung wieso aber so sheint es den fehler zu umgehen
					if ( (!isset ($elements[1]) ) && (!isset ($elements[2]) ) ) {
						return $string;
					}
					if (!isset ($elements[1]) ) {
						opnErrorHandler (E_WARNING, 'Debug', 'Debug: elements1 : ' . $string . ' : <br />', print_array ($elements) );
					}
					if (!isset ($elements[2]) ) {
						opnErrorHandler (E_WARNING, 'Debug', 'Debug: elements2 : ' . $string . ' : <br />', print_array ($elements) );
					}
					if (eregi ("Q", $elements[1]) ) {
						$elements[2] = str_replace ('_', ' ', $elements[2]);
						$elements[2] = eregi_replace ("=([A-F,0-9]{2})", "%\\1", $elements[2]);
						$string .= urldecode ($elements[2]);
					} else {

						/* we should check for B the only valid encoding other then Q */

						$elements[2] = str_replace ('=', '', $elements[2]);
						if ($elements[2]) {
							$string .= base64_decode ($elements[2]);
						}
					}
					if (isset ($elements[3]) && $elements[3] != '') {
						$elements[3] = ereg_replace ("^=", '', $elements[3]);
						$string .= $elements[3];
					}
					$counter++;
				}
			}
			if (substr_count ($string, 'Content-Transfer-Encoding:')>0) {
				if (substr_count ($string, 'base64')>0) {
					// $coded_strings = explode('base64', $string);
					// $string = base64_decode ($coded_strings[0]);
				}
			}
			if ( ($this->property ('decode') == 'none') && is_array ($headers) ) {
				$myheaders = array ();
				foreach ($headers as $header) {
					$temp = explode (':', $header);
					if (isset ($temp[0]) && isset ($temp[1]) ) {
						$myheaders[$temp[0]] = trim ($temp[1]);
					}
				}
				if (isset ($myheaders['Content-Transfer-Encoding']) ) {
					$this->_insert ('decode', $myheaders['Content-Transfer-Encoding']);
				}
			}
			if ($this->property ('decode') == '') {
				return $string;
			}
			if ($this->property ('decode') == 'base64') {
				return base64_decode ($string);
			}
			if ($this->property ('decode') == 'quoted-printbale') {
				return quoted_printable_decode ($string);
			}
			return $string;

		}

		function ResetDeletedMessages () {
			if ($this->state != 'TRANSACTION') {
				return ('connection is not in TRANSACTION state');
			}
			if ($this->SendData ('RSET') == 0) {
				return ('Could not send the RSET command');
			}
			$popresult = $this->GetData ();
			if (gettype ($popresult) != 'string') {
				return ('Could not get reset deleted messages command response');
			}
			if ($this->Splitter ($popresult, ' ') != '+OK') {
				return ('Could not reset deleted messages: ' . $this->Splitter (_OPN_HTML_CRLF) );
			}
			$this->_insert ('update', 0);
			return '';

		}

		function Statistics (&$messages, &$size) {
			if ($this->state != 'TRANSACTION') {
				return ('connection is not in TRANSACTION state');
			}
			if ($this->SendData ('STAT') == 0) {
				return ('Could not send the STAT command');
			}
			$popresult = $this->GetData ();
			if (gettype ($popresult) != 'string') {
				return ('Could not get the statistics command response');
			}
			if ($this->Splitter ($popresult, ' ') != '+OK') {
				return ('Could not get the statistics: ' . $this->Splitter (_OPN_HTML_CRLF) );
			}
			$messages = $this->Splitter (' ');
			$size = $this->Splitter (' ');
			return '';

		}

		function IssueNOOP () {
			if ($this->state != 'TRANSACTION') {
				return ('connection is not in TRANSACTION state');
			}
			if ($this->SendData ('NOOP') == 0) {
				return ('Could not send the NOOP command');
			}
			$popresult = $this->GetData ();
			if (gettype ($popresult) != 'string') {
				return ('Could not NOOP command response');
			}
			if ($this->Splitter ($popresult, ' ') != '+OK') {
				return ('Could not issue the NOOP command: ' . $this->Splitter (_OPN_HTML_CRLF) );
			}
			return '';

		}

		function DeleteMessage ($message) {
			if ($this->state != 'TRANSACTION') {
				return ('connection is not in TRANSACTION state');
			}
			if ($this->SendData ('DELE ' . $message) == 0) {
				return ('Could not send the DELE command');
			}
			$popresult = $this->GetData ();
			if (gettype ($popresult) != 'string') {
				return ('Could not get message delete command response');
			}
			if ($this->Splitter ($popresult, ' ') != '+OK') {
				return ('Could not delete the message: ' . $this->Splitter (_OPN_HTML_CRLF) );
			}
			$this->_insert ('update', 1);
			return '';

		}

		function ListMessages ($message, $unique_id) {
			if ($this->state != 'TRANSACTION') {
				return ('connection is not in TRANSACTION state');
			}
			if ($unique_id) {
				$list_command = 'UIDL';
			} else {
				$list_command = 'LIST';
			}
			if ($this->SendData ($list_command . ' ' . $message) == 0) {
				return ('Could not send the ' . $list_command . ' command');
			}
			$popresult = $this->GetData ();
			if (gettype ($popresult) != 'string') {
				return ('Could not get message list command response');
			}
			if ($this->Splitter ($popresult, ' ') != '+OK') {
				return ('Could not get the message listing: ' . $this->Splitter (_OPN_HTML_CRLF) );
			}
			if ($message == '') {
				$messages = array ();
				for ($messages;; ) {
					$popresult = $this->GetData ();
					if (gettype ($popresult) != 'string') {
						return ('Could not get message list response');
					}
					if ($popresult == '.') {
						break;
					}
					$message = intval ($this->Splitter ($popresult, ' ') );
					if ($unique_id) {
						$messages[$message] = $this->Splitter (' ');
					} else {
						$messages[$message] = intval ($this->Splitter (' ') );
					}
				}
				return ($messages);
			}
			$message = intval ($this->Splitter (' ') );
			return (intval ($this->Splitter (' ') ) );

		}

	}
}
// if

?>