<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* SmartTemplate Extension number
* Format a number with grouped thousands
*
* Usage Example:
* Content:  $template->assign('SUM', 2500000);
* Template: Current balance: {number:SUM}
* Result:   Current balance: 2.500.000,00
*
* @author Philipp v. Criegern philipp@criegern.de
*/

function smarttemplate_extension_number ($param) {

	global $_CONFIG;
	if (empty ($_CONFIG['decimal_char']) ) {
		$_CONFIG['decimal_char'] = ',';
	}
	if (empty ($_CONFIG['decimal_places']) ) {
		$_CONFIG['decimal_places'] = 2;
	}
	if (empty ($_CONFIG['thousands_sep']) ) {
		$_CONFIG['thousands_sep'] = '.';
	}
	return number_format ($param, $_CONFIG['decimal_places'], $_CONFIG['decimal_char'], $_CONFIG['thousands_sep']);

}

?>