<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/**
* SmartTemplate Extension options
* Creates HTML DropDown Option list from an array
*
* Usage Example I:
* Content:  $template->assign('pick', array( "on", "off" ) );
* Template: Choose: <select name="onoff"> {optiongroup:pick} </select>
* Result:   Choose: <select name="onoff"> <option>on</option><option>off</option> </select>
*
* Usage Example II:
* Content:  $template->assign('color',   array( "FF0000" => "Red", "00FF00" => "Green", "0000FF" => "Blue" ) );
*           $template->assign('default', "00FF00" );
* Template: Color: <select name="col"> {options:color,default} </select>
* Result:   Color: <select name="col"> <option value="FF0000">Red</option><option value="00FF00" selected="selected">Green</option><option value="0000FF">Blue</option> </select>
*
* @author Heinz-Gerd Hombergs heinz@hhombergs.de
*/

function smarttemplate_extension_optiongroup ($param, $default = '_DEFAULT_') {

	$output = '';
	if (is_array ($param) ) {
		$keys = array_keys ($param);
		foreach ($keys as $key) {
			if (count ($param[$key]['options'])) {
				if (isset ($param[$key]['label'])) {
					$output .= '<optgroup label="' . $param[$key]['label'] . '">' . _OPN_HTML_NL;
				}
				$options = $param[$key]['options'];
				$keys1 = array_keys ($options);
				foreach ($keys1 as $key1) {
					$output .= '<option value="' . $key1 . '"' . ( ($key1 == $default)?'  selected="selected"' : '') . '>' . $options[$key1] . '</option>' . _OPN_HTML_NL;
				}
				if (isset ($param[$key]['label'])) {
					$output .= '</optgroup>' . _OPN_HTML_NL;
				}
				unset($options);
			}
		}
		unset($keys);
	}
	return $output;

}

?>