<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_DRIVERBORLANDIBASE_INCLUDED') ) {
	define ('_OPN_CLASS_DRIVERBORLANDIBASE_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'sql/drivers/driver-ibase.php');

	/**
	* Extends the SQL Connection class for Interbase >= 6.0 Database access
	*/

	class SQLLayer_borland_ibase extends SQLLayer_ibase {

		/*<{php4}>
		var $databaseType = 'borland_ibase';
		<{php4/}>*/

		/*<{php5}>
		public $databaseType = 'borland_ibase';
		<{php5/}>*/

		/*<{delete}>*/
		var $databaseType = 'borland_ibase';
		/*<{delete/}>*/

		/**
		* Constructor for SQLLayer_borland_ibase
		*
		* @access public
		* @return void
		*/

		function SQLLayer_borland_ibase () {

			$this->SQLLayer_ibase ();

		}

		/**
		* select records, start getting rows from $offset (1-based), for $nrows.
		* Note that Interbase 6.5 uses this ROWS instead - don't you love forking wars!
		* SELECT col1, col2 FROM table ROWS 5 -- get 5 rows
		* SELECT col1, col2 FROM TABLE ORDER BY col1 ROWS 3 TO 7 -- first 5 skip 2
		*
		* @access public
		* @param string	$sql
		* @param int		$nrows
		* @param int		$offset
		* @param mixed		$inputarr
		* @return void
		*/

		function &SelectLimit ($sql, $nrows = -1, $offset = -1, $inputarr = false) {
			if ($nrows>0) {
				if ($offset<=0) {
					$str = ' ROWS ' . $nrows . ' ';
				} else {
					$a = $offset+1;
					$b = $offset+ $nrows;
					$str = ' ROWS ' . $a . ' TO ' . $b;
				}
			} else {
				// ok, skip
				$a = $offset+1;
				$str = ' ROWS ' . $a . ' TO 999999999';
				// 999 million
			}
			$sql .= $str;
			return $this->Execute ($sql, $inputarr);

		}

	}

	/* class SQLLayer_borland_ibase */

	/**
	* Extends the RecordSet class that represents the dataset returned by the database
	* for Interbase >= 6.0 Database access
	*
	* @var string	$databaseType
	*/

	class SQLLayerRecordSet_borland_ibase extends SQLLayerRecordSet_ibase {

		/*<{php4}>
		var $databaseType = 'borland_ibase';
		<{php4/}>*/

		/*<{php5}>
		public $databaseType = 'borland_ibase';
		<{php5/}>*/

		/*<{delete}>*/
		var $databaseType = 'borland_ibase';
		/*<{delete/}>*/

		/**
		* Constructor
		*
		* @access public
		* @param ressource	$id
		* @param bool		$mode
		* @return void
		*/

		function SQLLayerRecordSet_borland_ibase ($id, $mode = true) {

			$this->SQLLayerRecordSet_ibase ($id, $mode);

		}

	}

	/* class SQLLayerRecordSet_borland_ibase */
}

?>