<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_DRIVERFIREBIRD_INCLUDED') ) {
	define ('_OPN_CLASS_DRIVERFIREBIRD_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'sql/drivers/driver-ibase.php');

	/**
	* Extends the SQL Connection class for Firebird Database access
	* @var string	$databaseType
	* @var integer	$dialect
	*/

	class SQLLayer_firebird extends SQLLayer_ibase {
		var $databaseType = 'firebird';
		var $dialect = 3;

		/**
		* Constructor for SQLLayer_firebird
		*
		* @access public
		* @return void
		*/

		function SQLLayer_firebird () {

			$this->SQLLayer_ibase ();

		}

		/**
		* select records, start getting rows from $offset (1-based), for $nrows.
		* Note that Interbase 6.5 uses this ROWS instead - don't you love forking wars!
		* SELECT col1, col2 FROM table ROWS 5 -- get 5 rows
		* SELECT col1, col2 FROM TABLE ORDER BY col1 ROWS 3 TO 7 -- first 5 skip 2
		*
		* @access public
		* @param string	$sql
		* @param int		$nrows
		* @param int		$offset
		* @param mixed		$inputarr
		* @return void
		*/

		function &SelectLimit ($sql, $nrows = -1, $offset = -1, $inputarr = false) {

			$str = 'SELECT ';
			if ($nrows >= 0) {
				$str .= 'FIRST ' . $nrows . ' ';
			}
			$str .= ($offset >= 0)?'SKIP ' . $offset . ' ' : '';
			$sql = preg_replace ('/^[ \t]*select/i', $str, $sql);
			$rs = &$this->Execute ($sql, $inputarr);
			return $rs;

		}

	}

	/* class SQLLayer_firebird */

	/**
	* Extends the RecordSet class that represents the dataset returned by the database
	* for Firebird Database access
	*
	* @var string	$databaseType
	*/

	class SQLLayerRecordSet_firebird extends SQLLayerRecordSet_ibase {
		var $databaseType = 'firebird';

		/**
		* Constructor
		*
		* @access public
		* @param ressource	$id
		* @param bool		$mode
		* @return void
		*/

		function SQLLayerRecordSet_firebird ($id, $mode = true) {

			$this->SQLLayerRecordSet_ibase ($id, $mode);

		}

	}

	/* class SQLLayerRecordSet_firebird */
}

?>