<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_DRIVERPG64_INCLUDED') ) {
	define ('_OPN_CLASS_DRIVERPG64_INCLUDED', 1);

	/**
	*
	* @param string	$s
	* @return string
	*/

	function sqllayer_addslashes ($s) {

		$len = strlen ($s);
		if ($len == 0) {
			return "''";
		}
		if (strncmp ($s, "'", 1) === 0 && substr ($s, $len-1) == "'") {
			return $s;
			// already quoted
		}
		return "'" . addslashes ($s) . "'";

	}

	/**
	* Extends the SQL Connection class for Postgres 6.x Database access
	*/

	class SQLLayer_postgres64 extends SQLConnection {

		/*<{php4}>
		<{php4/}>*/

		/*<{php5}>
		<{php5/}>*/

		/*<{delete}>*/
		/*<{delete/}>*/
		var $dataProvider = 'postgres';
		var $databaseType = 'postgres64';
		var $_resultid = false;
		var $metaDatabasesSQL = 'SELECT datname FROM pg_database WHERE datname not in (\'template0\',\'template1\') ORDER BY 1';
		var $metaTablesSQL = "SELECT tablename,'T' FROM pg_tables WHERE tablename not like 'pg\_%' AND tablename not in ('sql_features', 'sql_implementation_info', 'sql_languages', 'sql_packages', 'sql_sizing', 'sql_sizing_profiles') union select viewname,'V' FROM pg_views WHERE viewname not like 'pg\_%'";
		var $blobEncodeType = 'C';
		var $metaColumnsSQL = "SELECT a.attname,t.typname,a.attlen,a.atttypmod,a.attnotnull,a.atthasdef,a.attnum FROM pg_class c, pg_attribute a,pg_type t WHERE relkind in ('r','v') AND (c.relname='%s' or c.relname = lower('%s')) and a.attname not like '....%%' AND a.attnum > 0 AND a.atttypid = t.oid AND a.attrelid = c.oid ORDER BY a.attnum";
		// used when schema defined
		var $metaColumnsSQL1 = "SELECT a.attname, t.typname, a.attlen, a.atttypmod, a.attnotnull, a.atthasdef, a.attnum FROM pg_class c, pg_attribute a, pg_type t, pg_namespace n WHERE relkind in ('r','v') AND (c.relname='%s' or c.relname = lower('%s')) AND c.relnamespace=n.oid and n.nspname='%s' AND a.attname not like '....%%' AND a.attnum > 0 AND a.atttypid = t.oid AND a.attrelid = c.oid ORDER BY a.attnum";
		// get primary key etc -- from Freek Dijkstra
		var $metaKeySQL = "SELECT ic.relname AS index_name, a.attname AS column_name,i.indisunique AS unique_key, i.indisprimary AS primary_key FROM pg_class bc, pg_class ic, pg_index i, pg_attribute a WHERE bc.oid = i.indrelid AND ic.oid = i.indexrelid AND (i.indkey[0] = a.attnum OR i.indkey[1] = a.attnum OR i.indkey[2] = a.attnum OR i.indkey[3] = a.attnum OR i.indkey[4] = a.attnum OR i.indkey[5] = a.attnum OR i.indkey[6] = a.attnum OR i.indkey[7] = a.attnum) AND a.attrelid = bc.oid AND bc.relname = '%s'";
		// below suggested by Freek Dijkstra
		var $true = 't';
		// string that represents TRUE for a database
		var $false = 'f';
		// string that represents FALSE for a database
		var $version = '';
		var $metaDefaultsSQL = "SELECT d.adnum as num, d.adsrc as def from pg_attrdef d, pg_class c where d.adrelid=c.oid and c.relname='%s' order by d.adnum";
		var $autoRollback = true;
		// apparently pgsql does not autorollback properly before php 4.3.4
		// http://bugs.php.net/bug.php?id=25404
		var $_bindInputArray = false;
		// requires postgresql 7.3+ and ability to modify database

		/**
		* Constructor for SQLLayer_firebird
		*
		* @access public
		* @return void
		*/

		function SQLLayer_postgres64 () {
			if (!extension_loaded ('pgsql') ) {
				trigger_error ('You must have the pgsql extension installed.', E_USER_ERROR);
			}
			$this->fetchMode = true;

		}

		/**
		* IfNull
		*
		* @access public
		* @param string	$field
		* @param string	$ifNull
		* @return string
		*/

		function IfNull ($field, $ifNull) {
			return ' coalesce(' . $field . ', ' . $ifNull . ') ';

		}

		/**
		*
		* @access private
		* @return mixed boolean or int
		*/

		function _affectedrows () {
			if (!is_resource ($this->_resultid) || get_resource_type ($this->_resultid) !== 'pgsql result') {
				return false;
			}
			if (version_compare (phpversion (), '4.2.0') == 1) {
				return pg_affected_rows ($this->_resultid);
			}
			return pg_cmdtuples ($this->_resultid);

		}

		/**
		* Start a transaction.
		*
		* @access public
		* @return mixed boolean or number
		*/

		function BeginTrans () {
			if ($this->transOff) {
				return true;
			}
			$this->transCnt += 1;
			return @pg_Exec ($this->_connectionID, 'begin');

		}

		/**
		* Commit a transaction.
		*
		* @access public
		* @param bool	$ok
		* @return mixed boolean or number
		*/

		function CommitTrans ($ok = true) {
			if ($this->transOff) {
				return true;
			}
			if (!$ok) {
				return $this->RollbackTrans ();
			}
			$this->transCnt -= 1;
			return @pg_Exec ($this->_connectionID, 'commit');

		}

		/**
		* Rollback a transaction.
		*
		* @access public
		* @return mixed boolean or number
		*/

		function RollbackTrans () {
			if ($this->transOff) {
				return true;
			}
			$this->transCnt -= 1;
			return @pg_Exec ($this->_connectionID, 'rollback');

		}

		/**
		* Locks a row.
		*
		* @access public
		* @param string	$tables
		* @param string	$where
		* @return void
		*/

		function RowLock ($tables, $where) {
			if (!$this->transCnt) {
				$this->BeginTrans ();
			}
			return $this->GetOne ('SELECT 1 AS ignore FROM ' . $tables . ' WHERE ' . $where . ' for update');

		}

		/**
		*
		* @access public
		* @return array
		*/

		function ServerInfo () {
			if ($this->version != '') {
				return $this->version;
			}
			$arr['description'] = $this->GetOne ('SELECT version()');
			$arr['version'] = $this->_findvers ($arr['description']);
			$this->version = $arr;
			return $arr;

		}

		/**
		*
		* @access public
		* @param mixed		$ttype
		* @param mixed		$showSchema
		* @param mixed		$mask
		* @return void
		*/

		function &MetaTables ($ttype = false, $showSchema = false, $mask = false) {

			$info = $this->ServerInfo ();
			if ($info['version'] >= 7.3) {
				$this->metaTablesSQL = "SELECT tablename,'T' FROM pg_tables WHERE tablename not like 'pg\_%' " . "AND schemaname not in ( 'pg_catalog','information_schema') " . "UNION " . "SELECT viewname,'V' FROM pg_views WHERE viewname not like 'pg\_%'  and schemaname  not in ( 'pg_catalog','information_schema') ";
			}
			if ($mask) {
				$save = $this->metaTablesSQL;
				$mask = $this->qstr (strtolower ($mask) );
				if ($info['version'] >= 7.3) {
					$this->metaTablesSQL = 'SELECT tablename,\'T\' FROM pg_tables WHERE tablename LIKE ' . $mask . ' AND schemaname not in ( \'pg_catalog\',\'information_schema\') ' . "union " . "SELECT viewname,'V' FROM pg_views WHERE viewname LIKE $mask AND schemaname not in ( 'pg_catalog','information_schema') ";
				} else {
					$this->metaTablesSQL = "SELECT tablename,'T' FROM pg_tables WHERE tablename LIKE $mask " . "UNION " . "SELECT viewname,'V' FROM pg_views WHERE viewname LIKE $mask";
				}
			}
			$ret = &$this->_MetaTables ($ttype, $showSchema);
			if ($mask) {
				$this->metaTablesSQL = $save;
			}
			return $ret;

		}

		/**
		*
		* @access public
		* @param string	$table
		* @param bool		$normalize
		* @return mixed unknown or array
		*/

		function &MetaColumns ($table, $normalize = true) {

			$schema = false;
			$this->_findschema ($table, $schema);
			if ($normalize) {
				$table = strtolower ($table);
			}
			if ($this->fetchMode !== false) {
				$savem = $this->SetFetchMode (false);
			}
			if ($schema) {
				$rs = &$this->Execute (sprintf ($this->metaColumnsSQL1, $table, $table, $schema) );
			} else {
				$rs = &$this->Execute (sprintf ($this->metaColumnsSQL, $table, $table) );
			}
			if (isset ($savem) ) {
				$this->SetFetchMode ($savem);
			}
			if ($rs === false) {

				/* return byRef required - so it must be a variable*/

				$false = false;
				return $false;
			}
			if (!empty ($this->metaKeySQL) ) {
				// If we want the primary keys, we have to issue a separate query
				// Of course, a modified version of the metaColumnsSQL query using a
				// LEFT JOIN would have been much more elegant, but postgres does
				// not support OUTER JOINS. So here is the clumsy way.
				$rskey = $this->Execute (sprintf ($this->metaKeySQL, ($table) ) );
				// fetch all result in once for performance.
				$keys = &$rskey->GetArray ();
				if (isset ($savem) ) {
					$this->SetFetchMode ($savem);
				}
				$rskey->Close ();
				unset ($rskey);
			}
			$rsdefa = array ();
			if (!empty ($this->metaDefaultsSQL) ) {
				$sql = sprintf ($this->metaDefaultsSQL, ($table) );
				$rsdef = $this->Execute ($sql);
				if (isset ($savem) ) {
					$this->SetFetchMode ($savem);
				}
				if ($rsdef) {
					while (! $rsdef->EOF) {
						$num = $rsdef->fields['num'];
						$s = $rsdef->fields['def'];
						if (strpos ($s, '::') === false && substr ($s, 0, 1) == "'") {

							/* quoted strings hack... for now... fixme */

							$s = substr ($s, 1);
							$s = substr ($s, 0, strlen ($s)-1);
						}
						$rsdefa[$num] = $s;
						$rsdef->MoveNext ();
					}
				}
				unset ($rsdef);
			}
			$retarr = array ();
			while (! $rs->EOF) {
				$fld =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ SQLLayerFieldObject;
				$fld->name = $rs->fields[0];
				$fld->type = $rs->fields[1];
				$fld->max_length = $rs->fields[2];
				if ($fld->max_length<=0) {
					$fld->max_length = $rs->fields[3]-4;
				}
				if ($fld->max_length<=0) {
					$fld->max_length = -1;
				}
				if ($fld->type == 'numeric') {
					$fld->scale = $fld->max_length&0xFFFF;
					$fld->max_length >>= 16;
				}
				// 5 hasdefault; 6 num-of-column
				$fld->has_default = ($rs->fields[5] == 't');
				if ($fld->has_default) {
					$fld->default_value = $rsdefa[$rs->fields[6]];
				}
				if ($rs->fields[4] == $this->true) {
					$fld->not_null = true;
				}
				if (is_array ($keys) ) {
					foreach ($keys as $key) {
						if ($fld->name == $key['column_name'] AND $key['primary_key'] == $this->true) {
							$fld->primary_key = true;
						}
						if ($fld->name == $key['column_name'] AND $key['unique_key'] == $this->true) {
							$fld->unique = true;
							// What name is more compatible?
						}
					}
				}
				if ($this->fetchMode === false) {
					$retarr[] = $fld;
				} else {
					$retarr[ ($normalize)?strtoupper ($fld->name) : $fld->name] = $fld;
				}
				$rs->MoveNext ();
			}
			$rs->Close ();
			return $retarr;

		}

		/**
		*
		* @access public
		* @param string	$table
		* @param bool		$primary
		* @return mixed bool or array
		*/

		function &MetaIndexes ($table, $primary = false) {

			$schema = false;
			$this->_findschema ($table, $schema);
			if ($schema) {
				// requires pgsql 7.3+ - pg_namespace used.
				$sql = 'SELECT c.relname as "Name", i.indisunique as "Unique", i.indkey as "Columns" ' . 'FROM pg_catalog.pg_class c ' . 'JOIN pg_catalog.pg_index i ON i.indexrelid=c.oid ' . 'JOIN pg_catalog.pg_class c2 ON c2.oid=i.indrelid ' . ',pg_namespace n ' . 'WHERE (c2.relname=\'%s\' or c2.relname=lower(\'%s\')) and c.relnamespace=c2.relnamespace and c.relnamespace=n.oid and n.nspname=\'%s\' AND i.indisprimary=false';
			} else {
				$sql = 'SELECT c.relname as "Name", i.indisunique as "Unique", i.indkey as "Columns" ' . 'FROM pg_catalog.pg_class c ' . 'JOIN pg_catalog.pg_index i ON i.indexrelid=c.oid ' . 'JOIN pg_catalog.pg_class c2 ON c2.oid=i.indrelid ' . 'WHERE c2.relname=\'%s\' or c2.relname=lower(\'%s\')';
			}
			if ($primary == false) {
				$sql .= ' AND i.indisprimary=false;';
			}
			if ($this->fetchMode !== false) {
				$savem = $this->SetFetchMode (false);
			}
			$rs = $this->Execute (sprintf ($sql, $table, $table, $schema) );
			if (isset ($savem) ) {
				$this->SetFetchMode ($savem);
			}
			if (!is_object ($rs) ) {

				/* return byRef required - so it must be a variable*/

				$false = false;
				return $false;
			}
			$col_names = $this->MetaColumnNames ($table, true);
			$indexes = array ();
			while ($row = $rs->FetchRow () ) {
				$columns = array ();
				foreach (explode (' ', $row[2]) as $col) {
					$columns[] = $col_names[$col-1];
				}
				$indexes[$row[0]] = array ('unique' => ($row[1] == 't'),
							'columns' => $columns);
			}
			return $indexes;

		}

		/**
		* Connect to a database.
		*
		* @access private
		* @param string	$str
		* @param string	$user
		* @param string	$pwd
		* @param string	$db
		* @param int		$ctype
		* @return boolean
		*/

		function _connect ($str, $user = '', $pwd = '', $db = '', $ctype = 0) {

			$this->_errorMsg = false;
			if ($user || $pwd || $db) {
				$user = sqllayer_addslashes ($user);
				$pwd = sqllayer_addslashes ($pwd);
				if (strlen ($db) == 0) {
					$db = 'template1';
				}
				$db = sqllayer_addslashes ($db);
				if ($str) {
					$host = split (':', $str);
					if ($host[0]) {
						$str = 'host=' . sqllayer_addslashes ($host[0]);
					} else {
						$str = 'host=localhost';
					}
					if (isset ($host[1]) ) {
						$str .= ' port=' . $host[1];
					}
				}
				if ($user) {
					$str .= ' user=' . $user;
				}
				if ($pwd) {
					$str .= ' password=' . $pwd;
				}
				if ($db) {
					$str .= ' dbname=' . $db;
				}
			}
			if ($ctype === 1) {
				// persistent
				$this->_connectionID = pg_pconnect ($str);
			} else {
				if ($ctype === -1) {
					// nconnect, we trick pgsql ext by changing the connection str
					static $ncnt;
					if (empty ($ncnt) ) {
						$ncnt = 1;
					} else {
						$ncnt += 1;
					}
					$str .= str_repeat (' ', $ncnt);
				}
				$this->_connectionID = pg_connect ($str);
			}
			if ($this->_connectionID === false) {
				return false;
			}
			return true;

		}

		/**
		* Forces a new connection to the database.
		*
		* @access private
		* @param string	$argHostname
		* @param string	$argUsername
		* @param string	$argPassword
		* @param string	$argDatabaseName
		* @return boolean
		*/

		function _nconnect ($argHostname, $argUsername, $argPassword, $argDatabaseName) {
			return $this->_connect ($argHostname, $argUsername, $argPassword, $argDatabaseName, -1);

		}

		/**
		* Persitent connection to the database.
		*
		* @access private
		* @param string	$str
		* @param string	$user
		* @param string	$pwd
		* @param string	$db
		* @return boolean
		*/

		function _pconnect ($str, $user = '', $pwd = '', $db = '') {
			return $this->_connect ($str, $user, $pwd, $db, 1);

		}

		/**
		* Execute the query.
		*
		* @access private
		* @param string	$sql
		* @param array		$inputarr
		* @return mixed	boolean or ressourceid
		*/

		function _query ($sql, $inputarr) {
			if ($inputarr) {

				/*
				It appears that PREPARE/EXECUTE is slower for many queries.

				For query executed 1000 times:
				"select id,firstname,lastname from adoxyz
				where firstname not like ? and lastname not like ? and id = ?"

				with plan = 1.51861286163 secs
				no plan =   1.26903700829 secs
				*/

				$plan = 'P' . md5 ($sql);
				$execp = '';
				foreach ($inputarr as $v) {
					if ($execp) {
						$execp .= ',';
					}
					if (is_string ($v) ) {
						if (strncmp ($v, "'", 1) !== 0) {
							$execp .= $this->qstr ($v);
						}
					} else {
						$execp .= $v;
					}
				}
				if ($execp) {
					$exsql = 'EXECUTE ' . $plan . ' (' . $execp . ')';
				} else {
					$exsql = 'EXECUTE ' . $plan;
				}
				$rez = @pg_exec ($this->_connectionID, $exsql);
				if (!$rez) {
					// Perhaps plan does not exist? Prepare/compile plan.
					$params = '';
					foreach ($inputarr as $v) {
						if ($params) {
							$params .= ',';
						}
						if (is_string ($v) ) {
							$params .= 'VARCHAR';
						} elseif (is_integer ($v) ) {
							$params .= 'INTEGER';
						} else {
							$params .= 'REAL';
						}
					}
					$sqlarr = explode ('?', $sql);
					$sql = '';
					$i = 1;
					foreach ($sqlarr as $v) {
						$sql .= $v . ' $' . $i;
						$i++;
					}
					$s = 'PREPARE ' . $plan . ' (' . $params . ') AS ' . substr ($sql, 0, strlen ($sql)-2);
					debugbreak ();
					pg_exec ($this->_connectionID, $s);
					echo $this->ErrorMsg ();
				}
				$rez = pg_exec ($this->_connectionID, $exsql);
			} else {
				$this->_errorMsg = false;
				$rez = pg_exec ($this->_connectionID, $sql);
			}
			// check if no data returned, then no need to create real recordset
			if ($rez && pg_numfields ($rez)<=0) {
				if (is_resource ($this->_resultid) && get_resource_type ($this->_resultid) === 'pgsql result') {
					pg_freeresult ($this->_resultid);
				}
				$this->_resultid = $rez;
				return true;
			}
			return $rez;

		}

		/**
		* Returns: the last error message from previous database operation
		*
		* @access public
		* @return string
		*/

		function ErrorMsg () {
			if ($this->_errorMsg !== false) {
				return $this->_errorMsg;
			}
			if (version_compare (phpversion (), '4.3.0', 'ge') == 1) {
				if (!empty ($this->_resultid) ) {
					$this->_errorMsg = @pg_result_error ($this->_resultid);
					if ($this->_errorMsg) {
						return $this->_errorMsg;
					}
				}
				if (!empty ($this->_connectionID) ) {
					$this->_errorMsg = @pg_last_error ($this->_connectionID);
				} else {
					$this->_errorMsg = @pg_last_error ();
				}
			} else {
				if (empty ($this->_connectionID) ) {
					$this->_errorMsg = @pg_errormessage ();
				} else {
					$this->_errorMsg = @pg_errormessage ($this->_connectionID);
				}
			}
			return $this->_errorMsg;

		}

		/**
		* Returns the errormesage or number.
		*
		* @access public
		* @return mixed string or number
		*/

		function ErrorNo () {

			$e = $this->ErrorMsg ();
			if (strlen ($e) ) {
				$this->_errorCode = $e;
			} else {
				$this->_errorCode = 0;
			}
			return $this->_errorCode;

		}

		/**
		* Close the connection.
		*
		* @access private
		* @return boolean
		*/

		function _close () {
			if ($this->transCnt) {
				$this->RollbackTrans ();
			}
			if ($this->_resultid) {
				@pg_freeresult ($this->_resultid);
				$this->_resultid = false;
			}
			@pg_close ($this->_connectionID);
			$this->_connectionID = false;
			return true;

		}

		/**
		* Maximum size of C field
		*
		* @access public
		* @return number
		*/

		function CharMax () {
			return 1000000000;
			// should be 1 Gb?

		}

		/**
		* Maximum size of X field
		*
		* @access public
		* @return number
		*/

		function TextMax () {
			return 1000000000;
			// should be 1 Gb?

		}

	}

	/* class SQLLayer_postgres64 */

	class SQLLayerRecordSet_postgres64 extends SQLLayerRecordSet {
		var $_blobArr;
		var $databaseType = 'postgres64';
		var $canSeek = true;

		/**
		* Constructor
		*
		* @access public
		* @param ressource	$id
		* @param bool		$mode
		* @return void
		*/

		function SQLLayerRecordSet_postgres64 ($id, $mode = true) {
			if ($mode) {
				$this->fetchMode = PGSQL_ASSOC;
			} else {
				$this->fetchMode = PGSQL_NUM;
			}
			$this->SQLLayerRecordSet ($id);

		}

		/**
		*
		* @access public
		* @param $upper
		* @return array
		*/

		function &GetRowAssoc ($upper = true) {
			if ($this->fetchMode == PGSQL_ASSOC && !$upper) {
				return $this->fields;
			}
			$row = &$this->_GetRowAssoc ($upper);
			return $row;

		}

		/**
		* Init the recordset.
		*
		* @access private
		* @return void
		*/

		function _initrs () {

			$qid = $this->_queryID;
			$this->_numOfRows = @pg_numrows ($qid);
			$this->_numOfFields = @pg_numfields ($qid);

		}

		/**
		* Get the value of a field in the current row by column name.
		*
		* @access public
		* @param string	$colname
		* @return mixed
		*/

		function Fields ($colname) {
			if ($this->fetchMode != PGSQL_NUM) {
				return @ $this->fields[$colname];
			}
			if (!$this->bind) {
				$this->bind = array ();
				for ($i = 0, $max = $this->_numOfFields; $i< $max; $i++) {
					$o = $this->FetchField ($i);
					$this->bind[strtolower ($o->name)] = $i;
				}
			}
			return $this->fields[$this->bind[strtolower ($colname)]];

		}

		/**
		* Get the SQLLayerFieldObject of a specific column.
		*
		* It zero based offset
		*
		* @access public
		* @param int	$off
		* @return obejct
		*/

		function &FetchField ($off = 0) {

			$object =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ SQLLayerFieldObject;
			$object->name = @pg_fieldname ($this->_queryID, $off);
			$object->type = @pg_fieldtype ($this->_queryID, $off);
			$object->max_length = @pg_fieldsize ($this->_queryID, $off);
			return $object;

		}

		/**
		* Adjusts the result pointer to an arbitary row in the result.
		*
		* @access private
		* @param int	$row
		* @return array
		*/

		function _seek ($row) {
			return @pg_fetch_row ($this->_queryID, $row);

		}

		/**
		* Fetch a record.
		*
		* @access private
		* @return boolean
		*/

		function _fetch () {
			if ($this->_currentRow >= $this->_numOfRows && $this->_numOfRows >= 0) {
				return false;
			}
			$this->fields = @pg_fetch_array ($this->_queryID, $this->_currentRow, $this->fetchMode);
			if ( ($this->fetchMode == PGSQL_ASSOC) && (is_array ($this->fields) ) ) {
				$this->_convert_to_lowercase ();
			}
			return (is_array ($this->fields) );

		}

		/**
		* Close the recordset.
		*
		* @access private
		* @return number
		*/

		function _close () {
			return @pg_freeresult ($this->_queryID);

		}

		/**
		*
		* @access public
		* @param mixed		$t
		* @param int		$len
		* @param object	$fieldobj
		* @return string
		*/

		function MetaType ($t, $len = -1, $fieldobj = object) {
			if (is_object ($t) ) {
				$fieldobj = $t;
				$t = $fieldobj->type;
				$len = $fieldobj->max_length;
			}
			switch (strtoupper ($t) ) {
				case 'MONEY':
					// stupid, postgres expects money to be a string
				case 'INTERVAL':
				case 'CHAR':
				case 'CHARACTER':
				case 'VARCHAR':
				case 'NAME':
				case 'BPCHAR':
				case '_VARCHAR':
				case 'INET':
					return 'C';
				case 'TEXT':
					return 'X';
				case 'IMAGE':
					// user defined type
				case 'BLOB':
					// user defined type
				case 'BIT':
					// This is a bit string, not a single bit, so don't return 'L'
				case 'VARBIT':
				case 'BYTEA':
					return 'B';
				case 'BOOL':
				case 'BOOLEAN':
					return 'L';
				case 'DATE':
					return 'D';
				case 'TIME':
				case 'DATETIME':
				case 'TIMESTAMP':
				case 'TIMESTAMPTZ':
					return 'T';
				case 'SMALLINT':
				case 'BIGINT':
				case 'INTEGER':
				case 'INT8':
				case 'INT4':
				case 'INT2':
					return 'I';
				case 'OID':
				case 'SERIAL':
					return 'R';
				default:
					return 'N';
			}

		}

	}

	/* class SQLLayerRecordSet_postgres64 */

	class opn_postgres extends OPN_SQL {
		var $ShowTableStatus = "";

		function opn_postgres () {

			global $opnConfig;

			$this->CanOptimize = true;
			$this->CanRepair = true;
			$this->HasStatus = false;
			$this->CanAlterColumnAdd = false;
			$this->CanAlterColumnChange = false;
			$this->CanAddRepairField = true;
			$this->CanChangeRepairField = true;
			$this->CanExecuteColumnAdd = true;
			$this->CanExecuteColumnChange = false;
			$this->ShowTableStatus = "SELECT relname as name, relpages*8192 AS data_length, 0 as index_length, 0 as data_free FROM pg_class WHERE relname LIKE '" . $opnConfig['tableprefix'] . "%%' ORDER BY relname";

		}

		function TableComment ($tablename, $comment) {
			return 'COMMENT ON ' . $tablename . " IS '" . $comment . "'";

		}

		function TableOptimize ($tablename) {
			return 'VACUUM FULL ' . $tablename;

		}

		function TableRepair ($tablename) {
			return 'REINDEX TABLE ' . $tablename;

		}

		function TableDrop ($tablename) {
			return 'DROP TABLE ' . $tablename;

		}

		function TableRename ($oldname, $newname) {
			return 'ALTER TABLE ' . $oldname . ' RENAME TO ' . $newname;

		}

		function CreateIndex ($unique, $idxname, $idxcounter, $table, $fields) {
			return sprintf ($this->IndexCreate, $unique, $idxname, $idxcounter, $table, $fields);

		}

		function CreateBetween ($field, $from, $to, $char = false, $len = 0) {

			$t = $len;
			if (!$char) {
				return '(' . $field . ' BETWEEN CAST(' . $from . ' AS NUMERIC) AND CAST(' . $to . ' AS NUMERIC) )';
			}
			return '(' . $field . " BETWEEN CAST('" . $from . "' AS VARCHAR) AND CAST('" . $to . "' AS VARCHAR) )";

		}

		/**
		* OPN_SQL::ExecuteColumnAdd()
		*
		* @param  $table
		* @param  $field
		*/

		function ExecuteColumnAdd ($table, $field, $datatype, $length = 0, $default = NULL, $null = FALSE, $decimal = 0) {

			global $opnConfig, $opnTables;

			$opnConfig['database']->Execute ('alter table ' . $opnTables[$table] . ' ADD ' . $field . ' ' . $opnConfig['opnSQL']->GetDBType ($datatype, $length, NULL, TRUE, $decimal) );
			$hlp = '';
			if ($default !== NULL) {
				$hlp .= ' SET DEFAULT ';
				if (strlen ($default) == 0) {
					$hlp .= "''";
				} else {
					$hlp .= "'" . $default . "'";
				}
			}
			$opnConfig['database']->Execute ('alter table ' . $opnTables[$table] . ' alter ' . $field . ' ' . $hlp);
			if ($null) {
			} else {
				$hlp = $this->_buildid ($field);
				$opnConfig['database']->Execute ('alter table ' . $opnTables[$table] . ' ADD CONSTRAINT "' . $hlp . '" CHECK (' . $field . ' NOTNULL)');
			}

		}

		function AddRepairField ($module, $table, $field) {

			global $opnConfig;

			$t = $field;
			if ($this->_CreateTable ($module, 'dummy', $table, true) ) {
				$module1 = explode ('/', $module);
				$module1 = $module1[1];
				$thefunc = $module1 . '_repair_sql_table';
				if (function_exists ($thefunc) ) {
					$arr = $thefunc ();
					$insertquery = '';
					$result = &$opnConfig['database']->Execute ('SELECT * FROM ' . $opnConfig['tableprefix'] . $table);
					if ($result !== false) {
						while (! $result->EOF) {
							$row = $result->GetRowAssoc ('0');
							$first = 0;
							$insertquery .= 'INSERT INTO "' . $opnConfig['tableprefix'] . 'dummy" (';
							$values = ') VALUES (';
							$tmparr = array_keys ($arr['table'][$table]);
							foreach ($tmparr as $fieldname) {
								if (strpos ($fieldname, '__opn_key') ) {
								} else {
									if ($first != 0) {
										$values .= ', ';
										$insertquery .= ', ';
									}
									if (isset ($row[$fieldname]) ) {
										$insertquery .= '"' . $fieldname . '"';
										$values .= "'" . addslashes ($row[$fieldname]) . "'";
									} else {
										$insertquery .= '"' . $fieldname . '"';
										$values .= "''";
									}
									$first++;
								}
							}
							$insertquery .= $values . ');';
							$result->MoveNext ();
						}
						$drop = $this->TableDrop ($opnConfig['tableprefix'] . $table);
						$opnConfig['database']->Execute ($drop);
					}
					$this->_CreateTable ($module, $table, $table, true);
					if ($insertquery != '') {
						$opnConfig['database']->Execute ($insertquery);
						$insertquery = 'INSERT INTO ' . $opnConfig['tableprefix'] . $table . ' SELECT * FROM ' . $opnConfig['tableprefix'] . 'dummy';
						$opnConfig['database']->Execute ($insertquery);
					}
					// $insertquery = 'INSERT INTO '.$opnConfig['tableprefix'].'dummy SELECT * FROM '.$opnConfig['tableprefix'].$table;
					// $opnConfig['database']->Execute($insertquery);
					$drop = $this->TableDrop ($opnConfig['tableprefix'] . 'dummy');
					$opnConfig['database']->Execute ($drop);
				}
			}

		}

		/**
		* OPN_SQL::FieldRename()
		*
		* @param  $table
		* @param  $oldname
		* @param  $newname
		*/

		function FieldRename ($module, $table, $oldname, $newname) {

			global $opnConfig, $opnTables;

			$t = $module;
			$repairsql = 'ALTER TABLE ' . $opnTables[$table] . ' RENAME ' . $oldname . ' TO ' . $newname;
			$opnConfig['database']->Execute ($repairsql);

		}

		function ChangeRepairField ($module, $table, $field) {

			$this->AddRepairField ($module, $table, $field);

		}

		function ChangeColumn ($module, $table, $field) {

			$this->AddRepairField ($module, $table, $field);

		}

		function CreateOpnRegexp ($field, $regx) {
			if ($regx == '0-9') {
				$regx = '^\[1-9]';
			} elseif ($regx == 'a-z') {
				$regx = '^\[a-z]';
			}
			return '(' . $field . " ~ '" . $regx . "')";

		}

		function IndexDrop ($index, $table = '') {

			$t = $table;
			return 'DROP INDEX "' . $index . '"';

		}

		function PrimaryIndexDrop ($table) {
			return 'ALTER TABLE ' . $table . ' DROP PRIMARY KEY';

		}

		function GetIndex ($table) {
			return "SELECT ic.relname AS index_name, bc.relname AS tab_name, i.indisunique AS unique_key, i.indisprimary AS primary_key FROM pg_class bc, pg_class ic, pg_index i, pg_attribute ia WHERE bc.oid = i.indrelid AND ic.oid = i.indexrelid AND ia.attrelid = i.indexrelid AND bc.relname = '$table' ORDER BY index_name, tab_name";

		}

		function TableLock ($tablename, $lockmode = _OPNSQL_TABLOCK_ACCESS_EXCLUSIVE) {

			global $opnConfig;
			if ( (isset ($opnConfig['opn_db_lock_use']) ) AND ($opnConfig['opn_db_lock_use'] == 1) ) {
				static $alocks = array (_OPNSQL_TABLOCK_ACCESS_SHARE => 'access share',
							_OPNSQL_TABLOCK_ROW_SHARE => 'row share',
							_OPNSQL_TABLOCK_ROW_EXCLUSIVE => 'row exclusive',
							_OPNSQL_TABLOCK_SHUPD_EXCLUSIVE => 'share update exlusive',
							_OPNSQL_TABLOCK_SHARE => 'share',
							_OPNSQL_TABLOCK_SHROW_EXCLUSIVE => 'share row exclusive',
							_OPNSQL_TABLOCK_EXCLUSIVE => 'exclusive',
							_OPNSQL_TABLOCK_ACCESS_EXCLUSIVE => 'access exclusive');
				$lock = $alocks[$lockmode];
				if ($lock) {
					$opnConfig['database']->Execute ('LOCK TABLE ' . $tablename . ' in ' . $lock . ' mode');
				}
			}

		}

		function TableUnLock ($tablename) {

			$t = $tablename;
			return '';

		}

		function GetDBType ($datatype, $length = 0, $default = null, $null = false, $decimal = 0) {

			global $opnConfig;
			if ( (isset ($opnConfig['return_tableinfo_as_array']) ) && ($opnConfig['return_tableinfo_as_array'] === TRUE) ) {
				if ($decimal == 0) {
					$decimal = null;
				}
				return $opnConfig['opnSQL']->BuildField ('', $length, $datatype, ! $null, !is_null ($default), $default, $decimal);
			}
			$hlp = '';
			switch ($datatype) {
				case _OPNSQL_TINYINT:
				case _OPNSQL_SMALLINT:
					$hlp .= 'SMALLINT';
					break;
				case _OPNSQL_MEDIUMINT:
				case _OPNSQL_INT:
					$hlp .= 'INTEGER';
					break;
				case _OPNSQL_BIGINT:
					$hlp .= 'INT8';
					break;
				case _OPNSQL_FLOAT:
					$hlp .= 'REAL';
					break;
				case _OPNSQL_DOUBLE:
					$hlp .= 'FLOAT8';
					break;
				case _OPNSQL_NUMERIC:
					$hlp .= 'NUMERIC (' . $length . ',' . $decimal . ')';
					break;
				case _OPNSQL_DATE:
					$hlp .= 'DATE';
					break;
				case _OPNSQL_DATETIME:
					$hlp .= 'DATETIME';
					break;
				case _OPNSQL_TIMESTAMP:
					$hlp .= 'TIMESTAMP';
					break;
				case _OPNSQL_TIME:
					$hlp .= 'TIME';
					break;
				case _OPNSQL_CHAR:
					$hlp .= 'CHAR (' . $length . ')';
					break;
				case _OPNSQL_VARCHAR:
					$hlp .= 'VARCHAR (' . $length . ')';
					break;
				case _OPNSQL_TINYBLOB:
				case _OPNSQL_BLOB:
				case _OPNSQL_MEDIUMBLOB:
				case _OPNSQL_BIGBLOB:
					// $hlp.="BYTEA";  // eigentlich aber da 7Bit
					$hlp .= 'TEXT';
					// ich hoffe das geht
					break;
				case _OPNSQL_TINYTEXT:
				case _OPNSQL_TEXT:
				case _OPNSQL_MEDIUMTEXT:
				case _OPNSQL_BIGTEXT:
					$hlp .= 'TEXT';
					break;
			}
			switch ($datatype) {
				case _OPNSQL_DATETIME:
					// DEFAULT CURRENT_TIMESTAMP.
					if ($default !== NULL) {
						$hlp .= ' DEFAULT ';
						if (strlen ($default) == 0) {
							$hlp .= "TEXT ''";
						} else {
							$hlp .= "TEXT '" . $default . "'";
						}
					}
					break;
				case _OPNSQL_DATE:
					if ($default !== NULL) {
						$hlp .= ' DEFAULT ';
						if (strlen ($default) == 0) {
							$hlp .= "TEXT ''";
						} else {
							$hlp .= "TEXT '" . $default . "'";
						}
					}
					if ($null) {
					} else {
						$hlp .= ' NOT NULL';
					}
					break;
				default:
					if ($default !== NULL) {
						$hlp .= ' DEFAULT ';
						if (strlen ($default) == 0) {
							$hlp .= "''";
						} else {
							$hlp .= "'" . $default . "'";
						}
					}
					if ($null) {
					} else {
						$hlp .= ' NOT NULL';
					}
					break;
			}
			return $hlp;

		}

	}
}

?>