<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_DRIVERPG7_INC') ) {
	define ('_OPN_CLASS_DRIVERPG7_INC', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'sql/drivers/driver-postgres64.php');

	/**
	* Extends the SQL Connection class for Postgres 7 Database access
	*/

	class SQLLayer_postgres7 extends SQLLayer_postgres64 {

		/*<{php4}>
		<{php4/}>*/

		/*<{php5}>
		<{php5/}>*/

		/*<{delete}>*/
		/*<{delete/}>*/
		var $databaseType = 'postgres7';
		var $ansiOuter = true;
		var $charSet = true;
		// set to true for Postgres 7 and above - PG client supports encodings

		/**
		* Constructor for SQLLayer_postgres7
		*
		* @access public
		* @return void
		*/

		function SQLLayer_postgres7 () {

			$this->SQLLayer_postgres64 ();

		}

		/**
		*
		* @access public
		* @param string	$sql
		* @param int		$nrows
		* @param int		$offset
		* @param array		$inputarr
		* @return void
		*/

		function &SelectLimit ($sql, $nrows = -1, $offset = -1, $inputarr = false) {

			$offsetStr = ($offset >= 0)?' OFFSET ' . $offset : '';
			$limitStr = ($nrows >= 0)?' LIMIT ' . $nrows : '';
			$rs = &$this->Execute ($sql . $limitStr . $offsetStr, $inputarr);
			return $rs;

		}

		/**
		*
		* @access public
		* @param string	$table
		* @param mixed		$owner
		* @param mixed		$upper
		* @return mixed array or boolean
		*/

		function MetaForeignKeys ($table, $owner = false, $upper = false) {

			$t = $owner;
			$sql = 'SELECT t.tgargs as args FROM pg_trigger t,pg_class c,pg_proc p WHERE ' . 't.tgenabled AND t.tgrelid = c.oid AND t.tgfoid = p.oid AND ' . 'p.proname = \'RI_FKey_check_ins\' AND c.relname = \'' . strtolower ($table) . '\'' . 'ORDER BY t.tgrelid';
			$rs = $this->Execute ($sql);
			if ($rs && !$rs->EOF) {
				$arr = &$rs->GetArray ();
				$a = array ();
				foreach ($arr as $v) {
					$data = explode (chr (0), $v['args']);
					if ($upper) {
						$a[strtoupper ($data[2])][] = strtoupper ($data[4] . '=' . $data[5]);
					} else {
						$a[$data[2]][] = $data[4] . '=' . $data[5];
					}
				}
				unset ($data);
				return $a;
			}
			return false;

		}

		/**
		* Get the current database encoding.
		*
		* @access public
		* @return mixed boolean or string
		*/

		function GetCharset () {

			$this->charSet = @pg_client_encoding ($this->_connectionID);
			if (!$this->charSet) {
				return false;
			}
			return $this->charSet;

		}

		/**
		* Set the database encoding.
		*
		* @access public
		* @param string	$charset_name	The encoding.
		* @return boolean
		*/

		function SetCharset ($charset_name) {

			$this->GetCharset ();
			if ($this->charSet !== $charset_name) {
				$if = pg_set_client_encoding ($this->_connectionID, $charset_name);
				if ($if == '0'&$this->GetCharset () == $charset_name) {
					return true;
				}
				return false;
			}
			return true;

		}

	}

	/* class SQLLayer_postgres7 */

	class SQLLayerRecordSet_postgres7 extends SQLLayerRecordSet_postgres64 {
		var $databaseType = 'postgres7';

		/**
		* Constructor
		*
		* @access public
		* @param ressource	$id
		* @param bool		$mode
		* @return void
		*/

		function SQLLayerRecordSet_postgres7 ($id, $mode = true) {

			$this->SQLLayerRecordSet_postgres64 ($id, $mode);

		}

	}

	/* class SQLLayerRecordSet_postgres7 */
}

?>