<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!function_exists ('get_var') ) {

	function get_var ($key, &$value, $type, $check = '', $prefix = false) {

		global $opnConfig, ${$opnConfig['opn_post_vars']}, ${$opnConfig['opn_get_vars']}, ${$opnConfig['opn_server_vars']}, ${$opnConfig['opn_file_vars']}, ${$opnConfig['opn_cookie_vars']}, ${$opnConfig['opn_session_vars']}, ${$opnConfig['opn_request_vars']}, ${$opnConfig['opn_env_vars']};

		$t = $prefix;
		$vars = array ();
		switch ($type) {
			case 'url':
				$vars = ${$opnConfig['opn_get_vars']};
				break;
			case 'form':
				$vars = ${$opnConfig['opn_post_vars']};
				break;
			case 'both':
				$vars = ${$opnConfig['opn_request_vars']};
				break;
			case 'server':
				$vars = ${$opnConfig['opn_server_vars']};
				break;
			case 'cookie':
				$vars = ${$opnConfig['opn_cookie_vars']};
				break;
			case 'session':
				$vars = ${$opnConfig['opn_session_vars']};
				break;
			case 'env':
				$temp = $value;
				$value = getenv ($key);
				if ($value === FALSE) {
					$value = $temp;
				}
				break;
			case 'file':
				$vars = ${$opnConfig['opn_file_vars']};
				break;
		}
		// switch
		if (isset ($vars[$key]) ) {
			$val = $vars[$key];
			if ($check == '') {
				$value = $val;
			} elseif ($check == _OOBJ_DTYPE_INT) {
				$value = intval ($val);
			}
		}
		unset ($vars);

	}
}

class file_db {
	var $filename = '';
	var $db = array ();

	function ReadDB () {

		$this->db = array ();
		$usando = '';
		$info = array ();
		if (file_exists ($this->filename) ) {
			$linhas = @file ($this->filename);
			$linsize = sizeof ($linhas);
			for ($x = 0; $x<$linsize; $x++) {
				$linha = trim ($linhas[$x]);

				#					$n = count($linhas)-1;
				$res = '';
				if (preg_match ("/'~~~'~~~'(.+)'~~~'~~~'/", $linha, $res) ) {
					if ($usando) {
						$ret[$usando] = $info[$usando];
					}
					$usando = $res[1];
				} else
				if ($usando) {
					$coluna = explode ("||", $linha);
					$colunasize = sizeof ($coluna);
					for ($l = 0; $l<$colunasize; $l++) {
						$coluna[$l] = urldecode ($coluna[$l]); $info[$usando][] = $coluna;
					}
				}
			}
			$ret[$usando] = $info[$usando]; $this->db = $ret;
		}

	}

	function FindIndex ($tabela, $col, $valor) {
		$mysize = sizeof ($this->db[$tabela]);
		for ($x = 0; $x<$mysize; $x++)
		if ($this->db[$tabela][$x][$col] == $valor) {
			return $x;
		}
		return false;

	}

}

function fallback ($op, $error = '') {

	global $opnConfig;

	$placebo = $op;
	$ex = & new file_db;
	$ex->filename = $opnConfig['root_path_datasave'] . 'opnfallback.php';
	$ex->ReadDB ();
	$index = $ex->FindIndex ('fallback', 0, 'adminmail');
	if ($index !== false) {
		$adminmail = $ex->db['fallback'][$index][1];
	}
	$email_to = $adminmail . ' <' . $adminmail . '>';
	$email_from_mail = $adminmail;
	$email_from_name = 'OPN Fallback User';
	$email_subject = 'DataBase Error';
	$REQUEST_URI = '';
	get_var ('REQUEST_URI', $REQUEST_URI, 'server');
	$DOCUMENT_ROOT = '';
	get_var ('DOCUMENT_ROOT', $DOCUMENT_ROOT, 'server');
	$HTTP_REFERER = '';
	get_var ('HTTP_REFERER', $HTTP_REFERER, 'server');
	$SERVER_NAME = '';
	get_var ('SERVER_NAME', $SERVER_NAME, 'server');
	$HTTP_USER_AGENT = '';
	get_var ('HTTP_USER_AGENT', $HTTP_USER_AGENT, 'server');
	$emailbody = 'Sorry, but' . _OPN_HTML_NL;
	$emailbody .= 'your OPN has detected a big problem...' . _OPN_HTML_NL;
	$emailbody .= _OPN_HTML_NL;
	$emailbody .= 'Please check the DataBase' . _OPN_HTML_NL;
	$emailbody .= _OPN_HTML_NL;
	$emailbody .= 'REQUEST_URI=' . $REQUEST_URI . ' - ' . _OPN_HTML_NL;
	$emailbody .= 'DOCUMENT_ROOT=' . $DOCUMENT_ROOT . ' - ' . _OPN_HTML_NL;
	$emailbody .= 'HTTP_REFERER=' . $HTTP_REFERER . ' - ' . _OPN_HTML_NL;
	$emailbody .= 'HTTP_USER_AGENT=' . $HTTP_USER_AGENT . ' - ' . _OPN_HTML_NL;
	$emailbody .= 'SERVER_NAME=' . $SERVER_NAME . ' - ' . _OPN_HTML_NL;
	$emailbody .= _OPN_HTML_NL;
	$emailbody .= 'ERROR=' . $error . ' - ' . _OPN_HTML_NL;
	$emailbody .= _OPN_HTML_NL;
	$header = 'From:' . $email_from_name . '<' . $email_from_mail . '>' . _OPN_HTML_NL;
	$header .= 'Reply-To: ' . $email_from_mail . _OPN_HTML_NL;
	$header .= 'X-Mailer: PHP/' . phpversion () . _OPN_HTML_NL;
	$header .= 'X-MSMail-Priority: High' . _OPN_HTML_NL;
	$header .= 'X-Priority: 1' . _OPN_HTML_NL;
	$header .= 'X-MimeOLE: generated by openPHPnuke' . _OPN_HTML_NL;
	$header .= 'Content-Type: text/html';
	mail ($email_to, $email_subject, $emailbody, $header);
	if (!class_exists ('opn_handler_logging') ) {
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.handler_logging.php');
	}
	$_logger = & new opn_handler_logging ('errors.log');
	$_logger->write ('DataBase Error: Please check the DataBase');
	$_logger->close ();
	$_logger = & new opn_handler_logging ('messages.log');
	$_logger->write ('DataBase Error: Please check the DataBase');
	$_logger->close ();

	?><p>&nbsp;OpenPHPNuke: Great Web Portal System<br />
		<br />
		&nbsp;Copyright (c) 2001-2006 by &nbsp;<br />
		&nbsp;Heinz Hombergs heinz@hhombergs.de<br />
		&nbsp;Stefan Kaletta stefan@kaletta.de<br />
		&nbsp;Alexander Weber xweber@kamelfreunde.de<br /><br />
		&nbsp;Error while connecting to database or within database itself<br />
		&nbsp;Fehler bei der Verbindung mit der Datenbank oder innerhalb der Datenbank<br />
		</p><?php

}

?>