<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/* Case study of a new installer
*
* This will NOT install opn (yet). It is just there to improve usabilty
*
* Alex
*/

if (file_exists('cache/install.lock') && !file_exists('cache/installer.unlock')) {
	echo 'opn<br /><br />your opn has already been installed - <a href="index.php">click here to visit your website</a>';
} else {
	/* we want a clean code, so we want to see all */
	error_reporting(E_ALL);
	ini_set('display_errors', true);

	if(!defined('_OPN_HTML_NL')) {
		define('_OPN_HTML_NL',"\n");
	}
	if(!defined('_OPN_SLASH')) {
		define('_OPN_SLASH',chr(92));
	}
	$installerdata = array();

	define('_OPNINSTALLER_MINPHPVERSION', '4.1.0');

	/*
	 * The classes
	 */

		/**
		 * OPN Installation Wizard class (all functionality should go here)
		 *
		 */
		class installer {

			/**
		 	 * Return the expected variables and their default values
		 	 *
		 	 * this is the place where you should "announce" your variables
		 	 * to use inside the installer. If you place thmen here they will
		 	 * automaticly be initalized and set to new values on url or post events
		 	 * Set the default value to something that match the later values since
		 	 * there will be a type check in the setting method to provide a little
		 	 * more security.
		 	 *
		 	 * @return array
			 */
			function get_installervariables() {
				$steps = array('welcome'=>'undone',
								'syscheck'=>'undone',
								'license'=>'done',
								'configuration'=>'undone',
								'execution'=>'undone',
								'finale'=>'undone');
				$internal = array('sessionpath'=>'original');

				$storage = array();
				$this->prepare_formvar($storage, 'license', 'licenseaccepted', 'bool', false);
				$this->prepare_formvar($storage, 'config_database', 'dbdriver', 'string', '', '', 1, 60);
				$this->prepare_formvar($storage, 'config_database', 'dbhost', 'string', '', '', 1, 60);
				$this->prepare_formvar($storage, 'config_database', 'dbport', 'string', '', '', 1, 60);
				$this->prepare_formvar($storage, 'config_database', 'dbusername', 'string', '', '', 1, 60);
				$this->prepare_formvar($storage, 'config_database', 'dbuserpassword', 'string', '', '', 0, 40);
				$this->prepare_formvar($storage, 'config_database', 'dbname', 'string', '', '', 1);
				$this->prepare_formvar($storage, 'config_database', 'dbprefix', 'string', 'opn', '', 0, 20);
				$this->prepare_formvar($storage, 'config_database', 'dbconnectstr', 'string', '', '', 0, 60);
				$this->prepare_formvar($storage, 'config_database', 'dbdialect', 'string', '', '', 0, 60);
				$this->prepare_formvar($storage, 'config_database', 'dbcharset', 'string', '', '', 0, 60);

				return array('debugmode'=>false,
								'language'=>$this->guess_language(),
								'goto'=>'welcome',
								'steps'=>$steps,
								'something'=>'new',
								'internal'=>$internal,
								'formdata'=>$storage
							);
			}

			/**
			 * returns the possible language in an array
			 *
			 * this is the only place where you should "announce" your possible
			 * languages for selection. They will be automaticly checked if they
			 * are present on the webserver.
			 *
			 * @return array
			 */
			function get_possiblelanguages() {

				$mylanguages = array('english'=>array('short'=>'en'),
									 'german'=>array('short'=>'de'),
									 'german_du'=>array(),
									 'german_utf8'=>array());

				if(defined('_INST_LANGFILEINCLUDED')) {
					$mylanguages['english']['text'] = _INST_LANG_ENGLISH;
					$mylanguages['german']['text'] = _INST_LANG_GERMAN;
					$mylanguages['german_du']['text'] = _INST_LANG_GERMANDU;
					$mylanguages['german_utf8']['text'] = _INST_LANG_GERMANUTF8;
				}

				$alllangs = array_keys($mylanguages);
				$lookupfor = 'install/installer-lang-';
				foreach ($alllangs as $lang) {
					if(file_exists($lookupfor.$lang.'.php')) {
						$mylanguages[$lang]['state']  = 'done';
					} else {
						$mylanguages[$lang]['state']  = 'error';
					}
				}
				return $mylanguages;
			}

			/**
			 * Guess what language to use depending on the users browser setting
			 *
			 * @param string $guessedlanguage the preset value if no guess can be made
			 * @return string
			 */
			function guess_language($guessedlanguage='english') {
				global $_SERVER;

				if (isset($_SERVER['HTTP_ACCEPT_LANGUAGE'])) {
					$foundlanguages = array();
					$browserlangs = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
					$count = 1;
					foreach ($browserlangs as $languagestring) {
						$found = preg_match ('/^([a-z]{1,8}(?:-[a-z]{1,8})*)(?:;\s*q=(0(?:\.[0-9]{1,3})?|1(?:\.0{1,3})?))?$/i', $languagestring, $items='');
						if ($found === 1) {
							$lang_code = explode ('-', $items[1]);
							$foundlanguages[$lang_code[0]] = $count;
							$count++;
						}
					}
					if(count($foundlanguages)>0) {
						$installedlangs = $this->get_possiblelanguages();
						$besthit = 999;
						foreach($installedlangs as $checklang=>$langproperties) {
							if($langproperties['state']=='done' && isset($langproperties['short'])) {
								if(isset($foundlanguages[$langproperties['short']]) && $foundlanguages[$langproperties['short']]<$besthit) {
									$guessedlanguage = $checklang;
									$besthit = $foundlanguages[$langproperties['short']];
								}
							}
						}
					}
				}
				return $guessedlanguage;
			}

			/**
			 * includes a file after checking if it exists
			 *
			 * @param string $filename the path and name of the file to include
			 * @return voind
			 */
			function includefile($include) {
				if(file_exists($include)) {
					include_once($include);
				}
			}

			/**
			 * checks if the given path is writable.
			 *
			 * If more than one path is submitted all are checked the first writeable is found.
			 * The name of the writable path is returned.
			 * Multi path should be seperated by semicolon
			 *
			 * @param string $pathtocheck
			 * @return string
			 */
			function check_writeable($pathtocheck) {
				$pathtocheck = explode(';', $pathtocheck);
				$check = false;
				foreach($pathtocheck as $currentpath) {
					if($currentpath!='') {
						$check = is_writable($currentpath);
					}
					if($check) {
						return $currentpath;
					}
				}
				return '';
			}

			/**
		 	 * Start the session and sets the data array values
		 	 *
		 	 * This will automaticly set the values to the data array.
		 	 * If you mix multiple send events in one pass, the latest
		 	 * event will win. Variable values will be set in the order
		 	 * session->get->post.
		 	 * There is also a little security check. The variable type
		 	 * must match the type of the default value for this variable.
		 	 * So it should be not that easy to place a string where only
		 	 * numeric values are used / expected.
		 	 *
		 	 * @return void
			 */
			function init_session() {
				global $installerdata;

				define('_OPNINSTALLER_ORIGSESSIONPATH', ini_get('session.save_path'));
				$usepath = $this->check_writeable(_OPNINSTALLER_ORIGSESSIONPATH);
				if($usepath=='') {
					$usepath = $this->check_writeable('cache/;./cache/;'.dirname(__FILE__).'/cache/;.;./;../');
					if($usepath!='') {
						session_save_path ($usepath);
					}
					$installerdata['internal']['sessionpath'] = $usepath;
				}

				session_start();
				if((isset($_SESSION['installerdata']) && count($_SESSION['installerdata'])>0) && (!isset($_GET['newsession']) || $_GET['newsession']!='yes')) {
					foreach ($_SESSION['installerdata'] as $variable=>$default) {
						$installerdata[$variable] = $default;
						if (isset($_GET[$variable]) && gettype($_GET[$variable])===gettype($default)) {
							$installerdata[$variable] = $_GET[$variable];
						}
						if (isset($_POST[$variable]) && gettype($_POST[$variable])===gettype($default)) {
							$installerdata[$variable] = $_POST[$variable];
						}
					}
				} else {
					$installerdata = $this->get_installervariables();
				}
			}

			/**
			 * Close the session
			 *
		 	 * for closing the session we will dump the current content of our data
		 	 * into the session. This method should be one of the last in your code
		 	 * otherwise there may be not the most current values stored into the session
		 	 *
		 	 * @return void
			 */
			function close_session() {
				global $installerdata;

				$_SESSION['installerdata'] = $installerdata;
			}

			/**
		 	 * Set the current opn version into the constant _OPN_VERSION
		 	 *
		 	 * @return void
			 */
			function set_opnversion() {
				if(!defined('_OPN_VERSION')) {
					if(!defined('_OPN_CLASS_opnVERSION_INCLUDED')) {
						if(!defined('_OPN_ROOT_PATH')) {define('_OPN_ROOT_PATH', ''); }
						include (_OPN_ROOT_PATH.'admin/openphpnuke/version.php');
					}
					define('_OPN_VERSION', _get_core_major_version().'.'._get_core_minor_version().'.'._get_core_bugfix_version().' '.versionname().' (Revision '._get_core_revision_version().')');
				}
			}

			/**
			 * add a container for a form data variane
			 *
			 * @param array $storage the new container will be added to this
			 * @param string $form name of the form
			 * @param string $varname name of the variable
			 * @param string $vartype the returned value from the form will be checked to match this type
			 * @param string $value initial value for the variable. The current value will also be stored here
		  	 * @param integer $min minmum value / character required
			 * @param integer $max maximumvalue / character required
			 * @param variant $testexpr checked if the input is valid
			 * @return void
			 */
			 function prepare_formvar(&$storage, $form, $varname, $vartype, $value, $testexpr='', $min=0, $max=0) {
				if (!is_array($storage)) {
					$storage = array();
				}
				$storage[$form][$varname]['vartype'] = $vartype;
				$storage[$form][$varname]['value'] = $value;
				$storage[$form][$varname]['varexpr'] = $testexpr;
				$storage[$form][$varname]['max'] = $max;
				$storage[$form][$varname]['min'] = $min;
				$storage[$form][$varname]['error'] = '';
			}

			/**
			 * This extracs the current setting for a variable of the formcontainer
			 *
			 * @param $form
			 * @param $varname
			 * @return array varcontainer
			 */
			function get_formvarcontainer($form, $varname) {
				global $installerdata;

				$varcontainer = array('tagname'=>'formdata_'.$form.'_'.$varname,
									  'value'=>$installerdata['formdata'][$form][$varname]['value'],
									  'min'=>$installerdata['formdata'][$form][$varname]['min'],
									  'max'=>$installerdata['formdata'][$form][$varname]['max'],
									  'error'=>$installerdata['formdata'][$form][$varname]['error']
									  );

				return $varcontainer;
			}

			/**
			 * Processes the POST vars for a given form name
			 *
			 * It processes the values into the session.
			 *
			 * @param $formname
			 * @return boolean errorsdetected
			 */
			function process_form($formname) {
				global $installerdata;

				$errordetected = false;

				if (isset($_POST[$formname]) && $_POST[$formname]==='processed') {
					foreach($installerdata['formdata'][$formname] as $varname=>$properties) {
						$formitem = 'formdata_'.$formname.'_'.$varname;
						if(!isset($_POST[$formitem])) {
							if ($properties['vartype']==='bool') {
								$installerdata['formdata'][$formname][$varname]['value'] = false;
								$_POST[$formitem] = false;
							} else {
								$_POST[$formitem] = '';
							}
						}
						$installerdata['formdata'][$formname][$varname]['error'] = '';
						if ($properties['vartype']==='string') {
							if($properties['min']>0 && $_POST[$formitem]=='') {
								$installerdata['formdata'][$formname][$varname]['error'] .= 'err_notempty,';
								$errordetected = true;
							}
							if($properties['min']>0 && strlen($_POST[$formitem])<$properties['min']) {
								$installerdata['formdata'][$formname][$varname]['error'] .= 'err_tooshort('.$properties['min'].'),';
								$errordetected = true;
							}
//							if($properties['max']>0 && strlen($_POST[$formitem])>$properties['max']) {
//								$installerdata['formdata'][$formname][$varname]['error'] .= 'err_tolong('.$properties['max'].')';
//								$errordetected = true;
//							}
							$installerdata['formdata'][$formname][$varname]['value'] = (string) $_POST[$formitem];
						}
						if ($properties['vartype']==='bool' && $_POST[$formitem]==='bool') {
							$installerdata['formdata'][$formname][$varname]['value'] = true;
						}
					}
				}
				return $errordetected;
			}

			/**
		 	 * Set the current opn version into the constant _OPN_VERSION
		 	 *
		 	 * @return void
			 */
			function do_systemcheck() {
				$check = array();
				$this->set_checkeditem($check, 'basic', 'phpver',
							'minimum php version ist greater or equal '._OPNINSTALLER_MINPHPVERSION,
							phpversion(),
							$this->bool2text(version_compare(phpversion(), _OPNINSTALLER_MINPHPVERSION, 'ge')),
							'it is quite important to have a uptodate php version. If your version does not match the requirements you will recieve some wired errors and you opn won\'t run as expected'
							);

				$this->set_checkeditem($check, 'basic', 'sesspath',
							'session path is writable ',
							_OPNINSTALLER_ORIGSESSIONPATH,
							$this->bool2text(ini_get('session.save_path')==_OPNINSTALLER_ORIGSESSIONPATH),
							'the session is needed to keep some values stored while you are logged in. If this path is not writable you may encounter problems'
							);

				return $check;
			}

			/**
		 	 * set / add a check item
		 	 *
		 	 * @param array $check add item to this array ByRef
		 	 * @param string $groupname the group where the check belongs to
		 	 * @param string $name the internal name of the check
		 	 * @param string $desc description what is tested for
		 	 * @param string $current whats the current value / setting
		 	 * @param mixed $result the checkresult
		 	 * @param string $hint some more descriptive text for the check
		 	 * @return void
			 */
			function set_checkeditem(&$check, $groupname, $name, $desc, $current, $result, $hint='') {
				$check[$groupname][$name]['desc'] = $desc;
				$check[$groupname][$name]['current'] = $current;
				$check[$groupname][$name]['result'] = $result;
				$check[$groupname][$name]['hint'] = $hint;
				$check[$groupname][$name]['combined'] = installerlayout::build_tooltip($current, '['._INST_DETAILS.': '.$hint.']');
			}

			/**
		 	 * turns a bool into a humand readable text
		 	 *
		 	 * @param bool $mybool contains the value to output
		 	 * @return void
			 */
			function bool2text($mybool) {
				if($mybool===true) {
					return 'yes';
				}
				if($mybool===false) {
					return 'no';
				}
				return 'unknown';
			}
		}


		/**
		 * OPN Installation Wizard layout class
		 *
		 * Will work like a tiny cms, so the hardcodet output will reduce to a minimum
		 */

		class installerlayout {
			var $headercontent;
			var $sidebarcontent;
			var $maincontent;
			var $footercontent;
			var $menuitems;
			var $submenuitems;
			var $formitems;

			/**
			 * Init
			 */
			function installerlayout() {
				$this->headercontent = '';
				$this->sidebarcontent = '';
				$this->maincontent = '';
				$this->footercontent = '';
				$this->menuitems = array();
				$this->submenuitems = array();
				$this->formitems = array();
			}

			/**
		 	 * start output of the initial html code
		 	 *
		 	 * @return void
			 */
			function draw_htmlstart() {
				echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'._OPN_HTML_NL;
				echo '<html xmlns="http://www.w3.org/1999/xhtml">'._OPN_HTML_NL;
			}

			/**
		 	 * end output of the html code
		 	 *
		 	 * @return void
			 */
			function draw_htmlend() {
				echo '</html>';
			}

			/**
		 	 * output of the html head section
		 	 *
		 	 * @return void
			 */
			function draw_htmlhead() {
				$this->draw_htmlstart();
				echo '<head>'._OPN_HTML_NL;
				echo '	<title>opn Installation Wizard</title>'._OPN_HTML_NL;
				echo '	<meta http-equiv="content-Type" content="text/html; charset=iso-8859-1" />'._OPN_HTML_NL;
				echo '	<meta name="author" content="oPn" />'._OPN_HTML_NL;
				echo '	<meta name="generator" content="OPN -- http://www.opn.info" />'._OPN_HTML_NL;
				echo '	<link href="install/installer.css" rel="stylesheet" type="text/css" />'._OPN_HTML_NL;
				echo '	<link href="install/niftyCorners.css" rel="stylesheet" type="text/css" />'._OPN_HTML_NL;
				echo '	<script type="text/javascript" src="java/nifty.js"></script>'._OPN_HTML_NL;
				echo '	<script type="text/javascript">'._OPN_HTML_NL;
				echo '	/*<![CDATA[*/'._OPN_HTML_NL;
				echo '		window.onload=function(){'._OPN_HTML_NL;
				echo '			if(!NiftyCheck())'._OPN_HTML_NL;
				echo '	    		return;'._OPN_HTML_NL;
/*				echo '			Rounded("div.header","tr bl","#FFF","transparent","smooth");'._OPN_HTML_NL;
				echo '			Rounded("div#horiznav li","tr bl","transparent","#6F6F6F","border #6C6C6C");'._OPN_HTML_NL;
		#		echo '			Rounded("div.header h1","tr bl","#FFF","transparent");'._OPN_HTML_NL;
				echo '			Rounded("div#content","tl bottom","#FFF","#FFF","smooth");'._OPN_HTML_NL;
				echo '			Rounded("div.nav","bottom","#FFF","transparent","smooth");'._OPN_HTML_NL;
				echo '			Rounded("div.sidenotes","bottom","#FFF","transparent","smooth");'._OPN_HTML_NL;
				echo '			Rounded("form","all","#FFF","#B4CEF7","smooth");'._OPN_HTML_NL;
				echo '			Rounded("blockquote","tr bl","#FFF","#CDFFAA","border #88D84F");'._OPN_HTML_NL;
				echo '			Rounded("div#relax","all","#FFF","transparent");'._OPN_HTML_NL;
				echo '			Rounded("div#footer","tr bl","#FFF","transparent","small border #fff");'._OPN_HTML_NL;
				echo '			Rounded("h3","all","transparent","#efeadc","border #DADADA");';*/
/*
				echo '			Rounded("div#header","top","#FFFFFF","transparent","border #FFF smooth");'._OPN_HTML_NL;
				echo '			Rounded("div#sidenote","all","#FFFFFF","#C4EFA1","smooth");'._OPN_HTML_NL;
//				echo '			Rounded("div#mainmenu li a","bottom","#FFF","#3D4B69"," small smooth");'._OPN_HTML_NL;
				echo '			Rounded("li.mainmenuactive","bottom","#FFF","transparent","small smooth");'._OPN_HTML_NL;
				echo '			Rounded("li.mainmenuinactive","bottom","#FFF","transparent","small smooth");'._OPN_HTML_NL;

//				echo '			Rounded("div#submenu li a","top","#FFF","#747474","border #747474 small smooth");'._OPN_HTML_NL;
				echo '			Rounded("li.submenuactive","top","#FFF","transparent","small smooth");'._OPN_HTML_NL;
				echo '			Rounded("li.submenuinactive","top","#FFF","transparent","small smooth");'._OPN_HTML_NL;

				echo '			Rounded("div#footer","bottom","#ffffff","#E4ECEC","smooth");'._OPN_HTML_NL;
				*/
				echo '			Rounded("div#header","top","#FFFFFF","transparent","border #FFF smooth");'._OPN_HTML_NL;
				echo '			Rounded("div#sidenote","all","#FFFFFF","#C4EFA1","smooth");'._OPN_HTML_NL;
				echo '			Rounded("div#footer","bottom","#ffffff","transparent","smooth");'._OPN_HTML_NL;
				echo '			Rounded("ul#mainnav li a","top","#3D4B69","#747F96","smooth");'._OPN_HTML_NL;
				echo '			Rounded("ul#subnav li a","top","#FFFFFF","#747F96","smooth");'._OPN_HTML_NL;
				echo '			Rounded("li.submenuactive","top","#FFF","transparent","small smooth");'._OPN_HTML_NL;
				echo '			Rounded("li.submenuinactive","top","#FFF","transparent","small smooth");'._OPN_HTML_NL;
//				echo '			Rounded("ul#mainnav li a.mainmenuactive","top","#3D4B69","#FFFFFF","smooth");';

				echo '		}'._OPN_HTML_NL;
				echo '		/*]]>*/'._OPN_HTML_NL;
				echo '	</script>'._OPN_HTML_NL;
				echo '</head>'._OPN_HTML_NL;
			}

			/**
		 	 * output of the html body section
		 	 *
		 	 * @return void
			 */
			function draw_htmlbody() {
				echo '<body>'._OPN_HTML_NL;
				echo '<div id="nifty"><div id="container">'._OPN_HTML_NL;
				$this->draw_headerbox();
				$this->draw_menu();
				$this->draw_submenu();
				$this->draw_mainbox();
				$this->draw_footer();
				echo '</div></div>'._OPN_HTML_NL;
				echo '</body>'._OPN_HTML_NL;
				$this->draw_htmlend();
			}

			/**
		 	 * output of a titlebox
		 	 *
		 	 * @return void
			 */
			function draw_headerbox() {
				echo '<div id="header">'._OPN_HTML_NL;
				echo $this->headercontent;
				echo '</div>'._OPN_HTML_NL;
			}

			/**
		 	 * output of the menu
		 	 *
		 	 * @param array $myitems a structured array of menuitems
		 	 * @return void
			 */
			function draw_menu() {
				if(count($this->menuitems)>0) {
					echo '<div id="mainmenu">'._OPN_HTML_NL;
					echo '	<ul id="mainnav">'._OPN_HTML_NL;
					$i = 0;
					foreach ($this->menuitems as $name=>$properties) {
						$i++;
						$class = '';
						if($properties['state']!='') {
							$class = ' class="mainmenu'.$properties['state'].'"';
						}
						if($properties['state']!='active') {
							echo '		<li class="mainmenuinactive"><a'.$class.' href="installer.php?goto='.$name.$properties['link'].'">'.$properties['title'].'</a></li>'._OPN_HTML_NL;
						} else {
							echo '		<li class="mainmenuactive"><a'.$class.' href="installer.php?goto='.$name.$properties['link'].'">'.$properties['title'].'</a></li>'._OPN_HTML_NL;
						}
					}
					echo '	</ul>'._OPN_HTML_NL;
					echo '</div>'._OPN_HTML_NL;
				}
			}

			/**
		 	 * output of the submenu
		 	 *
		 	 * @param array $myitems a structured array of submenuitems
		 	 * @return void
			 */
			function draw_submenu() {
				if(count($this->submenuitems)>0) {
					echo '<div id="submenu">'._OPN_HTML_NL;
					echo '	<ul id="subnav">'._OPN_HTML_NL;
					$i = 0;
					foreach ($this->submenuitems as $name=>$properties) {
						$i++;
						$class = '';
						if($properties['state']!='') {
							$class = ' class="submenu'.$properties['state'].'"';
						} else {
							$class = ' class="submenuundone"';
						}

						if($properties['state']!='active') {
							echo '		<li class="submenuinactive"><a'.$class.' href="installer.php?sub='.$name.$properties['link'].'">'.$properties['title'].'</a></li>'._OPN_HTML_NL;
						} else {
							echo '		<li class="submenuactive"><a'.$class.' href="installer.php?sub='.$name.$properties['link'].'">'.$properties['title'].'</a></li>'._OPN_HTML_NL;
						}
					}
					echo '	</ul>'._OPN_HTML_NL;
					echo '</div>'._OPN_HTML_NL;
				}
			}

			/**
		 	 * output of the main text
		 	 *
		 	 * @return void
			 */
			function draw_mainbox() {
				if($this->maincontent!='') {
					echo '<div id="main">'._OPN_HTML_NL;
					$this->draw_sidebar();
					echo ' <div id="content">'._OPN_HTML_NL;
					echo $this->maincontent;
					echo ' </div>'._OPN_HTML_NL;
					echo '</div>'._OPN_HTML_NL;
				}
			}

			/**
		 	 * output of a footer
		 	 *
		 	 * @return void
			 */
			function draw_footer() {
				global $installerdata;

				if($this->footercontent!='') {
					echo '<div id="footer">'._OPN_HTML_NL;
					echo '	<address>'._OPN_HTML_NL.$this->footercontent.'	</address>'._OPN_HTML_NL;
					echo '</div>'._OPN_HTML_NL;
				}
				if($installerdata['debugmode']===true) {
					echo '<br /><br /><blockquote><p>debugmode detected - dumping $installerdata and $_SESSION</p>';
					ob_start();
					var_dump($installerdata);
					var_dump($_SESSION);
					var_dump($_POST);
					$content = ob_get_contents();
					ob_end_clean();
					echo '<pre>'.htmlspecialchars($content).'</pre></blockquote>';
				}
			}

			/**
		 	 * output of the sidebar
		 	 *
		 	 * @return void
			 */
			function draw_sidebar() {
				if($this->sidebarcontent!='') {
					echo ' <div id="sidenote">'._OPN_HTML_NL;
					echo $this->sidebarcontent;
					echo ' </div>'._OPN_HTML_NL;
				}
			}

			/**
		 	 * add a text to the sidebar
		 	 *
		 	 * @param string $myheadline headline for this content - empty string possible
		 	 * @param string $mycontent text to add
		 	 * @return void
			 */
			function add_sidebarcontent($myheadline, $mycontent) {
				if($myheadline!='') {
					$this->sidebarcontent .= '	<h3>'.$myheadline.'</h3>'._OPN_HTML_NL;
				}
				$this->sidebarcontent .= '	<p>'.$mycontent.'</p>'._OPN_HTML_NL._OPN_HTML_NL;
			}

			/**
		 	 * add content for the header box
		 	 *
		 	 * @param string $mycontent html text to add
		 	 * @return void
			 */
			function add_headercontent($mycontent) {
				$this->headercontent .= $mycontent._OPN_HTML_NL;
			}

			/**
		 	 * add content for the main box
		 	 *
		 	 * @param string $myheadline headline for this content - empty string possible
		 	 * @param string $mycontent text to add
		 	 * @return void
			 */
			function add_maincontent($myheadline, $mycontent) {
				if($myheadline!='') {
					$this->maincontent .= '	<h2>'.$myheadline.'</h2>'._OPN_HTML_NL;
				}
				$this->maincontent .= '	<p>'.$mycontent.'</p>'._OPN_HTML_NL._OPN_HTML_NL;
			}

			/**
		 	 * add content for the footer box
		 	 *
		 	 * @param string $mycontent html text to add
		 	 * @return void
			 */
			function add_footercontent($mycontent) {
				$this->footercontent .= $mycontent._OPN_HTML_NL;
			}

			/**
		 	 * add or set a menuitem
		 	 *
		 	 * @param string $myname name of the navigation point
		 	 * @param string $mytitle the title to display inside the box
		 	 * @param string $mystate this will change the color of the navbox.
		 	 * @param string $mylink Where to go when clicking this item
		 	 * @return void
			 */
			function set_menuitem($myname, $mytitle, $mystate='', $mylink='') {
				global $installerdata;

				if($mytitle!='*') {
					$this->menuitems[$myname]['title'] = $mytitle;
				}
				if($mylink!='*') {
					$this->menuitems[$myname]['link'] = $mylink;
				}
				if($mystate!='*') {
					if($mystate!='') {
						$this->menuitems[$myname]['state'] = $mystate;
					} else {
						$this->menuitems[$myname]['state'] = $installerdata['steps'][$myname];
					}
				}
			}

			/**
		 	 * add or set a submenuitem
		 	 *
		 	 * @param string $myname internal name of the navigation point
		 	 * @param string $mytitle the title to display
		 	 * @param string $mystate set this to 'active' for the current item
		 	 * @param string $mylink where to go when clicking this item
		 	 * @return void
			 */
			function set_submenuitem($myname, $mytitle, $mystate='', $mylink='') {

				if($mytitle!='*') {
					$this->submenuitems[$myname]['title'] = $mytitle;
				}
				if($mylink!='*') {
					$this->submenuitems[$myname]['link'] = $mylink;
				}
				if($mystate!='*') {
					if($mystate!='') {
						$this->submenuitems[$myname]['state'] = $mystate;
					} else {
						$this->submenuitems[$myname]['state'] = '';
					}
				}
			}

			/**
		 	 * structured output of syscheck results
		 	 *
		 	 * @param array $myitems a structured array
		 	 * @return void
			 */
			function add_syscheckresults($myitems) {
				if(count($myitems)>0) {
					foreach ($myitems as $section=>$items) {
						$this->maincontent .= '	<h2>'.$section.'</h2>'._OPN_HTML_NL;
						$this->maincontent .= '	<dl id="bdragon">'._OPN_HTML_NL;
						foreach ($items as $item) {
							$this->maincontent .= '				<dt>'.$item['desc'].'</dt>'._OPN_HTML_NL;
							if($item['result']=='yes') {
								$ddcssname = ' class="success"';
								$humanreadable = _INST_SUCCESS;
							} elseif($item['result']=='no') {
								$ddcssname = ' class="failed"';
								$humanreadable = _INST_FAILED;
							} else {
								$ddcssname = '';
								$humanreadable = _INST_UNKNOWN;
							}
							$this->maincontent .= '				<dd'.$ddcssname.'>'.$humanreadable.' -&gt; '.$item['combined'].'</dd>'._OPN_HTML_NL;
						}
						$this->maincontent .= '	</dl>'._OPN_HTML_NL;
					}
				}
			}

			/**
		 	 * prints a complete html table
		 	 *
		 	 * @param string $summary the summary for the table. Should be used to describe the primary purpose of the table and give an indication of its overall structure.
		 	 * @param string $caption the caption for the table
		 	 * @param array $mycolums an array with the caption key and title text
		 	 * @param array $myitems a structured array
		 	 * @return void
			 */
			function add_table($summary, $caption, $mycolums, $myitems) {
				if(count($myitems)>0) {
					if($summary!='') {
						$summary = ' summary="'.$summary.'"';
					}
					$this->maincontent .= '	<table'.$summary.'">'._OPN_HTML_NL;
					if($caption!='') {
						$this->maincontent .= '		<caption>"'.$caption.'"</caption>'._OPN_HTML_NL;
					}
					$this->maincontent .= '	<tr>'._OPN_HTML_NL;
					foreach ($mycolums as $abbreviation=>$title) {
						if($title!='') {
							$this->maincontent .= '		<th abbr="'.$abbreviation.'">'.$title.'</th>'._OPN_HTML_NL;
						} else {
							$this->maincontent .= '		<td></td>'._OPN_HTML_NL;
						}
					}
					$this->maincontent .= '	</tr>'._OPN_HTML_NL;

					foreach ($myitems as $title=>$item) {
						$this->maincontent .= '	<tr>'._OPN_HTML_NL;
						foreach ($mycolums as $abbreviation=>$caption) {
							if($abbreviation=='hasrowheader') {
								$this->maincontent .= '		<th>'.$title.'</th>'._OPN_HTML_NL;
							} else {
								if(isset($item[$abbreviation])) {
									$this->maincontent .= '		<td>'.$item[$abbreviation].'</td>'._OPN_HTML_NL;
								}
							}
						}
						$this->maincontent .= '	</tr>'._OPN_HTML_NL;
					}
					$this->maincontent .= '	</table>'._OPN_HTML_NL;
				}
			}

			/**
			 * build a word with tooltip mouseover effect
			 *
			 * @param string $text the word or text wich will cause the mouseover
			 * @param string $tooltip  the tooltiptext
			 * @return string
			 */
			function build_tooltip($text, $tooltip) {
				return $text.' <p>'.$tooltip.'</p>'._OPN_HTML_NL;
			}

			/**
			 * converts the system readable error type into a human readable text
			 *
			 * @param string $errors the comma seperated string with errors
			 * @return string
			 */
			function build_humanreadable_error($errors) {
				$errortext = '';
				if($errors!='') {
					$errors = substr($errors, 0, -1);
					$errors = explode(',', $errors);
					foreach($errors as $error) {
						$error = explode('(', $error);
						$limit = '';
						if(isset($error[1])) {
							$limit = substr($error[1],0,-1);
						}
						switch($error[0]) {
							case 'err_tooshort':
								$errortext .= '<p>'.sprintf(_INST_ERR_TOOSHORT, $limit).'</p>';
								break;
							case 'err_notempty':
								$errortext .= '<p>'._INST_ERR_NOTEMPTY.'</p>';
								break;

						}
					}
				}
				return $errortext;
			}

			/**
			 * Add a form to the content
			 *
			 * The item should be add by their functions
			 *
			 * @param string $formname name of the form. This is also used to process the formdate after sending
			 * @return void
			 */
			function add_form($formname) {
				$formitemcount = 0;
				if(count($this->formitems)>0) {
					$this->maincontent .= '	<form name="'.$formname.'" action="installer.php" method="post" id="'.$formname.'">'._OPN_HTML_NL;

					foreach($this->formitems as $legend=>$fieldsetitems) {
						$this->maincontent .= '	 <fieldset><legend>'.$legend.'</legend>'._OPN_HTML_NL;
						$this->maincontent .= '	  <dl class="tdisplay">'._OPN_HTML_NL;
						foreach($fieldsetitems as $item) {
							$item['label'] = sprintf($item['label'], $formitemcount);
							$item['tag'] = sprintf($item['tag'], $formitemcount);
							$this->maincontent .= '		<dt>'.$item['label'].'</dt>'._OPN_HTML_NL;
							$this->maincontent .= '		<dd>'.$item['tag'].'</dd>'._OPN_HTML_NL;
							if($item['error']!=='') {
								$this->maincontent .= '		<dd class="error">'.$this->build_humanreadable_error($item['error']).'</dd>'._OPN_HTML_NL;
							}
							$formitemcount++;
						}
						$this->maincontent .= '	  </dl>'._OPN_HTML_NL;
						$this->maincontent .= '	 </fieldset>'._OPN_HTML_NL;
					}
					$this->maincontent .= '	 <input type="hidden" name="'.$formname.'" value="processed" />'._OPN_HTML_NL;
					$this->maincontent .= '	 <input type="submit" value=" '._INST_SUBMITDATA.' " />'._OPN_HTML_NL;
					$this->maincontent.= '	</form>'._OPN_HTML_NL;
					$this->formitems = array();
				}
			}

			/**
			 * Generic form item add method. Do not use this directly.
			 *
			 * @param $fieldset
			 * @param $label
			 * @param $tag
			 * @param $error
			 * @param $wrapasinput
			 * @return void
			 */
			function add_formitem($fieldset, $label, $tag, $error='', $wrapasinput=true) {
				if(isset($this->formitems[$fieldset])) {
					$formitemcount = count($this->formitems[$fieldset]);
				} else {
					$formitemcount = 0;
				}
				if($wrapasinput===true) {
					$tag = '<input id="formitem%s" '.$tag.' />';
				}
				$label = '<label for="formitem%s">'.$label.'</label>';
				$this->formitems[$fieldset][$formitemcount] = array(
														'label'=>$label,
														'tag'=>$tag,
														'error'=>$error);
			}

			/**
			 * Add a text input field for your form
			 *
			 * @param string $fieldset name of the fieldset this field belongs to
			 * @param string $label the label for this field
			 * @param array $varcontainer contains additional informations for the field
			 * @param numeric $size display size of the field
			 * @param string $note add a hint note for this input field
			 * @return void
			 */
			function add_formtextinput($fieldset, $label, $varcontainer, $size=0, $note='') {
				$maxlength = '';
				if($varcontainer['max']>0) {
					$maxlength = ' maxlength="'.$varcontainer['max'].'"';
				}
				$size = '';
				if($size>0) {
					$size = ' size="'.(int)$size.'"';
				}
				$name = ' name="'.$varcontainer['tagname'].'"';
				$this->add_formitem($fieldset, $label, 'type="text" value="'.$varcontainer['value'].'"'.$name.$size.$maxlength, $varcontainer['error']);
				if($note!='') {
					$this->add_sidebarcontent($label, $note);
				}
			}

			/**
			 * Add a select box for your form
			 *
			 * @param string $fieldset name of the fieldset this field belongs to
			 * @param string $label the label for this field
			 * @param array $options the options that should be selectable
			 * @param array $varcontainer contains additional informations for the field
			 * @param numeric $size display size of the field
			 * @param string $note add a hint note for this input field
			 * @return void
			 */
			function add_formselectbox($fieldset, $label, $options, $varcontainer, $size=0, $note='') {
				$size = '';
				if($size>0) {
					$size = ' size="'.(int)$size.'"';
				}
				$tag = '<select id="formitem%s" name="'.$varcontainer['tagname'].'" size="1" title="'._INST_PLEASESELECT.'">'._OPN_HTML_NL;
				if(is_array($options)) {
					if($varcontainer['value']=='') {
						$selected = ' selected="selected"';
					} else {
						$selected = '';
					}
					$tag .= '		  <option disabled="disabled"'.$selected.'>'._INST_PLEASESELECT.':</option>'._OPN_HTML_NL;
					foreach($options as $value=>$option) {
						if($varcontainer['value']==$value) {
							$selected = ' selected="selected"';
						} else {
							$selected = '';
						}
						$tag .= '		  <option value="'.$value.'"'.$selected.'>'.$option.'</option>'._OPN_HTML_NL;
					}
				}
				$tag .= '		 </select>';
				$this->add_formitem($fieldset, $label, $tag, $varcontainer['error'], false);

				if($note!='') {
					$this->add_sidebarcontent($label, $note);
				}
			}

			/**
			 * Add a checkbox to your form
			 *
			 * @param $fieldset
			 * @param $label
			 * @param $varcontainer
			 * @return void
			 */
			function add_formcheckbox($fieldset, $label, $varcontainer) {
				$state = '';
				if($varcontainer['value']===true) {
					$state = ' checked="checked"';
				}
				$name = ' name="'.$varcontainer['tagname'].'"';
				$this->add_formitem($fieldset, $label, 'type="checkbox" value="bool"'.$name.$state);
			}
		}
	/*
	 * End of the classes
	 */

	/* Now to the beef */
	$install = new installer;
	$install->init_session();
	$install->set_opnversion();

	$layout = new installerlayout;

	$install->includefile('install/installer-lang-'.$installerdata['language'].'.php');
	define('_INST_LANGFILEINCLUDED', 'true');

	$layout->add_headercontent('<h1>OPN '._INST_INSTALLWIZARD.'</h1>');
	$layout->add_headercontent('<h2>Version '._OPN_VERSION.'</h2>');
	$layout->add_footercontent('&copy; by opn - '._INST_SEECREDITS);

	$layout->set_menuitem('welcome', _INST_MENUWELCOME);
	$layout->set_menuitem('syscheck', _INST_MENUSYSCHECK);
	$layout->set_menuitem('license', _INST_MENUACCEPTLICENSE);
	$layout->set_menuitem('configuration', _INST_MENUCONFIGURATION);
	$layout->set_menuitem('execution', _INST_MENUEXECUTION);
	$layout->set_menuitem('finale', _INST_MENUFINALE);

	switch ($installerdata['goto']) {
		case 'welcome':
			$layout->set_menuitem('welcome', '*', 'active');

			$mylanguages = $install->get_possiblelanguages();
			foreach ($mylanguages as $language=>$langproperties) {
				$layout->set_submenuitem($language, $langproperties['text'], $langproperties['state'], '&amp;language='.$language);
			}
			$layout->set_submenuitem($installerdata['language'], '*', 'active', '*');

			$layout->add_sidebarcontent(_INST_NOTE, _INST_WELCOME_NOTELANGUAGE);

			$layout->add_maincontent(_INST_HEADLINEWELCOME, _INST_TEXTWELCOME);
//TODO: Change != to ==
			if($installerdata['internal']['sessionpath']!='') {
				$check = array();
				$install->set_checkeditem($check, _INST_ALERT, 'sesspath',
							_INST_INITSESSIONFORINSTALLER,
							_INST_INITSESSIONFORINSTALLER,
							'no',
							_INST_SESSIONPATHUNUSABLE
							);
				$layout->add_syscheckresults($check);
			}

			$layout->add_maincontent(_INST_HEADLINESELLANG, _INST_TEXTSELLANG);
			$layout->add_maincontent(_INST_HEADLINEABOUTWIZARD, _INST_TEXTABOUTWIZARD1);
			$layout->add_maincontent('', '<a href="installer.php?newsession=yes">'._INST_TEXTABOUTWIZARD2.'</a>.');
			$layout->add_maincontent('', _INST_TEXTABOUTWIZARD3.$install->guess_language());
			$installarray['steps']['welcome'] = 'done';
			break;
		case 'syscheck':
			$layout->set_menuitem('syscheck', '*',  'active');
			$layout->add_sidebarcontent(_INST_NOTE, 'This system check gets its values from the webserver. If your webserver responds not the true values or blocks the needed funtions to query the values, this check may provide false messages');

			$content = $install->do_systemcheck();
			$layout->add_maincontent('system check', 'This step will check for required conditions to be met for installtion of opn');
			$layout->add_maincontent('result', 'The system check has run its tests and here are the results');
			$layout->add_syscheckresults($content);

#			$layout->add_maincontent('Another way to display', 'This time we will output the results as html table.');
#			$layout->add_table('system check results', 'basic', array('hasrowheader'=>'', 'desc'=>'description', 'current'=>'current value', 'hint'=>'hint'), $content['basic']);
#			$layout->add_table('system check results', 'basic', array('desc'=>'description', 'hint'=>'hint', 'current'=>'current value'), $content['basic']);
			break;
		case 'license':
			$layout->set_menuitem('license', '*', 'active');
			$install->process_form('license');
			$layout->add_maincontent('license', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit.');
			$layout->add_formcheckbox('Legende', _INST_LIC_IACCEPTTHELICENSE, $install->get_formvarcontainer('license', 'licenseaccepted'));

			$layout->add_form('license');

			break;
		case 'configuration':
			$layout->set_submenuitem('basic', _INST_BASICSETTINGS, 'undone');
			$layout->set_submenuitem('database', _INST_DATABASESETTINGS, 'undone');
			$layout->set_submenuitem('extended', _INST_EXTENDEDSETTINGS, 'undone');

			$layout->set_menuitem('configuration', '*', 'active');

			if(!isset($installerdata['sub']) || $installerdata['sub']=='') {
				$installerdata['sub'] = 'database';
			}

			switch ($installerdata['sub']) {
				case 'basic':
					$layout->set_submenuitem('basic', '*', 'active');
					$layout->add_maincontent(_INST_BASICSETTINGS, 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit.');
					break;
				case 'database':
					$layout->set_submenuitem('database', '*', 'active');
					$install->process_form('config_database');

					$layout->add_maincontent(_INST_DATABASESETTINGS, _INST_CONFDB_TEXT);
					$layout->add_sidebarcontent(_INST_NOTE, _INST_FIELDSNOTES);

					$possibledrivers = array('firebird'=>_INST_CONFDB_DBDRIVERFIREBIRD,
											 'ibase'=>_INST_CONFDB_DBDRIVERIBASE,
											 'borland_ibase'=>_INST_CONFDB_DBDRIVERBORLANDIBASE,
											 'mssql'=>_INST_CONFDB_DBDRIVERMSSQL,
											 'mysql'=>_INST_CONFDB_DBDRIVERMYSQL,
 											 'mysqli'=>_INST_CONFDB_DBDRIVERMYSQLI,
											 'mysqlt'=>_INST_CONFDB_DBDRIVERMYSQLT,
											 'postgres'=>_INST_CONFDB_DBDRIVERPOSTGRES64,
											 'postgres7'=>_INST_CONFDB_DBDRIVERPOSTGRES7,
											 'sqlite'=>_INST_CONFDB_DBDRIVERSQLITE);

					$possibledialects = array('1'=>_INST_CONFDB_DBDIALECT1,
											  '2'=>_INST_CONFDB_DBDIALECT2,
											  '3'=>_INST_CONFDB_DBDIALECT3);

					$possiblecharsets = array('NONE'=>_INST_CONFDB_DBNONE,
											  'ASCII'=>_INST_CONFDB_DBASCII,
											  'BIG_5'=>_INST_CONFDB_DBBIG5,
											  'CYRL'=>_INST_CONFDB_DBCYRL,
											  'DOS437'=>_INST_CONFDB_DBDOS437,
											  'DOS850'=>_INST_CONFDB_DBDOS850,
											  'DOS852'=>_INST_CONFDB_DBDOS852,
											  'DOS857'=>_INST_CONFDB_DBDOS857,
											  'DOS860'=>_INST_CONFDB_DBDOS860,
											  'DOS861'=>_INST_CONFDB_DBDOS861,
											  'DOS863'=>_INST_CONFDB_DBDOS863,
											  'DOS865'=>_INST_CONFDB_DBDOS865,
											  'EUCJ_0208'=>_INST_CONFDB_DBEUCJ0208,
											  'GB_2312'=>_INST_CONFDB_DBGB2312,
											  'ISO8859_1'=>_INST_CONFDB_DBISO88591,
											  'ISO8859_2'=>_INST_CONFDB_DBISO88592,
											  'KSC_5601'=>_INST_CONFDB_DBKSC5601,
											  'NEXT'=>_INST_CONFDB_DBNEXT,
											  'OCTETS'=>_INST_CONFDB_DBOCTETS,
											  'SJIS_0208'=>_INST_CONFDB_DBSJIS0208,
											  'UNICODE_FSS'=>_INST_CONFDB_DBUNICODEFSS,
											  'WIN1250'=>_INST_CONFDB_DBWIN1250,
											  'WIN1251'=>_INST_CONFDB_DBWIN1251,
											  'WIN1252'=>_INST_CONFDB_DBWIN1252,
											  'WIN1253'=>_INST_CONFDB_DBWIN1253,
											  'WIN1254'=>_INST_CONFDB_DBWIN1254);

					$layout->add_formselectbox(_INST_CONFDB_DBSERVERITEMS, _INST_CONFDB_DBDRIVER, $possibledrivers, $install->get_formvarcontainer('config_database', 'dbdriver'), 0, _INST_CONFDB_DBDRIVERTEXT);
					$layout->add_formtextinput(_INST_CONFDB_DBSERVERITEMS, _INST_CONFDB_DBHOST, $install->get_formvarcontainer('config_database', 'dbhost'), 0, _INST_CONFDB_DBHOSTTEXT);
					$layout->add_formtextinput(_INST_CONFDB_DBSERVERITEMS, _INST_CONFDB_DBPORT, $install->get_formvarcontainer('config_database', 'dbport'), 0, _INST_CONFDB_DBPORTTEXT);
					$layout->add_formtextinput(_INST_CONFDB_DBITEMS, _INST_CONFDB_DBNAME, $install->get_formvarcontainer('config_database', 'dbname'), 0, _INST_CONFDB_DBNAMETEXT);
					$layout->add_formtextinput(_INST_CONFDB_DBITEMS, _INST_CONFDB_DBUSERNAME, $install->get_formvarcontainer('config_database', 'dbusername'), 0, _INST_CONFDB_DBUSERNAMETEXT);
					$layout->add_formtextinput(_INST_CONFDB_DBITEMS, _INST_CONFDB_DBUSERPASSWORD, $install->get_formvarcontainer('config_database', 'dbuserpassword'), 0, _INST_CONFDB_DBUSERPASSWORDTEXT);
					$layout->add_formtextinput(_INST_CONFDB_TABLEITEMS, _INST_CONFDB_TABLEPREFIX, $install->get_formvarcontainer('config_database', 'dbprefix'), 0, _INST_CONFDB_TABLEPREFIXTEXT);
					$layout->add_formtextinput(_INST_CONFDB_EXTRAITEMS, _INST_CONFDB_DBCONNECTIONSTR, $install->get_formvarcontainer('config_database', 'dbconnectstr'), 0, _INST_CONFDB_DBCONNECTIONSTRTEXT);
					$layout->add_formselectbox(_INST_CONFDB_EXTRAITEMS, _INST_CONFDB_DBDIALECT, $possibledialects, $install->get_formvarcontainer('config_database', 'dbdialect'), 0, _INST_CONFDB_DBDIALECTTEXT);
					$layout->add_formselectbox(_INST_CONFDB_EXTRAITEMS, _INST_CONFDB_DBCHARSET, $possiblecharsets, $install->get_formvarcontainer('config_database', 'dbcharset'), 0, _INST_CONFDB_DBCHARSETTEXT);

					$layout->add_form('config_database');
					break;
			}
			break;
		case 'execution':
			$layout->set_menuitem('execution', '*', 'active');
			$layout->add_maincontent('execution', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit.');
			break;
		case 'finale':
			$layout->set_menuitem('finale', '*', 'active');
			$layout->add_maincontent('finale', 'Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit.');
			break;
	}

	$layout->draw_htmlhead();
	$layout->draw_htmlbody();

	$install->close_session();
}
?>