<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

/*
* Makros:
*
* class OPN_MACRO_XL_[makroname]
*
* 	function parse (&$text) {
*    			...
* 	}
*
* }
*
*/

class OPN_MACRO_XL_modul_autolink {
	var $search = array ();
	var $replace = array ();

	function OPN_MACRO_XL_modul_autolink () {

		global $opnConfig, $opnTables;

		$i = 0;
		$css = 'opn' . $opnConfig['opnOutput']->GetDisplaySide () . 'box';
		$sql = 'SELECT id, autolink, meaning, declaration, lastmod FROM ' . $opnTables['auto_link'];
		$result = &$opnConfig['database']->Execute ($sql);
		if ( ($result !== false) && ($result->fields !== false) ) {
			while (! $result->EOF) {
				$id = $result->fields['id'];
				$term = $result->fields['autolink'];
				$meaning = $result->fields['meaning'];
				$declaration = $result->fields['declaration'];
				if ($meaning != '') {
					if ($declaration != '') {
						$link = '<a class="' . $css . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/auto_link/index.php',
													'op' => 'showautolink',
													'id' => $id) ) . '" title="' . $meaning . '">' . $term . '</a>';
					} else {
						$link = str_replace ('*CLASS*', $css, $meaning);
					}
				} else {
					$link = str_replace ('*CLASS*', $css, $declaration);
				}
				$this->search[$i] = '#(?!<.*?)(' . preg_quote ($term) . ')(?![^<>]*?>)#i';

				/*
				$this->search[$i] = '#(?!<.*?)(\b' . preg_quote ($term) . '\b)(?![^<>]*?>)#i';
				*/

				$this->replace[$i] = $link;
				$i++;
				$result->MoveNext ();
			}
		}

	}

	function parse (&$text) {

		$haslinks = false;
		$hasselect = false;
		$hasscript = false;
		$hastitle = false;
		$hasimg = false;
		if ( (substr_count (strtolower ($text), '<a ')>0) ) {
			$haslinks = true;
			$links = array () ;
			replace_tag ($text, 'a', $links);
		}
		if ( (substr_count (strtolower ($text), '<select ')>0) ) {
			$hasselect = true;
			$selects = array ();
			replace_tag ($text, 'select', $selects);
		}
		if ( (substr_count (strtolower ($text), '<script')>0) ) {
			$hasscript = true;
			$scripts = array ();
			replace_tag ($text, 'script', $scripts);
		}
		if ( (substr_count (strtolower ($text), '<img')>0) ) {
			$hasimg = true;
			$images = array ();
			replace_tag ($text, 'img', $images);
		}
		if ( (substr_count (strtolower ($text), 'title="')>0) ) {
			$hastitle = true;
			$titles = array ();
			replace_attribute ($text, 'title', $titles);
		}
		$text = preg_replace ($this->search, $this->replace, $text);
		if ($haslinks) {
			restore_tag ($text, 'a', $links);
			unset ($links);
		}
		if ($hasselect) {
			restore_tag ($text, 'select', $selects);
			unset ($selects);
		}
		if ($hasscript) {
			restore_tag ($text, 'script', $scripts);
			unset ($scripts);
		}
		if ($hasimg) {
			restore_tag ($text, 'img', $images);
			unset ($images);
		}
		if ($hastitle) {
			restore_attribute ($text, 'title', $titles);
			unset ($titles);
		}

	}

}

?>