<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/auto_link/plugin/search/language/');

function auto_link_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'auto_link';
	$button['sel'] = 0;
	$button['label'] = _AUTO_LINK_SEARCH_AUTO_LINK;
	$buttons[] = $button;
	unset ($button);

}

function auto_link_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'auto_link':
			auto_link_retrieve_all ($query, $data, $sap);
		}
	}

	function auto_link_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = auto_link_get_query ($query);
		$q .= auto_link_get_order ();
		$result = &$opnConfig['database']->Execute ($q);
		$hlp1 = array ();
		if (is_object ($result) ) {
			$nrows = $result->RecordCount ();
			if ($nrows>0) {
				$hlp1['data'] = _AUTO_LINK_SEARCH_AUTO_LINK;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$id = $result->fields['id'];
					$keyphrase = $result->fields['autolink'];
					$meaning = $result->fields['meaning'];
					$declaration = $result->fields['declaration'];
					$hlp1['data'] = auto_link_build_link ($keyphrase, $meaning, $id, $declaration);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function auto_link_build_link ($keyphrase, $meaning, $id, $declaration) {

		global $opnConfig;

		$furl = array ($opnConfig['opn_url'] . '/modules/auto_link/index.php',
				'op' => 'listautolink',
				'id' => $id);
		$onclick = "onclick=\"NewWindow('" . encodeurl ($furl) . "','test','400,200);return false\"";
		if ($declaration == '') {
			$hlp = $keyphrase;
		} else {
			$hlp = '<a class="%linkclass%" href="' . encodeurl ($furl) . '" ' . $onclick . '>' . $keyphrase . '</a>';
		}
		$hlp .= '&nbsp;' . $meaning;
		return $hlp;

}

function auto_link_get_query ($query) {

	global $opnTables, $opnConfig;

	$opnConfig['opn_searching_class']->init ();
	$opnConfig['opn_searching_class']->SetFields (array ('id',
							'autolink',
							'meaning',
							'declaration') );
	$opnConfig['opn_searching_class']->SetTable ($opnTables['auto_link']);
	$opnConfig['opn_searching_class']->SetQuery ($query);
	$opnConfig['opn_searching_class']->SetSearchfields (array ('autolink',
								'meaning') );
	return $opnConfig['opn_searching_class']->GetSQL ();

}

function auto_link_get_order () {
	return ' ORDER BY autolink ASC';

}

?>