<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/bug_tracking', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
$pubsettings = $opnConfig['module']->GetPublicSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/admin/language/');

function bug_tracking_allhiddens ($wichSave, $what = '') {

	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	if ($what != '') {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'what',
				'value' => $what);
	}
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$nav[_BUGADMIN_NAVGENERAL] = _BUGADMIN_NAVGENERAL;
	$nav[_BUGADMIN_NAVATTACHMENTS] = _BUGADMIN_NAVATTACHMENTS;
	$nav[_BUGADMIN_NAVUPDATED] = _BUGADMIN_NAVUPDATED;
	$nav[_BUGADMIN_NAVASSIGNED] = _BUGADMIN_NAVASSIGNED;
	$nav[_BUGADMIN_NAVREOPENED] = _BUGADMIN_NAVREOPENED;
	$nav[_BUGADMIN_NAVRESOLVED] = _BUGADMIN_NAVRESOLVED;
	$nav[_BUGADMIN_NAVCLOSED] = _BUGADMIN_NAVCLOSED;
	$nav[_BUGADMIN_NAVDELETED] = _BUGADMIN_NAVDELETED;
	$nav[_BUGADMIN_NAVBUGNOTE] = _BUGADMIN_NAVBUGNOTE;
	$nav[_BUGADMIN_NAVSTATUSNEW] = _BUGADMIN_NAVSTATUSNEW;
	$nav[_BUGADMIN_NAVSTATUSFEEDBACK] = _BUGADMIN_NAVSTATUSFEEDBACK;
	$nav[_BUGADMIN_NAVSTATUSACKNOWLEDGED] = _BUGADMIN_NAVSTATUSACKNOWLEDGED;
	$nav[_BUGADMIN_NAVSTATUSCONFIRMED] = _BUGADMIN_NAVSTATUSCONFIRMED;
	$nav[_BUGADMIN_NAVSTATUSASSIGNED] = _BUGADMIN_NAVSTATUSASSIGNED;
	$nav[_BUGADMIN_NAVSTATUSRESOLVED] = _BUGADMIN_NAVSTATUSRESOLVED;
	$nav[_BUGADMIN_NAVSTATUSCLOSED] = _BUGADMIN_NAVSTATUSCLOSED;
	$nav[_BUGADMIN_NAVCOLOR] = _BUGADMIN_NAVCOLOR;
	$nav[_BUGADMIN_NAVGRAPHVIZ] = _BUGADMIN_NAVGRAPHVIZ;
	$nav[_INPUT_BLANKLINE] = _INPUT_BLANKLINE;
	$nav[_BUGADMIN_SAVE] = _BUGADMIN_SAVE;
	$nav[_BUGADMIN_ADMIN] = _BUGADMIN_ADMIN;
	$nav[$wichSave] = '';
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav,
			'rt' => 4);
	return $values;

}

function bugtrackingsettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _BUGADMIN_GENERAL);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGSPERPAGE,
			'name' => 'bugs_perpage',
			'value' => $privsettings['bugs_perpage'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_REFRESHRATE,
			'name' => 'refresh_rate',
			'value' => $privsettings['refresh_rate'],
			'size' => 3,
			'maxlength' => 3);
	if ($opnConfig['installedPlugins']->isplugininstalled ('modules/phplot') ) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _BUGADMIN_XRES,
				'name' => 'xres',
				'value' => $privsettings['xres'],
				'size' => 4,
				'maxlength' => 4);
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _BUGADMIN_YRES,
				'name' => 'yres',
				'value' => $privsettings['yres'],
				'size' => 4,
				'maxlength' => 4);
		$options_datei = array ();
		$themelist = get_file_list (_OPN_ROOT_PATH . 'modules/phplot/class/', array ('phplot_data.php',
											'phplot.php',
											'rgb.inc.php') );
		if (count ($themelist) ) {
			usort ($themelist, 'strnatcasecmp');
			$max = sizeof ($themelist);
			for ($i = 0; $i< $max; $i++) {
				$options_datei[$themelist[$i]] = $themelist[$i];
			}
		}
		$options_datei[_BUGADMIN_NONE] = 'NONE';
		$values[] = array ('type' => _INPUT_SELECT_KEY,
				'display' => _BUGADMIN_TTFONT,
				'name' => 'ttffont',
				'options' => $options_datei,
				'selected' => $privsettings['ttffont']);
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'xres',
				'value' => 800);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'yres',
				'value' => 600);
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'ttffont',
				'value' => '');
	}
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_SEND_EMAIL,
			'name' => 'bugtrack_sender_email',
			'value' => $privsettings['bugtrack_sender_email'],
			'size' => 40,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_REPLY_EMAIL,
			'name' => 'bugtrack_reply_email',
			'value' => $privsettings['bugtrack_reply_email'],
			'size' => 40,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_SEND_TO_PROJECT_ADMIN,
			'name' => 'bug_send_to_project_admin',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bug_send_to_project_admin'] == 1?true : false),
			 ($privsettings['bug_send_to_project_admin'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_SEND_ON_NEW,
			'name' => 'bug_send_email_on_new',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bug_send_email_on_new'] == 1?true : false),
			 ($privsettings['bug_send_email_on_new'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_RECIVE_OWN,
			'name' => 'bug_email_receive_own',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bug_email_receive_own'] == 1?true : false),
			 ($privsettings['bug_email_receive_own'] == 0?true : false) ) );
	$values = array_merge ($values, bug_tracking_allhiddens (_BUGADMIN_NAVGENERAL) );
	$set->GetTheForm (_BUGADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/bug_tracking/admin/settings.php', $values);

}

function bugtrackingemail ($title, $nav, $what) {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => $title);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_SEND_REPORTER,
			'name' => 'reporter',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bug_send_email_on'][$what]['reporter'] == 1?true : false),
			 ($privsettings['bug_send_email_on'][$what]['reporter'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_SEND_HANDLER,
			'name' => 'handler',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bug_send_email_on'][$what]['handler'] == 1?true : false),
			 ($privsettings['bug_send_email_on'][$what]['handler'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_SEND_MONITOR,
			'name' => 'monitor',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bug_send_email_on'][$what]['monitor'] == 1?true : false),
			 ($privsettings['bug_send_email_on'][$what]['monitor'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_SEND_BUGNOTES,
			'name' => 'bugnotes',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bug_send_email_on'][$what]['bugnotes'] == 1?true : false),
			 ($privsettings['bug_send_email_on'][$what]['bugnotes'] == 0?true : false) ) );
	$values = array_merge ($values, bug_tracking_allhiddens ($nav, $what) );
	$set->GetTheForm (_BUGADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/bug_tracking/admin/settings.php', $values);

}

function bugtrackingcolor () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _BUGADMIN_COLOR);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_FONTCOLOR . '&nbsp;' . $privsettings['bugtrackingfontcolor'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingfontcolor'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingfontcolor',
			'value' => $privsettings['bugtrackingfontcolor'],
			'size' => 7,
			'maxlength' => 7);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGNEW . '&nbsp;' . $privsettings['bugtrackingnew'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingnew'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingnew',
			'value' => $privsettings['bugtrackingnew'],
			'size' => 7,
			'maxlength' => 7);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGFEEDBACK . '&nbsp;' . $privsettings['bugtrackingfeedback'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingfeedback'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingfeedback',
			'value' => $privsettings['bugtrackingfeedback'],
			'size' => 7,
			'maxlength' => 7);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGACKNOWLEGED . '&nbsp;' . $privsettings['bugtrackingacknowledged'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingacknowledged'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingacknowledged',
			'value' => $privsettings['bugtrackingacknowledged'],
			'size' => 7,
			'maxlength' => 7);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGCONFIRMED . '&nbsp;' . $privsettings['bugtrackingconfirmed'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingconfirmed'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingconfirmed',
			'value' => $privsettings['bugtrackingconfirmed'],
			'size' => 7,
			'maxlength' => 7);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGASSIGNED . '&nbsp;' . $privsettings['bugtrackingassigned'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingassigned'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingassigned',
			'value' => $privsettings['bugtrackingassigned'],
			'size' => 7,
			'maxlength' => 7);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGRESOLVED . '&nbsp;' . $privsettings['bugtrackingresolved'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingresolved'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingresolved',
			'value' => $privsettings['bugtrackingresolved'],
			'size' => 7,
			'maxlength' => 7);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_BUGCLOSED . '&nbsp;' . $privsettings['bugtrackingclosed'] . '<br />&nbsp;<span style="background-color:' . $privsettings['bugtrackingclosed'] . '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span>',
			'name' => 'bugtrackingclosed',
			'value' => $privsettings['bugtrackingclosed'],
			'size' => 7,
			'maxlength' => 7);
	$values = array_merge ($values, bug_tracking_allhiddens (_BUGADMIN_NAVCOLOR) );
	$set->GetTheForm (_BUGADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/bug_tracking/admin/settings.php', $values);

}

function bugtrackinggraphviz () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _BUGADMIN_GRAPHVIZ);
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _BUGADMIN_GRAPHVIZTEXT,
			'colspan' => 2);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_ENABLE_GRAPH,
			'name' => 'bugtracking_graphviz_enable',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bugtracking_graphviz_enable'] == 1?true : false),
			 ($privsettings['bugtracking_graphviz_enable'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_GRAPH_FONT,
			'name' => 'bugtracking_graph_font',
			'value' => $privsettings['bugtracking_graph_font'],
			'size' => 40,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_GRAPH_FONTSIZE,
			'name' => 'bugtracking_graph_fontsize',
			'value' => $privsettings['bugtracking_graph_fontsize'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _BUGADMIN_GRAPH_FONTPATHDEF,
			'colspan' => 2);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_GRAPH_FONTPATH,
			'name' => 'bugtracking_graph_fontpath',
			'value' => $privsettings['bugtracking_graph_fontpath'],
			'size' => 40,
			'maxlength' => 250);
	$options = array ();
	$options[_BUGADMIN_GRAPH_HORIZONTAL] = 'horizontal';
	$options[_BUGADMIN_GRAPH_VERTICAL] = 'vertical';
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _BUGADMIN_GRAPH_ORIENTATION,
			'name' => 'bugtracking_graph_orientation',
			'options' => $options,
			'selected' => $privsettings['bugtracking_graph_orientation']);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_GRAPH_DEPTH,
			'name' => 'bugtracking_graph_max_depth',
			'value' => $privsettings['bugtracking_graph_max_depth'],
			'size' => 2,
			'maxlength' => 2);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_GRAPH_ONCLICK,
			'name' => 'bugtracking_graph_view_on_click',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['bugtracking_graph_view_on_click'] == 1?true : false),
			 ($privsettings['bugtracking_graph_view_on_click'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_GRAPH_DOTTOOL,
			'name' => 'bugtracking_graph_dot_tool',
			'value' => $privsettings['bugtracking_graph_dot_tool'],
			'size' => 40,
			'maxlength' => 250);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_GRAPH_NEATOTOOL,
			'name' => 'bugtracking_graph_neato_tool',
			'value' => $privsettings['bugtracking_graph_neato_tool'],
			'size' => 40,
			'maxlength' => 250);
	$values = array_merge ($values, bug_tracking_allhiddens (_BUGADMIN_NAVGRAPHVIZ) );
	$set->GetTheForm (_BUGADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/bug_tracking/admin/settings.php', $values);

}

function bugtrackingattachments () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _BUGADMIN_ATTACHMENTS);
	$options = array ();
	$options[_BUGADMIN_ATTACHMENT_NONE] = 0;
	$options[_BUGADMIN_ATTACHMENT_YES] = 1;
	$options[_BUGADMIN_ATTACHMENT_NONEW] = 2;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _BUGADMIN_ATTACHMENTS_MODE,
			'name' => 'attachmentenable',
			'options' => $options,
			'selected' => $privsettings['attachmentenable']);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_ATTACHMENT_CHECKEXT,
			'name' => 'attachmentcheckexten',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['attachmentcheckexten'] == 1?true : false),
			 ($privsettings['attachmentcheckexten'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_ATTACHMENT_EXT,
			'name' => 'attachmentextensions',
			'value' => $privsettings['attachmentextensions'],
			'size' => 40,
			'maxlength' => 250);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _BUGADMIN_ATTACHMENT_SHOWIMAGE,
			'name' => 'attachmentshowimages',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['attachmentshowimages'] == 1?true : false),
			 ($privsettings['attachmentshowimages'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_ATTACHMENT_DIRLIMIT,
			'name' => 'attachemntdirsizelim',
			'value' => $privsettings['attachemntdirsizelim'],
			'size' => 5,
			'maxlength' => 250);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_ATTACHMENT_SIZELIMIT,
			'name' => 'attachmentsizelimit',
			'value' => $privsettings['attachmentsizelimit'],
			'size' => 4,
			'maxlength' => 250);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_ATTACHMENT_MAX_WIDTH,
			'name' => 'maxwidth',
			'value' => $privsettings['maxwidth'],
			'size' => 4,
			'maxlength' => 250);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BUGADMIN_ATTACHMENT_MAX_HEIGHT,
			'name' => 'maxheight',
			'value' => $privsettings['maxheight'],
			'size' => 4,
			'maxlength' => 250);
	$values[] = array ('type' => _INPUT_TEXTLINE,
			'text' => _BUGADMIN_ATTACHMENTS_ICONS,
			'colspan' => 2);
	$options = array ();
	$filelist = get_file_list (_OPN_ROOT_PATH . 'images/files/');
	if (count ($filelist) ) {
		natcasesort ($filelist);
		reset ($filelist);
		foreach ($filelist as $file) {
			$options[$file] = $file;
		}
	}
	if (is_array ($privsettings['bug_tracking_file_types']) ) {
		foreach ($privsettings['bug_tracking_file_types'] as $key => $value) {
			$values[] = array ('type' => _INPUT_TEXTSELECT,
					'display' => array (_BUGADMIN_ATTACHMENTS_EXTENSION,
					_BUGADMIN_ATTACHMENTS_EXTENSION_ICON),
					'name' => array ('btext[]',
					'bticon[]'),
					'value' => array ($key,
					$value),
					'size' => 10,
					'maxlength' => 100,
					'options' => $options);
		}
	}
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _BUGADMIN_ATTACHMENTS_ADD_EXT);
	$values = array_merge ($values, bug_tracking_allhiddens (_BUGADMIN_NAVATTACHMENTS) );
	$set->GetTheForm (_BUGADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/bug_tracking/admin/settings.php', $values);

}

function bug_tracking_dosavesettings () {

	global $opnConfig, $privsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();

}

function bug_tracking_dosaveattachments ($vars) {

	global $privsettings;

	unset ($privsettings['bug_tracking_file_types']);
	$max = count ($vars['btext']);
	for ($i = 0; $i< $max; $i++) {
		if ($vars['btext'][$i] != '') {
			$privsettings['bug_tracking_file_types'][$vars['btext'][$i]] = $vars['bticon'][$i];
		}
	}
	$privsettings['attachmentenable'] = $vars['attachmentenable'];
	$privsettings['attachmentcheckexten'] = $vars['attachmentcheckexten'];
	$privsettings['attachmentextensions'] = $vars['attachmentextensions'];
	$privsettings['attachmentshowimages'] = $vars['attachmentshowimages'];
	$privsettings['attachemntdirsizelim'] = $vars['attachemntdirsizelim'];
	$privsettings['attachmentsizelimit'] = $vars['attachmentsizelimit'];
	$privsettings['maxwidth'] = $vars['maxwidth'];
	$privsettings['maxheight'] = $vars['maxheight'];
	bug_tracking_dosavesettings ();

}

function bug_tracking_dosavebugtracking ($vars) {

	global $privsettings;

	$privsettings['bugs_perpage'] = $vars['bugs_perpage'];
	$privsettings['refresh_rate'] = $vars['refresh_rate'];
	$privsettings['xres'] = $vars['xres'];
	$privsettings['yres'] = $vars['yres'];
	$privsettings['ttffont'] = $vars['ttffont'];
	$privsettings['bugtrack_sender_email'] = $vars['bugtrack_sender_email'];
	$privsettings['bugtrack_reply_email'] = $vars['bugtrack_reply_email'];
	$privsettings['bug_send_to_project_admin'] = $vars['bug_send_to_project_admin'];
	$privsettings['bug_email_receive_own'] = $vars['bug_email_receive_own'];
	$privsettings['bug_send_email_on_new'] = $vars['bug_send_email_on_new'];
	bug_tracking_dosavesettings ();

}

function bug_tracking_dosaveemail ($vars) {

	global $privsettings;

	$what = $vars['what'];
	$privsettings['bug_send_email_on'][$what]['reporter'] = $vars['reporter'];
	$privsettings['bug_send_email_on'][$what]['handler'] = $vars['handler'];
	$privsettings['bug_send_email_on'][$what]['monitor'] = $vars['monitor'];
	$privsettings['bug_send_email_on'][$what]['bugnotes'] = $vars['bugnotes'];
	bug_tracking_dosavesettings ();

}

function bug_tracking_dosavecolor ($vars) {

	global $privsettings;

	$privsettings['bugtrackingfontcolor'] = $vars['bugtrackingfontcolor'];
	$privsettings['bugtrackingnew'] = $vars['bugtrackingnew'];
	$privsettings['bugtrackingfeedback'] = $vars['bugtrackingfeedback'];
	$privsettings['bugtrackingacknowledged'] = $vars['bugtrackingacknowledged'];
	$privsettings['bugtrackingconfirmed'] = $vars['bugtrackingconfirmed'];
	$privsettings['bugtrackingassigned'] = $vars['bugtrackingassigned'];
	$privsettings['bugtrackingresolved'] = $vars['bugtrackingresolved'];
	$privsettings['bugtrackingclosed'] = $vars['bugtrackingclosed'];
	bug_tracking_dosavesettings ();

}

function bug_tracking_dosavegraphviz ($vars) {

	global $privsettings;

	$privsettings['bugtracking_graphviz_enable'] = $vars['bugtracking_graphviz_enable'];
	$privsettings['bugtracking_graph_font'] = $vars['bugtracking_graph_font'];
	$privsettings['bugtracking_graph_fontsize'] = $vars['bugtracking_graph_fontsize'];
	$privsettings['bugtracking_graph_fontpath'] = $vars['bugtracking_graph_fontpath'];
	$privsettings['bugtracking_graph_orientation'] = $vars['bugtracking_graph_orientation'];
	$privsettings['bugtracking_graph_max_depth'] = $vars['bugtracking_graph_max_depth'];
	$privsettings['bugtracking_graph_view_on_click'] = $vars['bugtracking_graph_view_on_click'];
	$privsettings['bugtracking_graph_dot_tool'] = $vars['bugtracking_graph_dot_tool'];
	$privsettings['bugtracking_graph_neato_tool'] = $vars['bugtracking_graph_neato_tool'];
	bug_tracking_dosavesettings ();

}

function bug_tracking_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _BUGADMIN_NAVGENERAL:
			bug_tracking_dosavebugtracking ($returns);
			break;
		case _BUGADMIN_NAVATTACHMENTS:
			bug_tracking_dosaveattachments ($returns);
			break;
		case _BUGADMIN_NAVASSIGNED:
		case _BUGADMIN_NAVREOPENED:
		case _BUGADMIN_NAVRESOLVED:
		case _BUGADMIN_NAVCLOSED:
		case _BUGADMIN_NAVDELETED:
		case _BUGADMIN_NAVUPDATED:
		case _BUGADMIN_NAVBUGNOTE:
		case _BUGADMIN_NAVSTATUSNEW:
		case _BUGADMIN_NAVSTATUSFEEDBACK:
		case _BUGADMIN_NAVSTATUSACKNOWLEDGED:
		case _BUGADMIN_NAVSTATUSCONFIRMED:
		case _BUGADMIN_NAVSTATUSASSIGNED:
		case _BUGADMIN_NAVSTATUSRESOLVED:
		case _BUGADMIN_NAVSTATUSCLOSED:
			bug_tracking_dosaveemail ($returns);
			break;
		case _BUGADMIN_NAVCOLOR:
			bug_tracking_dosavecolor ($returns);
			break;
		case _BUGADMIN_NAVGRAPHVIZ:
			bug_tracking_dosavegraphviz ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		bug_tracking_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _BUGADMIN_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _BUGADMIN_ADMIN:
		$opnConfig['opnOutput']->Redirect ('/modules/bug_tracking/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	case _BUGADMIN_NAVATTACHMENTS:
		bugtrackingattachments ();
		break;
	case _BUGADMIN_ATTACHMENTS_ADD_EXT:
		$privsettings['bug_tracking_file_types']['New'] = 'fileicon.gif';
		bug_tracking_dosavesettings ();
		bugtrackingattachments ();
		break;
	case _BUGADMIN_NAVASSIGNED:
		bugtrackingemail (_BUGADMIN_ASSIGNED, _BUGADMIN_NAVASSIGNED, 'assigned');
		break;
	case _BUGADMIN_NAVREOPENED:
		bugtrackingemail (_BUGADMIN_REOPENED, _BUGADMIN_NAVREOPENED, 'reopened');
		break;
	case _BUGADMIN_NAVRESOLVED:
		bugtrackingemail (_BUGADMIN_RESOLVED, _BUGADMIN_NAVRESOLVED, 'resolved');
		break;
	case _BUGADMIN_NAVCLOSED:
		bugtrackingemail (_BUGADMIN_CLOSED, _BUGADMIN_NAVCLOSED, 'closed');
		break;
	case _BUGADMIN_NAVDELETED:
		bugtrackingemail (_BUGADMIN_DELETED, _BUGADMIN_NAVDELETED, 'deleted');
		break;
	case _BUGADMIN_NAVUPDATED:
		bugtrackingemail (_BUGADMIN_UPDATED, _BUGADMIN_NAVUPDATED, 'updated');
		break;
	case _BUGADMIN_NAVBUGNOTE:
		bugtrackingemail (_BUGADMIN_BUGNOTE, _BUGADMIN_NAVBUGNOTE, 'bugnote');
		break;
	case _BUGADMIN_NAVSTATUSNEW:
		bugtrackingemail (_BUGADMIN_STATUSNEW, _BUGADMIN_NAVSTATUSNEW, 'status_new');
		break;
	case _BUGADMIN_NAVSTATUSFEEDBACK:
		bugtrackingemail (_BUGADMIN_STATUSFEEDBACK, _BUGADMIN_NAVSTATUSFEEDBACK, 'status_feedback');
		break;
	case _BUGADMIN_NAVSTATUSACKNOWLEDGED:
		bugtrackingemail (_BUGADMIN_STATUSACKNOWLEDGED, _BUGADMIN_NAVSTATUSACKNOWLEDGED, 'status_acknowledged');
		break;
	case _BUGADMIN_NAVSTATUSCONFIRMED:
		bugtrackingemail (_BUGADMIN_STATUSCONFIRMED, _BUGADMIN_NAVSTATUSCONFIRMED, 'status_confirmed');
		break;
	case _BUGADMIN_NAVSTATUSASSIGNED:
		bugtrackingemail (_BUGADMIN_STATUSASSIGNED, _BUGADMIN_NAVSTATUSASSIGNED, 'status_assigned');
		break;
	case _BUGADMIN_NAVSTATUSRESOLVED:
		bugtrackingemail (_BUGADMIN_STATUSRESOLVED, _BUGADMIN_NAVSTATUSRESOLVED, 'status_resolved');
		break;
	case _BUGADMIN_NAVSTATUSCLOSED:
		bugtrackingemail (_BUGADMIN_STATUSCLOSED, _BUGADMIN_NAVSTATUSCLOSED, 'status_closed');
		break;
	case _BUGADMIN_NAVCOLOR:
		bugtrackingcolor ();
		break;
	case _BUGADMIN_NAVGRAPHVIZ:
		bugtrackinggraphviz ();
		break;
	default:
		bugtrackingsettings ();
		break;
}

?>