<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function BugTracking_Summary_Graph () {

	global $opnConfig;
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$do = '';
	get_var ('do', $do, 'both', _OOBJ_DTYPE_CLEAN);
	if ($opnConfig['installedPlugins']->isplugininstalled ('modules/phplot') ) {
		$boxtxt = mainheaderbug_tracking (1, 'summary_graph', $sel_project);
		if (!$sel_project) {
			$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'summary_graph',
							'do' => 'project',
							'sel_project' => $sel_project),
							_BUG_BY_PROJECT,
							'',
							'');
		}
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'category',
						'sel_project' => $sel_project),
						_BUG_BY_CATEGORY,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'version',
						'sel_project' => $sel_project),
						_BUG_BY_VERSION,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'status',
						'sel_project' => $sel_project),
						_BUG_BY_STATUS,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'severity',
						'sel_project' => $sel_project),
						_BUG_BY_SEVERITY,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'resolution',
						'sel_project' => $sel_project),
						_BUG_BY_RESOLUTION,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'priority',
						'sel_project' => $sel_project),
						_BUG_BY_PRIORITY,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'reproducibility',
						'sel_project' => $sel_project),
						_BUG_BY_REPRODUCIBILITY,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'projection',
						'sel_project' => $sel_project),
						_BUG_BY_PROJECTION,
						'',
						'');
		$boxtxt .= '<br /><br />';
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'eta',
						'sel_project=' => $sel_project),
						_BUG_BY_ETA,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'developer',
						'sel_project' => $sel_project),
						_BUG_BY_DEVELOPER,
						'',
						'');
		$boxtxt .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'do' => 'reporter',
						'sel_project' => $sel_project),
						_BUG_BY_REPORTER,
						'',
						'');
		$boxtxt .= '<br /><br />';
		switch ($do) {
			case 'project':
				$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_project.php" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_project.php?pie=1') . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_project_by_status.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				break;
			case 'category':
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_category.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />';
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_category.php?',
									'pie' => '1',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_category_by_status.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				break;
			case 'version':
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_version.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />';
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_version.php',
									'pie' => '1',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_version_by_status.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				break;
			case 'status':
			case 'severity':
			case 'resolution':
			case 'priority':
			case 'reproducibility':
			case 'projection':
			case 'eta':
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_by.php',
									'by' => $do,
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_by.php',
									'by' => $do,
									'pie' => '1',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_by_status.php',
									'by' => $do,
									'project_id' => $sel_project) ) . '" alt="" />';
				break;
			case 'developer':
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_developer.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_developer.php',
									'pie' => '1',
									'project_id' => $sel_project,
									false) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_developer_by_status.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				break;
			case 'reporter':
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_reporter.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_reporter.php',
									'pie' => '1',
									'project_id' => $sel_project) ) . '" alt="" />';
				$boxtxt .= '<br /><br /><br /><br />' . _OPN_HTML_NL;
				$boxtxt .= '<img src="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/include/graphics/graph_reporter_by_status.php',
									'project_id' => $sel_project) ) . '" alt="" />';
				break;
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_80_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_SUMMARY_GRAPH, $boxtxt);
	} else {
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php?&sel_project=' . $sel_project, false) );
	}

}

?>