<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

global $opnConfig, $opnTables;

global $bugs, $bugshistory, $bugsmonitoring, $bugsnotes;

global $project, $category, $version;

global $bugvalues, $settings, $bugusers;

class BugRelationshipData {
	var $id = 0;
	var $src_bug_id = 0;
	var $src_project_id = 0;
	var $dest_bug_id = 0;
	var $dest_project_id = 0;
	var $type = 0;

	function SetId ($id) {

		$this->id = $id;

	}

	function SetSrcBug ($bug) {

		$this->src_bug_id = $bug;

	}

	function SetSrcProject ($project) {

		$this->src_project_id = $project;

	}

	function SetDestBug ($bug) {

		$this->dest_bug_id = $bug;

	}

	function SetDestProject ($project) {

		$this->dest_project_id = $project;

	}

	function SetType ($type) {

		$this->type = $type;

	}

}

function BugTracking_InitArrays () {

	global $opnConfig, $bugvalues, $settings, $bugusers;

	$bugvalues['status'][_OPN_BUG_STATUS_NEW] = _BUG_STATUS_NEW;
	$bugvalues['status'][_OPN_BUG_STATUS_FEEDBACK] = _BUG_STATUS_FEEDBACK;
	$bugvalues['status'][_OPN_BUG_STATUS_ACKNOWLEDGED] = _BUG_STATUS_ACKNOWLEDGED;
	$bugvalues['status'][_OPN_BUG_STATUS_CONFIRMED] = _BUG_STATUS_CONFIRMED;
	$bugvalues['status'][_OPN_BUG_STATUS_ASSIGNED] = _BUG_STATUS_ASSIGNED;
	$bugvalues['status'][_OPN_BUG_STATUS_RESOLVED] = _BUG_STATUS_RESOLVED;
	$bugvalues['status'][_OPN_BUG_STATUS_CLOSED] = _BUG_STATUS_CLOSED;
	$bugvalues['statusemail'][_OPN_BUG_STATUS_NEW] = 'status_new';
	$bugvalues['statusemail'][_OPN_BUG_STATUS_FEEDBACK] = 'status_feedback';
	$bugvalues['statusemail'][_OPN_BUG_STATUS_ACKNOWLEDGED] = 'status_acknowledged';
	$bugvalues['statusemail'][_OPN_BUG_STATUS_CONFIRMED] = 'status_confirmed';
	$bugvalues['statusemail'][_OPN_BUG_STATUS_ASSIGNED] = 'status_assigned';
	$bugvalues['statusemail'][_OPN_BUG_STATUS_RESOLVED] = 'status_resolved';
	$bugvalues['statusemail'][_OPN_BUG_STATUS_CLOSED] = 'status_closed';
	$bugvalues['statusemailtitle'][_OPN_BUG_STATUS_NEW] = _BUG_EMAIL_TITLE_STATUSNEW;
	$bugvalues['statusemailtitle'][_OPN_BUG_STATUS_FEEDBACK] = _BUG_EMAIL_TITLE_FEEDBACK;
	$bugvalues['statusemailtitle'][_OPN_BUG_STATUS_ACKNOWLEDGED] = _BUG_EMAIL_TITLE_ACKNOWLEDGED;
	$bugvalues['statusemailtitle'][_OPN_BUG_STATUS_CONFIRMED] = _BUG_EMAIL_TITLE_CONFIRMED;
	$bugvalues['statusemailtitle'][_OPN_BUG_STATUS_ASSIGNED] = _BUG_EMAIL_TITLE_ASSIGNED;
	$bugvalues['statusemailtitle'][_OPN_BUG_STATUS_RESOLVED] = _BUG_EMAIL_TITLE_RESOLVED;
	$bugvalues['statusemailtitle'][_OPN_BUG_STATUS_CLOSED] = _BUG_EMAIL_TITLE_CLOSED;
	$bugvalues['altstatuscss'][_OPN_BUG_STATUS_NEW] = 'bugtrackingnew';
	$bugvalues['altstatuscss'][_OPN_BUG_STATUS_FEEDBACK] = 'bugtrackingfeedback';
	$bugvalues['altstatuscss'][_OPN_BUG_STATUS_ACKNOWLEDGED] = 'bugtrackingacknowledged';
	$bugvalues['altstatuscss'][_OPN_BUG_STATUS_CONFIRMED] = 'bugtrackingconfirmed';
	$bugvalues['altstatuscss'][_OPN_BUG_STATUS_ASSIGNED] = 'bugtrackingassigned';
	$bugvalues['altstatuscss'][_OPN_BUG_STATUS_RESOLVED] = 'bugtrackingresolved';
	$bugvalues['altstatuscss'][_OPN_BUG_STATUS_CLOSED] = 'bugtrackingclosed';
	$bugvalues['listaltstatuscss'][_OPN_BUG_STATUS_NEW] = 'bugtrackingnewlist';
	$bugvalues['listaltstatuscss'][_OPN_BUG_STATUS_FEEDBACK] = 'bugtrackingfeedbacklist';
	$bugvalues['listaltstatuscss'][_OPN_BUG_STATUS_ACKNOWLEDGED] = 'bugtrackingacknowledgedlist';
	$bugvalues['listaltstatuscss'][_OPN_BUG_STATUS_CONFIRMED] = 'bugtrackingconfirmedlist';
	$bugvalues['listaltstatuscss'][_OPN_BUG_STATUS_ASSIGNED] = 'bugtrackingassignedlist';
	$bugvalues['listaltstatuscss'][_OPN_BUG_STATUS_RESOLVED] = 'bugtrackingresolvedlist';
	$bugvalues['listaltstatuscss'][_OPN_BUG_STATUS_CLOSED] = 'bugtrackingclosedlist';
	$bugvalues['state'][_OPN_BUG_STATE_PUBLIC] = _BUG_STATE_PUBLIC;
	$bugvalues['state'][_OPN_BUG_STATE_PRIVATE] = _BUG_STATE_PRIVATE;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_OPEN] = _BUG_RESOLUTION_OPEN;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_FIXED] = _BUG_RESOLUTION_FIXED;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_REOPEN] = _BUG_RESOLUTION_REOPEN;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_UNABLEDUPLICATE] = _BUG_RESOLUTION_UNABLEDUPLICATE;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_NOTFIXABLE] = _BUG_RESOLUTION_NOTFIXABLE;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_DUPLICATE] = _BUG_RESOLUTION_DUPLICATE;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_NOTBUG] = _BUG_RESOLUTION_NOTBUG;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_SUSPENDED] = _BUG_RESOLUTION_SUSPENDED;
	$bugvalues['resolution'][_OPN_BUG_RESOLUTION_WONTFIX] = _BUG_RESOLUTION_WONTFIX;
	$bugvalues['reproducibility'][_OPN_BUG_REPRODUCIBILITY_ALWAYS] = _BUG_REPRODUCIBILITY_ALWAYS;
	$bugvalues['reproducibility'][_OPN_BUG_REPRODUCIBILITY_SOMETIMES] = _BUG_REPRODUCIBILITY_SOMTIMES;
	$bugvalues['reproducibility'][_OPN_BUG_REPRODUCIBILITY_RANDOM] = _BUG_REPRODUCIBILITY_RANDOM;
	$bugvalues['reproducibility'][_OPN_BUG_REPRODUCIBILITY_NOTTRIED] = _BUG_REPRODUCIBILITY_NOTTRIED;
	$bugvalues['reproducibility'][_OPN_BUG_REPRODUCIBILITY_UNABLEDUPLI] = _BUG_REPRODUCIBILITY_UNABLEDUPLI;
	$bugvalues['reproducibility'][_OPN_BUG_REPRODUCIBILITY_NA] = _BUG_REPRODUCIBILITY_NA;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_FEATURE] = _BUG_SEVERITY_FEATURE;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_TRIVIAL] = _BUG_SEVERITY_TRIVIAL;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_TEXT] = _BUG_SEVERITY_TEXT;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_TWEAK] = _BUG_SEVERITY_TWEAK;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_MINOR] = _BUG_SEVERITY_MINOR;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_MAJOR] = _BUG_SEVERITY_MAJOR;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_CRASH] = _BUG_SEVERITY_CRASH;
	$bugvalues['severity'][_OPN_BUG_SEVERITY_BLOCK] = _BUG_SEVERITY_BLOCK;
	$bugvalues['priority'][_OPN_BUG_PRIORITY_NONE] = _BUG_PRIORITY_NONE;
	$bugvalues['priority'][_OPN_BUG_PRIORITY_LOW] = _BUG_PRIORITY_LOW;
	$bugvalues['priority'][_OPN_BUG_PRIORITY_NORMAL] = _BUG_PRIORITY_NORMAL;
	$bugvalues['priority'][_OPN_BUG_PRIORITY_HIGH] = _BUG_PRIORITY_HIGH;
	$bugvalues['priority'][_OPN_BUG_PRIORITY_URGENT] = _BUG_PRIORITY_URGENT;
	$bugvalues['priority'][_OPN_BUG_PRIORITY_IMMEDIATE] = _BUG_PRIORITY_IMMEDIATE;
	$bugvalues['priorityimage'][_OPN_BUG_PRIORITY_NONE] = '';
	$bugvalues['priorityimage'][_OPN_BUG_PRIORITY_LOW] = '';
	$bugvalues['priorityimage'][_OPN_BUG_PRIORITY_NORMAL] = '';
	$bugvalues['priorityimage'][_OPN_BUG_PRIORITY_HIGH] = 'priority_1.gif';
	$bugvalues['priorityimage'][_OPN_BUG_PRIORITY_URGENT] = 'priority_2.gif';
	$bugvalues['priorityimage'][_OPN_BUG_PRIORITY_IMMEDIATE] = 'priority_3.gif';
	$bugvalues['projection'][_OPN_BUG_PROJECTION_NONE] = _BUG_PROJECTION_NONE;
	$bugvalues['projection'][_OPN_BUG_PROJECTION_TWEAK] = _BUG_PROJECTION_TWEAK;
	$bugvalues['projection'][_OPN_BUG_PROJECTION_MINOR] = _BUG_PROJECTION_MINOR;
	$bugvalues['projection'][_OPN_BUG_PROJECTION_MAJOR] = _BUG_PROJECTION_MAJOR;
	$bugvalues['projection'][_OPN_BUG_PROJECTION_REDISGN] = _BUG_PROJECTION_REDISGN;
	$bugvalues['eta'][_OPN_BUG_ETA_NONE] = _BUG_ETA_NONE;
	$bugvalues['eta'][_OPN_BUG_ETA_DAY] = _BUG_ETA_DAY;
	$bugvalues['eta'][_OPN_BUG_ETA_DAYS] = _BUG_ETA_DAYS;
	$bugvalues['eta'][_OPN_BUG_ETA_WEEK] = _BUG_ETA_WEEK;
	$bugvalues['eta'][_OPN_BUG_ETA_MONTH] = _BUG_ETA_MONTH;
	$bugvalues['eta'][_OPN_BUG_ETA_MONTHS] = _BUG_ETA_MONTHS;
	$bugvalues[_OPN_HISTORY_NORMAL_TYPE] = _BUG_HISTORY_NORMAL_TYPE;
	$bugvalues[_OPN_HISTORY_NEW_BUG] = _BUG_HISTORY_NEW_BUG;
	$bugvalues[_OPN_HISTORY_BUGNOTE_ADDED] = _BUG_HISTORY_BUGNOTE_ADDED;
	$bugvalues[_OPN_HISTORY_BUGNOTE_UPDATED] = _BUG_HISTORY_BUGNOTE_UPDATED;
	$bugvalues[_OPN_HISTORY_BUGNOTE_DELETED] = _BUG_HISTORY_BUGNOTE_DELETED;
	$bugvalues[_OPN_HISTORY_SUMMARY_UPDATED] = _BUG_HISTORY_SUMMARY_UPDATED;
	$bugvalues[_OPN_HISTORY_DESCRIPTION_UPDATED] = _BUG_HISTORY_DESCRIPTION_UPDATED;
	$bugvalues[_OPN_HISTORY_ADDITIONAL_INFO_UPDATED] = _BUG_HISTORY_ADDITIONAL_INFO_UPDATED;
	$bugvalues[_OPN_HISTORY_STEP_TO_REPRODUCE_UPDATED] = _BUG_HISTORY_STEP_TO_REPRODUCE_UPDATED;
	$bugvalues[_OPN_HISTORY_FILE_ADDED] = _BUG_HISTORY_FILE_ADDED;
	$bugvalues[_OPN_HISTORY_FILE_DELETED] = _BUG_HISTORY_FILE_DELETED;
	$bugvalues[_OPN_HISTORY_BUG_MONITOR] = _BUG_HISTORY_BUG_MONITOR;
	$bugvalues[_OPN_HISTORY_BUG_UNMONITOR] = _BUG_HISTORY_BUG_UNMONITOR;
	$bugvalues[_OPN_HISTORY_BUG_DELETED] = _BUG_HISTORY_BUG_DELETED;
	$settings['bug_resolved'] = 0;
	$settings['bug_closed'] = 0;
	$settings['bug_feature'] = 0;
	$settings['standard_project'] = 0;
	$settings['bugs_perpage'] = $opnConfig['bugs_perpage'];
	$settings['refresh_rate'] = $opnConfig['refresh_rate'];
	if ($opnConfig['permission']->IsUser () ) {
		$setting = & new BugsUserSettings ();
		$setting->SetUser ($opnConfig['permission']->UserInfo ('uid') );
		if ($setting->GetCount () ) {
			$sett = $setting->RetrieveSingle ($opnConfig['permission']->UserInfo ('uid') );
			$settings['bug_resolved'] = $sett['block_resolved'];
			$settings['bug_closed'] = $sett['block_closed'];
			$settings['bug_feature'] = $sett['block_feature'];
			$settings['standard_project'] = $sett['default_project'];
			$settings['bugs_perpage'] = $sett['bugs_perpage'];
			$settings['refresh_rate'] = $sett['refresh_delay'];
			unset ($sett);
		}
		unset ($setting);
	}
	$css = & new opn_cssparser ();
	$css->Parse ($opnConfig['opnOutput']->csspath);
	$cssalt = $css->GetSection ('.alternator1');
	$csslist = $css->GetSection ('.listalternator1');
	unset ($css);
	$opnConfig['put_to_head']['startcss'] = '<style type="text/css">';
	$opnConfig['put_to_head']['startcomment'] = '<!--';
	$opnConfig['put_to_head']['fonts'] = '.bugtrackingnew,.bugtrackingfeedback,' . '.bugtrackingacknowledged,.bugtrackingconfirmed,.bugtrackingassigned,' . '.bugtrackingresolved,.bugtrackingclosed {';
	foreach ($cssalt as $key => $value) {
		if ( (substr_count ($key, 'background') == 0) && (strtolower ($key) != 'color') ) {
			$opnConfig['put_to_head']['fonts'] .= $key . ': ' . $value . '; ';
		}
	}
	$opnConfig['put_to_head']['fonts'] .= 'color: ' . $opnConfig['bugtrackingfontcolor'] . ';}' . _OPN_HTML_NL;
	$opnConfig['put_to_head']['fonts'] .= '.bugtrackingnewlist,.bugtrackingfeedbacklist,' . '.bugtrackingacknowledgedlist,.bugtrackingconfirmedlist,.bugtrackingassignedlist,' . '.bugtrackingresolvedlist,.bugtrackingclosedlist {';
	foreach ($csslist as $key => $value) {
		if ( (substr_count ($key, 'background') == 0) && (strtolower ($key) != 'color') ) {
			$opnConfig['put_to_head']['fonts'] .= $key . ': ' . $value . '; ';
		}
	}
	unset ($cssalt);
	unset ($csslist);
	$opnConfig['put_to_head']['fonts'] .= 'color: ' . $opnConfig['bugtrackingfontcolor'] . ';}';
	$opnConfig['put_to_head']['bugtrackingnew'] = '.bugtrackingnew {background-color: ' . $opnConfig['bugtrackingnew'] . '}';
	$opnConfig['put_to_head']['bugtrackingfeedback'] = '.bugtrackingfeedback {background-color: ' . $opnConfig['bugtrackingfeedback'] . '}';
	$opnConfig['put_to_head']['bugtrackingacknowledged'] = '.bugtrackingacknowledged {background-color: ' . $opnConfig['bugtrackingacknowledged'] . '}';
	$opnConfig['put_to_head']['bugtrackingconfirmed'] = '.bugtrackingconfirmed {background-color: ' . $opnConfig['bugtrackingconfirmed'] . '}';
	$opnConfig['put_to_head']['bugtrackingassigned'] = '.bugtrackingassigned {background-color: ' . $opnConfig['bugtrackingassigned'] . '}';
	$opnConfig['put_to_head']['bugtrackingresolved'] = '.bugtrackingresolved {background-color: ' . $opnConfig['bugtrackingresolved'] . '}';
	$opnConfig['put_to_head']['bugtrackingclosed'] = '.bugtrackingclosed {background-color: ' . $opnConfig['bugtrackingclosed'] . '}';
	$opnConfig['put_to_head']['bugtrackingnewlist'] = '.bugtrackingnewlist {background-color: ' . $opnConfig['bugtrackingnew'] . '}';
	$opnConfig['put_to_head']['bugtrackingfeedbacklist'] = '.bugtrackingfeedbacklist {background-color: ' . $opnConfig['bugtrackingfeedback'] . '}';
	$opnConfig['put_to_head']['bugtrackingacknowledgedlist'] = '.bugtrackingacknowledgedlist {background-color: ' . $opnConfig['bugtrackingacknowledged'] . '}';
	$opnConfig['put_to_head']['bugtrackingconfirmedlist'] = '.bugtrackingconfirmedlist {background-color: ' . $opnConfig['bugtrackingconfirmed'] . '}';
	$opnConfig['put_to_head']['bugtrackingassignedlist'] = '.bugtrackingassignedlist {background-color: ' . $opnConfig['bugtrackingassigned'] . '}';
	$opnConfig['put_to_head']['bugtrackingresolvedlist'] = '.bugtrackingresolvedlist {background-color: ' . $opnConfig['bugtrackingresolved'] . '}';
	$opnConfig['put_to_head']['bugtrackingclosedlist'] = '.bugtrackingclosedlist {background-color: ' . $opnConfig['bugtrackingclosed'] . '}';
	$opnConfig['put_to_head']['endcomment'] = '-->';
	$opnConfig['put_to_head']['endcss'] = '</style>';
	$bugusers = $opnConfig['permission']->GetUsersForGroupname (_BUGT_GROUP_DEVELOPER);
	$bugusers = $bugusers+ $opnConfig['permission']->GetUsersForGroupname (_BUGT_GROUP_MANAGER);
	$bugusers = $bugusers+ $opnConfig['permission']->GetUsersForGroupname (_BUGT_GROUP_ADMINISTRATOR);
	$bugusers = $bugusers+ $opnConfig['permission']->GetUsersForGroupname ('Webmaster');
	$bugusers = array_unique ($bugusers);
	uasort ($bugusers, 'BugTacking_ArraySort');

}

function mainheaderbug_tracking ($mainlink = 1, $op = '', $sel = 0, $sortby = '', $sel_reporter = 0, $sel_handler = 0, $sel_category = 0, $sel_severity = 0, $sel_status = 0, $block_resolved = 0, $block_resolved_hidden = 0, $block_closed = 0, $block_closed_hidden = 0, $block_feature = 0, $block_feature_hidden = 0, $bugs_perpage = 0, $sel_query = '', $bug_id = 0) {

	global $opnConfig, $project, $settings;

	$boxtext = '<br /><div class="centertag">';
	if ($mainlink>0) {
		$boxtext .= theme_boxi ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php?sel_project=' . $sel, _BUG_MAIN, '', '');
	}
	if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _PERM_ADMIN), true) ) {
		$boxtext .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'submit_bug',
						'sel_project' => $sel),
						_BUG_SUBMIT,
						'',
						'');
	}
	$boxtext .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
					'op' => 'changelog',
					'sel_project' => $sel),
					_BUG_CHANGELOG,
					'',
					'');
	$boxtext .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
					'op' => 'summary',
					'sel_project' => $sel),
					_BUG_SUMMARY,
					'',
					'');
	if ($opnConfig['installedPlugins']->isplugininstalled ('modules/phplot') ) {
		$boxtext .= theme_boxi (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
						'op' => 'summary_graph',
						'sel_project' => $sel),
						_BUG_SUMMARY_GRAPH,
						'',
						'');
	}
	$boxtext .= '<br /><br /></div>';
	$boxtext .= '<div class="centertag">';
	if ($sel == -1) {
		$sel = $settings['standard_project'];
	}
	$project = & new Project ();
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_100_', 'bug_tracking');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php', 'post', 'bug_select_project');
	$form->AddTable ();
	$form->AddOpenRow ();
	$projects = $project->GetArray ();
	$options[0] = _BUG_ALL_PROJECTS;
	foreach ($projects as $value) {
		$options[$value['project_id']] = $value['project_name'];
	}
	unset ($projects);
	$form->SetSameCol ();
	$form->AddSelect ('sel_project', $options, $sel, 'document.forms.bug_select_project.submit();');
	$form->AddText ('&nbsp;');
	$form->AddHidden ('op', $op);
	$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, $sortby);
	$form->AddHidden ('sel_reporter', $sel_reporter);
	$form->AddHidden ('sel_handler', $sel_handler);
	$form->AddHidden ('sel_category', $sel_category);
	$form->AddHidden ('sel_severity', $sel_severity);
	$form->AddHidden ('sel_status', $sel_status);
	$form->AddHidden ('block_resolved', $block_resolved);
	$form->AddHidden ('block_resolved_hidden', $block_resolved_hidden);
	$form->AddHidden ('block_closed', $block_closed);
	$form->AddHidden ('block_closed_hidden', $block_closed_hidden);
	$form->AddHidden ('block_feature', $block_feature);
	$form->AddHidden ('block_feature_hidden', $block_feature_hidden);
	$form->AddHidden ('bugs_perpage', $bugs_perpage);
	$form->AddHidden ('sel_query', urlencode ($sel_query) );
	$form->AddHidden ('bug_id', $bug_id);
	$form->AddSubmit ('change', _BUG_CHANGE);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtext);
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
	$form->AddTable ();
	$form->AddOpenRow ();
	$form->SetSameCol ();
	$form->AddTextfield ('bug_id', 10, 10);
	$form->AddText ('&nbsp;');
	$form->AddHidden ('op', 'view_bug');
	$form->AddHidden ('sel_project', $sel);
	$form->AddSubmit ('submit', _BUG_JUMPBUG);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtext);
	$boxtext .= '<br /><br /></div>';
	return $boxtext;

}

function BugTracking_AddHistory ($bug_id, $user_id, $field_name, $old_value, $new_value, $type) {

	global $bugshistory;

	set_var ('user_id', $user_id, 'form');
	set_var ('field_name', $field_name, 'form');
	set_var ('old_value', $old_value, 'form');
	set_var ('new_value', $new_value, 'form');
	set_var ('wtype', $type, 'form');
	$bugshistory->AddRecord ($bug_id);
	set_var ('user_id', 0, 'form');
	set_var ('field_name', '', 'form');
	set_var ('old_value', '', 'form');
	set_var ('new_value', '', 'form');
	set_var ('wtype', $type, 'form');

}

function BugTacking_ArraySort ($a, $b) {

	$a = strtoupper ($a);
	$b = strtoupper ($b);
	return strcollcase ($a, $b);

}

function BugTracking_CheckAdmin ($project = 0) {

	global $opnConfig;

	$admins = & new ProjectUser ();
	if ($project) {
		$admins->SetProject ($project);
	}
	if ($admins->GetCount ($opnConfig['permission']->UserInfo ('uid') ) ) {
		return true;
	}
	return false;

}

function BugTracking_CheckAdmins ($project) {

	$admins = & new ProjectUser ();
	$admins->SetProject ($project);
	if ($admins->GetCount () ) {
		return true;
	}
	return false;

}

function BugTracking_Index ($project, $category, $bugvalues, $settings, $bugusers) {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$sel_project = -1;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$sortby = 'desc_date_updated';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$sel_reporter = 0;
	get_var ('sel_reporter', $sel_reporter, 'both', _OOBJ_DTYPE_INT);
	$sel_handler = 0;
	get_var ('sel_handler', $sel_handler, 'both', _OOBJ_DTYPE_INT);
	$sel_category = 0;
	get_var ('sel_category', $sel_category, 'both', _OOBJ_DTYPE_INT);
	$sel_severity = 0;
	get_var ('sel_severity', $sel_severity, 'both', _OOBJ_DTYPE_INT);
	$sel_reproducibility = 0;
	get_var ('sel_reproducibility', $sel_reproducibility, 'both', _OOBJ_DTYPE_INT);
	$sel_priority = 0;
	get_var ('sel_priority', $sel_priority, 'both', _OOBJ_DTYPE_INT);
	$sel_resolution = 0;
	get_var ('sel_resolution', $sel_resolution, 'both', _OOBJ_DTYPE_INT);
	$sel_projection = 0;
	get_var ('sel_projection', $sel_projection, 'both', _OOBJ_DTYPE_INT);
	$sel_eta = 0;
	get_var ('sel_eta', $sel_eta, 'both', _OOBJ_DTYPE_INT);
	$sel_status = 0;
	get_var ('sel_status', $sel_status, 'both', _OOBJ_DTYPE_INT);
	$block_resolved = 0;
	get_var ('block_resolved', $block_resolved, 'both', _OOBJ_DTYPE_INT);
	$block_resolved_hidden = 0;
	get_var ('block_resolved_hidden', $block_resolved_hidden, 'both', _OOBJ_DTYPE_INT);
	$block_closed = 0;
	get_var ('block_closed', $block_closed, 'both', _OOBJ_DTYPE_INT);
	$block_closed_hidden = 0;
	get_var ('block_closed_hidden', $block_closed_hidden, 'both', _OOBJ_DTYPE_INT);
	$block_feature = 0;
	get_var ('block_feature', $block_feature, 'both', _OOBJ_DTYPE_INT);
	$block_feature_hidden = 0;
	get_var ('block_feature_hidden', $block_feature_hidden, 'both', _OOBJ_DTYPE_INT);
	$bugs_perpage = $settings['bugs_perpage'];
	get_var ('bugs_perpage', $bugs_perpage, 'both', _OOBJ_DTYPE_INT);
	$sel_query = '';
	get_var ('sel_query', $sel_query, 'both');
	$sel_query = urldecode ($sel_query);
	if ($sel_project == -1) {
		$sel_project = $settings['standard_project'];
	}
	if (!$block_resolved_hidden) {
		$block_resolved = $settings['bug_resolved'];
	}
	if (!$block_closed_hidden) {
		$block_closed = $settings['bug_closed'];
	}
	if (!$block_feature_hidden) {
		$block_feature = $settings['bug_feature'];
	}
	$progurlp = array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
			'sel_project' => $sel_project,
			'sel_reporter' => $sel_reporter,
			'sel_handler' => $sel_handler,
			'sel_category' => $sel_category,
			'sel_severity' => $sel_severity,
			'sel_reproducibility' => $sel_reproducibility,
			'sel_priority' => $sel_priority,
			'sel_resolution' => $sel_resolution,
			'sel_projection' => $sel_projection,
			'sel_eta' => $sel_eta,
			'sel_status' => $sel_status,
			'block_resolved' => $block_resolved,
			'block_resolved_hidden' => $block_resolved_hidden,
			'block_closed' => $block_closed,
			'block_closed_hidden' => $block_closed_hidden,
			'bugs_perpage' => $bugs_perpage,
			'block_feature' => $block_feature,
			'block_feature_hidden' => $block_feature_hidden,
			'sel_query',
			urlencode ($sel_query) );
	$progurlp['offset'] = $offset;
	$progurlp['sortyby'] = $sortby;
	$hlp1 = encodeurl ($progurlp);
	$opnConfig['put_to_head']['bugtrackingrefresh'] = '<meta http-equiv="refresh" content="' . ($settings['refresh_rate']*60) . ';url=' . $hlp1 . '" />';
	$bugs = & new Bugs ();
	$category = & new ProjectCategory ();
	$bugsnotes = & new BugsNotes ();
	$attachments = & new BugsAttachments ();
	$bugs->SetProject ($sel_project);
	$bugs->SetCategory ($sel_category);
	$bugs->SetSeverity ($sel_severity);
	if ($sel_reproducibility > 0) {
		$bugs->SetReproducibility ($sel_reproducibility);
	}
	if ($sel_priority > 0) {
		$bugs->SetPriority ($sel_priority);
	}
	if ($sel_resolution > 0) {
		$bugs->SetResolution ($sel_resolution);
	}
	if ($sel_projection > 0) {
		$bugs->SetProjection ($sel_projection);
	}
	if ($sel_eta > 0) {
		$bugs->SetEta ($sel_eta);
	}
	$bugs->SetQuery ($sel_query);
	if ($sel_status) {
		$bugs->SetStatus ($sel_status);
		$bugs->ClearBlockStatus ();
	}
	$boxtxt = mainheaderbug_tracking (0, '', $sel_project, $sortby, $sel_reporter, $sel_handler, $sel_category, $sel_severity, $sel_status, $block_resolved, $block_resolved_hidden, $block_closed, $block_closed_hidden, $block_feature, $block_feature_hidden, $bugs_perpage, $sel_query);
	$form = & new opn_BugFormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_FILTER_', 'bug_tracking');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php', 'post', 'bugsfilter');
	$form->AddTable ('alternator');
	$form->AddCols ( array ('10%','10%','10%','10%','10%','10%','40%'));
	$form->OpenHeaderRow ();
	$form->AddText (_BUG_REPORTER);
	$form->AddText (_BUG_HANDLER);
	$form->AddText (_BUG_CATEGORY);
	$form->AddText (_BUG_SEVERITY);
	$form->AddText (_BUG_STATUS);
	$form->AddText (_BUG_SHOW);
	$form->AddText (_BUG_BLOCK_STATUS);
	$form->CloseHeaderRow ();
	$form->AddOpenRow ();
	// Add select for reporters
	$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us WHERE ((us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ') AND (u.uid <> ' . $opnConfig['opn_anonymous_id'] . ')) ORDER BY uname');
	$options = array ();
	$options[0] = _BUG_ALL;
	while (! $result->EOF) {
		$options[$result->fields['uid']] = $result->fields['uname'];
		$result->MoveNext ();
	}
	$form->AddSelect ('sel_reporter', $options, $sel_reporter);
	$result->Close ();
	// Add select for handlers
	$options = array ();
	$options[0] = _BUG_ALL;
	$options = $options+ $bugusers;
	$form->AddSelect ('sel_handler', $options, $sel_handler);
	// Add select for categories
	$options = array ();
	$options[0] = _BUG_ALL;
	if ($sel_project) {
		$category->SetProject ($sel_project);
		if ($category->GetCount () ) {
			$cats = $category->GetArray ();
			foreach ($cats as $value) {
				$options[$value['category_id']] = $value['category'];
			}
		}
	}
	$form->AddSelect ('sel_category', $options, $sel_category);
	// Add select for severity
	BugTracking_BuildOptions ($options, $bugvalues['severity'], _BUG_ALL);
	$form->AddSelect ('sel_severity', $options, $sel_severity);
	// Add select for status
	BugTracking_BuildOptions ($options, $bugvalues['status'], _BUG_ALL);
	$form->AddSelect ('sel_status', $options, $sel_status);
	// Add bugs per page
	$form->AddTextfield ('bugs_perpage', 5, 5, $bugs_perpage);
	// Add checkboxes for blocking states
	$form->SetSameCol ();
	$form->AddCheckbox ('block_resolved', 1, ($block_resolved == 1?true : false) );
	$form->AddLabel ('block_resolved', '&nbsp;' . _BUG_STATUS_RESOLVED, 1);
	$form->AddHidden ('block_resolved_hidden', 1);
	$form->AddText ('&nbsp;&nbsp;&nbsp;');
	$form->AddCheckbox ('block_closed', 1, ($block_closed == 1?true : false) );
	$form->AddHidden ('block_closed_hidden', 1);
	$form->AddLabel ('block_closed', '&nbsp;' . _BUG_STATUS_CLOSED, 1);
	$form->AddText ('&nbsp;&nbsp;&nbsp;');
	$form->AddCheckbox ('block_feature', 1, ($block_feature == 1?true : false) );
	$form->AddHidden ('block_feature_hidden', 1);
	$form->AddLabel ('block_feature', '&nbsp;' . _BUG_SEVERITY_FEATURE, 1);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->OpenHeaderRow ();
	$form->AddText (_BUG_REPRO);
	$form->AddText (_BUG_PRIORITY);
	$form->AddText (_BUG_RESOLUTION);
	$form->AddText (_BUG_PROJECTION);
	$form->AddText (_BUG_ETA);
	$form->SetColspan ('2');
	$form->AddText (_BUG_SEARCH);
	$form->CloseHeaderRow ();
	$form->AddOpenRow ();
	$form->SetColspan ('');
	BugTracking_BuildOptions ($options, $bugvalues['reproducibility'], _BUG_ALL);
	$form->AddSelect ('sel_reproducibility', $options, $sel_reproducibility);
	BugTracking_BuildOptions ($options, $bugvalues['priority'], _BUG_ALL);
	$form->AddSelect ('sel_priority', $options, $sel_priority);
	BugTracking_BuildOptions ($options, $bugvalues['resolution'], _BUG_ALL);
	$form->AddSelect ('sel_resolution', $options, $sel_resolution);
	BugTracking_BuildOptions ($options, $bugvalues['projection'], _BUG_ALL);
	$form->AddSelect ('sel_projection', $options, $sel_projection);
	BugTracking_BuildOptions ($options, $bugvalues['eta'], _BUG_ALL);
	$form->AddSelect ('sel_eta', $options, $sel_eta);
	$form->SetColspan ('2');
	$form->AddTextfield ('sel_query', 32, 128, $sel_query);
	$form->AddCloseRow ();
	$form->OpenHeaderRow ();
	$form->SetColspan ('7');
	$form->AddText ('&nbsp;');
	$form->CloseHeaderRow ();
	$form->AddOpenRow ();
	$form->SetAlign ('right');
	$form->SetSameCol ();
	$form->AddHidden ('sel_project', $sel_project);
	$form->AddSubmit ('submit', _BUG_FILTER);
	$form->SetEndCol ();
	$form->SetColspan ('');
	$form->SetAlign ('');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$form = & new opn_BugFormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_BUGS_', 'bug_tracking');
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php', 'post', 'bugs');
	$form->AddTable ();
	$form->AddDataRow (array ('&nbsp;') );
	if ($opnConfig['permission']->IsUser () ) {
		if ( (!$sel_reporter) && (!$sel_handler) ) {
			$form->AddOpenRow ();
			$form->AddTable ('default');
			$form->AddCols (array ('50%', '50%') );
			$form->AddOpenRow ();
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$bugs->SetHandler ($uid);
			$bugs->SetBlockStatus (_OPN_BUG_STATUS_RESOLVED);
			$bugs->SetBlockStatus (_OPN_BUG_STATUS_CLOSED);
			unset ($progurlp['offset']);
			$progurlp['sel_reporter'] = 0;
			$progurlp['sel_handler'] = $uid;
			$form->AddText (_BUG_OPEN_ASSIGNED_TO_ME . '<a class="opncenterbox" href="' . encodeurl ($progurlp) . '">' . $bugs->GetCount () . '</a>');
			$form->SetAlign ('right');
			$bugs->SetHandler (0);
			$bugs->SetReporter ($uid);
			$progurlp['sel_reporter'] = $uid;
			$progurlp['sel_handler'] = 0;
			$form->AddText (_BUG_OPEN_REPORTED_BY_ME . '<a class="opncenterbox" href="' . encodeurl ($progurlp) . '">' . $bugs->GetCount () . '</a>');
			$bugs->ClearBlockStatus ();
			$bugs->SetReporter (0);
			$form->SetAlign ('');
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddCloseRow ();
			$form->AddDataRow (array ('&nbsp;') );
		}
	}
	$helper = '';
	if ($opnConfig['permission']->HasRight ('modules/bug_tracking', _BUGT_PERM_CSV, true) ) {
		$progurlp['sel_reporter'] = $sel_reporter;
		$progurlp['sel_handler'] = $sel_handler;
		$progurlp['op'] = 'csvexport';
		$helper .= theme_boxi ($progurlp, _BUG_CSVEXPORT, '', '', '', true);
		unset ($progurlp['op']);
	}
	if ($helper != '') {
		$form->AddDataRow (array ($helper) );
		$form->AddDataRow (array ('&nbsp;') );
	}
	$form->AddOpenRow ();
	$bugs->SetReporter ($sel_reporter);
	$bugs->SetHandler ($sel_handler);
	if (!$sel_status) {
		if ($block_resolved) {
			$bugs->SetBlockStatus (_OPN_BUG_STATUS_RESOLVED);
		}
		if ($block_closed) {
			$bugs->SetBlockStatus (_OPN_BUG_STATUS_CLOSED);
		}
	}
	if (!$sel_severity) {
		if ($block_feature) {
			$bugs->SetBlockSeverity (_OPN_BUG_SEVERITY_FEATURE);
		}
	}
	$reccounter = $bugs->GetCount ();
	$form->AddTable ('default');
	$form->AddOpenRow ();
	$form->SetAlign ('center');
	$progurlp['sel_reporter'] = $sel_reporter;
	$progurlp['sel_handler'] = $sel_handler;
	$progurlp['sortby'] = $sortby;
	$pagebar = build_pagebar ($progurlp, $reccounter, $bugs_perpage, $offset);
	$form->AddText ($pagebar);
	$form->SetAlign ('');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseRow ();
	$form->AddDataRow (array ('&nbsp;') );
	$sortby1 = _BUG_ORDERBY . ' ';
	switch ($sortby) {
		case 'asc_bug_id':
			$sortby1 .= _BUG_ID . '&nbsp;' . _BUG_ORDERASC;
			break;
		case 'desc_bug_id':
			$sortby1 .= _BUG_ID . '&nbsp;' . _BUG_ORDERDESC;
			break;
		case 'asc_category':
			$sortby1 .= _BUG_CATEGORY . '&nbsp;' . _BUG_ORDERASC;
			break;
		case 'desc_category':
			$sortby1 .= _BUG_CATEGORY . '&nbsp;' . _BUG_ORDERDESC;
			break;
		case 'asc_severity':
			$sortby1 .= _BUG_SEVERITY . '&nbsp;' . _BUG_ORDERASC;
			break;
		case 'desc_severity':
			$sortby1 .= _BUG_SEVERITY . '&nbsp;' . _BUG_ORDERDESC;
			break;
		case 'asc_status':
			$sortby1 .= _BUG_STATUS . '&nbsp;' . _BUG_ORDERASC;
			break;
		case 'desc_status':
			$sortby1 .= _BUG_STATUS . '&nbsp;' . _BUG_ORDERDESC;
			break;
		case 'asc_date_updated':
			$sortby1 .= _BUG_DATE_UPDATED . '&nbsp;' . _BUG_ORDERASC;
			break;
		case 'desc_date_updated':
			$sortby1 .= _BUG_DATE_UPDATED . '&nbsp;' . _BUG_ORDERDESC;
			break;
		case 'asc_summary':
			$sortby1 .= _BUG_SUMMARY . '&nbsp;' . _BUG_ORDERASC;
			break;
		case 'desc_summary':
			$sortby1 .= _BUG_SUMMARY . '&nbsp;' . _BUG_ORDERDESC;
			break;
		case 'asc_project_id':
			$sortby1 .= _BUG_PROJECT . '&nbsp;' . _BUG_ORDERASC;
			break;
		case 'desc_project_id':
			$sortby1 .= _BUG_PROJECT . '&nbsp;' . _BUG_ORDERDESC;
			break;
	}
	$form->AddDataRow (array ($sortby1) );
	$form->AddOpenRow ();
	$form->AddTable ('bug');
	$form->OPenHeaderRow ();
	$order = '';
	$form->get_sort_order ($order, array ('bug_id',
						'category',
						'severity',
						'status',
						'date_updated',
						'summary'),
						$sortby);
	if (!$sel_project) {
		$form->get_sort_order ($order, 'project_id', $sortby);
	}
	$bugs->SetOrderby ($order);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
		$form->AddText ('&nbsp;');
	}
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
		$form->AddText ('&nbsp;');
	}
	$form->AddText (_BUG_PRIORITY_SHORT);
	$form->AddText ($form->get_sort_feld ('bug_id', _BUG_ID, $progurlp) );
	$form->AddText ('#');
	$colspanselbox = '10';
	if (!$sel_project) {
		$colspanselbox = '11';
		$form->AddText ($form->get_sort_feld ('project_id', _BUG_PROJECT, $progurlp) );
	}
	$form->AddText ($form->get_sort_feld ('category', _BUG_CATEGORY, $progurlp) );
	$form->AddText ($form->get_sort_feld ('severity', _BUG_SEVERITY, $progurlp) );
	$form->AddText ($form->get_sort_feld ('status', _BUG_STATUS, $progurlp) );
	$form->AddText ($form->get_sort_feld ('date_updated', _BUG_DATE_UPDATED, $progurlp) );
	$form->AddText ($form->get_sort_feld ('summary', _BUG_SUMMARY, $progurlp) );
	$form->CloseHeaderRow ();
	$result = $bugs->GetLimit ($bugs_perpage, $offset);
	while (! $result->EOF) {
		$form->AddOpenRow ();
		$form->SetAlign ('center');
		$form->SetClass ($bugvalues['altstatuscss'][$result->fields['status']]);
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) {
				$form->AddCheckBox ('work_bug[]',
													$result->fields['bug_id'],
													0,
													'CheckCheckAll(\'bugs\',\'bugall\');');
			} else {
				$form->AddText ('&nbsp;');
			}
		}
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) {
				$form->AddText ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
										'op' => 'edit_bug',
										'bug_id' => $result->fields['bug_id']), '*' ));
			} elseif (BugTracking_CheckAdmin ($result->fields['project_id']) ) {
				$form->AddText ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
										'op' => 'edit_bug',
										'bug_id' => $result->fields['bug_id']), '*' ));
			} else {
				$form->AddText ('&nbsp;');
			}
		}
		if ($bugvalues['priorityimage'][$result->fields['priority']] != '') {
			$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/' . $bugvalues['priorityimage'][$result->fields['priority']] . '" alt="' . $bugvalues['priority'][$result->fields['priority']] . '" title="' . $bugvalues['priority'][$result->fields['priority']] . '" />');
		} else {
			$form->AddText ('&nbsp;');
		}
		$form->AddText ('<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $result->fields['bug_id'],
								'sel_project' => $sel_project) ) . '">' . $result->fields['bug_id'] . '</a>');
		$bugsnotes->SetBug ($result->fields['bug_id']);
		if ($bugsnotes->GetCount () ) {
			$form->AddText ('<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $result->fields['bug_id'],
									'sel_project' => $sel_project),
									true,
									true,
									false,
									'#bugnotes') . '">' . $bugsnotes->GetCount () . '</a>');
		} else {
			$form->AddText ('&nbsp;');
		}
		if (!$sel_project) {
			$pro = $project->RetrieveSingle ($result->fields['project_id']);
			$form->AddText ($pro['project_name']);
		}
		if ($result->fields['category']) {
			$cat = $category->RetrieveSingle ($result->fields['category']);
			$form->AddText ($cat['category']);
		} else {
			$form->AddText ('&nbsp;');
		}
		$form->AddText ($bugvalues['severity'][$result->fields['severity']]);
		$help = $bugvalues['status'][$result->fields['status']];
		if ($result->fields['handler_id']) {
			$ui = $opnConfig['permission']->GetUser ($result->fields['handler_id'], 'useruid', '');
			$help .= '&nbsp;(' . $ui['uname'] . ')';
		}
		$form->AddText ($help);
		$opnConfig['opndate']->sqlToopnData ($result->fields['date_updated']);
		$time = '';
		$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING4);
		$form->AddText ($time);
		$form->SetAlign ('left');
		$help = htmlentities ($result->fields['summary']);
		if ($result->fields['view_state'] == 2) {
			$help .= '&nbsp;<img src="' . $opnConfig['opn_url'] . '/modules/bug_tracking/images/protected.gif" alt="' . _BUG_STATE_PRIVATE . '" title="' . _BUG_STATE_PRIVATE . '" />';
		}
		$attachments->SetBug ($result->fields['bug_id']);
		if ($attachments->GetCount () ) {
			$help .= '&nbsp;' . $opnConfig['defimages']->get_attachment_image (_BUG_ATTACHMENT_FOUND);
		}
		$form->AddText ($help);
		$form->AddCloseRow ();
		$result->MoveNext ();
	}
	$result->Close ();
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
		$form->SetClass ('opncenterbox');
		$form->SetAlign ('left');
		$options = array ();
		$options[0] = _BUG_MOVE;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$options[1] = _BUG_ASSIGN;
			$options[2] = _BUG_CLOSE;
			$options[3] = _BUG_DELETE;
		}
		$options[4] = _BUG_RESOLVE;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$options[5] = _BUG_CHANGE_PRIORITY;
			$options[6] = _BUG_CHANGE_STATUS;
			$options[7] = _BUG_CHANGE_VIEW_STATE;
		}
		$form->SetColspan ($colspanselbox);
		$form->SetSameCol ();
		$form->AddOpenRow ();
		$form->AddText (_BUG_SELECT_ALL . '&nbsp;:&nbsp;');
		$form->AddCheckbox ('bugall', 'Check All', 0, 'CheckAll(\'bugs\',\'bugall\');');
		$form->AddText ('&nbsp;&nbsp;&nbsp;');
		$form->AddSelect ('bug_change', $options);
		$form->AddText ('&nbsp;');
		$form->AddSubmit ('bug_changer', _BUG_OK);
		$form->SetEndCol ();
		$form->AddCloseRow ();
	}
	$form->SetColspan ('');
	$form->SetAlign ('');
	$form->SetClass ('');
	$form->AddTableClose ();
	$form->AddCloseRow ();
	$form->AddDataRow (array ('&nbsp;') );
	$form->AddOpenRow ();
	$form->AddTable ('bug');
	$form->AddCols (array ('15%', '14%', '14%', '14%', '14%', '14%', '15%') );
	$form->AddOpenRow ();
	foreach ($bugvalues['status'] as $key => $value) {
		$form->SetClass ($bugvalues['altstatuscss'][$key]);
		$form->AddText ($value);
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseRow ();
	$form->AddDataRow (array ('&nbsp;') );
	$form->AddOpenRow ();
	$form->AddTable ('default');
	$form->AddOpenRow ();
	$form->SetAlign ('center');
	$form->AddText ($pagebar);
	$form->SetAlign ('');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_120_';
	$_display_dat['module'] = 'modules/bug_tracking';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	$opnConfig['opnOutput']->EnableJavaScript ();
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);

}

function BugTracking_DisplayBug (&$form, $bug, $sel_project, $attachments = false) {

	global $opnConfig, $bugvalues, $bugsattachments;

	global $project, $category, $version;
	if ($bug['project_id']) {
		$pro = $project->RetrieveSingle ($bug['project_id']);
	} else {
		$pro['project_name'] = '&nbsp;';
	}
	if ($bug['category']) {
		$cat = $category->RetrieveSingle ($bug['category']);
	} else {
		$cat['category'] = '&nbsp;';
	}
	if ($bug['version']) {
		$ver = $version->RetrieveSingle ($bug['version']);
	} else {
		$ver['version'] = '&nbsp;';
	}
	$form->AddTable ('alternator');
	$form->OpenHeaderRow ();
	$form->AddText (_BUG_ID);
	$form->AddText (_BUG_CATEGORY);
	$form->AddText (_BUG_VERSION);
	$form->AddText (_BUG_SEVERITY);
	$form->AddText (_BUG_REPRO);
	$form->AddText (_BUG_DATE_SUBMITTED);
	$form->AddText (_BUG_DATE_UPDATED1);
	$form->CloseHeaderRow ();
	$form->AddOpenRow ();
	$form->AddText ($bug['bug_id']);
	$form->AddText ('[' . $pro['project_name'] . ']&nbsp;' . $cat['category']);
	$form->AddText ($ver['version']);
	$form->AddText ($bugvalues['severity'][$bug['severity']]);
	$form->AddText ($bugvalues['reproducibility'][$bug['reproducibility']]);
	$opnConfig['opndate']->sqlToopnData ($bug['date_submitted']);
	$time = '';
	$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
	$form->AddText ($time);
	$opnConfig['opndate']->sqlToopnData ($bug['date_updated']);
	$time = '';
	$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
	$form->AddText ($time);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseRow ();
	$form->AddDataRow (array ('&nbsp;') );
	$form->AddOpenRow ();
	$form->AddTable ('listalternator');
	$form->AddCols (array ('30%', '70%') );
	$form->AddOpenRow ();
	$form->AddText (_BUG_REPORTER);
	$ui = $opnConfig['permission']->GetUser ($bug['reporter_id'], 'useruid', '');
	$form->AddText ($ui['uname']);
	$form->AddChangeRow ();
	$form->AddText (_BUG_DISPLAY_STATE);
	$form->AddText ($bugvalues['state'][$bug['view_state']]);
	$form->AddChangeRow ();
	$form->AddText (_BUG_HANDLER);
	if ($bug['handler_id']) {
		$ui = $opnConfig['permission']->GetUser ($bug['handler_id'], 'useruid', '');
		$form->AddText ($ui['uname']);
	} else {
		$form->AddText ('&nbsp;');
	}
	$form->AddChangeRow ();
	$form->AddText (_BUG_PRIORITY);
	$form->AddText ($bugvalues['priority'][$bug['priority']]);
	$form->AddChangeRow ();
	$form->AddText (_BUG_RESOLUTION);
	$form->AddText ($bugvalues['resolution'][$bug['resolution']]);
	$form->AddChangeRow ();
	$form->AddText (_BUG_STATUS);
	$form->SetClass ($bugvalues['listaltstatuscss'][$bug['status']]);
	$form->AddText ($bugvalues['status'][$bug['status']]);
	$form->SetClass ('');
	$form->AddChangeRow ();
	$form->AddText (_BUG_DUPLICATE_ID);
	if ($bug['duplicate_id']) {
		$form->AddText ('<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $bug['duplicate_id'],
								'sel_project' => $sel_project) ) . '">' . $bug['duplicate_id'] . '</a>');
	} else {
		$form->AddText ('&nbsp;');
	}
	$form->AddChangeRow ();
	$form->AddText (_BUG_PROJECTION);
	$form->AddText ($bugvalues['projection'][$bug['projection']]);
	$form->AddChangeRow ();
	$form->AddText (_BUG_ETA);
	$form->AddText ($bugvalues['eta'][$bug['eta']]);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseRow ();
	$form->AddDataRow (array ('&nbsp;') );
	$form->AddOpenRow ();
	$form->AddTable ('listalternator');
	$form->AddCols (array ('30%', '70%') );
	$form->AddOpenRow ();
	$form->AddText (_BUG_SUMMARY);
	$form->AddText ($bug['summary']);
	$form->AddChangeRow ();
	$form->AddText (_BUG_DESCRIPTION);
	$bug['description'] = htmlentities ($bug['description']);
	$bug['steps_to_reproduce'] = htmlentities ($bug['steps_to_reproduce']);
	$bug['additional_information'] = htmlentities ($bug['additional_information']);
	opn_nl2br ($bug['description']);
	opn_nl2br ($bug['steps_to_reproduce']);
	opn_nl2br ($bug['additional_information']);
	$form->AddText ($bug['description']);
	$form->AddChangeRow ();
	$form->AddText (_BUG_STEPS_TO_REPRO);
	$form->AddText ($bug['steps_to_reproduce']);
	$form->AddChangeRow ();
	$form->AddText (_BUG_ADDITIONAL_INFO);
	$form->AddText ($bug['additional_information']);
	if ($attachments) {
		if ($opnConfig['attachmentenable']>0) {
			$bugsattachments->SetBug ($bug['bug_id']);
			$attachs = $bugsattachments->loadAttachmentContext ();
			if (count ($attachs) ) {
				$form->AddChangeRow ();
				$form->AddText ('<a name="attachments" id="attachments"></a>' . _BUG_ATTACHMENT_ATTACHMENTS);
				$form->SetSameCol ();
				$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
				$url['op'] = 'delete_attachment';
				$url['bug_id'] = $bug['bug_id'];
				$url['sel_project'] = $sel_project;
				foreach ($attachs as $attach) {
					$hlp1 = $attach['icon'] . '&nbsp;' . $attach['link'];
					$hlp1 .= ' (';
					$hlp1 .= $attach['size'];
					$hlp1 .= ($attach['is_image']?', ' . $attach['width'] . 'x' . $attach['height'] : '');
					$hlp1 .= ')';
					if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
						$url['attachment_id'] = $attach['id'];
						$hlp1 .= ' [<a class="%alternate%" href="' . encodeurl ($url) . '">' . _BUG_DELETE . '</a>]';
					}
					if (isset ($attach['image']) ) {
						$hlp1 .= '<br />' . $attach['image'];
					}
					$hlp1 .= '<br />';
					$form->AddText ($hlp1);
				}
				$form->SetEndCol ();
			}
		}
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();

}

function BugTracking_ViewBug () {

	global $opnConfig;

	global $bugs, $bugshistory, $bugsmonitoring, $bugsnotes;

	global $project, $bugsrelation;

	global $bugvalues, $bugusers;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$boxtxt = mainheaderbug_tracking (1, 'view_bug', $sel_project, '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, '', $bug_id);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if (count ($bug) ) {
		$bugshistory->SetBug ($bug_id);
		$bugsmonitoring->SetBug ($bug_id);
		$bugsnotes->SetBug ($bug_id);
		$form = & new opn_BugFormularClass ('default');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_130_', 'bug_tracking');
		if ( ($opnConfig['attachmentenable'] == 1) && ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_ATTACHMENT, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) ) {
			$enc = 'multipart/form-data';
		} else {
			$enc = '';
		}
		$form->UseEditor (false);
		$form->UseWysiwyg (false);
		$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php', 'post', 'bug', $enc);
		$form->AddTable ();
		$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $bug_id,
									'sel_project' => $sel_project),
									true,
									true,
									false,
									'#bugnotes') . '">' . _BUG_JUMP_TO_NOTES . '</a>&nbsp;&nbsp;&nbsp;' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
																	'op' => 'view_bug',
																	'bug_id' => $bug_id,
																	'sel_project' => $sel_project),
																	true,
																	true,
																	false,
																	'#history') . '">' . _BUG_JUMP_TO_HISTORY . '</a>';
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$hlp .= '&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
													'op' => 'reminder',
													'bug_id' => $bug_id,
													'sel_project' => $sel_project) ) . '">' . _BUG_SEND_REMINDER . '</a>';
		}
		$hlp .= '&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/printbug.php',
												'bug_id' => $bug_id) ) . '" target="_blank">' . _BUG_PRINT . '</a>';
		$form->AddDataRow (array ($hlp) );
		$form->AddDataRow (array ('&nbsp;') );
		$form->AddOpenRow ();
		BugTracking_DisplayBug ($form, $bug, $sel_project, true);
		$form->AddCloseRow ();
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form->AddDataRow (array ('&nbsp;') );
			$form->AddOpenRow ();
			$status = $bug['status'];
			$form->AddTable ('default');
			$form->AddOpenRow ();
			$form->SetAlign ('center');
			$form->SetSameCol ();
			$form->AddHidden ('bug_id', $bug_id);
			$form->AddHidden ('sel_project', $sel_project);
			if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
				if ( ($status != _OPN_BUG_STATUS_RESOLVED) && ($status != _OPN_BUG_STATUS_CLOSED) ) {
					$form->AddText ('&nbsp;');
					$form->AddSubmit ('edit_bug', _BUG_EDIT_BUG);
					$form->AddText ('&nbsp;');
					$options = array ();
					if ($status == _OPN_BUG_STATUS_ASSIGNED) {
						if ($bug['handler_id']) {
							if ($bug['handler_id'] != $opnConfig['permission']->Userinfo ('uid') ) {
								$options[-1] = _BUG_ASSIGN_SELF;
								$options[1] = '&nbsp;';
							} else {
								$options[0] = _BUG_ASSIGN_REPORTER;
								$options[1] = '&nbsp;';
							}
						} else {
							$options[-1] = _BUG_ASSIGN_SELF;
							$options[0] = _BUG_ASSIGN_REPORTER;
						}
					} else {
						$options[-1] = _BUG_ASSIGN_SELF;
						$options[0] = _BUG_ASSIGN_REPORTER;
					}
					if (!BugTracking_CheckAdmins ($bug['project_id']) ) {
						$options = $options+ $bugusers;
					} else {
						$admins = & new ProjectUser ();
						$admins->SetProject ($bug['project_id']);
						$users = $admins->GetArray ();
						$user = array ();
						foreach ($users as $value) {
							$ui = $opnConfig['permission']->GetUser ($value['user_id'], 'useruid', '');
							$user[$value['user_id']] = $ui['uname'];
						}
						unset ($users);
						unset ($admins);
						unset ($ui);
						$options = $options+ $user;
						unset ($user);
					}
					$form->AddSubmit ('assign_to', _BUG_ASSIGN_TO);
					$form->AddSelect ('handler_id', $options);
				}
				$form->AddText ('&nbsp;');
				if ($status == _OPN_BUG_STATUS_RESOLVED) {
					$form->AddSubmit ('reopenresolve_bug', _BUG_REOPEN_BUG);
				} elseif ($status != _OPN_BUG_STATUS_CLOSED) {
					$form->AddSubmit ('resolve_bug', _BUG_RESOLVE_BUG);
				}
				$form->AddText ('&nbsp;');
				if ($status == _OPN_BUG_STATUS_CLOSED) {
					$form->AddSubmit ('reopenclose_bug', _BUG_REOPEN_BUG);
				} else {
					$form->AddSubmit ('close_bug', _BUG_CLOSE_BUG);
				}
				$form->AddText ('&nbsp;');
				$form->AddSubmit ('move_bug', _BUG_MOVE);
			}
			if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
				$bugsmonitoring->SetUser ($opnConfig['permission']->Userinfo ('uid') );
				$form->AddText ('&nbsp;');
				if ($bugsmonitoring->GetCount () ) {
					$form->AddSubmit ('unmonitorbug', _BUG_UNMONITOR_BUG);
				} else {
					$form->AddSubmit ('monitorbug', _BUG_MONITOR_BUG);
				}
			}
			if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
				$form->AddText ('&nbsp;');
				$form->AddSubmit ('delete_bug', _BUG_DELETE_BUG);
			}
			$form->SetEndCol ();
			$form->SetAlign ('');
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddCloseRow ();
		}
		$form->AddDataRow (array ('&nbsp;') );
		$hlp = '';
		$bugsrelation->ClearCache ();
		$bugsrelation->SetBug ($bug_id);
		if ( ($bugsrelation->GetCount () ) && ($opnConfig['bugtracking_graphviz_enable']) ) {
			$url = array ();
			$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
			$url['bug_id'] = $bug_id;
			$url['sel_project'] = $sel_project;
			$url['op'] = 'graph_relation';
			$hlp = '&nbsp;&nbsp;[<a href="' . encodeurl ($url) . '">' . _BUG_GRAPH_REALATION . '</a>]&nbsp;&nbsp;';
			$url['op'] = 'graph_dependency';
			$hlp .= '[<a href="' . encodeurl ($url) . '">' . _BUG_GRAPH_DEPENDENCY . '</a>]';
		}
		$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_BUG_RELATIONSHIPS . '</span>' . $hlp) );
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddCols (array ('30%', '70%') );
			$form->AddOpenRow ();
			$form->AddText (_BUG_NEW_RELATION);
			$form->SetSameCol ();
			$form->AddLabel ('relation', _BUG_THIS_BUG);
			$options = array ();
			$options[_OPN_BUG_RELATION_RELATED] = _BUG_RELATED_TO;
			$options[_OPN_BUG_RELATION_DEPENDANT_ON] = _BUG_DEPENDANT_ON;
			$options[_OPN_BUG_RELATION_DEPENDANT_OF] = _BUG_DEPENDANT_OF;
			$options[_OPN_BUG_RELATION_DUPLICATE_OF] = _BUG_DUPLICATE_OF;
			$options[_OPN_BUG_RELATION_HAS_DUPLICATE] = _BUG_HAS_DUPLICATE;
			$form->AddSelect ('relation', $options);
			$form->AddTextfield ('destination_id', 5, 5);
			$form->AddText ('&nbsp;');
			$form->AddHidden ('source_id', $bug_id);
			$form->AddSubmit ('add_addrelation', _BUG_ADD_RELATION);
			$form->SetEndCol ();
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddCloseRow ();
		}
		if ($bugsrelation->GetCount () ) {
			$rels = $bugsrelation->GetArray ();
			$form->AddOpenRow ();
			$form->AddTable ('bug');
			foreach ($rels as $rel) {
				$id = $rel['relation_id'];
				$source = $rel['source_bug_id'];
				$dest = $rel['destination_bug_id'];
				$type = $rel['relation_type'];
				if ($dest == $bug_id) {
					$dest = $source;
				}
				switch ($type) {
					case _OPN_BUG_RELATION_RELATED:
						$text = _BUG_RELATED_TO;
						break;
					case _OPN_BUG_RELATION_DEPENDANT_ON:
						$text = _BUG_DEPENDANT_ON;
						break;
					case _OPN_BUG_RELATION_DEPENDANT_OF:
						$text = _BUG_DEPENDANT_OF;
						break;
					case _OPN_BUG_RELATION_DUPLICATE_OF:
						$text = _BUG_DUPLICATE_OF;
						break;
					case _OPN_BUG_RELATION_HAS_DUPLICATE:
						$text = _BUG_HAS_DUPLICATE;
						break;
				}
				// switch
				$dbug = $bugs->RetrieveSingle ($dest);
				if (count ($dbug) ) {
					$rcss = $bugvalues['altstatuscss'][$dbug['status']];
					$form->SetClass ($rcss);
					$form->AddOpenRow ('', '', $rcss);
					$form->AddDataCol ($text, '', '', '', '', $rcss);
					$url = array ();
					$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
					$url['op'] = 'view_bug';
					$url['bug_id'] = $dest;
					$form->AddDataCol ('<a href="' . encodeurl ($url) . '">' . $dest . '</a>', '', '', '', '', $rcss);
					$form->AddDataCol ($bugvalues['status'][$dbug['status']], '', '', '', '', $rcss);
					if ($dbug['handler_id']) {
						$ui = $opnConfig['permission']->GetUser ($dbug['handler_id'], 'useruid', '');
						$name = $ui['uname'];
					} else {
						$name = '&nbsp;';
					}
					// if
					$form->AddDataCol ($name, '', '', '', '', $rcss);
					$pro = $project->RetrieveSingle ($dbug['project_id']);
					$form->AddDataCol ($pro['project_name'], '', '', '', '', $rcss);
					$link = '';
					if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
						$url = array ();
						$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
						$url['op'] = 'delete_relation';
						$url['bug_id'] = $bug_id;
						$url['sel_project'] = $sel_project;
						$url['relation_id'] = $id;
						$link = ' [<a href="' . encodeurl ($url) . '">' . _BUG_DELETE . '</a>]';
					}
					$form->AddDataCol (htmlentities ($dbug['summary']) . $link, '', '', '', '', $rcss);
				} else {
					$form->AddOpenRow ();
					$form->AddDataCol ('<span class="alerttext">' . sprintf (_BUG_NO_DEST_BUG, $dest) . '</span>', '', '5');
					$link = '';
					if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
						$url = array ();
						$url[0] = $opnConfig['opn_url'] . '/modules/bug_tracking/index.php';
						$url['op'] = 'delete_relation';
						$url['bug_id'] = $bug_id;
						$url['sel_project'] = $sel_project;
						$url['relation_id'] = $id;
						$link = ' [<a href="' . encodeurl ($url) . '">' . _BUG_DELETE . '</a>]';
					}
					$form->AddDataCol ($link);
				}
				$form->AddCloseRow ();
			}
			if (!BugTracking_relationship_can_resolve_bug ($bug_id) ) {
				$form->SetClass ('opncenterbox');
				$form->AddOpenRow ();
				$form->AddDataCol (_BUG_RELATIONSHIP_WARNING_BLOCKING_BUGS_NOT_RESOLVED, '', '6');
				$form->AddCloseRow ();
			}
			$form->AddTableClose ();
			$form->AddCloseRow ();
		}
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_ATTACHMENT, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			if ($opnConfig['attachmentenable'] == 1) {
				$form->AddDataRow (array ('&nbsp;') );
				$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_ATTACHMENT_ADD . '</span>') );
				$form->AddOpenRow ();
				$form->AddTable ('listalternator');
				$form->AddCols (array ('30%', '70%') );
				$form->AddOpenRow ();
				$form->AddText (sprintf (_BUG_ATTACHMENT_CHOOSE, $opnConfig['attachmentsizelimit']) );
				$form->SetSameCol ();
				$form->AddHidden ('bug_id', $bug_id);
				$form->AddHidden ('sel_project', $sel_project);
				$form->AddHidden ('max_file_size', $opnConfig['attachmentsizelimit']*1024);
				$form->AddFile ('file');
				$form->AddText ('&nbsp;');
				$form->AddSubmit ('add_file', _BUG_ATTACHMENT_SEND);
				$form->SetEndCol ();
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddCloseRow ();
			}
		}
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form->AddDataRow (array ('&nbsp;') );
			$bugsmonitoring->ClearCache ();
			$bugsmonitoring->SetBug ($bug_id);
			$bugsmonitoring->SetUser (0);
			if ($bugsmonitoring->GetCount () ) {
				$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_MONITORING_MAIN . '</span>') );
				$form->AddOpenRow ();
				$monis = $bugsmonitoring->GetArray ();
				$users = array ();
				foreach ($monis as $value) {
					$ui = $opnConfig['permission']->GetUser ($value['user_id'], 'useruid', '');
					if (isset ($ui['uname']) ) {
						$users[] = $ui['uname'];
					} else {
						$users[] = $value['user_id'];
					}
				}
				$monis = implode (', ', $users);
				$form->AddTable ('listalternator');
				$form->AddCols (array ('30%', '70%') );
				$form->AddOpenRow ();
				$form->AddText (_BUG_MONITORING_LIST);
				$form->AddText ($monis);
				unset ($monis);
			} else {
				$form->AddOpenRow ();
				$form->AddTable ('default');
				$form->SetAlign ('center');
				$form->AddOpenRow ();
				$form->AddText (_BUG_NO_MONITORING);
				$form->SetAlign ('');
			}
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddCloseRow ();
		}
		if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) {
			$form->AddDataRow (array ('&nbsp;') );
			$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_ADD_BUGNOTE . '</span>') );
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddCols (array ('30%', '70%') );
			$form->AddOpenRow ();
			$form->AddText (_BUG_BUGNOTES);
			$form->AddTextarea ('note', 0, 0, '');
			if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
				$form->AddChangeRow ();
				$form->AddLabel ('view_state', $bugvalues['state'][_OPN_BUG_STATE_PRIVATE]);
				$form->AddCheckBox ('view_state', _OPN_BUG_STATE_PRIVATE);
			}
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('bug_id', $bug_id);
			$form->AddHidden ('sel_project', $sel_project);
			$form->AddHidden ('reporter_id', $opnConfig['permission']->Userinfo ('uid') );
			if ( (!$opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) && (!BugTracking_CheckAdmin ($bug['project_id']) ) ) {
				$form->AddHidden ('view_state',
													_OPN_BUG_STATE_PUBLIC);
			}
			$form->SetEndCol ();
			$form->AddSubmit ('add_note', _BUG_ADD_BUGNOTE);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddCloseRow ();
		}
		$form->AddDataRow (array ('&nbsp;<a name="bugnotes" id="bugnotes"></a>') );
		if ($bugsnotes->GetCount () ) {
			$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_BUGNOTES . '</span>') );
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddCols (array ('30%', '70%') );
			$notes = $bugsnotes->GetArray ();
			foreach ($notes as $note) {
				$note['note'] = htmlentities ($note['note']);
				opn_nl2br ($note['note']);
				$form->AddOpenRow ();
				$form->SetSameCol ();
				$ui = $opnConfig['permission']->GetUser ($note['reporter_id'], 'useruid', '');
				$form->AddText ($ui['uname']);
				$form->AddNewLine ();
				$opnConfig['opndate']->sqlToopnData ($note['date_updated']);
				$time = '';
				$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
				$form->AddText ($time);
				$form->AddNewLine ();
				$isadmin = false;
				$isreporter = false;
				if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
					$isadmin = true;
				}
				if ($ui['uid'] == $opnConfig['permission']->Userinfo ('uid') ) {
					$isreporter = true;
				}
				$help = '';
				if ( ($isadmin) || ($isreporter) ) {
					$help .= '[<a class="listalternator" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
													'op' => 'edit_note',
													'note_id' => $note['note_id'],
													'uid' => $opnConfig['permission']->Userinfo ('uid'),
													'bug_id' => $bug_id,
													'sel_project' => $sel_project) ) . '">' . _BUG_EDIT . '</a>]';
					$help .= '[<a class="listalternator" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
													'op' => 'delete_note',
													'note_id' => $note['note_id'],
													'uid' => $opnConfig['permission']->Userinfo ('uid'),
													'bug_id' => $bug_id,
													'sel_project' => $sel_project) ) . '">' . _BUG_DELETE . '</a>]';
				}
				if ($isadmin) {
					if ($note['view_state'] == 2) {
						$help .= '[<a class="listalternator" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
														'op' => 'change_view_state_note',
														'note_id' => $note['note_id'],
														'view_state' => _OPN_BUG_STATE_PUBLIC,
														'uid' => $opnConfig['permission']->Userinfo ('uid'),
														'bug_id' => $bug_id,
														'sel_project' => $sel_project) ) . '">' . _BUG_MAKE_PUBLIC . '</a>]';
					} else {
						$help .= '[<a class="listalternator" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
														'op' => 'change_view_state_note',
														'note_id' => $note['note_id'],
														'view_state' => _OPN_BUG_STATE_PRIVATE,
														'uid' => $opnConfig['permission']->Userinfo ('uid'),
														'bug_id' => $bug_id,
														'sel_project' => $sel_project) ) . '">' . _BUG_MAKE_PRIVATE . '</a>]';
					}
				}
				$form->AddText ($help);
				$form->SetEndCol ();
				$form->AddText ($note['note']);
				$form->AddCloseRow ();
			}
			$form->AddTableClose ();
			$form->AddCloseRow ();
		} else {
			$form->SetAlign ('center');
			$form->AddDataRow (array (_BUG_NO_NOTES), array ('center') );
			$form->SetAlign ('');
		}
		$form->AddDataRow (array ('&nbsp;<a name="history" id="history"></a>') );
		$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_HISTORY . '</span>') );
		if ($bugshistory->GetCount () ) {
			$form->AddOpenRow ();
			$form->AddTable ('alternator');
			$history = $bugshistory->GetArray ();
			$form->AddCols (array ('20%', '20%', '30%', '30%') );
			$form->OpenHeaderRow ();
			$form->AddText (_BUG_CHANGE_DATE);
			$form->AddText (_BUG_USER_NAME);
			$form->AddText (_BUG_FIELD_NAME);
			$form->AddText (_BUG_CHANGED);
			$form->CloseHeaderRow ();
			foreach ($history as $value) {
				$form->AddOpenRow ();
				$form->AddText ($value['date']);
				$form->AddText ($value['username']);
				$form->AddText ($value['note']);
				if ($value['change'] != '') {
					$form->AddText ($value['change']);
				} else {
					$form->AddText ('&nbsp;');
				}
				$form->AddCloseRow ();
			}
			$form->AddTableClose ();
			$form->AddCloseRow ();
		}
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_140_';
	$_display_dat['module'] = 'modules/bug_tracking';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);

}

function BugTracking_ChangeViewStateNote () {

	global $opnConfig, $bugsnotes, $bugs;

	$note_id = 0;
	get_var ('note_id', $note_id, 'both', _OOBJ_DTYPE_INT);
	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$view_state = 0;
	get_var ('view_state', $view_state, 'both', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$isadmin = false;
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$isadmin = true;
	}
	if ($isadmin) {
		$bugsnotes->ModifyState ();
		$bugs->ModifyDate ($bug_id);
		$uid = $opnConfig['permission']->Userinfo ('uid');
		BugTracking_AddHistory ($bug_id, $uid, '', $view_state, $note_id, _OPN_HISTORY_BUGNOTE_STATE_CHANGED);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false,
							true,
							false,
							'#bugnotes') );

}

function BugTracking_DeleteNote () {

	global $opnConfig, $bugsnotes, $bugs;

	$note_id = 0;
	get_var ('note_id', $note_id, 'both', _OOBJ_DTYPE_INT);
	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUser ($uid, 'useruid', '');
	$bug = $bugs->RetrieveSingle ($bug_id);
	$isadmin = false;
	$isreporter = false;
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$isadmin = true;
	}
	if ($ui['uid'] == $opnConfig['permission']->Userinfo ('uid') ) {
		$isreporter = true;
	}
	if ($ok == 1) {
		if ( ($isadmin) || ($isreporter) ) {
			$bugsnotes->DeleteRecord ();
			$bugs->ModifyDate ($bug_id);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			BugTracking_AddHistory ($bug_id, $uid, '', $note_id, '', _OPN_HISTORY_BUGNOTE_DELETED);
		}
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $bug_id,
								'sel_project' => $sel_project),
								false,
								true,
								false,
								'#bugnotes') );
	} else {
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _BUG_DELETENOTE . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
										'op' => 'delete_note',
										'note_id' => $note_id,
										'uid' => $uid,
										'bug_id' => $bug_id,
										'sel_project' => $sel_project,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
															'op' => 'view_bug',
															'bug_id' => $bug_id,
															'sel_project' => $sel_project) ) . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_150_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $text);
	}

}

function BugTracking_EditNote () {

	global $opnConfig, $bugsnotes, $bugs;

	$boxtxt = '';
	$note_id = 0;
	get_var ('note_id', $note_id, 'both', _OOBJ_DTYPE_INT);
	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUser ($uid, 'useruid', '');
	$bug = $bugs->RetrieveSingle ($bug_id);
	$isadmin = false;
	$isreporter = false;
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$isadmin = true;
	}
	if ($ui['uid'] == $opnConfig['permission']->Userinfo ('uid') ) {
		$isreporter = true;
	}
	if ( ($isadmin) || ($isreporter) ) {
		$bugsnotes->ClearCache ();
		$note = $bugsnotes->RetrieveSingle ($note_id);
		$form = & new opn_BugFormularClass ('default');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_160_', 'bug_tracking');
		$form->UseEditor (false);
		$form->UseWysiwyg (false);
		$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
		$form->AddTable ();
		$form->AddCols (array ('50%', '50%') );
		$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_EDIT_BUGNOTE . '</span>', '<a class="opncenterbox" href="javascript:history.go(-1)">' . _BUG_GO_BACK . '</a>'), array ('left', 'right') );
		$form->SetColspan ('2');
		$form->AddDataRow (array ('&nbsp;', '&nbsp;') );
		$form->SetColspanTab ('2');
		$form->AddOpenRow ();
		$form->AddTable ('listalternator');
		$form->AddCols (array ('30%', '70%') );
		$form->AddOpenRow ();
		$form->AddText (_BUG_BUGNOTES);
		$form->AddTextarea ('note', 0, 0, '', $note['note']);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('bug_id', $bug_id);
		$form->AddHidden ('note_id', $note_id);
		$form->AddHidden ('uid', $uid);
		$form->AddHidden ('sel_project', $sel_project);
		$form->AddHidden ('op', 'modify_note');
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _BUG_UPDATE_INFORMATION);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddCloseRow ();
		$form->SetColspanTab ('');
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_170_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
	} else {
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $bug_id,
								'sel_project' => $sel_project),
								false,
								true,
								false,
								'#bugnotes') );
	}

}

function BugTracking_ModifyNote () {

	global $opnConfig, $bugsnotes, $bugs;

	$note_id = 0;
	get_var ('note_id', $note_id, 'form', _OOBJ_DTYPE_INT);
	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUser ($uid, 'useruid', '');
	$bug = $bugs->RetrieveSingle ($bug_id);
	$isadmin = false;
	$isreporter = false;
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$isadmin = true;
	}
	if ($ui['uid'] == $opnConfig['permission']->Userinfo ('uid') ) {
		$isreporter = true;
	}
	if ( ($isadmin) || ($isreporter) ) {
		$note = $bugsnotes->RetrieveSingle ($note_id);
		set_var ('view_state', $note['view_state'], 'form');
		$bugsnotes->ModifyRecord ();
		$bugs->ModifyDate ($bug_id);
		BugTracking_AddHistory ($bug_id, $uid, '', $note_id, '', _OPN_HISTORY_BUGNOTE_UPDATED);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false,
							true,
							false,
							'#bugnotes') );

}

function Bugtracking_AddNote () {

	global $opnConfig, $bugsnotes, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) {
		$uid = $opnConfig['permission']->Userinfo ('uid');
		set_var ('reproter_id', $uid, 'form');
		$note_id = $bugsnotes->AddRecord ($bug_id);
		$bugs->ModifyDate ($bug_id);
		BugTracking_AddHistory ($bug_id, $uid, '', $note_id, '', _OPN_HISTORY_BUGNOTE_ADDED);
		BugTracking_email_bugnote_add ($bug_id);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false,
							true,
							false,
							'#bugnotes') );

}

function Bugtracking_AddFile () {

	global $opnConfig, $bugsattachments, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_ATTACHMENT, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$attachment_id = $bugsattachments->AddRecord ($bug_id);
		if ($attachment_id) {
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$bugs->ModifyDate ($bug_id);
			$attach = $bugsattachments->RetrieveSingle ($attachment_id);
			BugTracking_AddHistory ($bug_id, $uid, '', $attach['filename'], '', _OPN_HISTORY_FILE_ADDED);
			BugTracking_email_bug_updated ($bug_id);
		}
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false,
							true,
							false,
							'#attachments') );

}

function BugTracking_MonitorBug () {

	global $opnConfig, $bugsmonitoring;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$uid = $opnConfig['permission']->Userinfo ('uid');
	if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) {
		set_var ('user_id',
											$uid,
											'form');
		$bugsmonitoring->AddRecord ($bug_id);
		BugTracking_AddHistory ($bug_id, $uid, '', $uid, '', _OPN_HISTORY_BUG_MONITOR);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_UnMonitorBug () {

	global $opnConfig, $bugsmonitoring;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$uid = $opnConfig['permission']->Userinfo ('uid');
	if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) {
		$bugsmonitoring->SetBug ($bug_id);
		$bugsmonitoring->SetUser ($uid);
		$bugsmonitoring->DeleteRecord ();
		BugTracking_AddHistory ($bug_id, $uid, '', $uid, '', _OPN_HISTORY_BUG_UNMONITOR);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_DeleteBug () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$isadmin = false;
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$isadmin = true;
	}
	if ($ok == 1) {
		if ($isadmin) {
			$uid = $opnConfig['permission']->Userinfo ('uid');
			BugTracking_AddHistory ($bug_id, $uid, '', '', '', _OPN_HISTORY_BUG_DELETED);
			BugTracking_email_bug_deleted ($bug_id);
			$bugs->DeleteRecord ($bug_id);
		}
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php', false) );
	} else {
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _BUG_DELETEBUG . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
										'op' => 'delete_bug',
										'bug_id' => $bug_id,
										'sel_project' => $sel_project,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
															'op' => 'view_bug',
															'bug_id' => $bug_id,
															'sel_project' => $sel_project) ) . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_180_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $text);
	}

}

function BugTracking_ReopenResolveBug () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if (count ($bug) ) {
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form = & new opn_BugFormularClass ('default');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_190_', 'bug_tracking');
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
			$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
			$form->AddTable ();
			$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_DOREOPEN_BUG . '</span>') );
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddOpenRow ();
			$form->AddText (_BUG_BUGNOTES);
			$form->AddTextarea ('note', 0, 0, '');
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('bug_id', $bug_id);
			$form->AddHidden ('sel_project', $sel_project);
			$form->AddHidden ('op', 'doreopen_resolve');
			$form->SetEndCol ();
			$form->AddSubmit ('submit', _BUG_REOPEN_BUG);
			$form->AddTableClose ();
			$form->AddCloseRow ();
			$form->AddDataRow (array ('&nbsp;') );
			$form->AddOpenRow ();
			BugTracking_DisplayBug ($form, $bug, $sel_project);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$boxtxt = '';
			$form->GetFormular ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_200_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $bug_id,
									'sel_project' => $sel_project),
									false) );
		}
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_210_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, _BUG_RESOLUTION_NOTBUG);
	}

}

function BugTracking_DoReopenResolveBug () {

	global $opnConfig, $bugs, $bugsnotes;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$uid = $opnConfig['permission']->Userinfo ('uid');
		$note = '';
		get_var ('note', $note, 'form', _OOBJ_DTYPE_CHECK);
		if ($note != '') {
			set_var ('reporter_id', $uid, 'form');
			$note_id = $bugsnotes->AddRecord ($bug_id);
			BugTracking_AddHistory ($bug_id, $uid, '', $note_id, '', _OPN_HISTORY_BUGNOTE_ADDED);
		}
		$bugs->ModifyResolution ($bug_id, _OPN_BUG_RESOLUTION_REOPEN);
		BugTracking_AddHistory ($bug_id, $uid, 'resolution', _OPN_BUG_RESOLUTION_FIXED, _OPN_BUG_RESOLUTION_REOPEN, _OPN_HISTORY_NORMAL_TYPE);
		$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_FEEDBACK);
		BugTracking_AddHistory ($bug_id, $uid, 'status', _OPN_BUG_STATUS_RESOLVED, _OPN_BUG_STATUS_FEEDBACK, _OPN_HISTORY_NORMAL_TYPE);
		$bugs->ModifyDate ($bug_id);
		BugTracking_email_reopen ($bug_id);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_ResolveBug () {

	global $opnConfig, $bugs, $bugvalues, $version;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if (count ($bug) ) {
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form = & new opn_BugFormularClass ('default');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_220_', 'bug_tracking');
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
			$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
			$form->AddTable ();
			$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_RESOLVE_BUG . '</span>') );
			if (!BugTracking_relationship_can_resolve_bug ($bug_id) ) {
				$form->AddDataRow (array (_BUG_RELATIONSHIP_WARNING_BLOCKING_BUGS_NOT_RESOLVED_2) );
			}
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddOpenRow ();
			$options = array ();
			foreach ($bugvalues['resolution'] as $key => $value) {
				$options[$key] = $value;
			}
			$form->AddLabel ('resolution', _BUG_RESOLUTION);
			$form->AddSelect ('resolution', $options, _OPN_BUG_RESOLUTION_FIXED);
			$form->AddChangeRow ();
			$form->AddLabel ('duplicate_id', _BUG_DUPLICATE_ID);
			$form->AddTextfield ('duplicate_id', 10, 10);
			$version->SetProject ($sel_project);
			$version->SetDescend ();
			$ver = $version->GetArray ();
			$options = array ();
			foreach ($ver as $value) {
				$options[$value['version_id']] = $value['version'];
			}
			$form->AddChangeRow ();
			$form->AddLabel ('fixed_in_version', _BUG_SOLVED_IN_VERSION);
			$form->AddSelect ('fixed_in_version', $options);
			$form->AddChangeRow ();
			$form->AddLabel ('note', _BUG_BUGNOTES);
			$form->AddTextarea ('note');
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('bug_id', $bug_id);
			$form->AddHidden ('sel_project', $sel_project);
			$form->AddHidden ('op', 'do_resolve');
			$form->SetEndCol ();
			$form->AddSubmit ('submit', _BUG_RESOLVE_BUG);
			$form->AddTableClose ();
			$form->AddCloseRow ();
			$form->AddDataRow (array ('&nbsp;') );
			$form->AddOpenRow ();
			BugTracking_DisplayBug ($form, $bug, $sel_project);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$boxtxt = '';
			$form->GetFormular ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_230_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $bug_id,
									'sel_project' => $sel_project),
									false) );
		}
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_240_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, _BUG_RESOLUTION_NOTBUG);
	}

}

function BugTracking_DoResolveBug () {

	global $opnConfig, $bugs, $bugsnotes;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$uid = $opnConfig['permission']->Userinfo ('uid');
		$bug = $bugs->RetrieveSingle ($bug_id);
		$resolution = 0;
		get_var ('resolution', $resolution, 'form', _OOBJ_DTYPE_INT);
		$note = '';
		get_var ('note', $note, 'form', _OOBJ_DTYPE_CHECK);
		$fixed_in_version = 0;
		get_var ('fixed_in_version', $fixed_in_version, 'form', _OOBJ_DTYPE_INT);
		$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_RESOLVED);
		BugTracking_AddHistory ($bug_id, $uid, 'status', $bug['status'], _OPN_BUG_STATUS_RESOLVED, _OPN_HISTORY_NORMAL_TYPE);
		if ($fixed_in_version) {
			$bugs->ModifyFixed ($bug_id, $fixed_in_version);
			BugTracking_AddHistory ($bug_id, $uid, 'fixed_in_version', $bug['fixed_in_version'], $fixed_in_version, _OPN_HISTORY_NORMAL_TYPE);
		}
		$bugs->ModifyResolution ($bug_id, $resolution);
		BugTracking_AddHistory ($bug_id, $uid, 'resolution', $bug['resolution'], $resolution, _OPN_HISTORY_NORMAL_TYPE);
		if (!$bug['handler_id']) {
			$bugs->ModifyHandler ($bug_id, $uid);
			BugTracking_AddHistory ($bug_id, $uid, 'handler_id', $bug['handler_id'], $uid, _OPN_HISTORY_NORMAL_TYPE);
		}
		$duplicate_id = 0;
		get_var ('duplicate_id', $duplicate_id, 'form', _OOBJ_DTYPE_INT);
		if ($duplicate_id) {
			$bugs->ModifyDuplicateID ($bug_id);
			BugTracking_AddHistory ($bug_id, $uid, 'duplicate_id', $bug['duplicate_id'], $duplicate_id, _OPN_HISTORY_NORMAL_TYPE);
		}
		if ($note != '') {
			set_var ('reporter_id', $uid, 'form');
			$note_id = $bugsnotes->AddRecord ($bug_id);
			BugTracking_AddHistory ($bug_id, $uid, '', $note_id, '', _OPN_HISTORY_BUGNOTE_ADDED);
		}
		$bugs->ModifyDate ($bug_id);
		BugTracking_email_resolved ($bug_id);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_ReopenBug () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if (count ($bug) ) {
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form = & new opn_BugFormularClass ('default');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_250_', 'bug_tracking');
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
			$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
			$form->AddTable ();
			$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_REOPEN_BUG . '</span>') );
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddOpenRow ();
			$form->AddText (_BUG_BUGNOTES);
			$form->AddTextarea ('note');
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('bug_id', $bug_id);
			$form->AddHidden ('sel_project', $sel_project);
			$form->AddHidden ('op', 'doreopen_close');
			$form->SetEndCol ();
			$form->AddSubmit ('submit', _BUG_REOPEN_BUG);
			$form->AddTableClose ();
			$form->AddCloseRow ();
			$form->AddDataRow (array ('&nbsp;') );
			$form->AddOpenRow ();
			BugTracking_DisplayBug ($form, $bug, $sel_project);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$boxtxt = '';
			$form->GetFormular ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_260_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $bug_id,
									'sel_project' => $sel_project),
									false) );
		}
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_270_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, _BUG_RESOLUTION_NOTBUG);
	}

}

function BugTracking_DoReopenBug () {

	global $opnConfig, $bugs, $bugsnotes;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$uid = $opnConfig['permission']->Userinfo ('uid');
		$bug = $bugs->RetrieveSingle ($bug_id);
		$note = '';
		get_var ('note', $note, 'form', _OOBJ_DTYPE_CHECK);
		if ($note != '') {
			set_var ('reporter_id', $uid, 'form');
			$note_id = $bugsnotes->AddRecord ($bug_id);
			BugTracking_AddHistory ($bug_id, $uid, '', $note_id, '', _OPN_HISTORY_BUGNOTE_ADDED);
		}
		$bugs->ModifyResolution ($bug_id, _OPN_BUG_RESOLUTION_REOPEN);
		BugTracking_AddHistory ($bug_id, $uid, 'resolution', $bug['resolution'], _OPN_BUG_RESOLUTION_REOPEN, _OPN_HISTORY_NORMAL_TYPE);
		$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_FEEDBACK);
		BugTracking_AddHistory ($bug_id, $uid, 'status', _OPN_BUG_STATUS_CLOSED, _OPN_BUG_STATUS_FEEDBACK, _OPN_HISTORY_NORMAL_TYPE);
		$bugs->ModifyDate ($bug_id);
		BugTracking_email_reopen ($bug_id);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_CloseBug () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if (count ($bug) ) {
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form = & new opn_BugFormularClass ('default');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_280_', 'bug_tracking');
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
			$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
			$form->AddTable ();
			$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_CLOSE_BUG . '</span>') );
			if (!BugTracking_relationship_can_resolve_bug ($bug_id) ) {
				$form->AddDataRow (array (_BUG_RELATIONSHIP_WARNING_BLOCKING_BUGS_NOT_RESOLVED_2) );
			}
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddOpenRow ();
			$form->AddLabel ('note', _BUG_BUGNOTES);
			$form->AddTextarea ('note');
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('bug_id', $bug_id);
			$form->AddHidden ('sel_project', $sel_project);
			$form->AddHidden ('op', 'do_close');
			$form->SetEndCol ();
			$form->AddSubmit ('submit', _BUG_CLOSE_BUG);
			$form->AddTableClose ();
			$form->AddCloseRow ();
			$form->AddDataRow (array ('&nbsp;') );
			$form->AddOpenRow ();
			BugTracking_DisplayBug ($form, $bug, $sel_project);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$boxtxt = '';
			$form->GetFormular ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_290_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $bug_id,
									'sel_project' => $sel_project),
									false) );
		}
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_300_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, _BUG_RESOLUTION_NOTBUG);
	}

}

function BugTracking_MoveBug () {

	global $opnConfig, $bugs, $project;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if (count ($bug) ) {
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
			$form = & new opn_BugFormularClass ('default');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_280_', 'bug_tracking');
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
			$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
			$form->AddTable ();
			$form->AddOpenRow ();
			$form->AddTable ('listalternator');
			$form->AddCols (array ('15%', '85%') );
			$form->AddOpenRow ();
			$projects = $project->GetArray ();
			$options = array ();
			foreach ($projects as $value) {
				$options[$value['project_id']] = $value['project_name'];
			}
			$form->AddLabel ('project_id', _BUG_MOVE_TITLE);
			$form->AddSelect ('project_id', $options);
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('bug_id', $bug_id);
			$form->AddHidden ('sel_project', $sel_project);
			$form->AddHidden ('op', 'do_move_bug');
			$form->SetEndCol ();
			$form->AddSubmit ('submit', _BUG_DO_MOVE);
			$form->AddTableClose ();
			$form->AddCloseRow ();
			$form->AddDataRow (array ('&nbsp;') );
			$form->AddOpenRow ();
			BugTracking_DisplayBug ($form, $bug, $sel_project);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$boxtxt = '';
			$form->GetFormular ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_290_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $bug_id,
									'sel_project' => $sel_project),
									false) );
		}
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_300_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, _BUG_RESOLUTION_NOTBUG);
	}

}

function BugTracking_DoCloseBug () {

	global $opnConfig, $bugs, $bugsnotes;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$uid = $opnConfig['permission']->Userinfo ('uid');
		$bug = $bugs->RetrieveSingle ($bug_id);
		$note = '';
		get_var ('note', $note, 'form', _OOBJ_DTYPE_CHECK);
		if ($note != '') {
			set_var ('reporter_id', $uid, 'form');
			$note_id = $bugsnotes->AddRecord ($bug_id);
			BugTracking_AddHistory ($bug_id, $uid, '', $note_id, '', _OPN_HISTORY_BUGNOTE_ADDED);
		}
		$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_CLOSED);
		BugTracking_AddHistory ($bug_id, $uid, 'status', $bug['status'], _OPN_BUG_STATUS_CLOSED, _OPN_HISTORY_NORMAL_TYPE);
		$bugs->ModifyDate ($bug_id);
		BugTracking_email_close ($bug_id);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_Assign_To () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$handler_id = 0;
	get_var ('handler_id', $handler_id, 'form', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$uid = $opnConfig['permission']->Userinfo ('uid');
		$bug = $bugs->RetrieveSingle ($bug_id);
		if ($handler_id == -1) {
			$handler_id = $uid;
		} elseif ($handler_id == 0) {
			$handler_id = $bug['reporter_id'];
		} elseif ($handler_id == 1) {
			$handler_id = 0;
		}
		$bugs->ModifyHandler ($bug_id, $handler_id);
		BugTracking_AddHistory ($bug_id, $uid, 'handler_id', $bug['handler_id'], $handler_id, _OPN_HISTORY_NORMAL_TYPE);
		if ($bug['status']<_OPN_BUG_STATUS_ASSIGNED) {
			$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_ASSIGNED);
			BugTracking_AddHistory ($bug_id, $uid, 'status', $bug['status'], _OPN_BUG_STATUS_ASSIGNED, _OPN_HISTORY_NORMAL_TYPE);
		}
		$bugs->ModifyDate ($bug_id);
		BugTracking_email_assign ($bug_id);
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_AddLabel (&$form, $name, $title, $value) {

	$form->SetSameCol ();
	$form->AddLabel ($name, $title);
	$form->AddHidden ('old_' . $name, $value);
	$form->SetEndCol ();

}

function BugTracking_BuildOptions (&$options, $array, $first = '') {

	$options = array ();
	if ($first != '') {
		$options[0] = $first;
	}
	foreach ($array as $key => $value) {
		$options[$key] = $value;
	}

}

function BugTracking_DisplayInput ($title, $new = true, $bug_id = 0, $sel_project = 0) {

	global $opnConfig, $opnTables, $bugs, $bugusers;

	global $project, $category, $version, $bugvalues;

	$uid = $opnConfig['permission']->Userinfo ('uid');
	if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_ADMIN), true) ) {
		if (!$new) {
			$bug = $bugs->RetrieveSingle ($bug_id);
			$project = $bug['project_id'];
			$boxtxt = '';
		} else {
			$bug['category'] = 1;
			$bug['version'] = 1;
			$bug['project_id'] = 0;
			$bug['reporter_id'] = 0;
			$bug['handler_id'] = 0;
			$bug['duplicate_id'] = 0;
			$bug['priority'] = _OPN_BUG_PRIORITY_NORMAL;
			$bug['severity'] = _OPN_BUG_SEVERITY_FEATURE;
			$bug['reproducibility'] = _OPN_BUG_REPRODUCIBILITY_ALWAYS;
			$bug['status'] = _OPN_BUG_STATUS_NEW;
			$bug['resolution'] = _OPN_BUG_RESOLUTION_OPEN;
			$bug['projection'] = _OPN_BUG_PROJECTION_NONE;
			$bug['eta'] = _OPN_BUG_ETA_NONE;
			$bug['view_state'] = _OPN_BUG_STATE_PUBLIC;
			$bug['summary'] = '';
			$bug['description'] = '';
			$bug['steps_to_reproduce'] = '';
			$bug['additional_information'] = '';
			$project = $sel_project;
			$boxtxt = mainheaderbug_tracking (1, 'submit_bug', $sel_project);
		}
		$form = & new opn_BugFormularClass ('default');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_310_', 'bug_tracking');
		$form->UseEditor (false);
		$form->UseWysiwyg (false);
		$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
		$form->AddTable ();
		$form->AddDataRow (array ('<span class="normaltextbold">' . $title . '</span>') );
		$form->AddOpenRow ();
		$form->AddTable ('listalternator');
		$form->AddCols (array ('30%', '70%') );
		$form->AddOpenRow ();
		if (!$new) {
			$form->SetSameCol ();
			$form->AddText (_BUG_ID);
			$form->AddHidden ('bug_id', $bug_id);
			$form->SetEndCol ();
			$form->AddText ($bug_id);
			$form->AddChangeRow ();
		}
		$category->SetProject ($project);
		$cats = $category->GetArray ();
		$options = array ();
		foreach ($cats as $value) {
			$options[$value['category_id']] = $value['category'];
		}
		BugTracking_AddLabel ($form, 'category', _BUG_CATEGORY, $bug['category']);
		$form->AddSelect ('category', $options, $bug['category']);
		$form->AddChangeRow ();
		$version->SetProject ($project);
		$version->SetDescend ();
		$vers = $version->GetArray ();
		$options = array ();
		if (!$new) {
			$options[0] = '&nbsp;';
		}
		foreach ($vers as $value) {
			$options[$value['version_id']] = $value['version'];
		}
		BugTracking_AddLabel ($form, 'version', _BUG_VERSION, $bug['version']);
		$form->AddSelect ('version', $options, $bug['version']);
		$form->AddChangeRow ();
		BugTracking_AddLabel ($form, 'severity', _BUG_SEVERITY, $bug['severity']);
		BugTracking_BuildOptions ($options, $bugvalues['severity']);
		$form->AddSelect ('severity', $options, $bug['severity']);
		$form->AddChangeRow ();
		BugTracking_AddLabel ($form, 'reproducibility', _BUG_REPRO, $bug['reproducibility']);
		BugTracking_BuildOptions ($options, $bugvalues['reproducibility']);
		$form->AddSelect ('reproducibility', $options, $bug['reproducibility']);
		$form->AddChangeRow ();
		BugTracking_AddLabel ($form, 'priority', _BUG_PRIORITY, $bug['priority']);
		BugTracking_BuildOptions ($options, $bugvalues['priority']);
		$form->AddSelect ('priority', $options, $bug['priority']);
		if (!$new) {
			$form->AddChangeRow ();
			$form->AddText (_BUG_DATE_SUBMITTED);
			$opnConfig['opndate']->sqlToopnData ($bug['date_submitted']);
			$time = '';
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
			$form->AddText ($time);
			$form->AddChangeRow ();
			$form->AddText (_BUG_DATE_UPDATED1);
			$opnConfig['opndate']->sqlToopnData ($bug['date_updated']);
			$time = '';
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
			$form->AddText ($time);
			$form->AddChangeRow ();
			$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us WHERE ((us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ') AND (u.uid <> ' . $opnConfig['opn_anonymous_id'] . ')) ORDER BY uname');
			$options = array ();
			while (! $result->EOF) {
				$options[$result->fields['uid']] = $result->fields['uname'];
				$result->MoveNext ();
			}
			BugTracking_AddLabel ($form, 'reporter_id', _BUG_REPORTER, $bug['reporter_id']);
			$form->AddSelect ('reporter_id', $options, $bug['reporter_id']);
			$result->Close ();
			$form->AddChangeRow ();
			$options = array ();
			$options[0] = '&nbsp;';
			$options = $options+ $bugusers;
			BugTracking_AddLabel ($form, 'handler_id', _BUG_HANDLER, $bug['handler_id']);
			$form->AddSelect ('handler_id', $options, $bug['handler_id']);
			$form->AddChangeRow ();
			BugTracking_AddLabel ($form, 'view_state', _BUG_DISPLAY_STATE, $bug['view_state']);
			BugTracking_BuildOptions ($options, $bugvalues['state']);
			$form->AddSelect ('view_state', $options, $bug['view_state']);
			$form->AddChangeRow ();
			BugTracking_AddLabel ($form, 'status', _BUG_STATUS, $bug['status']);
			BugTracking_BuildOptions ($options, $bugvalues['status']);
			$form->SetClass ($bugvalues['listaltstatuscss'][$bug['status']]);
			$form->AddSelect ('status', $options, $bug['status']);
			$form->SetClass ('');
			$form->AddChangeRow ();
			BugTracking_AddLabel ($form, 'resolution', _BUG_RESOLUTION, $bug['resolution']);
			BugTracking_BuildOptions ($options, $bugvalues['resolution']);
			$form->AddSelect ('resolution', $options, $bug['resolution']);
			$version->SetProject ($sel_project);
			$version->SetDescend ();
			$ver = $version->GetArray ();
			$options = array ();
			$options[0] = '&nbsp;';
			foreach ($ver as $value) {
				$options[$value['version_id']] = $value['version'];
			}
			$form->AddChangeRow ();
			BugTracking_AddLabel ($form, 'fixed_in_version', _BUG_SOLVED_IN_VERSION, $bug['fixed_in_version']);
			$form->AddSelect ('fixed_in_version', $options, $bug['fixed_in_version']);
			$form->AddChangeRow ();
			BugTracking_AddLabel ($form, 'duplicate_id', _BUG_DUPLICATE_ID, $bug['duplicate_id']);
			$form->AddTextfield ('duplicate_id', 10, 10, $bug['duplicate_id']);
			$form->AddChangeRow ();
			BugTracking_AddLabel ($form, 'projection', _BUG_PROJECTION, $bug['projection']);
			BugTracking_BuildOptions ($options, $bugvalues['projection']);
			$form->AddSelect ('projection', $options, $bug['projection']);
			$form->AddChangeRow ();
			BugTracking_AddLabel ($form, 'eta', _BUG_ETA, $bug['eta']);
			BugTracking_BuildOptions ($options, $bugvalues['eta']);
			$form->AddSelect ('eta', $options, $bug['eta']);
		}
		$form->AddChangeRow ();
		BugTracking_AddLabel ($form, 'summary', _BUG_SUMMARY, urlencode ($bug['summary']) );
		$form->AddTextfield ('summary', 80, 128, $bug['summary']);
		$form->AddChangeRow ();
		BugTracking_AddLabel ($form, 'description', _BUG_DESCRIPTION, urlencode ($bug['description']) );
		$form->AddTextarea ('description', 0, 0, '', $bug['description']);
		$form->AddChangeRow ();
		BugTracking_AddLabel ($form, 'steps_to_reproduce', _BUG_STEPS_TO_REPRO, urlencode ($bug['steps_to_reproduce']) );
		$form->AddTextarea ('steps_to_reproduce', 0, 0, '', $bug['steps_to_reproduce']);
		$form->AddChangeRow ();
		BugTracking_AddLabel ($form, 'additional_information', _BUG_ADDITIONAL_INFO, urlencode ($bug['additional_information']) );
		$form->AddTextarea ('additional_information', 0, 0, '', $bug['additional_information']);
		if ($new) {
			$form->AddChangeRow ();
			$form->AddText (_BUG_DISPLAY_STATE);
			$form->SetSameCol ();
			$form->AddRadio ('view_state', _OPN_BUG_STATE_PUBLIC, true);
			$form->AddLabel ('view_state', '&nbsp;' . _BUG_STATE_PUBLIC, 1);
			$form->AddText ('&nbsp;');
			$form->AddRadio ('view_state', _OPN_BUG_STATE_PRIVATE);
			$form->AddLabel ('view_state', '&nbsp;' . _BUG_STATE_PRIVATE, 1);
			$form->SetEndCol ();
			$form->AddChangeRow ();
			$form->AddText (_BUG_STAY_IN_INPUT);
			$form->SetSameCol ();
			$form->AddCheckbox ('stay_input', 1);
			$form->AddLabel ('stay_input', _BUG_STAY_IN_INPUT_CHECK, 1);
			$form->SetEndCol ();
		}

		/*		$form->AddLabel('note',_BUG_BUGNOTES);
		$form->AddTextarea('note');*/

		$form->AddChangeRow ();
		$form->SetSameCol ();
		if ($new) {
			$form->AddHidden ('reporter_id', $uid);
		}
		$form->AddHidden ('sel_project', $sel_project);
		$form->AddHidden ('project_id', $project);
		if ($new) {
			$form->AddHidden ('op', 'do_add_bug');
		} else {
			$form->AddHidden ('op', 'do_modify_bug');
		}
		$form->SetEndCol ();
		if (!$new) {
			$form->AddSubmit ('submit', _BUG_EDIT_BUG_DO);
		} else {
			$form->AddSubmit ('submit', _BUG_ADD_BUG_DO);
		}
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_320_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
	}

}

function BugTracking_EditBug () {

	global $opnConfig, $bugs;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		BugTracking_DisplayInput (_BUG_EDIT_BUG_TITLE,
											false,
											$bug_id,
											$sel_project);
	} else {
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $bug_id,
								'sel_project' => $sel_project),
								false) );
	}

}

function BugTracking_CheckValues ($name, $bug_id, &$doupdate, $int = true) {

	global $opnConfig;

	$uid = $opnConfig['permission']->Userinfo ('uid');
	if ($int) {
		$oldvalue = 0;
		get_var ('old_' . $name, $oldvalue, 'form', _OOBJ_DTYPE_INT);
		$newvalue = 0;
		get_var ($name, $newvalue, 'form', _OOBJ_DTYPE_INT);
	} else {
		$oldvalue = '';
		get_var ('old_' . $name, $oldvalue, 'form', _OOBJ_DTYPE_CHECK);
		$newvalue = '';
		get_var ($name, $newvalue, 'form', _OOBJ_DTYPE_CHECK);
		$oldvalue = urldecode ($oldvalue);
		$newvalue = urldecode ($newvalue);
	}
	if ($oldvalue != $newvalue) {
		switch ($name) {
			case 'description':
				BugTracking_AddHistory ($bug_id, $uid, '', '', '', _OPN_HISTORY_DESCRIPTION_UPDATED);
				break;
			case 'steps_to_reproduce':
				BugTracking_AddHistory ($bug_id, $uid, '', '', '', _OPN_HISTORY_STEP_TO_REPRODUCE_UPDATED);
				break;
			case 'additional_information':
				BugTracking_AddHistory ($bug_id, $uid, '', '', '', _OPN_HISTORY_ADDITIONAL_INFO_UPDATED);
				break;
			default:
				BugTracking_AddHistory ($bug_id, $uid, $name, $oldvalue, $newvalue, _OPN_HISTORY_NORMAL_TYPE);
				break;
		}
		$doupdate = true;
	}

}

function BugTracking_ModifyBug () {

	global $opnConfig, $bugs, $bugvalues;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$doupdate = false;
		BugTracking_CheckValues ('category', $bug_id, $doupdate);
		BugTracking_CheckValues ('version', $bug_id, $doupdate);
		BugTracking_CheckValues ('severity', $bug_id, $doupdate);
		BugTracking_CheckValues ('reproducibility', $bug_id, $doupdate);
		BugTracking_CheckValues ('priority', $bug_id, $doupdate);
		BugTracking_CheckValues ('reporter_id', $bug_id, $doupdate);
		BugTracking_CheckValues ('handler_id', $bug_id, $doupdate);
		BugTracking_CheckValues ('view_state', $bug_id, $doupdate);
		BugTracking_CheckValues ('status', $bug_id, $doupdate);
		BugTracking_CheckValues ('resolution', $bug_id, $doupdate);
		BugTracking_CheckValues ('duplicate_id', $bug_id, $doupdate);
		BugTracking_CheckValues ('projection', $bug_id, $doupdate);
		BugTracking_CheckValues ('eta', $bug_id, $doupdate);
		BugTracking_CheckValues ('summary', $bug_id, $doupdate, false);
		BugTracking_CheckValues ('description', $bug_id, $doupdate, false);
		BugTracking_CheckValues ('steps_to_reproduce', $bug_id, $doupdate, false);
		BugTracking_CheckValues ('additional_information', $bug_id, $doupdate, false);
		if ($doupdate) {
			$t_old_data = $bugs->RetrieveSingle ($bug_id);
			$bugs->ModifyRecord ();
			$t_new_data = $bugs->RetrieveSingle ($bug_id);
			// bug assigned
			if ($t_old_data['handler_id'] != $t_new_data['handler_id']) {
				BugTracking_email_assign ($bug_id);
			} elseif ($t_old_data['status'] != $t_new_data['status']) {
				// status changed
				$t_status = $bugvalues['statusemail'][$t_new_data['status']];
				$t_title = $bugvalues['statusemailtitle'][$t_new_data['status']];
				BugTracking_email_generic ($bug_id, $t_status, $t_title, 'status');
			} else {
				// @@@ handle priority change if it requires special handling
				// generic update notification
				BugTracking_email_bug_updated ($bug_id);
			}
		}
	}
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $bug_id,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_SubmitBug () {

	global $opnConfig;

	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	if ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) {
		if (!$sel_project) {
			BugTracking_SelectProject ('submit_bug');
		} else {
			BugTracking_DisplayInput (_BUG_EDIT_BUG_TITLE, true, 0, $sel_project);
		}
	} else {
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php', false) );
	}

}

function BugTracking_AddBug () {

	global $opnConfig, $bugs;

	$opnConfig['permission']->HasRights ('modules/bug_tracking', array (_PERM_WRITE, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN) );
	$bug_id = $bugs->AddRecord ();
	$uid = $opnConfig['permission']->Userinfo ('uid');
	BugTracking_AddHistory ($bug_id, $uid, '', '', '', _OPN_HISTORY_NEW_BUG);
	BugTracking_email_new_bug ($bug_id);
	$stay_input = 0;
	get_var ('stay_input', $stay_input, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	if ($stay_input) {
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'submit_bug',
								'sel_project' => $sel_project),
								false) );
	} else {
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php?sel_project=' . $sel_project, false) );
	}

}

function BugTracking_BugChange () {

	global $opnConfig, $bugvalues;

	global $project, $bugusers, $bugs, $version;
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
		$bug_change = 0;
		get_var ('bug_change', $bug_change,'form',_OOBJ_DTYPE_INT);
		$cbugs = array ();
		get_var ('work_bug', $cbugs,'form',_OOBJ_DTYPE_CHECK);
		if (!count ($cbugs) ) {
			BugTracking_GoToIndex ();
		} else {
			$offset = 0;
			get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
			$sel_project = 0;
			get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
			$sortby = 'desc_date_updated';
			get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
			$sel_reporter = 0;
			get_var ('sel_reporter', $sel_reporter, 'both', _OOBJ_DTYPE_INT);
			$sel_handler = 0;
			get_var ('sel_handler', $sel_handler, 'both', _OOBJ_DTYPE_INT);
			$sel_category = 0;
			get_var ('sel_category', $sel_category, 'both', _OOBJ_DTYPE_INT);
			$sel_severity = 0;
			get_var ('sel_severity', $sel_severity, 'both', _OOBJ_DTYPE_INT);
			$sel_status = 0;
			get_var ('sel_status', $sel_status, 'both', _OOBJ_DTYPE_INT);
			$block_resolved = 0;
			get_var ('block_resolved', $block_resolved, 'both', _OOBJ_DTYPE_INT);
			$block_resolved_hidden = 0;
			get_var ('block_resolved_hidden', $block_resolved_hidden, 'both', _OOBJ_DTYPE_INT);
			$block_closed = 0;
			get_var ('block_closed', $block_closed, 'both', _OOBJ_DTYPE_INT);
			$block_closed_hidden = 0;
			get_var ('block_closed_hidden', $block_closed_hidden, 'both', _OOBJ_DTYPE_INT);
			$block_feature = 0;
			get_var ('block_feature', $block_feature, 'both', _OOBJ_DTYPE_INT);
			$block_feature_hidden = 0;
			get_var ('block_feature_hidden', $block_feature_hidden, 'both', _OOBJ_DTYPE_INT);
			$bugs_perpage = 0;
			get_var ('bugs_perpage', $bugs_perpage, 'both', _OOBJ_DTYPE_INT);
			$sel_query = '';
			get_var ('sel_query', $sel_query, 'both');
			$form = & new opn_BugFormularClass ('listalternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_330_', 'bug_tracking');
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
			$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
			$form->AddTable ();
			$form->AddCols (array ('30%', '70%') );
			$form->AddOpenRow ();
			switch ($bug_change) {
				case 0:
					$title = _BUG_DO_MOVE;
					$projects = $project->GetArray ();
					$options = array ();
					foreach ($projects as $value) {
						$options[$value['project_id']] = $value['project_name'];
					}
					$form->AddLabel ('project_id', _BUG_MOVE_TITLE);
					$form->AddSelect ('project_id', $options);
					$op = 'do_move_bugs';
					break;
				case 1:
					$title = _BUG_DO_ASSIGN;
					$options = array ();
					$options = $options+ $bugusers;
					$form->AddLabel ('handler_id', _BUG_ASSIGN_TITLE);
					$form->AddSelect ('handler_id', $options);
					$op = 'do_assign_bugs';
					break;
				case 2:
					$title = _BUG_DO_CLOSE;
					$canresolve = true;
					foreach ($cbugs as $value) {
						if (!BugTracking_relationship_can_resolve_bug ($value) ) {
							$canresolve = false;
						}
					}
					if (!$canresolve) {
						$form->SetColspan ('2');
						$form->AddText (_BUG_RELATIONSHIP_WARNING_BLOCKING_BUGS_NOT_RESOLVED_2);
						$form->AddChangeRow ();
						$form->SetColspan ('');
					}
					$form->AddText ('&nbsp;');
					$form->AddText (_BUG_CLOSE_TITLE);
					$op = 'do_close_bugs';
					break;
				case 3:
					$title = _BUG_DO_DELETE;
					$form->AddText ('&nbsp;');
					$form->AddText (_BUG_DELETE_TITLE);
					$op = 'do_delete_bugs';
					break;
				case 4:
					$title = _BUG_DO_RESOLVE;
					$canresolve = true;
					foreach ($cbugs as $value) {
						if (!BugTracking_relationship_can_resolve_bug ($value) ) {
							$canresolve = false;
						}
					}
					if (!$canresolve) {
						$form->SetColspan ('2');
						$form->AddText (_BUG_RELATIONSHIP_WARNING_BLOCKING_BUGS_NOT_RESOLVED_2);
						$form->AddChangeRow ();
						$form->SetColspan ('');
					}
					$form->AddLabel ('resolution', _BUG_RESOLVE_TITLE);
					$options = array ();
					foreach ($bugvalues['resolution'] as $key => $value) {
						$options[$key] = $value;
					}
					$form->AddSelect ('resolution', $options, _OPN_BUG_RESOLUTION_FIXED);
					$op = 'do_resolve_bugs';
					if ($sel_project) {
						$version->SetProject ($sel_project);
						$version->SetDescend ();
						$ver = $version->GetArray ();
						$options = array ();
						foreach ($ver as $value) {
							$options[$value['version_id']] = $value['version'];
						}
						$form->AddChangeRow ();
						$form->AddLabel ('fixed_in_version', _BUG_SOLVED_IN_VERSION);
						$form->AddSelect ('fixed_in_version', $options);
					}
					break;
				case 5:
					$title = _BUG_DO_PRIORITY;
					$form->AddLabel ('priority', _BUG_PRIORITY_TITLE);
					$options = array ();
					foreach ($bugvalues['priority'] as $key => $value) {
						$options[$key] = $value;
					}
					$form->AddSelect ('priority', $options, _OPN_BUG_PRIORITY_LOW);
					$op = 'do_change_prio_bugs';
					break;
				case 6:
					$title = _BUG_DO_STATUS;
					$form->AddLabel ('status', _BUG_STATUS_TITLE);
					$options = array ();
					foreach ($bugvalues['status'] as $key => $value) {
						$options[$key] = $value;
					}
					$form->AddSelect ('status', $options, _OPN_BUG_STATUS_FEEDBACK);
					$op = 'do_change_status_bugs';
					break;
				case 7:
					$title = _BUG_DO_VIEW;
					$form->AddLabel ('view', _BUG_VIEW_TITLE);
					$options = array ();
					$options[1] = _BUG_STATE_PUBLIC;
					$options[2] = _BUG_STATE_PRIVATE;
					$form->AddSelect ('view', $options, 1);
					$op = 'do_change_view';
				}
				$form->AddChangeRow ();
				$form->SetSameCol ();
				$form->AddHidden ('op', $op);
				$form->AddHidden ('offset', $offset);
				$form->AddHidden ('sel_project', $sel_project);
				$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, $sortby);
				$form->AddHidden ('sel_reporter', $sel_reporter);
				$form->AddHidden ('sel_handler', $sel_handler);
				$form->AddHidden ('sel_category', $sel_category);
				$form->AddHidden ('sel_severity', $sel_severity);
				$form->AddHidden ('sel_status', $sel_status);
				$form->AddHidden ('block_resolved', $block_resolved);
				$form->AddHidden ('block_resolved_hidden', $block_resolved_hidden);
				$form->AddHidden ('block_closed', $block_closed);
				$form->AddHidden ('block_closeed_hidden', $block_closed_hidden);
				$form->AddHidden ('block_feature', $block_feature);
				$form->AddHidden ('block_feature_hidden', $block_feature_hidden);
				$form->AddHidden ('bugs_perpage', $bugs_perpage);
				$form->AddHidden ('sel_query', urlencode ($sel_query) );
				$max = count ($cbugs);
				for ($i = 0; $i< $max; $i++) {
					$form->AddHidden ('work_bug[]', $cbugs[$i]);
				}
				$form->SetEndCol ();
				$form->AddSubmit ('submit', $title);
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$boxtxt = '';
				$form->GetFormular ($boxtxt);
				$boxtxt .= '<br /><br />';
				$table = & new opn_TableClass ('custom');
				$table->SetTableClass ('alternatortable');
				$table->SetHeaderClass ('alternatorhead');
				$table->SetFooterClass ('alternatorfoot');
				$table->AddOpenHeadRow ();
				$table->AddHeaderCol (_BUG_SELECTED_BUGS, '', '2');
				$table->AddCloseRow ();
				foreach ($cbugs as $value) {
					$bug = $bugs->RetrieveSingle ($value);
					$table->SetColClass ($bugvalues['altstatuscss'][$bug['status']]);
					$table->SetRowClass ($bugvalues['altstatuscss'][$bug['status']]);
					$hlp = '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
										'op' => 'view_bug',
										'bug_id' => $bug['bug_id'],
										'sel_project' => $sel_project) ) . '">' . $bug['bug_id'] . '</a>';
					$table->AddDataRow (array ($hlp, $bug['summary']) );
				}
				unset ($bug);
				$table->GetTable ($boxtxt);
				$_display_dat = array ();
				$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_340_';
				$_display_dat['module'] = 'modules/bug_tracking';
				$opnConfig['opnOutput']->SetDisplay ($_display_dat);
				unset ($_display_dat);
				$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
			}
		} else {
			BugTracking_GoToIndex ();
		}
	}

	function BugTracking_GoToIndex () {

		global $opnConfig;

		$offset = 0;
		get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
		$sel_project = 0;
		get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
		$sortby = 'desc_date_updated';
		get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
		$sel_reporter = 0;
		get_var ('sel_reporter', $sel_reporter, 'both', _OOBJ_DTYPE_INT);
		$sel_handler = 0;
		get_var ('sel_handler', $sel_handler, 'both', _OOBJ_DTYPE_INT);
		$sel_category = 0;
		get_var ('sel_category', $sel_category, 'both', _OOBJ_DTYPE_INT);
		$sel_severity = 0;
		get_var ('sel_severity', $sel_severity, 'both', _OOBJ_DTYPE_INT);
		$sel_status = 0;
		get_var ('sel_status', $sel_status, 'both', _OOBJ_DTYPE_INT);
		$block_resolved = 0;
		get_var ('block_resolved', $block_resolved, 'both', _OOBJ_DTYPE_INT);
		$block_resolved_hidden = 0;
		get_var ('block_resolved_hidden', $block_resolved_hidden, 'both', _OOBJ_DTYPE_INT);
		$block_closed = 0;
		get_var ('block_closed', $block_closed, 'both', _OOBJ_DTYPE_INT);
		$block_closed_hidden = 0;
		get_var ('block_closed_hidden', $block_closed_hidden, 'both', _OOBJ_DTYPE_INT);
		$block_feature = 0;
		get_var ('block_feature', $block_feature, 'both', _OOBJ_DTYPE_INT);
		$block_feature_hidden = 0;
		get_var ('block_feature_hidden', $block_feature_hidden, 'both', _OOBJ_DTYPE_INT);
		$bugs_perpage = 0;
		get_var ('bugs_perpage', $bugs_perpage, 'both', _OOBJ_DTYPE_INT);
		$sel_query = '';
		get_var ('sel_query', $sel_query, 'both');
		$sel_query = urldecode ($sel_query);
		$progurlp = array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
				'sel_project' => $sel_project,
				'sel_reporter' => $sel_reporter,
				'sel_handler' => $sel_handler,
				'sel_category' => $sel_category,
				'sel_severity' => $sel_severity,
				'sel_status' => $sel_status,
				'block_resolved' => $block_resolved,
				'block_resolved_hidden' => $block_resolved_hidden,
				'block_closed' => $block_closed,
				'block_closed_hidden' => $block_closed_hidden,
				'bugs_perpage' => $bugs_perpage,
				'block_feature' => $block_feature,
				'block_feature_hidden' => $block_feature_hidden,
				'sel_query' => urlencode ($sel_query),
				'offset' => $offset,
				'sortby' => $sortby);
		$opnConfig['opnOutput']->Redirect (encodeurl ($progurlp, false) );

	}

	function BugTracking_DoMoveBugs () {

		global $opnConfig, $bugs;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug',$cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				$bug = $bugs->RetrieveSingle ($bug_id);
				$bugs->ModifyProject ($bug_id, $project_id);
				$bugs->ModifyDate ($bug_id);
				BugTracking_AddHistory ($bug_id, $uid, 'project_id', $bug['project_id'], $project_id, _OPN_HISTORY_NORMAL_TYPE);
				BugTracking_email_bug_updated ($bug_id);
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_DoMoveBug () {

		global $opnConfig, $bugs;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$bug_id = 0;
			get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_CHECK);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$sel_project = 0;
			get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$bug = $bugs->RetrieveSingle ($bug_id);
			$bugs->ModifyProject ($bug_id, $project_id);
			$bugs->ModifyDate ($bug_id);
			BugTracking_AddHistory ($bug_id, $uid, 'project_id', $bug['project_id'], $project_id, _OPN_HISTORY_NORMAL_TYPE);
			BugTracking_email_bug_updated ($bug_id);
		}
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $bug_id,
								'sel_project' => $sel_project),
								false) );

	}

	function BugTracking_DoAssignBugs () {

		global $opnConfig, $bugs;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug', $cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$handler_id = 0;
			get_var ('handler_id', $handler_id, 'form', _OOBJ_DTYPE_INT);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				$bug = $bugs->RetrieveSingle ($bug_id);
				$bugs->ModifyHandler ($bug_id, $handler_id);
				if ($bug['status']<_OPN_BUG_STATUS_ASSIGNED) {
					$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_ASSIGNED);
				}
				$bugs->ModifyDate ($bug_id);
				BugTracking_AddHistory ($bug_id, $uid, 'handler_id', $bug['handler_id'], $handler_id, _OPN_HISTORY_NORMAL_TYPE);
				if ($bug['status']<_OPN_BUG_STATUS_ASSIGNED) {
					BugTracking_AddHistory ($bug_id, $uid, 'status', $bug['status'], _OPN_BUG_STATUS_ASSIGNED, _OPN_HISTORY_NORMAL_TYPE);
				}
				BugTracking_email_assign ($bug_id);
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_DoCloseBugs () {

		global $opnConfig, $bugs;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug', $cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				$bug = $bugs->RetrieveSingle ($bug_id);
				$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_CLOSED);
				$bugs->ModifyDate ($bug_id);
				BugTracking_AddHistory ($bug_id, $uid, 'status', $bug['status'], _OPN_BUG_STATUS_CLOSED, _OPN_HISTORY_NORMAL_TYPE);
				BugTracking_email_close ($bug_id);
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_DoDeleteBugs () {

		global $opnConfig, $bugs;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug', $cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				BugTracking_AddHistory ($bug_id, $uid, '', '', '', _OPN_HISTORY_BUG_DELETED);
				BugTracking_email_bug_deleted ($bug_id);
				$bugs->DeleteRecord ($bug_id);
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_DoResolveBugs () {

		global $opnConfig, $bugs;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug', $cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$resolution = 0;
			get_var ('resolution', $resolution, 'form', _OOBJ_DTYPE_INT);
			$fixed_in_version = 0;
			get_var ('fixed_in_version', $fixed_in_version, 'form', _OOBJ_DTYPE_INT);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				$bug = $bugs->RetrieveSingle ($bug_id);
				$bugs->ModifyStatus ($bug_id, _OPN_BUG_STATUS_RESOLVED);
				BugTracking_AddHistory ($bug_id, $uid, 'status', $bug['status'], _OPN_BUG_STATUS_RESOLVED, _OPN_HISTORY_NORMAL_TYPE);
				if ($fixed_in_version) {
					$bugs->ModifyFixed ($bug_id, $fixed_in_version);
					BugTracking_AddHistory ($bug_id, $uid, 'fixed_in_version', $bug['fixed_in_version'], $fixed_in_version, _OPN_HISTORY_NORMAL_TYPE);
				}
				$bugs->ModifyResolution ($bug_id, $resolution);
				BugTracking_AddHistory ($bug_id, $uid, 'resolution', $bug['resolution'], $resolution, _OPN_HISTORY_NORMAL_TYPE);
				if (!$bug['handler_id']) {
					$bugs->ModifyHandler ($bug_id, $uid);
					BugTracking_AddHistory ($bug_id, $uid, 'handler_id', $bug['handler_id'], $uid, _OPN_HISTORY_NORMAL_TYPE);
				}
				$bugs->ModifyDate ($bug_id);
				BugTracking_email_resolved ($bug_id);
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_DoChangePrioBugs () {

		global $opnConfig, $bugs;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug', $cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$priority = 0;
			get_var ('priority', $priority, 'form', _OOBJ_DTYPE_INT);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				$bug = $bugs->RetrieveSingle ($bug_id);
				$bugs->ModifyPriority ($bug_id, $priority);
				$bugs->ModifyDate ($bug_id);
				BugTracking_AddHistory ($bug_id, $uid, 'priority', $bug['priority'], $priority, _OPN_HISTORY_NORMAL_TYPE);
				BugTracking_email_bug_updated ($bug_id);
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_DoChangeStatusBugs () {

		global $opnConfig, $bugs, $bugvalues;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug', $cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$status = 0;
			get_var ('status', $status, 'form', _OOBJ_DTYPE_INT);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				$bug = $bugs->RetrieveSingle ($bug_id);
				$bugs->ModifyStatus ($bug_id, $status);
				$bugs->ModifyDate ($bug_id);
				$t_new_data = $bugs->RetrieveSingle ($bug_id);
				BugTracking_AddHistory ($bug_id, $uid, 'status', $bug['status'], $status, _OPN_HISTORY_NORMAL_TYPE);
				// status changed
				$t_status = $bugvalues['statusemail'][$t_new_data['status']];
				$t_title = $bugvalues['statusemailtitle'][$t_new_data['status']];
				BugTracking_email_generic ($bug_id, $t_status, $t_title, 'status');
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_DoChangeViewBugs () {

		global $opnConfig, $bugs, $bugvalues;
		if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_TESTER, _BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin () ) ) {
			$cbugs = array ();
			get_var ('work_bug', $cbugs, 'form', _OOBJ_DTYPE_CHECK);
			$view = 0;
			get_var ('view', $view, 'form', _OOBJ_DTYPE_INT);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$max = count ($cbugs);
			for ($i = 0; $i< $max; $i++) {
				$bug_id = $cbugs[$i];
				$bug = $bugs->RetrieveSingle ($bug_id);
				$bugs->ModifyView ($bug_id, $view);
				$bugs->ModifyDate ($bug_id);
				BugTracking_AddHistory ($bug_id, $uid, 'view_state', $bug['view_state'], $view, _OPN_HISTORY_NORMAL_TYPE);
				BugTracking_email_bug_updated ($bug_id);
			}
		}
		BugTracking_GoToIndex ();

	}

	function BugTracking_Reminder () {

		global $opnConfig, $opnTables, $bugs;

		$bug_id = 0;
		get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
		$sel_project = 0;
		get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
		$bug = $bugs->RetrieveSingle ($bug_id);
		if (count ($bug) ) {
			if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
				$form = & new opn_BugFormularClass ('default');
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_350_', 'bug_tracking');
				$form->UseEditor (false);
				$form->UseWysiwyg (false);
				$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
				$form->AddTable ();
				$form->AddDataRow (array ('<span class="normaltextbold">' . _BUG_DOREOPEN_BUG . '</span>') );
				$form->AddOpenRow ();
				$form->AddTable ('listalternator');
				$form->AddOpenRow ();
				$result = &$opnConfig['database']->Execute ('SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' us WHERE ((us.uid=u.uid) AND (us.level1<>' . _PERM_USER_STATUS_DELETE . ') AND (u.uid <> ' . $opnConfig['opn_anonymous_id'] . ')) ORDER BY uname');
				$options = array ();
				while (! $result->EOF) {
					$options[$result->fields['uid']] = $result->fields['uname'];
					$result->MoveNext ();
				}
				$form->AddLabel ('send_to[]', _BUG_TO);
				$form->AddSelect ('send_to[]', $options, 0, '', 10, 1);
				$form->AddChangeRow ();
				$form->AddLabel ('body', _BUG_REMINDER);
				$form->AddTextarea ('body');
				$form->AddChangeRow ();
				$form->SetSameCol ();
				$form->AddHidden ('bug_id', $bug_id);
				$form->AddHidden ('sel_project', $sel_project);
				$form->AddHidden ('op', 'do_reminder');
				$form->SetEndCol ();
				$form->AddSubmit ('submit', _BUG_SEND);
				$form->AddTableClose ();
				$form->AddCloseRow ();
				$form->AddDataRow (array ('&nbsp;') );
				$form->AddOpenRow ();
				BugTracking_DisplayBug ($form, $bug, $sel_project);
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$boxtxt = '';
				$form->GetFormular ($boxtxt);
				$_display_dat = array ();
				$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_360_';
				$_display_dat['module'] = 'modules/bug_tracking';
				$opnConfig['opnOutput']->SetDisplay ($_display_dat);
				unset ($_display_dat);
				$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
			} else {
				$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
										'op' => 'view_bug',
										'bug_id' => $bug_id,
										'sel_project' => $sel_project),
										false) );
			}
		} else {
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_370_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$boxtxt = '';
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
		}

	}

	function BugTracking_Changelog () {

		global $opnConfig, $project, $category, $version, $bugs;

		$sel_project = 0;
		get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
		if (!$sel_project) {
			BugTracking_SelectProject ('changelog');
		} else {
			$pro = $project->RetrieveSingle ($sel_project);
			$boxtxt = mainheaderbug_tracking (1, 'changelog', $sel_project);
			$boxtxt .= '<br /><br /><strong>' . $pro['project_name'] . ' - ' . _BUG_CHANGELOG . '</strong><br /><br />' . _OPN_HTML_NL;
			$version->SetProject ($sel_project);
			$version->SetDescend ();
			$versions = $version->GetArray ();
			foreach ($versions as $value) {
				$bugs->ClearCache ();
				$bugs->SetProject ($sel_project);
				$bugs->SetFixedVersion ($value['version_id']);
				$bugs->SetDescend ();
				$bugs->SetStatus (_OPN_BUG_STATUS_RESOLVED);
				$all = $bugs->GetArray ();
				if (count ($all) ) {
					$release_title = trim ($pro['project_name']) . ' - ' . trim ($value['version']);
					$table = & new opn_TableClass ('alternator');
					$table->AddOpenRow ();
					$table->AddHeaderCol ($release_title, 'left', '4');
					$table->AddCloseRow ();
					$table->AddHeaderRow (array (_BUG_ID, _BUG_CATEGORY, _BUG_DESCRIPTION, _BUG_HANDLER) );
					foreach ($all as $val) {
						$link = '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
											'op' => 'view_bug',
											'bug_id' => $val['bug_id'],
											'sel_project' => $sel_project) ) . '">' . $val['bug_id'] . '</a>';
						$cat = $category->RetrieveSingle ($val['category']);
						$ui = $opnConfig['permission']->GetUser ($val['handler_id'], 'useruid', '');
						$name = $ui['uname'];
						$table->AddDataRow (array ($link, $cat['category'], $val['summary'], $name) );
					}
					$table->GetTable ($boxtxt);
				}
			}
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_380_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);
		}

	}

	function BugTracking_SelectProject ($op) {

		global $opnConfig, $project;

		$form = & new opn_BugFormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_390_', 'bug_tracking');
		$form->Init ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php');
		$form->AddTable ();
		$form->AddCols (array ('30%', '70%') );
		$form->AddOpenRow ();
		$form->AddLabel ('sel_project', _BUG_PROJECT);
		$projects = $project->GetArray ();
		$options = array ();
		foreach ($projects as $value) {
			$options[$value['project_id']] = $value['project_name'];
		}
		$form->AddSelect ('sel_project', $options);
		$form->AddChangeRow ();
		$form->AddHidden ('op', $op);
		$form->AddSubmit ('submit', _BUG_SEL_PROJECT);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$boxtxt = '';
		$form->GetFormular ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_400_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $boxtxt);

	}

	function BugTracking_relationship_get_complementary_type ($p_relationship_type) {
		switch ($p_relationship_type) {
		case _OPN_BUG_RELATION_RELATED:
			return _OPN_BUG_RELATION_RELATED;
		case _OPN_BUG_RELATION_DEPENDANT_ON:
			return _OPN_BUG_RELATION_DEPENDANT_OF;
		case _OPN_BUG_RELATION_DEPENDANT_OF:
			return _OPN_BUG_RELATION_DEPENDANT_ON;
		case _OPN_BUG_RELATION_DUPLICATE_OF:
			return _OPN_BUG_RELATION_HAS_DUPLICATE;
		case _OPN_BUG_RELATION_HAS_DUPLICATE:
			return _OPN_BUG_RELATION_DUPLICATE_OF;

	}
	return '';

}

function BugTracking_AddRelation () {

	global $opnConfig, $bugsrelation, $bugs;

	$source_bug = 0;
	get_var ('source_id', $source_bug, 'form', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'form', _OOBJ_DTYPE_INT);
	$relation = 0;
	get_var ('relation', $relation, 'form', _OOBJ_DTYPE_INT);
	$destination_id = 0;
	get_var ('destination_id', $destination_id, 'form', _OOBJ_DTYPE_INT);
	$uid = $opnConfig['permission']->UserInfo ('uid');
	$bugsrelation->AddRecord ();
	BugTracking_AddHistory ($source_bug, $uid, '', $relation, $destination_id, _OPN_HISTORY_BUG_RELEATION);
	$bugs->ModifyDate ($source_bug);
	BugTracking_AddHistory ($destination_id, $uid, '', BugTracking_relationship_get_complementary_type ($relation), $source_bug, _OPN_HISTORY_BUG_RELEATION);
	$bugs->ModifyDate ($destination_id);
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
							'op' => 'view_bug',
							'bug_id' => $source_bug,
							'sel_project' => $sel_project),
							false) );

}

function BugTracking_DeleteRelation () {

	global $opnConfig, $bugsrelation, $bugs;

	$relation_id = 0;
	get_var ('relation_id', $relation_id, 'both', _OOBJ_DTYPE_INT);
	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$isadmin = false;
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$isadmin = true;
	}
	if ($ok == 1) {
		if ($isadmin) {
			$rel = $bugsrelation->RetrieveSingle ($relation_id);
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$type = $rel['relation_type'];
			if ($rel['source_bug_id'] == $bug_id) {
				$stype = $type;
				$dtype = BugTracking_relationship_get_complementary_type ($type);
			} else {
				$dtype = $type;
				$stype = BugTracking_relationship_get_complementary_type ($type);
			}
			BugTracking_AddHistory ($rel['source_bug_id'], $uid, '', $stype, $rel['destination_bug_id'], _OPN_HISTORY_BUG_RELEATION_DELETE);
			$bugs->ModifyDate ($rel['source_bug_id']);
			BugTracking_AddHistory ($rel['destination_bug_id'], $uid, '', $dtype, $rel['source_bug_id'], _OPN_HISTORY_BUG_RELEATION_DELETE);
			$bugs->ModifyDate ($rel['destination_bug_id']);
			$bugsrelation->DeleteRecord ($relation_id);
		}
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $bug_id,
								'sel_project' => $sel_project),
								false) );
	} else {
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . _BUG_DELETERELATION . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
										'op' => 'delete_relation',
										'bug_id' => $bug_id,
										'sel_project' => $sel_project,
										'relation_id' => $relation_id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
															'op' => 'view_bug',
															'bug_id' => $bug_id,
															'sel_project' => $sel_project) ) . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_410_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $text);
	}

}

function BugTracking_bug_exists ($bug_id) {

	global $bugs;
	if ($bugs->GetCount ($bug_id) ) {
		return true;
	}
	return false;

}

function BugTracking_relationship_get_all_src ($p_src_bug_id) {

	global $opnConfig, $opnTables, $bugs;

	$query = 'SELECT br.relation_id AS relation_id, br.relation_type AS relation_type, br.source_bug_id AS source_bug_id' . ', br.destination_bug_id as destination_bug_id, b.project_id AS project_id FROM ' . $opnTables['bugs_relation'] . ' br ' . 'INNER JOIN ' . $opnTables['bugs'] . ' b ON br.destination_bug_id = b.bug_id ' . 'WHERE br.source_bug_id=' . $p_src_bug_id . ' ORDER BY br.relation_type, br.relation_id';
	$result = $opnConfig['database']->Execute ($query);
	$bug = $bugs->RetrieveSingle ($p_src_bug_id);
	$t_src_project_id = $bug['project_id'];
	$t_bug_relationship_data = array (new BugRelationshipData);
	$t_relationship_count = $result->RecordCount ();
	$i = 0;
	while (! $result->EOF) {
		$t_bug_relationship_data[$i] = & new BugRelationshipData;
		$t_bug_relationship_data[$i]->SetId ($result->fields['relation_id']);
		$t_bug_relationship_data[$i]->SetSrcBug ($result->fields['source_bug_id']);
		$t_bug_relationship_data[$i]->SetSrcProject ($t_src_project_id);
		$t_bug_relationship_data[$i]->SetDestBug ($result->fields['destination_bug_id']);
		$t_bug_relationship_data[$i]->SetDestProject ($result->fields['project_id']);
		$t_bug_relationship_data[$i]->SetType ($result->fields['relation_type']);
		$i++;
		$result->MoveNext ();
	}
	unset ($t_bug_relationship_data[$t_relationship_count]);
	return $t_bug_relationship_data;

}

function BugTracking_relationship_can_resolve_bug ($p_bug_id) {

	global $bugs;
	// retrieve all the relationships in which the bug is the source bug
	$t_relationship = BugTracking_relationship_get_all_src ($p_bug_id);
	$t_relationship_count = count ($t_relationship);
	if ($t_relationship_count == 0) {
		return true;
	}
	for ($i = 0; $i< $t_relationship_count; $i++) {
		// verify if each bug in relation BUG_DEPENDANT is already marked as resolved
		if ($t_relationship[$i]->type == _OPN_BUG_RELATION_DEPENDANT_ON) {
			$t_dest_bug_id = $t_relationship[$i]->dest_bug_id;
			$bug = $bugs->RetrieveSingle ($t_dest_bug_id);
			if ($bug['status']<_OPN_BUG_STATUS_RESOLVED) {
				// the bug is NOT marked as resolved/closed
				return false;
			}
		}
	}
	return true;

}

function BugTracking_DeleteFile () {

	global $opnConfig, $bugs, $bugsattachments;

	$bug_id = 0;
	get_var ('bug_id', $bug_id, 'both', _OOBJ_DTYPE_INT);
	$sel_project = 0;
	get_var ('sel_project', $sel_project, 'both', _OOBJ_DTYPE_INT);
	$attachment_id = 0;
	get_var ('attachment_id', $attachment_id, 'both', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
	$isadmin = false;
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ( ($opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) || (BugTracking_CheckAdmin ($bug['project_id']) ) ) {
		$isadmin = true;
	}
	if ($ok == 1) {
		if ($isadmin) {
			$uid = $opnConfig['permission']->Userinfo ('uid');
			$bugs->ModifyDate ($bug_id);
			$attach = $bugsattachments->RetrieveSingle ($attachment_id);
			BugTracking_AddHistory ($bug_id, $uid, '', $attach['filename'], '', _OPN_HISTORY_FILE_DELETED);
			BugTracking_email_bug_updated ($bug_id);
			$bugsattachments->DeleteRecord ($attachment_id);
		}
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $bug_id,
								'sel_project' => $sel_project),
								false,
								true,
								false,
								'#attachments') );
	} else {
		if ($isadmin) {
			$attach = $bugsattachments->RetrieveSingle ($attachment_id);
			$text = '<div class="bigtextbold" align="center">';
			$text .= '<span class="alerttextcolor">' . sprintf (_BUG_ATTACHMENT_DELETE, $attach['filename']) . '</span><br />';
			$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
											'op' => 'delete_attachment',
											'bug_id' => $bug_id,
											'sel_project' => $sel_project,
											'attachment_id' => $attachment_id,
											'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking',
																'op' => 'view_bug',
																'bug_id' => $bug_id,
																'sel_project' => $sel_project) ) . '">' . _NO . '</a><br /><br /></div>';
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_180_';
			$_display_dat['module'] = 'modules/bug_tracking';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_BUG_MAINTITLE, $text);
		} else {
			$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
									'op' => 'view_bug',
									'bug_id' => $bug_id,
									'sel_project' => $sel_project),
									false,
									true,
									false,
									'#attachments') );
		}
	}

}

?>