<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_BUG_FORMULAR_TABLE_INCLUDED') ) {
	define ('_OPN_CLASS_BUG_FORMULAR_TABLE_INCLUDED', 1);

	class opn_BugFormularClass extends opn_FormularClass {

		/**
		* opn_FormularClass::opn_FormularClass()
		*
		* Classconstructor
		*
		* @param string $profile
		* @return
		**/

		function opn_BugFormularClass ($profile = 'default') {

			global $opnConfig;

			$this->opn_TableClass ($profile, '0', '0', '', true);
			$this->_formular = '';
			$this->_isTable = 0;
			$this->_hlp = '';
			$this->_class = '';
			$this->_colspan = '';
			$this->_rowspan = '';
			$this->_valign = '';
			$this->_align = '';
			$this->_isdiv = false;
			$this->_isheader = false;
			$this->_onecol = 0;
			if (isset ($opnConfig['lasttabindex']) ) {
				$this->_tabindex = $opnConfig['lasttabindex'];
			} else {
				$this->_tabindex = 1;
			}

		}

		/**
		* opn_FormularClass::AddTable()
		*
		* @param string $border
		* @param string $cellspacing
		* @param string $cellpadding
		* @param string $class
		* @return
		**/

		function AddTable ($profile = '', $colspan = '', $openrow = false, $currentcol = 1, $border = '0', $cellspacing = '0', $cellpadding = '0', $class = '') {
			if ($this->_isdiv) {
				$this->_formular .= '</div>' . _OPN_HTML_NL;
				$this->_isdiv = false;
			}
			if ($this->_isTable) {
				if ($openrow) {
					$this->AddOpenRow ();
				}
				$this->_currentcol = $currentcol;
				$this->_autotd = true;
				if ($colspan != '') {
					$this->SetColspanTab ($colspan);
				}
			}
			$this->_addtd ();
			$this->SetColspanTab ('');
			if ($this->_isTable) {
				$this->_autotd = false;
				$this->SaveProfile ();
			}
			if ($profile != '') {
				switch ($profile) {
					case 'default':
						$this->SetDefaultProfile ();
						$this->SetClass ('');
						break;
					case 'alternator':
						$this->SetAlternatorProfile ();
						$this->SetClass ('');
						break;
					case 'listalternator':
						$this->SetListAlternatorProfile ();
						$this->SetClass ('');
						break;
					case 'bug':
						$this->_profile = 'custom';
						$this->SetTableClass ('alternatortable');
						$this->SetHeaderClass ('alternatorhead');
						$this->SetFooterClass ('alternatorfoot');
						break;
				}
			}
			$this->InitTable ($cellpadding, $cellspacing, $border, $class);
			$this->_isTable++;
			$this->_append = true;

		}

		function OpenHeaderRow () {

			$this->AddOpenHeadRow ();
			$this->SetIsHeader (true);

		}

		function CloseHeaderRow () {

			$this->SetIsHeader (false);
			$this->AddCloseRow ();

		}

	}
}

?>