<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_BUGS_INCLUDED') ) {
	define ('_OPN_BUGS_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsabstract.php');
	global $opnConfig;

	$opnConfig['permission']->InitPermissions ('modules/bug_tracking');

	class Bugs extends AbstractBugs {
		var $_project = 0;
		var $_category = 0;
		var $_severity = 0;
		var $_reporter = 0;
		var $_handler = 0;
		var $_orderby = '';
		var $_query = '';
		var $_fixed_version = 0;
		var $_desc = '';
		var $_selectstatus = array ();
		var $_selectseverity = array ();
		var $_selectreproducibility = array ();
		var $_selectpriority = array ();
		var $_selectresolution = array ();
		var $_selectprojection = array ();
		var $_selecteta = array ();
		var $_blockstatus = array ();
		var $_blockseverity = array ();

		function Bugs () {

			$this->_fieldname = 'bug_id';
			$this->_tablename = 'bugs';
			$this->_orderby = ' ORDER BY date_updated';

		}

		function SetProject ($project) {

			$this->_project = $project;

		}

		function SetFixedVersion ($version) {

			$this->_fixed_version = $version;

		}

		function SetDescend () {

			$this->_desc = ' DESC';

		}

		function SetOrderby ($orderby) {

			$this->_orderby = $orderby;

		}

		function ClearStatus () {

			$this->_selectstatus = array ();

		}

		function SetStatus ($status) {

			$this->_selectstatus[] = $status;

		}

		function ClearSeverity () {

			$this->_selectseverity = array ();

		}

		function SetSeveritys ($severity) {

			$this->_selectseverity[] = $severity;

		}

		function ClearReproducibility () {
			$this->_selectreproducibility = array ();
		}

		function SetReproducibility ($reproducibility) {
			$this->_selectreproducibility[] = $reproducibility;
		}

		function ClearPriority () {
			$this->_selectpriority = array ();
		}

		function SetPriority ($priority) {
			$this->_selectpriority[] = $priority;
		}

		function ClearResolution () {
			$this->_selectresolution = array ();
		}

		function SetResolution ($resolution) {
			$this->_selectresolution[] = $resolution;
		}

		function ClearProjection () {
			$this->_selectprojection = array ();
		}

		function SetProjection ($resolution) {
			$this->_selectprojection[] = $resolution;
		}

		function ClearEta () {
			$this->_selecteta = array ();
		}

		function Seteta ($eta) {
			$this->_selecteta[] = $eta;
		}

		function ClearBlockStatus () {

			$this->_blockstatus = array ();

		}

		function SetBlockStatus ($status) {

			$this->_blockstatus[] = $status;

		}

		function ClearBlockSeverity () {

			$this->_blockseverity = array ();

		}

		function SetBlockSeverity ($severity) {

			$this->_blockseverity[] = $severity;

		}

		function SetCategory ($cat) {

			$this->_category = $cat;

		}

		function SetSeverity ($severity) {

			$this->_severity = $severity;

		}

		function SetReporter ($reporter) {

			$this->_reporter = $reporter;

		}

		function SetHandler ($handler) {

			$this->_handler = $handler;

		}

		function SetQuery ($query) {

			$this->_query = $query;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT bug_id, project_id, reporter_id, handler_id, duplicate_id, priority, severity, reproducibility, status, resolution, projection, category, date_submitted, date_updated, eta, version, view_state, summary, description, steps_to_reproduce, additional_information,fixed_in_version FROM ' . $opnTables['bugs'] . $where . $this->_orderby . $this->_desc);
			while (! $result->EOF) {
				$this->_cache[$result->fields['bug_id']]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$result->fields['bug_id']]['project_id'] = $result->fields['project_id'];
				$this->_cache[$result->fields['bug_id']]['reporter_id'] = $result->fields['reporter_id'];
				$this->_cache[$result->fields['bug_id']]['handler_id'] = $result->fields['handler_id'];
				$this->_cache[$result->fields['bug_id']]['duplicate_id'] = $result->fields['duplicate_id'];
				$this->_cache[$result->fields['bug_id']]['priority'] = $result->fields['priority'];
				$this->_cache[$result->fields['bug_id']]['severity'] = $result->fields['severity'];
				$this->_cache[$result->fields['bug_id']]['reproducibility'] = $result->fields['reproducibility'];
				$this->_cache[$result->fields['bug_id']]['status'] = $result->fields['status'];
				$this->_cache[$result->fields['bug_id']]['resolution'] = $result->fields['resolution'];
				$this->_cache[$result->fields['bug_id']]['projection'] = $result->fields['projection'];
				$this->_cache[$result->fields['bug_id']]['category'] = $result->fields['category'];
				$this->_cache[$result->fields['bug_id']]['date_submitted'] = $result->fields['date_submitted'];
				$this->_cache[$result->fields['bug_id']]['date_updated'] = $result->fields['date_updated'];
				$this->_cache[$result->fields['bug_id']]['eta'] = $result->fields['eta'];
				$this->_cache[$result->fields['bug_id']]['version'] = $result->fields['version'];
				$this->_cache[$result->fields['bug_id']]['view_state'] = $result->fields['view_state'];
				$this->_cache[$result->fields['bug_id']]['summary'] = $result->fields['summary'];
				$this->_cache[$result->fields['bug_id']]['description'] = $result->fields['description'];
				$this->_cache[$result->fields['bug_id']]['steps_to_reproduce'] = $result->fields['steps_to_reproduce'];
				$this->_cache[$result->fields['bug_id']]['additional_information'] = $result->fields['additional_information'];
				$this->_cache[$result->fields['bug_id']]['fixed_in_version'] = $result->fields['fixed_in_version'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = ' WHERE bug_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT bug_id, project_id, reporter_id, handler_id, duplicate_id, priority, severity, reproducibility, status, resolution, projection, category, date_submitted, date_updated, eta, version, view_state, summary, description, steps_to_reproduce, additional_information, fixed_in_version FROM ' . $opnTables['bugs'] . $where);
				if (!$result->EOF) {
					$this->_cache[$id]['bug_id'] = $result->fields['bug_id'];
					$this->_cache[$id]['project_id'] = $result->fields['project_id'];
					$this->_cache[$id]['reporter_id'] = $result->fields['reporter_id'];
					$this->_cache[$id]['handler_id'] = $result->fields['handler_id'];
					$this->_cache[$id]['duplicate_id'] = $result->fields['duplicate_id'];
					$this->_cache[$id]['priority'] = $result->fields['priority'];
					$this->_cache[$id]['severity'] = $result->fields['severity'];
					$this->_cache[$id]['reproducibility'] = $result->fields['reproducibility'];
					$this->_cache[$id]['status'] = $result->fields['status'];
					$this->_cache[$id]['resolution'] = $result->fields['resolution'];
					$this->_cache[$id]['projection'] = $result->fields['projection'];
					$this->_cache[$id]['category'] = $result->fields['category'];
					$this->_cache[$id]['date_submitted'] = $result->fields['date_submitted'];
					$this->_cache[$id]['date_updated'] = $result->fields['date_updated'];
					$this->_cache[$id]['eta'] = $result->fields['eta'];
					$this->_cache[$id]['version'] = $result->fields['version'];
					$this->_cache[$id]['view_state'] = $result->fields['view_state'];
					$this->_cache[$id]['summary'] = $result->fields['summary'];
					$this->_cache[$id]['description'] = $result->fields['description'];
					$this->_cache[$id]['steps_to_reproduce'] = $result->fields['steps_to_reproduce'];
					$this->_cache[$id]['additional_information'] = $result->fields['additional_information'];
					$this->_cache[$id]['fixed_in_version'] = $result->fields['fixed_in_version'];
					$result->Close ();
				} else {
					$result->Close ();
					return array ();
				}
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$reporter_id = 0;
			get_var ('reporter_id', $reporter_id, 'form', _OOBJ_DTYPE_INT);
			$handler_id = 0;
			get_var ('handler_id', $handler_id, 'form', _OOBJ_DTYPE_INT);
			$duplicate_id = 0;
			get_var ('duplicate_id', $duplicate_id, 'form', _OOBJ_DTYPE_INT);
			$priority = 3;
			get_var ('priority', $priority, 'form', _OOBJ_DTYPE_INT);
			$severity = 1;
			get_var ('severity', $severity, 'form', _OOBJ_DTYPE_INT);
			$reproducibility = 1;
			get_var ('reproducibility', $reproducibility, 'form', _OOBJ_DTYPE_INT);
			$status = 1;
			get_var ('status', $status, 'form', _OOBJ_DTYPE_INT);
			$resolution = 1;
			get_var ('resolution', $resolution, 'form', _OOBJ_DTYPE_INT);
			$projection = 1;
			get_var ('projection', $projection, 'form', _OOBJ_DTYPE_INT);
			$category = 1;
			get_var ('category', $category, 'form', _OOBJ_DTYPE_INT);
			$eta = 1;
			get_var ('eta', $eta, 'form', _OOBJ_DTYPE_INT);
			$version = 1;
			get_var ('version', $version, 'form', _OOBJ_DTYPE_INT);
			$view_state = 1;
			get_var ('view_state', $view_state, 'form', _OOBJ_DTYPE_INT);
			$summary = '';
			get_var ('summary', $summary, 'form', _OOBJ_DTYPE_CHECK);
			$description = '';
			get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
			$steps_to_reproduce = '';
			get_var ('steps_to_reproduce', $steps_to_reproduce, 'form', _OOBJ_DTYPE_CHECK);
			$additional_information = '';
			get_var ('additional_information', $additional_information, 'form', _OOBJ_DTYPE_CHECK);
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$bug_id = $opnConfig['opnSQL']->get_new_number ('bugs', 'bug_id');
			$this->_cache[$bug_id]['bug_id'] = $bug_id;
			$this->_cache[$bug_id]['project_id'] = $project_id;
			$this->_cache[$bug_id]['reporter_id'] = $reporter_id;
			$this->_cache[$bug_id]['handler_id'] = $handler_id;
			$this->_cache[$bug_id]['duplicate_id'] = $duplicate_id;
			$this->_cache[$bug_id]['priority'] = $priority;
			$this->_cache[$bug_id]['severity'] = $severity;
			$this->_cache[$bug_id]['reproducibility'] = $reproducibility;
			$this->_cache[$bug_id]['status'] = $status;
			$this->_cache[$bug_id]['resolution'] = $resolution;
			$this->_cache[$bug_id]['projection'] = $projection;
			$this->_cache[$bug_id]['category'] = $category;
			$this->_cache[$bug_id]['date_submitted'] = $time;
			$this->_cache[$bug_id]['date_updated'] = $time;
			$this->_cache[$bug_id]['eta'] = $eta;
			$this->_cache[$bug_id]['version'] = $version;
			$this->_cache[$bug_id]['view_state'] = $view_state;
			$this->_cache[$bug_id]['summary'] = $summary;
			$this->_cache[$bug_id]['description'] = $description;
			$this->_cache[$bug_id]['steps_to_reproduce'] = $steps_to_reproduce;
			$this->_cache[$bug_id]['additional_information'] = $additional_information;
			$summary = $opnConfig['opnSQL']->qstr ($summary);
			$description = $opnConfig['opnSQL']->qstr ($description, 'description');
			$steps_to_reproduce = $opnConfig['opnSQL']->qstr ($steps_to_reproduce, 'steps_to_reproduce');
			$additional_information = $opnConfig['opnSQL']->qstr ($additional_information, 'additional_information');
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bugs'] . '(bug_id, project_id, reporter_id, handler_id, duplicate_id, priority, severity, reproducibility, status, resolution, projection, category, date_submitted, date_updated, eta, version, view_state, summary,description,steps_to_reproduce,additional_information,fixed_in_version) VALUES ' . "($bug_id,$project_id,$reporter_id,$handler_id,$duplicate_id,$priority, " . "$severity,$reproducibility,$status,$resolution,$projection,$category, " . "$time,$time,$eta,$version,$view_state,$summary,$description,$steps_to_reproduce,$additional_information,0)");
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bugs'], 'bug_id=' . $bug_id);
			return $bug_id;

		}

		function ModifyRecord () {

			global $opnConfig, $opnTables;

			$bug_id = 0;
			get_var ('bug_id', $bug_id, 'form', _OOBJ_DTYPE_INT);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$reporter_id = 0;
			get_var ('reporter_id', $reporter_id, 'form', _OOBJ_DTYPE_INT);
			$handler_id = 0;
			get_var ('handler_id', $handler_id, 'form', _OOBJ_DTYPE_INT);
			$duplicate_id = 0;
			get_var ('duplicate_id', $duplicate_id, 'form', _OOBJ_DTYPE_INT);
			$priority = 3;
			get_var ('priority', $priority, 'form', _OOBJ_DTYPE_INT);
			$severity = 1;
			get_var ('severity', $severity, 'form', _OOBJ_DTYPE_INT);
			$reproducibility = 1;
			get_var ('reproducibility', $reproducibility, 'form', _OOBJ_DTYPE_INT);
			$status = 1;
			get_var ('status', $status, 'form', _OOBJ_DTYPE_INT);
			$resolution = 1;
			get_var ('resolution', $resolution, 'form', _OOBJ_DTYPE_INT);
			$projection = 1;
			get_var ('projection', $projection, 'form', _OOBJ_DTYPE_INT);
			$category = 0;
			get_var ('category', $category, 'form', _OOBJ_DTYPE_INT);
			$eta = 1;
			get_var ('eta', $eta, 'form', _OOBJ_DTYPE_INT);
			$version = 0;
			get_var ('version', $version, 'form', _OOBJ_DTYPE_INT);
			$view_state = 1;
			get_var ('view_state', $view_state, 'form', _OOBJ_DTYPE_INT);
			$summary = '';
			get_var ('summary', $summary, 'form', _OOBJ_DTYPE_CLEAN);
			$description = '';
			get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
			$steps_to_reproduce = '';
			get_var ('steps_to_reproduce', $steps_to_reproduce, 'form', _OOBJ_DTYPE_CLEAN);
			$additional_information = '';
			get_var ('additional_information', $additional_information, 'form', _OOBJ_DTYPE_CLEAN);
			$fixed_in_version = 0;
			get_var ('fixed_in_version', $fixed_in_version, 'form', _OOBJ_DTYPE_INT);
			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$this->_cache[$bug_id]['project_id'] = $project_id;
			$this->_cache[$bug_id]['reporter_id'] = $reporter_id;
			$this->_cache[$bug_id]['handler_id'] = $handler_id;
			$this->_cache[$bug_id]['duplicate_id'] = $duplicate_id;
			$this->_cache[$bug_id]['priority'] = $priority;
			$this->_cache[$bug_id]['severity'] = $severity;
			$this->_cache[$bug_id]['reproducibility'] = $reproducibility;
			$this->_cache[$bug_id]['status'] = $status;
			$this->_cache[$bug_id]['resolution'] = $resolution;
			$this->_cache[$bug_id]['projection'] = $projection;
			$this->_cache[$bug_id]['category'] = $category;
			$this->_cache[$bug_id]['date_updated'] = $time;
			$this->_cache[$bug_id]['eta'] = $eta;
			$this->_cache[$bug_id]['version'] = $version;
			$this->_cache[$bug_id]['view_state'] = $view_state;
			$this->_cache[$bug_id]['summary'] = $summary;
			$this->_cache[$bug_id]['description'] = $description;
			$this->_cache[$bug_id]['steps_to_reproduce'] = $steps_to_reproduce;
			$this->_cache[$bug_id]['additional_information'] = $additional_information;
			$summary = $opnConfig['opnSQL']->qstr ($summary);
			$description = $opnConfig['opnSQL']->qstr ($description, 'description');
			$steps_to_reproduce = $opnConfig['opnSQL']->qstr ($steps_to_reproduce, 'steps_to_reproduce');
			$additional_information = $opnConfig['opnSQL']->qstr ($additional_information, 'additional_information');
			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET project_id=$project_id, reporter_id=$reporter_id, handler_id=$handler_id," . "duplicate_id=$duplicate_id,priority=$priority,severity=$severity," . "reproducibility=$reproducibility,status=$status,resolution=$resolution," . "projection=$projection,category=$category,date_updated=$time,eta=$eta," . "version=$version,view_state=$view_state,summary=$summary,description=$description," . "steps_to_reproduce=$steps_to_reproduce,additional_information=$additional_information, fixed_in_version=$fixed_in_version" . $where);
			$opnConfig['opnSQL']->UpdateBlobs ($opnTables['bugs'], 'bug_id=' . $bug_id);

		}

		function ModifyDate ($bug_id) {

			global $opnConfig, $opnTables;

			$opnConfig['opndate']->now ();
			$time = '';
			$opnConfig['opndate']->opnDataTosql ($time);
			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET date_updated=$time" . $where);

		}

		function ModifyStatus ($bug_id, $status) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET status=$status" . $where);

		}

		function ModifyPriority ($bug_id, $priority) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET priority=$priority" . $where);

		}

		function ModifyFixed ($bug_id, $version) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET fixed_in_version=$version" . $where);

		}

		function ModifyResolution ($bug_id, $resolution) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET resolution=$resolution" . $where);

		}

		function ModifyHandler ($bug_id, $handler_id) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET handler_id=$handler_id" . $where);

		}

		function ModifyDuplicateID ($bug_id) {

			global $opnConfig, $opnTables;

			$duplicate_id = 0;
			get_var ('duplicate_id', $duplicate_id, 'form', _OOBJ_DTYPE_INT);
			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET duplicate_id=$duplicate_id" . $where);

		}

		function ModifyProject ($bug_id, $project_id) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET project_id=$project_id" . $where);

		}

		function ModifyView ($bug_id, $view) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['bugs'] . " SET view_state=$view" . $where);

		}

		function DeleteRecord () {

			$bug_id = func_get_arg (0);
			unset ($this->_cache[$bug_id]);
			$this->DeleteByBug ($bug_id);

		}

		function DeleteByProject ($project_id) {

			$this->SetProject ($project_id);
			$bugs = $this->GetArray ();
			foreach ($bugs as $value) {
				$this->DeleteByBug ($value['bug_id']);
			}
			$this->SetProject (0);
			$this->_cache = array ();
			unset ($bugs);

		}

		function DeleteByBug ($bug_id) {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsnotes.php');
			$delete = & new BugsNotes ();
			$delete->DeleteByBug ($bug_id);
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsmonitoring.php');
			$delete = & new BugsMonitoring ();
			$delete->DeleteByBug ($bug_id);
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugshistory.php');
			$delete = & new BugsHistory ();
			$delete->DeleteByBug ($bug_id);
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsrelation.php');
			$delete = & new BugsRelation ();
			$delete->DeleteByBug ($bug_id);
			include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsattachments.php');
			$delete = & new BugsAttachments ();
			$delete->DeleteByBug ($bug_id);
			unset ($delete);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs'] . ' WHERE bug_id=' . $bug_id);

		}

		/**
		* @return object
		*/

		function GetLimit ($limit, $offset) {

			global $opnConfig, $opnTables;

			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->SelectLimit ('SELECT bug_id, project_id, reporter_id, handler_id, duplicate_id, priority, severity, reproducibility, status, resolution, projection, category, date_submitted, date_updated, eta, version, view_state, summary, description, steps_to_reproduce, additional_information, fixed_in_version FROM ' . $opnTables['bugs'] . $where . $this->_orderby, $limit, $offset);
			return $result;

		}

		function CheckAdmin () {

			global $opnConfig;

			include_once (_OPN_ROOT_PATH . 'modules/project/include/class.user.php');
			$admins = & new ProjectUser ();
			if ($this->_project) {
				$admins->SetProject ($this->_project);
			}
			if ($admins->GetCount ($opnConfig['permission']->UserInfo ('uid') ) ) {
				return true;
			}
			return false;

		}

		function BuildWhere () {

			global $opnConfig;

			$help = '';
			if (count ($this->_selectstatus) ) {
				$help1 = array ();
				foreach ($this->_selectstatus as $value) {
					$help1[] = ' status=' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' OR', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_selectseverity) ) {
				$help1 = array ();
				foreach ($this->_selectseverity as $value) {
					$help1[] = ' severity=' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' OR', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_selectreproducibility)) {
				$help1 = array ();
				foreach ($this->_selectreproducibility as $value) {
					$help1[] = ' reproducibility=' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' OR', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_selectpriority)) {
				$help1 = array ();
				foreach ($this->_selectpriority as $value) {
					$help1[] = ' priority=' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' OR', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_selectresolution)) {
				$help1 = array ();
				foreach ($this->_selectresolution as $value) {
					$help1[] = ' resolution=' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' OR', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_selectprojection)) {
				$help1 = array ();
				foreach ($this->_selectprojection as $value) {
					$help1[] = ' projection=' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' OR', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_selecteta)) {
				$help1 = array ();
				foreach ($this->_selecteta as $value) {
					$help1[] = ' eta=' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' OR', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_blockstatus) ) {
				$help1 = array ();
				foreach ($this->_blockstatus as $value) {
					$help1[] = ' status<>' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' AND', $help1) . ')';
				unset ($help1);
			}
			if (count ($this->_blockseverity) ) {
				$help1 = array ();
				foreach ($this->_blockseverity as $value) {
					$help1[] = ' severity<>' . $value;
				}
				$this->_isAnd ($help);
				$help .= '(' . implode (' AND', $help1) . ')';
				unset ($help1);
			}
			if ($this->_project) {
				$this->_isAnd ($help);
				$help .= ' (project_id=' . $this->_project . ')';
			}
			if ($this->_fixed_version) {
				$this->_isAnd ($help);
				$help .= ' (fixed_in_version=' . $this->_fixed_version . ')';
			}
			if ($this->_category) {
				$this->_isAnd ($help);
				$help .= ' (category=' . $this->_category . ')';
			}
			if ($this->_severity) {
				$this->_isAnd ($help);
				$help .= ' (severity=' . $this->_severity . ')';
			}
			if ($this->_query != '') {
				$this->_isAnd ($help);
				$like_search = $opnConfig['opnSQL']->AddLike ($this->_query);
				$help .= ' (summary LIKE ' . $like_search . ')';
			}
			if ($this->_reporter) {
				$this->_isAnd ($help);
				if ($this->_reporter == -1) {
					$help .= ' (reporter_id>0)';
				} else {
					$help .= ' (reporter_id=' . $this->_reporter . ')';
				}
			}
			if ($this->_handler) {
				$this->_isAnd ($help);
				if ($this->_handler == 1) {
					$help .= ' handler_id=0';
				} elseif ($this->_handler == -1) {
					$help .= ' (handler_id>0)';
				} else {
					$help .= ' (handler_id=' . $this->_handler . ')';
				}
			}
			if ( (!$opnConfig['permission']->HasRights ('modules/bug_tracking', array (_BUGT_PERM_DEVELOPER, _BUGT_PERM_MANAGER, _PERM_EDIT, _PERM_NEW, _PERM_DELETE, _PERM_ADMIN), true) ) && (!$this->CheckAdmin () ) ) {
				$help1 = '( (view_state=' . _OPN_BUG_STATE_PUBLIC . ')';
				if ($opnConfig['permission']->IsUser () ) {
					$help1 .= ' OR ((view_state=' . _OPN_BUG_STATE_PRIVATE . ') AND (reporter_id=' . $opnConfig['permission']->UserInfo ('uid') . '))';
				}
				$help1 .= ' )';
				$this->_isAnd ($help);
				$help .= $help1;
			}
			if ($help != '') {
				return ' WHERE ' . $help;
			}
			return '';

		}

	}
}

?>