<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_BUGS_MONITORING_INCLUDED') ) {
	define ('_OPN_BUGS_MONITORING_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsabstract.php');

	class BugsMonitoring extends AbstractBugs {
		var $_bug = 0;
		var $_user = 0;

		function BugsMonitoring () {

			$this->_fieldname = 'bug_id';
			$this->_tablename = 'bugs_monitoring';

		}

		function SetBug ($bug) {

			$this->_bug = $bug;

		}

		function SetUser ($userid) {

			$this->_user = $userid;

		}

		function BuildKey ($bug_id, $user_id) {
			return 'B' . $bug_id . 'U' . $user_id;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT bug_id, user_id FROM ' . $opnTables['bugs_monitoring'] . $where . ' ORDER BY bug_id');
			while (! $result->EOF) {
				$key = $this->BuildKey ($result->fields['bug_id'], $result->fields['user_id']);
				$this->_cache[$key]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$key]['user_id'] = $result->fields['user_id'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($bug_id) {

			global $opnConfig, $opnTables;

			$user_id = func_get_arg (1);
			$key = $this->BuildKey ($bug_id, $user_id);
			if (!isset ($this->_cache[$key]) ) {
				$where = ' WHERE bug_id=' . $bug_id . ' AND user_id=' . $user_id;
				$result = $opnConfig['database']->Execute ('SELECT bug_id, user_id FROM ' . $opnTables['bugs_monitoring'] . $where);
				$this->_cache[$key]['bug_id'] = $result->fields['bug_id'];
				$this->_cache[$key]['user_id'] = $result->fields['user_id'];
				$result->Close ();
			}
			return $this->_cache[$key];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$bug_id = func_get_arg (0);
			$user_id = 0;
			get_var ('user_id', $user_id, 'form', _OOBJ_DTYPE_INT);
			$key = $this->BuildKey ($bug_id, $user_id);
			$this->_cache[$key]['bug_id'] = $bug_id;
			$this->_cache[$key]['user_id'] = $user_id;
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['bugs_monitoring'] . "(bug_id, user_id) VALUES ($bug_id,$user_id)");

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$key = $this->BuildKey ($this->_bug, $this->_user);
			unset ($this->_cache[$key]);
			$where = $this->BuildWhere ();
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_monitoring'] . $where);

		}

		function DeleteByBug ($bug_id) {

			global $opnConfig, $opnTables;

			$where = ' WHERE bug_id=' . $bug_id;
			$this->_cache = array ();
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['bugs_monitoring'] . $where);

		}

		function BuildWhere () {

			$help = '';
			if ($this->_user) {
				$help .= ' user_id=' . $this->_user;
			}
			if ($this->_bug) {
				$help1 = ' bug_id=' . $this->_bug;
				$this->_isAnd ($help);
				$help .= $help1;
			}
			if ($help != '') {
				return ' WHERE ' . $help;
			}
			return '';

		}

	}
}

?>