<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/plugin/middlebox/newbugs/language/');

function send_middlebox_edit (&$box_array_dat) {

	global $opnConfig, $opnTheme;
	if (!isset ($box_array_dat['box_options']['title']) ) {
		$box_array_dat['box_options']['title'] = _MID_BUGTRACKINGENEW_TITLE;
	}
	if (!isset ($box_array_dat['box_options']['limit']) ) {
		$box_array_dat['box_options']['limit'] = 5;
	}
	if (!isset ($box_array_dat['box_options']['project']) ) {
		$box_array_dat['box_options']['project'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['use_tpl']) ) {
		$box_array_dat['box_options']['use_tpl'] = '';
	}
	if (!isset ($box_array_dat['box_options']['strlength']) ) {
		$box_array_dat['box_options']['strlength'] = 22;
	}
	if (!isset ($box_array_dat['box_options']['show_link']) ) {
		$box_array_dat['box_options']['show_link'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['block_feature']) ) {
		$box_array_dat['box_options']['block_feature'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['only_feature']) ) {
		$box_array_dat['box_options']['only_feature'] = 0;
	}
	$options = array ();
	if ($opnConfig['_THEME_HAVE_opnliste'] == 0) {
		GetFileChooseOption ($options, _OPN_ROOT_PATH . 'themes/opn_themes_include/tpl/', 'opnliste-');
	} else {
		GetFileChooseOption ($options, _OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/tpl/', 'opnliste-');
	}
	$box_array_dat['box_form']->AddOpenRow ();
	$box_array_dat['box_form']->AddLabel ('use_tpl', _MID_USETPL . ':');
	$box_array_dat['box_form']->AddSelect ('use_tpl', $options, $box_array_dat['box_options']['use_tpl']);
	if ($opnConfig['installedPlugins']->isplugininstalled ('modules/project') ) {
		include_once (_OPN_ROOT_PATH . 'modules/project/include/class.project.php');
		$project = & new Project ();
		$projects = $project->GetArray ();
		unset ($project);
		$options = array ();
		$options[0] = _MID_BUGTRACKINGNEW_ALL_PROJECTS;
		foreach ($projects as $value) {
			$options[$value['project_id']] = $value['project_name'];
		}
		$box_array_dat['box_form']->AddChangeRow ();
		$box_array_dat['box_form']->AddLabel ('project', _MID_BUGTRACKINGNEW_PROJECT);
		$box_array_dat['box_form']->AddSelect ('project', $options, $box_array_dat['box_options']['project']);
	}
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_MID_BUGTRACKINGNEW_SHOW_LINK);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('show_link', 1, ($box_array_dat['box_options']['show_link'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('show_link', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('show_link', 0, ($box_array_dat['box_options']['show_link'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('show_link', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_MID_BUGTRACKINGNEW_BLOCK_FEATURE);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('block_feature', 1, ($box_array_dat['box_options']['block_feature'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('block_feature', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('block_feature', 0, ($box_array_dat['box_options']['block_feature'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('block_feature', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_MID_BUGTRACKINGNEW_ONLY_FEATURE);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('only_feature', 1, ($box_array_dat['box_options']['only_feature'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('only_feature', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('only_feature', 0, ($box_array_dat['box_options']['only_feature'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('only_feature', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddLabel ('limit', _MID_BUGTRACKINGENEW_LIMIT);
	$box_array_dat['box_form']->AddTextfield ('limit', 10, 10, $box_array_dat['box_options']['limit']);
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddLabel ('strlength', _MID_BUGTRACKINGNEW_STRLENGTH);
	$box_array_dat['box_form']->AddTextfield ('strlength', 10, 10, $box_array_dat['box_options']['strlength']);
	$box_array_dat['box_form']->AddCloseRow ();

}

?>