<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/plugin/search/language/');

function bug_tracking_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'bug_tracking';
	$button['sel'] = 0;
	$button['label'] = _BUGTRACKING_SEARCH_BUG;
	$buttons[] = $button;
	unset ($button);

}

function bug_tracking_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'bug_tracking':
			bug_tracking_retrieve_all ($query, $data, $sap);
		}
	}

	function bug_tracking_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$q = bug_tracking_get_query ($query);
		$q .= bug_tracking_get_orderby ();
		$result = &$opnConfig['database']->Execute ($q);
		$hlp1 = array ();
		if ($result !== false) {
			$nrows = $result->RecordCount ();
			if ($nrows>0) {
				$hlp1['data'] = _BUGTRACKING_SEARCH_BUG;
				$hlp1['ishead'] = true;
				$data[] = $hlp1;
				while (! $result->EOF) {
					$lid = $result->fields['bug_id'];
					$title = $result->fields['summary'];
					$hlp1['data'] = bug_tracking_build_link ($lid, $title);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
					$result->MoveNext ();
				}
				unset ($hlp1);
				$sap++;
			}
			$result->Close ();
		}

	}

	function bug_tracking_get_query ($query) {

		global $opnTables, $opnConfig;

		$opnConfig['opn_searching_class']->init ();
		$opnConfig['opn_searching_class']->SetFields (array ('bug_id',
								'summary') );
		$opnConfig['opn_searching_class']->SetTable ($opnTables['bugs']);
		$opnConfig['opn_searching_class']->SetWhere ('(view_state=0) AND');
		$opnConfig['opn_searching_class']->SetQuery ($query);
		$opnConfig['opn_searching_class']->SetSearchfields (array ('summary',
									'description',
									'steps_to_reproduce',
									'additional_information') );
		return $opnConfig['opn_searching_class']->GetSQL ();

}

function bug_tracking_get_orderby () {
	return ' ORDER BY bug_id ASC';

}

function bug_tracking_build_link ($lid, $title) {

	global $opnConfig;

	$hlp = '<a class="%linkclass%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/bug_tracking/index.php',
								'op' => 'view_bug',
								'bug_id' => $lid) ) . '" target="_blank">' . $title . '</a>';
	return $hlp;

}

?>