<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../../../../mainfile.php');
}
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/bug_tracking/plugin/user/admin/language/');
include_once (_OPN_ROOT_PATH . 'api/user_name.php');

function bug_tracking_MenuBuild ($usernr) {

	global $opnConfig;

	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsusersettings.php');
	$opnConfig['permission']->InitPermissions ('modules/bug_tracking');
	$opnConfig['module']->InitModule ('modules/bug_tracking');
	$default_project = 0;
	$block_resolved = 0;
	$block_closed = 0;
	$block_feature = 0;
	$bugs_perpage = $opnConfig['bugs_perpage'];
	$refresh_delay = $opnConfig['refresh_rate'];
	$email_on_new = 0;
	$email_on_updated = 1;
	$email_on_deleted = 1;
	$email_on_assigned = 1;
	$email_on_feedback = 1;
	$email_on_resolved = 1;
	$email_on_closed = 1;
	$email_on_reopened = 1;
	$email_on_bugnote = 1;
	$email_on_status = 1;
	$email_on_priority = 1;
	$print_pref = '111111111111111111111111111';
	$users = & new BugsUserSettings ();
	$users->SetUser ($usernr);
	if ($users->GetCount () ) {
		$settings = $users->RetrieveSingle ($usernr);
		$default_project = $settings['default_project'];
		$block_resolved = $settings['block_resolved'];
		$block_closed = $settings['block_closed'];
		$bugs_perpage = $settings['bugs_perpage'];
		$refresh_delay = $settings['refresh_delay'];
		$email_on_new = $settings['email_on_new'];
		$email_on_updated = $settings['email_on_updated'];
		$email_on_deleted = $settings['email_on_deleted'];
		$email_on_assigned = $settings['email_on_assigned'];
		$email_on_feedback = $settings['email_on_feedback'];
		$email_on_resolved = $settings['email_on_resolved'];
		$email_on_closed = $settings['email_on_closed'];
		$email_on_reopened = $settings['email_on_reopened'];
		$email_on_bugnote = $settings['email_on_bugnote'];
		$email_on_status = $settings['email_on_status'];
		$email_on_priority = $settings['email_on_priority'];
		$print_pref = $settings['print_pref'];
		$block_feature = $settings['block_feature'];
		unset ($settings);
	}
	unset ($users);
	$help = '<br />';
	$bugusers = $opnConfig['permission']->GetUsersForGroupname (_BUGT_GROUP_DEVELOPER);
	$bugusers = $bugusers+ $opnConfig['permission']->GetUsersForGroupname (_BUGT_GROUP_MANAGER);
	$bugusers = $bugusers+ $opnConfig['permission']->GetUsersForGroupname (_BUGT_GROUP_ADMINISTRATOR);
	$bugusers = $bugusers+ $opnConfig['permission']->GetUsersForGroupname ('Webmaster');
	if ($opnConfig['installedPlugins']->isplugininstalled ('modules/project') ) {
		include_once (_OPN_ROOT_PATH . 'modules/project/include/class.user.php');
		$admins = & new ProjectUser ();
		if ($admins->GetCount ($usernr) ) {
			$bugusers[$usernr] = $usernr;
		}
		unset ($admins);
	}
	$bugusers = array_unique ($bugusers);
	$test = array_keys ($bugusers);
	$test = in_array ($usernr, $test);
	unset ($bugusers);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_BUG_TRACKING_430_', 'bug_tracking');
	$form->Init ('index.php');
	$form->AddTable ();
	$form->AddCols (array ('30%', '70%') );
	$form->AddOpenRow ();
	$form->AddLabel ('block_resolved', _BUG_TRACKING_RESOLVED);
	$form->AddCheckbox ('block_resolved', 1, $block_resolved);
	$form->AddChangeRow ();
	$form->AddLabel ('block_closed', _BUG_TRACKING_CLOSED);
	$form->AddCheckbox ('block_closed', 1, $block_closed);
	$form->AddChangeRow ();
	$form->AddLabel ('block_feature', _BUG_TRACKING_FEATURE);
	$form->AddCheckbox ('block_feature', 1, $block_feature);
	if ($opnConfig['installedPlugins']->isplugininstalled ('modules/project') ) {
		include_once (_OPN_ROOT_PATH . 'modules/project/include/class.project.php');
		$project = & new Project ();
		$projects = $project->GetArray ();
		unset ($project);
		$options[0] = _BUG_TRACKING_ALL_PROJECTS;
		foreach ($projects as $value) {
			$options[$value['project_id']] = $value['project_name'];
		}
		$form->AddChangeRow ();
		$form->AddLabel ('default_project', _BUG_TRACKING_PROJECT);
		$form->AddSelect ('default_project', $options, $default_project);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('bugs_perpage', _BUG_TRACKING_PERPAGE);
	$form->AddTextfield ('bugs_perpage', 3, 3, $bugs_perpage);
	$form->AddChangeRow ();
	$form->AddLabel ('refresh_delay', _BUG_TRACKING_REFRESH_DELAY);
	$form->AddTextfield ('refresh_delay', 3, 3, $refresh_delay);
	if ($test) {
		$form->AddChangeRow ();
		$form->AddLabel ('email_on_new', _BUG_TRACKING_EMAIL_ON_NEW);
		$form->AddCheckbox ('email_on_new', 1, ($email_on_new == 1?true : false) );
	}
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_updated', _BUG_TRACKING_EMAIL_ON_UPDATED);
	$form->AddCheckbox ('email_on_updated', 1, ($email_on_updated == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_deleted', _BUG_TRACKING_EMAIL_ON_DELETED);
	$form->AddCheckbox ('email_on_deleted', 1, ($email_on_deleted == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_assigned', _BUG_TRACKING_EMAIL_ON_ASSIGNED);
	$form->AddCheckbox ('email_on_assigned', 1, ($email_on_assigned == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_feedback', _BUG_TRACKING_EMAIL_ON_FEEDBACK);
	$form->AddCheckbox ('email_on_feedback', 1, ($email_on_feedback == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_resolved', _BUG_TRACKING_EMAIL_ON_RESOLVED);
	$form->AddCheckbox ('email_on_resolved', 1, ($email_on_resolved == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_closed', _BUG_TRACKING_EMAIL_ON_CLOSED);
	$form->AddCheckbox ('email_on_closed', 1, ($email_on_closed == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_reopened', _BUG_TRACKING_EMAIL_ON_REOPENED);
	$form->AddCheckbox ('email_on_reopened', 1, ($email_on_reopened == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_bugnote', _BUG_TRACKING_EMAIL_ON_BUGNOTE);
	$form->AddCheckbox ('email_on_bugnote', 1, ($email_on_bugnote == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_status', _BUG_TRACKING_EMAIL_ON_STATUS);
	$form->AddCheckbox ('email_on_status', 1, ($email_on_status == 1?true : false) );
	$form->AddChangeRow ();
	$form->AddLabel ('email_on_priority', _BUG_TRACKING_EMAIL_ON_PRIORITY);
	$form->AddCheckbox ('email_on_priority', 1, ($email_on_priority == 1?true : false) );
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('print_pref', $print_pref);
	$form->AddHidden ('op', 'go_save');
	$form->AddHidden ('uid', $usernr);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _BUG_TRACKING_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($help);
	unset ($form);
	$help .= '<br />';
	OpenTable ($help);
	$help .= '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _BUG_TRACKING_BACK_TO_MY_USERMENU . '</a>';
	CloseTable ($help);
	unset ($users);
	return $help;

}

function bug_tracking_write_the_secretuseradmin () {

	include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsusersettings.php');
	$users = & new BugsUserSettings ();
	$users->ModifyRecord ();
	unset ($users);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'go':
		$uid = 0;
		get_var ('uid', $uid, 'url', _OOBJ_DTYPE_INT);
		if ( ($uid>0) && ($opnConfig['permission']->HasRight ('admin/openphpnuke', _PERM_ADMIN, true) ) ) {
			$boxtxt = bug_tracking_MenuBuild ($uid);
		} else {
			$ui = $opnConfig['permission']->GetUserinfo ();
			$boxtxt = bug_tracking_MenuBuild ($ui['uid']);
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_440_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_BUG_TRACKING_SECRECT_LINK, $boxtxt);
		break;
	case 'go_save':
		$ui = $opnConfig['permission']->GetUserinfo ();
		$uid = 0;
		get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
		if ( ($ui['uid'] == $uid) OR ($opnConfig['permission']->HasRight ('admin/openphpnuke', _PERM_ADMIN, true) ) ) {
			bug_tracking_write_the_secretuseradmin ();
			$boxtitle = _BUG_TRACKING_SECRECT_LINK;
			$boxtxt = bug_tracking_MenuBuild ($uid);
		} else {
			$boxtitle = _BUG_TRACKING_SECRECT_LINK;
			$boxtxt = 'tries more nicely';
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_BUG_TRACKING_450_';
		$_display_dat['module'] = 'modules/bug_tracking';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtxt);
		break;
}

?>