<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;

$opnConfig['permission']->InitPermissions ('modules/bug_tracking');
$opnConfig['module']->InitModule ('modules/bug_tracking');
$bug_id = 0;
get_var ('bug_id', $bug_id, 'url', _OOBJ_DTYPE_INT);
if (!$bug_id) {
	exit ();
}
getLanguageDef (_OPN_ROOT_PATH . "modules/bug_tracking/language/");
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/function_center.php');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/bugs.constants.php');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugs.php');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsnotes.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.project.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.category.php');
include_once (_OPN_ROOT_PATH . 'modules/project/include/class.version.php');
include_once (_OPN_ROOT_PATH . 'modules/bug_tracking/include/class.bugsusersettings.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_cssparser.php');
global $bugvalues, $settings, $bugusers;

function PrintPage ($bug_id) {

	global $opnConfig;

	global $bugvalues;

	BugTracking_InitArrays ();
	$bugs = & new Bugs ();
	$bugsnotes = & new BugsNotes ();
	$project = & new Project ();
	$category = & new ProjectCategory ();
	$version = & new ProjectVersion ();
	$bug = $bugs->RetrieveSingle ($bug_id);
	if ($bug['project_id']) {
		$pro = $project->RetrieveSingle ($bug['project_id']);
	} else {
		$pro['project_name'] = '&nbsp;';
	}
	if ($bug['category']) {
		$cat = $category->RetrieveSingle ($bug['category']);
	} else {
		$cat['category'] = '&nbsp;';
	}
	if ($bug['version']) {
		$ver = $version->RetrieveSingle ($bug['version']);
	} else {
		$ver['version'] = '&nbsp;';
	}
	if ( ($opnConfig['site_logo'] == '') OR (!file_exists ($opnConfig['root_path_datasave'] . '/logo/' . $opnConfig['site_logo']) ) ) {
		$logo = '<img src="' . $opnConfig['opn_default_images'] . 'logo.gif" class="imgtag" alt="" />';
	} else {
		$logo = '<img src="' . $opnConfig['url_datasave'] . '/logo/' . $opnConfig['site_logo'] . '" class="imgtag" alt="" />';
	}
	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" \"http://www.w3.org/TR/html4/loose.dtd\"><html>" . '<head><title>' . $opnConfig['sitename'] . '</title></head>' . '<body bgcolor="#FFFFFF" text="#000000">' . '<table class="opncenterbox" border="0" cellspacing="0" cellpadding="0"><tr class="opncenterbox"><td class="opncenterbox">' . '<table border="0" width="800" cellpadding="0" cellspacing="1" bgcolor="#000000"><tr class="opncenterbox"><td class="opncenterbox">' . '<table border="0" width="800" cellpadding="20" cellspacing="1" bgcolor="#FFFFFF"><tr class="opncenterbox"><td class="opncenterbox">' . '<div class="centertag">' . $logo . '<br /><br /></div>' . '<table style="font-family:' . 'Verdana,Arial,Helvetica' . '">' . '<tr style="font-weight:bold"><td>' . _BUG_ID . '</td><td>' . _BUG_CATEGORY . '</td><td>' . _BUG_VERSION . '</td><td>' . _BUG_SEVERITY . '</td><td>' . _BUG_REPRO . '</td><td>' . _BUG_DATE_SUBMITTED . '</td><td>' . _BUG_DATE_UPDATED1 . '</td></tr>' . '<tr><td>' . $bug['bug_id'] . '</td><td>' . '[' . $pro['project_name'] . ']&nbsp;' . $cat['category'] . '</td><td>' . $ver['version'] . '</td><td>' . $bugvalues['severity'][$bug['severity']] . '</td><td>' . $bugvalues['reproducibility'][$bug['reproducibility']];
	$opnConfig['opndate']->sqlToopnData ($bug['date_submitted']);
	$time1 = '';
	$opnConfig['opndate']->formatTimestamp ($time1, _DATE_DATESTRING5);
	$opnConfig['opndate']->sqlToopnData ($bug['date_updated']);
	$time2 = '';
	$opnConfig['opndate']->formatTimestamp ($time2, _DATE_DATESTRING5);
	echo '</td><td>' . $time1 . '</td><td>' . $time2 . '</td></tr></table><br />';
	echo '<table style="font-family:Verdana,Arial,Helvetica"><tr><td style="font-weight:bold">' . _BUG_REPORTER;
	$ui = $opnConfig['permission']->GetUser ($bug['reporter_id'], 'useruid', '');
	echo '</td><td>' . $ui['uname'] . '</td><td style="font-weight:bold">' . _BUG_DISPLAY_STATE . '</td><td>' . $bugvalues['state'][$bug['view_state']] . '</td></tr>' . '<tr><td style="font-weight:bold">' . _BUG_HANDLER . '</td><td>';
	if ($bug['handler_id']) {
		$ui = $opnConfig['permission']->GetUser ($bug['handler_id'], 'useruid', '');
		echo $ui['uname'];
	} else {
		echo '&nbsp;';
	}
	echo '</td><td style="font-weight:bold">' . _BUG_PRIORITY . '</td><td>' . $bugvalues['priority'][$bug['priority']] . '</td></tr>' . '<tr><td style="font-weight:bold">' . _BUG_RESOLUTION . '</td><td>' . $bugvalues['resolution'][$bug['resolution']] . '</td>' . '<td style="font-weight:bold">' . _BUG_STATUS . '</td><td>' . $bugvalues['status'][$bug['status']] . '</td></tr>' . '<tr><td style="font-weight:bold">' . _BUG_DUPLICATE_ID . '</td><td>';
	if ($bug['duplicate_id']) {
		echo $bug['duplicate_id'];
	} else {
		echo '&nbsp;';
	}
	echo '</td><td style="font-weight:bold">' . _BUG_PROJECTION . '</td><td>' . $bugvalues['projection'][$bug['projection']] . '</td>' . '<td style="font-weight:bold">' . _BUG_ETA . '</td><td>' . $bugvalues['eta'][$bug['eta']] . '</td></tr></table><br />';
	echo '<table style="font-family:Verdana,Arial,Helvetica"><tr><td style="font-weight:bold">' . _BUG_SUMMARY . '</td><td>' . $bug['summary'] . '</td></tr>';
	opn_nl2br ($bug['description']);
	opn_nl2br ($bug['steps_to_reproduce']);
	opn_nl2br ($bug['additional_information']);
	echo '<tr><td style="font-weight:bold; vertical-align:top;">' . _BUG_DESCRIPTION . '</td><td>' . $bug['description'] . '</td></tr>' . '<tr><td style="font-weight:bold; vertical-align:top;">' . _BUG_STEPS_TO_REPRO . '</td><td>' . $bug['steps_to_reproduce'] . '</td></tr>' . '<tr><td style="font-weight:bold; vertical-align:top;">' . _BUG_ADDITIONAL_INFO . '</td><td>' . $bug['additional_information'] . '</td></tr></table>' . '</td></tr></table></td></tr></table></td></tr></table><br />';
	echo '</body></html>';

}
PrintPage ($bug_id);

?>