<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/changelog', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/changelog/admin/language/');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.php');
include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
include_once (_OPN_ROOT_PATH . 'modules/changelog/api/importchangelog.php');

global $opnTables;

$mf = & new CatFunctions ('changelog', false);
$mf->itemtable = $opnTables['changelog'];
$mf->itemid = 'id';
$mf->itemlink = 'catid';
$categories = & new opn_categorie ('changelog', 'changelog');
$categories->SetModule ('modules/changelog');
$categories->SetImagePath ($opnConfig['datasave']['changelog_cat']['path']);
$categories->SetItemID ('id');
$categories->SetItemLink ('catid');
$categories->SetScriptname ('index');
$categories->SetWarning (_CHANGELOG_WARNING);

function changelog_ConfigHeader () {

	global $opnConfig, $opnTables;

	$menu = & new OPN_Adminmenu (_CHANGELOG_ADMIN);
	$menu->InsertEntry (_CHANGELOG_NAVGENERAL, $opnConfig['opn_url'] . '/modules/changelog/admin/index.php');
	$menu->InsertEntry (_CHANGELOG_CATEGORY, array ($opnConfig['opn_url'] . '/modules/changelog/admin/index.php',
							'op' => 'catConfigMenu') );
	if ( $opnConfig['installedPlugins']->isplugininstalled ('pro/svnchangelog')) {
		$menu->InsertEntry (_CHANGELOG_CATEGORYREPRO, array ($opnConfig['opn_url'] . '/modules/changelog/admin/index.php',
								'op' => 'catRepro') );
		$justforcounting = &$opnConfig['database']->Execute ('SELECT COUNT(reproid) AS counter FROM ' . $opnTables['changelog_repros']);
		if (isset ($justforcounting->fields['counter']) ) {
			$reccount = $justforcounting->fields['counter'];
		} else {
			$reccount = 0;
		}
		unset ($justforcounting);
		if ($reccount > 0) {
			$menu->InsertEntry (_CHANGELOG_IMPORT, array ($opnConfig['opn_url'] . '/modules/changelog/admin/index.php',
									'op' => 'import') );
		}
	}
	$menu->InsertEntry (_CHANGELOG_GENERAL, $opnConfig['opn_url'] . '/modules/changelog/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	return '&nbsp;';

}

function changelog_startoutput () {

	global $opnConfig;

	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->DisplayHead ();
	changelog_ConfigHeader ();
}

function changelog_dooutput ($boxtxt, $helpid) {

	global $opnConfig;

	$_display_dat = array ();
	$_display_dat['title_help_id'] = $helpid;
	$_display_dat['module'] = 'modules/changelog';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	if ($boxtxt != '&nbsp;') {
		$opnConfig['opnOutput']->DisplayCenterbox (_CHANGELOG_ADMIN, $boxtxt);
	} else {
		$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);
	}
}

function changelog_catrepro () {

	global $opnConfig, $opnTables, $mf;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);

	$boxtxt = '';
	$justforcounting = &$opnConfig['database']->Execute ('SELECT COUNT(reproid) AS counter FROM ' . $opnTables['changelog_repros']);
	if (isset ($justforcounting->fields['counter']) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);

	$result = $opnConfig['database']->Execute ('SELECT reproid, reproname FROM ' . $opnTables['svnchangelog_repro'] . ' WHERE reproid>0 ORDER BY reproid');
	$repros = array ();
	while (!$result->EOF) {
		$repros[$result->fields['reproid']] = $result->fields['reproname'];
		$result->MoveNext ();
	}
	$result->Close ();
	if ($reccount) {
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array (	_CHANGELOG_REPRO,
										_CHANGELOG_CATEGORY,
										_CHANGELOG_LASTREV,
										_CHANGELOG_FUNCTIONS) );
		$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
		$result = &$opnConfig['database']->SelectLimit ('SELECT reproid, catid, lastrev FROM ' . $opnTables['changelog_repros'] . ' WHERE (reproid>0) AND (catid>0)', $maxperpage, $offset);
		if ($result !== false) {
			while (! $result->EOF) {
				$reproid = $result->fields['reproid'];
				$catid = $result->fields['catid'];
				$lastrev = $result->fields['lastrev'];
				$cat = $mf->getPathFromId ($catid);
				$cat = substr ($cat, 1);
				$table->AddDataRow (array ($repros[$reproid], $cat, $lastrev,
				$opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/changelog/admin/index.php', 'op' => 'editcatrepro', 'reproid' => $reproid, 'catid' => $catid) )
				.$opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/changelog/admin/index.php', 'op' => 'delcatrepro', 'reproid' => $reproid, 'catid' => $catid) )
				), array ('left', 'left', 'center') );
				$result->MoveNext ();
			}
			$result->Close ();
			$boxtxt = '';
			$table->GetTable ($boxtxt);
			$boxtxt .= '<br /><br />';
			$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/modules/changelog/admin/index.php',
							'op' => 'catRepro'),
							$reccount,
							$maxperpage,
							$offset);
			$boxtxt .= '<br /><br />';
		}

	}
	$boxtxt .= '<span class="bigtextbold">' . _CHANGELOG_ADDNEWCATREPRO . '</span>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CHANGELOG_NEW_CATREPRO_', 'changelog');
	$form->Init ('' . $opnConfig['opn_url'] . '/modules/changelog/admin/index.php');
	$form->UseBBCode (false);
	$form->UseEditor (false);
	$form->UseImages (false);
	$form->UseSmilies (false);
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('catid', _CHANGELOG_CATEGORY);
	$mf->makeMySelBox (0, $form, 0, 'catid');
	$form->AddChangeRow ();
	$form->AddLabel ('reproid', _CHANGELOG_REPRO);
	$form->AddSelect('reproid', $repros);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'addcatrepro');
	$form->AddSubmit ('submity', _CHANGELOG_ADDNEW);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);

	return $boxtxt;
}

function changelog_addcatrepro () {

	global $opnConfig, $opnTables, $mf;

	$catid=0;
	get_var ('catid',$catid,'form',_OOBJ_DTYPE_INT);
	$reproid=0;
	get_var ('reproid',$reproid,'form',_OOBJ_DTYPE_INT);

	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['changelog_repros'] . " VALUES ($reproid, $catid, 0)");
	$opnConfig['opnOutput']->Redirect(encodeurl( array ($opnConfig['opn_url'].'/modules/changelog/admin/index.php', 'op' => 'catRepro'), false));
}

function changelog_modcatrepro () {

	global $opnConfig, $opnTables, $mf;

	$reproid=0;
	get_var ('reproid',$reproid,'url',_OOBJ_DTYPE_INT);
	$catid=0;
	get_var ('catid',$catid,'url',_OOBJ_DTYPE_INT);
	$result = $opnConfig['database']->Execute ('SELECT reproid, reproname FROM ' . $opnTables['svnchangelog_repro'] . ' WHERE reproid>0 ORDER BY reproid');
	$repros = array ();
	while (!$result->EOF) {
		$repros[$result->fields['reproid']] = $result->fields['reproname'];
		$result->MoveNext ();
	}
	$result->Close ();
	$result = $opnConfig['database']->Execute ('SELECT lastrev FROM ' . $opnTables['changelog_repros'] . ' WHERE reproid=' . $reproid . ' AND catid=' . $catid);
	$lastrev = $result->fields['lastrev'];
	$result->Close ();
	$boxtxt = '<span class="bigtextbold">' . _CHANGELOG_ADDNEWCATREPRO . '</span>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_CHANGELOG_EDIT_CATREPRO', 'changelog');
	$form->Init ('' . $opnConfig['opn_url'] . '/modules/changelog/admin/index.php');
	$form->UseBBCode (false);
	$form->UseEditor (false);
	$form->UseImages (false);
	$form->UseSmilies (false);
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('catid', _CHANGELOG_CATEGORY);
	$mf->makeMySelBox ($catid, $form, 0, 'catid');
	$form->AddChangeRow ();
	$form->AddLabel ('reproid', _CHANGELOG_REPRO);
	$form->AddSelect('reproid', $repros, $reproid);
	$form->AddChangeRow ();
	$form->AddLabel ('lastrev', _CHANGELOG_LASTREV);
	$form->AddTextfield ('lastrev', 10, 10, $lastrev);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('reproid1', $reproid);
	$form->AddHidden ('catid1', $catid);
	$form->AddHidden ('op', 'savecatrepro');
	$form->SetEndCol ();
	$form->AddSubmit ('submity', _CHANGELOG_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;
}

function changelog_savecatrepro () {

	global $opnConfig, $opnTables;

	$reproid=0;
	get_var ('reproid',$reproid,'form',_OOBJ_DTYPE_INT);
	$catid=0;
	get_var ('catid',$catid,'form',_OOBJ_DTYPE_INT);
	$reproid1=0;
	get_var ('reproid1',$reproid1,'form',_OOBJ_DTYPE_INT);
	$catid1=0;
	get_var ('catid1',$catid1,'form',_OOBJ_DTYPE_INT);
	$lastrev=0;
	get_var ('lastrev',$lastrev,'form',_OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['changelog_repros']. " SET reproid=$reproid, catid=$catid, lastrev=$lastrev WHERE reproid=$reproid1 AND catid=$catid1");
	$opnConfig['opnOutput']->Redirect(encodeurl( array ($opnConfig['opn_url'].'/modules/changelog/admin/index.php', 'op' => 'catRepro'), false));
}

function changelog_deletecatrepro () {

	global $opnConfig, $opnTables;

	$reproid=0;
	get_var ('reproid',$reproid,'url',_OOBJ_DTYPE_INT);
	$catid=0;
	get_var ('catid',$catid,'url',_OOBJ_DTYPE_INT);
	$ok=0;
	get_var ('ok',$ok,'both',_OOBJ_DTYPE_INT);

//	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
	if ( ($ok == 1)) {
		$opnConfig['database']->Execute ('DELETE FROM ' .  $opnTables['changelog_repros'] . ' WHERE reproid=' . $reproid . ' AND catid=' . $catid);
		$opnConfig['opnOutput']->Redirect(encodeurl( array ($opnConfig['opn_url'].'/modules/changelog/admin/index.php', 'op' => 'catRepro'), false));
		return '';
	}
	$boxtxt = '<div class="bigtextbold" align="center"><br />';
	$boxtxt .= '<span class="alerttextcolor">';
	$boxtxt .= _CHANGELOG_WARNING_CATREPRO . '</span><br /><br />';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/changelog/admin/index.php',
										'op' => 'delcatrepro',
										'reproid' => $reproid,
										'catid' => $catid,
										'ok' => '1') ) . '">';
	$boxtxt .= _YES;
	$boxtxt .= '</a>';
	$boxtxt .= '&nbsp;&nbsp;&nbsp;';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl( array ($opnConfig['opn_url'].'/modules/changelog/admin/index.php', 'op' => 'catRepro')) . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}
function changelog_deletecatreprocat ($lid) {

	global $opnConfig, $opnTables;

	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['changelog_repros'] . ' WHERE catid=' . $lid);

}

$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'import':
		$opnConfig['locking']->SetModule ('modules/changelog');
		$opnConfig['locking']->SetWhat ('doimport');
		if (!$opnConfig['locking']->IsLocked ()) {
			$opnConfig['locking']->Lock ();
			import_changelog ();
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_cache.php');
			$cache_dir = $opnConfig['datasave']['changelog']['path'];
			$cache_time = $opnConfig['changelog_cache_time']*60;
			$cache_file = $cache_dir . 'changelog.cache';
			$cache = & new opn_cache ($cache_file, $cache_time);
			$cache->WriteData ('Imported');
			unset ($cache);
			$opnConfig['locking']->Unlock ();
		}
		$opnConfig['opnOutput']->Redirect(encodeurl( array ($opnConfig['opn_url'].'/modules/changelog/admin/index.php', 'op' => 'catRepro'), false));
		break;
	case 'delcatrepro':
		$ok = 0;
		get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
		if (!$ok) {
			changelog_startoutput ();
			$boxtxt = changelog_deletecatrepro ();
			changelog_dooutput ($boxtxt, '_OPNDOCID_MODULES_CHANGELOG_DELETE_CATREPRO_');
		} else {
			changelog_deletecatrepro ();
		}
		break;
	case 'savecatrepro':
		changelog_savecatrepro ();
		break;
	case 'editcatrepro':
		changelog_startoutput ();
		$boxtxt = changelog_modcatrepro ();
		changelog_dooutput ($boxtxt, '_OPNDOCID_MODULES_CHANGELOG_EDIT_CATREPRO_');
		break;
	case 'addcatrepro':
		changelog_addcatrepro ();
		break;
	case 'catRepro':
		changelog_startoutput ();
		$boxtxt = changelog_catrepro ();
		changelog_dooutput ($boxtxt, '_OPNDOCID_MODULES_CHANGELOG_DISPLAY_CATREPRO_');
		break;
	case 'catConfigMenu':
		changelog_startoutput ();
		$boxtxt = $categories->DisplayCats ();
		changelog_dooutput ($boxtxt, '_OPNDOCID_MODULES_CHANGELOG_DISPLAY_CAT_');
		break;
	case 'addCat':
		$categories->AddCat ();
		break;
	case 'delCat':
		$ok = 0;
		get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
		if (!$ok) {
			changelog_startoutput ();
			$boxtxt = $categories->DeleteCat ('', 'changelog_deletecatreprocat');
			changelog_dooutput ($boxtxt, '_OPNDOCID_MODULES_CHANGELOG_DELETE_CAT_');
		} else {
			$categories->DeleteCat ('', 'changelog_deletecatreprocat');
		}
		break;
	case 'modCat':
		changelog_startoutput ();
		$boxtxt = $categories->ModCat ();
		changelog_dooutput ($boxtxt, '_OPNDOCID_MODULES_CHANGELOG_EDIT_CAT_');
		break;
	case 'modCatS':
		$categories->ModCatS ();
		break;
	case 'OrderCat':
		$categories->OrderCat ();
		break;
	default:
		changelog_startoutput ();
		$boxtxt = '&nbsp;';
		changelog_dooutput ($boxtxt, '_OPNDOCID_MODULES_CHANGELOG_MAIN_');
		break;
}
if ($boxtxt != '') {
	$opnConfig['opnOutput']->DisplayFoot ();
}

?>