<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/docu_viewer/admin/language/');

function docusortitems ($a, $b) {
	if ($a['pos'] == $b['pos']) {
		return strcollcase ($a['name'], $b['name']);
	}
	if ($a['pos']<$b['pos']) {
		return -1;
	}
	return 1;

}

function get_ftp_dirs ($ftp, $path, &$files, &$boxtxt) {

	global $opnConfig;

	$ftp_files = @ftp_nlist ($ftp->con_id, $path);
	foreach ($ftp_files as $file) {
		// $isfile = @ftp_size($ftp->con_id, $file);
		// if($isfile != '-1') {
		$thefile = str_replace ($path, '', $file);
		$e = preg_split ("/\.[a-zA-Z]+/", $thefile);
		$pos = str_replace ('.', '', $e[0]);
		$pos = sprintf ("%'0-10s", $pos);
		$name = str_replace ($e[0] . '.', '', $thefile);
		$ext = (strstr ($name, '.')?strtolower (substr (strrchr ($name, '.'), 1) ) : '');
		// $boxtxt .= "*$ext*";
		if ( ( ($ext == '') && ( ($thefile != '.') && ($thefile != '..') ) ) OR ( ($ext != '') && ( ($thefile != '.') && ($thefile != '..') ) ) ) {
			$files[] = array ('name' => $name,
					'file_name' => $thefile,
					'pos' => $pos,
					'item' => $e[0],
					'ext' => $ext);
			if ($ext == '') {
				// $boxtxt .= ">$path$file/< <br />";
				get_ftp_dirs ($ftp, $path . $file . '/', $files, $boxtxt);
			} else {
				$local_file = $opnConfig['datasave']['docu_viewer_cache']['path'] . $thefile;
				$server_file = $path . $file;
				if (ftp_get ($ftp->con_id, $local_file, $server_file, FTP_BINARY) ) {
					// $boxtxt .= "Successfully written to $local_file<br />";
				} else {
					// $boxtxt .= "There was a problem<br />";
				}
			}
		}
	}

}

function docu_viewerConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_DOCU_VIEWER_ADMIN_TITLE);
	$menu->InsertEntry (_DOCU_VIEWER_ADMIN_TITLE, $opnConfig['opn_url'] . '/modules/docu_viewer/admin/index.php');
	$menu->InsertEntry (_DOCU_VIEWER_ADMINSETTINGS, $opnConfig['opn_url'] . '/modules/docu_viewer/admin/settings.php');
	$menu->InsertEntry (_DOCU_VIEWER_ADMIN_IMPORT, array ($opnConfig['opn_url'] . '/modules/docu_viewer/admin/index.php',
								'op' => 'import') );
	$menu->InsertEntry (_DOCU_VIEWER_ADMIN_VIEW_DB, array ($opnConfig['opn_url'] . '/modules/docu_viewer/admin/index.php',
								'op' => 'viewdb') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	$path = '';

}

function docu_viewer_import () {

	global $opnTables, $opnConfig;

	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['docu_viewer_text']);
	$boxtxt = '';
	$path = $opnConfig['docu_viewer_path'];
	if ($path != '') {
		if ( ($opnConfig['docu_viewer_ftp_url'] != '') && ($opnConfig['docu_viewer_ftp_user'] != '') && ($opnConfig['docu_viewer_ftp_passw'] != '') ) {
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ftp_real.php');
			$error = '';
			$ftp = & new opn_ftp ($error, $opnConfig['opn_ftpmode'], false);
			$ftp->host = $opnConfig['docu_viewer_ftp_url'];
			$ftp->user = $opnConfig['docu_viewer_ftp_user'];
			$ftp->pw = $opnConfig['docu_viewer_ftp_passw'];
			$ftp->port = 21;
			$ftp->pasv = 1;
			$error = '';
			$ftp->connectftpreal ($error);
			if ($error == '') {
				$ftp->cwd = @ftp_pwd ($ftp->con_id);
				$files = array ();
				get_ftp_dirs ($ftp, $path, $files, $boxtxt);
			}
		}
		if (is_array ($files) ) {
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_meta_typ.php');
			$meta_type = & new opn_meta_type;
			$boxtxt .= '<br /><br />';
			usort ($files, 'docusortitems');
			$table = & new opn_TableClass ('alternator');
			$table->AddHeaderRow (array ('', '', '') );
			$max = count ($files);
			for ($i = 0; $i< $max; $i++) {
				$id = $opnConfig['opnSQL']->get_new_number ('docu_viewer_text', 'id');
				$name = $opnConfig['opnSQL']->qstr ($files[$i]['name'], 'name');
				$file_name = $opnConfig['opnSQL']->qstr ($files[$i]['file_name'], 'file_name');
				$pos = $opnConfig['opnSQL']->qstr ($files[$i]['pos'], 'pos');
				$item = $opnConfig['opnSQL']->qstr ($files[$i]['item'], 'item');
				$ext = $opnConfig['opnSQL']->qstr ($files[$i]['ext'], 'ext');
				$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['docu_viewer_text'] . " values ($id, $name, $file_name, $pos, $item, $ext)");
				$opnConfig['opnSQL']->UpdateBlobs ($opnTables['docu_viewer_text'], 'id=' . $id);
				$table->AddDataRow (array ($meta_type->get_file_icon ($files[$i]['ext']), $files[$i]['name'], $files[$i]['pos']) );
			}
			$table->GetTable ($boxtxt);
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOCU_VIEWER_10_';
	$_display_dat['module'] = 'modules/docu_viewer';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_DOCU_VIEWER_ADMIN_TITLE, $boxtxt);

}

function docu_viewer_viewdb () {

	global $opnTables, $opnConfig;

	$boxtxt = '<script type="text/javascript">
		<!--
			function DocuToggleDisplay(id) {
				var elestyle = DocuGetElementById(id).style;

				if (elestyle.display == "block" || elestyle.display == "") {
					elestyle.display = "none";
				} else {
					elestyle.display = "block";
				}
			}

			function DocuGetElementById(id) {
				if (document.getElementById(id)) {
					return document.getElementById(id);
				} else if (document.all[id]) {
					return document.all[id];
				} else if (document.layers && document.layers[id]) {
					return (document.layers[id]);
				} else {
					return false;
				}
			}
		-->
		</script>';
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
	$file = & new opnFile;
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.code_macro.php');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.code_filter.php');
	$macro_class = & new OPN_code_macro (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . '');
	$filter_class = & new OPN_code_filter (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . '');
	$option = array ();
	$option['image_url'] = $opnConfig['datasave']['docu_viewer_cache']['url'];
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array ('', '') );
	$result = $opnConfig['database']->Execute ('SELECT name, file_name, pos, item, ext FROM ' . $opnTables['docu_viewer_text'] . ' ORDER BY pos, ext');
	while (! $result->EOF) {
		$name = $result->fields['name'];
		$file_name = $result->fields['file_name'];
		$pos = $result->fields['pos'];
		$item = $result->fields['item'];
		$ext = $result->fields['ext'];
		$link = $item;
		if ($ext == 'txt') {
			$filename = $opnConfig['datasave']['docu_viewer_cache']['path'] . $file_name;
			$data = $file->read_file ($filename);
			opn_nl2br ($data);
			$name = str_replace ('.txt', '', $name);
			$data = preg_replace ('/\[BILD]\[(.|..)]/', '<img src="' . $opnConfig['datasave']['docu_viewer_cache']['url'] . '/' . $item . '.' . $name . '[\1].png' . '" border="0" />', $data);
			$name = '';
			$name .= $data;
			$item = '';
			$name = $macro_class->ParseText ($name, $option);
			$name = $filter_class->getParsedText ($name);
		}
		if ( ($ext != 'png') && ($ext != 'jpg') && ($ext != 'db') ) {
			if ($ext == '') {
				$clean_item = str_replace ('.', '', $item);
				$item = '<a href="javascript:DocuToggleDisplay(\'item' . $clean_item . '\')">' . $item . '</a>';
			} else {
				$clean_item = str_replace ('.', '', $link);
				$name = '<span id="item' . $clean_item . '" style="display: none">' . $name . '</span>';
			}
			$table->AddDataRow (array ($item, $name) );
		}
		$result->MoveNext ();
	}
	// while
	$result->Close ();
	$table->GetTable ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOCU_VIEWER_20_';
	$_display_dat['module'] = 'modules/docu_viewer';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_DOCU_VIEWER_ADMIN_TITLE, $boxtxt);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'viewdb':
		docu_viewerConfigHeader ();
		docu_viewer_viewdb ();
		break;
	case 'import':
		docu_viewerConfigHeader ();
		docu_viewer_import ();
		break;
	default:
		docu_viewerConfigHeader ();
		break;
}
$opnConfig['opnOutput']->DisplayFoot ();

?>