<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function download_set_edit_link ($lid, $cssclass = 'opncenterbox') {

	global $opnConfig;

	$boxtxt = '';
	if ($opnConfig['permission']->HasRight ('modules/download', _PERM_ADMIN, true) ) {
		$boxtxt .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/download/admin/index.php',
										'op' => 'downloadsModLink',
										'lid' => $lid), $cssclass );
	}
	return $boxtxt;

}

function get_filesize ($size) {

	$size = max (0, $size);
	$u = array ('&nbsp;B',
		'KB',
		'MB',
		'GB');
	for ($i = 0; $size >= 1024 && $i<4; $i++) {
		$size /= 1024;
	}
	return number_format ($size, 1) . ' ' . $u[$i];

}

function download_menu ($mainlink) {

	global $opnConfig;
	if ($opnConfig['download_nav'] != 1) {
		$boxtxt = '<div align="center" class="opncenterbox">';
		if ($mainlink>0) {
			$boxtxt .= theme_boxi ($opnConfig['opn_url'] . '/modules/download/index.php', _DOW_DOWNLOADMAIN, '', '');
			$boxtxt .= '&nbsp;';
		}
		if ($opnConfig['permission']->HasRight ('modules/download', _PERM_WRITE, true) ) {
			$boxtxt .= theme_boxi ($opnConfig['opn_url'] . '/modules/download/index.php?op=AddLink', _DOW_ADDDOWN, '', '');
			$boxtxt .= '&nbsp;';
		}
		$boxtxt .= theme_boxi ($opnConfig['opn_url'] . '/modules/download/index.php?op=NewLinks', _DOW_NEWDOWN, '', '');
		$boxtxt .= '&nbsp;';
		$boxtxt .= theme_boxi ($opnConfig['opn_url'] . '/modules/download/index.php?op=MostPopular', _DOW_POPDOWN, '', '');
		$boxtxt .= '&nbsp;';
		$boxtxt .= theme_boxi ($opnConfig['opn_url'] . '/modules/download/index.php?op=TopRated', _DOW_TOPRDOWN, '', '');
		$boxtxt .= '</div>';
		$boxtxt .= '<br />';
		return $boxtxt;
	}
	return '';

}

function download_SearchForm () {

	global $opnConfig, $query;

	$help = '<div class="centertag">';
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_DOWNLOAD_400_', 'download');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/download/index.php?op=search') );
	$form->AddTextfield ('query', 30, 0, $query);
	$form->AddText (' ');
	$form->AddSubmit ('submit', _DOW_SEARCH);
	$form->AddFormEnd ();
	$form->GetFormular ($help);
	$help .= '</div>';
	return $help;

}

#function download_linkinfomenu($lid, $ttitle) {

function download_linkinfomenu ($lid) {

	global $opnConfig;

	$hlp = '<span class="normaltext"> <a class="txtbutton" href="javascript:history.back()">' . _DOW_PREVIOUS . '</a> ';
	if ($opnConfig['permission']->HasRight ('modules/download', _DOWNLOAD_PERM_MODDOWNLOAD, true) ) {
		$hlp .= '<a class="txtbutton" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
									'op' => 'modifylinkrequest',
									'lid' => $lid) ) . '">' . _DOW_MODIFY . '</a>';
	}
	if ($opnConfig['permission']->HasRight ('modules/download', _DOWNLOAD_PERM_BROKENDOWNLOAD, true) ) {
		$hlp .= ' <a class="txtbutton" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
									'op' => 'brokenlink',
									'lid' => $lid) ) . '">' . _DOW_RPORTBROKLINK . '</a>';
	}
	$hlp .= ' <a class="txtbutton" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
								'op' => 'ratelink',
								'lid' => $lid) ) . '">' . _DOW_VOTEDL . '</a>
		</span><br />';
	return $hlp;

}

function download_index ($downcat, $mf) {

	global $opnConfig, $opnTables;

	$downcat_ftp = & new opn_categorienav ('download', 'downloads_categories_dir', 'downloads_votedata');
	$downcat_ftp->SetModule ('modules/download');
	$downcat_ftp->SetImagePath ($opnConfig['datasave']['download_cat']['url']);
	$downcat_ftp->SetItemID ('did');
	$downcat_ftp->SetItemLink ('cid');
	$downcat_ftp->SetColsPerRow ($opnConfig['downloads_cats_per_row']);
	$downcat_ftp->SetSubCatLink ('index.php?op=viewlink&cid=%s');
	$downcat_ftp->SetSubCatLinkVar ('cid');
	$downcat_ftp->SetMainpageScript ('index.php');
	$downcat_ftp->SetScriptname ('index.php');
	$downcat_ftp->SetScriptnameVar (array ('op' => 'viewlink') );
	$downcat_ftp->SetMainpageTitle (_DOW_DOWNLOADMAIN);
	$boxtxt = download_menu (0);
	$boxtxt .= download_SearchForm ();
	$boxtxt .= '<br /><br />';
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$hlptxt = $downcat->MainNavigation ();
	$downcat_ftp->SetItemWhere ('user_group IN (' . $checkerlist . ')');
	$hlptxt_ftp = $downcat_ftp->MainNavigation ();
	if ($hlptxt != '') {
		$boxtxt .= $hlptxt;
		$numrows = $mf->GetItemCount ();
		$boxtxt .= '<br /><br /><div align="center" class="normaltext">' . _DOW_THEREARE . ' ' . $numrows . '&nbsp;' . _DOW_LINKSINDB . '</div>';
	}
	if ($hlptxt_ftp != '') {
		$boxtxt .= '<br /><br />';
		$boxtxt .= '<div align="center" class="normaltext">' . _DOW_EXT_LINKS . '</div>';
		$boxtxt .= '<br /><br />';
		$boxtxt .= $hlptxt_ftp;
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_410_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
	$mf->itemwhere = '';

}

function download_AddLink () {

	global $opnConfig, $mf;

	$boxtxt = download_menu (1);
	if ($opnConfig['permission']->HasRight ('modules/download', _PERM_WRITE, true) ) {
		$boxtxt .= '&bull; ' . _DOW_NOTICE1 . '<br />&bull; ' . _DOW_NOTICE2 . '<br />&bull; ' . _DOW_NOTICE3 . '<br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_DOWNLOAD_420_', 'download');
		if ($opnConfig['permission']->HasRight ('modules/download', _DOWNLOAD_PERM_UPLOAD, true) ) {
			$form->Init ($opnConfig['opn_url'] . '/modules/download/index.php', 'post', '', 'multipart/form-data');
		} else {
			$form->Init ($opnConfig['opn_url'] . '/modules/download/index.php');
		}
		$form->Init ($opnConfig['opn_url'] . '/modules/download/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('title', _DOW_DOWNNAME);
		$form->AddTextfield ('title', 50, 100);
		$form->AddChangeRow ();
		$form->AddLabel ('url', _DOW_PAGEURL);
		$form->AddTextfield ('url', 50, 200, 'http://');
		$form->AddChangeRow ();
		$form->AddLabel ('downloadurl', _DOW_DOWNURL);
		$form->AddTextfield ('downloadurl', 50, 200, 'http://');
		$form->AddChangeRow ();
		$form->AddLabel ('author', _DOW_AUTOR);
		$form->AddTextfield ('author', 50, 60);
		$form->AddChangeRow ();
		$form->AddLabel ('version', _DOW_DLVERSION);
		$form->AddTextfield ('version', 50, 60);
		$form->AddChangeRow ();
		$form->AddLabel ('language', _DOW_LANG);
		$form->AddTextfield ('language', 50, 60);
		$form->AddChangeRow ();
		$form->AddLabel ('os', _DOW_OS);
		$form->AddTextfield ('os', 50, 60);
		$form->AddChangeRow ();
		$form->AddLabel ('filesize', _DOW_FILESIZE);
		$form->AddTextfield ('filesize', 50, 50);
		$form->AddChangeRow ();
		$form->AddLabel ('softwareart', _DOW_SOFTART);
		$form->AddTextfield ('softwareart', 50, 100);
		$form->AddChangeRow ();
		$form->AddLabel ('cid', _DOW_CATE);
		$mf->makeMySelBox (0, $form);
		$form->AddChangeRow ();
		$form->AddLabel ('description', _DOW_DESCRIPT);
		$form->Addtextarea ('description');
		if ($opnConfig['permission']->IsUser () ) {
			$userinfo = $opnConfig['permission']->GetUserinfo ();
			$uname = $userinfo['uname'];
			$uemail = $userinfo['email'];
		} else {
			$uname = '';
			$uemail = '';
		}
		if ($opnConfig['permission']->HasRight ('modules/download', _DOWNLOAD_PERM_UPLOAD, true) ) {
			$form->AddChangeRow ();
			$form->AddLabel ('userupload', _DOW_UPLOAD);
			$form->AddFile ('userupload');
		}
		$form->AddChangeRow ();
		$form->AddLabel ('name', _DOW_YOURNAME);
		$form->AddTextfield ('name', 30, 60, $uname);
		$form->AddChangeRow ();
		$form->AddLabel ('email', _DOW_YOUREMAIL);
		$form->AddTextfield ('email', 30, 60, $uemail);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('op', 'Add');
		if (!$opnConfig['permission']->HasRight ('modules/download', _DOWNLOAD_PERM_UPLOAD, true) ) {
			$form->AddHidden ('userupload', 'none');
		}
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _DOW_ADDURL);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	} else {
		$boxtxt .= '<div class="centertag">' . _DOW_NOTLOGIN . '<br />' . _DOW_NOTLOGIN1 . '<br /><br />' . '<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _DOW_REGFORACC . '</a></div>';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_430_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->EnableJavaScript ();
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function download_Add () {

	global $opnConfig, $opnTables;

	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$downloadurl = '';
	get_var ('downloadurl', $downloadurl, 'form', _OOBJ_DTYPE_URL);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$version = '';
	get_var ('version', $version, 'form', _OOBJ_DTYPE_CLEAN);
	$language = '';
	get_var ('language', $language, 'form', _OOBJ_DTYPE_CLEAN);
	$os = '';
	get_var ('os', $os, 'form', _OOBJ_DTYPE_CLEAN);
	$filesize = '';
	get_var ('filesize', $filesize, 'form', _OOBJ_DTYPE_CLEAN);
	$softwareart = '';
	get_var ('softwareart', $softwareart, 'form', _OOBJ_DTYPE_CLEAN);
	$userupload = 'none';
	get_var ('userupload', $userupload, 'file');
	$userupload = check_upload ($userupload);
	if ($userupload != 'none') {
		require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
		$upload = & new file_upload_class;
		$upload->max_filesize ($opnConfig['download_upload_size']);
		if ($upload->upload ('userupload', '', '') ) {
			if ($upload->save_file ($opnConfig['datasave']['download_downloads']['path'], 3) ) {
				$filename = $upload->file['name'];
			}
		}
		if (isset ($upload->errors) ) {
			foreach ($upload->errors as $var) {
				echo '<br /><br />' . $var . '<br />';
				exit;
			}
		} else {
			$downloadurl = $opnConfig['datasave']['download_downloads']['url'] . '/' . $filename;
		}
	}
	$downloadurl = $opnConfig['opnSQL']->qstr ($downloadurl);
	$url = $opnConfig['opnSQL']->qstr ($url);
	$numrows = 0;
	if (strtolower ($url) == "'http://'") {
		$url = "''";
	}
	if (strtolower ($downloadurl) == "'http://'") {
		$downloadurl = "''";
	} else {
		$downloadurl = $opnConfig['opnSQL']->qstr ($downloadurl);
		$result = &$opnConfig['database']->Execute ('SELECT COUNT(lid) AS counter FROM ' . $opnTables['downloads_links'] . " WHERE downloadurl=$downloadurl");
		if ($result !== false) {
			if (isset ($result->fields['counter']) ) {
				$numrows = $result->fields['counter'];
			}
			$result->Close ();
		}
	}
	if ($numrows>0) {
		$boxtxt = '';
		OpenTable ($boxtxt);
		$boxtxt .= download_menu (1);
		$boxtxt .= download_SearchForm ();
		$boxtxt .= '<div class="alerttext" align="center"';
		$boxtxt .= _DOW_ALREADYINDB . '</div><br /><br />';
		CloseTable ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_440_';
		$_display_dat['module'] = 'modules/download';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
	} else {
		if ($opnConfig['permission']->IsUser () ) {
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$name = $cookie['uname'];
		}
		$boxtxt = '';
		// Check if Title exist
		if ($title == '') {
			$boxtxt .= '<br />';
			OpenTable ($boxtxt);
			$boxtxt .= download_menu (1);
			$boxtxt .= download_SearchForm ();
			$boxtxt .= '<div class="alerttext" align="center">';
			$boxtxt .= _DOW_NOTITLEIN . '</div><br /><br />';
			CloseTable ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_450_';
			$_display_dat['module'] = 'modules/download';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
			exit;
		}
		// Check if URL exist
		if ($downloadurl == "''") {
			$boxtxt .= '<br />';
			OpenTable ($boxtxt);
			$boxtxt .= download_menu (1);
			$boxtxt .= download_SearchForm ();
			$boxtxt .= '<div class="alerttext" align="center">';
			$boxtxt .= _DOW_NOURLIN . '</div><br /><br />';
			CloseTable ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_460_';
			$_display_dat['module'] = 'modules/download';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
			exit;
		}
		// Check if Description exist
		if ($description == '') {
			$boxtxt .= '<br />';
			OpenTable ($boxtxt);
			$boxtxt .= download_menu (1);
			$boxtxt .= download_SearchForm ();
			$boxtxt .= '<div class="alerttext" align="center">';
			$boxtxt .= _DOW_NODESCIN . '</div><br /><br />';
			CloseTable ($boxtxt);
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_470_';
			$_display_dat['module'] = 'modules/download';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
			exit;
		}
		$title = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($title, true, true, 'nohtml') );
		$description = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($description, true, true), 'description');
		$name = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($name, true, true, 'nohtml') );
		$email = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($email, true, true, 'nohtml') );
		$author = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($author, true, true, 'nohtml') );
		$version = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($version, true, true, 'nohtml') );
		$language = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($language, true, true, 'nohtml') );
		$os = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($os, true, true, 'nohtml') );
		$filesize = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($filesize, true, true, 'nohtml') );
		$softwareart = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($softwareart, true, true, 'nohtml') );
		$lid = $opnConfig['opnSQL']->get_new_number ('downloads_newlink', 'lid');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['downloads_newlink'] . " values ($lid, $cid, $title, $url, $description, $name, $email, $name, $downloadurl, $author ,$version ,$language ,$os ,$filesize ,$softwareart)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['downloads_newlink'], 'lid=' . $lid);
		$boxtxt .= '<br />';
		OpenTable ($boxtxt);
		$boxtxt .= download_menu (1);
		$boxtxt .= download_SearchForm ();
		$boxtxt .= '<div class="centertag"><br />';
		$boxtxt .= _DOW_WERECEIVE . '<br />';
		$boxtxt .= _DOW_YOURECEIVE . '<br /><br /></div>';
		CloseTable ($boxtxt);
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_480_';
		$_display_dat['module'] = 'modules/download';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
	}

}

function download_newlinks () {

	global $opnConfig, $mf;

	$newlinkshowdays = 7;
	get_var ('newlinkshowdays', $newlinkshowdays, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = download_menu (1);
	$boxtxt .= '<br />';
	$boxtxt .= '<div class="extratextbold">' . _DOW_NEWDOWNLOADS . '</div>';
	$boxtxt .= '<br />';
	$counter = 0;
	$allweeklinks = 0;
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->formatTimestamp ($now, '%Y-%m-%d');
	$opnConfig['opndate']->setTimestamp ($now);
	$opnConfig['opndate']->opnDataTosql ($now);
	$newlinkDB = '';
	while ($counter<=6) {
		$opnConfig['opndate']->sqlToopnData ($now);
		$opnConfig['opndate']->subInterval ($counter . ' DAYS');
		$opnConfig['opndate']->opnDataTosql ($newlinkDB);
		$totallinks = $mf->GetItemCount ("i.wdate LIKE '%$newlinkDB%'");
		$counter++;
		$allweeklinks = $allweeklinks+ $totallinks;
	}
	$counter = 0;
	$allmonthlinks = 0;
	$newlinkDB = '';
	while ($counter<=29) {
		$opnConfig['opndate']->sqlToopnData ($now);
		$opnConfig['opndate']->subInterval ($counter . ' DAYS');
		$opnConfig['opndate']->opnDataTosql ($newlinkDB);
		$totallinks = $mf->GetItemCount ("i.wdate LIKE '%$newlinkDB%'");
		$allmonthlinks = $allmonthlinks+ $totallinks;
		$counter++;
	}
	$boxtxt .= _DOW_TOTALNEWDL . ' - ' . $allweeklinks . ' \ ' . _DOW_LAST30DAYS . ' - ' . $allmonthlinks . '<br />' . _DOW_SHOW . ' (<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
																								'op' => 'NewLinks',
																								'newlinkshowdays' => '7') ) . '">' . _DOW_WEEK . '</a>, ' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
															'op' => 'NewLinks',
															'newlinkshowdays' => '14') ) . '">2 ' . _DOW_WEEKS . '</a>, ' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
															'op' => 'NewLinks',
															'newlinkshowdays' => '30') ) . '">30 ' . _DOW_DAYS . '</a>)' . '<br />';
	// List Last VARIABLE Days of Links
	if (!isset ($newlinkshowdays) ) {
		$newlinkshowdays = 7;
	}
	$boxtxt .= '<br /><span class="normaltextbold">' . _DOW_TOTALNEWDLFOR . ' ' . $newlinkshowdays . '&nbsp;' . _DOW_DAYS . ':</span><br /><br />';
	$counter = 0;
	$allweeklinks = 0;
	$boxtxt .= '<ul>';
	$newlinkView = '';
	$newlinkdayRaw = '';
	while ($counter<= $newlinkshowdays-1) {
		$opnConfig['opndate']->sqlToopnData ($now);
		$opnConfig['opndate']->subInterval ($counter . ' DAYS');
		$opnConfig['opndate']->opnDataTosql ($newlinkdayRaw);
		$opnConfig['opndate']->formatTimestamp ($newlinkView, _DATE_DATESTRING4);
		$totallinks = $mf->GetItemCount ("i.wdate LIKE '%$newlinkdayRaw%'");
		$counter++;
		$allweeklinks = $allweeklinks+ $totallinks;
		$boxtxt .= '<li><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
										'op' => 'NewLinksDate',
										'selectdate' => $newlinkdayRaw) ) . '">' . $newlinkView . '</a>&nbsp;( ' . $totallinks . ')</li>';
	}
	$boxtxt .= '</ul>';
	$counter = 0;
	$allmonthlinks = 0;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_490_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function download_buildtablerows ($result, &$table) {

	global $opnConfig;

	while (! $result->EOF) {
		$lid = $result->fields['lid'];
		$title = $result->fields['title'];
		$description = $result->fields['description'];
		$time = $result->fields['wdate'];
		$hits = $result->fields['hits'];
		$linkratingsummary = $result->fields['linkratingsummary'];
		$url = $result->fields['url'];
		$file_license = $result->fields['file_license'];
		$linkratingsummary = number_format ($linkratingsummary, $opnConfig['down_mainvotedecimal']);
		$table->AddOpenRow ();
		if ($opnConfig['download_opennewwindow']) {
			$mytarget = ' target="_blank"';
		} else {
			$mytarget = '';
		}
		$table->AddDataCol ($title, 'left');
		if ($opnConfig['download_ddl'] != 0) {
			if ($file_license>0) {
				$hlp = array ($opnConfig['opn_url'] . '/modules/download/index.php',
						'op' => 'download',
						'file_license' => $file_license,
						'lid' => $lid);
			} else {
				$hlp = array ($opnConfig['opn_url'] . '/modules/download/index.php',
						'op' => 'visit',
						'lid' => $lid);
			}
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl ($hlp) . '"' . $mytarget . '><img src="' . $opnConfig['opn_url'] . '/modules/download/images/dl.png" class="imgtag" alt="' . _DOW_DOWNLOAD . '" title="' . _DOW_DOWNLOAD . '" /></a>', 'center');
		}
		$table->AddDataCol ('<a class="%alternate%" href="' . $url . '" target="_blank"><img src="' . $opnConfig['opn_url'] . '/modules/download/images/homepage.png" class="imgtag" alt="' . _DOW_HOMEPAGE . '" title="' . _DOW_HOMEPAGE . '" /></a>', 'center');
		$transfertitle = str_replace (' ', '_', $title);
		$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
											'op' => 'viewlinkdetails',
											'lid' => $lid,
											'ttitle' => $transfertitle) ) . '"><img src="' . $opnConfig['opn_url'] . '/modules/download/images/details.png" alt="' . _DOW_DETAILS . '" title="' . _DOW_DETAILS .'" /></a>',
											'center');
		opn_nl2br ($description);
		$table->AddDataCol ($description, 'left');
		$opnConfig['opndate']->sqlToopnData ($time);
		$datetime = '';
		$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_LINKSDATESTRING);
		$table->AddDataCol ($datetime, 'center');
		$table->AddDataCol ($hits, 'center');
		if ($opnConfig['permission']->HasRight ('modules/download', _PERM_ADMIN, true) ) {
			$table->AddDataCol (download_set_edit_link ($lid, '%alternate%') );
		}
		$table->AddCloseRow ();
		$result->MoveNext ();
	}

}

function download_buildheaderrow (&$table) {

	global $opnConfig;

	$mycols = array (_DOW_NAMEOFDL => '20%',
			_DOW_DOWNLOADTHIS => '5%',
			_DOW_HOMEPAGE => '5%',
			_DOW_DETAILS => '15%',
			_DOW_DESCIPTION => '30%',
			_DOW_ADDED => '10%',
			_DOW_COUNTER => '5%',
			'&nbsp;' => '9%');
	if ($opnConfig['download_ddl'] == 0) {
		unset ($mycols[_DOW_DOWNLOADTHIS]);
	}
	if (!$opnConfig['permission']->HasRight ('modules/download', _PERM_ADMIN, true) ) {
		unset ($mycols['&nbsp;']);
	}
	$colname = array ();
	$colwidth = array ();
	foreach ($mycols as $mycolname => $mycolwidth) {
		$colname[] = $mycolname;
		$colwidth[] = $mycolwidth;
	}
	$table->AddCols ($colwidth);
	$table->AddHeaderRow ($colname);

}

function download_newlinksdate () {

	global $opnConfig, $opnTables, $mf;

	$selectdate = 0;
	get_var ('selectdate', $selectdate, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['opndate']->sqlToopnData ($selectdate);
	$dateView = '';
	$opnConfig['opndate']->formatTimestamp ($dateView, _DATE_DATESTRING4);
	$boxtxt = '<br />';
	$boxtxt .= download_menu (1) . '<br />';
	$newlinkDB = $selectdate;
	$totallinks = $mf->GetItemCount ("wdate LIKE '%$newlinkDB%'");
	$boxtxt .= '<span class="normaltextbold">' . $dateView . ' - ' . $totallinks . '&nbsp;' . _DOW_NEWDOWNLOADS . '</span>';
	$boxtxt .= '<br /><br />';
	$result = $mf->GetItemResult (array ('lid',
					'cid',
					'title',
					'description',
					'wdate',
					'hits',
					'linkratingsummary',
					'totalvotes',
					'totalcomments',
					'url',
					'file_license'),
					array ('i.title ASC'),
		"wdate LIKE '%$newlinkDB%'");
	$table = & new opn_TableClass ('alternator');
	download_buildheaderrow ($table);
	if ($result !== false) {
		download_buildtablerows ($result, $table);
	}
	$table->GetTable ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_500_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function TopRated () {

	global $opnConfig, $mf;

	$ratenum = 10;
	get_var ('ratenum', $ratenum, 'url', _OOBJ_DTYPE_CLEAN);
	$ratetype = 'num';
	get_var ('ratetype', $ratetype, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = download_menu (1) . '<br />';
	if ($ratenum != '' && $ratetype != '') {
		$opnConfig['download_toplinks'] = $ratenum;
		if ($ratetype == 'percent') {
			$toplinkspercentrigger = 1;
		} else {
			$toplinkspercentrigger = 0;
		}
	}
	$linkvotemin = 1;
	if ($toplinkspercentrigger == 1) {
		$toplinkspercent = $opnConfig['download_toplinks'];
		$totalratedlinks = $mf->GetItemCount ('i.linkratingsummary <> 0');
		$opnConfig['download_toplinks'] = $opnConfig['download_toplinks']/100;
		$opnConfig['download_toplinks'] = $totalratedlinks* $opnConfig['download_toplinks'];
		$opnConfig['download_toplinks'] = round ($opnConfig['download_toplinks']);
	}
	if ($toplinkspercentrigger == 1) {
		$boxtxt .= '<div class="extratextbold" align="center">' . _DOW_BESTRATEDDL . ' ' . $toplinkspercent . '% (' . _DOW_TOPOF . ' ' . $totalratedlinks . '&nbsp;' . _DOW_TOTALRATEDDL . ')</div>';
	} else {
		$boxtxt .= '<div class="extratextbold" align="center">' . _DOW_BESTRATEDDL . ' ' . $opnConfig['download_toplinks'] . ' </div>';
	}
	$boxtxt .= '<br /><br />';
	$boxtxt .= _DOW_NOTE . ': ' . $linkvotemin . '&nbsp;' . _DOW_VOTESREQUIRE . '<br />' . _DOW_SHOWTOP . ': (';
	$urlp = array ();
	$urlp[0] = $opnConfig['opn_url'] . '/modules/download/index.php';
	$urlp['op'] = 'TopRated';
	$urlp['ratetype'] = 'num';
	$urlp['ratenum'] = 10;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">10</a>, ';
	$urlp['ratenum'] = 25;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">25</a>, ';
	$urlp['ratenum'] = 50;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">50</a> | ';
	$urlp['ratetype'] = 'percent';
	$urlp['ratenum'] = 1;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">1%</a>, ';
	$urlp['ratenum'] = 50;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">5%</a>, ';
	$urlp['ratenum'] = 10;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">10%</a>)';
	$boxtxt .= '<br /><br />';
	$result = $mf->GetItemLimit (array ('lid',
					'cid',
					'title',
					'description',
					'wdate',
					'hits',
					'linkratingsummary',
					'totalvotes',
					'totalcomments',
					'url',
					'file_license'),
					array ('i.linkratingsummary DESC'),
		$opnConfig['download_toplinks'],
		'i.linkratingsummary != 0 AND i.totalvotes>=' . $linkvotemin);
	$table = & new opn_TableClass ('alternator');
	download_buildheaderrow ($table);
	if ($result !== false) {
		download_buildtablerows ($result, $table);
	}
	$table->GetTable ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_510_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function MostPopular () {

	global $opnConfig, $opnTables, $mf;

	$ratenum = 10;
	get_var ('ratenum', $ratenum, 'url', _OOBJ_DTYPE_CLEAN);
	$ratetype = 'num';
	get_var ('ratetype', $ratetype, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = download_menu (1) . '<br />';
	if ($ratenum != '' && $ratetype != '') {
		$mostpoplinks = $ratenum;
		if ($ratetype == 'percent') {
			$mostpoplinkspercentrigger = 1;
		} else {
			$mostpoplinkspercentrigger = 0;
		}
	}
	if ($ratenum == '') {
		$mostpoplinks = $opnConfig['download_toplinks'];
	}
	if ($mostpoplinkspercentrigger == 1) {
		$toplinkspercent = $mostpoplinks;
		$totalmostpoplinks = $mf->GetItemCount ('i.hits <> 0');
		$mostpoplinks = $mostpoplinks/100;
		$mostpoplinks = $totalmostpoplinks* $mostpoplinks;
		$mostpoplinks = round ($mostpoplinks);
	}
	if ($mostpoplinkspercentrigger == 1) {
		$boxtxt .= '<div class="extratextbold">' . _DOW_MOSTPOP . ' ' . $toplinkspercent . '% (' . _DOW_OFALL . ' ' . $totalmostpoplinks . '&nbsp;' . _DOW_DESC . ')</div>';
	} else {
		$boxtxt .= '<div class="extratextbold">' . _DOW_MOSTPOP . ' ' . $mostpoplinks . ' </div>';
	}
	$boxtxt .= '<br /><br />';
	$boxtxt .= '' . _DOW_SHOWTOP . ': (';
	$urlp = array ();
	$urlp[0] = $opnConfig['opn_url'] . '/modules/download/index.php';
	$urlp['op'] = 'MostPopular';
	$urlp['ratetype'] = 'num';
	$urlp['ratenum'] = 10;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">10</a>, ';
	$urlp['ratenum'] = 25;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">25</a>, ';
	$urlp['ratenum'] = 50;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">50</a> | ';
	$urlp['ratetype'] = 'percent';
	$urlp['ratenum'] = 1;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">1%</a>, ';
	$urlp['ratenum'] = 50;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">5%</a>, ';
	$urlp['ratenum'] = 10;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($urlp) . '">10%</a>)';
	$boxtxt .= '<br /><br />';
	$result = $mf->GetItemLimit (array ('lid',
					'cid',
					'title',
					'description',
					'wdate',
					'hits',
					'linkratingsummary',
					'totalvotes',
					'totalcomments',
					'url',
					'file_license'),
					array ('i.hits DESC'),
		$opnConfig['download_toplinks']);
	$table = & new opn_TableClass ('alternator');
	download_buildheaderrow ($table);
	if ($result !== false) {
		download_buildtablerows ($result, $table);
	}
	$table->GetTable ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_520_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function download_viewlink () {

	global $opnConfig, $opnTables, $downcat, $mf;

	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	if (!$cid) {
		$cid = 0;
		get_var ('cat_id', $cid, 'url', _OOBJ_DTYPE_INT);
	}
	$min = 0;
	get_var ('min', $min, 'url', _OOBJ_DTYPE_INT);
	$orderby = '';
	get_var ('orderby', $orderby, 'url', _OOBJ_DTYPE_CLEAN);
	$show = '';
	get_var ('show', $show, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = download_menu (1);
	$boxtxt .= download_SearchForm () . '<br />';
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$max = $min+ $opnConfig['download_perpage'];
	if ($orderby <> '') {
		$orderby = 'i.' . download_convertorderbyin ($orderby);
	} else {
		$orderby = 'i.title ASC';
	}
	if ($show != '') {
		$opnConfig['download_perpage'] = $show;
	} else {
		$show = $opnConfig['download_perpage'];
	}
	$downcat->SetItemWhere ('user_group IN (' . $checkerlist . ')');
	$boxtxt .= $downcat->SubNavigation ($cid);
	$totalselectedlinks = $mf->GetItemCount ('i.cid=' . $cid);
	$x = 0;
	$result = $mf->GetItemLimit (array ('lid',
					'title',
					'url',
					'description',
					'wdate',
					'hits',
					'linkratingsummary',
					'totalvotes',
					'totalcomments',
					'downloadurl',
					'file_license'),
					array ($orderby),
		$opnConfig['download_perpage'],
		'i.cid=' . $cid,
		$min);
	if ( ($result !== false) && (!$result->EOF) ) {
		if ($opnConfig['download_sort'] != 0) {
			$orderbyTrans = download_convertorderbytrans ($orderby);
			$boxtxt .= '<div class="centertag">';
			$boxtxt .= '<span class="smalltext">' . _DOW_SORTDLBY . ':&nbsp;&nbsp;';
			$urlp = array ();
			$urlp[0] = $opnConfig['opn_url'] . '/modules/download/index.php';
			$urlp['op'] = 'viewlink';
			$urlp['cid'] = $cid;
			$urlp['orderby'] = 'titleA';
			$boxtxt .= ' ' . _DOW_SORTTITLE . ' (<a class="smalltext" href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'titleD';
			$boxtxt .= '<a class="smalltext" href="' . encodeurl ($urlp) . '">D</a>)';
			$urlp['orderby'] = 'dateA';
			$boxtxt .= ' ' . _DOW_SORTDATE . ' (<a class="smalltext" href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'dateD';
			$boxtxt .= '<a class="smalltext" href="' . encodeurl ($urlp) . '">D</a>)';
			$urlp['orderby'] = 'ratingA';
			$boxtxt .= ' ' . _DOW_SORTRATE . ' (<a class="smalltext" href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'ratingD';
			$boxtxt .= '<a class="smalltext" href="' . encodeurl ($urlp) . '">D</a>)';
			$urlp['orderby'] = 'hitsA';
			$boxtxt .= ' ' . _DOW_SORTPOPO . ' (<a class="smalltext" href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'hitsD';
			$boxtxt .= '<a class="smalltext" href="' . encodeurl ($urlp) . '">D</a>)';
			$boxtxt .= '</span><br /><span class="normaltextbold">' . _DOW_SORTCURRBY . ': ' . $orderbyTrans . '</span>';
			$boxtxt .= '</div><hr />';
		}
		$boxtxt .= '<br />';
		$table = & new opn_TableClass ('alternator');
		download_buildheaderrow ($table);
		if ($result !== false) {
			download_buildtablerows ($result, $table);
		}
		$table->GetTable ($boxtxt);
	}
	// /ende-v-downloads///
	$orderby = download_convertorderbyout ($orderby);
	// Calculates how many pages exist.  Which page one should be on, etc...
	// echo "Count Result:  $totalselectedlinks<br />"; // testing lines
	$linkpagesint = ($totalselectedlinks/ $opnConfig['download_perpage']);
	$linkpageremainder = ($totalselectedlinks% $opnConfig['download_perpage']);
	if ($linkpageremainder != 0) {
		$linkpages = ceil ($linkpagesint);
		if ($totalselectedlinks<$opnConfig['download_perpage']) {
			$linkpageremainder = 0;
		}
	} else {
		$linkpages = $linkpagesint;
	}
	// Page Numbering
	if ($linkpages != 1 && $linkpages != 0) {
		$boxtxt .= '<br /><br />';
		$boxtxt .= _DOW_SELECTPAGE . ':&nbsp;&nbsp;';
		$prev = $min- $opnConfig['download_perpage'];
		if ($prev >= 0) {
			$boxtxt .= '&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
												'op' => 'viewlink',
												'cid' => $cid,
												'min' => $prev,
												'orderby' => $orderby,
												'show' => $show) ) . '">';
			$boxtxt .= '[&lt;&lt;' . _DOW_PREVIOUS . ']</a>&nbsp;';
		}
		$counter = 1;
		$currentpage = ($max/ $opnConfig['download_perpage']);
		while ($counter<= $linkpages) {
			$mintemp = ($opnConfig['download_perpage']* $counter)- $opnConfig['download_perpage'];
			if ($counter == $currentpage) {
				$boxtxt .= $counter . '&nbsp;';
			} else {
				$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
												'op' => 'viewlink',
												'cid' => $cid,
												'min' => $mintemp,
												'orderby' => $orderby,
												'show' => $show) ) . '">' . $counter . '</a>&nbsp;';
			}
			$counter++;
		}
		if ($x >= $opnConfig['download_perpage']) {
			$boxtxt .= '&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
												'op' => 'viewlink',
												'cid' => $cid,
												'min' => $max,
												'orderby' => $orderby,
												'show' => $show) ) . '">';
			$boxtxt .= '[ ' . _DOW_NEXT . ' &gt;&gt;]</a>';
		}
	}
	// /titel displayContent abfrage
	$path = '';
	$result = $opnConfig['database']->Execute ('SELECT path, click_url, ftp_url, ftp_user, ftp_passw FROM ' . $opnTables['downloads_categories_dir'] . ' WHERE (cid=' . $cid . ') AND user_group IN (' . $checkerlist . ')');
	$click_url = '';
	while (! $result->EOF) {
		$path = $result->fields['path'];
		$click_url = $result->fields['click_url'];
		$ftp_url = $result->fields['ftp_url'];
		$ftp_user = $result->fields['ftp_user'];
		$ftp_passw = $result->fields['ftp_passw'];
		$result->MoveNext ();
	}
	if ($path != '') {
		$files = array ();
		$thefilesize = array ();
		if ( ($ftp_url != '') && ($ftp_user != '') && ($ftp_passw != '') ) {
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ftp_real.php');
			$error = '';
			$ftp = & new opn_ftp ($error, $opnConfig['opn_ftpmode'], false);
			$ftp->host = $ftp_url;
			$ftp->user = $ftp_user;
			$ftp->pw = $ftp_passw;
			$ftp->port = 21;
			$ftp->pasv = 1;
			$error = '';
			$ftp->connectftpreal ($error);
			if ($error == '') {
				$ftp->cwd = @ftp_pwd ($ftp->con_id);
				$ftp_files = @ftp_nlist ($ftp->con_id, $path);
				foreach ($ftp_files as $file) {
					$isfile = @ftp_size ($ftp->con_id, $file);
					if ($isfile != '-1') {
						$file = str_replace ($path, '', $file);
						$files[] = $file;
						$thefilesize[$file] = $isfile;
					}
				}
				$ftp->close ($error);
				unset ($ftp);
			}
		} else {
			$files = get_file_list ($path);
		}
		if ($click_url == '[OPN_URL]') {
			$click_url = $opnConfig['opn_url'] . '/' . str_replace (_OPN_ROOT_PATH, '', $path);
		} elseif ($click_url == '') {
		}
		if (count ($files) ) {
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
			include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_meta_typ.php');
			$File = & new opnFile;
			$meta_type = & new opn_meta_type;
			$boxtxt .= '<br /><br />';
			usort ($files, 'strcollcase');
			$table = & new opn_TableClass ('alternator');
			$table->AddHeaderRow (array (_DOW_SOFTART, _DOW_DLLOAD, _DOW_FILESIZE) );
			$max = count ($files);
			for ($i = 0; $i< $max; $i++) {
				if (isset ($thefilesize[$files[$i]]) ) {
					$size = $thefilesize[$files[$i]];
					$url = '<a class="opncenterbox" href="' . $click_url . $files[$i] . '">' . $files[$i] . '</a>';
					$table->AddDataRow (array ($meta_type->get_file_icon ($File->get_file_ext ($files[$i]) ), $url, get_filesize ($size) ) );
				} elseif ($File->is_sane ($path . $files[$i], 1, 1, 1) ) {
					$size = $File->get_file_size ($path . $files[$i]);
					$url = '<a class="opncenterbox" href="' . $click_url . $files[$i] . '">' . $files[$i] . '</a>';
					$table->AddDataRow (array ($meta_type->get_file_icon ($File->get_file_ext ($files[$i]) ), $url, get_filesize ($size) ) );
				}
			}
			$table->GetTable ($boxtxt);
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_530_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function categorydownload_newlinkgraphic ($cat) {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$newresult = &$opnConfig['database']->SelectLimit ('SELECT wdate FROM ' . $opnTables['downloads_links'] . ' WHERE cid=' . $cat . ' and user_group IN (' . $checkerlist . ') ORDER BY wdate desc', 1);
	$time = $newresult->fields['wdate'];
	return '&nbsp;' . buildnewtag ($time);

}

function popgraphic ($hits) {

	global $opnConfig;
	if ($hits >= $opnConfig['download_popular']) {
		$boxtxt = '&nbsp;<img src="' . $opnConfig['opn_default_images'] . 'pop.gif" title="' . _DOW_POPOULAR . '" alt="' . _DOW_POPOULAR . '" />';
		return $boxtxt;
	}
	return '';

}
// Reusable Link Sorting Functions

function download_convertorderbyin ($orderby) {
	if ($orderby == 'titleA') {
		$orderby = 'title ASC';
	}
	if ($orderby == 'dateA') {
		$orderby = 'wdate ASC';
	}
	if ($orderby == 'hitsA') {
		$orderby = 'hits ASC';
	}
	if ($orderby == 'ratingA') {
		$orderby = 'linkratingsummary ASC';
	}
	if ($orderby == 'ratingD') {
		$orderby = 'linkratingsummary DESC';
	}
	if ($orderby == 'titleD') {
		$orderby = 'title DESC';
	}
	if ($orderby == 'dateD') {
		$orderby = 'wdate DESC';
	}
	if ($orderby == 'hitsD') {
		$orderby = 'hits DESC';
	}
	return $orderby;

}

function download_convertorderbytrans ($orderby) {

	$orderbyTrans = $orderby;
	if ( ($orderby == 'l.hits ASC') || ($orderby == 'i.hits ASC') ) {
		$orderbyTrans = _DOW_POPOLETOMO;
	}
	if ( ($orderby == 'l.hits DESC') || ($orderby == 'i.hits DESC') ) {
		$orderbyTrans = _DOW_POPOMOTOLE;
	}
	if ( ($orderby == 'l.linkratingsummary ASC') || ($orderby == 'i.linkratingsummary ASC') ) {
		$orderbyTrans = _DOW_RATINGLOTOHI;
	}
	if ( ($orderby == 'l.linkratingsummary DESC') || ($orderby == 'i.linkratingsummary DESC') ) {
		$orderbyTrans = _DOW_RATINGHITOLO;
	}
	if ( ($orderby == 'l.title ASC') || ($orderby == 'i.title ASC') ) {
		$orderbyTrans = _DOW_TITLEATOZ;
	}
	if ( ($orderby == 'l.title DESC') || ($orderby == 'i.title DESC') ) {
		$orderbyTrans = _DOW_TITLEZTOA;
	}
	if ( ($orderby == 'l.wdate ASC') || ($orderby == 'i.wdate ASC') ) {
		$orderbyTrans = _DOW_DATEOLDFIRST;
	}
	if ( ($orderby == 'l.wdate DESC') || ($orderby == 'i.wdate DESC') ) {
		$orderbyTrans = _DOW_DATENEWFIRST;
	}
	return $orderbyTrans;

}

function download_convertorderbyout ($orderby) {
	if ( ($orderby == 'l.hits ASC') || ($orderby == 'i.hits ASC') ) {
		$orderby = 'hitsA';
	}
	if ( ($orderby == 'l.hits DESC') || ($orderby == 'i.hits DESC') ) {
		$orderby = 'hitsD';
	}
	if ( ($orderby == 'l.linkratingsummary ASC') || ($orderby == 'i.linkratingsummary ASC') ) {
		$orderby = 'ratingA';
	}
	if ( ($orderby == 'l.linkratingsummary DESC') || ($orderby == 'i.linkratingsummary DESC') ) {
		$orderby = 'ratingD';
	}
	if ( ($orderby == 'l.title ASC') || ($orderby == 'i.title ASC') ) {
		$orderby = 'titleA';
	}
	if ( ($orderby == 'l.title DESC') || ($orderby == 'i.title DESC') ) {
		$orderby = 'titleD';
	}
	if ( ($orderby == 'l.wdate ASC') || ($orderby == 'i.wdate ASC') ) {
		$orderby = 'dateA';
	}
	if ( ($orderby == 'l.wdate DESC') || ($orderby == 'i.wdate DESC') ) {
		$orderby = 'dateD';
	}
	return $orderby;

}

function download () {

	global $opnConfig, $opnTables;

	$file_license = 0;
	get_var ('file_license', $file_license, 'url', _OOBJ_DTYPE_INT);
	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);

	$result = &$opnConfig['database']->Execute ('SELECT id,name,text FROM ' . $opnTables['downloads_license'] . ' WHERE id=' . $file_license);
	if ($result !== false) {
		$numrows = $result->RecordCount ();
	} else {
		$numrows = 0;
	}
	if ($numrows>0) {
		$text = $result->fields['text'];
		opn_nl2br ($text);
	} else {
		$text = _DOW_LICENSE_NOT_FOUND;
	}
	$boxtxt = '<br />' . $text;
	$boxtxt .= '<br /><br /><div class="centertag"><span class="normaltextbold">
		' . _DOW_LICETEXTREAD . '</span><br />' . _DOW_LICETEXTINFO . '<br /><br />';
	$table = & new opn_TableClass ('default');
	$hlp = '<a class="txtbutton" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
								'op' => 'visit',
								'lid' => $lid) ) . '">' . _DOW_PLEASEYES . '</a>&nbsp;&nbsp;';
	$hlp1 = '<a class="txtbutton" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/download/index.php') . '">' . _DOW_PLEASENO . '</a>&nbsp;&nbsp;';
	$table->AddDataRow (array ($hlp, $hlp1), array ('center', 'center') );
	$table->GetTable ($boxtxt);
	$boxtxt .= '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_540_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_LICENSE, $boxtxt);

}

function download_visit () {

	global $opnConfig, $opnTables;

	$lid = 0;
	get_var ('lid', $lid, 'both', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUserinfo ();
	$uid = $ui['uid'];
	$query = &$opnConfig['database']->SelectLimit ('SELECT id FROM ' . $opnTables['downloads_userload'] . ' WHERE (lid=' . $lid . ') AND (uid=' . $uid . ')', 1);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->Execute ('SELECT downloadurl,title FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid . ' and user_group IN (' . $checkerlist . ')');
	if (!$result->RecordCount () ) {
		$opnConfig['opnOutput']->Redirect ($opnConfig['opn_url'] . '/error.php?op=404');
		CloseTheOpnDB ($opnConfig);
	} else {
		if ($query->RecordCount () == 1) {
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['downloads_userload'] . ' set hits=hits+1 WHERE (lid=' . $lid . ') AND (uid=' . $uid . ')');
			$query->Close ();
		} else {
			$id = $opnConfig['opnSQL']->get_new_number ('downloads_userload', 'id');
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['downloads_userload'] . " (id, uid, lid, hits) values ($id,$uid,$lid,1)");
		}
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['downloads_links'] . ' SET hits=hits+1 WHERE lid=' . $lid);
		$downloadurl = $result->fields['downloadurl'];
		if ( ($downloadurl != 'http://opnautoload') && ( (substr_count ($downloadurl, 'http://')>0) OR (substr_count ($downloadurl, 'ftp://')>0) ) ) {
			$opnConfig['opnOutput']->Redirect ($downloadurl, false, true);
		} elseif ( ($downloadurl != 'http://opnautoload') && (! (substr_count ($downloadurl, 'http://')>0) ) ) {
			if (substr_count ($downloadurl, '|')>0) {
				list ($path, $filename) = explode ('|', $downloadurl);
				$downloadurl = $path . '/' . $filename;
				header ('Content-Disposition: inline; filename=' . $filename);
				header ("Content-Type: application/octet-stream");
				header ('Content-Length: ' . filesize ($downloadurl) );
				header ('Pragma: no-cache');
				header ('Expires: 0');
				$maxsplit = 4194304;
				$filesize = filesize ($downloadurl);
				$fp = fopen ($downloadurl, 'r');
				while ($filesize != 0) {
					if ($maxsplit>$filesize) {
						$size = $filesize;
						$filesize = 0;
					} else {
						$size = $maxsplit;
						$filesize -= $maxsplit;
					}
					print (fread ($fp, $size) );
				}
				fclose ($fp);
			}
		} else {
			if ( (!isset ($opnConfig['download_multiswitchtraffic']) ) OR ($opnConfig['download_multiswitchtraffic'] == 0) ) {
				$NumDL = 0;
				$DLM = array ();
				$result2 = &$opnConfig['database']->Execute ('SELECT downloadurl FROM ' . $opnTables['downloads_multiswitch'] . ' WHERE forlid=' . $lid);
				while (! $result2->EOF) {
					$DLM[$NumDL] = $result2->fields['downloadurl'];
					$NumDL++;
					$result2->MoveNext ();
				}
				for ($i = 0; $i< $NumDL; $i++) {
					$Mirror = $DLM[$i];
					// echo "berprfe Mirror $l...";
					if (preg_match ('/^http:\/\//i', $Mirror) ) {
						$UA = @parse_url ($Mirror);
						if ( (!isset ($UA['port']) ) OR (!$UA['port']) ) {
							$UA['port'] = '80';
						}
						if (!$UA['path']) {
							$UA['path'] = '/';
						}
						$sock = fsockopen ($UA['host'], $UA['port']);
						if (!$sock) {
							$ret = 'NR';
						} else {
							$dump = 'GET ' . $UA['path'] . ' HTTP/1.1' . _OPN_HTML_CRLF . 'Host: ' . $UA['host'] . _OPN_HTML_CRLF . 'Connection: close' . _OPN_HTML_CRLF . 'Connection: close' . _OPN_HTML_CRLF . _OPN_HTML_CRLF;
							fputs ($sock, $dump);
							while ($str = fgets ($sock, 1024) ) {
								if (preg_match ('/^http\/[0-9]+.[0-9]+ ([0-9]{3}) [a-z ]*/i', $str) ) {
									$ret = trim (preg_replace ('/^http\/[0-9]+.[0-9]+ ([0-9]{3}) [a-z ]*/i', '\\1', $str) );
								}
							}
							fclose ($sock);
							flush ();
						}
						$ret2 = 0;
						switch ($ret) {
							case 'NR':
								// echo 'Server gestorben';
								$ret2 = 1;
								break;
							case '404':
								// echo 'Datei ist weg';
								$ret2 = 1;
								break;
						}
						if ($ret2 != 1) {
							// echo 'Done -> <a href=$Mirror>Downloading von Mirror $l</a>';
							echo '<script>self.window.location.href="' . $Mirror . '";</script>';
							$opnConfig['opnOutput']->Redirect ('/modules/download/index.php');
						}
					}
				}
			} else {
				$result = &$opnConfig['database']->Execute ('SELECT downloadurl FROM ' . $opnTables['downloads_multiswitch'] . ' WHERE forlid=' . $lid);
				if ($result !== false) {
					$numrows = $result->RecordCount ();
				} else {
					$numrows = 0;
				}
				if ($numrows>0) {
					srand ((double)microtime ()*1000000);
					$random = rand (1, $numrows);
					$result2 = &$opnConfig['database']->Execute ('SELECT downloadurl FROM ' . $opnTables['downloads_multiswitch'] . ' WHERE forlid="' . $random);
					$url = $result2->fields['downloadurl'];
					echo '<script>self.window.location.href="' . $url . '";</script>';
					$opnConfig['opnOutput']->Redirect ('/modules/download/index.php');
				}
			}
			// if traffic opti. or not
		}
		// if autoload
	}
	// if !RecordCount.

}
// func

function download_search () {

	global $opnConfig, $opnTables, $linksresults;

	$query = '';
	get_var ('query', $query, 'both');
	$min = 0;
	get_var ('min', $min, 'both', _OOBJ_DTYPE_INT);
	$orderby = '';
	get_var ('orderby', $orderby, 'both', _OOBJ_DTYPE_CLEAN);
	$show = '';
	get_var ('show', $show, 'both', _OOBJ_DTYPE_CLEAN);
	if (!isset ($linksresults) ) {
		$linksresults = 15;
	}
	$max = $min+ $linksresults;
	if ($orderby <> '') {
		$orderby = 'l.' . download_convertorderbyin ($orderby);
	} else {
		$orderby = 'l.title ASC';
	}
	if ($show != '') {
		$linksresults = $show;
	} else {
		$show = $linksresults;
	}
	$query_org = $opnConfig['cleantext']->filter_searchtext ($query);
	$query = $opnConfig['opnSQL']->AddLike ($query);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->SelectLimit ('SELECT l.lid AS lid, l.cid AS cid, l.title AS title, l.url AS url, l.description AS description, l.wdate AS wdate, l.hits AS hits, l.linkratingsummary AS linkratingsummary, l.totalvotes AS totalvotes, l.totalcomments AS totalcomments, l.downloadurl AS downloadurl FROM ' . $opnTables['downloads_links'] . ' l, ' . $opnTables['download_cats'] . " c WHERE (l.title LIKE $query OR l.description LIKE $query) and l.cid=c.cat_id AND l.user_group IN (" . $checkerlist . ') AND c.cat_usergroup IN (' . $checkerlist . ") ORDER BY $orderby", $linksresults, $min);
	$fullcountresult = &$opnConfig['database']->Execute ('SELECT COUNT(lid) AS counter FROM ' . $opnTables['downloads_links'] . ' l, ' . $opnTables['download_cats'] . " c WHERE (l.title LIKE $query OR l.description LIKE $query) and l.cid=c.cat_id AND l.user_group IN (" . $checkerlist . ') AND c.cat_usergroup IN (' . $checkerlist . ')');
	$totalselectedlinks = $fullcountresult->fields['counter'];
	if ( ($totalselectedlinks !== false) && (isset ($fullcountresult->fields['counter']) ) ) {
		$totalselectedlinks = $fullcountresult->fields['counter'];
		$fullcountresult->Close ();
	} else {
		$totalselectedlinks = 0;
	}
	if ($result !== false) {
		$nrows = $result->RecordCount ();
	} else {
		$nrows = 0;
	}
	$resultx = &$opnConfig['database']->Execute ('SELECT COUNT(cat_id) AS counter FROM ' . $opnTables['download_cats'] . " WHERE cat_name LIKE $query AND cat_usergroup IN (" . $checkerlist . ")");
	if ( ($resultx !== false) && (isset ($resultx->fields['counter']) ) ) {
		$nrowsx = $resultx->fields['counter'];
	} else {
		$nrowsx = 0;
	}
	$x = 0;
	$boxtxt = '<br />';
	$boxtxt .= download_menu (1) . '<br />';
	$boxtxt .= download_SearchForm () . '<br />';
	$boxtxt .= '<div class="centertag">';
	if ($query != '') {
		if ($nrows>0 || $nrowsx>0) {
			$result2 = &$opnConfig['database']->Execute ('SELECT cat_id, cat_name FROM ' . $opnTables['download_cats'] . " WHERE cat_name LIKE $query AND cat_usergroup IN (" . $checkerlist . ") ORDER BY cat_name DESC");
			$boxtxt .= '<span class="extratext">' . _DOW_SEARCHRESFOR . $query_org . '</span><br /><br />';
			$boxtxt .= '</div><span class="extratextbold">' . _DOW_CATE . '</span><br /><br />' . _OPN_HTML_NL;
			if ($result2 !== false) {
				while (! $result2->EOF) {
					$cid = $result2->fields['cat_id'];
					$stitle = $result2->fields['cat_name'];
					$checkerlist = $opnConfig['permission']->GetUserGroups ();
					$res = &$opnConfig['database']->Execute ('SELECT COUNT(lid) AS summe FROM ' . $opnTables['downloads_links'] . ' WHERE cid=' . $cid . ' and user_group IN (' . $checkerlist . ')');
					if (isset ($res->fields['summe']) ) {
						$numrows = $res->fields['summe'];
					} else {
						$numrows = 0;
					}
					$opnConfig['cleantext']->hilight_text ($stitle, $query_org);
					$boxtxtinner = '<li><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
														'op' => 'viewlink',
														'cid' => $cid) ) . '">' . $stitle . '</a> (' . $numrows . ')</li>';
					$result2->MoveNext ();
				}
				if (isset ($boxtxtinner) ) {
					$boxtxt .= '<ul>' . $boxtxtinner . '</ul>';
				} else {
					$boxtxt .= '<span class="alerttext">' . _DOW_NOMATCHESFOUND . '</span><br /><br />';
				}
			}
			$boxtxt .= _OPN_HTML_NL . '<br /><span class="extratextbold">' . _DOW_DESC . '</span><br/ ><br />';
			$orderbyTrans = download_convertorderbytrans ($orderby);
			$boxtxt .= '<div class="centertag"><br />' . _DOW_SORTDLBY . ':&nbsp;&nbsp;';
			$urlp = array ();
			$urlp[0] = $opnConfig['opn_url'] . '/modules/download/index.php';
			$urlp['op'] = 'search';
			$urlp['query'] = $query_org;
			$urlp['orderby'] = 'titleA';
			$boxtxt .= _DOW_SORTTITLE . ' (<a href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'titleD';
			$boxtxt .= '<a href="' . encodeurl ($urlp) . '">D</a>)  ';
			$urlp['orderby'] = 'dateA';
			$boxtxt .= _DOW_SORTDATE . ' (<a href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'dateD';
			$boxtxt .= '<a href="' . encodeurl ($urlp) . '">D</a>)  ';
			$urlp['orderby'] = 'ratingA';
			$boxtxt .= _DOW_SORTRATE . ' (<a href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'ratingD';
			$boxtxt .= '<a href="' . encodeurl ($urlp) . '">D</a>)  ';
			$urlp['orderby'] = 'hitsA';
			$boxtxt .= _DOW_SORTPOPO . ' (<a href="' . encodeurl ($urlp) . '">A</a> | ';
			$urlp['orderby'] = 'hitsD';
			$boxtxt .= '<a href="' . encodeurl ($urlp) . '">D</a>)  ';
			$boxtxt .= '<br /><span class="normaltextbold">' . _DOW_SORTCURRBY . ': ' . $orderbyTrans . '</span></div>';
			if ($result !== false) {
				$datetime = '';
				while (! $result->EOF) {
					$lid = $result->fields['lid'];
					$cid = $result->fields['cid'];
					$title = $result->fields['title'];
					$description = $result->fields['description'];
					$time = $result->fields['wdate'];
					$hits = $result->fields['hits'];
					$linkratingsummary = $result->fields['linkratingsummary'];
					$totalvotes = $result->fields['totalvotes'];
					$totalcomments = $result->fields['totalcomments'];
					$linkratingsummary = number_format ($linkratingsummary, $opnConfig['down_mainvotedecimal']);
					$transfertitle = str_replace (' ', '_', $title);
					$opnConfig['cleantext']->hilight_text ($title, $query_org);

					# $boxtxt .= download_set_edit_link($lid);

					$boxtxt .= '<br />';
					$table = & new opn_TableClass ('default');
					$table->AddDataRow (array ('<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php', 'op' => 'viewlinkdetails', 'lid' => $lid, 'ttitle' => $transfertitle) ) . '">' . $title . '</a>' . buildnewtag ($time) . popgraphic ($hits) ) );
					$opnConfig['opndate']->sqlToopnData ($time);
					$opnConfig['opndate']->formatTimestamp ($datetime, _DATE_LINKSDATESTRING);
					if ($query_org != '') {
						$opnConfig['cleantext']->hilight_text ($description, $query_org);
					}
					opn_nl2br ($description);
					$hlp = _DOW_DESCIPTION . '<br />' . $description;
					$hlp .= '<br />' . _DOW_ADDED . ': ' . $datetime . '&nbsp;' . _DOW_DLHITS . $hits;
					// voting & comments stats
					if ($totalvotes == 1) {
						$votestring = _DOW_DLVOTE;
					} else {
						$votestring = _DOW_DLVOTES;
					}
					if ($linkratingsummary != '0' || $linkratingsummary != '0.0') {
						$hlp .= ' ' . _DOW_SORTRATE . ': ' . $linkratingsummary . ' (' . $totalvotes . ' ' . $votestring . ')';
					}
					$hlp .= '<br /><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
													'op' => 'ratelink',
													'lid' => $lid,
													'ttitle' => $transfertitle) ) . '">' . _DOW_RATETHISDL . '</a>';
					if ($totalvotes != 0) {
						$hlp .= '&nbsp;|&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
															'op' => 'viewlinkdetails',
															'lid' => $lid,
															'ttitle' => $transfertitle) ) . '">' . _DOW_DETAILS . '</a>';
					}
					if ($totalcomments != 0) {
						$hlp .= '&nbsp;|&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
															'op' => 'viewlinkdetails',
															'lid' => $lid,
															'ttitle' => $transfertitle) ) . '">' . _DOW_COMMENTS . ' (' . $totalcomments . ')</a>';
					}
					// $hlp .= detecteditorial($lid, $transfertitle);
					$result3 = &$opnConfig['database']->Execute ('SELECT cat_name FROM ' . $opnTables['download_cats'] . ' WHERE cat_id=' . $cid);
					$ctitle = $result3->fields['cat_name'];
					$hlp .= '<br />' . _DOW_CATE . $ctitle . '<br /><br />';
					$table->AddDataRow (array ($hlp) );
					$table->GetTable ($boxtxt);
					$boxtxt .= '<br />';
					$x++;
					$result->MoveNext ();
				}
			}
			$orderby = download_convertorderbyout ($orderby);
		} else {
			$boxtxt .= '<div class="alerttext" align="center">' . _DOW_NOMATCHESFOUND . '</div><br /><br />';
		}
		// Calculates how many pages exist.  Which page one should be on, etc...
		// echo "Count Result:  $totalselectedlinks<br />";			# testing lines
		if ($linksresults <> 0) {
			$linkpagesint = ($totalselectedlinks/ $linksresults);
			$linkpageremainder = ($totalselectedlinks% $linksresults);
		} else {
			$linkpagesint = 0;
			$linkpageremainder = 0;
		}
		if ($linkpageremainder != 0) {
			$linkpages = ceil ($linkpagesint);
			if ($totalselectedlinks<$linksresults) {
				$linkpageremainder = 0;
			}
		} else {
			$linkpages = $linkpagesint;
		}
		// Page Numbering
		if ($linkpages != 1 && $linkpages != 0) {
			$boxtxt .= '<br /><br />';
			$boxtxt .= _DOW_SELECTPAGE . ':&nbsp;&nbsp;';
			$prev = $min- $linksresults;
			if ($prev >= 0) {
				$boxtxt .= '&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
													'op' => 'search',
													'query' => $query_org,
													'min' => $prev,
													'orderby' => $orderby,
													'show' => $show) ) . '">';
				$boxtxt .= '[&lt;&lt; ' . _DOW_PREVIOUS . ' ]</a>&nbsp;';
			}
			$counter = 1;
			$currentpage = ($max/ $linksresults);
			while ($counter<= $linkpages) {
				$mintemp = ($opnConfig['download_perpage']* $counter)- $linksresults;
				if ($counter == $currentpage) {
					$boxtxt .= $counter . '&nbsp;';
				} else {
					$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
													'op' => 'search',
													'query' => $query_org,
													'min' => $mintemp,
													'orderby' => $orderby,
													'show' => $show) ) . '">' . $counter . '</a>&nbsp;';
				}
				$counter++;
			}
			if ($x >= $opnConfig['download_perpage']) {
				$boxtxt .= '&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
													'op' => 'search',
													'query' => $query_org,
													'min' => $max,
													'orderby' => $orderby,
													'show' => $show) ) . '">';
				$boxtxt .= '[ ' . _DOW_NEXT . ' &gt;&gt;]</a>';
			}
		}
		$boxtxt .= '<br /><br /><div class="centertag">' . _DOW_TRYTOSEARCH . ' "' . $query_org . '" ' . _DOW_INOTHERENGINE . '<br />' . '<a href="http://www.google.com/search?q=' . $query_org . '" target="_blank">Google</a> -' . ' <a href="http://www.altavista.com/cgi-bin/query?pg=q&amp;sc=on&amp;hl=on&amp;act=2006&amp;par=0&amp;q=' . $query_org . '&amp;kl=XX&amp;stype=stext" target="_blank">Alta Vista</a> -' . ' <a href="http://www.lycos.com/cgi-bin/pursuit?query=' . $query_org . '&amp;maxhits=20" target="_blank">Lycos</a> -' . ' <a href="http://search.yahoo.com/bin/search?p=' . $query_org . '" target="_blank">Yahoo</a> -' . ' <a href="http://srch.overture.com/d/search/p/go/?Partner=go_home&amp;Keywords=' . $query_org . '&amp;Go=Search" target="_blank">Infoseek</a> -' . ' <a href="http://www.dejanews.com/dnquery.xp?QRY=' . $query_org . '" target="_blank">Deja News</a> -' . ' <a href="http://www.hotbot.com/?MT=' . $query_org . '&amp;DU=days&amp;SW=web" target="_blank">HotBot</a>' . '<br />' . '<a href="http://www.linuxapps.com/?page=search&amp;search=' . $query_org . '" target="_blank">LinuxStart</a> -' . ' <a href="http://search.1stlinuxsearch.com/compass?scope=' . $query_org . '&amp;ui=sr" target="_blank">1stLinuxSearch</a> -' . ' <a href="http://www.linuxlinks.com/cgi-bin/search.cgi?query=' . $query_org . '&amp;engine=Links" target="_blank">LinuxLinks</a> -' . ' <a href="http://www.freshmeat.net/search/?q=' . $query_org . '" target="_blank">Freshmeat</a> -' . ' <a href="http://linuxtoday.com/search.php3?query=' . $query_org . '" target="_blank">Linux Today</a>' . '</div>';
	} else {
		$boxtxt .= '<div class="alerttext" align="center">' . _DOW_NOMATCHESFOUND . '</div><br /><br />';
	}
	// $boxtxt .= '</td></tr></table>'._OPN_HTML_NL;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_550_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function detecteditorial ($lid, $ttitle) {

	global $opnConfig, $opnTables;

	$resulted2 = &$opnConfig['database']->Execute ('SELECT adminid FROM ' . $opnTables['downloads_editorials'] . ' WHERE linkid=' . $lid);
	if ($resulted2 !== false) {
		$recordexist = $resulted2->RecordCount ();
	} else {
		$recordexist = 0;
	}
	// if returns 'bad query' status 0 (add editorial)
	if ($recordexist != 0) {
		return ' | <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
										'op' => 'viewlinkeditorial',
										'lid' => $lid,
										'ttitle' => $ttitle) ) . '">' . _DOW_EDITORIAL . '</a>';
	}
	return '';

}

function linkfooter ($lid, $ttitle) {

	global $opnConfig;

	$ttitle = str_replace (' ', '_', $ttitle);
	$boxtxt = '<div class="centertag"><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
												'op' => 'visit',
												'lid' => $lid) ) . '">' . _DOW_VISITTHESITE . '</a>  |  ' . '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
															'op' => 'ratelink',
															'lid' => $lid,
															'ttitle' => $ttitle) ) . '">' . _DOW_RATETHISDL . '</a></div><br />';
	$boxtxt .= linkfooterchild ($lid);
	return $boxtxt;

}

function linkfooterchild ($lid) {

	global $opnConfig;
	if ($opnConfig['download_useoutsidevoting'] != 0) {
		return '<br /><div class="centertag"><hr size="1" noshade="noshade" />' . _DOW_ISTHISYOURRES . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
																				'op' => 'outsidelinksetup',
																				'lid' => $lid) ) . '">' . _DOW_ALLOWUSERTORATE . '</a></div>';
	}
	return '';

}

function brokenlink () {

	global $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = download_menu (1);
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$ratinguser = $cookie['uname'];
	} else {
		$ratinguser = $opnConfig['opn_anonymous_name'];
	}
	$boxtxt .= '<br /><div class="extratextbold" align="center">' . _DOW_REPORTBROKENDL . '</div><br /><br /><br />';
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_DOWNLOAD_560_', 'download');
	$form->Init ($opnConfig['opn_url'] . '/modules/download/index.php');
	$form->AddHidden ('lid', $lid);
	$form->AddHidden ('modifysubmitter', $ratinguser);
	$form->AddText ('<div align="center" class="normaltext">' . _DOW_THANKS1 . '<br />' . _DOW_THANKS2 . '<br /><br />');
	$form->AddHidden ('op', 'brokenlinkS');
	$form->AddSubmit ('submit', _DOW_SUBMITBROKENDL);
	$form->AddText ('</div>');
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_570_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function brokenlinkS () {

	global $opnConfig, $opnTables;

	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$modifysubmitter = '';
	get_var ('modifysubmitter', $modifysubmitter, 'form', _OOBJ_DTYPE_CLEAN);
	$requestid = $opnConfig['opnSQL']->get_new_number ('downloads_modrequest', 'requestid');
	$_modifysubmitter = $opnConfig['opnSQL']->qstr ($modifysubmitter);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['downloads_modrequest'] . " values ($requestid, $lid, 0, '', '', '', $_modifysubmitter, 1, '')");
	$boxtxt = '<br />';
	$boxtxt .= download_menu (1);
	$boxtxt .= '<br /><div class="extratextbold" align="center">' . _DOW_REPORTBROKENDL . '</div><br />';
	$boxtxt .= '<br /><br /><div class="centertag">' . _DOW_THANKS3 . '</div>';
	if ($opnConfig['download_notify']) {
		$email = $opnConfig['download_notify_email'];
		$from = $opnConfig['download_notify_from'];
		$message = $opnConfig['download_notify_message'] . _OPN_HTML_NL;
		$subject = $opnConfig['download_notify_subject'];
		$mail = & new opn_mailer ();
		$mail->opn_mail_fill ($email, $subject, '', '', $message, $from, $email, true);
		$mail->send ();
		$mail->init ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_580_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function modifylinkrequest () {

	global $opnConfig, $opnTables, $mf;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$ratinguser = $cookie['uname'];
	} else {
		$ratinguser = $opnConfig['opn_anonymous_name'];
	}
	$boxtxt = download_menu (1);
	$boxtxt .= '<br />';
	$blocknow = 0;
	$blockunregmodify = 0;
	if ($blockunregmodify == 1 && $ratinguser == $opnConfig['opn_anonymous_name']) {
		$boxtxt .= '<br /><br /><div class="centertag">' . _DOW_MESSAGEK . '</div>';
		$blocknow = 1;
	}
	if ($blocknow != 1) {
		$checkerlist = $opnConfig['permission']->GetUserGroups ();
		$result = &$opnConfig['database']->Execute ('SELECT cid, title, url, description, downloadurl FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid . ' and user_group IN (' . $checkerlist . ')');
		$boxtxt .= '<span class="extratextbold">' . _DOW_REQUESTLINKMODI . '</span><br /><br />' . _OPN_HTML_NL;
		while (! $result->EOF) {
			$cid = $result->fields['cid'];
			$title = $result->fields['title'];
			$url = $result->fields['url'];
			$description = $result->fields['description'];
			$downloadurl = $result->fields['downloadurl'];
			$form = & new opn_FormularClass ('listalternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_DOWNLOAD_590_', 'download');
			$form->Init ($opnConfig['opn_url'] . '/modules/download/index.php');
			$form->AddTable ();
			$form->AddCols (array ('10%', '90%') );
			$form->AddOpenRow ();
			$form->AddText (_DOW_DOWNID);
			$form->AddText ($lid);
			$form->AddChangeRow ();
			$form->AddLabel ('title', _DOW_DOWNNAME);
			$form->AddTextfield ('title', 50, 100, $title);
			$form->AddChangeRow ();
			$form->AddText ('downloadurl', _DOW_DOWNURL);
			$form->AddTextfield ('downloadurl', 50, 200, $downloadurl);
			$form->AddChangeRow ();
			$form->AddLabel ('url', _DOW_PAGEURL);
			$form->AddTextfield ('url', 50, 200, $url);
			$form->AddChangeRow ();
			$form->AddLabel ('description', _DOW_DESCIPTION);
			$form->AddTextarea ('description', 0, 0, '', $description);
			$form->AddChangeRow ();
			$form->AddLabel ('cid', _DOW_CATE);
			$mf->makeMySelBox ($cid, $form, 0, 'cid');
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('lid', $lid);
			$form->AddHidden ('modifysubmitter', $ratinguser);
			$form->AddHidden ('op', 'modifylinkrequestS');
			$form->SetEndCol ();
			$form->AddSubmit ('submit', _DOW_SENDREQUEST);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
			$boxtxt .= '<br />';
			$result->MoveNext ();
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_600_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function modifylinkrequestS () {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$modifysubmitter = '';
	get_var ('modifysubmitter', $modifysubmitter, 'form', _OOBJ_DTYPE_CLEAN);
	$downloadurl = '';
	get_var ('downloadurl', $downloadurl, 'form', _OOBJ_DTYPE_URL);
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$ratinguser = $cookie['uname'];
	} else {
		$ratinguser = $opnConfig['opn_anonymous_name'];
	}
	$blocknow = 0;
	$blockunregmodify = 0;
	if ($blockunregmodify == 1 && $ratinguser == $opnConfig['opn_anonymous_name']) {
		$boxtxt = '<br />';
		$boxtxt .= download_menu (1);
		$boxtxt .= '<br /><div class="extratextbold" align="center">' . _DOW_REPORTMODIFYDL . '</div><br />';
		$boxtxt .= '<br /><br /><div class="centertag">' . _DOW_MESSAGEK . '</div>';
		if ($opnConfig['download_notify']) {
			$email = $opnConfig['download_notify_email'];
			$from = $opnConfig['download_notify_from'];
			$message = $opnConfig['download_notify_message'] . _OPN_HTML_NL;
			$subject = $opnConfig['download_notify_subject'];
			$mail = & new opn_mailer ();
			$mail->opn_mail_fill ($email, $subject, '', '', $message, $from, $email, true);
			$mail->send ();
			$mail->init ();
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_610_';
		$_display_dat['module'] = 'modules/download';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
		$blocknow = 1;
	}
	if ($blocknow != 1) {
		$title = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($title, true, true, 'nohtml') );
		$url = $opnConfig['opnSQL']->qstr ($url);
		$description = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($description, true, true), 'description');
		$downloadurl = $opnConfig['opnSQL']->qstr ($downloadurl);
		$requestid = $opnConfig['opnSQL']->get_new_number ('downloads_modrequest', 'requestid');
		$_modifysubmitter = $opnConfig['opnSQL']->qstr ($modifysubmitter);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['downloads_modrequest'] . " values ($requestid, $lid, $cid, $title, $url, $description, $_modifysubmitter, 0, $downloadurl)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['downloads_modrequest'], 'requestid=' . $requestid);
		$boxtxt .= '<br />';
		$boxtxt .= download_menu (1);
		$boxtxt .= '<br /><div class="extratextbold" align="center">' . _DOW_REPORTMODIFYDL . '</div><br />';
		$boxtxt .= '<br /><br /><div class="centertag">' . _DOW_THANKS3 . '</div>';
		if ($opnConfig['download_notify']) {
			$email = $opnConfig['download_notify_email'];
			$from = $opnConfig['download_notify_from'];
			$message = $opnConfig['download_notify_message'] . _OPN_HTML_NL;
			$subject = $opnConfig['download_notify_subject'];
			$mail = & new opn_mailer ();
			$mail->opn_mail_fill ($email, $subject, '', '', $message, $from, $email, true);
			$mail->send ();
			$mail->init ();
		}
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_620_';
		$_display_dat['module'] = 'modules/download';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);
	}

}

function rateinfo () {

	global $opnConfig, $opnTables;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['downloads_links'] . ' SET hits=hits+1 WHERE lid=' . $lid);
	$result = $opnConfig['database']->Execute ('SELECT url FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid . ' and user_group in (' . $checkerlist . ')');
	$url = $result->fields['url'];
	$opnConfig['opnOutput']->Redirect ($url);

}

function addrating () {

	global $opnConfig, $opnTables;

	$ratinglid = 0;
	get_var ('ratinglid', $ratinglid, 'form', _OOBJ_DTYPE_INT);
	$ratinguser = '';
	get_var ('ratinguser', $ratinguser, 'form', _OOBJ_DTYPE_CLEAN);
	$rating = '';
	get_var ('rating', $rating, 'form', _OOBJ_DTYPE_CLEAN);
	$ratingcomments = '';
	get_var ('ratingcomments', $ratingcomments, 'form', _OOBJ_DTYPE_CHECK);
	$passtest = 'yes';
	$boxtxt = '<div class="centertag">';
	$boxtxt .= completevoteheader ();
	// !!if ($ratinguser != "outside") then...  determine anon or reg and write reg.  DON'T pass it in.  Bad idea.
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$ratinguser = $cookie['uname'];
	} elseif ($ratinguser == 'outside') {
		$ratinguser = 'outside';
	} else {
		$ratinguser = $opnConfig['opn_anonymous_name'];
	}
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$results3 = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $ratinglid . ' and user_group IN (' . $checkerlist . ')');
	$title = $results3->fields['title'];
	// Make sure only 1 anonymous from an IP in a single day.
	$anonwaitdays = 1;
	$outsidewaitdays = 1;
	$ip = get_real_IP ();
	// }
	// Check if Rating is Null
	if ($rating == '--') {
		$error = 'nullerror';
		$boxtxt .= completevote ($error);
		$passtest = 'no';
	}
	// Check if Link POSTER is voting (UNLESS Anonymous users allowed to post)
	if ($ratinguser != $opnConfig['opn_anonymous_name'] && $ratinguser != 'outside') {
		$checkerlist = $opnConfig['permission']->GetUserGroups ();
		$result = &$opnConfig['database']->Execute ('SELECT submitter FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $ratinglid . ' and user_group IN (' . $checkerlist . ')');
		while (! $result->EOF) {
			$ratinguserDB = $result->fields['submitter'];
			if ($ratinguserDB == $ratinguser) {
				$error = 'postervote';
				$boxtxt .= completevote ($error);
				$passtest = 'no';
			}
			$result->MoveNext ();
		}
	}
	// Check if REG user is trying to vote twice.
	if ($ratinguser !== $opnConfig['opn_anonymous_name'] && $ratinguser != 'outside') {
		$result = &$opnConfig['database']->Execute ('SELECT ratinguser FROM ' . $opnTables['downloads_votedata'] . ' WHERE ratinglid=' . $ratinglid);
		while (! $result->EOF) {
			$ratinguserDB = $result->fields['ratinguser'];
			if ($ratinguserDB == $ratinguser) {
				$error = 'regflood';
				$boxtxt .= completevote ($error);
				$passtest = 'no';
			}
			$result->MoveNext ();
		}
	}
	// Check if ANONYMOUS user is trying to vote more than once per day.
	if ($ratinguser == $opnConfig['opn_anonymous_name']) {
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$_ip = $opnConfig['opnSQL']->qstr ($ip);
		$result = &$opnConfig['database']->Execute ('SELECT COUNT(ratingdbid) AS counter FROM ' . $opnTables['downloads_votedata'] . ' WHERE ratinglid=' . $ratinglid . " AND ratinguser='" . $opnConfig['opn_anonymous_name'] . "' AND ratinghostname = $_ip AND ($now-ratingtimestamp) < $anonwaitdays");
		if (isset ($result->fields['counter']) ) {
			$anonvotecount = $result->fields['counter'];
		} else {
			$anonvotecount = 0;
		}
		if ($anonvotecount >= 1) {
			$error = 'anonflood';
			$boxtxt .= completevote ($error);
			$passtest = 'no';
		}
	}
	// Check if OUTSIDE user is trying to vote more than once per day.
	if ($ratinguser == 'outside') {
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$_ip = $opnConfig['opnSQL']->qstr ($ip);
		$result = &$opnConfig['database']->Execute ('SELECT COUNT(ratingdbid) AS counter FROM ' . $opnTables['downloads_votedata'] . " WHERE ratinglid=$ratinglid AND ratinguser='outside' AND ratinghostname = $_ip AND ($now-ratingtimestamp) < $outsidewaitdays");
		if (isset ($result->fields['counter']) ) {
			$outsidevotecount = $result->fields['counter'];
		} else {
			$outsidevotecount = 0;
		}
		if ($outsidevotecount >= 1) {
			$error = 'outsideflood';
			$boxtxt .= completevote ($error);
			$passtest = 'no';
		}
	}
	// Passed Tests
	if ($passtest == 'yes') {
		$ratingcomments = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($ratingcomments, true, true), 'ratingcomments');
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$ratingdbid = $opnConfig['opnSQL']->get_new_number ('downloads_votedata', 'ratingdbid');
		$_ratinguser = $opnConfig['opnSQL']->qstr ($ratinguser);
		$_ip = $opnConfig['opnSQL']->qstr ($ip);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['downloads_votedata'] . " values ($ratingdbid, $ratinglid, $_ratinguser, $rating, $_ip, $ratingcomments, $now)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['downloads_votedata'], 'ratingdbid=' . $ratingdbid);
		include ('voteinclude.php');
		$finalrating = 0;
		$totalvotesDB = 0;
		$truecomments = '';
		vote_download ($ratinglid, $finalrating, $totalvotesDB, $truecomments);
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['downloads_links'] . ' SET linkratingsummary=' . $finalrating . ', totalvotes=' . $totalvotesDB . ',totalcomments=' . $truecomments . ' WHERE lid=' . $ratinglid);
		$error = 'none';
		$boxtxt .= completevote ($error);
	}
	$boxtxt .= completevotefooter ($ratinglid, $title, $ratinguser);
	$boxtxt .= '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_630_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function completevoteheader () {
	return download_menu (1) . '<br />';

}

function completevotefooter ($lid, $title, $ratinguser) {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->Execute ('SELECT url FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid . ' and user_group IN (' . $checkerlist . ')');
	$boxtxt = '';
	if ($result !== false) {
		$url = $result->fields['url'];
		$boxtxt .= '<span class="normaltext">' . _DOW_MESSAGEL . $opnConfig['sitename'] . _DOW_MESSAGEM . '</span><br /><br /><br />';
		if ($ratinguser == 'outside') {
			$boxtxt .= '<div class="centertag">';
			$boxtxt .= '<span class="normaltext">' . _DOW_MESSAGEN . $opnConfig['sitename'] . '</div><br /><div class="centertag"><a class="opncenterbox" href="' . $url . '">' . _DOW_RETURNTO . ' ' . $title . '</a></span><br /><br /></div>';
			$checkerlist = $opnConfig['permission']->GetUserGroups ();
			$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid . ' and user_group IN (' . $checkerlist . ')');
			$title = $result->fields['title'];
		}
	}
	$boxtxt .= '<br /><br />';
	// $boxtxt .= download_linkinfomenu ($lid,$title);
	$boxtxt .= download_linkinfomenu ($lid);
	return $boxtxt;

}

function completevote ($error) {

	$boxtxt = '';
	$anonwaitdays = 1;
	$outsidewaitdays = 1;
	if ($error == 'none') {
		$boxtxt .= '<div class="bigtextbold" align="center">' . _DOW_ERROR0 . '</div>';
	}
	if ($error == 'anonflood') {
		$boxtxt .= '<div class="alerttext" align="center">' . _DOW_ERROR1 . $anonwaitdays . _DOW_ERROR10 . '</div><br />';
	}
	if ($error == 'regflood') {
		$boxtxt .= '<div class="alerttext" align="center">' . _DOW_ERROR2 . '</div><br />';
	}
	if ($error == 'postervote') {
		$boxtxt .= '<div class="alerttext" align="center">' . _DOW_ERROR3 . '</div><br />';
	}
	if ($error == 'nullerror') {
		$boxtxt .= '<div class="alerttext" align="center">' . _DOW_ERROR4 . '</div><br />';
	}
	if ($error == 'outsideflood') {
		$boxtxt .= '<div class="alerttext" align="center">' . _DOW_ERROR5 . $outsidewaitdays . _DOW_ERROR10 . '</div><br />';
	}
	return $boxtxt;

}

function ratelink () {

	global $opnConfig, $cookie;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$ttitle = '';
	get_var ('ttitle', $ttitle, 'url', _OOBJ_DTYPE_CLEAN);
	$boxtxt = download_menu (1);
	$transfertitle = str_replace ('_', ' ', $ttitle);
	$displaytitle = $transfertitle;
	$ip = getenv ('REMOTE_HOST');
	if (empty ($ip) ) {
		$ip = get_real_IP ();
	}
	$boxtxt .= '<br /><br /><div class="extratextbold" align="center">' . $displaytitle . '</div>' . '<ul>' . '<li>' . _DOW_RATETEXT1 . '</li>' . '<li>' . _DOW_RATETEXT2 . '</li>' . '<li>' . _DOW_RATETEXT3 . '</li>' . '<li>' . _DOW_RATETEXT4 . '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/download/index.php?op=TopRated') . '">' . _DOW_RATETEXT5 . '</a></li>' . '<li>' . _DOW_RATETEXT6 . '</li>';
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$name = $cookie['uname'];
		$boxtxt .= '<li>' . _DOW_RATETEXTA . ' ' . $name . '</li>' . '<li>' . _DOW_RATETEXTB . '</li>' . '<li>' . _DOW_RATETEXTC . '</li>';
	} else {
		$boxtxt .= '<li>' . _DOW_RATETEXTD . '</li>' . '<li>' . _DOW_RATETEXTE . '</li>';
		$name = $opnConfig['opn_anonymous_name'];
	}
	$boxtxt .= '</ul><div class="centertag">';
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_DOWNLOAD_640_', 'download');
	$form->Init ($opnConfig['opn_url'] . '/modules/download/index.php');
	$form->AddHidden ('ratinglid', $lid);
	$form->AddHidden ('ratinguser', $name);
	$form->AddHidden ('ratinghost_name', $ip);
	$form->AddText (_DOW_RATETHISDOWNLO . ': ');
	$options[] = '--';
	for ($i = 10; $i>0; $i--) {
		$options[] = $i;
	}
	$form->AddSelectnokey ('rating', $options);
	$form->AddHidden ('op', 'addrating');
	$form->AddText ('<br /><br />');
	if ($opnConfig['permission']->IsUser () ) {
		$form->AddText (_DOW_COMMENTS . ': <br />');
		$form->AddTextarea ('ratingcomments');
		$form->AddNewline (1);
	} else {
		$form->AddHidden ('ratingcomments', '');
	}
	$form->AddNewline (1);
	$form->AddSubmit ('submit', _DOW_RATETHISDOWNLO);
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br />';
	$boxtxt .= linkfooterchild ($lid) . '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_650_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DESC, $boxtxt);

}

function download_buildpass () {

	global $opnConfig, $opnTables;

	$lid = 0;
	get_var ('lid', $lid, 'both', _OOBJ_DTYPE_INT);
	$boxtxt = '<div class="normaltext">';
	$boxtxt .= _DOW_SECURE . '<br /><br />';
	$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['downloads_links'] . ' WHERE lid=' . $lid);
	$boxtxt .= sprintf (_DOW_SECURE1, $result->fields['title']) . '<br /><br /></div>';
	$pass = & new opn_gen_password ();
	$pass->MakePassword ();
	$boxtxt .= $pass->GetForm ('index.php', 'modules/download', 'visit', 'lid', $lid, 'Download');
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_DOWNLOAD_660_';
	$_display_dat['module'] = 'modules/download';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_DOW_DOWNLOAD, $boxtxt);

}

?>