<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/download/plugin/middlebox/recentdownloads/language/');

function recentdownloads_get_data ($result, $box_array_dat, $css, $mytarget, &$data) {

	global $opnConfig;

	$i = 0;
	while (! $result->EOF) {
		$lid = $result->fields['lid'];
		$link = $result->fields['title'];
		$license = $result->fields['file_license'];
		$time = buildnewtag ($result->fields['wdate']);
		$title = $link;
		$transfertitle = str_replace (' ', '_', $title);
		$opnConfig['cleantext']->opn_shortentext ($link, $box_array_dat['box_options']['strlength']);
		$data[$i]['link'] = '';
		if ($license>0) {
			$data[$i]['link'] .= '<a class="' . $css . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
											'op' => 'download',
											'file_license' => $license,
											'lid' => $lid) ) . '"' . $mytarget . ' title="' . $title . '">' . $link . '</a>';
		} else {
			$data[$i]['link'] .= '<a class="' . $css . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
											'op' => 'visit',
											'lid' => $lid) ) . '"' . $mytarget . ' title="' . $title . '">' . $link . '</a>';
		}
		if ($box_array_dat['box_options']['display_details']) {
			$data[$i]['link'] .= '&nbsp;<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/download/index.php',
											'op' => 'viewlinkdetails',
											'lid' => $lid,
											'ttitle' => $transfertitle) ) . '"><img src="' . $opnConfig['opn_url'] . '/modules/download/images/details1.png" alt="' . _MID_RECENTDOWNLOADS_DETAILS . '" title="' . _MID_RECENTDOWNLOADS_DETAILS .'" /></a>';
		}
		$i++;
		$result->MoveNext ();
	}

}

function recentdownloads_middlebox_getprivs () {

	global $opnConfig;
	if ($opnConfig['permission']->HasRight ('modules/download', _PERM_ADMIN, true) ) {
		$ug = 99;
	} else {
		$ui = $opnConfig['permission']->GetUserinfo ();
		$ug = $ui['user_group'];
		unset ($ui);
	}
	return $ug;

}

function recentdownloads_get_middlebox_result (&$box_array_dat) {

	global $opnConfig, $opnTables;

	$boxstuff = $box_array_dat['box_options']['textbefore'];
	$order = 'wdate';
	$limit = $box_array_dat['box_options']['limit'];
	if (!isset ($box_array_dat['box_options']['use_tpl']) ) {
		$box_array_dat['box_options']['use_tpl'] = '';
	}
	if (!isset ($box_array_dat['box_options']['display_details']) ) {
		$box_array_dat['box_options']['display_details'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['strlength']) ) {
		$box_array_dat['box_options']['strlength'] = 22;
	}
	$css = 'opn' . $box_array_dat['box_options']['opnbox_class'] . 'box';
	if (!$limit) {
		$limit = 5;
	}
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$mf = & new CatFunctions ('download');
	$mf->itemtable = $opnTables['downloads_links'];
	$mf->itemid = 'lid';
	$mf->itemlink = 'cid';
	$mf->itemwhere = 'i.user_group IN (' . $checkerlist . ')';
	$result = $mf->GetItemLimit (array ('lid',
					'title',
					'file_license',
					'wdate'),
					array ('i.' . $order . ' DESC'),
		$limit);
	if ($result !== false) {
		$counter = $result->RecordCount ();
		if ($opnConfig['download_opennewwindow']) {
			$mytarget = ' target="_blank"';
		} else {
			$mytarget = '';
		}
		$data = array ();
		recentdownloads_get_data ($result, $box_array_dat, $css, $mytarget, $data);
		if ($box_array_dat['box_options']['use_tpl'] == '') {
			$boxstuff .= '<ul class="' . $css . '">';
			foreach ($data as $val) {
				$boxstuff .= '<li class="' . $css . '">' . $val['link'];
				$boxstuff .= '</li>' . _OPN_HTML_NL;
			}
			$themax = $limit - $counter;
			for ($i = 0; $i<$themax; $i++) {
				$boxstuff .= '<li class="invisible">&nbsp;</li>';
			}
			$boxstuff .= '</ul>';
		} else {
			$pos = 0;
			$dcol1 = '2';
			$dcol2 = '1';
			$a = 0;
			$opnliste = array ();
			foreach ($data as $val) {
				$dcolor = ($a == 0? $dcol1 : $dcol2);
				$opnliste[$pos]['topic'] = $val['link'];
				$opnliste[$pos]['case'] = 'nosubtopic';
				$opnliste[$pos]['alternator'] = $dcolor;
				$opnliste[$pos]['image'] = '';
				$opnliste[$pos]['subtopic'][0] = '';
				$pos++;
				$a = ($dcolor == $dcol1?1 : 0);
			}
			get_box_template ($box_array_dat, array ('subtopic',
								'nosubtopic'),
								$opnliste,
								$limit,
								$counter,
								$boxstuff);
		}
		unset ($data);
		$result->Close ();
	}
	get_box_footer ($box_array_dat, $opnConfig['opn_url'] . '/modules/download/index.php', $opnConfig['opn_url'] . '/modules/download/index.php?op=AddLink', _MID_RECENTDOWNLOADS_ADD, $boxstuff);
	$boxstuff .= $box_array_dat['box_options']['textafter'];
	$box_array_dat['box_result']['skip'] = false;
	$box_array_dat['box_result']['title'] = $box_array_dat['box_options']['title'];
	$box_array_dat['box_result']['content'] = $boxstuff;
	unset ($boxstuff);

}

?>