<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

global $opnConfig, $opnTables;

define ('_EGAL_SQL_BOX', 'SELECT p.pid AS pid, p.img AS img, p.name AS name, p.description AS description, c.galloc AS galloc FROM ' . $opnTables['gallery_pictures'] . ' p LEFT JOIN ' . $opnTables['gallery_categories'] . ' c ON c.gallid=p.gid WHERE c.visible>=');

function build_box_content ($pic, $hidename = 0) {

	global $opnConfig;

	$content = '';
	if (isset ($pic['pid']) ) {
		$content = '<div align="center">';
		$content .= '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
							'op' => 'showpic',
							'pid' => $pic['pid']) ) . '">';
		if ($pic['description'] != '') {
			$title = 'title="' . $pic['description'] . '" ';
		} else {
			$title = '';
		}
		if (file_exists ($opnConfig['datasave']['egallery']['path'] . $pic['galloc'] . '/thumb/' . $pic['img']) ) {
			$content .= '<img src="' . $opnConfig['datasave']['egallery']['url'] . '/' . $pic['galloc'] . '/thumb/' . $pic['img'] . '" class="imgtag" alt="' . $pic['description'] . '" ' . $title . '/>';
		} else {
			$content .= '<img src="' . $opnConfig['datasave']['egallery']['url'] . '/' . $pic['galloc'] . '/' . $pic['img'] . '" class="imgtag" alt="' . $pic['description'] . '" ' . $title . 'width="70" />';
		}
		$content .= '</a>';
		if ($hidename == 0) {
			$content .= '<br />';
			$content .= '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
								'op' => 'showpic',
								'pid' => $pic['pid']) ) . '">';
			$content .= '<span class="smalltext">' . $pic['name'] . '</span>';
			$content .= '</a>';
		}
		$content .= '</div><br />';
	}
	return $content;

}

function egallery_random ($myparameters) {

	global $opnConfig, $opnTables;

	$do_not = 0;
	$ut = & new MyModules;
	$ut->SetModuleName ('modules/egallery');
	$ut->LoadPrivateSettings ();
	if ($myparameters['onlyimages'] == 1) {
		$where = " AND (extension='jpg' OR extension='gif' OR extension='png' OR extension='bmp')";
	} else {
		$where = '';
	}
	if ($myparameters['smidtype'] == 7) {
		if ( (isset ($myparameters['smidtype7categories']) ) && ($myparameters['smidtype7categories'] != '') ) {
			$temp = implode (',', $myparameters['smidtype7categories']);
			$where .= ' AND (c.gallid IN (' . $temp . '))';
		}
	}
	mt_srand ((double)microtime ()*1000000);
	if ($opnConfig['permission']->IsUser () ) {
		$egboxsql = 'SELECT COUNT(p.pid) AS total FROM ' . $opnTables['gallery_pictures'] . ' p LEFT JOIN ' . $opnTables['gallery_categories'] . ' c ON c.gallid=p.gid WHERE c.visible>=1' . $where;
	} else {
		$egboxsql = 'SELECT COUNT(p.pid) AS total FROM ' . $opnTables['gallery_pictures'] . ' p LEFT JOIN ' . $opnTables['gallery_categories'] . ' c ON c.gallid=p.gid WHERE c.visible>=2' . $where;
	}
	$egboxresult = &$opnConfig['database']->Execute ($egboxsql);
	$total = $egboxresult->GetRowAssoc ('0');
	$egboxresult->Close ();
	if ($total['total']<=1) {
		$p = 0;
	} else {
		$p = mt_rand (0, ($total['total']-1) );
	}
	if ($opnConfig['permission']->IsUser () ) {
		$egboxsql = _EGAL_SQL_BOX . '1' . $where;
	} else {
		$egboxsql = _EGAL_SQL_BOX . '2' . $where;
	}
	$egboxresult = &$opnConfig['database']->SelectLimit ($egboxsql, 1, $p);
	if ($egboxresult !== false) {
		$pic = $egboxresult->GetRowAssoc ('0');
		$pic['description'] = htmlentities ($pic['description']);
		$egboxresult->Close ();
		$do_not = 1;
	}
	if (isset ($pic) ) {
		$content = build_box_content ($pic, $myparameters['hidename']);
	} else {
		$content = '';
	}
	if ( ($do_not == 1) && ($pic['pid'] != '') ) {
		return ($content);
	}
	return '';

}

function egallery_newest ($myparameters) {

	global $opnConfig;
	if (!isset ($myparameters['newestnumber']) ) {
		$myparameters['newestnumber'] = 1;
	}
	$content = '';
	$ut = & new MyModules;
	$ut->SetModuleName ('modules/egallery');
	$ut->LoadPrivateSettings ();
	if ($myparameters['onlyimages'] == 1) {
		$where = " AND (extension='jpg' OR extension='gif' OR extension='png' OR extension='bmp')";
	} else {
		$where = '';
	}
	if ($opnConfig['permission']->IsUser () ) {
		$egboxsql = _EGAL_SQL_BOX . '1' . $where . ' ORDER BY wdate DESC';
	} else {
		$egboxsql = _EGAL_SQL_BOX . '2' . $where . ' ORDER BY wdate DESC';
	}
	$egboxresult = &$opnConfig['database']->SelectLimit ($egboxsql, $myparameters['newestnumber']);
	if ($egboxresult !== false) {
		while (! $egboxresult->EOF) {
			$pic = $egboxresult->GetRowAssoc ('0');
			$pic['description'] = htmlentities ($pic['description']);
			$content .= build_box_content ($pic, $myparameters['hidename']);
			$egboxresult->MoveNext ();
		}
		$egboxresult->Close ();
	}
	return $content;

}

function egallery_static ($thepid, $myparameters) {

	global $opnConfig;

	$do_not = 0;
	$ut = & new MyModules;
	$ut->SetModuleName ('modules/egallery');
	$ut->LoadPrivateSettings ();
	if ($opnConfig['permission']->IsUser () ) {
		$egboxsql = _EGAL_SQL_BOX . '1 AND p.pid=' . $thepid;
	} else {
		$egboxsql = _EGAL_SQL_BOX . '2 AND p.pid=' . $thepid;
	}
	$egboxresult = &$opnConfig['database']->SelectLimit ($egboxsql, 1);
	if ($egboxresult !== false) {
		$pic = $egboxresult->GetRowAssoc ('0');
		$pic['description'] = htmlentities ($pic['description']);
		$egboxresult->Close ();
		$do_not = 1;
	}
	if (isset ($pic) ) {
		$content = build_box_content ($pic, $myparameters['hidename']);
	} else {
		$content = '';
	}
	if ( ($do_not == 1) && ($pic['pid'] != '') ) {
		return ($content);
	}
	return '';

}

function egallery_bestrated ($myparameters) {

	global $opnConfig;

	$do_not = 0;
	$ut = & new MyModules;
	$ut->SetModuleName ('modules/egallery');
	$ut->LoadPrivateSettings ();
	if ($myparameters['onlyimages'] == 1) {
		$where = " AND (extension='jpg' OR extension='gif' OR extension='png' OR extension='bmp')";
	} else {
		$where = '';
	}
	if ($opnConfig['permission']->IsUser () ) {
		$egboxsql = _EGAL_SQL_BOX . '1' . $where . ' ORDER BY rate DESC';
	} else {
		$egboxsql = _EGAL_SQL_BOX . '2' . $where . ' ORDER BY rate DESC';
	}
	$egboxresult = &$opnConfig['database']->SelectLimit ($egboxsql, 1);
	if ($egboxresult !== false) {
		$pic = $egboxresult->GetRowAssoc ('0');
		$pic['description'] = htmlentities ($pic['description']);
		$egboxresult->Close ();
		$do_not = 1;
	}
	if (isset ($pic) ) {
		$content = build_box_content ($pic, $myparameters['hidename']);
	} else {
		$content = '';
	}
	if ( ($do_not == 1) && ($pic['pid'] != '') ) {
		return ($content);
	}
	return '';

}

function egallery_famous ($myparameters) {

	global $opnConfig;

	$do_not = 0;
	$ut = & new MyModules;
	$ut->SetModuleName ('modules/egallery');
	$ut->LoadPrivateSettings ();
	if ($myparameters['onlyimages'] == 1) {
		$where = " AND (extension='jpg' OR extension='gif' OR extension='png' OR extension='bmp')";
	} else {
		$where = '';
	}
	if ($opnConfig['permission']->IsUser () ) {
		$egboxsql = _EGAL_SQL_BOX . '1' . $where . ' ORDER BY counter DESC';
	} else {
		$egboxsql = _EGAL_SQL_BOX . '2' . $where . ' ORDER BY counter DESC';
	}
	$egboxresult = &$opnConfig['database']->SelectLimit ($egboxsql, 1);
	if ($egboxresult !== false) {
		$pic = $egboxresult->GetRowAssoc ('0');
		$pic['description'] = htmlentities ($pic['description']);
		$egboxresult->Close ();
		$do_not = 1;
	}
	if (isset ($pic) ) {
		$content = build_box_content ($pic, $myparameters['hidename']);
	} else {
		$content = '';
	}
	if ( ($do_not == 1) && ($pic['pid'] != '') ) {
		return ($content);
	}
	return '';

}

function egallery_newestcomment ($myparameters) {

	global $opnConfig, $opnTables;

	$do_not = 0;
	$ut = & new MyModules;
	$ut->SetModuleName ('modules/egallery');
	$ut->LoadPrivateSettings ();
	if ($myparameters['onlyimages'] == 1) {
		$where = " AND (extension='jpg' OR extension='gif' OR extension='png' OR extension='bmp')";
	} else {
		$where = '';
	}
	if ($opnConfig['permission']->IsUser () ) {
		$egboxsql = 'SELECT p.pid AS pid, p.img AS img, p.name AS name, p.description AS description, c.galloc AS galloc FROM ' . $opnTables['gallery_pictures'] . ' p LEFT JOIN ' . $opnTables['gallery_categories'] . ' c ON c.gallid=p.gid LEFT JOIN ' . $opnTables['gallery_comments'] . ' t ON t.pid=p.pid WHERE c.visible>=1' . $where . ' ORDER BY t.wdate DESC';
	} else {
		$egboxsql = 'SELECT p.pid AS pid, p.img AS img, p.name AS name, p.description AS description, c.galloc AS galloc FROM ' . $opnTables['gallery_pictures'] . ' p LEFT JOIN ' . $opnTables['gallery_categories'] . ' c ON c.gallid=p.gid LEFT JOIN ' . $opnTables['gallery_comments'] . ' t ON t.pid=p.pid WHERE c.visible>=2' . $where . ' ORDER BY t.wdate DESC';
	}
	$egboxresult = &$opnConfig['database']->SelectLimit ($egboxsql, 1);
	if ($egboxresult !== false) {
		$pic = $egboxresult->GetRowAssoc ('0');
		$pic['description'] = htmlentities ($pic['description']);
		$egboxresult->Close ();
		$do_not = 1;
	}
	if (isset ($pic) ) {
		$content = build_box_content ($pic, $myparameters['hidename']);
	} else {
		$content = '';
	}
	if ( ($do_not == 1) && ($pic['pid'] != '') ) {
		return ($content);
	}
	return '';

}

?>