<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include (_OPN_ROOT_PATH . 'modules/egallery/public/imagefunctions.php');
include (_OPN_ROOT_PATH . 'modules/egallery/admin/gallery/filefunctions.php');

function displayPictureGall ($gid, $pid, $thumbwidth, $galloc, $name, $img, $orderby) {

	global $opnConfig;

	$mythumb = GetThumbinfo ($img, $galloc, $gid);
	if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
		$out = '&nbsp;&nbsp;' . $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/egallery/admin/index.php',
								'op' => 'editmedia',
								'type' => 'edit',
								'category' => $gid,
								'pid' => $pid,
								'gid' => $gid) ) . _OPN_HTML_NL;
	} else {
		$out = '';
	}
	return '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
								'op' => 'showpic',
								'pid' => $pid,
								'orderby' => $orderby) ) . '">' . _OPN_HTML_NL . '<img src="' . $mythumb['url'] . '" width="' . $thumbwidth . '" alt="' . underscoreTospace ($name) . '" title="' . underscoreTospace ($name) . '" class="imgtag" align="middle" />' . _OPN_HTML_NL . '</a>' . $out . _OPN_HTML_NL;

}

function displayDescriptionGall ($row, $crow) {

	global $opnConfig;
	if ($crow['numcol']>0) {
		$m = 90/ $crow['numcol'];
	} else {
		$m = 1;
	}
	if (!isset ($row['description']) ) {
		$row['description'] = '';
	}
	$opnConfig['cleantext']->opn_shortentext ($row['description'], $m);
	return '<span class="normaltext">' . $row['description'] . '</span>' . _OPN_HTML_NL;

}

function displayNewGall ($row) {
	return buildnewtag ($row['new_day']);

}

function displaySizeGall ($row) {
	if ($row['imginfo'][2]) {
		$size = $row['imginfo'];
		return '<span class="normaltextbold">' . _EGALLERY_GALSIZE . '</span><span class="smalltext">: ' . $size[0] . 'x' . $size[1] . '</span>' . _OPN_HTML_NL;
	}
	return '<span class="normaltextbold">' . _EGALLERY_GALSIZE . '</span><span class="smalltext">: ' . _EGALLERY_GALUNKNOWN . '</span>' . _OPN_HTML_NL;

}

function displayFormatGall ($row) {

	$ext = $row['imginfo'][2];
	switch ($ext) {
		case 1:
			$type = 'GIF';
			break;
		case 2:
			$type = 'JPEG';
			break;
		case 3:
			$type = 'PNG';
			break;
		case 4:
			$type = 'WBMP';
			break;
		default:
			$type = $ext;
			break;
	}
	return '<span class="normaltextbold">' . _EGALLERY_MEDIATYPE . '</span><span class="smalltext">: ' . $type . '</span>' . _OPN_HTML_NL;

}

function displayNumCommentsGall ($row) {

	global $opnConfig, $opnTables;

	$egdncresult = &$opnConfig['database']->Execute ('SELECT COUNT(cid) AS total FROM ' . $opnTables['gallery_comments'] . ' WHERE pid=' . $row['pid']);
	$numcomments = $egdncresult->GetRowAssoc ('0');
	$egdncresult->Close ();
	if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_WRITE, true) ) {
		return '<span class="normaltextbold">' . _EGALLERY_GALNBCOMMENTS . '</span><span class="smalltext">: ' . $numcomments['total'] . '</span>' . _OPN_HTML_NL;
	}
	return '';

}

function displayHitsGall ($row) {
	return '<span class="normaltextbold">' . _EGALLERY_GALHITS . '</span><br /><span class="smalltext">' . $row['counter'] . '</span>' . _OPN_HTML_NL;

}

function displayRateGall ($row) {

	global $opnConfig;
	if ($opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_ALLOWRATING, true) ) {
		return '<span class="normaltextbold">' . _EGALLERY_GALRATING . '</span><br /><span class="smalltext">' . $row['rate'] . '</span>' . _OPN_HTML_NL;
	}
	return '';

}

function displayDateAddedGall ($row) {

	global $opnConfig;

	$opnConfig['opndate']->sqlToopnData ($row['unix_date']);
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _EGALLERY_GALDATEBRIEF);
	return '<span class="normaltextbold">' . _EGALLERY_GALADDED . '</span><br /><span class="smalltext">' . $temp . '</span>' . _OPN_HTML_NL;

}

function displayName ($row) {
	return '<span class="smalltextbold">' . $row['name'] . '</span>' . _OPN_HTML_NL;

}

function navigationCat ($gid, $offset, $orderby) {

	global $opnConfig, $opnTables;

	$limit = $opnConfig['egallery_maxNumberMedia'];
	$orderby = convertorderbyoutgally ($orderby);
	$numresults = &$opnConfig['database']->Execute ('SELECT COUNT(gid) AS total FROM ' . $opnTables['gallery_pictures'] . ' WHERE gid=' . $gid);
	if ( ($numresults !== false) && (isset ($numresults->fields['total']) ) ) {
		$numrows = $numresults->fields['total'];
	} else {
		$numrows = 0;
	}
	$numresults->Close ();
	$nav = '';
	$pages = intval ($numrows/ $limit);
	if ($numrows>0&$pages >= 1) {
		if ($offset != 0) {
			$prevoffset = $offset- $limit;
			$nav = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
										'op' => 'showgall',
										'gid' => $gid,
										'offset' => $prevoffset,
										'orderby' => $orderby) ) . '">[&lt;&lt;]</a>&nbsp;.&nbsp;' . _OPN_HTML_NL;
		}
		if ($numrows%$limit) {
			$pages++;
		}
		for ($i = 1; $i<= $pages; $i++) {
			$newoffset = $limit* ($i-1);
			if ($newoffset == $offset) {
				$nav .= '<span class="normaltext">';
				if ($i == 1) {
					if ($pages == 1) {
						$nav .= '[&lt;&lt;] . ' . $i . ' . [&gt;&gt;]';
					} else {
						$nav .= '[&lt;&lt;] . ' . $i . '&nbsp;.&nbsp;';
					}
				} elseif ($i == $pages) {
					$nav .= $i . '&nbsp;.&nbsp;[&gt;&gt;]';
				} else {
					$nav .= $i . '&nbsp;.&nbsp;';
				}
				$nav .= '</span>' . _OPN_HTML_NL;
			} else {
				$nav .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
											'op' => 'showgall',
											'gid' => $gid,
											'offset' => $newoffset,
											'orderby' => $orderby) ) . '">' . $i . '</a>&nbsp;.&nbsp;' . _OPN_HTML_NL;
			}
		}
		if (! ( ($offset/$limit) == ($pages-1) ) && $pages != 1) {
			$newoffset = $offset+ $limit;
			$nav .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
										'op' => 'showgall',
										'gid' => $gid,
										'offset' => $newoffset,
										'orderby' => $orderby) ) . '">[&gt;&gt;]</a>' . _OPN_HTML_NL;
		}
	}
	return $nav;

}

function navigationSubCat ($gid) {

	global $opnTables, $opnConfig;

	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$sql = 'SELECT gallid, gallname, galloc, gallimg, description, visible, total,' . ' lastadd AS new_day FROM ' . $opnTables['gallery_categories'] . ' WHERE parent=' . $gid . ' AND visible';
	if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
		$sql .= '>=0';
	} else {
		$sql .= '>0';
	}
	$sql .= ' ORDER by gallname';
	$egnscresult = &$opnConfig['database']->Execute ($sql);
	$nb = $egnscresult->RecordCount ();
	if (!$nb) {
		return false;
	}
	$c = 0;
	$out = '<table border="0" width="50%" align="center" cellpadding="2"><tr>' . _OPN_HTML_NL;
	$hundret = 100;
	$pc = ceil ($hundret/3);
	$isuser = $opnConfig['permission']->IsUser ();
	$isadmin = $opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true);
	while (! $egnscresult->EOF) {
		$row = $egnscresult->GetRowAssoc ('0');
		$vis = '';
		$icon = '';
		if ($row['visible'] == 1 && !$isuser) {
			$vis = '(*)';
		}
		if ($isadmin) {
			switch ($row['visible']) {
				case 0:
					$vis .= '&nbsp;<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/admin/index.php',
													'op' => 'editcategory',
													'type' => 'status',
													'visible' => '1',
													'category' => $row['gallid'],
													'gouser' => '1') ) . '" title="' . _EGALLERY_GALVISIBLEADMIN . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/red_dot.gif" class="imgtag" width="10" height="10" alt="' . _EGALLERY_GALVISIBLEADMIN . '" title="' . _EGALLERY_GALVISIBLEADMIN . '" /></a>&nbsp;' . _OPN_HTML_NL;
					break;
				case 1:
					$vis .= '&nbsp;<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/admin/index.php',
													'op' => 'editcategory',
													'type' => 'status',
													'visible' => '2',
													'category' => $row['gallid'],
													'gouser' => '1') ) . '" title="' . _EGALLERY_GALVISIBLEMEMBER . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/yellow_dot.gif" class="imgtag" width="10" height="10" alt="' . _EGALLERY_GALVISIBLEMEMBER . '" title="' . _EGALLERY_GALVISIBLEMEMBER . '" /></a>&nbsp;' . _OPN_HTML_NL;
					break;
				default:
					$vis .= '&nbsp;<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/admin/index.php',
													'op' => 'editcategory',
													'type' => 'status',
													'visible' => '0',
													'category' => $row['gallid'],
													'gouser' => '1') ) . '" title="' . _EGALLERY_GALVISIBLEPUBLIC . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/green_dot.gif" class="imgtag" width="10" height="10" alt="' . _EGALLERY_GALVISIBLEPUBLIC . '" title="' . _EGALLERY_GALVISIBLEPUBLIC . '" /></a>&nbsp;' . _OPN_HTML_NL;
					break;
			}
		}
		if ($opnConfig['egallery_displaySubCatIcon']) {
			if (isset ($opnConfig['egallery_SubCatIconwidth']) && $opnConfig['egallery_SubCatIconwidth'] != '') {
				$icon = '<img src="' . $opnConfig['datasave']['egallery']['url'] . '/' . $row['galloc'] . '/' . $row['gallimg'] . '" width="' . $opnConfig['egallery_SubCatIconwidth'] . '" class="imgtag" alt="' . strip_tags ($row['description']) . '" title="' . strip_tags ($row['description']) . '" />' . _OPN_HTML_NL;
			} else {
				$icon = '<img src="' . $opnConfig['datasave']['egallery']['url'] . '/' . $row['galloc'] . '/' . $row['gallimg'] . '" class="imgtag" alt="' . strip_tags ($row['description']) . '" title="' . strip_tags ($row['description']) . '" /></a>' . _OPN_HTML_NL;
			}
		}
		$out .= '<td width="' . $pc . '%">' . _OPN_HTML_NL;
		$out .= '<span class="smalltext"><img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/folder.gif" width="15" height="13" class="imgtag" alt="" /> ' . _OPN_HTML_NL;
		if ($row['visible'] == 1 && !$isuser && !$isadmin) {
			$out .= underscoreTospace ($row['gallname']) . ' (' . $row['total'] . ') ' . $vis;
		} else {
			$out .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
										'op' => 'showgall',
										'gid' => $row['gallid']) ) . '">' . underscoreTospace ($row['gallname']) . '</a> (' . $row['total'] . ')  ' . $vis . _OPN_HTML_NL;
			$icon = '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
										'op' => 'showgall',
										'gid' => $row['gallid']) ) . '">' . $icon . '</a>' . _OPN_HTML_NL;
		}
		$out .= buildnewtag ($row['new_day']);
		$out .= '</span>' . _OPN_HTML_NL;
		$out .= '<br />' . $icon;
		$out .= '</td>' . _OPN_HTML_NL;
		$c++;
		if ($c == 3 && $nb != 3) {
			$out .= '</tr><tr>' . _OPN_HTML_NL;
			$c = 0;
		}
		$egnscresult->MoveNext ();
	}
	$egnscresult->Close ();
	$out .= '</tr></table>' . _OPN_HTML_NL;
	return $out;

}

function convertorderbytrans ($orderby) {
	if ($orderby == 'counter ASC') {
		$orderbyTrans = _EGALLERY_GALPOPULARITY1;
	}
	if ($orderby == 'counter DESC') {
		$orderbyTrans = _EGALLERY_GALPOPULARITY2;
	}
	if ($orderby == 'name ASC') {
		$orderbyTrans = _EGALLERY_GALNAMEAZ;
	}
	if ($orderby == 'name DESC') {
		$orderbyTrans = _EGALLERY_GALNAMEZA;
	}
	if ($orderby == 'wdate ASC') {
		$orderbyTrans = _EGALLERY_GALDATE1;
	}
	if ($orderby == 'wdate DESC') {
		$orderbyTrans = _EGALLERY_GALDATE2;
	}
	if ($orderby == 'rate ASC') {
		$orderbyTrans = _EGALLERY_GALRATING1;
	}
	if ($orderby == 'rate DESC') {
		$orderbyTrans = _EGALLERY_GALRATING2;
	}
	if (! (isset ($orderbyTrans) ) ) {
		$orderbyTrans = '';
	}
	return $orderbyTrans;

}

function search_split_query ($q) {

	$w = array ();
	$qwords = explode (' ', $q);
	if (is_array ($qwords) ) {
		foreach ($qwords as $word) {
			$w[] = '%' . $word . '%';
		}
	}
	return $w;

}

function search_go () {

	global $opnConfig, $opnTables;

	$q = '';
	get_var ('q', $q, 'form', _OOBJ_DTYPE_CLEAN);
	$bool = '';
	get_var ('bool', $bool, 'form', _OOBJ_DTYPE_CLEAN);
	$search_picname = '';
	get_var ('search_picname', $search_picname, 'form', _OOBJ_DTYPE_CLEAN);
	$search_picdesc = '';
	get_var ('search_picdesc', $search_picdesc, 'form', _OOBJ_DTYPE_CLEAN);
	$search_catname = '';
	get_var ('search_catname', $search_catname, 'form', _OOBJ_DTYPE_CLEAN);
	$search_catdesc = '';
	get_var ('search_catdesc', $search_catdesc, 'form', _OOBJ_DTYPE_CLEAN);
	$nothingfound = FALSE;
	$navgall = navigationGall ();
	$w = search_split_query ($q);
	$flag = false;
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$query = 'SELECT p.pid AS pid, p.gid AS gid, p.img AS img, p.counter AS counter, p.submitter AS submitter, p.wdate AS wdate, p.name AS name, p.description AS description, p.votes AS votes, p.rate AS rate, p.extension AS extension, p.width AS width, p.height AS height, c.gallname AS gallname, c.description AS galldesc, c.galloc AS galloc, c.numcol AS numcol, c.thumbwidth AS thumbwidth,' . ' t.templatecategory AS templateCategory, t.templatecss AS templateCSS, p.wdate AS unix_date,' . ' p.wdate AS new_day, f.displaytag AS displaytag, f.thumbnail AS thumbnail, f.filetype AS filetype,' . ' f.description AS description_media FROM ' . $opnTables['gallery_pictures'] . ' p LEFT JOIN ' . $opnTables['gallery_categories'] . ' c ON c.gallid=p.gid LEFT JOIN ' . $opnTables['gallery_template_types'] . ' t ON t.id=c.template LEFT JOIN ' . $opnTables['gallery_media_types'] . ' f ON f.extension=p.extension WHERE c.visible>=';
	if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
		$query .= '0 AND ';
	} elseif ($opnConfig['permission']->IsUser () ) {
		$query .= '1 AND ';
	} else {
		$query .= '2 AND ';
	}
	$curGal = '';
	foreach ($w as $word) {
		if ($flag) {
			switch ($bool) {
				case 'AND':
					$query .= ' AND ';
					break;
				case 'OR':
				default:
					$query .= ' OR ';
					break;
			}
		}
		$query .= '(';
		$like_search = $opnConfig['opnSQL']->AddLike ($word);
		if ($search_picname) {
			$query .= "p.name LIKE $like_search OR ";
		}
		if ($search_picdesc) {
			$query .= "p.description LIKE $like_search OR ";
		}
		if ($search_catname) {
			$query .= "c.gallname LIKE $like_search OR ";
		}
		if ($search_catdesc) {
			$query .= "c.description LIKE $like_search OR ";
		}
		$query .= '0)';
		// little bit of filler to reduce code requirements :-)
		$flag = true;
	}
	$query .= ' ORDER BY c.gallname ASC, p.name ASC';
	$egsgresult = &$opnConfig['database']->Execute ($query);
	$total_rows = $egsgresult->RecordCount ();
	$boxtxt = '<br />';
	$boxtxt .= '<br />' . $navgall;
	$boxtxt .= '<br />';
	if ($total_rows) {
		$col = 1;
		$table = & new opn_TableClass ('default');
		$table->AddOpenRow ();
		while (! $egsgresult->EOF) {
			$row = $egsgresult->GetRowAssoc ('0');
			if ($row['gid'] != $curGal) {
				if ($col<=2) {
					while ($col<=2) {
						$table->AddDataCol ('&nbsp;');
						$col++;
					}
				}
				$table->AddChangeRow ();
				$table->AddDataCol ('<span class="normaltext">' . underscoreTospace ($row['gallname']) . '</span>' . _OPN_HTML_NL, 'center', '2');
				$table->AddChangeRow ();
				$curGal = $row['gid'];
				$col = 1;
			}
			if ($col>2) {
				$table->AddChangeRow ();
				$col = 1;
			}
			$template = $row['templatecategory'];
			$template = str_replace ('<:IMAGE:>', displayPictureGall ($row['gid'], $row['pid'], $row['thumbwidth'], $row['galloc'], $row['name'], $row['img'], convertorderbyoutgally ($opnConfig['egallery_defaultsortmedia']) ), $template);
			// get some image info stuff out of the way here
			// echo $row['extension'];
			if ($row['filetype'] == 1) {
				$row['imginfo'] = @getimagesize ($opnConfig['datasave']['egallery']['path'] . $row['galloc'] . '/' . $row['img']);
			} else {
				$row['imginfo'] = false;
				$row['imginfo'][0] = $row['width'];
				$row['imginfo'][1] = $row['height'];
				$row['imginfo'][2] = $row['description_media'];
				$row['imginfo'][3] = 'width="' . $row['width'] . '" height="' . $row['height'] . '"';
			}
			// ok, back to what we were doing
			$val_description = displayDescriptionGall ($row, $row);
			$val_rate = displayRateGall ($row);
			$val_format = displayFormatGall ($row);
			$val_size = displaySizeGall ($row);
			$val_nmbComments = displayNumCommentsGall ($row);
			$val_new = displayNewGall ($row);
			$val_hits = displayHitsGall ($row);
			$val_date = displayDateAddedGall ($row);
			$val_name = displayName ($row);
			$template = str_replace ('<:DESCRIPTION:>', $val_description, $template);
			$template = str_replace ('<:RATE:>', $val_rate, $template);
			$template = str_replace ('<:FORMAT:>', $val_format, $template);
			$template = str_replace ('<:SIZE:>', $val_size, $template);
			$template = str_replace ('<:NBCOMMENTS:>', $val_nmbComments, $template);
			$template = str_replace ('<:NEW:>', $val_new, $template);
			$template = str_replace ('<:HITS:>', $val_hits, $template);
			$template = str_replace ('<:DATE:>', $val_date, $template);
			$template = str_replace ('<:NAME:>', $val_name, $template);
			$table->AddDataCol ($template);
			$col++;
			$egsgresult->MoveNext ();
		}
		if ($col<=2) {
			while ($col<=2) {
				$table->AddDataCol ('&nbsp;');
				$col++;
			}
		}
		$table->AddCloseRow ();
		$table->GetTable ($boxtxt);
	} else {
		$nothingfound = TRUE;
	}
	if ($nothingfound) {
		$boxtxt .= '<div align="center">' . _EGALLERY_GALNOTHINGMATCHSEARCH . '</div>' . _OPN_HTML_NL;
	}
	$boxtxt .= search_form ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EGALLERY_380_';
	$_display_dat['module'] = 'modules/egallery';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_EGALLERY_GALSEARCHRESULT, $boxtxt, _EGALLERY_GALFOOTER);

}

function showgall () {

	global $opnConfig, $opnTables;

	$gid = 0;
	get_var ('gid', $gid, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$orderby = '';
	get_var ('orderby', $orderby, 'url', _OOBJ_DTYPE_CLEAN);
	$egsgresult = &$opnConfig['database']->Execute ('SELECT COUNT(gallid) AS total FROM ' . $opnTables['gallery_categories'] . ' WHERE parent=' . $gid . ' AND visible=1');
	$res = $egsgresult->GetRowAssoc ('0');
	$egsgresult->Close ();
	$egsql = 'SELECT c.galloc AS galloc, c.numcol AS numcol, c.description AS description, c.visible AS visible, c.thumbwidth AS thumbwidth, t.templatecategory AS templateCategory, t.templatecss AS templateCSS FROM ' . $opnTables['gallery_categories'] . ' c LEFT JOIN ' . $opnTables['gallery_template_types'] . ' t ON t.id=c.template WHERE gallid=' . $gid;
	$egsgresult = &$opnConfig['database']->Execute ($egsql);
	$crow = $egsgresult->GetRowAssoc ('0');
	$egsgresult->Close ();
	$ok = 0;
	switch ($crow['visible']) {
		case 0:
			if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
				$ok = 1;
			}
			break;
		case 1:
			if ($opnConfig['permission']->IsUser () || $opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
				$ok = 1;
			}
			break;
		default:
			$ok = 1;
			break;
	}
	if ($ok) {
		if ($orderby <> '') {
			$orderby = convertorderbyingally ($orderby);
		} else {
			$orderby = convertorderbyingally ($opnConfig['egallery_defaultsortmedia']);
		}
		if (!$gid) {
			$opnConfig['opnOutput']->Redirect ('/modules/egallery/index.php');
			exit;
		}
		$limit = $opnConfig['egallery_maxNumberMedia'];
		if (empty ($offset) ) {
			$offset = 0;
		}
		$newoffset = $offset;
		$orderbyTrans = convertorderbytrans ($orderby);
		$navtree = navigationTree ($gid, false);
		$nav = navigationCat ($gid, $offset, $orderby);
		$subcats = navigationSubCat ($gid);
		$boxtxt = '';
		$egsql = 'SELECT m.pid AS pid, m.gid AS gid, m.img AS img, m.counter AS counter, m.submitter AS submitter, m.wdate AS wdate, m.name AS name, m.description AS description, m.votes AS votes, m.rate AS rate, m.extension AS extension, m.width AS width, m.height AS height, m.wdate AS unix_date, m.wdate AS new_day, f.displaytag AS displaytag, f.thumbnail AS thumbnail, f.filetype AS filetype, f.description AS description_media ' . 'FROM ' . $opnTables['gallery_pictures'] . ' m LEFT JOIN ' . $opnTables['gallery_media_types'] . ' f ON f.extension=m.extension ' . 'WHERE gid=' . $gid . ' ORDER BY ' . $orderby;
		$egsgresult = &$opnConfig['database']->SelectLimit ($egsql, $limit, $offset);
		$nb = $egsgresult->RecordCount ();
		if ($crow['numcol']>0) {
			$pc = ceil (100/ $crow['numcol']);
		} else {
			$pc = 100;
		}
		$c = 0;
		$boxtxt = '<br />';
		$boxtxt .= '<br />' . navigationGall ();
		$boxtxt .= '<br />';
		$boxtxt .= $navtree;
		if ($subcats !== FALSE) {
			$boxtxt .= $subcats . '<hr />';
		}
		$boxtxt .= '<div align="center" class="normaltext">' . $crow['description'] . '</div>' . _OPN_HTML_NL;
		if ($opnConfig['egallery_displaysortbar'] && $nb>1) {
			$boxtxt .= '<div align="center" class="smalltext">' . _EGALLERY_GALSORTMEDIABY . ': ' . _EGALLERY_GALNAME . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																							'op' => 'showgall',
																							'gid' => $gid,
																							'offset' => $newoffset,
																							'orderby' => 'titleA') ) . '">' . _EGALLERY_GALASC . '</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																'op' => 'showgall',
																'gid' => $gid,
																'offset' => $newoffset,
																'orderby' => 'titleD') ) . '">' . _EGALLERY_GALDESC . '</a>)' . _OPN_HTML_NL . _EGALLERY_GALDATE . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																						'op' => 'showgall',
																						'gid' => $gid,
																						'offset' => $newoffset,
																						'orderby' => 'dateA') ) . '">' . _EGALLERY_GALASC . '</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																'op' => 'showgall',
																'gid' => $gid,
																'offset' => $newoffset,
																'orderby' => 'dateD') ) . '">' . _EGALLERY_GALDESC . '</a>)' . _OPN_HTML_NL . _EGALLERY_GALRATE . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																						'op' => 'showgall',
																						'gid' => $gid,
																						'offset' => $newoffset,
																						'orderby' => 'ratingA') ) . '">' . _EGALLERY_GALASC . '</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																'op' => 'showgall',
																'gid' => $gid,
																'offset' => $newoffset,
																'orderby' => 'ratingD') ) . '">' . _EGALLERY_GALDESC . '</a>) ' . _OPN_HTML_NL . _EGALLERY_GALPOPULARITY . ' (<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																							'op' => 'showgall',
																							'gid' => $gid,
																							'offset' => $newoffset,
																							'orderby' => 'hitsA') ) . '">' . _EGALLERY_GALASC . '</a>\<a class="smalltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
																'op' => 'showgall',
																'gid' => $gid,
																'offset' => $newoffset,
																'&orderby' => 'hitsD') ) . '">' . _EGALLERY_GALDESC . '</a>) ' . _OPN_HTML_NL . '<br />' . _EGALLERY_GALMEDIASORTED . ': ' . $orderbyTrans . '</div>';
		}
		$boxtxt .= '<div class="centertag">' . $nav . '</div>' . _OPN_HTML_NL;
		$table = & new opn_TableClass ('default', '2');
		$table->AddOpenColGroup ();
		for ($xx = 0; $xx< $crow['numcol']; $xx++) {
			$table->AddCol ($pc . '%');
		}
		$table->AddCloseColGroup ();
		$table->AddOpenRow ();
		while (! $egsgresult->EOF) {
			$row = $egsgresult->GetRowAssoc ('0');
			$template = $crow['templatecategory'];
			$template = str_replace ('<:IMAGE:>', displayPictureGall ($row['gid'], $row['pid'], $crow['thumbwidth'], $crow['galloc'], $row['name'], $row['img'], convertorderbyoutgally ($orderby) ), $template);
			// get some image info stuff out of the way here
			if ($row['filetype'] == 1) {
				$row['imginfo'] = @getimagesize ($opnConfig['datasave']['egallery']['path'] . $crow['galloc'] . '/' . $row['img']);
			} else {
				$row['imginfo'] = false;
				$row['imginfo'][0] = $row['width'];
				$row['imginfo'][1] = $row['height'];
				$row['imginfo'][2] = $row['description_media'];
				$row['imginfo'][3] = 'width="' . $row['width'] . '" height="' . $row['height'] . '"';
			}
			// ok, back to what we were doing
			$val_description = displayDescriptionGall ($row, $crow);
			$val_rate = displayRateGall ($row);
			$val_format = displayFormatGall ($row);
			$val_size = displaySizeGall ($row);
			$val_nmbComments = displayNumCommentsGall ($row);
			$val_new = displayNewGall ($row);
			$val_hits = displayHitsGall ($row);
			$val_date = displayDateAddedGall ($row);
			$val_name = displayName ($row);
			$template = str_replace ('<:DESCRIPTION:>', $val_description, $template);
			$template = str_replace ('<:RATE:>', $val_rate, $template);
			$template = str_replace ('<:FORMAT:>', $val_format, $template);
			$template = str_replace ('<:SIZE:>', $val_size, $template);
			$template = str_replace ('<:NBCOMMENTS:>', $val_nmbComments, $template);
			$template = str_replace ('<:NEW:>', $val_new, $template);
			$template = str_replace ('<:HITS:>', $val_hits, $template);
			$template = str_replace ('<:DATE:>', $val_date, $template);
			$template = str_replace ('<:NAME:>', $val_name, $template);
			$table->AddDataCol ($template);
			$c++;
			if ($c == $crow['numcol'] && $nb != $crow['numcol']) {
				$table->AddChangeRow ();
				$c = 0;
			}
			$egsgresult->MoveNext ();
		}
		$egsgresult->Close ();
		$table->AddDataCol ('&nbsp;');
		$table->AddCloseRow ();
		$table->GetTable ($boxtxt);
		$boxtxt .= '<div class="centertag"><br />' . $nav . '<br />';
		if ($opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_DISPLAYSEARCH, true) ) {
			$boxtxt .= search_form ();
		}
		$boxtxt .= '</div>' . _OPN_HTML_NL;
		if ($res['total']>0 && !$opnConfig['permission']->IsUser () ) {
			$boxtxt .= '<br /><div align="center" class="smalltextitalic">' . sprintf (_EGALLERY_GALCATMEMBERS, $opnConfig['opn_url']) . '</div>' . _OPN_HTML_NL;
		}
		// $boxtxt .= '</td></tr></table>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EGALLERY_390_';
		$_display_dat['module'] = 'modules/egallery';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_EGALLERY_GAL, $boxtxt, _EGALLERY_GALFOOTER);
	} else {
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EGALLERY_400_';
		$_display_dat['module'] = 'modules/egallery';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_EGALLERY_GALNOTALLOWED, _EGALLERY_GALCANNOTBEDISPLAYED, _EGALLERY_GALFOOTER);
	}

}

?>