<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function displayIconCat ($row) {

	global $opnConfig;

	$imgsize = sgetimagesize ($opnConfig['datasave']['egallery']['path'] . $row['galloc'] . '/' . $row['gallimg']);
	if ($row['visible'] == 1) {
		if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) || $opnConfig['permission']->IsUser () ) {
			return '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
								'op' => 'showgall',
								'gid' => $row['gallid']) ) . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['datasave']['egallery']['url'] . '/' . $row['galloc'] . '/' . $row['gallimg'] . '" alt="' . $row['gallname'] . '" title="' . $row['gallname'] . '" ' . $imgsize[3] . ' class="imgtag" />' . _OPN_HTML_NL . '</a>' . _OPN_HTML_NL;
		}
		return '<img src="' . $opnConfig['datasave']['egallery']['url'] . '/' . $row['galloc'] . '/' . $row['gallimg'] . '" alt="' . $row['gallname'] . '" title="' . $row['gallname'] . '" ' . $imgsize[3] . ' class="imgtag" />' . _OPN_HTML_NL;
	}
	return '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
						'op' => 'showgall',
						'gid' => $row['gallid']) ) . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['datasave']['egallery']['url'] . '/' . $row['galloc'] . '/' . $row['gallimg'] . '" alt="' . $row['gallname'] . '" title="' . $row['gallname'] . '" ' . $imgsize[3] . ' class="imgtag" />' . _OPN_HTML_NL . '</a>' . _OPN_HTML_NL;

}

function displayDescriptionCat ($row) {
	return '<span class="normaltext">' . nl2br ($row['description']) . '</span>' . _OPN_HTML_NL;

}

function displayCatName ($row) {

	global $opnConfig;
	if ($row['visible'] == 1 && !$opnConfig['permission']->IsUser () ) {
		$vis = '<span class="smalltext">(*)</span>' . _OPN_HTML_NL;
	} else {
		$vis = '';
	}
	if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
		switch ($row['visible']) {
			case 0:
				$vis .= '&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/admin/index.php',
										'op' => 'editcategory',
										'type' => 'status',
										'visible' => '1',
										'category' => $row['gallid'],
										'gouser' => '1') ) . '" title="' . _EGALLERY_GALVISIBLEADMIN . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/red_dot.gif" class="imgtag" width="10" height="10" alt="' . _EGALLERY_GALVISIBLEADMIN . '" title="' . _EGALLERY_GALVISIBLEADMIN . '" /></a>&nbsp;' . _OPN_HTML_NL;
				break;
			case 1:
				$vis .= '&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/admin/index.php',
										'op' => 'editcategory',
										'type' => 'status',
										'visible' => '2',
										'category' => $row['gallid'],
										'gouser' => '1') ) . '" title="' . _EGALLERY_GALVISIBLEMEMBER . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/yellow_dot.gif" class="imgtag" width="10" height="10" alt="' . _EGALLERY_GALVISIBLEMEMBER . '" title="' . _EGALLERY_GALVISIBLEMEMBER . '" /></a>&nbsp;' . _OPN_HTML_NL;
				break;
			default:
				$vis .= '&nbsp;<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/admin/index.php',
										'op' => 'editcategory',
										'type' => 'status',
										'visible' => '0',
										'category' => $row['gallid'],
										'gouser' => '1') ) . '" title="' . _EGALLERY_GALVISIBLEPUBLIC . '">' . _OPN_HTML_NL . '<img src="' . $opnConfig['opn_url'] . '/modules/egallery/images/green_dot.gif" class="imgtag" width="10" height="10" alt="' . _EGALLERY_GALVISIBLEPUBLIC . '" title="' . _EGALLERY_GALVISIBLEPUBLIC . '" /></a>&nbsp;' . _OPN_HTML_NL;
				break;
		}
	}
	if ($row['visible'] == 1 && !$opnConfig['permission']->IsUser () && !$opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
		$out = '<span class="normaltext">' . underscoreTospace ($row['gallname']) . '</span> <span class="smalltext">(' . $row['total'] . ') ' . $vis . '</span>' . _OPN_HTML_NL;
	} else {
		$out = '<a class="normaltextbold" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
										'op' => 'showgall',
										'gid' => $row['gallid']) ) . '">' . underscoreTospace ($row['gallname']) . '</a> <span class="smalltext">(' . $row['total'] . ') ' . $vis . '</span>' . _OPN_HTML_NL;
	}
	$out .= buildnewtag ($row['new_day']);
	return $out;

}

function navigationSubCat ($row) {

	global $opnTables, $opnConfig;
	if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
		$egnscresult = &$opnConfig['database']->Execute ('SELECT gallid, gallname FROM ' . $opnTables['gallery_categories'] . ' WHERE parent=' . $row['gallid'] . ' AND visible>=0 ORDER by gallname');
	} else {
		$egnscresult = &$opnConfig['database']->Execute ('SELECT gallid, gallname FROM ' . $opnTables['gallery_categories'] . ' WHERE parent=' . $row['gallid'] . ' AND visible>0 ORDER by gallname');
	}
	if ($egnscresult->RecordCount () == 0) {
		return '';
	}
	$c = false;
	$out = '';
	while (! $egnscresult->EOF) {
		$row = $egnscresult->GetRowAssoc ('0');
		if ($c) {
			$out .= ', ';
		}
		$out .= '<a class="normaltext" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/egallery/index.php',
									'op' => 'showgall',
									'gid' => $row['gallid']) ) . '">' . $row['gallname'] . '</a>';
		$c = true;
		$egnscresult->MoveNext ();
	}
	$egnscresult->Close ();
	return $out;

}

function viewcats () {

	global $opnConfig, $opnTables;

	$egsql = 'SELECT templatecategory, templatecss FROM ' . $opnTables['gallery_template_types'] . ' WHERE id=' . $opnConfig['egallery_maintemplate'];
	$egvcresult = &$opnConfig['database']->Execute ($egsql);
	$trow = $egvcresult->GetRowAssoc ('0');
	$egvcresult->Close ();
	if ($opnConfig['permission']->HasRight ('modules/egallery', _PERM_ADMIN, true) ) {
		$egsql = 'SELECT gallid, gallname, gallimg, galloc, description, parent, visible, template, thumbwidth, numcol, total, lastadd, lastadd AS new_day FROM ' . $opnTables['gallery_categories'] . ' WHERE parent=-1 AND visible>=0 ORDER BY gallname';
		$egvcresult = &$opnConfig['database']->Execute ($egsql);
	} else {
		$egsql = 'SELECT gallid, gallname, gallimg, galloc, description, parent, visible, template, thumbwidth, numcol, total, lastadd, lastadd AS new_day FROM ' . $opnTables['gallery_categories'] . ' WHERE parent=-1 AND visible>0 ORDER BY gallname';
		$egvcresult = &$opnConfig['database']->Execute ($egsql);
	}
	$egsql = 'SELECT COUNT(gallid) AS total FROM ' . $opnTables['gallery_categories'] . ' WHERE parent=-1 AND visible=1';
	$egvcresult2 = &$opnConfig['database']->Execute ($egsql);
	$res = $egvcresult2->GetRowAssoc ('0');
	$egvcresult2->Close ();
	$nb = $egvcresult->RecordCount ();
	if ($nb >= $opnConfig['egallery_numColMain']) {
		$pc = ceil (100/ $opnConfig['egallery_numColMain']);
	} else {
		if ($nb>0) {
			$pc = ceil (100/ $nb);
			$opnConfig['egallery_numColMain'] = $nb;
		} else {
			$pc = 100;
			$opnConfig['egallery_numColMain'] = 1;
		}
	}
	// Start Of Output
	$boxtxt = '<br /><br />' . navigationGall () . '<br />';
	$table = & new opn_TableClass ('default', '2');
	$table->AddOpenColGroup ();
	for ($xx = 1; $xx<= $opnConfig['egallery_numColMain']; $xx++) {
		$table->AddCol ($pc . '%');
	}
	$table->AddCloseColGroup ();
	$table->AddOpenRow ();
	$c = 0;
	while (! $egvcresult->EOF) {
		$row = $egvcresult->GetRowAssoc ('0');
		$template = $trow['templatecategory'];
		$template = str_replace ('<:IMAGE:>', displayIconCat ($row), $template);
		$template = str_replace ('<:GALLNAME:>', displayCatName ($row), $template);
		$template = str_replace ('<:DESCRIPTION:>', displayDescriptionCat ($row), $template);
		$template = str_replace ('<:SUBCATEGORIES:>', navigationSubCat ($row), $template);
		$table->AddDataCol ($template, 'center', '', 'top');
		$c++;
		if ($c == $opnConfig['egallery_numColMain']&$nb != $opnConfig['egallery_numColMain']) {
			$table->AddChangeRow ();
			$c = 0;
		}
		$egvcresult->MoveNext ();
	}
	$egvcresult->Close ();
	$table->AddDataCol ('&nbsp;');
	$table->AddChangeRow ();
	$hlp = '';
	if ($opnConfig['permission']->HasRight ('modules/egallery', _EGALLERY_PERM_DISPLAYSEARCH, true) ) {
		$hlp .= search_form ();
	}
	if ($res['total']>0 && !$opnConfig['permission']->IsUser () ) {
		$hlp .= '<span class="smalltextitalic">' . sprintf (_EGALLERY_GALCATMEMBERS, $opnConfig['opn_url']) . '</span>';
	}
	$table->AddDataCol ('<br />' . $hlp . '&nbsp;', 'center', $opnConfig['egallery_numColMain']);
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_EGALLERY_550_';
	$_display_dat['module'] = 'modules/egallery';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_EGALLERY_GAL, $boxtxt, _EGALLERY_GALFOOTER);

}

?>