<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/glossar', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/glossar/admin/language/');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_categorie.functions.php');
include (_OPN_ROOT_PATH . 'modules/glossar/functions.php');
$mf = & new CatFunctions ('glossary', false);
$mf->itemtable = $opnTables['glossary'];
$mf->itemid = 'gloid';
$mf->itemlink = 'catid';
$mf->itemwhere = "status = ''";
$categories = & new opn_categorie ('glossary', 'glossary');
$categories->SetModule ('modules/glossar');
$categories->SetItemID ('gloid');
$categories->SetImagePath ($opnConfig['datasave']['glossar_cat']['path']);
$categories->SetItemLink ('catid');
$categories->SetScriptname ('index');
$categories->SetWarning (_GLOADMIN_YOUWANTTODELETE);

function glossarConfigHeader () {

	global $opnTables, $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_GLOADMIN_GLOSSARYADMINISTRATION);
	$menu->InsertEntry (_GLOADMIN_MAIN, $opnConfig['opn_url'] . '/modules/glossar/admin/index.php');
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(gloid) AS counter FROM ' . $opnTables['glossary'] . " WHERE status='N'");
	if ( (is_object ($result) ) && (isset ($result->fields['counter']) ) ) {
		$number = $result->fields['counter'];
	} else {
		$number = 0;
	}
	$menu->InsertEntry (sprintf (_GLOADMIN_NEWDEFINITIONS . ' (%s)', $number), array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
											'op' => 'requesteddefinitions',
											'status' => 'N',
											'glocatid' => '0') );
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(gloid) AS counter FROM ' . $opnTables['glossary'] . " WHERE status='R'");
	if ( (is_object ($result) ) && (isset ($result->fields['counter']) ) ) {
		$number = $result->fields['counter'];
	} else {
		$number = 0;
	}
	$menu->InsertEntry (sprintf (_GLOADMIN_REQUESTEDDEFINITIONS . ' (%s)', $number), array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
												'op' => 'requesteddefinitions',
												'status' => 'R',
												'glocatid' => '0') );
	$menu->InsertEntry (_GLOADMIN_CATEGORY, array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
							'op' => 'catConfigMenu'),
							'',
							true);
	$menu->InsertEntry (_GLOADMIN_ADDADEFINITION, array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
							'op' => 'doadddefinition') );
	$menu->InsertEntry (_GLOADMIN_CHANGEDEFINITIONS, array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
								'op' => 'domodifydefinition') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function doaddglossardefinitionadmin () {

	global $opnConfig, $mf;

	glossarConfigHeader ();
	$opnConfig['opndate']->now ();
	$tday = '';
	$opnConfig['opndate']->getDay ($tday);
	$tmonth = '';
	$opnConfig['opndate']->getMonth ($tmonth);
	$tyear = '';
	$opnConfig['opndate']->getYear ($tyear);
	$thour = '';
	$opnConfig['opndate']->getHour ($thour);
	$tmin = '';
	$opnConfig['opndate']->getMinute ($tmin);
	$boxtxt = '<span class="extratextbold">' . _GLOADMIN_ADDDEFINITION . '</span><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_GLOSSAR_10_', 'glossar');
	$form->Init ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php');
	$form->AddCheckField ('keyphrase', 'e', _GLOADMIN_ERR_KEYPHRASE);
	$form->AddCheckField ('definition', 'e', _GLOADMIN_ERR_DEFDEFINITION);
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddLabel ('catid', _GLOADMIN_CHOOSECATEGORY);
	$options = array ();
	$options = build_categoryselect ($options, $mf);
	$form->AddSelect ('catid', $options);
	$form->AddChangeRow ();
	$form->AddLabel ('keyphrase', _GLOADMIN_DEFKEYPHRASE);
	$form->AddTextfield ('keyphrase', 80, 100);
	$form->AddChangeRow ();
	$form->AddLabel ('definition', _GLOADMIN_DEFDEFINITION);
	$form->AddTextarea ('definition');
	$form->AddChangeRow ();
	$form->AddLabel ('seealso', _GLOADMIN_DEFSEEALSOWORDS);
	$form->AddTextfield ('seealso', 80, 255);
	$form->AddChangeRow ();
	$form->AddLabel ('linkto', _GLOADMIN_DEFLINKTO);
	$form->AddTextfield ('linkto', 80, 255);
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->SetSameCol ();
	$form->AddSelect ('myday', buildDaySelectGLO (), $tday);
	$form->AddSelect ('mymonth', buildMonthSelectGLO (), $tmonth);
	$form->AddSelect ('myyear', buildYearSelectGLO (), $tyear);
	$form->AddText ('&nbsp;&nbsp;&nbsp;&nbsp;');
	$form->AddSelect ('myhour', buildHourSelectGLO (), $thour);
	$tmin = floor ($tmin/15)*15;
	$form->AddSelect ('mymin', buildMinSelectGLO (), $tmin);
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('status', '');
	$form->AddHidden ('op', 'glodefinitionmake');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _GLOADMIN_SAVEDEFINITION);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_20_';
	$_display_dat['module'] = 'modules/glossar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_GLOADMIN_GLOSSARYADMINISTRATION, $boxtxt);

}

function makeaddglossardefinition () {

	global $opnTables, $opnConfig;

	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$keyphrase = '';
	get_var ('keyphrase', $keyphrase, 'form', _OOBJ_DTYPE_CLEAN);
	$definition = '';
	get_var ('definition', $definition, 'form', _OOBJ_DTYPE_CLEAN);
	$seealso = '';
	get_var ('seealso', $seealso, 'form', _OOBJ_DTYPE_CLEAN);
	$linkto = '';
	get_var ('linkto', $linkto, 'form', _OOBJ_DTYPE_CLEAN);
	$myyear = 0;
	get_var ('myyear', $myyear, 'form', _OOBJ_DTYPE_INT);
	$mymonth = 0;
	get_var ('mymonth', $mymonth, 'form', _OOBJ_DTYPE_INT);
	$myday = 0;
	get_var ('myday', $myday, 'form', _OOBJ_DTYPE_INT);
	$myhour = 0;
	get_var ('myhour', $myhour, 'form', _OOBJ_DTYPE_INT);
	$mymin = 0;
	get_var ('mymin', $mymin, 'form', _OOBJ_DTYPE_INT);
	$gloid = $opnConfig['opnSQL']->get_new_number ('glossary', 'gloid');
	$keyphrase = trim ($keyphrase);
	$orderchar = build_orderchar ($keyphrase);
	$keyphrase = $opnConfig['opnSQL']->qstr ($keyphrase);
	$definition = $opnConfig['opnSQL']->qstr (trim ($definition), 'definition');
	$seealso = $opnConfig['opnSQL']->qstr (trim ($seealso) );
	$linkto = $opnConfig['opnSQL']->qstr (trim ($linkto) );
	$opnConfig['opndate']->setTimestamp ($myyear . '-' . $mymonth . '-' . $myday . ' ' . $myhour . ':' . $mymin . ':00');
	$mydatestring = '';
	$opnConfig['opndate']->opnDataTosql ($mydatestring);
	$_orderchar = $opnConfig['opnSQL']->qstr ($orderchar);
	$sql = 'INSERT INTO ' . $opnTables['glossary'] . " VALUES ($gloid, $catid, $_orderchar," . " $keyphrase, $definition, $seealso, $linkto, ''," . " $mydatestring)";
	$opnConfig['database']->Execute ($sql);
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['glossary'], 'gloid=' . $gloid);
	glossarConfigHeader ();

}

function domodifyglossardefinition () {

	global $opnConfig;

	glossarConfigHeader ();
	$mycategorieslist = build_categorylist ('?op=listdefinitionincategory&glocatid=');
	$boxtxt = '<span class="extratextbold">' . _GLOADMIN_SELECTMODIFYDEFINITIONCATEGORY . '</span>' . '<br /><br />' . '<a href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php',
																			'op' => 'listdefinitionincategory',
																			'glocatid' => '0') ) . '">' . _GLOADMIN_LISTALL . '</a>' . '<br /><br />' . _GLOADMIN_PLEASECHOOSECATFROMDEFINITION . '<br /><blockquote>' . $mycategorieslist . '</blockquote><br /><br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_30_';
	$_display_dat['module'] = 'modules/glossar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_GLOADMIN_GLOSSARYADMINISTRATION, $boxtxt);

}

function listdefinitionincategory () {

	global $opnConfig, $mf;

	$glocatid = 0;
	get_var ('glocatid', $glocatid, 'both', _OOBJ_DTYPE_INT);
	$status = '';
	get_var ('status', $status, 'both', _OOBJ_DTYPE_CLEAN);
	glossarConfigHeader ();
	$mycats = $mf->composeCatArray ();
	$listthiscategorie[] = $glocatid;
	$namethiscategory = array ();
	foreach ($mycats as $v) {
		if ($glocatid == 0) {
			$listthiscategorie[] = $v['catid'];
		}
		$namethiscategory[$v['catid']] = $v['name'];
	}
	$_status = $opnConfig['opnSQL']->qstr ($status);
	$mf->itemwhere = "status=$_status";
	$result = $mf->GetItemResult (array ('gloid',
					'catid',
					'keyphrase',
					'status'),
					array ('catid',
		'orderchar',
		'keyphrase'),
		'catid IN (' . implode (', ',
		$listthiscategorie) . ')');
	if (is_object ($result) ) {
		$result_count = $result->RecordCount ();
	} else {
		$result_count = 0;
	}
	if ($result_count == 0) {
		$boxtxt = _GLOADMIN_NODEFINITIONSFOUND;
	} else {
		$boxtxt = '<span class="extratextbold">' . _GLOADMIN_LISTMODIFYDEFINITION . '</span>' . '<br /><br />';
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('15%', '65%', '10%', '10%') );
		$table->AddHeaderRow (array (_GLOADMIN_CATEGORY, _GLOADMIN_KEYPHRASE, _GLOADMIN_STATUS, _GLOADMIN_OPTIONS) );
		while (! $result->EOF) {
			$gloid = $result->fields['gloid'];
			$catid = $result->fields['catid'];
			$keyphrase = $result->fields['keyphrase'];
			$status = $result->fields['status'];
			$table->AddDataRow (array ($namethiscategory[$catid], $keyphrase, $status, $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php', 'op' => 'modifydefinition', 'gloid' => $gloid) ) . ' ' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php', 'op' => 'deletedefinition', 'gloid' => $gloid) )), array ('left', 'center', 'center', 'center') );
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_40_';
	$_display_dat['module'] = 'modules/glossar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_GLOADMIN_GLOSSARYADMINISTRATION, $boxtxt);

}

function modifydefinition () {

	global $opnConfig, $opnTables, $mf;

	$gloid = 0;
	get_var ('gloid', $gloid, 'url', _OOBJ_DTYPE_INT);
	glossarConfigHeader ();
	$sql = 'SELECT gloid, catid, keyphrase, definition, seealso, linkto, status FROM ' . $opnTables['glossary'] . ' WHERE gloid=' . $gloid;
	$definition = &$opnConfig['database']->Execute ($sql);
	if (is_object ($definition) ) {
		$defcount = $definition->RecordCount ();
	} else {
		$defcount = 0;
	}
	if ($defcount <> 1) {
		$boxtxt = '' . _GLOADMIN_NODEFINITIONSFOUND;
	} else {
		$catid = $definition->fields['catid'];
		$keyphrase = $definition->fields['keyphrase'];
		$definitiontext = $definition->fields['definition'];
		$seealso = $definition->fields['seealso'];
		$linkto = $definition->fields['linkto'];
		$status = $definition->fields['status'];
		$opnConfig['opndate']->now ();
		$tday = '';
		$opnConfig['opndate']->getDay ($tday);
		$tmonth = '';
		$opnConfig['opndate']->getMonth ($tmonth);
		$tyear = '';
		$opnConfig['opndate']->getYear ($tyear);
		$thour = '';
		$opnConfig['opndate']->getHour ($thour);
		$tmin = '';
		$opnConfig['opndate']->getMinute ($tmin);
		$boxtxt = '<span class="extratextbold">' . _GLOADMIN_MODIFYDEFINITION . '</span><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_GLOSSAR_50_', 'glossar');
		$form->Init ($opnConfig['opn_url'] . '/modules/glossar/admin/index.php');
		$form->AddCheckField ('keyphrase', 'e', _GLOADMIN_ERR_KEYPHRASE);
		$form->AddCheckField ('definition', 'e', _GLOADMIN_ERR_DEFDEFINITION);
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->AddOpenRow ();
		$form->AddLabel ('catid', _GLOADMIN_CHOOSECATEGORY);
		$options = array ();
		$options = build_categoryselect ($options, $mf);
		$form->AddSelect ('catid', $options, $catid);
		$form->AddChangeRow ();
		$form->AddLabel ('keyphrase', _GLOADMIN_DEFKEYPHRASE);
		$form->AddTextfield ('keyphrase', 80, 100, $keyphrase);
		$form->AddChangeRow ();
		$form->AddLabel ('definition', _GLOADMIN_DEFDEFINITION);
		$form->AddTextarea ('definition', 0, 0, '', $definitiontext);
		$form->AddChangeRow ();
		$form->AddLabel ('seealso', _GLOADMIN_DEFSEEALSOWORDS);
		$form->AddTextfield ('seealso', 80, 255, $seealso);
		$form->AddChangeRow ();
		$form->AddLabel ('linkto', _GLOADMIN_DEFLINKTO);
		$form->AddTextfield ('linkto', 80, 255, $linkto);
		$form->AddChangeRow ();
		$form->AddText (_GLOADMIN_DEFSTATUS);
		$form->SetSameCol ();
		$form->AddRadio ('status', '', ($status == ''?1 : 0) );
		$form->AddLabel ('status', _GLOADMIN_PUBLIC . '<br />', 1);
		$form->AddRadio ('status', 'N', ($status == 'N'?1 : 0) );
		$form->AddLabel ('status', _GLOADMIN_NEWDEFINITION . '<br />', 1);
		$form->AddRadio ('status', 'R', ($status == 'R'?1 : 0) );
		$form->AddLabel ('status', _GLOADMIN_REQUESTEDDEFINITION, 1);
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddSelect ('myday', buildDaySelectGLO (), $tday);
		$form->AddSelect ('mymonth', buildMonthSelectGLO (), $tmonth);
		$form->AddSelect ('myyear', buildYearSelectGLO (), $tyear);
		$form->AddText ('&nbsp;&nbsp;&nbsp;&nbsp;');
		$form->AddSelect ('myhour', buildHourSelectGLO (), $thour);
		$tmin = round ($tmin/15)*15;
		$form->AddSelect ('mymin', buildMinSelectGLO (), $tmin);
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('gloid', $gloid);
		$form->AddHidden ('op', 'glodefinitionupdate');
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _GLOADMIN_SAVEDEFINITION);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_60_';
	$_display_dat['module'] = 'modules/glossar';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_GLOADMIN_GLOSSARYADMINISTRATION, $boxtxt);

}

function deleteglossardefinition () {

	global $opnTables, $opnConfig;

	$gloid = 0;
	get_var ('gloid', $gloid, 'url', _OOBJ_DTYPE_INT);
	// HHOMBERGS: IST DAS SO GEWOLLT, DASS EINE DEFINITON OHNE SICHERHEITSABFRAGE GELSCHT WIRD????
	// STEFAN: AW: NEIN HAT BLOSS KEINER EINGEBAUT :)
	$sql = 'delete FROM ' . $opnTables['glossary'] . ' WHERE gloid=' . $gloid;
	$opnConfig['database']->Execute ($sql);
	glossarConfigHeader ();

}

function updateglossardefinition () {

	global $opnTables, $opnConfig;

	$gloid = '';
	get_var ('gloid', $gloid, 'form', _OOBJ_DTYPE_CLEAN);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$keyphrase = '';
	get_var ('keyphrase', $keyphrase, 'form', _OOBJ_DTYPE_CHECK);
	$definition = '';
	get_var ('definition', $definition, 'form', _OOBJ_DTYPE_CHECK);
	$seealso = '';
	get_var ('seealso', $seealso, 'form', _OOBJ_DTYPE_CLEAN);
	$linkto = '';
	get_var ('linkto', $linkto, 'form', _OOBJ_DTYPE_CLEAN);
	$myyear = 0;
	get_var ('myyear', $myyear, 'form', _OOBJ_DTYPE_INT);
	$status = '';
	get_var ('status', $status, 'form', _OOBJ_DTYPE_CLEAN);
	$mymonth = 0;
	get_var ('mymonth', $mymonth, 'form', _OOBJ_DTYPE_INT);
	$myday = 0;
	get_var ('myday', $myday, 'form', _OOBJ_DTYPE_INT);
	$myhour = 0;
	get_var ('myhour', $myhour, 'form', _OOBJ_DTYPE_INT);
	$mymin = 0;
	get_var ('mymin', $mymin, 'form', _OOBJ_DTYPE_INT);
	$keyphrase = trim ($keyphrase);
	$orderchar = build_orderchar ($keyphrase);
	$keyphrase = $opnConfig['opnSQL']->qstr ($keyphrase);
	$seealso = $opnConfig['opnSQL']->qstr (trim ($seealso) );
	$linkto = $opnConfig['opnSQL']->qstr (trim ($linkto) );
	$definition = $opnConfig['opnSQL']->qstr (trim ($definition), 'definition');
	$opnConfig['opndate']->setTimestamp ($myyear . '-' . $mymonth . '-' . $myday . ' ' . $myhour . ':' . $mymin . ':00');
	$mydatestring = '';
	$opnConfig['opndate']->opnDataTosql ($mydatestring);
	$_orderchar = $opnConfig['opnSQL']->qstr ($orderchar);
	$_status = $opnConfig['opnSQL']->qstr ($status);
	$sql = 'UPDATE ' . $opnTables['glossary'] . " SET catid=$catid, orderchar=$_orderchar, keyphrase=$keyphrase, definition=$definition, seealso=$seealso, linkto=$linkto, status=$_status, lastmod=$mydatestring WHERE gloid=$gloid";
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['glossary'], 'gloid=' . $gloid);
	$opnConfig['database']->Execute ($sql);
	glossarConfigHeader ();

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'requesteddefinitions':
		listdefinitionincategory ();
		break;
	case 'newdefinitions':
		listdefinitionincategory ();
		break;
	case 'glodefinitionmake':
		makeaddglossardefinition ();
		break;
	case 'doadddefinition':
		doaddglossardefinitionadmin ();
		break;
	case 'domodifydefinition':
		domodifyglossardefinition ();
		break;
	case 'glodefinitionupdate':
		updateglossardefinition ();
		break;
	case 'listdefinitionincategory':
		listdefinitionincategory ();
		break;
	case 'modifydefinition':
		modifydefinition ();
		break;
	case 'deletedefinition':
		deleteglossardefinition ();
		break;
	case 'catConfigMenu':
		glossarConfigHeader ();
		$boxtxt = $categories->DisplayCats ();
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_70_';
		$_display_dat['module'] = 'modules/glossar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_GLOADMIN_GLOSSARYADMINISTRATION, $boxtxt);
		break;
	case 'addCat':
		glossarConfigHeader ();
		$categories->AddCat ();
		break;
	case 'modCat':
		glossarConfigHeader ();
		$boxtxt = $categories->ModCat ();
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_80_';
		$_display_dat['module'] = 'modules/glossar';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_GLOADMIN_GLOSSARYADMINISTRATION, $boxtxt);
		break;
	case 'modCatS':
		glossarConfigHeader ();
		$categories->ModCatS ();
		break;
	case 'delCat':
		$ok = 0;
		get_var ('ok', $ok, 'both', _OOBJ_DTYPE_INT);
		glossarConfigHeader ();
		if (!$ok) {
			$boxtxt = $categories->DeleteCat ('');
			$_display_dat = array ();
			$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_GLOSSAR_90_';
			$_display_dat['module'] = 'modules/glossar';
			$opnConfig['opnOutput']->SetDisplay ($_display_dat);
			unset ($_display_dat);
			$opnConfig['opnOutput']->DisplayCenterbox (_GLOADMIN_GLOSSARYADMINISTRATION, $boxtxt);
		} else {
			$categories->DeleteCat ('');
		}
		break;
	case 'OrderCat':
		glossarConfigHeader ();
		$categories->OrderCat ();
		break;
	default:
		glossarConfigHeader ();
		break;
}
$opnConfig['opnOutput']->DisplayFoot ();

?>