<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function howto_nav ($letter, $name, $howtotitle = '') {

	global $opnConfig, $opnTables;

	$boxtxt = '<div class="centertag"><span class="normaltextbold">';
	if ($letter == 'ALL') {
		$boxtxt .= _HOWTO_LIST_ALL;
	} elseif ($letter == '123') {
		$boxtxt .= _HOWTO_LIST_OTHER;
	} elseif ($letter != '') {
		$boxtxt .= sprintf (_HOWTO_LIST_BEGINN, $letter);
	} elseif ($name != '') {
		$boxtxt .= sprintf (_HOWTO_LIST_WRITTEN, $name);
	} else {
		$boxtxt .= sprintf (_HOWTO_LIST_WELCOME, $opnConfig['sitename']);
	}
	$boxtxt .= '</span><br /><br />';
	$boxtxt .= $howtotitle;
	if (isset ($opnConfig['howto_lettersasnormallink']) && $opnConfig['howto_lettersasnormallink'] == 1) {
		$classname = 'opncenterbox';
	} else {
		$classname = 'txtbutton';
	}
	if (isset ($opnConfig['howto_showonlypossibleletters']) && $opnConfig['howto_showonlypossibleletters'] == 1) {
		$sql = 'SELECT orderchar FROM ' . $opnTables['howto'] . ' GROUP BY orderchar';
	} else {
		$sql = '';
	}
	$boxtxt .= build_letterpagebar (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
						'op' => 'howto'),
						'letter',
						$letter,
						$sql);
	$boxtxt .= '<br />';
	if ($opnConfig['permission']->HasRights ('modules/howto', array (_PERM_WRITE, _PERM_ADMIN), true) ) {
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/howto/index.php?op=write_howto') . '"><span class="normaltextbold">' . _HOWTO_WRITE_HOWTO . '</span></a>';
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/search') ) {
		$boxtxt .= '<br />';
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HOWTO_100_', 'howto');
		$form->Init ($opnConfig['opn_url'] . '/system/search/index.php', 'post');
		$form->AddTextfield ('query', 17);
		$form->AddText ('&nbsp;');
		$form->AddHidden ('types[]', 'howto');
		$form->AddSubmit ('submit', _HOWTO_SEARCH);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$boxtxt .= '</div><br />';
	return $boxtxt;

}

function howto_display_score ($score) {

	global $opnConfig;

	$image = '<img src="' . $opnConfig['opn_default_images'] . 'blue.gif" alt="" />';
	$halfimage = '<img src="' . $opnConfig['opn_default_images'] . 'bluehalf.gif" alt="" />';
	$full = '<img src="' . $opnConfig['opn_default_images'] . 'star.gif" alt="" />';
	$boxtxt = '';
	if ($score == 10) {
		for ($i = 0; $i<5; $i++) $boxtxt .= $full;
	} elseif ($score%2) {
		$score -= 1;
		$score /= 2;
		for ($i = 0; $i< $score; $i++) $boxtxt .= $image; $boxtxt .= $halfimage;
	} else {
		$score /= 2;
		for ($i = 0; $i< $score; $i++) $boxtxt .= $image;
	}
	return $boxtxt;

}

function write_howto ($mf) {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/howto', array (_PERM_WRITE, _PERM_ADMIN) );
	$boxtxt = '<br />';
	$boxtxt .= '<span class="normaltextbold">' . _HOWTO_WRITE_HOWTO_FOR . ' ' . $opnConfig['sitename'] . '</span><br /><br /><span class="normaltextitalic">' . _HOWTO_SPECS_TEXT . '</span><br /><br /><div class="normaltext">';
	$boxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HOWTO_110_', 'howto');
	$form->Init ($opnConfig['opn_url'] . '/modules/howto/index.php', 'post', 'coolsus');
	$form->AddCheckField ('title', 'e', _HOWTO_ERR_TITLE);
	$form->AddCheckField ('text', 'e', _HOWTO_ERR_TITLE_TEXT);
	$form->AddCheckField ('score', '<', _HOWTO_ERR_SCORE,'',0);
	$form->AddCheckField ('score', '>', _HOWTO_ERR_SCORE,'',11);
	$form->AddCheckField ('howtoer', 'e', _HOWTO_ERR_NAME_EMAIL);
	$form->AddCheckField ('email', 'e', _HOWTO_ERR_NAME_EMAIL);
	$form->AddCheckField ('email', 'm', _HOWTO_ERR_EMAIL);
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('title', _HOWTO_PRODUCT_TITLE);
	$form->AddTextfield ('title', 50, 150);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('text', _HWT_DES);
	$form->AddText ('<br /><span class="normaltextitalic">' . _HOWTO_WRITE_TEXT . '</span><br />');
	$form->SetEndCol ();
	$form->UseImages (true);
	$form->AddTextarea ('text');
	if ($opnConfig['permission']->IsUser () ) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$name = $userinfo['uname'];
		$email = '';
		if (isset ($userinfo['femail']) ) {
			$email = $userinfo['femail'];
		}
	}
	if (!isset ($name) ) {
		$name = '';
	}
	if (!isset ($email) ) {
		$email = '';
	}
	$form->AddChangeRow ();
	$form->AddLabel ('howtoer', _HOWTO_YOUR_NAME);
	$form->SetSameCol ();
	$form->AddTextfield ('howtoer', 40, 20, $name);
	$form->AddText ('<br /><span class="normaltextitalic">' . _HOWTO_YOUR_NAME_REQUIRED . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('email', _HOWTO_YOUR_EMAIL);
	$form->SetSameCol ();
	$form->AddTextfield ('email', 40, 60, $email);
	$form->AddText ('<br /><span class="normaltextitalic">' . _HOWTO_YOUR_EMAIL_REQUIRED . '</span>');
	$form->SetEndCol ();
	$options = array ();
	for ($i = 10; $i>0; $i--) {
		$options[$i] = $i;
	}
	$form->AddChangeRow ();
	$form->AddLabel ('score', _HOWTO_SCORE);
	$form->SetSameCol ();
	$form->AddSelect ('score', $options);
	$form->AddText ('<br /><span class="normaltextitalic">' . _HOWTO_SCORE_TEXT . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('url', _HOWTO_RELAT_LINK);
	$form->SetSameCol ();
	$form->AddTextfield ('url', 40, 100, 'http://');
	$form->AddText ('<br /><span class="normaltextitalic">' . _HOWTO_RELAT_LINK_TEXT . ' "http://"</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('url_title', _HOWTO_LINK_TITLE);
	$form->SetSameCol ();
	$form->AddTextfield ('url_title', 40, 50);
	$form->AddText ('<br /><span class="normaltextitalic">' . _HOWTO_LINK_TITLE_TEXT . '</span>');
	$form->SetEndCol ();
	$form->AddChangeRow ();
	$form->AddLabel ('cid', _HOWTO_CATE);
	$mf->makeMySelBox (0, $form, 0, 'cid');
	if ($opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN, true) ) {
		$form->AddChangeRow ();
		$form->AddLabel ('cover', _HOWTO_IMAGE_NAME);
		$form->SetSameCol ();
		$form->AddTextfield ('cover', 40, 100);
		$form->AddText ('<br /><span class="normaltextitalic">' . sprintf (_HOWTO_IMAGE_NAME_TEXT, $opnConfig['datasave']['howto_images']['url']) . '</span>');
		$form->SetEndCol ();
	}
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddText ('<span class="normaltextitalic">' . _HOWTO_WRITE_HOWTO_TEXT . '</span>');
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'preview_howto');
	$form->SetSameCol ();
	$form->AddSubmit ('submit', _HOWTO_WRITE_PHOWTO);
	$form->AddText (' ');
	$form->AddButton ('Cancel', _HOWTO_WRITE_CANCEL, '', '', 'javascript:history.go(-1)');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div>';
	$opnConfig['opnOutput']->EnableJavaScript ();
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_120_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function preview_howto () {

	global $opnConfig;

	$date = '';
	get_var ('date', $date, 'form', _OOBJ_DTYPE_CLEAN);
	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$howtoer = '';
	get_var ('howtoer', $howtoer, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$cover = '';
	get_var ('cover', $cover, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$url_title = '';
	get_var ('url_title', $url_title, 'form', _OOBJ_DTYPE_CLEAN);
	$hits = 0;
	get_var ('hits', $hits, 'form', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/howto', array (_PERM_WRITE, _PERM_ADMIN) );
	$title = stripslashes ($opnConfig['cleantext']->filter_text ($title, false, true, 'nohtml') );
	$text = stripslashes ($opnConfig['cleantext']->filter_text ($text, true, true) );
	$howtoer = stripslashes ($opnConfig['cleantext']->filter_text ($howtoer, false, true, 'nohtml') );
	$url_title = stripslashes ($opnConfig['cleantext']->filter_text ($url_title, false, true, 'nohtml') );
	$opnConfig['cleantext']->filter_text ($text, true, true);
	if ($url == 'http://') {
		$url = '';
	}
	$errormsg = '';
	$boxtxt = '<br />';
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HOWTO_130_', 'howto');
	$form->Init ($opnConfig['opn_url'] . '/modules/howto/index.php', 'post', 'coolsus');
	if ( ($hits<0) && ($id != 0) ) {
		$errormsg .= _HOWTO_ERR_HITS . '<br />';
	}
	if ( ($url_title != '' && $url == '') || ($url_title == '' && $url != '') ) {
		$errormsg .= _HOWTO_ERR_LINK . '<br />';
	} elseif ( ($url != '') && (! (preg_match ('/(^http[s]*:[\/]+)(.*)/i', $url) ) ) ) {
		$url = 'http://' . $url;
	}
	if ($errormsg != '') {
		$form->AddText ($errormsg . '<br />');
		$form->AddButton ('Cancel', _HOWTO_GOBACK, '', '', 'history.go(-1)');
	} else {
		if ($date != '') {
			$opnConfig['opndate']->sqlToopnData ($date);
		}
		$fdate = '';
		$opnConfig['opndate']->formatTimestamp ($fdate, _DATE_FORUMDATESTRING2);
		if ($hits == '') {
			$hits = 1;
		}
		$form->AddText ('<div class="extratextbold" align="left">' . $title . '</div>');
		if ($cover != '') {
			$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/modules/howto/images/howto/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />');
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$showtext = make_user_images ($text);
		} else {
			$showtext = $text;
		}
		opn_nl2br ($showtext);
		$form->AddText ('<div align="left">' . $showtext . '</div>');
		$form->AddText ('<br />');
		$form->AddText (howto_extrainfo ($id, $fdate, $title, $howtoer, $email, $score, $url_title, $url, $hits, 1) );
		$text = urlencode ($text);
		$form->AddText ('<div align="center" class="normaltextitalic">' . _HOWTO_LOOK_RIGHT . ' </div>');
		$form->AddHidden ('id', $id);
		$form->AddHidden ('hits', $hits);
		$form->AddHidden ('op', 'send_howto');
		$form->AddHidden ('date', $date);
		$form->AddHidden ('title', $title);
		$form->AddHidden ('text', $text);
		$form->AddHidden ('howtoer', $howtoer);
		$form->AddHidden ('email', $email);
		$form->AddHidden ('score', $score);
		$form->AddHidden ('url', $url);
		$form->AddHidden ('url_title', $url_title);
		$form->AddHidden ('cover', $cover);
		$form->AddHidden ('cid', $cid);
		$form->AddText ('<div class="centertag">');
		$form->AddSubmit ('submit', _YES_SUBMIT);
		$form->AddText (' ');
		$form->AddButton ('Cancel', _NO_SUBMIT, '', '', 'history.go(-1)');
		$form->AddText ('</div>');
		if ($id != 0) {
			$word = _HOWTO_MOD;
		} else {
			$word = _HOWTO_ADD;
		}
		if ($opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN, true) ) {
			$form->AddText ('<br /><br /><span class="normaltextbold">' . _HOWTO_NOTE . '</span> ' . _HOWTO_LOG_ADMIN_TEXT . ' ' . $word . '&nbsp;' . _HOWTO_IMMED . '.');
		}
	}
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_140_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function send_howto () {

	global $opnTables, $opnConfig;

	$title = '';
	get_var ('title', $title, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$howtoer = '';
	get_var ('howtoer', $howtoer, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$cover = '';
	get_var ('cover', $cover, 'form', _OOBJ_DTYPE_CLEAN);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$url_title = '';
	get_var ('url_title', $url_title, 'form', _OOBJ_DTYPE_CLEAN);
	$hits = 0;
	get_var ('hits', $hits, 'form', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$cid = 0;
	get_var ('cid', $cid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/howto', array (_PERM_WRITE, _PERM_ADMIN) );
	$title = $opnConfig['cleantext']->filter_text ($title, true, true, 'nohtml');
	$orderchar = $opnConfig['opnSQL']->qstr (strtoupper ($title{0}) );
	$title = $opnConfig['opnSQL']->qstr ($title);
	$text = urldecode ($opnConfig['cleantext']->filter_text ($text, true, true, '') );
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$text = make_user_images ($text);
	}
	$url_title = $opnConfig['opnSQL']->qstr ($url_title);
	$boxtxt = '<br />';
	$boxtxt .= '<br /><div class="centertag">' . _HOWTO_THANKS;
	if ($id != 0) {
		$boxtxt .= ' ' . _HOWTO_MODI;
	} else {
		$boxtxt .= ', ' . $howtoer;
	}
	$boxtxt .= '!<br />';
	$opnConfig['cleantext']->filter_text ($howtoer, false, true, 'nohtml');
	$opnConfig['cleantext']->filter_text ($title, false, true, 'nohtml');
	$opnConfig['cleantext']->filter_text ($url_title, false, true, 'nohtml');
	$opnConfig['cleantext']->filter_text ($text, true, true);
	$opnConfig['opndate']->now ();
	$date = '';
	$opnConfig['opndate']->opnDataTosql ($date);
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$_howtoer = $opnConfig['opnSQL']->qstr ($howtoer);
	$_cover = $opnConfig['opnSQL']->qstr ($cover);
	$_url = $opnConfig['opnSQL']->qstr ($url);
	$text = $opnConfig['opnSQL']->qstr ($text, 'text');
	if ( ($opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN, true) ) && ($id == 0) ) {
		$id = $opnConfig['opnSQL']->get_new_number ('howto', 'id');
		$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['howto'] . " VALUES ($id, $date, $title, $text, $_howtoer, $_email, $score, $_cover, $_url, $url_title, 1,$cid,$orderchar)");
		if ($result === false) {
			die ('Unable to insert recordset');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['howto'], 'id=' . $id);
		$boxtxt .= _HOWTO_AVAI_TEXT;
	} elseif ( ($opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN, true) ) && ($id != 0) ) {
		$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['howto'] . " SET text=$text,wdate=$date, title=$title, howtoer=$_howtoer, email=$_email, score=$score, cover=$_cover, url=$_url, url_title=$url_title, hits=$hits, cid=$cid, orderchar=$orderchar WHERE id = $id");
		if ($result === false) {
			die ('Unable to update record');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['howto'], 'id=' . $id);
		$boxtxt .= _HOWTO_AVAI_TEXT;
	} else {
		$id = $opnConfig['opnSQL']->get_new_number ('howto_add', 'id');
		$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['howto_add'] . " VALUES ($id, $date, $title, $text, $_howtoer, $_email, $score, $_url, $url_title,$cid)");
		if ($result === false) {
			die ('Unable to insert record');
		}
		$result->Close ();
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['howto_add'], 'id=' . $id);
		$boxtxt .= _HOWTO_LOOK_SUBMISSION;
		if ($opnConfig['send_new_howto']) {
			$vars = array ();
			$mail = & new opn_mailer ();
			$mail->opn_mail_fill ($opnConfig['adminmail'], _HOWTO_HWT_SEND, 'modules/howto', 'newhowto', $vars, $opnConfig['opn_webmaster_name'], $opnConfig['adminmail']);
			$mail->send ();
			$mail->init ();
		}
	}
	$boxtxt .= '<br /><br />[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/howto/index.php">' . _HOWTO_BACK_INDEX . '</a> ]<br /></div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_150_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function howto_index ($howtocat, $mf) {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	if (!$cid) {
		$cid = 0;
		get_var ('cat_id', $cid, 'url', _OOBJ_DTYPE_INT);
	}
	$hlptxt = '';
	$boxtxt = '';
	$boxtxt2 = '';
	$title = '';
	$description = '';
	$result = &$opnConfig['database']->Execute ('SELECT title, description FROM ' . $opnTables['howto_main']);
	if ($result !== false) {
		$title = $result->fields['title'];
		$description = $result->fields['description'];
		opn_nl2br ($description);
		$result->Close ();
	}
	if ($title != '') {
		OpenTable2 ($boxtxt2);
		$boxtxt2 .= '<div align="center"><span class="normaltextbold">' . $title . '</span><br /><br />' . $description . '</div>';
		CloseTable2 ($boxtxt2);
		$boxtxt2 .= '<br />';
	}
	$boxtxt .= howto_nav ('', '', $boxtxt2);
	if ($cid == 0) {
		$boxtxt .= $howtocat->MainNavigation ();
	} else {
		$boxtxt .= $howtocat->SubNavigation ($cid);
	}
	$table = & new opn_TableClass ('alternator');
	$table->AddCols (array ('50%', '50%') );
	$table->AddHeaderRow (array (_HOWTO_10_POP, _HOWTO_10_REC) );
	$where = '';
	if ($cid != 0) {
		$where = 'i.cid=' . $cid . ' ';
	}
	$result_pop = $mf->GetItemLimit (array ('id',
						'title'),
						array ('i.hits DESC'),
		10,
		$where);
	$result_rec = $mf->GetItemLimit (array ('id',
						'title'),
						array ('i.wdate DESC'),
		10,
		$where);
	$y = 1;
	if ( ($result_pop !== false) && ($result_rec !== false) ) {
		for ($x = 0; $x<10; $x++) {
			$row = $result_pop->GetRowAssoc ('0');
			$table->AddOpenRow ();
			if ($row['id'] != '') {
				$table->AddDataCol ($y . ') <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
														'op' => 'showcontent',
														'id' => $row['id']) ) . '">' . $row['title'] . '</a>');
			} else {
				$table->AddDataCol ('&nbsp;');
			}
			$row = $result_rec->GetRowAssoc ('0');
			if ($row['id'] != '') {
				$table->AddDataCol ($y . ') <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
														'op' => 'showcontent',
														'id' => $row['id']) ) . '">' . $row['title'] . '</a>');
			} else {
				$table->AddDataCol ('&nbsp;');
			}
			$table->AddCloseRow ();
			$y++;
			$result_pop->MoveNext ();
			$result_rec->MoveNext ();
		}
		$result_pop->Close ();
		$result_rec->Close ();
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$numresults = $mf->GetItemCount ($where);
	$boxtxt .= '<div align="center" class="normaltext">' . _HOWTO_THERE_ARE . ' ' . $numresults . '&nbsp;' . _HOWTO_IN_DB . '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_160_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function howto () {

	global $opnConfig, $mf;

	$letter = '';
	get_var ('letter', $letter, 'url', _OOBJ_DTYPE_CLEAN);
	$field = 'title';
	get_var ('field', $field, 'url', _OOBJ_DTYPE_CLEAN);
	$order = 'ASC';
	get_var ('order', $order, 'url', _OOBJ_DTYPE_CLEAN);
	$name = '';
	get_var ('name', $name, 'both', _OOBJ_DTYPE_CLEAN);
	$name = $opnConfig['cleantext']->filter_searchtext ($name);
	if ( ($letter != '123') && ($letter != 'ALL') ) {
		$like_search = $opnConfig['opnSQL']->AddLike ($letter, '', '%');
		$where = "title LIKE $like_search ";
	} elseif ( ($letter == '123') && ($letter != 'ALL') ) {
		$where = $opnConfig['opnSQL']->CreateOpnRegexp ('title', '0-9');
	} elseif ($name != '') {
		$like_search = $opnConfig['opnSQL']->AddLike ($name);
		$where = "howtoer LIKE $like_search ";
	} else {
		$where = '';
	}
	$numresults = 0;
	$err = $opnConfig['cleantext']->var_possible_check ($field, array ('id','title','hits','howtoer','email','score'));
	$result = $mf->GetItemResult (array ('id',
					'title',
					'hits',
					'howtoer',
					'email',
					'score'),
					array ($field . ' ' . $order),
		$where);
	$boxtxt = howto_nav ($letter, $name);
	if ($result !== false) {
		$numresults = $result->RecordCount ();
	}
	if ($numresults == 0) {
		$boxtxt .= '<span class="normaltextbold">' . sprintf (_HOWTO_NO_HWT_FOR_LETTER, $letter) . '</span><br /><br />';
	} elseif ($numresults>0) {
		$i = 1;
		$table = & new opn_TableClass ('alternator');
		$table->AddCols (array ('40%', '21%', '21%', '18%') );
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
											'op' => 'howto',
											'letter' => $letter,
											'field' => 'title',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_small.gif" class="imgtag" title="' . _HOWTO_SORT_ASC . '"></a> ' . _HOWTO_PRODUCT_TITLE . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																															'op' => 'howto',
																															'letter' => $letter,
																															'field' => 'title',
																															'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_small.gif" class="imgtag" title="' . _HOWTO_SORT_DESC . '"></a>',
																															'left');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
											'op' => 'howto',
											'letter' => $letter,
											'field' => 'howtoer',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_small.gif" class="imgtag" title="' . _HOWTO_SORT_ASC . '"></a> ' . _HWT_ER . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																													'op' => 'howto',
																													'letter' => $letter,
																													'field' => 'howtoer',
																													'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_small.gif" class="imgtag" title="' . _HOWTO_SORT_DESC . '"></a>',
																													'center');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
											'op' => 'howto',
											'letter' => $letter,
											'field' => 'score',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_small.gif" class="imgtag" title="' . _HOWTO_SORT_ASC . '"></a> ' . _HOWTO_SCORE . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																														'op' => 'howto',
																														'letter' => $letter,
																														'field' => 'score',
																														'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_small.gif" class="imgtag" title="' . _HOWTO_SORT_DESC . '"></a>',
																														'center');
		$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
											'op' => 'howto',
											'letter' => $letter,
											'field' => 'hits',
											'order' => 'ASC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/up_small.gif" class="imgtag" title="' . _HOWTO_SORT_ASC . '"></a> ' . _HOWTO_HITS . ' <a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																													'op' => 'howto',
																													'letter' => $letter,
																													'field' => 'hits',
																													'order' => 'DESC') ) . '"><img src="' . $opnConfig['opn_default_images'] . 'arrow/down_small.gif" class="imgtag" title="' . _HOWTO_SORT_DESC . '"></a>',
																													'center');
		$table->AddCloseRow ();
		while (! $result->EOF) {
			$i++;
			$id = $result->fields['id'];
			$title = $result->fields['title'];
			$id = $result->fields['id'];
			$howtoer = $result->fields['howtoer'];
			$score = $result->fields['score'];
			$hits = $result->fields['hits'];
			// spter
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
												'op' => 'showcontent',
												'id' => $id),
												false) . '">' . $title . '</a>',
												'left');
			$table->AddDataCol ($howtoer, 'center');
			$table->AddDataCol (howto_display_score ($score), 'center');
			$table->AddDataCol ($hits, 'center');
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
		$result->Close ();
		$table->GetTable ($boxtxt);
		$boxtxt .= '<br /><div class="normaltext" align="center">' . $numresults . '&nbsp;' . _HOWTO_TOTAL . '</div><br /><br />';
	}
	$boxtxt .= '<div class="centertag">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/howto/index.php">' . _HOWTO_RET_MAIN . '</a> ]</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_170_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function howto_postcomment () {

	global $anonpost, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$title = '';
	get_var ('title', $title, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRight ('modules/howto', _PERM_WRITE);
	$title = urldecode ($title);
	$boxtxt = '<br />';
	$boxtxt .= '<div class="bigtextbold" align="center">' . _HOWTO_COM_HWT . ' ' . $title . '<br /><br /></div><div class="normaltext">';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HOWTO_180_', 'howto');
	$form->Init ($opnConfig['opn_url'] . '/modules/howto/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	if ( ( (!$opnConfig['permission']->IsUser () ) && ($anonpost == 1) ) or ($opnConfig['permission']->IsUser () ) ) {
		$form->AddText (_HOWTO_YOUR_NICKNAME);
		$form->SetSameCol ();
		if (!$opnConfig['permission']->IsUser () ) {
			$form->AddText ('Anonymous [ <a class="%alternate%" href="' . $opnConfig['opn_url'] . '/system/user/index.php">' . _HOWTO_CREATE_ACCOUNT . ' ]');
			$cookie['uname'] = 'Anonymous';
		} else {
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$form->AddText ($cookie['uname']);
			if ($anonpost == 1) {
				$form->AddCheckbox ('xanon', 1);
				$form->AddLabel ('xanon', _HOWTO_POST_ANONYM, 1);
			}
		}
		$form->AddHidden ('uname', $cookie['uname']);
		$form->AddHidden ('id', $id);
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddLabel ('score', _HOWTO_PRODUCT_SCORE);
		for ($i = 10; $i>0; $i--) {
			$options[$i] = $i;
		}
		$form->AddSelect ('score', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('comments', _HOWTO_YOU_COMM);
		$form->AddTextarea ('comments');
		$form->AddChangeRow ();
		$form->AddText ('&nbsp;');
		$form->SetSameCol ();
		$form->AddText (_HOWTO_HTML);
		$form->AddNewLine (1);
		if (is_array ($opnConfig['AllowableHTML']) ) {
			$temp = $opnConfig['AllowableHTML'];
			$tmparr = array_keys ($temp);
			foreach ($tmparr as $key) {
				$form->AddText (htmlentities ($key) . ' ');
			}
		}
		$form->AddText ('&nbsp;');
		$form->SetEndCol ();
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'savecomment');
		$form->AddSubmit ('submit', _HOWTO_SUBMIT);
	} else {
		$form->AddText (sprintf (_HOWTO_PLEASE_REG, $opnConfig['opn_url']) );
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_190_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function howto_printComments ($id) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT cid, userid, wdate, comments, score FROM ' . $opnTables['howto_comments'] . ' WHERE rid=' . $id . ' ORDER BY cid DESC');
	if ($result !== false) {
		$date = '';
		while (! $result->EOF) {
			$uname = $result->fields['userid'];
			$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
			$comments = $result->fields['comments'];
			$score = $result->fields['score'];
			if ($uname == $opnConfig['opn_anonymous_name']) {
				$boxtxt .= _HOWTO_POST_BY . ' ' . $uname . '&nbsp;' . _HOWTO_ON . ' ' . $date . '<br />';
			} else {
				$boxtxt .= _HOWTO_POST_BY . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
														'op' => 'userinfo',
														'uname' => $uname) ) . '">' . $uname . '</a> ' . _HOWTO_ON . ' ' . $date . '<br />';
			}
			$boxtxt .= _HOWTO_MY_SCORE . ' ';
			$boxtxt .= howto_display_score ($score);
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$comments = $opnConfig['cleantext']->filter_text ($comments, true, true);
			opn_nl2br ($comments);
			$boxtxt .= $comments;
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $boxtxt;

}

function howto_savecomment () {

	global $opnTables, $opnConfig;

	$xanon = 0;
	get_var ('xanon', $xanon, 'form', _OOBJ_DTYPE_INT);
	$uname = '';
	get_var ('uname', $uname, 'form', _OOBJ_DTYPE_CLEAN);
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$score = 0;
	get_var ('score', $score, 'form', _OOBJ_DTYPE_INT);
	$comments = '';
	get_var ('comments', $comments, 'form', _OOBJ_DTYPE_CHECK);
	$opnConfig['permission']->HasRight ('modules/howto', _PERM_WRITE);
	if ($xanon) {
		$uname = 'Anonymous';
	}
	$comments = $opnConfig['opnSQL']->qstr (urldecode ($opnConfig['cleantext']->filter_text ($comments, true, true) ), 'comments');
	$cid = $opnConfig['opnSQL']->get_new_number ('howto_comments', 'cid');
	$opnConfig['cleantext']->filter_text ($uname, false, true, 'nohtml');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$_uname = $opnConfig['opnSQL']->qstr ($uname);
	$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['howto_comments'] . " values ($cid, $id, $_uname, $now, $comments, $score)");
	$result->Close ();
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['howto_comments'], 'cid=' . $cid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/howto/index.php?', false, true, array ('op' => 'showcontent',
																'id' => $id) ) );

}

function howto_r_comments ($id, $title) {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$result = &$opnConfig['database']->Execute ('SELECT cid, userid, wdate, comments, score FROM ' . $opnTables['howto_comments'] . ' WHERE rid=' . $id . ' ORDER BY cid DESC');
	if ($result !== false) {
		$date = '';
		while (! $result->EOF) {
			$cid = $result->fields['cid'];
			$uname = $result->fields['userid'];
			$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
			$opnConfig['opndate']->formatTimestamp ($date, _DATE_DATESTRING5);
			$comments = $result->fields['comments'];
			$score = $result->fields['score'];
			$title = urldecode ($title);
			$boxtxt .= '<span class="normaltextbold">' . $title . '</span><br />';
			if ($uname == $opnConfig['opn_anonymous_name']) {
				$boxtxt .= _HOWTO_POST_BY . ' ' . $uname . '&nbsp;' . _HOWTO_ON . ' ' . $date . '<br />';
			} else {
				$boxtxt .= _HOWTO_POST_BY . ' <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
														'op' => 'userinfo',
														'uname' => $uname) ) . '">' . $uname . '</a> ' . _HOWTO_ON . ' ' . $date . '<br />';
			}
			$boxtxt .= _HOWTO_MY_SCORE . ' ';
			$boxtxt .= howto_display_score ($score);
			if ($opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN, true) ) {
				$boxtxt .= '<br /><span class="normaltextbold">' . _HOWTO_ADMIN . '</span> [ <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																				'op' => 'del_comment',
																				'cid' => $cid,
																				'id' => $id) ) . '">' . _HOWTO_DEL . '</a> ]<hr noshade="noshade" size="1" /><br /><br />';
			} else {
				$boxtxt .= '<hr noshade="noshade" size="1" /><br /><br />';
			}
			$comments = $opnConfig['cleantext']->filter_text ($comments, true, true);
			opn_nl2br ($comments);
			$boxtxt .= $comments;
			$boxtxt .= '<br />';
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $boxtxt;

}

function howto_showcontent () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$myrow = &$opnConfig['database']->Execute ('SELECT id, wdate, title, text, cover, howtoer, email, hits, url, url_title, score FROM ' . $opnTables['howto'] . ' WHERE id=' . $id);
	$test_id = $myrow->fields['id'];
	if ($test_id == $id) {
		$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['howto'] . ' SET hits=hits+1 WHERE id=' . $id);
		$result->Close ();
		$boxtxt = '';
		$opnConfig['opndate']->sqlToopnData ($myrow->fields['wdate']);
		$fdate = '';
		$opnConfig['opndate']->formatTimestamp ($fdate, _DATE_FORUMDATESTRING2);
		$title = $myrow->fields['title'];
		$text = $myrow->fields['text'];
		$cover = $myrow->fields['cover'];
		$howtoer = $myrow->fields['howtoer'];
		$email = $myrow->fields['email'];
		$hits = $myrow->fields['hits'];
		$url = $myrow->fields['url'];
		$url_title = $myrow->fields['url_title'];
		$score = $myrow->fields['score'];
		$boxtxt .= '<div class="extratextbold" align="left">' . $title . '</div>';
		$boxtxt .= '<br /><br />';
		$boxtxt .= '<div class="normaltext" align="left">';
		if ($cover != '') {
			$boxtxt .= '<img src="' . $opnConfig['opn_url'] . '/modules/howto/images/howto/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />';
		}
		opn_nl2br ($text);
		$boxtxt .= $text . '</div>';
		$title = urlencode ($title);
		$boxtxt .= howto_extrainfo ($id, $fdate, $title, $howtoer, $email, $score, $url_title, $url, $hits, 0);
		$boxtxt .= '<br /><br /><span class="normaltextbold">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/howto/index.php">' . _HOWTO_BACK_INDEX . '</a> ]</span>';
		$boxtxt .= '<br />';
		$boxtxt .= howto_r_comments ($id, $title);
		$myrow->Close ();
	} else {
		$boxtxt = _HOWTO_NO_HWT_FOUND;
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_200_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function mod_howto ($mf) {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN);
	$boxtxt = '<br />';
	if ( ($id == 0) ) {
		$boxtxt .= 'This function must be passed argument id, or you are not admin.';
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT id, wdate, title, text, cover, howtoer, email, hits, url, url_title, score, cid FROM ' . $opnTables['howto'] . ' WHERE id=' . $id);
		if ($result !== false) {
			$date = '';
			while (! $result->EOF) {
				$id = $result->fields['id'];
				$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
				$opnConfig['opndate']->formatTimestamp ($date);
				$title = $result->fields['title'];
				$text = $result->fields['text'];
				$cover = $result->fields['cover'];
				$howtoer = $result->fields['howtoer'];
				$email = $result->fields['email'];
				$hits = $result->fields['hits'];
				$url = $result->fields['url'];
				$url_title = $result->fields['url_title'];
				$score = $result->fields['score'];
				$cid = $result->fields['cid'];
				$result->MoveNext ();
			}
			$result->Close ();
		}
		if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
			include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
			$text = de_make_user_images ($text);
		}
		$text = opn_br2nl ($text);
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _HOWTO_MODIFIC . '</span></div><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HOWTO_210_', 'howto');
		$form->Init ($opnConfig['opn_url'] . '/modules/howto/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('title', _HOWTO_TITEL);
		$form->AddTextfield ('title', 50, 150, $title);
		$form->AddChangeRow ();
		$form->AddLabel ('date', _HOWTO_DAT);
		$form->AddTextfield ('date', 18, 18, $date);
		$text = str_replace ('&amp;', '&amp;amp;', $text);
		$text = str_replace ('&lt;', '&amp;lt;', $text);
		$text = str_replace ('&gt;', '&amp;gt;', $text);
		$form->AddChangeRow ();
		$form->UseImages (true);
		$form->AddLabel ('text', _HOWTO_TEXT);
		$form->AddTextarea ('text', 0, 0, '', $text);

		/*
		if ($opnConfig['installedPlugins']->isplugininstalled('system/user_images')) {
		include (_OPN_ROOT_PATH.'system/user_images/user_images.php');
		$form->AddText('<br /><hr /><br />');
		$form->AddText (user_images_display('coolsus'.'.'.'text','95%','100px'));
		$form->AddText('<br /><hr /><br />');
		}
		*/

		$form->AddChangeRow ();
		$form->AddLabel ('howtoer', _HWT_ER);
		$form->AddTextfield ('howtoer', 30, 20, $howtoer);
		$form->AddChangeRow ();
		$form->AddLabel ('email', _HOWTO_EMAIL);
		$form->AddTextfield ('email', 30, 60, $email);
		for ($i = 10; $i>0; $i--) {
			$options[$i] = $i;
		}
		$form->AddChangeRow ();
		$form->AddLabel ('score', _HOWTO_SCORE);
		$form->AddSelect ('score', $options, $score);
		$form->AddChangeRow ();
		$form->AddLabel ('url', _HOWTO_LINK);
		$form->AddTextfield ('url', 30, 100, $url);
		$form->AddChangeRow ();
		$form->AddLabel ('url_title', _HOWTO_LINK_TITLE);
		$form->AddTextfield ('url_title', 30, 50, $url_title);
		$form->AddChangeRow ();
		$form->AddLabel ('cid', _HOWTO_CATE);
		$mf->makeMySelBox ($cid, $form, 0, 'cid');
		if ($opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN, true) ) {
			$form->AddChangeRow ();
			$form->AddLabel ('cover', _HOWTO_COVER_IMG);
			$form->AddTextfield ('cover', 30, 100, $cover);
		}
		$form->AddChangeRow ();
		$form->AddLabel ('hits', _HOWTO_HITS);
		$form->AddTextfield ('hits', 5, 5, $hits);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('op', 'preview_howto');
		$form->AddHidden ('id', $id);
		$form->SetEndCol ();
		$form->SetSameCol ();
		$form->AddSubmit ('submit', _HOWTO_PHOWTO_MOD);
		$form->AddText ('&nbsp;&nbsp;');
		$form->AddButton ('Cancel', _HOWTO_WRITE_CANCEL, '', '', 'javascript:history.go(-1)');
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_220_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);

}

function del_howto () {

	global $opnTables, $opnConfig;

	$id_del = 0;
	get_var ('id_del', $id_del, 'url', _OOBJ_DTYPE_INT);
	$yes = 0;
	get_var ('yes', $yes, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN);
	if ( ($yes) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['howto_comments'] . ' WHERE rid=' . $id_del);
		$result->Close ();
		$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['howto'] . ' WHERE id=' . $id_del);
		$result->Close ();
		$opnConfig['opnOutput']->Redirect ('/modules/howto/index.php');
	} else {
		$boxtxt = '';
		$boxtxt .= '<h3>' . sprintf (_HOWTO_DEL_HWT, $id_del) . '</h3>';
		$boxtxt .= '' . sprintf (_HOWTO_DEL_HWT_TXT, $id_del) . ' ';
		$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
										'op' => 'del_howto',
										'id_del' => $id_del,
										'yes' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
															'op' => 'showcontent',
															'id' => $id_del) ) . '">' . _NO . '</a><br />';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_230_';
		$_display_dat['module'] = 'modules/howto';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
	}

}

function howto_del_comment () {

	global $opnTables, $opnConfig;

	$cid = 0;
	get_var ('cid', $cid, 'url', _OOBJ_DTYPE_INT);
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN);
	$result = &$opnConfig['database']->Execute ('delete FROM ' . $opnTables['howto_comments'] . ' WHERE cid=' . $cid);
	$result->Close ();
	$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
							'op' => 'showcontent',
							'id' => $id),
							false) );

}

function PrintHowto () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$printcomment = 0;
	get_var ('printcomment', $printcomment, 'url', _OOBJ_DTYPE_INT);
	if (!$id) {
		$opnConfig['opnOutput']->Redirect ('/modules/howto/index.php');
	}
	$themecss = $opnConfig['opnOutput']->css;
	$result = &$opnConfig['database']->Execute ('SELECT wdate, title, text, howtoer, email, score, cover, url, url_title FROM ' . $opnTables['howto'] . ' WHERE id=' . $id);
	if ($result !== false) {
		$opnConfig['opndate']->sqlToopnData ($result->fields['wdate']);
		$date = '';
		$opnConfig['opndate']->formatTimestamp ($date, _DATE_FORUMDATESTRING2);
		$title = $result->fields['title'];
		$text = $result->fields['text'];
		$howtoer = $result->fields['howtoer'];
		$email = $result->fields['email'];
		$score = $result->fields['score'];
		$cover = $result->fields['cover'];
		$url = $result->fields['url'];
		$url_title = $result->fields['url_title'];
		$result->Close ();
	}
	echo '<html><head><title>' . $opnConfig['sitename'] . ' - ' . $title . '</title>';
	if ($themecss != '') {
		echo '<link href="' . $themecss . '" rel="stylesheet">' . _OPN_HTML_NL;
	}
	echo '</head><body bgcolor="#FFFFFF" text="#000000"><table class="opncenterbox" border="0" cellspacing="0" cellpadding="0"><tr class="opncenterbox"><td class="opncenterbox"><table  border="0" width="640" cellpadding="0" cellspacing="1" class="bgcolor2"><tr class="opncenterbox"><td class="opncenterbox"><table  border="0" width="640" cellpadding="20" cellspacing="1" class="bgcolor3"><tr class="opncenterbox"><td class="opncenterbox"><div class="bigtextbold" align="center">' . $title . '<br /><br /></div>';
	if ($cover != '') {
		echo '<img src="' . $opnConfig['opn_url'] . '/modules/howto/images/howto/' . $cover . '" align="right" class="imgtag" vspace="2" alt="" />' . _OPN_HTML_NL;
	}
	echo $text . '<br /><br />' . _OPN_HTML_NL . '<span class="normaltextbold">' . _HWT_ER . '</span> ' . $howtoer . ' (' . $opnConfig['crypttext']->CodeEmail ($email) . ')<br />' . '<span class="normaltextbold">' . _HOWTO_ADD . '</span> ' . $date . '<br />' . '<span class="normaltextbold">' . _HOWTO_SCORE . '</span> ';
	echo howto_display_score ($score);
	echo '<br /><span class="normaltextbold">' . _HOWTO_RELAT_LINK . ' </span> ' . $url_title . '<br />' . '<span class="normaltextbold">' . _HOWTO_RELAT_URL . '</span> ' . $url . '<br /><br />';
	if ($printcomment == 1) {
		echo '<br />';
		echo '<br />' . _HOWTO_COMMENT . '<br />';
		echo '<br />';
		echo howto_printcomments ($id);
	}
	echo '</td></tr></table></td></tr></table><br /><br /><div class="centertag">' . _HOWTO_THIS_HWT . ' ' . $opnConfig['sitename'] . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '">' . $opnConfig['opn_url'] . '</a><br /><br />' . _HOWTO_URL_HWT . '<br /><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																																									'op' => 'showcontent',
																																									'id' => $id) ) . '">' . encodeurl (array ($opnConfig['opn_url'] . '/index.php',
						'op' => 'showcontent',
						'id' => $id) ) . '</a></td></tr></table></body></html>';

}

function howto_extrainfo ($id, $fdate, $title, $howtoer, $email, $score, $url_title, $url, $hits, $preview) {

	global $anonpost, $opnTables, $opnConfig;

	$_howtoer = $opnConfig['opnSQL']->qstr ($howtoer);
	$result = &$opnConfig['database']->Execute ('SELECT uname FROM ' . $opnTables['users'] . " WHERE uname=$_howtoer");
	if ($result !== false) {
		$name = $result->fields['uname'];
		$result->Close ();
	} else {
		$name = '';
	}
	if ($name != '') {
		$name = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
									'op' => 'userinfo',
									'uname' => $name) ) . '" target="_blank">' . $howtoer . '</a>';
	} else {
		$name = $howtoer;
	}
	$boxtxt = '<br /><br />';
	$table = & new opn_TableClass ('listalternator');
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol ($opnConfig['defimages']->get_info_image (_HOWTO_EX_INFO), 'left', '2');
	$table->AddCloseRow ();
	$table->AddDataRow (array (_HOWTO_DATE_ADD, $fdate) );
	$table->AddOpenRow ();
	$table->AddDataCol (_HWT_ER);
	$name .= ' (' . $opnConfig['crypttext']->CodeEmail ($email, '', $table->currentclass) . ')';
	$table->AddDataCol ($name);
	$table->AddCloseRow ();
	if ($score != '') {
		$hlp = howto_display_score ($score) . _OPN_HTML_NL;
		$hlp .= '  (' . sprintf (_HOWTO_READ_TIMES, $hits) . ')';
		$table->AddDataRow (array (_HOWTO_SCORE, $hlp) );
	}
	if ($url != '') {
		$table->AddDataRow (array (_HOWTO_RELAT_LINK, '<a class="%alternate%" href="' . $url . '" target="_blank">' . $url_title . '</a>') );
	}
	if (!$preview) {
		$hlp = '';
		if ( ($opnConfig['permission']->IsUser () ) or ($anonpost == 1) ) {
			$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
										'op' => 'postcomment',
										'id' => $id,
										'title' => $title), '', _HOWTO_COMMENT, _HOWTO_COMMENT ) . ' |&nbsp;' . _OPN_HTML_NL;
		}
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
									'op' => 'PrintHowto',
									'id' => $id) ) . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="" /> ' . _HOWTO_PRINT . '</a> |&nbsp;' . _OPN_HTML_NL;
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
									'op' => 'PrintHowto',
									'id' => $id,
									'printcomment' => '1') ) . '" target="_blank"><img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="" /> ' . _HOWTO_PRINTCOMMENT . '</a> |&nbsp;' . _OPN_HTML_NL;
		if ($opnConfig['permission']->HasRights ('modules/howto', array (_HOWTO_PERM_FRIENDSEND, _PERM_ADMIN), true) ) {
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
										'op' => 'SendHowto',
										'id' => $id) ) . '"><img src="' . $opnConfig['opn_default_images'] . 'friend.gif" class="imgtag" alt="" /> ' . _HOWTO_SEND . '</a>';
		}
		$table->AddDataRow (array (_HOWTO_OPTION, $hlp) );
		if ($opnConfig['permission']->HasRight ('modules/howto', _PERM_ADMIN, true) ) {
			$table->AddOpenFootRow ();
			$table->AddFooterCol ('Admin (ID ' . $id . '): [ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																'op' => 'mod_howto',
																'id' => $id) ) . '">' . _HOWTO_MODIFY . '</a> ] - [ <a class="listalternatorfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/howto/index.php',
																	'op' => 'del_howto',
																	'id_del' => $id,
																	'yes' => '0') ) . '">' . _HOWTO_DEL . '</a> ]',
																	'left',
																	'2');
			$table->AddCloseRow ();
		}
		if ( (!$opnConfig['permission']->IsUser () ) && ($anonpost == 0) ) {
			$table->AddOpenFootRow ();
			$table->AddFooterCol (sprintf (_HOWTO_PLEASE_REG, $opnConfig['opn_url']), 'left', '2');
			$table->AddCloseRow ();
		}
	}
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function SendHowto () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/howto', array (_HOWTO_PERM_FRIENDSEND, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	if (!$id) {
		exit ();
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_240_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayHead ();
	$boxtxt = '<script type="text/javascript">' . _OPN_HTML_NL;
	$boxtxt . '<!--' . _OPN_HTML_NL;
	// Function for Validating Forms
	$boxtxt .= 'function CheckForm(form)' . _OPN_HTML_NL . '{' . _OPN_HTML_NL . 'if ( form.yname.value == "" ) {' . _OPN_HTML_NL . 'alert( "' . _HOWTO_PLEASE_NAME . '" )' . _OPN_HTML_NL . 'form.yname.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if (form.ymail.value == "") {' . _OPN_HTML_NL . 'alert( "' . _HOWTO_PLEASE_EMAIL . '" )' . _OPN_HTML_NL . 'form.ymail.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if ( form.fname.value == "") {' . _OPN_HTML_NL . 'alert( "' . _HOWTO_PLEASE_FRIEND_NAME . '" )' . _OPN_HTML_NL . 'form.fname.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else if ( form.fmail.value == "") {' . _OPN_HTML_NL . 'alert( "' . _HOWTO_PLEASE_FRIEND_EMAIL . '" )' . _OPN_HTML_NL . 'form.fmail.focus()' . _OPN_HTML_NL . 'return false' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . 'else {' . _OPN_HTML_NL . 'document.friend.submit()' . _OPN_HTML_NL . 'return true' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . '//--->' . _OPN_HTML_NL . '</script>' . _OPN_HTML_NL;
	$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['howto'] . " WHERE id=$id");
	if ($result !== false) {
		$title = $result->fields['title'];
		$result->Close ();
	}
	$boxtxt .= '<br />';
	$boxtxt .= '<span class="extratextbold">' . _HOWTO_SEND_FRIEND . '</span><br /><br />' . sprintf (_HOWTO_SEND_SPEC_FRIEND, $title) . '<br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_HOWTO_250_', 'howto');
	$form->Init ($opnConfig['opn_url'] . '/modules/howto/index.php', 'post', 'friend');
	$form->AddHidden ('id', $id);
	if ($opnConfig['permission']->IsUser () ) {
		$cookie = $opnConfig['permission']->GetUserinfo ();
		$result = &$opnConfig['database']->Execute ('SELECT uname, email FROM ' . $opnTables['users'] . " WHERE uname='" . $cookie['uname'] . "'");
		if ($result !== false) {
			$yn = $result->fields['uname'];
			$ye = $result->fields['email'];
			$result->Close ();
		}
	}
	if (!isset ($yn) ) {
		$yn = '';
	}
	if (!isset ($ye) ) {
		$ye = '';
	}
	$form->AddTable ();
	$form->AddCols (array ('10%', '90') );
	$form->AddOpenRow ();
	$form->AddLabel ('yname', _HOWTO_YOUR_NAME);
	$form->AddTextfield ('yname', 30, 50, $yn);
	$form->AddChangeRow ();
	$form->AddLabel ('ymail', _HOWTO_YOUR_EMAIL);
	$form->AddTextfield ('ymail', 30, 60, $ye);
	$form->AddChangeRow ();
	$form->AddLabel ('fname', _HOWTO_FRIEND_NAME);
	$form->AddTextfield ('fname', 30, 50);
	$form->AddChangeRow ();
	$form->AddLabel ('fmail', _HOWTO_FRIEND_EMAIL);
	$form->AddTextfield ('fmail', 30, 60);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'EmailReview');
	$form->AddButton ('Send', _HOWTO_SEND, '', '', 'CheckForm(this.form)');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_260_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ('', $boxtxt);
	$opnConfig['opnOutput']->DisplayFoot ();

}

function EmailHowto () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/howto', array (_HOWTO_PERM_FRIENDSEND, _PERM_ADMIN) );
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$yname = '';
	get_var ('yname', $yname, 'form', _OOBJ_DTYPE_CLEAN);
	$ymail = '';
	get_var ('ymail', $ymail, 'form', _OOBJ_DTYPE_CLEAN);
	$fname = '';
	get_var ('fname', $fname, 'form', _OOBJ_DTYPE_CLEAN);
	$fmail = '';
	get_var ('fmail', $fmail, 'form', _OOBJ_DTYPE_CLEAN);
	$result = &$opnConfig['database']->SelectLimit ('SELECT title, text, howtoer, score FROM ' . $opnTables['howto'] . ' WHERE id=' . $id, 1);
	if ($result !== false) {
		$title = $result->fields['title'];
		$text = $result->fields['text'];
		$howtoer = $result->fields['howtoer'];
		$score = $result->fields['score'];
		$result->Close ();
	}
	$subject = sprintf (_HOWTO_MAIL_SUBJECT, $opnConfig['sitename']);
	$text = $opnConfig['cleantext']->filter_text ($text, true, true, 'nohtml');
	$vars['{FNAME}'] = $fname;
	$vars['{YNAME}'] = $yname;
	$vars['{TITLE}'] = $title;
	$vars['{TEXT}'] = $text;
	$vars['{REVIEWER}'] = $howtoer;
	$vars['{SCORE}'] = $score;
	$mail = & new opn_mailer ();
	$mail->opn_mail_fill ($fmail, $subject, 'modules/howto', 'howto', $vars, $yname, $ymail);
	$mail->send ();
	$mail->init ();
	$boxtxt = '<br />';
	$boxtxt .= _HOWTO_HWT_SEND . '<blockquote>' . sprintf (_HOWTO_THX_SUPP, $opnConfig['sitename'], $yname) . '' . '<br />' . sprintf (_HOWTO_SEND_TO, $fname, $fmail) . '</blockquote>';
	$boxtxt .= '<p align="center"><span class="normaltextbold">[ <a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/howto/index.php">' . _HOWTO_RET_MAIN . '</a> ]</span></p>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_HOWTO_270_';
	$_display_dat['module'] = 'modules/howto';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
	unset ($boxtxt);

}

?>