<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/kleinanzeigen', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/kleinanzeigen/admin/language/');

function kleinanzeigenConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_KLN_ADMINISTRATION);
	$menu->InsertEntry (_KLN_MAIN, $opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/index.php');
	$menu->InsertEntry (_KLA_WEB_IMPORT, array ($opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/index.php',
						'op' => 'webinterfaceimport') );
	$menu->InsertEntry (_KLA_SETTINGS, $opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function CatAdmin () {

	global $opnTables, $opnConfig;

	$boxtxt = '';
	$boxtxt = '<div align="center" class="normaltextbold">' . _KLN_CAT_ADMIN . '</div><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_KLN_CAT, _KLN_CAT_TITLE, _KLN_CAT_DESC, '&nbsp;') );
	$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat, cat_title, cat_desc FROM ' . $opnTables['kleinanzeigen_cat'] . ' WHERE cat_id>0 ORDER BY cat');
	if (!$result === false) {
		while (! $result->EOF) {
			$cat_id = $result->fields['cat_id'];
			$cat = $result->fields['cat'];
			$cat_title = $result->fields['cat_title'];
			$cat_desc = $result->fields['cat_desc'];
			$hlp = $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/index.php',
										'op' => 'CatEdit',
										'cat_id' => $cat_id) ) . ' ' . $opnConfig['defimages']->get_delete_link ('index.php?op=CatDel&cat_id=' . $cat_id . '&ok=0');
			$table->AddDataRow (array ($cat, $cat_title, $cat_desc, $hlp), array ('center', 'center', 'center', 'center') );
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$boxtxt .= '<span class="normaltextbold">' . _KLN_CAT_ADDIT . '</span><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_KLEINANZEIGEN_10_', 'kleinanzeigen');
	$form->Init ($opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/index.php', 'post');
	$form->AddTable ();
	$form->AddCols (array ('30%', '70%') );
	$form->AddOpenRow ();
	$form->AddLabel ('cat', _KLN_CAT);
	$form->AddTextfield ('cat', 31, 100);
	$form->AddChangeRow ();
	$form->AddLabel ('cat_title', _KLN_CAT_TITLE);
	$form->AddTextfield ('cat_title', 31, 100);
	$form->AddChangeRow ();
	$form->AddLabel ('cat_dex', _KLN_CAT_DESC);
	$form->AddTextfield ('cat_desc', 31, 100);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'CatAdd');
	$form->AddSubmit ('submit', _KLN_CAT_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function CatAdd () {

	global $opnTables, $opnConfig;

	$boxtxt = '';
	$cat = '';
	get_var ('cat', $cat, 'form', _OOBJ_DTYPE_CLEAN);
	$cat_title = '';
	get_var ('cat_title', $cat_title, 'form', _OOBJ_DTYPE_CHECK);
	$cat_desc = '';
	get_var ('cat_desc', $cat_desc, 'form', _OOBJ_DTYPE_CHECK);
	$cat_id = $opnConfig['opnSQL']->get_new_number ('kleinanzeigen_cat', 'cat_id');
	$cat = $opnConfig['opnSQL']->qstr ($cat);
	$cat_title = $opnConfig['opnSQL']->qstr ($cat_title);
	$cat_desc = $opnConfig['opnSQL']->qstr ($cat_desc);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['kleinanzeigen_cat'] . " values ($cat_id, $cat, $cat_title, $cat_desc)");
	return CatAdmin ();

}

function CatDel () {

	global $opnTables, $opnConfig;

	$cat_id = 0;
	get_var ('cat_id', $cat_id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['kleinanzeigen_cat'] . " WHERE cat_id=$cat_id");
		return CatAdmin ();
	}
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">';
	$boxtxt .= _KLN_WARNINGDELCAT . '</span><br /><br />';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/index.php',
									'op' => 'CatDel',
									'cat_id' => $cat_id,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/index.php">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}

function CatEdit () {

	global $opnTables, $opnConfig;

	$cat_id = 0;
	get_var ('cat_id', $cat_id, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT cat_id, cat, cat_title, cat_desc FROM ' . $opnTables['kleinanzeigen_cat'] . ' WHERE cat_id=' . $cat_id);
	if (!$result === false) {
		while (! $result->EOF) {
			$cat_id = $result->fields['cat_id'];
			$cat = $result->fields['cat'];
			$cat_title = $result->fields['cat_title'];
			$cat_desc = $result->fields['cat_desc'];
			$result->MoveNext ();
		}
	}
	$boxtxt = '<span class="normaltextbold">' . _KLN_CAT_EDIT . '</span><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_KLEINANZEIGEN_20_', 'kleinanzeigen');
	$form->Init ($opnConfig['opn_url'] . '/modules/kleinanzeigen/admin/index.php', 'post');
	$form->AddTable ();
	$form->AddCols (array ('30%', '70%') );
	$form->AddOpenRow ();
	$form->AddLabel ('cat', _KLN_CAT);
	$form->AddTextfield ('cat', 31, 100, $cat);
	$form->AddChangeRow ();
	$form->AddLabel ('cat_title', _KLN_CAT_TITLE);
	$form->AddTextfield ('cat_title', 31, 100, $cat_title);
	$form->AddChangeRow ();
	$form->AddLabel ('cat_desc', _KLN_CAT_DESC);
	$form->AddTextfield ('cat_desc', 31, 100, $cat_desc);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'CatUpdate');
	$form->AddHidden ('cat_id', $cat_id);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _KLN_CAT_UPDATE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function Webinterfaceimport ($webserver) {

	global $opnTables, $opnConfig;
	if ($webserver == $opnConfig['opn_url']) {
		return '';
	}
	$mydummycheck = time ();
	$fcontents = file ($webserver . '/masterinterface.php?op=GET&prog=kleinanzeigen&vari=1');
	$my = '';
	foreach ($fcontents as $line) {
		$my .= $line;
	}
	$my = explode ('::', $my);
	$max = count ($my);
	for ($k = 0; $k<$max; $k++) {
		if ($my[$k] == '+START+') {
			$boxquelle = '';
			$titel = '';
			$inhalt = '';
			$fuss = '';
		}
		if ($my[$k] == '+QUELLE+') {
			$boxquelle = $my[$k+1];
		}
		if ($my[$k] == '+INHALT+') {
			$inhalt = $my[$k+1];
			$inhalt = explode ('(:T:R:E:N:)', $inhalt);
		}
		if ($my[$k] == '+TITEL+') {
			$titel = $my[$k+1];
		}
		if ($my[$k] == '+FUSS+') {
			$fuss = $my[$k+1];
		}
		if ($my[$k] == '+ENDE+') {
			$add_id = $inhalt[0];
			$add_titel = $opnConfig['opnSQL']->qstr ($inhalt[1]);
			$add_text = $opnConfig['opnSQL']->qstr ($inhalt[2]);
			$add_text1 = $opnConfig['opnSQL']->qstr ($inhalt[2], 'add_text');
			$add_preis = $opnConfig['opnSQL']->qstr ($inhalt[3]);
			$add_bild = $opnConfig['opnSQL']->qstr ($inhalt[4]);
			$add_datum = $inhalt[5];
			$add_verfall = $inhalt[6];
			$add_name = $opnConfig['opnSQL']->qstr ($inhalt[7]);
			$add_email = $opnConfig['opnSQL']->qstr ($inhalt[8]);
			$add_kat = $opnConfig['opnSQL']->qstr ($inhalt[9]);
			$add_pw = $opnConfig['opnSQL']->qstr ($inhalt[10]);
			$add_nick = $opnConfig['opnSQL']->qstr ($inhalt[11]);
			$webserver = $opnConfig['opnSQL']->qstr ($webserver);
			$result = &$opnConfig['database']->Execute ('SELECT web_server_oid FROM ' . $opnTables['kleinanzeigen_web'] . " WHERE web_server_oid=$webserver AND web_kat_id_server=$add_id");
			if ( ($result === false) OR ($result->EOF) ) {
				$result = &$opnConfig['database']->Execute ('SELECT add_kat FROM ' . $opnTables['kleinanzeigen'] . " WHERE add_kat=$add_kat AND add_titel=$add_titel AND add_text=$add_text AND add_preis=$add_preis AND add_bild=$add_bild AND add_datum=$add_datum AND add_verfall=$add_verfall AND add_name=$add_name AND add_email=$add_email AND add_pw=$add_pw AND add_nick=$add_nick");
				if ( ($result !== false) && (! ($result->EOF) ) ) {
					$result->Close ();
				} else {
					$add_idmy = $opnConfig['opnSQL']->get_new_number ('kleinanzeigen', 'add_id');
					$_mydummycheck = $opnConfig['opnSQL']->qstr ($mydummycheck);
					$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['kleinanzeigen_web'] . " values ('','',$webserver,$_mydummycheck,$add_idmy,$add_id)");
					$result = &$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['kleinanzeigen'] . " (add_id, add_kat, add_titel, add_text, add_preis, add_bild, add_datum, add_verfall, add_name, add_email, add_pw, add_nick) VALUES ($add_idmy, $add_kat,$add_titel,$add_text1,$add_preis,$add_bild,$add_datum,$add_verfall,$add_name,$add_email,$add_pw,$add_nick)");
					$opnConfig['opnSQL']->UpdateBlobs ($opnTables['kleinanzeigen'], 'add_id=' . $add_idmy);
				}
			} else {
				$result->Close ();
				$_mydummycheck = $opnConfig['opnSQL']->qstr ($mydummycheck);
				$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['kleinanzeigen_web'] . " SET web_server_oid=$webserver, web_kat_id_server=$add_id, web_server_sends=$_mydummycheck WHERE web_server_oid=$webserver AND web_kat_id_server=$add_id");
			}
		}
	}
	$_mydummycheck = $opnConfig['opnSQL']->qstr ($mydummycheck);
	$result = &$opnConfig['database']->Execute ('SELECT web_kat_id_local FROM ' . $opnTables['kleinanzeigen_web'] . " WHERE web_server_sends!=$_mydummycheck AND web_server_oid=$webserver");
	if (!$result === false) {
		while (! $result->EOF) {
			$the_id = $result->fields['web_kat_id_local'];
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['kleinanzeigen'] . " WHERE add_id=$the_id");
			$result->MoveNext ();
		}
	}
	$_mydummycheck = $opnConfig['opnSQL']->qstr ($mydummycheck);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['kleinanzeigen_web'] . " WHERE web_server_sends!=$_mydummycheck AND web_server_oid=$webserver");
	$opnConfig['opnOutput']->Redirect ('/modules/kleinanzeigen/admin/index.php');
	return '';

}

function CatUpdate () {

	global $opnTables, $opnConfig;

	$cat_id = 0;
	get_var ('cat_id', $cat_id, 'form', _OOBJ_DTYPE_INT);
	$cat = '';
	get_var ('cat', $cat, 'form', _OOBJ_DTYPE_CLEAN);
	$cat_title = '';
	get_var ('cat_title', $cat_title, 'form', _OOBJ_DTYPE_CLEAN);
	$cat_desc = '';
	get_var ('cat_desc', $cat_desc, 'form', _OOBJ_DTYPE_CHECK);
	$boxtxt = '';
	$cat = $opnConfig['opnSQL']->qstr ($cat);
	$cat_title = $opnConfig['opnSQL']->qstr ($cat_title);
	$cat_desc = $opnConfig['opnSQL']->qstr ($cat_desc);
	$result = &$opnConfig['database']->Execute ('UPDATE ' . $opnTables['kleinanzeigen_cat'] . " SET cat=$cat, cat_title=$cat_title, cat_desc=$cat_desc WHERE cat_id=$cat_id");
	return CatAdmin ();

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'CatAdd':
		$boxtxt .= CatAdd ();
		break;
	case 'CatUpdate':
		$boxtxt .= CatUpdate ();
		break;
	case 'CatEdit':
		$boxtxt .= CatEdit ();
		break;
	case 'CatDel':
		$boxtxt .= CatDel ();
		break;
	case 'webinterfaceimport':
		if ($opnConfig['KLA_WebPartner1'] != '') {
			webinterfaceimport ($opnConfig['KLA_WebPartner1']);
		}
		if ($opnConfig['KLA_WebPartner2'] != '') {
			webinterfaceimport ($opnConfig['KLA_WebPartner2']);
		}
		if ($opnConfig['KLA_WebPartner3'] != '') {
			webinterfaceimport ($opnConfig['KLA_WebPartner3']);
		}
		break;
	default:
		$boxtxt .= CatAdmin ();
		break;
}
kleinanzeigenConfigHeader ();
if ($boxtxt != '') {
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_KLEINANZEIGEN_30_';
	$_display_dat['module'] = 'modules/kleinanzeigen';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_KLN_KLNCONFIG, $boxtxt);
}
$opnConfig['opnOutput']->DisplayFoot ();

?>