<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;
if ($opnConfig['permission']->HasRights ('modules/kliniken', array (_PERM_WRITE) ) ) {
	$opnConfig['module']->InitModule ('modules/kliniken');
	$opnConfig['opnOutput']->setMetaPageName ('modules/kliniken');
	include_once (_OPN_ROOT_PATH . 'modules/kliniken/functions.php');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
	getLanguageDef (_OPN_ROOT_PATH . 'modules/kliniken/language/');
	$eh = & new opn_errorhandler;
	// opn_errorhandler object
	klinikenSetErrorMesssages ($eh);
	$mf = & new MyFunctions;
	// MyFunctions object
	$mf->table = $opnTables['kliniken_cats'];
	$mf->itemtable = $opnTables['kliniken_kliniken'];
	$mf->itemid = 'lid';
	$mf->itemlink = 'cid';
	$mf->ratingtable = $opnTables['kliniken_votedata'];
	$submit = '';
	get_var ('submit', $submit, 'form', _OOBJ_DTYPE_CLEAN);
	$lid = 0;
	get_var ('lid', $lid, 'both', _OOBJ_DTYPE_INT);
	$rating = '';
	get_var ('rating', $rating, 'form', _OOBJ_DTYPE_CLEAN);
	if ($submit != '') {
		if (!$opnConfig['permission']->IsUser () ) {
			$ratinguser = $opnConfig['opn_anonymous_name'];
		} else {
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$ratinguser = $cookie['uname'];
		}
		// Make sure only 1 anonymous from an IP in a single day.
		$anonwaitdays = 1;
		$ip = get_real_IP ();
		// Check if Rating is Null
		if ($rating == '--') {
			$eh->show ('KLINIKEN_0005', 2);
		}
		if ($rating>10) {
			$eh->show ('OPN_0003');
		}
		// Check if Link POSTER is voting (UNLESS Anonymous users allowed to post)
		if ($ratinguser != $opnConfig['opn_anonymous_name']) {
			$result = &$opnConfig['database']->Execute ('SELECT submitter FROM ' . $opnTables['kliniken_kliniken'] . ' WHERE lid=' . $lid);
			while (! $result->EOF) {
				$ratinguserDB = $result->fields['submitter'];
				if ($ratinguserDB == $ratinguser) {
					$eh->show ('KLINIKEN_0004', 2);
				}
				$result->MoveNext ();
			}
			// Check if REG user is trying to vote twice.
			$result = &$opnConfig['database']->Execute ('SELECT ratinguser FROM ' . $opnTables['kliniken_votedata'] . ' WHERE lid=' . $lid);
			while (! $result->EOF) {
				$ratinguserDB = $result->fields['ratinguser'];
				if ($ratinguserDB == $ratinguser) {
					$eh->show ('KLINIKEN_0003', 2);
				}
				$result->MoveNext ();
			}
		}
		// Check if ANONYMOUS user is trying to vote more than once per day.
		if ($ratinguser == $opnConfig['opn_anonymous_name']) {
			$opnConfig['opndate']->now ();
			$now = '';
			$opnConfig['opndate']->opnDataTosql ($now);
			$opnConfig['opndate']->sqlToopnData ();
			$_ip = $opnConfig['opnSQL']->qstr ($ip);
			$result = &$opnConfig['database']->Execute ('SELECT COUNT(lid) AS counter FROM ' . $opnTables['kliniken_votedata'] . " WHERE lid=$lid AND ratinguser='" . $opnConfig['opn_anonymous_name'] . "' AND ratinghostname = $_ip AND ($now - ratingtimestamp < $anonwaitdays)");
			if (isset ($result->fields['counter']) ) {
				$anonvotecount = $result->fields['counter'];
			} else {
				$anonvotecount = 0;
			}
			if ($anonvotecount >= 1) {
				$eh->show ('KLINIKEN_0003', 2);
			}
		}
		// All is well.  Add to Line Item Rate to DB.
		$rating_id = $opnConfig['opnSQL']->get_new_number ('kliniken_votedata', 'ratingid');
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$_ratinguser = $opnConfig['opnSQL']->qstr ($ratinguser);
		$_ip = $opnConfig['opnSQL']->qstr ($ip);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['kliniken_votedata'] . " values ($rating_id, $lid, $_ratinguser, $rating, $_ip, $now)") or $eh->show ("OPN_0001");
		// All is well.  Calculate Score & Add to Summary (for quick retrieval & sorting) to DB.
		$mf->updaterating ($lid);
		$boxtxt = mainheaderkliniken ();
		$boxtxt .= '<br />';
		$boxtxt .= '<div class="centertag"><span class="normaltextbold">' . _KLINIKEN_YOURVOTEISAPPRECIATED . '</span></div><br />';
		$boxtxt .= sprintf (_KLINIKEN_THANKYOUFORTALKINGTHETIMTORATESITE, $opnConfig['sitename']);
		$boxtxt .= _KLINIKEN_INPUTFROMUSERSSUCHASYOURSELFWILLHELP;
		$boxtxt .= '<br /><br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/kliniken/index.php">' . _KLINIKEN_BACKTOWEBKLINIKEN . '</a>';
	} else {
		if (!$opnConfig['permission']->IsUser () ) {
			$ratinguser = $opnConfig['opn_anonymous_name'];
		} else {
			$cookie = $opnConfig['permission']->GetUserinfo ();
			$ratinguser = $cookie['uname'];
		}
		$boxtxt = mainheaderkliniken ();
		$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['kliniken_kliniken'] . ' WHERE lid=' . $lid);
		if (is_object ($result) ) {
			$title = $result->fields['title'];
		}
		opn_nl2br ($title);
		$boxtxt .= '<br /><hr size="1" noshade="noshade" /><div class="bigtextbold" align="center">' . $title . '</div>' . '<ul><li>' . _KLINIKEN_PLEASENOMOREVOTESASONCE . '</li>' . '<li>' . _KLINIKEN_THESCALE . '</li>' . '<li>' . _KLINIKEN_BEOBJEKTIVE . '</li>' . '<li>' . _KLINIKEN_NOTVOTEFOROWNKLINIKEN . '</li>';
		$boxtxt .= '</ul>';
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_KLINIKEN_200_', 'kliniken');
		$form->Init ($opnConfig['opn_url'] . '/modules/kliniken/ratelink.php');
		$form->AddHidden ('lid', $lid);
		$options[] = '--';
		for ($i = 10; $i>0; $i--) {
			$options[] = $i;
		}
		$form->AddSelectnokey ('rating', $options);
		$form->AddNewline (2);
		$form->AddSubmit ('submit', _KLINIKEN_RATEIT);
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_KLINIKEN_210_';
	$_display_dat['module'] = 'modules/kliniken';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('', $boxtxt);
}

?>