<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/myguestbook', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/myguestbook/admin/language/');
include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'custom/class.custom_spamfilter.php');

function myguestbookConfigHeader () {

	global $opnConfig, $opnTables;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_MYGBADMIN_ADMIN);
	$result = $opnConfig['database']->Execute ('SELECT COUNT(guest_id) AS counter FROM ' . $opnTables['myguestbook'] . ' WHERE wstatus=1');
	if (isset ($result->fields['counter']) ) {
		$num = $result->fields['counter'];
	} else {
		$num = 0;
	}
	$result->Close ();
	unset ($result);
	if ($num>0) {
		$menu->InsertEntry (sprintf (_MYGBADMIN_NEWENTRY, $num), array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
										'op' => 'newentrys') );
		$menu->InsertEntry (_MYGBADMIN_ADDALLNEW, array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
								'op' => 'addallnew') );
		$menu->InsertEntry (_MYGBADMIN_IGNOREALLNEW, array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
								'op' => 'ignoreallnew') );
	}
	$menu->InsertEntry (_MYGBADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/myguestbook/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function listNewEntrys () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(guest_id) AS counter FROM ' . $opnTables['myguestbook'] . ' WHERE wstatus=1';
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$info = &$opnConfig['database']->SelectLimit ('SELECT guest_id, guest_email, guest_name, guest_body FROM ' . $opnTables['myguestbook'] . ' WHERE wstatus=1 ORDER BY guest_id', $maxperpage, $offset);
	$table = & new opn_TableClass ('alternator');
	if ($opnConfig['mygb_myguestbook_spamcheck'] == 1) {
		$table->AddHeaderRow (array (_MYGBADMIN_EMAIL, _MYGBADMIN_CONTENT, _MYGBADMIN_FUNCTIONS, _MYGBADMIN_SPAMSCORE) );
		$spam_class = & new custom_spamfilter ();
	} else {
		$table->AddHeaderRow (array (_MYGBADMIN_EMAIL, _MYGBADMIN_CONTENT, _MYGBADMIN_FUNCTIONS) );
	}
	while (! $info->EOF) {
		$id = $info->fields['guest_id'];
		$email = $info->fields['guest_email'];
		$guest_name = $info->fields['guest_name'];
		$guest_body = $info->fields['guest_body'];
		opn_nl2br ($guest_body);
		$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
									'op' => 'addsinglenew',
									'id' => $id) ) . '">' . _MYGBADMIN_ADDNEW . '</a> | ';
		$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
									'op' => 'ignoresinglenew',
									'idog' => $id,
									'ok' => '0') ) . '">' . _MYGBADMIN_IGNORENEW . '</a>';
		if ($opnConfig['mygb_myguestbook_spamcheck'] == 1) {
			$help_spam = '';
			$help_spam = $spam_class->body_test ($guest_body);
			$table->AddDataRow (array ($email . '<br />' . $guest_name, $guest_body, $hlp, $help_spam) );
		} else {
			$table->AddDataRow (array ($email . '<br />' . $guest_name, $guest_body, $hlp) );
		}
		$info->MoveNext ();
	}
	// while
	$text = '';
	$table->GetTable ($text);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
					'op' => 'newentrys'),
					$reccount,
					$maxperpage,
					$offset);
	$text .= '<br /><br />' . $pagebar;
	return $text;

}

function guestbookdelete () {

	global $opnConfig;

	$idog = 0;
	get_var ('idog', $idog, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = '';
	$boxtxt .= '<div align="center" class="alerttext"><span class="normaltextbold">' . _MYGBADMIN_DELETEENTRY . '</span></div><br />';
	$boxtxt .= '<div class="centertag"><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
												'op' => 'guestbookdeleteconfirm',
												'id' => $idog) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/myguestbook/admin/index.php',
														'op' => 'opnguestbookAdmin') ) . '">' . _NO . '</a></div><br />';
	return $boxtxt;

}
myguestbookConfigHeader ();
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'newentrys':
		$boxtxt .= listNewEntrys ();
		break;
	case 'addallnew':
		$sqlst = 'UPDATE ' . $opnTables['myguestbook'] . ' SET wstatus=0 WHERE wstatus=1';
		$sql_result = &$opnConfig['database']->Execute ($sqlst);
		break;
	case 'addsinglenew':
		$id = 0;
		get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
		$sqlst = 'UPDATE ' . $opnTables['myguestbook'] . " SET wstatus=0 WHERE (wstatus=1) AND (guest_id=$id)";
		$sql_result = &$opnConfig['database']->Execute ($sqlst);
		break;
	case 'ignoreallnew':
		$sqlst = 'DELETE FROM ' . $opnTables['myguestbook'] . ' WHERE wstatus=1';
		$sql_result = &$opnConfig['database']->Execute ($sqlst);
		break;
	case 'ignoresinglenew':
		if ($opnConfig['opn_expert_mode'] == 1) {
			$id = 0;
			get_var ('idog', $id, 'url', _OOBJ_DTYPE_INT);
			$sqlst = 'DELETE FROM ' . $opnTables['myguestbook'] . ' WHERE guest_id=' . $id;
			$opnConfig['database']->Execute ($sqlst);
		} else {
			$boxtxt .= guestbookdelete ();
		}
		break;
	case 'guestbookdeleteconfirm':
		$id = 0;
		get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
		$sqlst = 'DELETE FROM ' . $opnTables['myguestbook'] . ' WHERE guest_id=' . $id;
		$opnConfig['database']->Execute ($sqlst);
		break;
	default:
		break;
}
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_MYGUESTBOOK_20_';
$_display_dat['module'] = 'modules/myguestbook';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_MYGBADMIN_ADMIN, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>