<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

define ('_OPN_NO_URL_DECODE', 1);
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables, $opnTheme;

/**
* build param string e.g. for URL from an array
*
* @access public
* @param array $params
* @return string
**/

function opendir_query_str ($params) {

	$str = '';
	foreach ($params as $key => $value) {
		$str .= (strlen ($str)<1)?'' : '&';
		$str .= $key . '=' . $value;
	}
	return ($str);

}
if ($opnConfig['permission']->HasRights ('modules/opendir', array (_PERM_READ, _PERM_BOT) ) ) {
	$opnConfig['module']->InitModule ('modules/opendir');
	$opnConfig['opnOutput']->setMetaPageName ('modules/opendir');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_http.php');
	$http = & new http ();
	// ******************************************************************************//
	// Configuration Variables
	// ******************************************************************************//
	$opendir_title = 'opendir';
	$requesturi = '';
	get_var ('REQUEST_URI', $requesturi, 'server');
	$opendir_url = $opnConfig['opn_url'] . '/modules/opendir/index.php';
	$odp_base = 'dmoz.org';
	$odp_search = 'search.dmoz.org';
	$odp_orig_search = 'search.dmoz.org/cgi-bin/osearch';
	$host = $odp_base;
	if (substr_count ($requesturi, '?')>0) {
		$target = explode ('?', $requesturi);
		$target = $target[1];
		$tbl = '';
		parse_str ($target, $tbl);
		$issesionid = false;
		if (isset ($tbl[session_name ()]) ) {
			unset ($tbl[session_name ()]);
			$issesionid = true;
		}
		if (isset ($tbl[strtolower (session_name () )]) ) {
			unset ($tbl[strtolower (session_name () )]);
			$issesionid = true;
		}
		if (empty ($tbl) ) {
			$target = '/';
		} else {
			if (isset ($tbl['search']) ) {
				$target = opendir_query_str ($tbl);
				$target = '/cgi-bin/search?' . $target;
				$host = $odp_search;
			}
		}
	} else {
		$target = '/';
	}
	if (!isset ($opnConfig['opndir_location']) ) {
		$opnConfig['opndir_location'] = '';
	}
	if ( ($opnConfig['opndir_location'] != '') && ($target == '/') ) {
		$target = '/World/' . $opnConfig['opndir_location'] . '/';
	}
	$allowed_tags = '<textarea>,<a>,<h1>,<h2>,<h3>,<h4>,<h5>,<h6>,<br />,<br>,<ol>,<i>,<b>,<form>,<p>,<center>,<small>,<input>,<select>,<option>,<ul>,<li>,<blockquote>';
	$target = strip_tags ($target);
	if (substr ($target, 0, 1) != '/') {
		$target = '/' . $target;
	}
	$http->host = $host;
	$status = $http->get ($target, true, '', false);
	if ($status != HTTP_STATUS_OK) {
		$line = '<div class="centertag"><br /><br /><span class="alerttext">Problem while getting data from Open Directory at DMOZ.</span><br />Error: could not open the url: ' . $host . $target . '<br /></div><br /><br /><br />' . _OPN_HTML_NL;
	} else {
		$line = $http->get_response_body ();
		$line = preg_replace ('/<title>.*<\/title>/i', '', $line);
		$line = preg_replace ('/Copyright &copy; [0-9]{4}-?[0-9]{0,4} Netscape/i', '<div class="centertag"><span class="smalltext">Open Directory - Copyright &copy; by Netscape</span></div>', $line);
		$line = str_replace ('<FORM accept-charset="UTF-8"', '<form', $line);
		$line = str_replace ('method="GET"', 'method="get"', $line);
		$line = strip_tags ($line, $allowed_tags);
		$line = str_replace ('<input size=30 name=search>', '<input size="30" name="search" />', $line);
		$line = str_replace ('<input type=submit value="Search">', '<input type="submit" value="Search" />', $line);
		$line = str_replace ('<select name=all>', '<select name="all">', $line);
		$line = str_replace ('<option value=no>', '<option value="no" />', $line);
		$line = str_replace ('<option selected value=yes>', '<option selected="selected" value="yes" />', $line);
		$line = str_replace ('<p>', '<br /><br />', $line);
		$line = str_replace ('<P>', '<br /><br />', $line);
		$line = str_replace ('<hr />', '<br /><br />', $line);
		$line = str_replace ('<hr />', '<br /><br />', $line);
		$line = str_replace ('<td', '<td class="opncenterbox"', $line);
		$line = str_replace ('<TD', '<td class="opncenterbox"', $line);
		$line = str_replace ('width=600', 'width="95%"', $line);
		$line = str_replace ('#669933', $opnTheme['bgcolor2'], $line);
		$line = str_replace ('#f0f0f0', $opnTheme['bgcolor2'], $line);
		$line = str_replace ('href="/', 'href="' . $opendir_url . '?/', $line);
		$line = str_replace ($odp_base, $opendir_url . '?/', $line);
		$line = str_replace ('href="http://search.dmoz.org/cgi-bin/search?a.x=0"', 'href="' . $opendir_url . '?asearch"', $line);
		$line = str_replace ($odp_search . '?search=', $opendir_url . '?search=', $line);
		$line = str_replace ($odp_search, $opendir_url, $line);
		$line = str_replace ($odp_orig_search . '?search=', $opendir_url . '?osearch=', $line);
		$line = str_replace ($odp_orig_search, $opendir_url, $line);
		$line = str_replace ('ACTION="search"', 'action="' . $opendir_url . '"', $line);
		$line = str_replace ('href="search', 'href="' . $opendir_url, $line);
		$line = str_replace ('HREF="/cgi-bin/search?search=', 'href=".' . $opendir_url . '?search=', $line);
		$line = str_replace ('HREF="osearch?search=', 'href="' . $opendir_url . '?osearch=', $line);
		$line = str_replace ('ACTION="osearch"', 'action="' . $opendir_url . '"', $line);
		$line = str_replace ('action="add2.cgi"', 'action="' . $odp_base . 'cgi-bin/add2.cgi"', $line);
		$line = str_replace ('action="update2.cgi"', 'action="' . $odp_base . 'cgi-bin/update2.cgi"', $line);
		$line = str_replace ('action="apply2.cgi"', 'action="' . $odp_base . 'cgi-bin/apply2.cgi"', $line);
		$line = str_replace ('action="forgot.cgi"', 'action="' . $odp_base . 'cgi-bin/forgot.cgi"', $line);
		$line = str_replace ('action="/cgi-bin/feedback2.cgi"', 'action="' . $odp_base . 'cgi-bin/feedback2.cgi"', $line);
		$line = str_replace ('href="desc.html"', 'href="' . $opendir_url . '?/' . $target . 'desc.html"', $line);
		$line = str_replace ('href="faq.html"', 'href="' . $opendir_url . '?/' . $target . 'faq.html"', $line);
		$line = str_replace ('HREF="/searchguide.html"', 'href="' . $opendir_url . '?/searchguide.html"', $line);
		$line = str_replace ('HREF="searchguide.html"', 'href="' . $opendir_url . '?/searchguide.html"', $line);
		$line = str_replace ('width="100%"', 'width="98%"', $line);
		$line = str_replace ('<table border=0 bgcolor="#dddddd" cellpadding=2 cellspacing=0 width="98%">', '<table align="center" border="0" class="bgcolor1" cellpadding="2" cellspacing="0" width="98%">', $line);
		$line = str_replace ('http://search.http://', 'http://', $line);
		$line = str_replace ('http://http://', 'http://', $line);
		$line = str_replace ('<A HREF="/', '<a href="' . $opendir_url . '?/', $line);
		$line = str_replace ('<FORM METHOD=GET ACTION="/', '<form method="get" action="' . $opendir_url . '?/', $line);

		#		echo '<br /><br />'.htmlentities($line).'<br /><br />';
	}
	$http->disconnect ();
	$line = str_replace ('<br>', '<br />', $line);
	$line = str_replace ('<br />', '<br />' . _OPN_HTML_NL, $line);
	$line = preg_replace ('/<td bgcolor="#cccccc"/', '<td class="opncenterbox"', $line);
	if ($opnConfig['opn_charset_encoding'] != 'utf-8') {
		include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_convert_charset.php');
		$convert = & new ConvertCharset;
		$line = $convert->Convert ($line, 'utf-8', $opnConfig['opn_charset_encoding'], true);
	}
	$boxtxt = '<br /><div class="centertag"><img src="' . $opnConfig['opn_url'] . '/modules/opendir/images/opendir.jpg" class="imgtag" alt="" /></div>';
	$boxtxt .= '<div align="left">' . $line . '</div>';
	$boxtxt .= '<div class="centertag">';
	$boxtxt .= '<br /><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddDataRow (array ('Help build the largest human-edited directory on the web.'), array ('center') );
	$hlp = '&nbsp;<a class="%alternate%" href="http://dmoz.org/cgi-bin/add.cgi?where=' . $target . '">';
	$hlp .= 'Submit a Site</a> - <a class="%alternate%" href="http://dmoz.org/about.html">';
	$hlp .= 'Open Directory Project</a> -';
	$hlp .= '<a class="%alternate%" href="http://dmoz.org/cgi-bin/apply.cgi?where=' . $target . '">';
	$hlp .= 'Become an Editor</a>&nbsp;';
	$table->AddDataRow (array ($hlp), array ('center') );
	$table->GetTable ($boxtxt);
	$boxtxt .= '</div>';
	$boxtxt .= '<br /><br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPENDIR_10_';
	$_display_dat['module'] = 'modules/opendir';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ('Open Directory', $boxtxt);
}

?>