<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/opn_newsletter', true);
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../../mainfile.php');
}
if (!defined ('_OPN_MAILER_INCLUDED') ) {
	include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
}
include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.multichecker.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/opn_newsletter/admin/language/');
$nl_title = 'Newsletter';

/*
some helpers for the output
*/

function nl_ConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_ONLA_ADMIN);
	$menu->InsertEntry (_ONLA_MAIN, $opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php');
	$menu->InsertEntry (_ONLA_SETTINGS, $opnConfig['opn_url'] . '/modules/opn_newsletter/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}
// displays the "Go back"
// - $to can set to an url not equals sqlf

function nl_GoBack ($to = '') {

	global $opnConfig;

	$PHPSELF = '';
	get_var ('PHP_SELF', $PHPSELF, 'server');
	$myreturn = "<div align='center'><a class='opncenterbox' href='" . encodeurl ( ( ($to == '')?"$PHPSELF" : $opnConfig['opn_url'] . '/modules/opn_newsletter/admin/' . $to) ) . "'>" . _ONLA_GOBACK . "</a></div>";
	return $myreturn;

}
// Just displays an Error and dies
// - $text: the message
// - $refer: Where to go by nl_GoBack

function nl_Error ($text, $refer = "") {

	global $opnConfig;

	$boxtxt = '<br />';
	$boxtxt .= $text . '<br /><br />' . nl_GoBack ($refer);
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_10_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent (_ONLA_ERROR, $boxtxt);
	exit;

}

/*	nl_ShowAdminSection

displays the choices for the admin
*/

function nl_ShowAdminSection () {

	global $opnConfig, $opnTables;
	// should never produces an error because of the test above
	nl_ConfigHeader ();
	$ui = $opnConfig['permission']->GetUserinfo ();
	$boxtxt = '<span class="normaltext">';
	$boxtxt .= _ONLA_HELLO . ' ' . $ui['uname'] . ',<br /><br />';
	$boxtxt .= _ONLA_SHORTDESC . '<br /><br /></span>';
	// open the list table
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_ONLA_CATEGORY, _ONLA_ACCESS, '&nbsp;', _ONLA_STATUS) );
	$table->AddDataRow (array ('<a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php?op=add') . '">' . _ONLA_ADDCATEGORY . '</a>', '&nbsp;', '&nbsp;', '&nbsp;') );
	$r = &$opnConfig['database']->Execute ('SELECT lid, name, access, enabled, description FROM ' . $opnTables['newsletter_list'] . ' ORDER BY name');
	if ($r !== false) {
		while (! $r->EOF) {
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
												'op' => 'archive',
												'lid' => $r->fields['lid']) ) . '">' . $r->fields['name'] . '</a>');
			$table->AddDataCol ($opnConfig['permission']->UserGroups[$r->fields['access']]['name']);
			$hlp = '[ ' . ( ($r->fields['enabled'] == 1)?'<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
															'op' => 'write',
															'lid' => $r->fields['lid']) ) . '">' . _ONLA_WRITE . '</a>' : _ONLA_WRITE) . ' | ' . '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
																				'op' => 'members',
																				'lid' => $r->fields['lid']) ) . '">' . _ONLA_MEMBERS . '</a> | ' . $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
																		'op' => 'edit',
																		'lid' => $r->fields['lid']) ) . ' | ' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
																																'op' => 'delete',
																																'lid' => $r->fields['lid']) ). ' ]';
			$table->AddDataCol ($hlp);
			if ($r->fields['enabled'] == 1) {
				$table->AddDataCol (_ONLA_OPEN);
			} else {
				$table->AddDataCol (_ONLA_CLOSED);
			}
			$table->AddCloseRow ();
			$r->MoveNext ();
		}
	}
	// close list table
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_20_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_DESC, $boxtxt, '');
	return TRUE;

}

function nl_AddCategory () {

	global $opnConfig, $name, $access;

	nl_ConfigHeader ();
	$boxtxt = _ONLA_FILLFORM;
	$boxtxt .= '<ul><li>' . _ONLA_FILLFORMNAME . '</li><li>' . _ONLA_FILLFORMACCESS . '</li></ul>';
	$boxtxt .= '<span class="normaltext">' . _ONLA_FILLFORMNAME2 . '</span>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_30_', 'opn_newsletter');
	$form->Init ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('name', _ONLA_CATEGORY . ':');
	$form->AddTextfield ('name', 40, 128, $name);
	$form->AddChangeRow ();
	$form->AddLabel ('description', _ONLA_CATEGORY_DESCRIPTION . ':');
	$form->AddTextarea ('description');
	$form->AddChangeRow ();
	$form->AddLabel ('access', _ONLA_ACCESS . ':');
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('access', $options, $access);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'checkadd');
	$form->AddSubmit ('submit', _ONLA_CREATE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br /><br />' . nl_GoBack () . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_40_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_ADDCATEGORY, $boxtxt, '');
	return TRUE;

}

function nl_AddData () {

	global $opnTables, $opnConfig;

	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$access = 0;
	get_var ('access', $access, 'form', _OOBJ_DTYPE_INT);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$name = trim ($name);
	if ($name == '') {
		nl_Error (_ONLA_ERRORNONAME, 'index.php?op=add&access=' . $access);
	}
	$name = $opnConfig['opnSQL']->qstr ($name);
	$description = $opnConfig['opnSQL']->qstr ($description, 'description');
	$lid = $opnConfig['opnSQL']->get_new_number ('newsletter_list', 'lid');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['newsletter_list'] . " (lid,name, access, enabled, description) VALUES ($lid,$name, $access, 0, $description);");
	if ($opnConfig['database']->ErrorNo () != 0) {
		nl_Error (_ONLA_ERRORWITHDB . $opnConfig['database']->ErrorMsg () );
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['newsletter_list'], 'lid=' . $lid);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.installer.php');
	$inst = & new OPN_PluginInstaller;
	$onltablename = 'newsletter_' . $lid . '_user';
	$opn_plugin_sql_table['table'][$onltablename]['nluid'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 10, 0);
	$opn_plugin_sql_table['table'][$onltablename]['email'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 200, "");
	$opn_plugin_sql_table['table'][$onltablename]['code'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 200, "");
	$opn_plugin_sql_table['table'][$onltablename]['enabled'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 1, 0);
	$opn_plugin_sql_table['table'][$onltablename]['wdate'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_NUMERIC, 15, 0, false, 5);
	$opn_plugin_sql_table['table'][$onltablename]['___opn_key1'] = $opnConfig['opnSQL']->GetPrimaryKey (Array ('nluid'),
														$onltablename);
	$opn_plugin_sql_index['index'][$onltablename]['___opn_key1'] = 'email';
	$opn_plugin_sql_index['index'][$onltablename]['___opn_key2'] = 'enabled';
	$opn_plugin_sql_index['index'][$onltablename]['___opn_key3'] = 'wdate';
	$opn_plugin_sql_index['index'][$onltablename]['___opn_key4'] = 'enabled,email';
	$onltablename = 'newsletter_' . $lid . '_data';
	$opn_plugin_sql_table['table'][$onltablename]['nlid'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 10, 0);
	$opn_plugin_sql_table['table'][$onltablename]['aid'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table'][$onltablename]['subject'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 128, "");
	$opn_plugin_sql_table['table'][$onltablename]['wdate'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_NUMERIC, 15, 0, false, 5);
	$opn_plugin_sql_table['table'][$onltablename]['text'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_TEXT);
	$opn_plugin_sql_table['table'][$onltablename]['___opn_key1'] = $opnConfig['opnSQL']->GetPrimaryKey (Array ('nlid'),
														$onltablename);
	$opn_plugin_sql_index['index'][$onltablename]['___opn_key1'] = 'aid';
	$opn_plugin_sql_index['index'][$onltablename]['___opn_key2'] = 'subject';
	$opn_plugin_sql_index['index'][$onltablename]['___opn_key3'] = 'wdate';
	$inst->opnExecuteSQL ($opn_plugin_sql_table);
	$inst->opnExecuteSQL ($opn_plugin_sql_index);

}

function nl_EditData () {

	global $opnConfig, $opnTables;

	nl_ConfigHeader ();
	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$access = 0;
	get_var ('access', $access, 'form', _OOBJ_DTYPE_INT);
	$enabled = 0;
	get_var ('enabled', $enabled, 'form', _OOBJ_DTYPE_INT);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	// collect data
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	// it's simple to test the error :)
	$name = trim ($name);
	if ($name == '') {
		nl_Error (_ONLA_ERRORNONAME, "index.php?op=edit&lid=$lid&access=$access&enabled=$enabled");
	}
	$enabled = (int) $enabled;
	if ($enabled<0) {
		$enabled = 0;
	} elseif ($enabled>1) {
		$enabled = 1;
	}
	// make name clean
	$name = $opnConfig['opnSQL']->qstr ($name);
	$description = $opnConfig['opnSQL']->qstr ($description, 'description');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['newsletter_list'] . " SET name=$name, enabled=$enabled, access=$access, description=$description WHERE lid=$lid;");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['newsletter_list'], 'lid=' . $lid);
	$boxtxt = _ONLA_CATEGORYCHANGED . '<br /><br />';
	$boxtxt .= nl_GoBack () . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_50_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_EDITCATEGORY, $boxtxt, '');
	return TRUE;

}

function nl_Edit () {

	global $opnConfig, $opnTables;

	nl_ConfigHeader ();
	// collect data
	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	$r = &$opnConfig['database']->Execute ("SELECT name, access, enabled, description FROM " . $opnTables['newsletter_list'] . " WHERE lid=$lid;");
	if ($r === false) {
		nl_Error (sprintf (_ONLA_LIDNOTFOUND, $lid), "index.php");
	}
	// now the table with the data
	$boxtxt = '';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_60_', "opn_newsletter");
	$form->Init ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('name', _ONLA_CATEGORY . ':');
	$form->AddTextfield ('name', 40, 128, $r->fields['name']);
	$form->AddChangeRow ();
	$form->AddLabel ('description', _ONLA_CATEGORY_DESCRIPTION . ':');
	$form->AddTextarea ('description', 0, 0, '', $r->fields['description']);
	$form->AddChangeRow ();
	$form->AddLabel ('access', _ONLA_ACCESS . ':');
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('access', $options, $r->fields['access']);
	$form->AddChangeRow ();
	$form->AddLabel ('enabled', _ONLA_OPEN);
	$form->AddCheckbox ('enabled', 1, $r->fields['enabled']);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'checkedit');
	$form->AddHidden ('lid', $lid);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _ONLA_CHANGE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br /><br />';
	$boxtxt .= nl_GoBack () . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_70_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_EDITCATEGORY, $boxtxt, '');
	return TRUE;

}

function nl_DeletCat () {

	global $opnConfig, $opnTables;

	nl_ConfigHeader ();
	// collect data
	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	if ($opnConfig['opn_expert_mode'] == 1) {
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
								'op' => 'kill',
								'lid' => $lid),
								false) );
	} else {
		$r = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
		$row = $r->FetchRow ();
		$boxtxt = sprintf ('<div class="centertag">' . _ONLA_DOYOUREALLY . '</div>', '<span class="normaltextbold">' . $row['name'] . '</span>');
		$boxtxt .= '<br /><br />' . _ONLA_DELETEHINT;
		$boxtxt .= '<p align="center"><a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
												'op' => 'kill',
												'lid' => $lid) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php">' . _NO . '</a>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_80_';
		$_display_dat['module'] = 'modules/opn_newsletter';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_DELCATEGORY, $boxtxt, '');
	}
	return TRUE;

}

function nl_KillCat () {

	global $opnConfig, $opnTables;
	// collect data
	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	// just kill - dont care about errors
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	if ($opnConfig['database']->ErrorNo () == 0) {
		$table = $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_user';
		$thesql = $opnConfig['opnSQL']->TableDrop ($table);
		$opnConfig['database']->Execute ($thesql);
		$table = $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_data';
		$thesql = $opnConfig['opnSQL']->TableDrop ($table);
		$opnConfig['database']->Execute ($thesql);
	} else {
		nl_Error (sprintf (_ONLA_ERRORCANNOTDELETE, $lid) );
	}

}

function nl_ShowMembers () {

	global $opnConfig, $opnTables, $limit, $offset;

	$lid = 0;
	get_var ('lid', $lid, 'both', _OOBJ_DTYPE_INT);
	$limit = 30;
	get_var ('limit', $limit, 'both', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$menu = & new OPN_Adminmenu (_ONLA_ADMIN);
	$menu->InsertEntry (_ONLA_IMPORTMEMBERS, array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
							'lid' => $lid,
							'op' => 'import') );
	$menu->InsertEntry (_ONLA_EXPORTMEMBERS, array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
							'lid' => $lid,
							'op' => 'export') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	// collect data
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	// first fetch the name
	$r = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	$name = $r->fields['name'];
	$r = &$opnConfig['database']->Execute ('SELECT COUNT(nluid) AS counter FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_user');
	if ( ($r !== false) && (isset ($r->fields['counter']) ) ) {
		$entries = $r->fields['counter'];
		$r->Close ();
	} else {
		$entries = 0;
	}
	// adjust offset
	if ($offset >= $entries) {
		$offset = 0;
	}
	$r = &$opnConfig['database']->SelectLimit ('SELECT nluid, email FROM ' . $opnConfig['tableprefix'] . "newsletter_" . $lid . "_user ORDER BY email", $limit, $offset);
	$boxtxt = '<span class="normaltext">';
	$boxtxt .= sprintf (_ONLA_NUMBEROFUSERS, $entries) . '<br /><br />';
	$boxtxt .= _ONLA_USERDELETEHINT;
	// display table header
	$boxtxt .= '</span>';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_ONLA_EMAIL, '&nbsp;'), array ('left', '') );
	if ($r !== false) {
		while (! $r->EOF) {
			$table->AddOpenRow ();
			$table->AddDataCol ('<a class="%alternate%" href="mailto:' . $r->fields['email'] . '">' . $r->fields['email'] . '</a>');
			$hlp = $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
										'op' => 'edituser',
										'lid' => $lid,
										'nluid' => $r->fields['nluid'],
										'offset' => $offset,
										'limit' => $limit) ) . ' ' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
																														'op' => 'deleteuser',
																														'lid' => $lid,
																														'nluid' => $r->fields['nluid']) );
			$table->AddDataCol ($hlp);
			$table->AddCloseRow ();
			$r->MoveNext ();
		}
	}
	$table->AddOpenRow ();
	// Create page navigation
	$actpage = (int) ($offset/ $limit)+1;
	$hlp = '';
	for ($i = 0; $i< $entries; $i += $limit) {
		$page = (int) ($i/ $limit)+1;
		if ($page == $actpage) {
			$hlp .= '<span class="normaltextbold">' . $page . '</span> ';
		} else {
			$hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
										'op' => 'members',
										'lid' => $lid,
										'offset' => $i,
										'limit' => $limit) ) . '">' . $page . '</a> ';
		}
	}
	$table->AddDataCol ($hlp, 'center', '2');
	$table->GetTable ($boxtxt);
	$boxtxt .= '<br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_90_', 'opn_newsletter');
	$form->Init ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('email', _ONLA_EMAIL);
	$form->AddTextfield ('email', 40, 128);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'adduser');
	$form->AddHidden ('lid', $lid);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _ONLA_ADDNEWUSER);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	// thats all
	$boxtxt .= '<br /><br />' . nl_GoBack () . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_100_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_SHOWMEMBERS . " (" . $name . ")", $boxtxt, '');
	return TRUE;

}

function nl_ExportMembers () {

	global $opnConfig;

	nl_ConfigHeader ();
	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	// collect data
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	$r = &$opnConfig['database']->Execute ('SELECT nluid, email FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_user ORDER BY email');
	$boxtxt = '';
	$boxtxtexp = '';
	if ($r !== false) {
		while (! $r->EOF) {
			$boxtxt .= $r['email'] . '<br />';
			$boxtxtexp .= $r['email'] . ';';
			$r->MoveNext ();
		}
	}
	// thats all
	$boxtxt .= '<br /><br />' . nl_GoBack () . '<br />';
	$boxtxt .= '<br />';
	$filename = $opnConfig['root_path_datasave'] . 'opn_newsletter.exp';
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
	$File = & new opnFile;
	$File->overwrite_file ($filename, $boxtxtexp);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_110_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_EXPORTMEMBERS . ' (' . $boxtxt . ')', '');
	return TRUE;

}

function nl_ImportMembers () {

	global $opnConfig, $opnTables;

	nl_ConfigHeader ();
	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	// collect data
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	$r = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	$name = $r->fields['name'];
	if (file_exists ($opnConfig['root_path_datasave'] . 'opn_newsletter.exp') ) {
		$file = fopen ($opnConfig['root_path_datasave'] . 'opn_newsletter.exp', 'r');
		$str = fread ($file, filesize ($opnConfig['root_path_datasave'] . 'opn_newsletter.exp') );
		fclose ($file);
		$boxtxt = '<br />';
		$my = explode (";", $str);
		for ($k = 0; $k< (count ($my)-1); $k++) {
			$boxtxt .= $my[$k] . '<br />';
			set_var ('lid', $lid, 'form');
			set_var ('email', $my[$k], 'form');
			nl_AddUser ();
		}
		$boxtxt .= '<br /><br />' . nl_GoBack () . '<br />';
		$boxtxt .= '<br />';
	} else {
		$boxtxt = '<br /><br />' . _ONLA_NO_IMPORTDATA . '<br />';
		$boxtxt .= '<br />' . $opnConfig['root_path_datasave'] . 'opn_newsletter.exp';
		$boxtxt .= '<br />';
		$boxtxt .= '<br />' . _ONLA_NO_IMPORTDATA_HERE . '<br />';
		$boxtxt .= '<br />';
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_120_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_IMPORTMEMBERS . ' (' . $name . ')', $boxtxt, '');
	return TRUE;

}

function nl_EditUser () {

	global $opnConfig, $opnTables;

	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	$nluid = 0;
	get_var ('nluid', $nluid, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$limit = 0;
	get_var ('limit', $limit, 'url', _OOBJ_DTYPE_INT);
	nl_ConfigHeader ();
	// collect data
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	if ((int) $nluid == 0) {
		nl_Error (_ONLA_ERRORINVALIDNLUID);
	}
	// first fetch the name
	$r = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	$name = $r->fields['name'];
	// now get the name
	$r = &$opnConfig['database']->Execute ('SELECT email FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_user WHERE nluid=' . $nluid);
	$email = $r->fields['email'];
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_130_', "opn_newsletter");
	$form->Init ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('email', _ONLA_EMAIL);
	$form->AddTextfield ('email', 40, 128, $email);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'userchange');
	$form->AddHidden ('lid', $lid);
	$form->AddHidden ('nluid', $nluid);
	$form->AddHidden ('offset', $offset);
	$form->AddHidden ('limit', $limit);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _ONLA_CHANGE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br /><br />' . nl_GoBack ("index.php?op=members&lid=$lid&offset=$offset&limit=$limit") . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_140_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_CHANGEUSER . " (" . $name . ")", $boxtxt, '');
	return TRUE;

}

function nl_ChangeUser () {

	global $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$nluid = 0;
	get_var ('nluid', $nluid, 'form', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'form', _OOBJ_DTYPE_INT);
	$limit = 0;
	get_var ('limit', $limit, 'form', _OOBJ_DTYPE_INT);
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	if ((int) $nluid == 0) {
		nl_Error (_ONLA_ERRORINVALIDNLUID);
	}
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$opnConfig['database']->Execute ('UPDATE ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user SET email=$_email WHERE nluid=$nluid;");
	if ($opnConfig['database']->ErrorNo () != 0) {
		nl_error ($opnConfig['database']->ErrorNo () . " - " . $opnConfig['database']->ErrorMsg () );
	} else {
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php',
								'op' => 'members',
								'lid' => $lid,
								'offset' => $offset,
								'limit' => $limit),
								false) );
	}

}

function nl_AddUser () {

	global $opnConfig, $opnTables;

	$check = & new multichecker ();
	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	if ($lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	// first fetch the name
	$r = &$opnConfig['database']->Execute ("SELECT name FROM " . $opnTables['newsletter_list'] . " WHERE lid=$lid;");
	$name = $r->fields['name'];
	$boxtxt = '';
	if ( (!$email) || ($email == '') || (!$check->is_email ($email) ) ) {
		$boxtxt .= sprintf (_ONLA_ERRORWRONGEMAIL, $email);
	} else {
		$_email = $opnConfig['opnSQL']->qstr ($email);
		$r = &$opnConfig['database']->Execute ("SELECT nluid FROM " . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email=$_email;");
		if ($r !== false) {
			$num = $r->RecordCount ();
		} else {
			$num = 0;
		}
		if ($num != 0) {
			$boxtxt .= sprintf (_ONLA_ERROREMAILALREADYEXISTS, $email);
		} else {
			$code = md5 (uniqid (rand () ) );
			$nluid = $opnConfig['opnSQL']->get_new_number ("newsletter_" . $lid . "_user", "nluid");
			$opnConfig['opndate']->now ();
			$now = '';
			$opnConfig['opndate']->opnDataTosql ($now);
			$_email = $opnConfig['opnSQL']->qstr ($email);
			$_code = $opnConfig['opnSQL']->qstr ($code);
			$opnConfig['database']->Execute ("INSERT INTO " . $opnConfig['tableprefix'] . "newsletter_" . $lid . "_user (nluid, email, enabled, wdate, code) VALUES (" . $nluid . ",$_email, 1, $now, $_code);");
			if ($opnConfig['database']->ErrorNo () == 0) {
				$boxtxt .= sprintf (_ONLA_EMAILADDED, $email);
			} else {
				$boxtxt .= _ONLA_ERRORWITHDB . $opnConfig['database']->ErrorNo () . ": " . $opnConfig['database']->ErrorMsg ();
			}
		}
	}
	$offset = 0;
	$limit = 30;
	$offset = (int) $offset;
	$boxtxt .= '<br /><br />' . nl_GoBack ("index.php?op=members&lid=$lid&offset=$offset&limit=$limit") . '<br />';
	$boxtxt .= '<br />';
	// if ($auto != 1) nl_ShowMembers($lid,$limit,$offset);
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_150_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_ADDUSER . " (" . $name . ")", $boxtxt, '');
	return TRUE;

}

function nl_nice ($text = "") {

	while (preg_match ("/\\\\/", $text) ) $text = preg_replace ("/\\\\/", "", $text);
	return $text;

}

function nl_Write () {

	global $subject, $text, $opnConfig, $opnTables;

	nl_ConfigHeader ();
	$lid = 0;
	get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	// first fetch the name
	$r = &$opnConfig['database']->Execute ("SELECT name, enabled FROM " . $opnTables['newsletter_list'] . " WHERE lid=$lid;");
	$name = $r->fields['name'];
	$enabled = $r->fields['enabled'];
	$boxtxt = '<span class="normaltext">';
	if ($enabled) {
		$boxtxt .= _ONLA_WRITEHINT . '</span>';
		$boxtxt .= '<ul>';
		$boxtxt .= '<li>' . _ONLA_WRITEHINTLIST1 . '</li>';
		$boxtxt .= '<li>' . _ONLA_WRITEHINTLIST2 . '</li>';
		$boxtxt .= '<li>' . _ONLA_WRITEHINTLIST3 . '</li>';
		$boxtxt .= '</ul>';
		$boxtxt .= _ONLA_WRITEWEBMASTERWILLGET;
		// display the form
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_160_', 'opn_newsletter');
		$form->Init ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('subject', _ONLA_SUBJECT . ':');
		$form->AddTextfield ('subject', 60, 128, $subject);
		$form->AddChangeRow ();
		$form->AddLabel ('text', _ONLA_TEXT . ':');
		if (!$opnConfig['opn_newsletter_usehtmlmail']) {
			$form->UseEditor (false);
			$form->UseWysiwyg (false);
		}
		$form->AddTextarea ('text', 0, 0, '', $text);
		$form->AddChangeRow ();
		$form->SetSameCol ();
		$form->AddHidden ('op', 'preview');
		$form->AddHidden ('lid', $lid);
		$form->SetEndCol ();
		$form->AddSubmit ('submit', _ONLA_PREVIEW);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	} else {
		$boxtxt .= _ONLA_CATEGORYCLOSED . '</span>';
	}
	$boxtxt .= '<br /><br />' . nl_GoBack ('index.php') . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_170_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_WRITENEWSLETTER . ' (' . $name . ')', $boxtxt, '');
	return TRUE;

}
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');

function nl_Preview () {

	global $opnTables, $opnConfig;

	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$fsubject = stripslashes ($subject);
	$ftext = stripslashes ($text);
	nl_ConfigHeader ();
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	// first fetch the name
	$r = &$opnConfig['database']->Execute ('SELECT name, enabled FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	$name = $r->fields['name'];
	$enabled = $r->fields['enabled'];
	$ui = $opnConfig['permission']->GetUserinfo ();
	if ( (isset ($ui['name']) ) && ($ui['name'] != '') ) {
		$aname = $ui['name'];
	} else {
		$aname = $ui['uname'];
	}
	if ($opnConfig['opn_newsletter_newsletteremail'] == '') {
		$aemail = $ui['email'];
	} else {
		$aemail = $opnConfig['opn_newsletter_newsletteremail'];
	}
	if ($opnConfig['opn_newsletter_usename']) {
		$aname = $name;
	}
	if (!$enabled) {
		die (_ONLA_CATEGORYCLOSED);
	}
	// Preview
	$boxtxt = '';
	if (trim ($subject) == '') {
		$boxtxt .= _ONLA_NOSUBJECT;
	}
	$subject = nl_nice ($subject);
	$text = nl_nice ($text);
	opn_nl2br ($ftext);
	$table = & new opn_TableClass ('default');
	$table->AddOpenRow ();
	$table->AddDataCol ('<span class="normaltextbold">' . _ONLA_FROM . ':</span>', 'right', '', 'top');
	$table->AddDataCol ($aname . ' &lt;' . $aemail . '&gt;', 'left', '', 'top');
	$table->AddChangeRow ();
	$table->AddDataCol ('<span class="normaltextbold">' . _ONLA_SUBJECT . ':</span>', 'right', '', 'top');
	$table->AddDataCol ($subject, 'left', '', 'top');
	$table->AddChangeRow ();
	$table->AddDataCol ('<span class="normaltextbold">' . _ONLA_TEXT . ':</span>', 'right', '', 'top');
	$table->AddDataCol ($ftext, 'left', '', 'top');
	$table->AddChangeRow ();
	$table->AddDataCol ('&nbsp;', 'center', '2');
	$table->AddChangeRow ();
	$table->AddDataCol ('&nbsp;', 'center', '2');
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_180_', 'opn_newsletter');
	$form->Init ($opnConfig['opn_url'] . '/modules/opn_newsletter/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('subject', _ONLA_SUBJECT . ':');
	$form->AddTextfield ('subject', 60, 128, $fsubject);
	$form->AddChangeRow ();
	$form->AddLabel ('text', _ONLA_TEXT . ':');
	$form->AddTextarea ('text', 0, 0, '', $text);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'sendletter');
	$form->AddHidden ('lid', $lid);
	$form->SetEndCol ();
	$form->SetSameCol ();
	$form->AddSubmit ('again', _ONLA_PREVIEW);
	$form->AddText ('&nbsp;');
	$form->AddSubmit ('submit');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '<br /><br />' . nl_GoBack ('index.php') . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_190_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_PREVIEWNEWSLETTER . ' (' . $name . ')', $boxtxt, '');
	return TRUE;

}

function nl_Send () {

	global $opnConfig, $opnTables;

	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$fsubject = stripslashes ($subject);
	$ftext = stripslashes ($text);
	$ui = $opnConfig['permission']->GetUserinfo ();
	if ( (isset ($ui['name']) ) && ($ui['name'] != '') ) {
		$aname = $ui['name'];
	} else {
		$aname = $ui['uname'];
	}
	if ($opnConfig['opn_newsletter_newsletteremail'] == '') {
		$aemail = $ui['email'];
	} else {
		$aemail = $opnConfig['opn_newsletter_newsletteremail'];
	}
	$aid = $ui['uid'];
	nl_ConfigHeader ();
	if ((int) $lid == 0) {
		nl_Error (_ONLA_ERRORINVALIDLID);
	}
	// first fetch the name
	$r = &$opnConfig['database']->Execute ('SELECT name, enabled FROM ' . $opnTables['newsletter_list'] . " WHERE lid=$lid;");
	$name = $r->fields['name'];
	$enabled = $r->fields['enabled'];
	if ($opnConfig['opn_newsletter_usename']) {
		$aname = $name;
	}
	// we allready test this!
	if (!$enabled) {
		die (_ONLA_CATEGORYCLOSED);
	}
	// Send it
	$boxtxt = '<p>' . _ONLA_SENDSTEP1;
	$nlid = $opnConfig['opnSQL']->get_new_number ('newsletter_' . $lid . '_data', 'nlid');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$text1 = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($text, true, true, 'nohtml'), 'text');
	$subject1 = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . '_data (nlid, aid, subject, wdate, text) VALUES (' . $nlid . ", $aid, $subject1, $now, $text1)");
	$boxtxt .= ( ($opnConfig['database']->ErrorNo () == 0)?_ONLA_OK : $opnConfig['database']->ErrorNo () . " - " . $opnConfig['database']->ErrorMsg () );
	$opnConfig['opnSQL']->UpdateBlobs ($opnConfig['tableprefix'] . 'newsletter_' . $lid . '_data', 'nlid=' . $nlid);
	$boxtxt .= "</p><p>";
	// get count
	$boxtxt .= _ONLA_TO . ': ' . $opnConfig['adminmail'];
	$mail = & new opn_mailer ();
	$mail->opn_mail_fill ($opnConfig['adminmail'], $fsubject, '', '', $ftext, $aname, $aemail, true);
	if ($opnConfig['opn_newsletter_usehtmlmail'] == 1) {
		$mail->SetToHTML_Send (true);
	}
	$mail->send ();
	$mail->init ();
	$r = &$opnConfig['database']->Execute ('SELECT email FROM ' . $opnConfig['tableprefix'] . "newsletter_" . $lid . "_user WHERE enabled=1 ORDER BY email;");
	$boxtxt .= ', ' . _ONLA_READY . '<br />' . _OPN_HTML_NL;
	$count = 0;
	if ($r !== false) {
		$count = $r->RecordCount ();
		while (! $r->EOF) {
			$email = $r->fields['email'];
			$boxtxt .= _ONLA_TO . ': ' . $email;
			$mail = & new opn_mailer ();
			$mail->opn_mail_fill ($email, $fsubject, '', '', $ftext, $aname, $aemail, true);
			if ($opnConfig['opn_newsletter_usehtmlmail'] == 1) {
				$mail->SetToHTML_Send (true);
			}
			$mail->send ();
			$mail->init ();
			$boxtxt .= ', ' . _ONLA_READY . '<br />' . _OPN_HTML_NL;
			$r->MoveNext ();
		}
	}
	$boxtxt .= '</p><p>' . ($count+1) . '&nbsp;' . _ONLA_NEWSLETTERSENT . '</p>' . _OPN_HTML_NL;
	$boxtxt .= '<br /><br />' . nl_GoBack ('index.php') . '<br />';
	$boxtxt .= '<br />';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_OPN_NEWSLETTER_200_';
	$_display_dat['module'] = 'modules/opn_newsletter';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox (_ONLA_SENDNEWSLETTER . ' (' . $name . ')', $boxtxt, '');
	return TRUE;

}
$dofoot = FALSE;
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'write':
		$dofoot = nl_Write ();
		break;
	case 'preview':
		$dofoot = nl_Preview ();
		break;
	case 'sendletter':
		$again = '';
		get_var ('again', $again, 'form', _OOBJ_DTYPE_CLEAN);
		if ($again != '') {
			$dofoot = nl_Preview ();
		} else {
			$dofoot = nl_Send ();
		}
		break;
	case 'userchange':
		nl_ChangeUser ();
		break;
	case 'adduser':
		nl_ConfigHeader ();
		nl_AddUser ();
		$dofoot = nl_ShowMembers ();
		break;
	case 'edituser':
		$dofoot = nl_EditUser ();
		break;
	case 'members':
	case 'deleteuser':
		$lid = 0;
		get_var ('lid', $lid, 'url', _OOBJ_DTYPE_INT);
		if ( ($op == 'deleteuser') && ((int) $lid != 0) ) {
			$nluid = 0;
			get_var ('nluid', $nluid, 'url', _OOBJ_DTYPE_INT);
			$_nluid = $opnConfig['opnSQL']->qstr ($nluid);
			$opnConfig['database']->Execute ('DELETE from ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE nluid=$_nluid");
		}
		nl_ConfigHeader ();
		$dofoot = nl_ShowMembers ();
		break;
	case 'export':
		$dofoot = nl_ExportMembers ();
		break;
	case 'import':
		$dofoot = nl_ImportMembers ();
		break;
	case 'kill':
		nl_KillCat ();
		$dofoot = nl_ShowAdminSection ();
		break;
	case 'delete':
		$dofoot = nl_DeletCat ();
		break;
	case 'add':
		$dofoot = nl_AddCategory ();
		break;
	case 'checkadd':
		nl_AddData ();
		$dofoot = nl_ShowAdminSection ();
		break;
	case 'checkedit':
		$dofoot = nl_EditData ();
		break;
	case 'edit':
		$dofoot = nl_Edit ();
		break;
	default:
		$dofoot = nl_ShowAdminSection ();
	}
	if ($dofoot) {
		$opnConfig['opnOutput']->DisplayFoot ();
	}

	?>