<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/opn_newsletter/plugin/sidebox/newsletter/language/');
include_once (_OPN_ROOT_PATH . 'modules/opn_newsletter/function_center.php');
include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_activation.php');

function newsletter_get_sidebox_result (&$box_array_dat) {

	global $opnConfig;

	$opnConfig['activation'] = & new OPNActivation ();
	$op = '';
	get_var ('op', $op, 'form', _OOBJ_DTYPE_CLEAN);
	if ($op == 'useradd') {
		$lid = 0;
		get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
		newsletter_add ($lid);
	}
	if ($op == 'userremove') {
		$lid = 0;
		get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
		newsletter_del ($lid);
	}
	if ($op == 'useraddremove') {
		newsletter_addremove ();
	}
	$boxstuff = $box_array_dat['box_options']['textbefore'];
	$boxstuff .= newsletter_list ($box_array_dat);
	$boxstuff .= $box_array_dat['box_options']['textafter'];
	$box_array_dat['box_result']['skip'] = false;
	$box_array_dat['box_result']['title'] = $box_array_dat['box_options']['title'];
	$box_array_dat['box_result']['content'] = $boxstuff;
	unset ($boxstuff);

}

function newsletter_list (&$box_array_dat) {

	global $opnConfig, $opnTables;

	$access = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->Execute ('SELECT lid, name, access, enabled, description FROM ' . $opnTables['newsletter_list'] . " WHERE access in ($access) ORDER BY name;");
	if ($result !== false) {
		$entries = $result->RecordCount ();
	} else {
		$entries = 0;
	}
	$boxtxt = '';
	if ($entries>0) {
		$table = & new opn_TableClass ('alternator');
		$table->SetAutoAlternator ('1');
		while (! $result->EOF) {
			// test if user is in list
			$lid = $result->fields['lid'];
			$enabled = $result->fields['enabled'];
			$access = $result->fields['access'];
			$name = $result->fields['name'];
			$active = nl_UserActive ($lid)&$enabled;
			$description = $result->fields['description'];
			$table->Alternate ();
			$dcol = ($active?'%alternateextra%' : '%alternate%');
			$table->AddDataRow (array ('<a class="' . $dcol . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php', 'op' => 'archive', 'lid' => $lid) ) . '">' . $name . '</a>') );
			if ($description != '') {
				$table->AddDataRow (array ($description) );
			}
			if ($box_array_dat['box_options']['display_addremove']) {
				if ($enabled == 0) {
					$table->AddDataRow (array (_OLN_SIDEBOX_THISNLISCLOSED) );
				} else {
					$form = & new opn_FormularClass ('listalternator');
					$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_OPN_NEWSLETTER_340_', 'opn_newsletter');
					$form->Init ('');
					$form->AddTable ();
					$form->AddCols (array ('10%', '90%') );
					if ($opnConfig['permission']->IsUser () ) {
						if ($active) {
							$op = 'userremove';
							$submit = _OLN_SIDEBOX_UNSUBSCRIBE;
							$form->AddOpenRow ();
						} else {
							$op = 'useradd';
							$submit = _OLN_SIDEBOX_SUBSCRIBE;
							$form->AddOpenRow ();
						}
					} else {
						$form->AddOpenRow ();
						$form->AddLabel ('email', _OLN_SIDEBOX_EMAIL);
						$form->AddTextfield ('email', 10, 128);
						$op = 'useraddremove';
						$submit = _OLN_SIDEBOX_SUBORUNSUBSCRIBE;
						$form->AddChangeRow ();
					}
					$form->SetSameCol ();
					$form->AddHidden ('lid', $lid);
					$form->AddHidden ('op', $op);
					$form->SetEndCol ();
					$form->AddSubmit ('submit', $submit);
					$form->AddCloseRow ();
					$form->AddTableClose ();
					$form->AddFormEnd ();
					$hlp = '';
					$form->GetFormular ($hlp);
					$table->AddDataRow (array ($hlp) );
				}
			}
			$result->MoveNext ();
		}
		$table->GetTable ($boxtxt);
		$result->Close ();
	} else {
		$boxtxt .= '<div class="centertag">' . _OLN_SIDEBOX_SORRYNONLHERE . '</div>';
	}
	return $boxtxt;

}

function newsletter_add ($lid) {

	global $opnConfig, $opnTables;

	$ui = $opnConfig['permission']->GetUserinfo ();
	// fetch name and access
	$r = &$opnConfig['database']->Execute ('SELECT name, access, enabled FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	$db_access = $r->fields['access'];
	$enabled = $r->fields['enabled'];
	if ( (!$opnConfig['permission']->CheckUserGroup ($db_access) ) || !$enabled) {
	} else {
		$r = &$opnConfig['database']->Execute ('SELECT email FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email='" . $ui['email'] . "'");
		if ($r !== false) {
			$num = $r->RecordCount ();
		} else {
			$num = 0;
		}
		if (!$num) {
			// could be happend that he will remove without logged in as user
			$code = md5 (uniqid (rand () ) );
			$nluid = $opnConfig['opnSQL']->get_new_number ('newsletter_' . $lid . '_user', 'nluid');
			$opnConfig['opndate']->now ();
			$now = '';
			$opnConfig['opndate']->opnDataTosql ($now);
			$_code = $opnConfig['opnSQL']->qstr ($code);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user (nluid, email, enabled, wdate, code) VALUES ($nluid, '" . $ui['email'] . "', 1, $now, $_code);");
		}
	}

}

function newsletter_del ($lid) {

	global $opnConfig;

	$ui = $opnConfig['permission']->GetUserinfo ();
	if (!isset ($ui['name']) ) {
		$ui['name'] = '';
	}
	// fetch name and access
	$r = &$opnConfig['database']->Execute ('SELECT nluid FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email='" . $ui['email'] . "'");
	if ($r !== false) {
		$num = $r->RecordCount ();
	} else {
		$num = 0;
	}
	if ($num) {
		$nluid = $r->fields['nluid'];
		$opnConfig['database']->Execute ('DELETE from ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE nluid=$nluid;");
	}

}

function newsletter_addremove () {

	global $opnConfig, $opnTables;
	if (!defined ('_OPN_MAILER_INCLUDED') ) {
		include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
	}
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$lid = 0;
	get_var ('lid', $lid, 'form', _OOBJ_DTYPE_INT);
	$r = &$opnConfig['database']->Execute ('SELECT name FROM ' . $opnTables['newsletter_list'] . ' WHERE lid=' . $lid);
	$name = $r->fields['name'];
	$vars['{SITENAME}'] = $opnConfig['sitename'];
	$vars['{EMAIL}'] = $email;
	$vars['{LISTNAME}'] = $name;
	$from = $opnConfig['adminmail'];
	$opnConfig['activation']->InitActivation ();
	$opnConfig['activation']->BuildActivationKey ();
	$opnConfig['activation']->SetActdata ($email);
	$opnConfig['activation']->SetExtraData ($lid);
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$r = &$opnConfig['database']->Execute ('SELECT nluid FROM ' . $opnConfig['tableprefix'] . 'newsletter_' . $lid . "_user WHERE email=$_email");
	$key = $opnConfig['activation']->GetActivationKey ();
	if ($r->RecordCount () == 0) {
		$subject = sprintf (_OLN_SIDEBOX_ADDSUBJECT, $name);
		$mail1 = 'addnl';
		$url = encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php?',
					'op' => 'confirmedadd',
					'actkey' => $key,
					'email' => $email,
					false) );
	} else {
		$subject = sprintf (_OLN_SIDEBOX_REMOVESUBJECT, $name);
		$mail1 = 'removenl';
		$url = encodeurl (array ($opnConfig['opn_url'] . '/modules/opn_newsletter/index.php',
					'op' => 'confirmedremove',
					'actkey' => $key,
					'email' => $email,
					false) );
	}
	$vars['{URL}'] = $url;
	$vars['{KEY}'] = $key;
	$opnConfig['activation']->SaveActivation ();
	$from = $opnConfig['adminmail'];
	$mail = & new opn_mailer ();
	$mail->opn_mail_fill ($email, $subject, 'modules/opn_newsletter', $mail1, $vars, $opnConfig['opn_webmaster_name'], $from);
	$mail->send ();
	$mail->init ();

}

?>