<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/poll', true);
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/poll/admin/language/');
$boxtxt = '';

function PollConfigHeader () {

	global $opnTables, $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_POLL_INDEXPOLLCONFIGURATION);
	$menu->InsertEntry (_POLL_INDEXMAIN, $opnConfig['opn_url'] . '/modules/poll/admin/index.php');
	$menu->InsertEntry (_POLL_INDEXSETTINGS, $opnConfig['opn_url'] . '/modules/poll/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);
	$result = &$opnConfig['database']->SelectLimit ('SELECT pollid, polltitle, wtimestamp FROM ' . $opnTables['poll_desc'] . ' ORDER BY pollid DESC', 1);
	if ( ($result !== false) && (!$result->EOF) ) {
		$pollTitle = $result->fields['polltitle'];
		$boxtxt = '<div class="centertag"><span class="normaltext">';
		$boxtxt .= _POLL_INDEXCURRENTPOLL . ' ' . $pollTitle . '</span></div>';
		$boxtxt .= '<br />';
	} else {
		$boxtxt = '';
	}
	return $boxtxt;

}

/*********************************************************/

/* Poll/Surveys Functions				*/

/*******************************************************/

function poll_listPoll () {

	global $opnTables, $opnConfig;

	$result = &$opnConfig['database']->Execute ('SELECT pollid, polltitle, wtimestamp, topicid FROM ' . $opnTables['poll_desc'] . ' ORDER BY pollid');
	$boxtxt = '<div class="centertag"><span class="extratextbold">' . _POLL_INDEXPOLLCONFIGURATION . '</span></div><br />';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/poll/admin/index.php?op=create') . '">' . _POLL_INDEXCREATENEWPOLL . '</a><br /><br />';
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_POLL_INDEXTITLE, _POLL_INDEXACTION, _POLL_INDEXSELECTEDTOPIC) );
	if ($result !== false) {
		while (! $result->EOF) {
			$myrow = $result->GetRowAssoc ('0');
			$title = $myrow['polltitle'];
			if ($myrow['topicid'] != 0) {
				$r = &$opnConfig['database']->Execute ('SELECT topictext FROM ' . $opnTables['article_topics'] . ' WHERE topicid=' . $myrow['topicid']);
				$topic = $r->fields['topictext'];
			} else {
				$topic = _POLL_NONE;
			}
			$table->AddDataRow (array ($title, $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/poll/admin/index.php', 'op' => 'poll_edit', 'pollid' => $myrow['pollid']) ) . '&nbsp;' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/poll/admin/index.php', 'op' => 'remove', 'pollid' => $myrow['pollid']) ), $topic), array ('left', 'center', 'right') );
			$result->MoveNext ();
		}
	}
	$table->GetTable ($boxtxt);
	return $boxtxt;

}

function poll_createPoll () {

	global $opnConfig, $opnTables;
	if (isset ($opnTables['article_topics']) ) {
		$mf = & new MyFunctions;
		$mf->table = $opnTables['article_topics'];
		$mf->id = 'topicid';
		$mf->title = 'topictext';
	}
	$boxtxt = "<div align='center'><span class='extratextbold'>" . _POLL_INDEXCREATENEWPOLL . '</span></div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_POLL_10_', "poll");
	$form->Init ($opnConfig['opn_url'] . "/modules/poll/admin/index.php");
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('pollTitle', _POLL_INDEXPOLLTITLE);
	$form->AddTextfield ('pollTitle', 50, 100);
	$form->AddChangeRow ();
	$form->SetColspan ('2');
	$form->AddText (_POLL_INDEXPLEASEENTER);
	$form->SetColspan ('');
	for ($i = 1; $i<= $opnConfig['maxOptions']; $i++) {
		$form->AddChangeRow ();
		$form->AddLabel ("optionText[]", _POLL_INDEXOPTION . ' ' . $i);
		$form->AddTextfield ("optionText[]", 50, 50);
	}
	if (isset ($opnTables['article_topics']) ) {
		$form->AddChangeRow ();
		$form->AddText (_POLL_TOPIC);
		$mf->makeMySelBox (0, $form, 1);
	}
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'createPosted');
	$form->SetSameCol ();
	$form->AddSubmit ('submit', _POLL_INDEXCREATE);
	$form->AddText ('&nbsp;');
	$form->AddButton ('Cancel', _POLL_INDEXCANCEL, _POLL_INDEXCANCEL, '', "javascript:history.go(-1)");
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function poll_editPoll () {

	global $opnConfig, $opnTables;

	$pollid = 0;
	get_var ('pollid', $pollid, 'url', _OOBJ_DTYPE_INT);
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$mf = & new MyFunctions;
		$mf->table = $opnTables['article_topics'];
		$mf->id = 'topicid';
		$mf->title = 'topictext';
	}
	$result = &$opnConfig['database']->Execute ('SELECT polltitle, topicid FROM ' . $opnTables['poll_desc'] . ' WHERE pollid=' . $pollid);
	$title = $result->fields['polltitle'];
	$topicid = $result->fields['topicid'];
	$boxtxt = '<div class="centertag"><span class="extratextbold">' . _POLL_INDEXEDITPOLL . '</span></div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_POLL_20_', 'poll');
	$form->Init ($opnConfig['opn_url'] . '/modules/poll/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('pollTitle', _POLL_INDEXPOLLTITLE);
	$form->AddTextfield ('pollTitle', 50, 100, $title);
	$form->AddChangeRow ();
	$form->SetColspan ('2');
	$form->AddText (_POLL_INDEXPLEASEENTER);
	$form->SetColspan ('');
	$result = &$opnConfig['database']->Execute ('SELECT optiontext, voteid FROM ' . $opnTables['poll_data'] . " WHERE pollid=" . $pollid . "");
	$i = 1;
	if ($result !== false) {
		while (! $result->EOF) {
			$option = $result->fields['optiontext'];
			$voteID = $result->fields['voteid'];
			$form->AddChangeRow ();
			$form->AddLabel ("optionText[]", _POLL_INDEXOPTION . ' ' . $i);
			$form->SetSameCol ();
			$form->AddTextfield ("optionText[]", 50, 50, $option);
			$form->AddHidden ("voteID[]", $voteID);
			$form->SetEndCol ();
			$i++;
			$result->MoveNext ();
		}
	}
	$form->AddChangeRow ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/article') ) {
		$form->AddText (_POLL_TOPIC);
		$mf->makeMySelBox ($topicid, $form, 1);
	} else {
		$form->AddText ('&nbsp;');
		$form->AddHidden ('topicid', 0);
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('pollid', $pollid);
	$form->AddHidden ('op', 'poll_editPosted');
	$form->SetEndCol ();
	$form->SetSameCol ();
	$form->AddSubmit ('submit', _POL_SAVE);
	// _POLL_INDEXEDIT
	$form->AddText ('&nbsp;');
	$form->AddButton ('Cancel', _POLL_INDEXCANCEL, _POLL_INDEXCANCEL, '', "javascript:history.go(-1)");
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function poll_createPosted () {

	global $opnConfig, $opnTables;

	$optionText = array ();
	get_var ('optionText', $optionText,'form',_OOBJ_DTYPE_CLEAN);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$pollTitle = '';
	get_var ('pollTitle', $pollTitle, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['opndate']->now ();
	$timeStamp = '';
	$opnConfig['opndate']->opnDataTosql ($timeStamp);
	$pollTitle = $opnConfig['opnSQL']->qstr ($pollTitle);
	$pollid = $opnConfig['opnSQL']->get_new_number ("poll_desc", "pollid");
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['poll_desc'] . " VALUES ($pollid, $pollTitle, $timeStamp, 0, $topicid)");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt = $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />';
		return $boxtxt;
	}
	$r = &$opnConfig['database']->Execute ('SELECT pollid FROM ' . $opnTables['poll_desc'] . ' WHERE polltitle=' . $pollTitle);
	$id = $r->fields['pollid'];
	$max = count ($optionText);
	for ($i = 0; $i< $max; $i++) {
		if ($optionText[$i] != "") {
			$optionText[$i] = $opnConfig['opnSQL']->qstr ($optionText[$i]);
		} else {
			$optionText[$i] = $opnConfig['opnSQL']->qstr ("");
		}
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['poll_data'] . " (pollid, optiontext, optioncount, voteid) VALUES ($id, $optionText[$i], 0, $i)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$boxtxt = $opnConfig['database']->ErrorNo () . ": " . $opnConfig['database']->ErrorMsg () . '<br />';
			return $boxtxt;
		}
	}
	$opnConfig['opnOutput']->Redirect (encodeurl ("/modules/poll/admin/index.php?op=adminMain", false) );
	CloseTheOpnDB ($opnConfig);
	return '';

}

function poll_editPosted () {

	global $opnConfig, $opnTables;

	$pollid = 0;
	get_var ('pollid', $pollid, 'form', _OOBJ_DTYPE_INT);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$voteID = array ();
	get_var ('voteID', $voteID,'form',_OOBJ_DTYPE_INT);
	$optionText = array ();
	get_var ('optionText', $optionText,'form',_OOBJ_DTYPE_CLEAN);
	$pollTitle = '';
	get_var ('pollTitle', $pollTitle, 'form', _OOBJ_DTYPE_CHECK);
	$pollTitle = $opnConfig['opnSQL']->qstr ($pollTitle);
	$query = 'UPDATE ' . $opnTables['poll_desc'] . " SET polltitle=" . $pollTitle . ", topicid=" . $topicid . " WHERE pollid=" . $pollid . "";
	$opnConfig['database']->Execute ($query);
	$boxtxt = "";
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt .= $opnConfig['database']->ErrorNo () . ": " . $opnConfig['database']->ErrorMsg () . '<br />';
		return $boxtxt;
	}
	$max = count ($optionText);
	for ($i = 0; $i< $max; $i++) {
		if ($optionText[$i] != '') {
			$optionText[$i] = $opnConfig['opnSQL']->qstr ($optionText[$i]);
		} else {
			$optionText[$i] = $opnConfig['opnSQL']->qstr ('');
		}
		$query = 'UPDATE ' . $opnTables['poll_data'] . " SET optiontext=$optionText[$i] WHERE pollid=" . $pollid . " and voteid=" . $voteID[$i] . "";
		$opnConfig['database']->Execute ($query);
		if ($opnConfig['database']->ErrorNo ()>0) {
			$boxtxt .= $opnConfig['database']->ErrorNo () . ": " . $opnConfig['database']->ErrorMsg () . '<br />';
			return $boxtxt;
		}
	}
	$opnConfig['opnOutput']->Redirect (encodeurl ("/modules/poll/admin/index.php?op=adminMain", false) );
	CloseTheOpnDB ($opnConfig);
	return '';

}

function poll_removePoll () {

	global $opnTables, $opnConfig;

	$pollid = 0;
	get_var ('pollid', $pollid, 'url', _OOBJ_DTYPE_INT);
	$boxtxt = "<div align='center'><span class='extratextbold'>" . _POLL_INDEXDELETEPOLL . '</span><br />';
	$boxtxt .= "<span class='alerttext'>" . _POLL_INDEXWARNING . '</span>';
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_POLL_30_', "poll");
	$form->Init ($opnConfig['opn_url'] . "/modules/poll/admin/index.php");
	$form->AddHidden ('op', 'removePosted');
	$result = &$opnConfig['database']->Execute ('SELECT polltitle FROM ' . $opnTables['poll_desc'] . " WHERE pollid=" . $pollid . "");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt .= $opnConfig['database']->ErrorNo () . ": " . $opnConfig['database']->ErrorMsg () . '<br />';
		return $boxtxt;
	}
	// cycle through the descriptions until everyone has been fetched
	$title = $result->fields['polltitle'];
	$form->AddText ('<span class="normaltextbold">' . $title . '</span>');
	$form->AddHidden ('id', $pollid);
	$form->AddNewline (2);
	$form->AddSubmit ('submit', _POLL_INDEXREMOVE);
	$form->AddText ('&nbsp;');
	$form->AddButton ('Cancel', _POLL_INDEXCANCEL, _POLL_INDEXCANCEL, '', "javascript:history.go(-1)");
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div>';
	return $boxtxt;

}

function poll_removePosted () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['poll_desc'] . " WHERE pollid=$id");
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['poll_data'] . " WHERE pollid=$id");
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['poll_comments'] . " WHERE sid=$id");
	$opnConfig['opnOutput']->Redirect (encodeurl ("/modules/poll/admin/index.php?op=adminMain", false) );
	CloseTheOpnDB ($opnConfig);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$boxtxt = '';
switch ($op) {
	default:
		$boxtxt .= poll_listPoll ();
		break;
	case 'poll_listPoll':
		$boxtxt .= poll_listPoll ();
		break;
	case 'create':
		$boxtxt .= poll_createPoll ();
		break;
	case 'createPosted':
		poll_createPosted ();
		break;
	case 'poll_edit':
		$boxtxt .= poll_editPoll ();
		break;
	case 'poll_editPosted':
		poll_editPosted ();
		break;
	case 'remove':
		$boxtxt .= poll_removePoll ();
		break;
	case 'removePosted':
		poll_removePosted ();
		break;
}
$boxtxt = PollConfigHeader () . $boxtxt;
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_POLL_40_';
$_display_dat['module'] = 'modules/poll';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_POLL_INDEXPOLLCONFIGURATION, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>