<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_PROJECT_CATEGORY_INCLUDED') ) {
	define ('_OPN_PROJECT_CATEGORY_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.abstracts.php');

	class ProjectCategory extends AbstractProjects {
		var $_project = 0;

		function ProjectCategory () {

			$this->_fieldname = 'category_id';
			$this->_tablename = 'projects_category';

		}

		function SetProject ($project) {

			$this->_project = $project;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT category_id, category, project_id FROM ' . $opnTables['projects_category'] . $where . ' ORDER BY category_id');
			while (! $result->EOF) {
				$this->_cache[$result->fields['category_id']]['category_id'] = $result->fields['category_id'];
				$this->_cache[$result->fields['category_id']]['category'] = $result->fields['category'];
				$this->_cache[$result->fields['category_id']]['project_id'] = $result->fields['project_id'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$where = $this->BuildWhere ();
				if ($where == '') {
					$where = ' WHERE ';
				} else {
					$where .= ' AND ';
				}
				$where .= ' category_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT category_id, category, project_id FROM ' . $opnTables['projects_category'] . $where);
				$this->_cache[$result->fields['category_id']]['category_id'] = $result->fields['category_id'];
				$this->_cache[$result->fields['category_id']]['category'] = $result->fields['category'];
				$this->_cache[$result->fields['category_id']]['project_id'] = $result->fields['project_id'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
			$category = '';
			get_var ('category', $category, 'form', _OOBJ_DTYPE_CLEAN);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$category_id = $opnConfig['opnSQL']->get_new_number ('projects_category', 'category_id');
			$this->_cache[$category_id]['category_id'] = $category_id;
			$this->_cache[$category_id]['category'] = $category;
			$this->_cache[$category_id]['project_id_id'] = $project_id;
			$category = $opnConfig['opnSQL']->qstr ($category);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['projects_category'] . "(category_id,category,project_id) VALUES ($category_id,$category,$project_id)");
			return $category_id;

		}

		function ModifyRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
			$category_id = 0;
			get_var ('category_id', $category_id, 'form', _OOBJ_DTYPE_INT);
			$category = '';
			get_var ('category', $category, 'form', _OOBJ_DTYPE_CLEAN);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$this->_cache[$category_id]['category'] = $category;
			$this->_cache[$category_id]['project_id'] = $project_id;
			$category = $opnConfig['opnSQL']->qstr ($category);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['projects_category'] . " SET category=$category, project_id=$project_id WHERE category_id=$category_id");

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$category_id = 0;
			get_var ('category_id', $category_id, 'both', _OOBJ_DTYPE_INT);
			unset ($this->_cache[$category_id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects_category'] . ' WHERE category_id=' . $category_id);

		}

		function DeleteByProject ($project_id) {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects_category'] . ' WHERE project_id=' . $project_id);

		}

		function GetLimit ($limit, $offset) {

			global $opnConfig, $opnTables;

			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->SelectLimit ('SELECT category_id, category, project_id FROM ' . $opnTables['projects_category'] . $where . ' ORDER BY category_id', $limit, $offset);
			return $result;

		}

		function BuildWhere () {
			if ($this->_project) {
				return ' WHERE project_id=' . $this->_project;
			}
			return '';

		}

	}
}

?>