<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_PROJECT_STATUS_INCLUDED') ) {
	define ('_OPN_PROJECT_STATUS_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.abstracts.php');

	class ProjectStatus extends AbstractProjects {

		function ProjectStatus () {

			$this->_fieldname = 'status_id';
			$this->_tablename = 'projects_status';

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$result = $opnConfig['database']->Execute ('SELECT status_id, status_name FROM ' . $opnTables['projects_status'] . ' ORDER BY status_id');
			while (! $result->EOF) {
				$this->_cache[$result->fields['status_id']]['status_id'] = $result->fields['status_id'];
				$this->_cache[$result->fields['status_id']]['status_name'] = $result->fields['status_name'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if (!isset ($this->_cache[$id]) ) {
				$result = $opnConfig['database']->Execute ('SELECT status_id, status_name FROM ' . $opnTables['projects_status'] . ' WHERE status_id=' . $id);
				$this->_cache[$id]['status_id'] = $result->fields['status_id'];
				$this->_cache[$id]['status_name'] = $result->fields['status_name'];
				$result->Close ();
			}
			return $this->_cache[$id];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
			$status_name = '';
			get_var ('status_name', $status_name, 'form', _OOBJ_DTYPE_CLEAN);
			$status_id = $opnConfig['opnSQL']->get_new_number ('projects_status', 'status_id');
			$this->_cache[$status_id]['status_id'] = $status_id;
			$this->_cache[$status_id]['status_name'] = $status_name;
			$status_name = $opnConfig['opnSQL']->qstr ($status_name);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['projects_status'] . "(status_id,status_name) VALUES ($status_id,$status_name)");

		}

		function ModifyRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_EDIT, _PERM_ADMIN) );
			$status_id = 0;
			get_var ('status_id', $status_id, 'form', _OOBJ_DTYPE_INT);
			$status_name = '';
			get_var ('status_name', $status_name, 'form', _OOBJ_DTYPE_CLEAN);
			$this->_cache[$status_id]['status_name'] = $status_name;
			$status_name = $opnConfig['opnSQL']->qstr ($status_name);
			$opnConfig['database']->Execute ('UPDATE ' . $opnTables['projects_status'] . " SET status_name=$status_name WHERE status_id=$status_id");

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$status_id = 0;
			get_var ('status_id', $status_id, 'both', _OOBJ_DTYPE_INT);
			unset ($this->_cache[$status_id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects_status'] . ' WHERE status_id=' . $status_id);

		}

		function GetLimit ($limit, $offset) {

			global $opnConfig, $opnTables;

			$result = $opnConfig['database']->SelectLimit ('SELECT status_id, status_name FROM ' . $opnTables['projects_status'] . ' ORDER BY status_id', $limit, $offset);
			return $result;

		}

	}
}

?>