<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_PROJECT_USER_INCLUDED') ) {
	define ('_OPN_PROJECT_USER_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . 'modules/project/include/class.abstracts.php');

	class ProjectUser extends AbstractProjects {
		var $_project = 0;

		function ProjectUser () {

			$this->_fieldname = 'user_id';
			$this->_tablename = 'projects_user';

		}

		function SetProject ($project) {

			$this->_project = $project;

		}

		function RetrieveAll () {

			global $opnConfig, $opnTables;

			$this->_cache = array ();
			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->Execute ('SELECT project_id, user_id FROM ' . $opnTables['projects_user'] . $where . ' ORDER BY project_id,user_id');
			while (! $result->EOF) {
				$id = 'P' . $result->fields['project_id'] . 'U' . $result->fields['user_id'];
				$this->_cache[$id]['project_id'] = $result->fields['project_id'];
				$this->_cache[$id]['user_id'] = $result->fields['user_id'];
				$result->MoveNext ();
			}
			$result->Close ();

		}

		function RetrieveSingle ($id) {

			global $opnConfig, $opnTables;
			if ($this->_project) {
				$id1 = 'P' . $this->_project . 'U' . $id;
			}
			if (!isset ($this->_cache[$id]) ) {
				$where = $this->BuildWhere ();
				if ($where == '') {
					$where = ' WHERE ';
				} else {
					$where .= ' AND ';
				}
				$where .= ' user_id=' . $id;
				$result = $opnConfig['database']->Execute ('SELECT project_id, user_id FROM ' . $opnTables['projects_user'] . $where);
				$id1 = 'P' . $result->fields['project_id'] . 'U' . $result->fields['user_id'];
				$this->_cache[$id1]['project_id'] = $result->fields['project_id'];
				$this->_cache[$id1]['user_id'] = $result->fields['user_id'];
				$result->Close ();
			}
			return $this->_cache[$id1];

		}

		function AddRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_NEW, _PERM_ADMIN) );
			$user_id = '';
			get_var ('user_id', $user_id, 'form', _OOBJ_DTYPE_INT);
			$project_id = 0;
			get_var ('project_id', $project_id, 'form', _OOBJ_DTYPE_INT);
			$id = 'P' . $project_id . 'U' . $user_id;
			$this->_cache[$id]['project_id'] = $project_id;
			$this->_cache[$id]['user_id'] = $user_id;
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['projects_user'] . "(project_id,user_id) VALUES ($project_id,$user_id)");

		}

		function DeleteRecord () {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$project_id = 0;
			get_var ('project_id', $project_id, 'both', _OOBJ_DTYPE_INT);
			$user_id = 0;
			get_var ('user_id', $user_id, 'both', _OOBJ_DTYPE_INT);
			$id = 'P' . $project_id . 'U' . $user_id;
			unset ($this->_cache[$id]);
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects_user'] . ' WHERE project_id=' . $project_id . ' AND user_id=' . $user_id);

		}

		function DeleteByProject ($project_id) {

			global $opnConfig, $opnTables;

			$opnConfig['permission']->HasRights ('modules/project', array (_PERM_DELETE, _PERM_ADMIN) );
			$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['projects_user'] . ' WHERE project_id=' . $project_id);

		}

		function GetLimit ($limit, $offset) {

			global $opnConfig, $opnTables;

			$where = $this->BuildWhere ();
			$result = $opnConfig['database']->SelectLimit ('SELECT project_id, user_id FROM ' . $opnTables['projects_user'] . $where . ' ORDER BY project_id,user_id', $limit, $offset);
			return $result;

		}

		function GetCount ($user_id = 0) {

			global $opnConfig, $opnTables;

			$where = $this->BuildWhere ();
			if ($user_id) {
				if ($where == '') {
					$where = ' WHERE ';
				} else {
					$where .= ' AND ';
				}
				$where .= ' user_id=' . $user_id;
			}
			$result = &$opnConfig['database']->Execute ('SELECT COUNT(' . $this->_fieldname . ') AS counter FROM ' . $opnTables[$this->_tablename] . $where);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$counter = $result->fields['counter'];
			} else {
				$counter = 0;
			}
			return $counter;

		}

		function BuildWhere () {
			if ($this->_project) {
				return ' WHERE project_id=' . $this->_project;
			}
			return '';

		}

	}
}

?>