<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/qotd/admin/language/');
include_once (_OPN_ROOT_PATH . 'include/opn_ini_options_get.php');

function qotdConfigHeader () {

	global $opnTables, $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(qid) AS summe FROM ' . $opnTables['quotes_submit']);
	if ( ($result !== false) && (isset ($result->fields['summe']) ) ) {
		$newsubs = $result->fields['summe'];
	} else {
		$newsubs = 0;
	}
	$menu = & new OPN_Adminmenu (_QOT_ADMIN_CONF);
	$menu->InsertEntry (_QOT_ADMIN_MAIN, $opnConfig['opn_url'] . '/modules/qotd/admin/index.php');
	if ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) {
		$menu->InsertEntry (_QOT_ADMIN_MODIFY,
										array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
			'op' => 'QotdDisplay',
			'offset' => '0') );
	}
	if ( ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_NEW, _PERM_ADMIN), true) ) && ($newsubs != 0) ) {
		$menu->InsertEntry (_QOT_ADMIN_SUBMISSIONS . ' (' . $newsubs . ')',
										array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
			'op' => 'submissions') );
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('pro/im_export_manager') ) {
		if ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_ADMIN, _QOTD_PERM_IMPORT), true) ) {
			$menu->InsertEntry (_QOT_ADMIN_IMPORT,
											array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
				'op' => 'import') );
		}
		if ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_ADMIN, _QOTD_PERM_EXPORT), true) ) {
			$menu->InsertEntry (_QOT_ADMIN_EXPORT,
											array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
				'op' => 'export') );
		}
	}
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function submissions () {

	global $opnTables, $opnConfig;

	$dummy = 0;
	$txt = '';
	$result = &$opnConfig['database']->Execute ('SELECT qid, quote, author FROM ' . $opnTables['quotes_submit'] . ' WHERE qid>0');
	if ( ($result === false) or ($result->EOF) ) {
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array (_QOT_ADMIN_ADMIN_NONEWQUOTESSUBMISSIONS) );
		$table->GetTable ($txt);
	} else {
		$txt .= '<div class="centertag"><span class="normaltextbold">' . _QOT_ADMIN_ADMIN_NEWQUOTESSUBMISSIONS . '</span><br /><br />';
		$table = & new opn_TableClass ('alternator');
		while (! $result->EOF) {
			$qid = $result->fields['qid'];
			$quote = $result->fields['quote'];
			$author = $result->fields['author'];
			$table->AddOpenRow ();
			$table->AddDataCol ($author);
			$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
												'op' => 'EditSubmission',
												'qid' => $qid) ) . '">' . $quote . '</a>');
			$table->AddCloseRow ();
			$dummy++;
			$result->MoveNext ();
		}
		if ($dummy<1) {
			$table->AddDataRow (array ('<span class="normaltextbold">' . _QOT_ADMIN_ADMIN_NONEWQUOTESSUBMISSIONS . '</span>') );
		}
		$table->GetTable ($txt);
	}
	return $txt;

}

function EditSubmission () {

	global $opnTables, $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '';
	$result = &$opnConfig['database']->SelectLimit ('SELECT quote, author FROM ' . $opnTables['quotes_submit'] . ' WHERE qid=' . $qid, 1);
	$quote = $result->fields['quote'];
	$author = $result->fields['author'];
	$myoptions = array ();
	$myoptions['_quotd_op_use_lang'] = '0';
	$myoptions['_quotd_op_use_group'] = 0;
	$boxtxt .= '<span class="extratextbold">';
	$boxtxt .= _QOT_ADMIN_EDIT_QUOTE;
	$boxtxt .= '</span><br /><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QOT_ADMIN_10_', 'qotd');
	$form->Init ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('qquote', _QOT_ADMIN_QUOTETEXT . ' ');
	$form->AddTextarea ('qquote', 0, 0, '', $quote);
	$form->AddChangeRow ();
	$form->AddLabel ('qauthor', _QOT_ADMIN_AUTHOR . '  ');
	$form->AddTextfield ('qauthor', 31, 128, $author);
	InputPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'SaveSubmission');
	$form->AddHidden ('qqid', $qid);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _QOT_ADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function SaveSubmission () {

	global $opnTables, $opnConfig;

	$qqid = 0;
	get_var ('qqid', $qqid, 'form', _OOBJ_DTYPE_INT);
	$qquote = '';
	get_var ('qquote', $qquote, 'form', _OOBJ_DTYPE_CLEAN);
	$qauthor = '';
	get_var ('qauthor', $qauthor, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_EDIT, _PERM_ADMIN) );
	$myoptions = array ();
	get_var ('_quotd_op_', $myoptions,'form','',true);
	if (!isset ($myoptions['_quotd_op_use_lang']) ) {
		$quotd_lang = '0';
	} else {
		$quotd_lang = $myoptions['_quotd_op_use_lang'];
	}
	if (!isset ($myoptions['_quotd_op_use_group']) ) {
		$quotd_group = 0;
	} else {
		$quotd_group = $myoptions['_quotd_op_use_group'];
	}
	$qid = $opnConfig['opnSQL']->get_new_number ('quotes', 'qid');
	$qquote = $opnConfig['opnSQL']->qstr ($qquote, 'quote');
	$qauthor = $opnConfig['opnSQL']->qstr ($qauthor);
	$_quotd_lang = $opnConfig['opnSQL']->qstr ($quotd_lang);
	$options = $opnConfig['opnSQL']->qstr (serialize ($myoptions), 'options');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['quotes'] . " values ($qid,$qquote, $qauthor, $options, $_quotd_lang, $quotd_group)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quotes'], 'qid=' . $qid);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['quotes_submit'] . ' WHERE qid=' . $qqid);

}

function InputPart ($myoptions, &$form) {

	global $opnConfig;
	if ( (!isset ($myoptions['_quotd_op_use_lang']) ) OR ($myoptions['_quotd_op_use_lang'] == '') ) {
		$myoptions['_quotd_op_use_lang'] = '0';
	}
	$options = get_language_options ();
	$form->AddChangeRow ();
	$form->AddLabel ('_quotd_op_use_lang', _QOT_ADMIN_USELANG . ' ');
	$form->AddSelect ('_quotd_op_use_lang', $options, $myoptions['_quotd_op_use_lang']);
	if ( (!isset ($myoptions['_quotd_op_use_group']) ) OR ($myoptions['_quotd_op_use_group'] == '') ) {
		$myoptions['_quotd_op_use_group'] = '0';
	}
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddChangeRow ();
	$form->AddLabel ('_quotd_op_use_group', _QOT_ADMIN_USEGROUP);
	$form->AddSelect ('_quotd_op_use_group', $options, $myoptions['_quotd_op_use_group']);

}

function QotdAdmin () {

	global $opnConfig;

	$boxtxt = '';
	if ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<span class="extratextbold">';
		$boxtxt .= _QOT_ADMIN_NEW;
		$boxtxt .= '</span><br /><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QOT_ADMIN_20_', 'qotd');
		$form->Init ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php');
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('qquote', _QOT_ADMIN_TEXT . '  ');
		$form->AddTextarea ('qquote');
		$form->AddChangeRow ();
		$form->AddLabel ('qauthor', _QOT_ADMIN_AUTHOR . '  ');
		$form->AddTextfield ('qauthor', 31, 128);
		$myoptions = array ();
		get_var ('_quotd_op_', $myoptions,'form','',true);
		InputPart ($myoptions, $form);
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'QotdAdd');
		$form->AddSubmit ('submit', _QOT_ADMIN_ADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	return $boxtxt;

}

function QotdAdd () {

	global $opnTables, $opnConfig;

	$qquote = '';
	get_var ('qquote', $qquote, 'form', _OOBJ_DTYPE_CHECK);
	$qauthor = '';
	get_var ('qauthor', $qauthor, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_NEW, _PERM_ADMIN) );
	$myoptions = array ();
	get_var ('_quotd_op_', $myoptions,'form','',true);
	if (!isset ($myoptions['_quotd_op_use_lang']) ) {
		$quotd_lang = '0';
	} else {
		$quotd_lang = $myoptions['_quotd_op_use_lang'];
	}
	if (!isset ($myoptions['_quotd_op_use_group']) ) {
		$quotd_group = 0;
	} else {
		$quotd_group = $myoptions['_quotd_op_use_group'];
	}
	$qid = $opnConfig['opnSQL']->get_new_number ('quotes', 'qid');
	$qquote = $opnConfig['opnSQL']->qstr ($qquote, 'quote');
	$qauthor = $opnConfig['opnSQL']->qstr ($qauthor);
	$options = $opnConfig['opnSQL']->qstr (serialize ($myoptions), 'options');
	$_quotd_lang = $opnConfig['opnSQL']->qstr ($quotd_lang);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['quotes'] . " values ($qid,$qquote, $qauthor, $options, $_quotd_lang, $quotd_group)");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quotes'], 'qid=' . $qid);

}

function QotdDisplay () {

	global $opnTables, $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$keyword = '';
	get_var ('keyword', $keyword, 'both', _OOBJ_DTYPE_CLEAN);
	$keyword = $opnConfig['cleantext']->filter_searchtext ($keyword);
	$boxtxt = '';
	if ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_EDIT, _PERM_DELETE, _PERM_ADMIN), true) ) {
		$keyword2 = str_replace (' ',
										'%',
										$keyword);
		$like_search = $opnConfig['opnSQL']->AddLike ($keyword2);
		$whereclause = 'WHERE quote LIKE ' . $like_search;
		if ($keyword == '') {
			$whereclause = '';
		}
		$result = &$opnConfig['database']->Execute ('SELECT COUNT(qid) AS help FROM ' . $opnTables['quotes'] . ' ' . $whereclause);
		if ( ($result !== false) && (isset ($result->fields['help']) ) ) {
			$numrecords = $result->fields['help'];
		} else {
			$numrecords = 0;
		}
		$entriesperpage = $opnConfig['opn_gfx_defaultlistrows'];
		if ($numrecords>0) {
			$boxtxt .= '<span class="extratextbold">';
			$boxtxt .= _QOT_ADMIN_MODIFY;
			$boxtxt .= '</span><br /><br /><br />';
			$table = & new opn_TableClass ('default');
			$table->AddCols (array ('50%', '50%') );
			$table->AddOpenRow ();
			$form = & new opn_FormularClass ();
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QOT_ADMIN_30_', 'qotd');
			$form->Init ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php');
			$form->AddLabel ('keyword', _QOT_ADMIN_SEARCH . '  ');
			$form->AddTextfield ('keyword', 31, 128, $keyword);
			$form->AddHidden ('offset', 0);
			$form->AddHidden ('op', 'QotdDisplay');
			$form->AddSubmit ('submit', _QOT_ADMIN_SEARCHBUTTON);
			$form->AddFormEnd ();
			$hlp = '';
			$form->GetFormular ($hlp);
			$table->AddDataCol ($hlp);
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QOT_ADMIN_40_', 'qotd');
			$form->Init ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php');
			$form->AddHidden ('offset', 0);
			$form->AddHidden ('op', 'QotdDisplay');
			$form->AddSubmit ('submit', _QOT_ADMIN_SEARCH_NEW);
			$form->AddFormEnd ();
			$hlp = '';
			$form->GetFormular ($hlp);
			$table->AddDataCol ($hlp);
			$table->AddCloseRow ();
			$table->GetTable ($boxtxt);
			$boxtxt .= '<br />';
			$table = & new opn_TableClass ('alternator');
			$table->AddHeaderRow (array (_QOT_ADMIN_QUOTE, _QOT_ADMIN_AUTHOR, _QOT_ADMIN_USELANG, _QOT_ADMIN_USEGROUP, _QOT_ADMIN_SEARCH_ACTION) );
			$start = $offset;
			$result = &$opnConfig['database']->SelectLimit ('SELECT qid, quote, author, lang, usergroup FROM ' . $opnTables['quotes'] . " $whereclause ORDER BY qid", $entriesperpage, $start);
			$nrows = $result->RecordCount ();
			while (! $result->EOF) {
				$qqid = $result->fields['qid'];
				$qquote = $result->fields['quote'];
				$qauthor = $result->fields['author'];
				$lang = $result->fields['lang'];
				if ($lang == '0') {
					$lang = _QOT_ADMIN_ALL;
				}
				$usergroup = $result->fields['usergroup'];
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
												'op' => 'QotdEdit',
												'qid' => $qqid,
												'offset' => $offset) ) . ' ';
				}
				if ($opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
												'op' => 'QotdDelete',
												'qid' => $qqid,
												'offset' => $offset) );
				}
				$table->AddDataRow (array (substr ($qquote, 0, 50), substr ($qauthor, 0, 50), substr ($lang, 0, 50), substr ($usergroup, 0, 50), $hlp) );
				$result->MoveNext ();
			}
			$table->GetTable ($boxtxt);
			$boxtxt .= '<br />';
			if ($nrows>0) {
				include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
				$boxtxt .= build_pagebar (array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
								'op' => 'QotdDisplay',
								'keyword' => $keyword),
								$numrecords,
								$entriesperpage,
								$offset);
			}
		} else {
			$boxtxt .= _QOT_ADMIN_SEARCH_BO_FOUND;
		}
	}
	return $boxtxt;

}

function QotdDelete () {

	global $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_DELETE, _PERM_ADMIN) );
	$boxtxt = '';
	$boxtxt .= '<span class="extratextbold">';
	$boxtxt .= _QOT_ADMIN_DELETE_QUOTE;
	$boxtxt .= '</span><br /><br /><br />';
	$boxtxt .= '<div class="centertag">';
	$boxtxt .= '<span class="alerttext">';
	$boxtxt .= '<span class="normaltextbold">' . _QOT_ADMIN_WARNING_DELETE . '</span><br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
									'op' => 'QotdDeleteOk',
									'qid' => $qid,
									'offset' => $offset) ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php',
															'op' => 'QotdDisplay',
															'offset' => $offset) ) . '">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}

function QotdDeleteOk () {

	global $opnTables, $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_DELETE, _PERM_ADMIN) );
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['quotes'] . ' WHERE qid=' . $qid);

}

function QotdEdit () {

	global $opnTables, $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_EDIT, _PERM_ADMIN) );
	$boxtxt = '';
	$result = &$opnConfig['database']->SelectLimit ('SELECT quote, author, options FROM ' . $opnTables['quotes'] . " WHERE qid = $qid", 1);
	$quote = $result->fields['quote'];
	$author = $result->fields['author'];
	$myoptions = unserialize ($result->fields['options']);
	$boxtxt .= '<span class="extratextbold">';
	$boxtxt .= _QOT_ADMIN_EDIT_QUOTE;
	$boxtxt .= '</span><br /><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_QOT_ADMIN_50_', 'qotd');
	$form->Init ($opnConfig['opn_url'] . '/modules/qotd/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('qquote', _QOT_ADMIN_QUOTETEXT . ' ');
	$form->AddTextarea ('qquote', 0, 0, '', $quote);
	$form->AddChangeRow ();
	$form->AddLabel ('qauthor', _QOT_ADMIN_AUTHOR . '  ');
	$form->AddTextfield ('qauthor', 31, 128, $author);
	InputPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'QotdSave');
	$form->AddHidden ('offset', $offset);
	$form->AddHidden ('qqid', $qid);
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _QOT_ADMIN_SAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	return $boxtxt;

}

function QotdSave () {

	global $opnTables, $opnConfig;

	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_EDIT, _PERM_ADMIN) );
	$qqid = 0;
	get_var ('qqid', $qqid, 'form', _OOBJ_DTYPE_INT);
	$qquote = '';
	get_var ('qquote', $qquote, 'form', _OOBJ_DTYPE_CHECK);
	$qauthor = '';
	get_var ('qauthor', $qauthor, 'form', _OOBJ_DTYPE_CLEAN);
	$myoptions = array ();
	get_var ('_quotd_op_', $myoptions,'form','',true);
	if (!isset ($myoptions['_quotd_op_use_lang']) ) {
		$quotd_lang = '0';
	} else {
		$quotd_lang = $myoptions['_quotd_op_use_lang'];
	}
	if (!isset ($myoptions['_quotd_op_use_group']) ) {
		$quotd_group = 0;
	} else {
		$quotd_group = $myoptions['_quotd_op_use_group'];
	}
	$qquote = $opnConfig['opnSQL']->qstr ($qquote, 'quote');
	$qauthor = $opnConfig['opnSQL']->qstr ($qauthor);
	$options = $opnConfig['opnSQL']->qstr (serialize ($myoptions), 'options');
	$_quotd_lang = $opnConfig['opnSQL']->qstr ($quotd_lang);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['quotes'] . " SET quote=$qquote, author=$qauthor, options=$options, lang=$_quotd_lang, usergroup=$quotd_group WHERE qid=$qqid");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quotes'], 'qid=' . $qqid);

}

function import () {

	global $opnConfig, $opnTables;

	$boxtxt = '';
	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_ADMIN, _QOTD_PERM_IMPORT) );
	include_once (_OPN_ROOT_PATH . 'pro/im_export_manager/class/class.data_port.php');
	$pro_export = & new opn_data_port ();
	$pro_export->set_use_format ('csv');
	$t = array ('quotes');
	$pro_export->read ($t);
	$help = $pro_export->getdatas ('quotes');
	$max = count ($help);
	for ($x = 0; $x< $max; $x++) {
		// $qid = $help[$x]['qid'];
		$quote = $opnConfig['opnSQL']->qstr ($help[$x]['quote'], 'quote');
		$author = $opnConfig['opnSQL']->qstr ($help[$x]['author']);
		$options = $opnConfig['opnSQL']->qstr ($help[$x]['options'], 'options');
		$lang = $opnConfig['opnSQL']->qstr ($help[$x]['lang']);
		$usergroup = $help[$x]['usergroup'];
		$qid = $opnConfig['opnSQL']->get_new_number ('quotes', 'qid');
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['quotes'] . " values ($qid,$quote, $author, $options, $lang, $usergroup)");
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['quotes'], array ($quote,
										$options),
										'qid=' . $qid);
	}
	return $boxtxt;

}

function export () {

	global $opnConfig;

	$opnConfig['permission']->HasRights ('modules/qotd', array (_PERM_ADMIN, _QOTD_PERM_EXPORT) );
	$boxtxt = '';
	include_once (_OPN_ROOT_PATH . 'pro/im_export_manager/class/class.data_port.php');
	$pro_export = & new opn_data_port ();
	$pro_export->set_use_format ('csv');
	$pro_export->setpointer ('quotes', 'qid');
	$pro_export->setfeld ('quotes', 'qid');
	$pro_export->setfeld ('quotes', 'quote');
	$pro_export->setfeld ('quotes', 'author');
	$pro_export->setfeld ('quotes', 'options');
	$pro_export->setfeld ('quotes', 'lang');
	$pro_export->setfeld ('quotes', 'usergroup');
	$pro_export->write ();
	$boxtxt .= _QOT_ADMIN_EXPORT . '&nbsp;' . _QOT_ADMIN_OK;
	return $boxtxt;

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'import':
		if ($opnConfig['installedPlugins']->isplugininstalled ('pro/im_export_manager') ) {
			$boxtxt .= import ();
		}
		break;
	case 'export':
		if ($opnConfig['installedPlugins']->isplugininstalled ('pro/im_export_manager') ) {
			$boxtxt .= export ();
		}
		break;
	case 'submissions':
		$boxtxt .= submissions ();
		break;
	case 'EditSubmission':
		$boxtxt .= EditSubmission ();
		break;
	case 'SaveSubmission':
		SaveSubmission ();
		$boxtxt .= QotdAdmin ();
		break;
	case 'QotdAdd':
		QotdAdd ();
		$boxtxt .= QotdAdmin ();
		break;
	case 'QotdSave':
		QotdSave ();
		$boxtxt .= QotdDisplay ();
		break;
	case 'QotdDeleteOk':
		QotdDeleteOk ();
		$boxtxt .= QotdDisplay ();
		break;
	case 'QotdDisplay':
		$boxtxt .= QotdDisplay ();
		break;
	case 'QotdDelete':
		$boxtxt .= QotdDelete ();
		break;
	case 'QotdEdit':
		$boxtxt .= QotdEdit ();
		break;
	default:
		$boxtxt .= QotdAdmin ();
		break;
}
qotdConfigHeader ();
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_QOT_ADMIN_60_';
$_display_dat['module'] = 'modules/qotd';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_QOT_ADMIN_CONF, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>