<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/reviews/plugin/tracking/language/');

function reviews_get_title ($id) {

	global $opnConfig, $opnTables;

	$title = '';
	$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['reviews'] . ' WHERE id=' . $id);
	if ($result !== false) {
		while (! $result->EOF) {
			$title = $result->fields['title'];
			$result->MoveNext ();
		}
		$result->Close ();
	}
	return $title;

}

function reviews_get_tracking ($url) {
	if ($url == '/modules/reviews/index.php?op=preview_review') {
		return _REV_TRACKING_PREVIEW;
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=write_review')>0) {
		return _REV_TRACKING_WRITE;
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=reviews')>0) {
		$letter = str_replace ('/modules/reviews/index.php?op=reviews', '', $url);
		$l = explode ('&', $letter);
		$letter = str_replace ('letter=', '', $l[1]);
		return _REV_TRACKING_DISPLAYREVIEWLETTER . ' "' . $letter . '"';
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=showcontent&id=')>0) {
		$id = str_replace ('/modules/reviews/index.php?op=showcontent&id=', '', $url);
		$title = reviews_get_title ($id);
		return _REV_TRACKING_DISPLAYREVIEW . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=postcomment')>0) {
		$id = str_replace ('/modules/reviews/index.php?op=postcomment', '', $url);
		$l = explode ('&', $id);
		$title = str_replace ('title=', '', $l[2]);
		return _REV_TRACKING_COMMENTREVIEW . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=SendReview&id=')>0) {
		$id = str_replace ('/modules/reviews/index.php?op=SendReview&id=', '', $url);
		$title = reviews_get_title ($id);
		return _REV_TRACKING_SENDREVIEW . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=PrintReview&id=')>0) {
		$id = str_replace ('/modules/reviews/index.php?op=PrintReview&id=', '', $url);
		$title = reviews_get_title ($id);
		return _REV_TRACKING_PRINTREVIEW . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=mod_review&id=')>0) {
		$id = str_replace ('/modules/reviews/index.php?op=mod_review&id=', '', $url);
		$title = reviews_get_title ($id);
		return _REV_TRACKING_MODREVIEW . ' "' . $title . '"';
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=del_review&id_del=')>0) {
		$id = str_replace ('/modules/reviews/index.php?op=del_review&id_del=', '', $url);
		return _REV_TRACKING_DELREVIEW . ' "' . $id . '"';
	}
	if (substr_count ($url, 'modules/reviews/index.php?op=del_comment')>0) {
		$cid = str_replace ('/modules/reviews/index.php?op=del_comment', '', $url);
		$c = explode ('&', $cid);
		$cid = str_replace ('cid=', '', $c[0]);
		$id = str_replace ('id=', '', $c[1]);
		$title = reviews_get_title ($id);
		return sprintf (_REV_TRACKING_DELCOMMENT, $cid, $title);
	}
	if (substr_count ($url, 'modules/reviews/admin/')>0) {
		return _REV_TRACKING_ADMIN;
	}
	if (substr_count ($url, 'modules/reviews/') ) {
		return _REV_TRACKING_INDEX;
	}
	return '';

}

?>