<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function Shoutbox_get_host ($ip) {

	$server = '';
	get_var ('SERVER_ADDR', $server, 'server');
	if ($server == '127.0.0.1') {
		$remohostname = $ip;
	} else {
		$remohostname = gethostbyaddr ($ip);
	}
	if ($remohostname == $ip) {
		$remohostname = '???';
	}
	return ' (IP: ' . $ip . ') / Host: ' . $remohostname;

}
// function

function DisplayShout () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/smilies') ) {
		include_once (_OPN_ROOT_PATH . 'system/smilies/smilies.php');
		$smilieinstalled = true;
	} else {
		$smilieinstalled = false;
	}
	$titletext = _SHOUTBOX_LIST;
	$text = '';
	$table = & new opn_TableClass ('alternator');
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['shoutbox'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$info = &$opnConfig['database']->SelectLimit ('SELECT id, username, shouttext, wdate,host_name FROM ' . $opnTables['shoutbox'] . ' ORDER BY id desc', $maxperpage, $offset);
	while (! $info->EOF) {
		$id = $info->fields['id'];
		$username = $info->fields['username'];
		$comment = $info->fields['shouttext'];
		$date = $info->fields['wdate'];
		$ip = $info->fields['host_name'];
		$opnConfig['opndate']->sqlToopnData ($date);
		$format = '';
		if ($opnConfig['shoutbox_displaydate']) {
			$format .= _DATE_DATESTRING4;
		}
		if ($opnConfig['shoutbox_displaytime']) {
			$format .= (strlen ($format)>0?' ' : '') . _DATE_DATESTRING8;
		}
		$date = '';
		$opnConfig['opndate']->formatTimestamp ($date, $format);
		if ($smilieinstalled) {
			$comment = smilies_smile ($comment);
		}
		if ($username == "anonymous") {
			$hlp = $username;
		} else {
			$hlp = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
										'op' => 'userinfo',
										'uname' => $username) ) . '">' . $username . '</a>';
		}
		$hlp .= ': ' . $comment . '<br />';
		$hlp .= $date;
		$table->AddOpenRow ();
		$table->AddDataCol ($hlp);
		if ($opnConfig['permission']->HasRight ('modules/shoutbox', _PERM_ADMIN, true) ) {
			if ($ip != '') {
				$ip = Shoutbox_get_host ($ip);
			}
			$table->AddDataCol ($ip);
			$hlp = $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/shoutbox/index.php',
										'op' => 'delshout',
										'id' => $id) );
			$table->AddDataCol ($hlp);
		}
		$table->AddCloseRow ();
		$info->MoveNext ();
	}
	$table->GetTable ($text);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/shoutbox/index.php'),
					$reccount,
					$maxperpage,
					$offset);
	$text .= '<br /><br />' . $pagebar;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_SHOUTBOX_50_';
	$_display_dat['module'] = 'modules/shoutbox';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($titletext, $text);

}

function DelShout () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRight ('modules/shoutbox', _PERM_ADMIN);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['shoutbox'] . ' WHERE id=' . $id);
		$opnConfig['opnOutput']->Redirect ($opnConfig['opn_url'] . '/modules/shoutbox/index.php');
	} else {
		$result = $opnConfig['database']->Execute ('SELECT shouttext FROM ' . $opnTables['shoutbox'] . ' WHERE id=' . $id);
		$shout = $result->fields['shouttext'];
		$result->Close ();
		unset ($result);
		$titletext = _SHOUTBOX_LIST;
		$text = '<div class="bigtextbold" align="center">';
		$text .= '<span class="alerttextcolor">' . sprintf (_SHOUTBOX_DELETE1, $shout) . '</span><br />';
		$text .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/shoutbox/index.php',
										'op' => 'delshout',
										'id' => $id,
										'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/shoutbox/index.php' . '">' . _NO . '</a><br /><br /></div>';
		$_display_dat = array ();
		$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_SHOUTBOX_60_';
		$_display_dat['module'] = 'modules/shoutbox';
		$opnConfig['opnOutput']->SetDisplay ($_display_dat);
		unset ($_display_dat);
		$opnConfig['opnOutput']->DisplayContent ($titletext, $text);
	}

}

?>