<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . 'include/opn_system_function_text.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/talking_free/language/');

function add_form ($chapter, $lang) {

	global $opnConfig;

	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TALKING_FREE_10_', 'talking_free');
	$form->Init ($opnConfig['opn_url'] . '/modules/talking_free/index.php', 'post', 'index');
	$form->AddTable ();
	$form->AddCols (array ('30%', '70%') );
	$form->AddOpenRow ();
	$form->AddLabel ('send_text', 'Verffentlichen');
	$form->AddTextarea ('send_text');
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('op', 'add');
	$form->AddHidden ('chapter', $chapter);
	$form->AddHidden ('lang', $lang);
	$form->SetEndCol ();
	$form->AddSubmit ('sbumit', _TAFREE_SEND);
	$form->AddChangeRow ();
	$form->AddText ('');
	$hlp = '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/talking_free/index.php',
								'chapter' => $chapter,
								'lang' => $lang) ) . '">[' . _TAFREE_REFRESH . ']</a><br /><br />';
	if ($opnConfig['permission']->HasRight ('modules/talking_free', _PERM_ADMIN, true) ) {
		$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/talking_free/index.php',
									'chapter' => $chapter,
									'lang' => $lang,
									'op' => 'delete_all') ) . '">[' . _TAFREE_DELETE_ALL_MESSAGES . ']</a><br /><br />';
		$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/talking_free/index.php',
									'chapter' => $chapter,
									'lang' => $lang,
									'op' => 'delete_last') ) . '">[' . _TAFREE_DELETE_LAST_MESSAGE . ']</a><br /><br />';
	}
	$form->AddText ($hlp);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$content = '';
	$form->GetFormular ($content);
	return $content;

}

function overview_talking_free ($chapter, $lang) {

	global $opnConfig, $opnTables;

	$_chapter = $opnConfig['opnSQL']->qstr ($chapter);
	$_lang = $opnConfig['opnSQL']->qstr ($lang);
	$result = &$opnConfig['database']->Execute ('SELECT COUNT(wtime) AS counter FROM ' . $opnTables['talking_free'] . ' WHERE chapter=' . $_chapter . ' AND lang=' . $_lang);
	if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
		$nmy_talking_free = $result->fields['counter'];
	} else {
		$nmy_talking_free = 0;
	}
	if ($nmy_talking_free == 0) {
		$content = '<div class="centertag">' . _TAFREE_THERE_ISNT_FREE_SPEAKING_MESSAGE . '</div>';
	} else {
		$result = &$opnConfig['database']->Execute ('SELECT wtime, text, ip, uname FROM ' . $opnTables['talking_free'] . ' WHERE chapter=' . $_chapter . ' AND lang=' . $_lang . ' ORDER BY wtime DESC');
		$table = & new opn_TableClass ('alternator');
		$a = 0;
		$thelasttime = 0;
		$dtime = '';
		$time = '';
		while (! $result->EOF) {
			$my_talking_free = $result->GetRowAssoc ('0');
			$opnConfig['opndate']->sqlToopnData ($thelasttime);
			$d1 = '';
			$opnConfig['opndate']->getDay ($d1);
			$opnConfig['opndate']->sqlToopnData ($my_talking_free['wtime']);
			$d2 = '';
			$opnConfig['opndate']->getDay ($d2);
			$table->AddOpenRow ();
			$hlp = '';
			if ( ($a == 0) OR ($d2 != $d1) ) {
				$opnConfig['opndate']->formatTimestamp ($dtime, _DATE_DATESTRING2);
				$hlp .= '* <span class="normaltextbold">' . ucfirst ($dtime) . '</span><br />';
				$thelasttime = $my_talking_free['wtime'];
			}
			$a++;
			$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING9);
			$hlp .= '<span class="normaltextbold">' . $time . '</span>';
			$hlp .= '<br />';
			$hlp .= nl2br ($my_talking_free['text']);
			$table->AddDataCol ($hlp);
			$hlp = '';
			if ($opnConfig['talking_free_display_user'] == 1) {
				$hlp .= $my_talking_free['uname'];
			}
			if ($opnConfig['permission']->HasRight ('modules/talking_free', _PERM_ADMIN, true) ) {
				$remohostname = '';
				if ($my_talking_free['ip'] != '') {
					$remohostname = gethostbyaddr ($my_talking_free['ip']);
					if ($remohostname == $my_talking_free['ip']) {
						$remohostname = '';
					}
				}
				$hlp .= '<br />';
				$hlp .= $my_talking_free['ip'] . ' ' . $remohostname;
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/talking_free/index.php',
																				'chapter' => $chapter,
																				'lang' => $lang,
																				'op' => 'delete',
																				'number' => $my_talking_free['wtime']) );
			}
			$table->AddDataCol ($hlp);
			$table->AddCloseRow ();
			$thelasttime = $my_talking_free['wtime'];
			$result->MoveNext ();
		}
		$content = '';
		$table->GetTable ($content);
		$content .= '<hr size="1" />';
	}
	return $content;

}

?>