<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/team_partner/admin/language/');
$opnConfig['module']->InitModule ('modules/team_partner', true);
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function PartnerConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_TPAR_CONF);
	$menu->InsertEntry (_TPAR_MAIN, $opnConfig['opn_url'] . '/modules/team_partner/admin/index.php');
	$menu->InsertEntry (_TPAR_SETTINGS, $opnConfig['opn_url'] . '/modules/team_partner/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function PartnerAdmin () {

	global $opnTables, $opnConfig;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sql = 'SELECT COUNT(num) AS counter FROM ' . $opnTables['team_partner'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$table = & new opn_TableClass ('alternator');
	$table->AddHeaderRow (array (_TPAR_POS, _TPAR_HITS, _TPAR_URL, _TPAR_IMAGE, _TPAR_TEXT, _TPAR_UID, '&nbsp;') );
	$result = &$opnConfig['database']->SelectLimit ('SELECT num, hits, url, image, text, uid, group_pos FROM ' . $opnTables['team_partner'] . ' ORDER BY group_pos', $maxperpage, $offset);
	if ($result !== false) {
		while (! $result->EOF) {
			$num = $result->fields['num'];
			$hits = $result->fields['hits'];
			$url = $result->fields['url'];
			$image = $result->fields['image'];
			$text = $result->fields['text'];
			$uid = $result->fields['uid'];
			$group_pos = $result->fields['group_pos'];
			$ui = $opnConfig['permission']->GetUser ($uid, 'uid', '');
			$hlp = '';
			if ($opnConfig['permission']->HasRights ('modules/team_partner', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php',
											'op' => 'PartnerEdit',
											'num' => $num) );
				$hlp .= '&nbsp;';
				$hlp .= $opnConfig['defimages']->get_up_link (array ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php',
											'op' => 'PartnerOrder',
											'id' => $num,
											'new_pos' => ($group_pos-1.5) ) );
				$hlp .= '&nbsp;';
				$hlp .= $opnConfig['defimages']->get_down_link (array ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php',
											'op' => 'PartnerOrder',
											'id' => $num,
											'new_pos' => ($group_pos+1.5) ) );
				$hlp .= '&nbsp;';
			}
			if ($opnConfig['permission']->HasRights ('modules/team_partner', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
				$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php',
											'op' => 'PartnerDel',
											'num' => $num,
											'ok' => '0') );
			}
			if ($image != '') {
				$image = '<img src="'.$image.'" class="imgtag" title="'.$image.'" alt="'.$image.'" />';
			}
			$table->AddDataRow (array ($group_pos, $hits, $url, $image, $text, $ui['uname'], $hlp) );
			$result->MoveNext ();
		}
	}
	$boxtxt = '';
	$table->GetTable ($boxtxt);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php',
					'op' => 'PartnerAdmin'),
					$reccount,
					$maxperpage,
					$offset);
	$boxtxt .= '<br /><br />' . $pagebar . '<br /><br />';
	if ($opnConfig['permission']->HasRights ('modules/team_partner', array (_PERM_NEW, _PERM_ADMIN), true) ) {
		$boxtxt .= '<br />';
		$boxtxt .= '<span class="normaltextbold">' . _TPAR_NEW_PARTNER . '</span><br /><br />';
		$form = & new opn_FormularClass ('listalternator');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TEAM_PARTNER_10_', 'team_partner');
		$form->Init ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php');
		$result = &$opnConfig['database']->Execute ('SELECT uid, uname FROM ' . $opnTables['users'] . ' ORDER BY uname');
		$options = array ();
		while (! $result->EOF) {
			$options[$result->fields['uid']] = $result->fields['uname'];
			$result->MoveNext ();
		}
		$form->AddTable ();
		$form->AddCols (array ('10%', '90%') );
		$form->AddOpenRow ();
		$form->AddLabel ('uid', _TPAR_UID);
		$form->AddSelect ('uid', $options);
		$form->AddChangeRow ();
		$form->AddLabel ('image', _TPAR_IMAGEURL);
		$form->AddTextfield ('image', 50, 250);
		$form->AddChangeRow ();
		$form->AddLabel ('url', _TPAR_CLICKURL);
		$form->AddTextfield ('url', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('vorname', _TPAR_FIRSTNAME);
		$form->AddTextfield ('vorname', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('nachname', _TPAR_LASTNAME);
		$form->AddTextfield ('nachname', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('funktion', _TPAR_FUNCTION);
		$form->AddTextfield ('funktion', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('email', _TPAR_EMAIL);
		$form->AddTextfield ('email', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('icq', _TPAR_ICQ);
		$form->AddTextfield ('icq', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('aim', _TPAR_AIM);
		$form->AddTextfield ('aim', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('msmn', _TPAR_MSMN);
		$form->AddTextfield ('msmn', 50, 200);
		$form->AddChangeRow ();
		$form->AddLabel ('text', _TPAR_TEXT);
		$form->AddTextarea ('text');
		$form->AddChangeRow ();
		$form->AddHidden ('op', 'PartnerAdd');
		$form->AddSubmit ('submit', _TPAR_ADD_PARTNER);
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	return $boxtxt;

}

function PartnerEdit () {

	global $opnTables, $opnConfig;

	$num = 0;
	get_var ('num', $num, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/team_partner', array (_PERM_EDIT, _PERM_ADMIN) );
	$result = &$opnConfig['database']->Execute ('SELECT num, hits, url, image, vorname, nachname, funktion, email, icq, aim, msmn, text, uid, group_pos FROM ' . $opnTables['team_partner'] . ' WHERE num=' . $num);
	$num = $result->fields['num'];
	$hits = $result->fields['hits'];
	$url = $result->fields['url'];
	$image = $result->fields['image'];
	$vorname = $result->fields['vorname'];
	$nachname = $result->fields['nachname'];
	$funktion = $result->fields['funktion'];
	$email = $result->fields['email'];
	$icq = $result->fields['icq'];
	$aim = $result->fields['aim'];
	$msmn = $result->fields['msmn'];
	$text = $result->fields['text'];
	$uid = $result->fields['uid'];
	$position = $result->fields['group_pos'];
	$boxtxt = '<div class="bigtextbold" align="center">' . _TPAR_EDIT_PARTNER . '<br /><br />';
	if ( ($image != '') && ($image != 'http://') ) {
		$boxtxt .= '<img src="' . $image . '" class="imgtag" alt="" />';
	}
	$boxtxt .= '<br /><br /></div><div class="normaltext">';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TEAM_PARTNER_20_', 'partner');
	$form->Init ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php');
	$result = &$opnConfig['database']->Execute ('SELECT uid, uname FROM ' . $opnTables['users']);
	$options = array ();
	while (! $result->EOF) {
		$options[$result->fields['uid']] = $result->fields['uname'];
		$result->MoveNext ();
	}
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('uid', _TPAR_UID);
	$form->AddSelect ('uid', $options, $uid);
	$form->AddChangeRow ();
	$form->AddLabel ('image', _TPAR_IMAGE);
	$form->AddTextfield ('image', 50, 250, $image);
	$form->AddChangeRow ();
	$form->AddLabel ('url', _TPAR_URL);
	$form->AddTextfield ('url', 50, 200, $url);
	$form->AddChangeRow ();
	$form->AddLabel ('vorname', _TPAR_FIRSTNAME);
	$form->AddTextfield ('vorname', 50, 200, $vorname);
	$form->AddChangeRow ();
	$form->AddLabel ('nachname', _TPAR_LASTNAME);
	$form->AddTextfield ('nachname', 50, 200, $nachname);
	$form->AddChangeRow ();
	$form->AddLabel ('funktion', _TPAR_FUNCTION);
	$form->AddTextfield ('funktion', 50, 200, $funktion);
	$form->AddChangeRow ();
	$form->AddLabel ('email', _TPAR_EMAIL);
	$form->AddTextfield ('email', 50, 200, $email);
	$form->AddChangeRow ();
	$form->AddLabel ('icq', _TPAR_ICQ);
	$form->AddTextfield ('icq', 50, 200, $icq);
	$form->AddChangeRow ();
	$form->AddLabel ('aim', _TPAR_AIM);
	$form->AddTextfield ('aim', 50, 200, $aim);
	$form->AddChangeRow ();
	$form->AddLabel ('msmn', _TPAR_MSMN);
	$form->AddTextfield ('msmn', 50, 200, $msmn);
	$form->AddChangeRow ();
	$form->AddLabel ('text', _TPAR_TEXT);
	$form->AddTextarea ('text', 0, 0, '', $text);
	$form->AddChangeRow ();
	$form->AddLabel ('hits', _TPAR_HITS);
	$form->AddTextfield ('hits', 3, 10, $hits);
	$form->AddChangeRow ();
	$form->AddLabel ('position', _TPAR_POSITION);
	$form->AddTextfield ('position', 0, 0, $position);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('num', $num);
	$form->AddHidden ('op', 'PartnerChange');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _TPAR_EDIT_PARTNER);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</span>';
	return $boxtxt;

}

function PartnerChange () {

	global $opnTables, $opnConfig;

	$num = 0;
	get_var ('num', $num, 'form', _OOBJ_DTYPE_INT);
	$hits = 0;
	get_var ('hits', $hits, 'form', _OOBJ_DTYPE_INT);
	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$image = '';
	get_var ('image', $image, 'form', _OOBJ_DTYPE_URL);
	$vorname = '';
	get_var ('vorname', $vorname, 'form', _OOBJ_DTYPE_CLEAN);
	$nachname = '';
	get_var ('nachname', $nachname, 'form', _OOBJ_DTYPE_CLEAN);
	$funktion = '';
	get_var ('funktion', $funktion, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$icq = '';
	get_var ('icq', $icq, 'form', _OOBJ_DTYPE_CLEAN);
	$aim = '';
	get_var ('aim', $aim, 'form', _OOBJ_DTYPE_CLEAN);
	$msmn = '';
	get_var ('msmn', $msmn, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$position = 0;
	get_var ('position', $position, 'form', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('modules/team_partner', array (_PERM_EDIT, _PERM_ADMIN) );
	$result = $opnConfig['database']->Execute ('SELECT group_pos FROM ' . $opnTables['team_partner'] . ' WHERE num=' . $num);
	$pos = $result->fields['group_pos'];
	$result->Close ();
	$text = $opnConfig['opnSQL']->qstr ($text, 'text');
	$email = $opnConfig['opnSQL']->qstr ($email);
	$_url = $opnConfig['opnSQL']->qstr ($url);
	$_image = $opnConfig['opnSQL']->qstr ($image);
	$_vorname = $opnConfig['opnSQL']->qstr ($vorname);
	$_nachname = $opnConfig['opnSQL']->qstr ($nachname);
	$_funktion = $opnConfig['opnSQL']->qstr ($funktion);
	$_uid = $opnConfig['opnSQL']->qstr ($uid);
	$_msmn = $opnConfig['opnSQL']->qstr ($msmn);
	$_icq = $opnConfig['opnSQL']->qstr ($icq);
	$_aim = $opnConfig['opnSQL']->qstr ($aim);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['team_partner'] . " SET hits=$hits, url=$_url, image=$_image, vorname=$_vorname, nachname=$_nachname, funktion=$_funktion, email=$email, icq=$_icq, aim=$_aim, msmn=$_msmn, text=$text, uid=$_uid WHERE num=$num");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['team_partner'], 'num=' . $num);
	if ($pos != $position) {
		set_var ('id', $num, 'url');
		set_var ('new_pos', $position, 'url');
		PartnerOrder ();
		unset_var ('id', 'url');
		unset_var ('new_pos', 'url');
	}
	return PartnerAdmin () . '<br />';

}

function PartnerAdd () {

	global $opnTables, $opnConfig;

	$url = '';
	get_var ('url', $url, 'form', _OOBJ_DTYPE_URL);
	$image = '';
	get_var ('image', $image, 'form', _OOBJ_DTYPE_CLEAN);
	$vorname = '';
	get_var ('vorname', $vorname, 'form', _OOBJ_DTYPE_CLEAN);
	$nachname = '';
	get_var ('nachname', $nachname, 'form', _OOBJ_DTYPE_CLEAN);
	$funktion = '';
	get_var ('funktion', $funktion, 'form', _OOBJ_DTYPE_CLEAN);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$icq = '';
	get_var ('icq', $icq, 'form', _OOBJ_DTYPE_CLEAN);
	$aim = '';
	get_var ('aim', $aim, 'form', _OOBJ_DTYPE_CLEAN);
	$msmn = '';
	get_var ('msmn', $msmn, 'form', _OOBJ_DTYPE_CLEAN);
	$text = '';
	get_var ('text', $text, 'form', _OOBJ_DTYPE_CHECK);
	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$opnConfig['permission']->HasRights ('modules/team_partner', array (_PERM_NEW, _PERM_ADMIN) );
	$num = $opnConfig['opnSQL']->get_new_number ('team_partner', 'num');
	$text = $opnConfig['opnSQL']->qstr ($text, 'text');
	$_email = $opnConfig['opnSQL']->qstr ($email);
	$_url = $opnConfig['opnSQL']->qstr ($url);
	$_icq = $opnConfig['opnSQL']->qstr ($icq);
	$_msmn = $opnConfig['opnSQL']->qstr ($msmn);
	$_funktion = $opnConfig['opnSQL']->qstr ($funktion);
	$_aim = $opnConfig['opnSQL']->qstr ($aim);
	$_uid = $opnConfig['opnSQL']->qstr ($uid);
	$_nachname = $opnConfig['opnSQL']->qstr ($nachname);
	$_image = $opnConfig['opnSQL']->qstr ($image);
	$_vorname = $opnConfig['opnSQL']->qstr ($vorname);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['team_partner'] . " (num, hits, url, image, vorname, nachname, funktion, email, icq, aim, msmn, text, uid, group_pos) VALUES ($num, 0, $_url, $_image, $_vorname, $_nachname, $_funktion, $_email, $_icq, $_aim, $_msmn, $text, $_uid, $num)");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
		return $boxtxt;
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['team_partner'], 'num=' . $num);
	return PartnerAdmin () . '<br />';

}

function PartnerDel () {

	global $opnTables, $opnConfig;

	$num = 0;
	get_var ('num', $num, 'url', _OOBJ_DTYPE_INT);
	$ok = '';
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_CLEAN);
	$opnConfig['permission']->HasRights ('modules/team_partner', array (_PERM_DELETE, _PERM_ADMIN) );
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['team_partner'] . ' WHERE num=' . $num);
		return PartnerAdmin () . '<br />';
	}
	$boxtxt = '<div class="bigtextbold" align="center"><br />';
	$boxtxt .= '<span class="alerttextcolor">';
	$boxtxt .= _TPAR_WARNING_DELETE . '<br /><br /></span>';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/team_partner/admin/index.php',
									'op' => 'PartnerDel',
									'num' => $num,
									'ok' => '1') ) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/team_partner/admin/index.php">' . _NO . '</a><br /><br /></div>';
	return $boxtxt;

}

function PartnerOrder () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$new_pos = 0;
	get_var ('new_pos', $new_pos, 'url', _OOBJ_DTYPE_CLEAN);
	if ($new_pos) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['team_partner'] . " SET group_pos=$new_pos WHERE num=$id");
	}
	$result = &$opnConfig['database']->Execute ('SELECT num FROM ' . $opnTables['team_partner'] . ' ORDER BY group_pos');
	$c = 0;
	while (! $result->EOF) {
		$row = $result->GetRowAssoc ('0');
		$c++;
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['team_partner'] . ' SET group_pos=' . $c . ' WHERE num=' . $row['num']);
		$result->MoveNext ();
	}

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'PartnerChange':
		$boxtxt = PartnerChange ();
		break;
	case 'PartnerAdd':
		$boxtxt = PartnerAdd ();
		break;
	case 'PartnerDel':
		$boxtxt = PartnerDel ();
		break;
	case 'PartnerEdit':
		$boxtxt = PartnerEdit ();
		break;
	case 'PartnerOrder':
		PartnerOrder ();
		$boxtxt = PartnerAdmin ();
		$boxtxt .= '<br />';
		break;
	Default:
		$boxtxt = PartnerAdmin ();
		$boxtxt .= '<br />';
		break;
}
PartnerConfigHeader ();
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TEAM_PARTNER_30_';
$_display_dat['module'] = 'modules/team_partner';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_TPAR_ADMIN, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();

?>