<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('modules/top_sites', true);
getLanguageDef (_OPN_ROOT_PATH . 'modules/top_sites/admin/language/');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');

function top_sites_ConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_TOPSADMIN_CONFIG);
	$menu->InsertEntry (_TOPSADMIN_MAIN, $opnConfig['opn_url'] . '/modules/top_sites/admin/index.php');
	$menu->InsertEntry (_TOPSADMIN_RESETRANK, array ($opnConfig['opn_url'] . '/modules/top_sites/admin/index.php',
							'op' => 'reset') );
	$menu->InsertEntry (_TOPSADMIN_SETTINGS2, $opnConfig['opn_url'] . '/modules/top_sites/admin/settings.php');
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}

function main () {

	global $opnConfig, $opnTables;

	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$boxtitle = sprintf (_TOPSADMIN_ADMINISTRATION, $opnConfig['topsites_max']);
	$sql = 'SELECT COUNT(id) AS counter FROM ' . $opnTables['topsites'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$nums = $justforcounting->fields['counter'];
	} else {
		$nums = 0;
	}
	unset ($justforcounting);
	if ($nums>0) {
		$result = &$opnConfig['database']->Execute ('SELECT id, name, description, siteurl, banurl, email, spass, bh, bw, ip, hitsin, hitsout FROM ' . $opnTables['topsites']);
		$table = & new opn_TableClass ('alternator');
		$table->AddHeaderRow (array (_TOPSADMIN_NUMBER, _TOPSADMIN_SITENAME, _TOPSADMIN_EMAIL, _TOPSADMIN_OPTIONS) );
		while (! $result->EOF) {
			$resultat = $result->GetRowAssoc ('0');
			$table->AddOpenRow ();
			$table->AddDataCol ($resultat['id'], 'center');
			$table->AddDataCol ('<a class="%alternate%" href="' . $resultat['siteurl'] . '" target="' . $opnConfig['topsites_target'] . '">' . $resultat['name'] . '</a>', 'left');
			$table->AddDataCol ('<a class="%alternate%" href="mailto:' . $resultat['email'] . '">' . $resultat['email'] . '</a>', 'left');
			$hlp1 = $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/top_sites/admin/index.php',
										'op' => 'modif',
										'topid' => $resultat['id']) ) . ' ';
			$hlp1 .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/top_sites/admin/index.php',
										'op' => 'suppr',
										'del' => $resultat['id']) );
			$table->AddDataCol ($hlp1, 'center');
			$table->AddCloseRow ();
			$result->MoveNext ();
		}
		$hlp = '';
		$table->GetTable ($hlp);
		$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/top_sites/index.php'),
						$nums,
						$opnConfig['top'],
						$offset);
		$hlp .= '<br /><br />' . $pagebar;
	} else {
		$hlp = _ADMIN_TOPSADMIN_NODATA;
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TOP_SITES_10_';
	$_display_dat['module'] = 'modules/top_sites';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $hlp);

}

function delentry () {

	global $opnConfig, $opnTables;

	$del = 0;
	get_var ('del', $del, 'form', _OOBJ_DTYPE_INT);
	$boxtitle = sprintf (_TOPSADMIN_ADMINISTRATION, $opnConfig['topsites_max']);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['topsites'] . ' WHERE id=' . $del);
	$help = '<div class="centertag">' . sprintf (_TOPSADMIN_DELETEENTRY, $del) . '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TOP_SITES_20_';
	$_display_dat['module'] = 'modules/top_sites';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $help);

}

function suppr () {

	global $opnConfig;

	$del = 0;
	get_var ('del', $del, 'url', _OOBJ_DTYPE_INT);
	$boxtitle = sprintf (_TOPSADMIN_ADMINISTRATION, $opnConfig['topsites_max']);
	$hlp = '<div class="normaltext" align="center">' . sprintf (_TOPSADMIN_DELETEQUESTION, $del) . '<br />' . _OPN_HTML_NL;
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TOP_SITES_30_', 'top_sites');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/top_sites/admin/index.php') );
	$form->AddHidden ('op', 'del');
	$form->AddHidden ('del', $del);
	$form->AddSubmit ('submity', _YES_SUBMIT);
	$form->AddFormEnd ();
	$form->GetFormular ($hlp);
	$hlp .= '</div>' . _OPN_HTML_NL;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TOP_SITES_40_';
	$_display_dat['module'] = 'modules/top_sites';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $hlp);

}

function dropranking () {

	global $opnConfig, $opnTables;

	$boxtitle = sprintf (_TOPSADMIN_ADMINISTRATION, $opnConfig['topsites_max']);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['topsites'] . ' SET hitsin=0, hitsout=0');
	$help = '<div class="centertag">' . _TOPSADMIN_RANKRESETED . '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TOP_SITES_50_';
	$_display_dat['module'] = 'modules/top_sites';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $help);

}

function resetranking () {

	global $opnConfig;

	$boxtitle = sprintf (_TOPSADMIN_ADMINISTRATION, $opnConfig['topsites_max']);
	$hlp = '<div class="normaltext" align="center">' . _TOPSADMIN_RANKQUESTION . '<br />' . _OPN_HTML_NL;
	$form = & new opn_FormularClass ();
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TOP_SITES_60_', 'top_sites');
	$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/top_sites/admin/index.php?op=drop') );
	$form->AddSubmit ('submity', _YES_SUBMIT);
	$form->AddFormEnd ();
	$form->GetFormular ($hlp);
	$hlp .= '</div>' . _OPN_HTML_NL;
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TOP_SITES_70_';
	$_display_dat['module'] = 'modules/top_sites';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $hlp);

}

function updateentry () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$name = '';
	get_var ('name', $name, 'form', _OOBJ_DTYPE_CLEAN);
	$description = '';
	get_var ('description', $description, 'form', _OOBJ_DTYPE_CHECK);
	$siteurl = '';
	get_var ('siteurl', $siteurl, 'form', _OOBJ_DTYPE_URL);
	$banurl = '';
	get_var ('banurl', $banurl, 'form', _OOBJ_DTYPE_URL);
	$bh = 0;
	get_var ('bh', $bh, 'form', _OOBJ_DTYPE_INT);
	$bw = 0;
	get_var ('bw', $bw, 'form', _OOBJ_DTYPE_INT);
	$email = '';
	get_var ('email', $email, 'form', _OOBJ_DTYPE_EMAIL);
	$spass = '';
	get_var ('spass', $spass, 'form', _OOBJ_DTYPE_CLEAN);
	$boxtitle = sprintf (_TOPSADMIN_ADMINISTRATION, $opnConfig['topsites_max']);
	$name = $opnConfig['opnSQL']->qstr ($name, 'name');
	$description = $opnConfig['opnSQL']->qstr ($description, 'description');
	$siteurl = $opnConfig['opnSQL']->qstr ($siteurl, 'siteurl');
	$banurl = $opnConfig['opnSQL']->qstr ($banurl, 'banurl');
	$email = $opnConfig['opnSQL']->qstr ($email, 'email');
	$spass = $opnConfig['opnSQL']->qstr ($spass, 'spass');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['topsites'] . " SET name=$name,description=$description,siteurl=$siteurl,banurl=$banurl,email=$email,spass=$spass,bh=$bh, bw=$bw WHERE id = $id");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['topsites'], 'id=' . $id);
	$help = '<div class="centertag">' . _TOPSADMIN_MODIFICATIONSAVED . '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TOP_SITES_80_';
	$_display_dat['module'] = 'modules/top_sites';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $help);

}

function modif () {

	global $opnConfig, $opnTables;

	$topid = 0;
	get_var ('topid', $topid, 'url', _OOBJ_DTYPE_INT);
	$boxtitle = sprintf (_TOPSADMIN_ADMINISTRATION, $opnConfig['topsites_max']);
	$result = &$opnConfig['database']->Execute ('SELECT id, name, description, siteurl, banurl, email, spass, bh, bw, ip, hitsin, hitsout FROM ' . $opnTables['topsites'] . ' WHERE id=' . $topid);
	if ($result !== false) {
		$NombreEntrees = $result->RecordCount ();
	} else {
		$NombreEntrees = 0;
	}
	if ($NombreEntrees == 0) {
		$hlp = '<div class="centertag">' . _ADMIN_TOPSADMIN_NODATA . '</div>';
	} else {
		while (! $result->EOF) {
			$resultat = $result->GetRowAssoc ('0');
			$hlp = '<span class="normaltextbold">' . _TOPSADMIN_MODIFYDATA . '</span><br />' . _OPN_HTML_NL;
			$form = & new opn_FormularClass ('listalternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TOP_SITES_90_', 'top_sites');
			$form->Init (encodeurl ($opnConfig['opn_url'] . '/modules/top_sites/admin/index.php?op=update') );
			$form->AddTable ();
			$form->AddCols (array ('10%', '90%') );
			$form->AddOpenRow ();
			$form->AddLabel ('name', _ADMIN_TOPSADMIN_FORM_SITENAME . ' :');
			$form->AddTextfield ('name', 50, 0, $resultat['name']);
			$form->AddChangeRow ();
			$form->AddLabel ('description', _ADMIN_TOPSADMIN_FORM_DESCRIPTION . ' :');
			$form->AddTextarea ('description', 0, 0, '', $resultat['description']);
			$form->AddChangeRow ();
			$form->AddLabel ('siteurl', _ADMIN_TOPSADMIN_FORM_URL . ' : ');
			$form->AddTextfield ('siteurl', 50, 0, $resultat['siteurl']);
			$form->AddChangeRow ();
			$form->AddLabel ('banurl', _ADMIN_TOPSADMIN_FORM_BANNERURL . ' :');
			$form->AddTextfield ('banurl', 50, 0, $resultat['banurl']);
			$form->AddChangeRow ();
			$form->AddLabel ('bh', _ADMIN_TOPSADMIN_FORM_BANNERHEIGHT . ' :');
			$form->AddTextfield ('bh', 2, 2, $resultat['bh']);
			$form->AddChangeRow ();
			$form->AddLabel ('bw', _ADMIN_TOPSADMIN_FORM_BANNERWIDTH . ' :');
			$form->AddTextfield ('bw', 3, 3, $resultat['bw']);
			$form->AddChangeRow ();
			$form->AddLabel ('email', _ADMIN_TOPSADMIN_FORM_EMAIL . ' :');
			$form->AddTextfield ('email', 30, 0, $resultat['email']);
			$form->AddChangeRow ();
			$form->SetSameCol ();
			$form->AddHidden ('spass', $resultat['spass']);
			$form->AddHidden ('id', $resultat['id']);
			$form->SetEndCol ();
			$form->AddSubmit ('submity', _ADMIN_TOPSADMIN_SAVE);
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($hlp);
			$result->MoveNext ();
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TOP_SITES_100_';
	$_display_dat['module'] = 'modules/top_sites';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $hlp);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
top_sites_ConfigHeader ();
switch ($op) {
	case 'modif':
		modif ();
		break;
	case 'update':
		updateentry ();
		break;
	case 'reset':
		resetranking ();
		break;
	case 'drop':
		dropranking ();
		break;
	case 'suppr':
		suppr ();
		break;
	case 'del':
		delentry ();
		break;
	default:
		main ();
		break;
}
$opnConfig['opnOutput']->DisplayFoot ();

?>