<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig, $opnTables;

$opnConfig['module']->InitModule ('modules/tutorial', true);
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');
include_once (_OPN_ROOT_PATH . 'modules/tutorial/admin/indexadmin.php');
include_once (_OPN_ROOT_PATH . 'modules/tutorial/include/tutorialfunctions.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.ubbcode.php');
require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
getLanguageDef (_OPN_ROOT_PATH . 'modules/tutorial/admin/language/');
$opnConfig['opnOption']['tutorial_uploadfilename'] = 'userfile';

function tutorialConfigMain () {

	global $opnConfig, $opnTables;

	$maxperpage = $opnConfig['admart'];
	$sortby = 'idasc';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$sql = 'SELECT COUNT(sid) AS counter FROM ' . $opnTables['tutorial_stories'];
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$txt = '';
	$table = & new opn_TableClass ('alternator');
	$result = &$opnConfig['database']->SelectLimit ('SELECT sid, title, wtime, topic, informant FROM ' . $opnTables['tutorial_stories'] . " ORDER BY wtime desc", $maxperpage, $offset);
	if ($result !== false) {
		if ($result->fields !== false) {
			while (! $result->EOF) {
				$sid = $result->fields['sid'];
				$title = $result->fields['title'];
				if ($title == '') {
					$title = '---';
				}
				// $time=$result->fields['wtime'];
				$topic = $result->fields['topic'];
				$topicname = $mf->getPathFromId ($topic);
				$topicname = substr ($topicname, 1);
				$table->AddOpenRow ();
				$table->AddDataCol ($sid, 'right');
				$table->AddDataCol ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/index.php',
													'sid' => $sid,
													'backto' => 'admin',
													'offset' => $offset) ) . '">' . $title . '</a>',
													'left');
				$table->AddDataCol ($topicname, 'right');
				$hlp = '';
				if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php',
												'op' => 'EditTutorial',
												'sid' => $sid) );
					$hlp .= '&nbsp;';
				}
				if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_DELETE, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php',
												'op' => 'RemoveTutorial',
												'sid' => $sid) );
					$hlp .= '&nbsp;';
				}
				if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
					$hlp .= $opnConfig['defimages']->get_time_link(array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php',
												'op' => 'ChangeTimeTutorial',
												'sid' => $sid), '', _TUT_SETNOWTIME);
				}
				$table->AddDataCol ($hlp, 'center');
				$table->AddCloseRow ();
				$result->MoveNext ();
			}
		}
	}
	$table->GetTable ($txt);
	$pagebar = build_pagebar (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php',
					'sortby' => $sortby),
					$reccount,
					$maxperpage,
					$offset,
					_TUT_ALLTUTORIALSINOURDATABASEARE . _TUTADMIN_ADMINTUTORIALINSIDE);
	$txt .= '<br /><br />' . $pagebar;
	if ($opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_EDIT, _PERM_ADMIN), true) ) {
		$form = & new opn_FormularClass ();
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_80_', 'tutorial_choose');
		$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php');
		$form->AddText (_TUTADMIN_ADMINTUTORIALID . ' ');
		$form->AddTextfield ('sid', 10);
		$options['EditTutorial'] = _TUTADMIN_ADMINEDITTUTORIAL;
		$options['RemoveTutorial'] = _TUTADMIN_ADMINREMOVETUTORIAL;
		$form->AddSelect ('op', $options);
		$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
		$form->AddFormEnd ();
		$form->GetFormular ($txt);
	}
	$txt .= '<br />';
	$txt .= '<br />';
	return $txt;

}

function puthome ($ihome, &$form) {

	$form->AddText (_TUTADMIN_PUBLISHHOME);
	if ( ($ihome == 0) OR ($ihome == '') ) {
		$sel1 = '1';
		$sel2 = '';
	}
	if ($ihome == 1) {
		$sel1 = '';
		$sel2 = '1';
	}
	$form->SetSameCol ();
	$form->AddRadio ('ihome', 0, $sel1);
	$form->AddLabel ('ihome', _YES . '&nbsp;', 1);
	$form->AddRadio ('ihome', 1, $sel2);
	$form->AddLabel ('ihome', _NO, 1);
	$form->AddText ('&nbsp;&nbsp;[ ' . _TUTADMIN_ADMINONLYWORKS . ' ]');
	$form->SetEndCol ();

}

function deleteTutorial () {

	global $opnTables, $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'both', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_queue'] . ' WHERE qid=' . $qid);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_del_queue'] . ' WHERE sid=' . $qid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/submissionsadmin.php?op=submissions', false) );
	CloseTheOpnDB ($opnConfig);

}

function SelectCategory ($cat, &$form) {

	global $opnTables, $opnConfig;

	$selcat = &$opnConfig['database']->Execute ('SELECT catid, title FROM ' . $opnTables['tutorial_stories_cat'] . " WHERE catid>0 ORDER BY title");
	$form->AddLabel ('catid', _TUTADMIN_ADMINCATEGORY);
	$options = array ();
	$options[0] = _TUTADMIN_ADMINTUTORIALS;
	while (! $selcat->EOF) {
		$options[$selcat->fields['catid']] = $selcat->fields['title'];
		$selcat->MoveNext ();
	}
	$form->SetSameCol ();
	$form->AddSelect ('catid', $options, $cat);
	$form->AddText ('[ <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/categoryadmin.php?op=AddCategory') . '">' . _TUTADMIN_ADMINADD . '</a> |');
	$form->AddText (' <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/categoryadmin.php?op=EditCategory') . '">' . _TUTADMIN_ADMINEDIT . '</a> |');
	$form->AddText (' <a class="%alternate%" href="' . encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/categoryadmin.php?op=DelCategory') . '">' . _TUTADMIN_ADMINDELETE . '</a> ]');
	$form->SetEndCol ();

}

function TutorialInputDelPart (&$form, $qid, $year = 0, $month = 0, $day = 0, $hour = 0, $min = 0, $auto = '') {

	global $opnTables, $opnConfig;
	if ($qid != -1) {
		$result_d = &$opnConfig['database']->Execute ('SELECT adqtimestamp FROM ' . $opnTables['tutorial_del_queue'] . " WHERE sid=$qid");
		if ($result_d !== false) {
			if ($result_d->fields !== false) {
				$opnConfig['opndate']->sqlToopnData ($result_d->fields['adqtimestamp']);
				$time = '';
				$opnConfig['opndate']->formatTimestamp ($time);
				$datetime = '';
				preg_match ('/([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})/', $time, $datetime);
				$year = $datetime[1];
				$month = $datetime[2];
				$day = $datetime[3];
				$hour = $datetime[4];
				$min = $datetime[5];
			}
		}
	}
	$opnConfig['opndate']->now ();
	if ($month == 0) {
		$opnConfig['opndate']->getMonth ($month);
	}
	if ($day == 0) {
		$opnConfig['opndate']->getDay ($day);
	}
	if ($hour == 0) {
		$opnConfig['opndate']->getHour ($hour);
	}
	if ($min == 0) {
		$opnConfig['opndate']->getMinute ($min);
	}
	if ($auto == 'AUTO') {
		if ($year == '') {
			$opnConfig['opndate']->getYear ($year);
		}
		$form->AddText (_TUTADMIN_ADMINWHENDOYOUPUBLISHTUTORIAL);
	} else {
		if ($year == 0) {
			$year = 9999;
		}
		$form->AddText (_TUT_ADMINWHENDOYOUDELTUTORIAL);
	}
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
	$form->SetSameCol ();
	$form->AddText (_TUT_ADMINNOWIS . ' ' . $temp);
	$form->AddNewline (2);
	$options = array ();
	$xday = 1;
	while ($xday<=31) {
		$day1 = sprintf ('%02d', $xday);
		$options[$day1] = $day1;
		$xday++;
	}
	$form->AddLabel ('day', _TUT_ADMINDAY . ' ');
	$form->AddSelect ('day', $options, sprintf ('%02d', $day) );
	$xmonth = 1;
	$options = array ();
	while ($xmonth<=12) {
		$month1 = sprintf ('%02d', $xmonth);
		$options[$month1] = $month1;
		$xmonth++;
	}
	$form->AddLabel ('month', ' ' . _TUT_ADMINMONTH . ' ');
	$form->AddSelect ('month', $options, sprintf ('%02d', $month) );
	$form->AddLabel ('year', ' ' . _TUT_ADMINYEAR . ' ');
	$form->AddTextfield ('year', 5, 4, $year);
	$xhour = 0;
	$options = array ();
	while ($xhour<=23) {
		$hour1 = sprintf ('%02d', $xhour);
		$options[$hour1] = $hour1;
		$xhour++;
	}
	$form->AddLabel ('hour', _TUT_ADMINHOUR . ' ');
	$form->AddSelect ('hour', $options, sprintf ('%02d', $hour) );
	$xmin = 0;
	$options = array ();
	while ($xmin<=59) {
		$min1 = sprintf ('%02d', $xmin);
		$options[$min1] = $min1;
		$xmin = $xmin+5;
	}
	$min = round ($min/5)*5;
	$form->AddLabel ('min', ' : ');
	$form->AddSelect ('min', $options, sprintf ('%02d', $min) );
	$form->AddText (' : 00');
	$form->SetEndCol ();

}

function TutorialInputContentPart (&$form, $hometext, $bodytext = '', $notes = '') {

	global $opnConfig;
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
	}
	$form->UseImages (true);
	$form->AddLabel ('hometext', _TUTADMIN_ADMININTROTEXT);
	$form->AddTextarea ('hometext', 0, 0, '', $hometext);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('bodytext', _TUTADMIN_ADMINFULLTEXT);
	$form->AddText ('<br /><br /><span class="normaltext">' . _TUTADMIN_ADMINCHECHURLS . '</span>');
	$form->SetEndCol ();
	$form->AddTextarea ('bodytext', 0, 0, '', $bodytext);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddLabel ('notes', _TUTADMIN_ADMINNOTES);
	$form->AddText ('<br /><br /><span class="normaltext">' . _TUTADMIN_ADMINCHECHURLS . '</span>');
	$form->SetEndCol ();
	$form->AddTextarea ('notes', 0, 0, '', $notes);

}

function TutorialInputFooterPart ($myoptions, &$form) {

	global $opnConfig;

	$form->AddLabel ('_tut_op_use_lang', _TUT_USELANG);
	if ( (!isset ($myoptions['_tut_op_use_lang']) ) OR ($myoptions['_tut_op_use_lang'] == '') ) {
		$myoptions['_tut_op_use_lang'] = '0';
	}
	$options = array ();
	$options = get_dir_list (_OPN_ROOT_PATH . 'language', '', '/^lang\-(.+)\.php/');
	usort ($options, 'strcollcase');
	$options['0'] = _TUT_ALL;
	$form->AddSelect ('_tut_op_use_lang', $options, $myoptions['_tut_op_use_lang']);
	$form->AddChangeRow ();
	$form->AddLabel ('_tut_op_keywords', _TUT_USEKEYWORDS);
	if (!isset ($myoptions['_tut_op_keywords']) ) {
		$myoptions['_tut_op_keywords'] = '';
	}
	$form->AddTextfield ('_tut_op_keywords', 64, 256, $myoptions['_tut_op_keywords']);
	$options_datei = array ();
	$themelist = get_file_list (_OPN_ROOT_PATH . 'themes' . '/' . $opnConfig['Default_Theme'] . '/tpl/tutorial', array ('opnliste-') );
	if (count ($themelist) ) {
		usort ($themelist, 'strnatcasecmp');
		$max = sizeof ($themelist);
		for ($i = 0; $i< $max; $i++) {
			$options_datei[$themelist[$i]] = $themelist[$i];
		}
	}
	$options_datei['*empty*'] = '&nbsp;';
	$options_tut = array ();
	$options_tut['tpl'] = 'tpl';
	$options_tut['php'] = 'php';
	$form->AddChangeRow ();
	$form->AddLabel ('_tut_op_use_head', _TUT_USEHEADER);
	if ( (!isset ($myoptions['_tut_op_use_head']) ) || ($myoptions['_tut_op_use_head'] == '') ) {
		if ($opnConfig['_op_tut_use_head_org'] != '') {
			$myoptions['_tut_op_use_head'] = $opnConfig['_op_tut_use_head_org'];
		} else {
			$myoptions['_tut_op_use_head'] = '*empty*';
		}
	}
	$form->AddSelect ('_tut_op_use_head', $options_datei, $myoptions['_tut_op_use_head']);
	$form->AddChangeRow ();
	$form->AddLabel ('_tut_op_use_foot', _TUT_USEFOOTER);
	if (! (isset ($myoptions['_tut_op_use_foot']) ) || ($myoptions['_tut_op_use_foot'] == '') ) {
		if ($opnConfig['_op_tut_use_foot_org'] != '') {
			$myoptions['_tut_op_use_foot'] = $opnConfig['_op_tut_use_foot_org'];
		} else {
			$myoptions['_tut_op_use_foot'] = '*empty*';
		}
	}
	$form->AddSelect ('_tut_op_use_foot', $options_datei, $myoptions['_tut_op_use_foot']);
	$form->AddChangeRow ();
	$form->AddLabel ('_tut_op_use_theme_id', _TUT_USETHEMEID);
	if (!isset ($myoptions['_tut_op_use_theme_id']) ) {
		$myoptions['_tut_op_use_theme_id'] = '';
	}
	$form->AddTextfield ('_tut_op_use_theme_id', 30, 256, $myoptions['_tut_op_use_theme_id']);
	$form->AddChangeRow ();
	$form->AddLabel ('_tut_op_use_user_group', _TUT_USEUSERGROUP);
	if (!isset ($myoptions['_tut_op_use_user_group']) ) {
		$myoptions['_tut_op_use_user_group'] = '';
	}
	$options = array ();
	$groups = $opnConfig['permission']->UserGroups;
	foreach ($groups as $group) {
		$options[$group['id']] = $group['name'];
	}
	$form->AddSelect ('_tut_op_use_user_group', $options, $myoptions['_tut_op_use_user_group']);
	$options = array ();
	$groups = $opnConfig['theme_groups'];
	foreach ($groups as $group) {
		$options[$group['theme_group_id']] = $group['theme_group_text'];
	}
	if (!isset ($myoptions['_tut_op_use_theme_group']) ) {
		$myoptions['_tut_op_use_theme_group'] = '';
	}
	$form->AddChangeRow ();
	$form->AddLabel ('_tut_op_use_theme_group', _TUT_USETHEMEGROUP);
	$form->AddSelect ('_tut_op_use_theme_group', $options, $myoptions['_tut_op_use_theme_group']);
	unset ($options_datei);
	unset ($options_tut);
	unset ($options);

}

function TutorialInputHeaderPart (&$form, $uname = '', $subject4edit = '', $topicid = 0, $cat = 0, $ihome = '', $acomm = 0) {

	global $opnTables;

	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$form->AddLabel ('author', _TUTADMIN_ADMINNAME);
	$form->AddTextfield ('author', 50, 0, $uname);
	$form->AddChangeRow ();
	$form->AddLabel ('subject', _TUTADMIN_ADMINSUBJECT);
	$form->AddTextfield ('subject', 50, 0, $subject4edit);
	$form->AddChangeRow ();
	$form->AddLabel ('topicid', _TUTADMIN_ADMINTOPIC);
	$mf->makeMySelBox ($topicid, $form);
	$form->AddChangeRow ();
	SelectCategory ($cat, $form);
	$form->AddChangeRow ();
	puthome ($ihome, $form);
	$form->AddChangeRow ();
	$form->AddText (_TUTADMIN_ALLOWCOMMENTS);
	if ($acomm == 0) {
		$sel1 = 1;
		$sel2 = 0;
	}
	if ($acomm == 1) {
		$sel1 = 0;
		$sel2 = 1;
	}
	$form->SetSameCol ();
	$form->AddRadio ('acomm', 0, $sel1);
	$form->AddLabel ('acomm', _YES . '&nbsp;', 1);
	$form->AddRadio ('acomm', 1, $sel2);
	$form->AddLabel ('acomm', _NO, 1);
	$form->SetEndCol ();

}

function MoveTutorial () {

	global $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CLEAN);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$move = '';
	get_var ('move', $move, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$form = & new opn_FormularClass ('listalternator');
	$mover = explode ('/', $move);
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	include_once (_OPN_ROOT_PATH . $move . '/plugin/tutorial/index.php');
	$myfunc = $mover[1] . '_tutorial_get_form';
	$myfunc ($form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('author', $author);
	$form->AddHidden ('subject', $subject);
	$form->AddHidden ('hometext', $hometext);
	$form->AddHidden ('move', $move);
	$form->AddHidden ('op', 'domovetutorial');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _TUTADMIN_MOVETUTORIAL);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$txt = '';
	$form->GetFormular ($txt);
	unset ($form);
	return $txt;

}

function DoMoveTutorial () {

	global $opnConfig;

	$cat = '';
	get_var ('cat', $cat, 'form', _OOBJ_DTYPE_CLEAN);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CLEAN);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$move = '';
	get_var ('move', $move, 'form', _OOBJ_DTYPE_CLEAN);
	$mover = explode ('/', $move);
	include_once (_OPN_ROOT_PATH . $move . '/plugin/tutorial/index.php');
	$myfunc = $mover[1] . '_tutorial_save_data';
	$myfunc ($cat, $author, $subject, $hometext);
	deleteTutorial ();
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/submissionsadmin.php?op=submissions', false) );

}

function displayTutorial () {

	global $opnConfig, $opnTables;

	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->SelectLimit ('SELECT qid, uid, uname, subject, tutorial, topic, userfile, options FROM ' . $opnTables['tutorial_queue'] . " WHERE qid=$qid", 1);
	$qid = $result->fields['qid'];
	$uid = $result->fields['uid'];
	$uname = $result->fields['uname'];
	$subject = $result->fields['subject'];
	$hometext = $result->fields['tutorial'];
	$topicid = $result->fields['topic'];
	$file = $result->fields['userfile'];
	$myoptions = unserialize ($result->fields['options']);
	$result->Close ();
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = de_make_user_images ($hometext);
	}
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$ubb->ubbencode ($hometext);
	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$ubb->ubbdecode ($hometext);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_100_', 'tutorial');
	$txt = '';
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $uname, $subject, $topicid);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext);
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, $qid);
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$plugs = array ();
	$opnConfig['installedPlugins']->getplugin ($plugs,
								'articlemove');
	if (count ($plugs)>0) {
		$options = array ();
		foreach ($plugs as $var) {
			include_once (_OPN_ROOT_PATH . $var['plugin'] . '/plugin/article/index.php');
			$myfunc = $var['module'] . '_article_get_name';
			$plugname = $myfunc ();
			$options[$var['plugin']] = $plugname;
		}
		if (count ($options)>0) {
			$form->AddChangeRow ();
			$form->AddText ('&nbsp;');
			$form->SetSameCol ();
			$form->AddSelect ('move', $options);
			$form->AddSubmit ('mover', _TUTADMIN_MOVETUTORIAL);
			$form->SetEndCol ();
		}
	}
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddText ('&nbsp;');
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('uid', $uid);
	$form->AddHidden ('file', $file);
	$form->SetEndCol ();
	$options = array ();
	$options['DeleteTutorial'] = _TUTADMIN_ADMINDELETETUTORIAL;
	$options['PreviewAgain'] = _TUTADMIN_ADMINPREWIEWAGAIN;
	$options['PostTutorial'] = _TUTADMIN_ADMINPOSTTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'PreviewAgain');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($txt);
	unset ($form);
	return $txt;

}

function previewTutorial () {

	global $opnConfig;

	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = '';
	get_var ('month', $month, 'form', _OOBJ_DTYPE_CLEAN);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$bodytext = $opnConfig['cleantext']->FixQuotes ($bodytext);
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$bodytext = $opnConfig['cleantext']->filter_text ($bodytext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$bodytext4pre = $opnConfig['cleantext']->makeClickable ($bodytext);
	$ubb->ubbdecode ($hometext);
	$ubb->ubbdecode ($bodytext);
	$notes4form = $opnConfig['cleantext']->FixQuotes ($notes);
	$notes4form = $opnConfig['cleantext']->filter_text ($notes4form);
	$notes4pre = $opnConfig['cleantext']->makeClickable ($notes4form);
	opn_nl2br ($notes4pre);
	$txt = '';
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_110_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre, $bodytext4pre, $notes4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $author, $subject, $topicid, $catid, $ihome, $acomm);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext, $bodytext, $notes4form);
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1, $year, $month, $day, $hour, $min);
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddText ('&nbsp;');
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('uid', $uid);
	$form->AddHidden ('file', $file);
	$form->SetEndCol ();
	$options = array ();
	$options['DeleteTutorial'] = _TUTADMIN_ADMINDELETETUTORIAL;
	$options['PreviewAgain'] = _TUTADMIN_ADMINPREWIEWAGAIN;
	$options['PostTutorial'] = _TUTADMIN_ADMINPOSTTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'PreviewAgain');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($txt);
	return $txt;

}

function postTutorial () {

	global $alltheboxtxt, $opnConfig, $opnTables;

	$myuser = $opnConfig['permission']->GetUserinfo ();
	$aid = $myuser['uname'];
	$uid = 1;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	if ($hometext == $bodytext) {
		$bodytext = '';
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = make_user_images ($hometext);
		$bodytext = make_user_images ($bodytext);
		$notes = make_user_images ($notes);
	}
	$ubb = & new UBBCode;
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$hometext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($hometext, true, true), 'hometext');
	$bodytext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($bodytext, true, true), 'bodytext');
	$notes = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($notes, true, true), 'notes');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$sid = $opnConfig['opnSQL']->get_new_number ('tutorial_stories', 'sid');
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	if ($myoptions['_tut_op_use_head'] == '*empty*') {
		$myoptions['_tut_op_use_head'] = '';
	}
	if ($myoptions['_tut_op_use_foot'] == '*empty*') {
		$myoptions['_tut_op_use_foot'] = '';
	}
	if (!isset ($myoptions['_tut_op_use_lang']) ) {
		$tut_lang = '0';
	} else {
		$tut_lang = $myoptions['_tut_op_use_lang'];
	}
	if (!isset ($myoptions['_tut_op_use_user_group']) ) {
		$tut_user_group = 0;
	} else {
		$tut_user_group = $myoptions['_tut_op_use_user_group'];
	}
	if (!isset ($myoptions['_tut_op_use_theme_group']) ) {
		$tut_theme_group = 0;
	} else {
		$tut_theme_group = $myoptions['_tut_op_use_theme_group'];
	}
	$options = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($myoptions) ), 'options');
	$_aid = $opnConfig['opnSQL']->qstr ($aid);
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$_file = $opnConfig['opnSQL']->qstr ($file);
	$_tut_lang = $opnConfig['opnSQL']->qstr ($tut_lang);
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_stories'] . " VALUES ($sid, $catid, $_aid, $subject, $now, $hometext, $bodytext, 0, 0, $topicid,$_author, $notes, $ihome, $_file, $options, $_tut_lang, $tut_user_group,$tut_theme_group,$acomm)");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$alltheboxtxt .= $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />';
		return;
	}
	if ($year != 9999) {
		$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_stories'], 'sid=' . $sid);
		if ($day<10) {
			$day = '0' . $day;
		}
		$sec = '00';
		$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min . ':' . $sec);
		$date = '';
		$opnConfig['opndate']->opnDataTosql ($date);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_del_queue'] . " VALUES ($sid, $date)");
	}
	if ($uid >= 2) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['users'] . ' SET counter=counter+1 WHERE uid=' . $uid);
	}
	deleteTutorial ();

}

function editTutorial () {

	global $opnConfig, $opnTables;

	$sid = 0;
	get_var ('sid', $sid, 'both', _OOBJ_DTYPE_INT);
	$dopreview = 0;
	get_var ('dopreview', $dopreview, 'form', _OOBJ_DTYPE_INT);
	if (!$dopreview) {
		$result = &$opnConfig['database']->Execute ('SELECT catid, title, hometext, bodytext, topic, notes, ihome, userfile, informant, options,acomm FROM ' . $opnTables['tutorial_stories'] . ' WHERE sid=' . $sid);
		$catid = $result->fields['catid'];
		$subject = $result->fields['title'];
		$hometext = $result->fields['hometext'];
		$bodytext = $result->fields['bodytext'];
		$topicid = $result->fields['topic'];
		$notes = $result->fields['notes'];
		$ihome = $result->fields['ihome'];
		$file = $result->fields['userfile'];
		$author = $result->fields['informant'];
		$myoptions = unserialize ($result->fields['options']);
		$acomm = $result->fields['acomm'];
		$result->Close ();
	} else {
		$catid = 0;
		get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
		$subject = '';
		get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
		$hometext = '';
		get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
		$bodytext = '';
		get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
		$topicid = 0;
		get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
		$notes = '';
		get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
		$ihome = 0;
		get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
		$file = '';
		get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
		$author = '';
		get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
		$year = 0;
		get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
		$day = 0;
		get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
		$month = 0;
		get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
		$hour = 0;
		get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
		$min = 0;
		get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
		$acomm = 0;
		get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
		$myoptions = array ();
		get_var ('_tut_op_', $myoptions,'form','',true);
		if ($myoptions['_tut_op_use_head'] == '*empty*') {
			$myoptions['_tut_op_use_head'] = '';
		}
		if ($myoptions['_tut_op_use_foot'] == '*empty*') {
			$myoptions['_tut_op_use_foot'] = '';
		}
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = de_make_user_images ($hometext);
		$bodytext = de_make_user_images ($bodytext);
		$notes = de_make_user_images ($notes);
	}
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$bodytext = $opnConfig['cleantext']->FixQuotes ($bodytext);
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$bodytext = $opnConfig['cleantext']->filter_text ($bodytext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$bodytext4pre = $opnConfig['cleantext']->makeClickable ($bodytext);
	$ubb->ubbdecode ($hometext);
	$ubb->ubbdecode ($bodytext);
	$notes4edit = $opnConfig['cleantext']->FixQuotes ($notes);
	$notes4show = $opnConfig['cleantext']->makeClickable ($notes4edit);
	opn_nl2br ($notes4show);
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_120_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre, $bodytext4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $author, $subject, $topicid, $catid, $ihome, $acomm);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext, $bodytext, $notes4edit);
	$form->AddChangeRow ();
	if ($dopreview) {
		TutorialInputDelPart ($form, -1, $year, $month, $day, $hour, $min);
	} else {
		TutorialInputDelPart ($form, $sid);
	}
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddText ('&nbsp;');
	$form->AddHidden ('file', $file);
	$form->AddHidden ('dopreview', 1);
	$form->AddHidden ('sid', $sid);
	$form->SetEndCol ();
	$options = array ();
	$options['EditTutorial'] = _TUTADMIN_ADMINPREWIEWAGAIN;
	$options['ChangeTutorial'] = _TUTADMIN_ADMINEDITTUTORIAL2;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'EditTutorial');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$tmp = '';
	$form->GetFormular ($tmp);
	return $tmp;

}

function removeTutorial () {

	global $opnConfig, $opnTables;

	$sid = 0;
	get_var ('sid', $sid, 'url', _OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_stories'] . ' WHERE sid=' . $sid);
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_comments'] . ' WHERE sid=' . $sid);
		$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_del_queue'] . ' WHERE sid=' . $sid);
		return '';
	}
	$result = &$opnConfig['database']->Execute ('SELECT title FROM ' . $opnTables['tutorial_stories'] . ' WHERE sid=' . $sid);
	$subject = $opnConfig['cleantext']->makeClickable ($result->fields['title']);
	opn_nl2br ($subject);
	$txt = '<div class="centertag">';
	$txt .= _TUTADMIN_ADMINAREYOUSUREYOUWANTTOREMOVETUTORIAL;
	$txt .= '<span class="normaltextbold">' . $subject . '</span>';
	$txt .= _TUTADMIN_ADMINAMDALLITSCOMMENTS;
	$txt .= '<br /><br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/modules/tutorial/admin/index.php">' . _NO . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php',
																										'op' => 'RemoveTutorial',
																										'sid' => $sid,
																										'ok' => '1') ) . '">' . _YES . '</a></div>';
	return $txt;

}

function changeTutorial () {

	global $opnConfig, $opnTables;

	$sid = 0;
	get_var ('sid', $sid, 'form', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = make_user_images ($hometext);
		$bodytext = make_user_images ($bodytext);
		$notes = make_user_images ($notes);
	}
	$ubb = & new UBBCode;
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$hometext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($hometext, true, true), 'hometext');
	$bodytext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($bodytext, true, true), 'bodytext');
	$notes = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($notes, true, true), 'notes');
	$_author = $opnConfig['opnSQL']->qstr ($author);
	if ($author != '') {
		$author = ", informant=$_author";
	}
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	if ($myoptions['_tut_op_use_head'] == '*empty*') {
		$myoptions['_tut_op_use_head'] = '';
	}
	if ($myoptions['_tut_op_use_foot'] == '*empty*') {
		$myoptions['_tut_op_use_foot'] = '';
	}
	if (!isset ($myoptions['_tut_op_use_lang']) ) {
		$tut_lang = '0';
	} else {
		$tut_lang = $myoptions['_tut_op_use_lang'];
	}
	if (!isset ($myoptions['_tut_op_use_user_group']) ) {
		$tut_user_group = 0;
	} else {
		$tut_user_group = $myoptions['_tut_op_use_user_group'];
	}
	if (!isset ($myoptions['_tut_op_use_theme_group']) ) {
		$tut_theme_group = 0;
	} else {
		$tut_theme_group = $myoptions['_tut_op_use_theme_group'];
	}
	$options = $opnConfig['opnSQL']->qstr (serialize ($myoptions), 'options');
	$_file = $opnConfig['opnSQL']->qstr ($file);
	$_tut_lang = $opnConfig['opnSQL']->qstr ($tut_lang);
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['tutorial_stories'] . " SET hometext=$hometext,bodytext=$bodytext,notes=$notes,options=$options,tut_lang=$_tut_lang, tut_user_group=$tut_user_group, tut_theme_group=$tut_theme_group, catid=$catid, title=$subject, topic=$topicid, ihome=$ihome, acomm=$acomm, userfile=$_file" . $author . ' WHERE sid=' . $sid);
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_stories'], 'sid=' . $sid);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_del_queue'] . ' WHERE sid=' . $sid);
	if ($year != 9999) {
		if ($day<10) {
			$day = "0$day";
		}
		$sec = "00";
		$opnConfig['opndate']->setTimestamp ("$year-$month-$day $hour:$min:$sec");
		$date = '';
		$opnConfig['opndate']->opnDataTosql ($date);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_del_queue'] . " VALUES ($sid, $date)");
	}

}

function adminTutorial () {

	global $opnConfig;

	$ui = $opnConfig['permission']->GetUserinfo ();
	$txt = '<a name="new"></a><div align="center" class="extratextbold">' . _TUTADMIN_ADMINNEWTUTORIAL . '</div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_130_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus', "multipart/form-data");
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	TutorialInputHeaderPart ($form, $ui['uname'], '', 0, 0, '');
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, '');
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1);
	$form->AddChangeRow ();
	$form->AddHidden ('MAX_FILE_SIZE', $opnConfig['opn_upload_size_limit']);
	$form->AddFile ('userfile');
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->AddHidden ('file', '');
	$options = array ();
	$options['PreviewAdminTutorial'] = _TUTADMIN_ADMINPREWIEWADMINTUTORIAL;
	$options['PostAdminTutorial'] = _TUTADMIN_ADMINPOSTADMINTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'PreviewAdminTutorial');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($txt);
	unset ($form);
	return $txt;

}

function previewAdminTutorial () {

	global $alltheboxtxt, $opnConfig;

	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$userfile = '';
	get_var ('userfile', $userfile, 'file');
	if ($userfile == '') {
		$userfile = 'none';
	}
	$userfile = check_upload ($userfile);
	if ($userfile <> 'none') {
		$upload = & new file_upload_class;
		$upload->max_filesize ($opnConfig['opn_upload_size_limit']);
		if ($upload->upload ('userfile', 'image', '') ) {
			if ($upload->save_file ($opnConfig['datasave']['tut_bild_upload']['path'], 3) ) {
				$file = $upload->new_file;
			}
		}
		if ( (isset ($upload->errors) ) && ($upload->errors) ) {
			$file = '';
		} else {
			$file = str_ireplace ($opnConfig['datasave']['tut_bild_upload']['path'], $opnConfig['datasave']['tut_bild_upload']['url'] . '/', $file);
		}
	}
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$bodytext = $opnConfig['cleantext']->FixQuotes ($bodytext);
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$bodytext = $opnConfig['cleantext']->filter_text ($bodytext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$bodytext4pre = $opnConfig['cleantext']->makeClickable ($bodytext);
	$ubb->ubbdecode ($hometext);
	$ubb->ubbdecode ($bodytext);
	$alltheboxtxt .= '<div class="extratextbold" align="center">' . _TUTADMIN_ADMINPREWIEWTUTORIAL . '</div>';
	$alltheboxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_140_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre, $bodytext4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $author, $subject, $topicid, $catid, $ihome, $acomm);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext, $bodytext, $notes);
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1, $year, $month, $day, $hour, $min);
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddText ('&nbsp;');
	$form->AddHidden ('catid', $catid);
	$form->AddHidden ('file', $file);
	$form->SetEndCol ();
	$options = array ();
	$options['PreviewAdminTutorial'] = _TUTADMIN_ADMINPREWIEWADMINTUTORIAL;
	$options['PostAdminTutorial'] = _TUTADMIN_ADMINPOSTADMINTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'PreviewAdminTutorial');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($alltheboxtxt);

}

function postAdminTutorial () {

	global $opnTables, $opnConfig;

	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$userfile = '';
	get_var ('userfile', $userfile, 'file');
	if ($userfile == '') {
		$userfile = 'none';
	}
	$userfile = check_upload ($userfile);
	if ($userfile <> 'none') {
		$upload = & new file_upload_class;
		$upload->max_filesize ($opnConfig['opn_upload_size_limit']);
		if ($upload->upload ('userfile', 'image', '') ) {
			if ($upload->save_file ($opnConfig['datasave']['tut_bild_upload']['path'], 3) ) {
				$file = $upload->new_file;
			}
		}
		if ( (isset ($upload->errors) ) && ($upload->errors) ) {
			$file = '';
		} else {
			$file = str_ireplace ($opnConfig['datasave']['tut_bild_upload']['path'], $opnConfig['datasave']['tut_bild_upload']['url'] . '/', $file);
		}
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = make_user_images ($hometext);
		$bodytext = make_user_images ($bodytext);
		$notes = make_user_images ($notes);
	}
	$ubb = & new UBBCode;
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$hometext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($hometext, true, true), 'hometext');
	$bodytext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($bodytext, true, true), 'bodytext');
	$notes = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($notes, true, true), 'notes');
	$opnConfig['opndate']->now ();
	$now = '';
	$opnConfig['opndate']->opnDataTosql ($now);
	$sid = $opnConfig['opnSQL']->get_new_number ('tutorial_stories', 'sid');
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	if ($myoptions['_tut_op_use_head'] == '*empty*') {
		$myoptions['_tut_op_use_head'] = '';
	}
	if ($myoptions['_tut_op_use_foot'] == '*empty*') {
		$myoptions['_tut_op_use_foot'] = '';
	}
	if (!isset ($myoptions['_tut_op_use_lang']) ) {
		$tut_lang = '0';
	} else {
		$tut_lang = $myoptions['_tut_op_use_lang'];
	}
	if (!isset ($myoptions['_tut_op_use_user_group']) ) {
		$tut_user_group = 0;
	} else {
		$tut_user_group = $myoptions['_tut_op_use_user_group'];
	}
	if (!isset ($myoptions['_tut_op_use_theme_group']) ) {
		$tut_theme_group = 0;
	} else {
		$tut_theme_group = $myoptions['_tut_op_use_theme_group'];
	}
	$_tut_lang = $opnConfig['opnSQL']->qstr ($tut_lang);
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$_file = $opnConfig['opnSQL']->qstr ($file);
	$options = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($myoptions) ), 'options');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_stories'] . " VALUES ($sid, $catid, $_author, $subject, $now, $hometext, $bodytext, 0, 0, $topicid, $_author, $notes, $ihome, $_file, $options, $_tut_lang, $tut_user_group,$tut_theme_group,$acomm)");
	if ($opnConfig['database']->ErrorNo ()>0) {
		return $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />';
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_stories'], 'sid=' . $sid);
	if ($year != 9999) {
		if ($day<10) {
			$day = "0$day";
		}
		$sec = '00';
		$opnConfig['opndate']->setTimestamp ("$year-$month-$day $hour:$min:$sec");
		$date = '';
		$opnConfig['opndate']->opnDataTosql ($date);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_del_queue'] . " VALUES ($sid, $date)");
	}
	return '';

}

function waitingautoTutorial () {

	global $opnTables, $opnConfig;

	$txt = '';
	$result = &$opnConfig['database']->Execute ('SELECT anid, title, wtime FROM ' . $opnTables['tutorial_autotutorials'] . " WHERE anid>0 ORDER BY wtime ASC");
	if ($result !== false) {
		if ($result->fields !== false) {
			$txt .= '<div class="centertag"><span class="normaltextbold">' . _TUTADMIN_ADMINPROGRAMMEDTUTORIALS . '</span></div><br /><br />';
			$table = & new opn_TableClass ('alternator');
			$table->AddCols (array ('20%', '65%', '15%') );
			while (! $result->EOF) {
				$anid = $result->fields['anid'];
				$title = $result->fields['title'];
				$time = $result->fields['wtime'];
				$opnConfig['opndate']->sqlToopnData ($time);
				if ($anid != '') {
					$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING5);
					$table->AddDataRow (array ($opnConfig['defimages']->get_edit_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'op' => 'autoEdit', 'anid' => $anid) ) . ' ' . $opnConfig['defimages']->get_delete_link (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'op' => 'autoDelete', 'anid' => $anid) ), $title, $time), array ('center', 'left', 'center') );
				}
				$result->MoveNext ();
			}
			$table->GetTable ($txt);
			$txt .= '<br />';
		}
	}
	return $txt;

}

function autoTutorial () {

	global $alltheboxtxt, $opnConfig;

	$myuser = $opnConfig['permission']->GetUserinfo ();
	$aid = $myuser['uname'];
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	$alltheboxtxt .= waitingautoTutorial ();
	$opnConfig['opndate']->now ();
	$alltheboxtxt .= '<div class="extratextbold" align="center">' . _TUTADMIN_ADMINNEWAUTOMATEDTUTORIAL . '</div>';
	$alltheboxtxt .= '<br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_150_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	TutorialInputHeaderPart ($form, $aid, '', 0, 0, '');
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, '');
	$form->AddChangeRow ();
	$form->AddText ('&nbsp;');
	$form->AddText (_TUTADMIN_ADMININCLUDEAURLANDTEST);
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1, '', '', '', '', '', 'AUTO');
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddText ('&nbsp;');
	$form->AddHidden ('file', 'none');
	$form->SetEndCol ();
	$options = array ();
	$options['autoPreviewTutorial'] = _TUTADMIN_ADMINPREWIEWADMINTUTORIAL;
	$options['autoSaveTutorial'] = _TUTADMIN_ADMINPOSTADMINTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'autoPreviewTutorial');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($alltheboxtxt);

}

function autoPreviewTutorial () {

	global $opnConfig;

	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$txt = waitingautoTutorial ();
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$bodytext = $opnConfig['cleantext']->FixQuotes ($bodytext);
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$bodytext = $opnConfig['cleantext']->filter_text ($bodytext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$bodytext4pre = $opnConfig['cleantext']->makeClickable ($bodytext);
	$ubb->ubbdecode ($hometext);
	$ubb->ubbdecode ($bodytext);
	$txt .= '<div class="extratextbold" align="center">' . _TUTADMIN_ADMINPREWIEWAUTOMATEDTUTORIAL . '</div>';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_160_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre, $bodytext4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $author, $subject, $topicid, $catid, $ihome, $acomm);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext, $bodytext, $notes);
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1, $year, $month, $day, $hour, $min, 'AUTO');
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddText ('&nbsp;');
	$form->AddHidden ('file', 'none');
	$form->SetEndCol ();
	$options = array ();
	$options['autoPreviewTutorial'] = _TUTADMIN_ADMINPREWIEWAGAIN;
	$options['autoSaveTutorial'] = _TUTADMIN_ADMINSAVEAUTOTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'autoPreviewTutorial');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($txt);
	return ($txt);

}

function autoSaveTutorial () {

	global $alltheboxtxt, $opnConfig, $opnTables;

	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = make_user_images ($hometext);
		$bodytext = make_user_images ($bodytext);
	}
	if ($day<10) {
		$day = "0$day";
	}
	$sec = '00';
	$opnConfig['opndate']->setTimestamp ("$year-$month-$day $hour:$min:$sec");
	$date = '';
	$opnConfig['opndate']->opnDataTosql ($date);
	$ubb = & new UBBCode;
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$hometext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($hometext, true, true), 'hometext');
	$bodytext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($bodytext, true, true), 'bodytext');
	$notes = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($notes, true, true), 'notes');
	$anid = $opnConfig['opnSQL']->get_new_number ('tutorial_autotutorials', 'anid');
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	if ($myoptions['_tut_op_use_head'] == '*empty*') {
		$myoptions['_tut_op_use_head'] = '';
	}
	if ($myoptions['_tut_op_use_foot'] == '*empty*') {
		$myoptions['_tut_op_use_foot'] = '';
	}
	if (!isset ($myoptions['_tut_op_use_lang']) ) {
		$tut_lang = '0';
	} else {
		$tut_lang = $myoptions['_tut_op_use_lang'];
	}
	if (!isset ($myoptions['_tut_op_use_user_group']) ) {
		$tut_user_group = 0;
	} else {
		$tut_user_group = $myoptions['_tut_op_use_user_group'];
	}
	if (!isset ($myoptions['_tut_op_use_theme_group']) ) {
		$tut_theme_group = 0;
	} else {
		$tut_theme_group = $myoptions['_tut_op_use_theme_group'];
	}
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$_tut_lang = $opnConfig['opnSQL']->qstr ($tut_lang);
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$_file = $opnConfig['opnSQL']->qstr ($file);
	$options = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($myoptions) ), 'options');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_autotutorials'] . " VALUES ($anid, $catid, $_author, $subject, $date, $hometext, $bodytext, $topicid, $_author, $notes, $ihome, $_file, $options, $_tut_lang, $tut_user_group,$tut_theme_group,$acomm)");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$alltheboxtxt .= $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />';
		exit ();
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_autotutorials'], 'anid=' . $anid);

}

function QautoTutorial () {

	global $alltheboxtxt, $opnConfig, $opnTables;

	$alltheboxtxt .= waitingautoTutorial ();
	$qid = 0;
	get_var ('qid', $qid, 'url', _OOBJ_DTYPE_INT);
	$result = &$opnConfig['database']->Execute ('SELECT qid, uid, uname, subject, tutorial, topic, userfile, options FROM ' . $opnTables['tutorial_queue'] . " WHERE qid=$qid");
	if ($result !== false) {
		if ($result->fields !== false) {
			$qid = $result->fields['qid'];
			$uid = $result->fields['uid'];
			$uname = $result->fields['uname'];
			$subject = $result->fields['subject'];
			$hometext = $result->fields['tutorial'];
			$topicid = $result->fields['topic'];
			$file = $result->fields['userfile'];
			$myoptions = unserialize ($result->fields['options']);
		}
		$result->Close ();
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = de_make_user_images ($hometext);
	}
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$ubb->ubbencode ($hometext);

	#	$ubb->ubbencode($bodytext);

	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$ubb->ubbdecode ($hometext);

	#	$ubb->ubbdecode($bodytext);

	$opnConfig['opndate']->now ();
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_170_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $uname, $subject, $topicid, 0, 0);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext);
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1, '', '', '', '', '', 'AUTO');
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('file', $file);
	$form->AddHidden ('uid', $uid);
	$form->SetEndCol ();
	$options = array ();
	$options['DeleteTutorial'] = _TUTADMIN_ADMINDELETETUTORIAL;
	$options['QautoPreview'] = _TUTADMIN_ADMINPREWIEWAGAIN;
	$options['QautoSave'] = _TUTADMIN_ADMINPOSTTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'QautoPreview');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($alltheboxtxt);

}

function QautoPreview () {

	global $alltheboxtxt, $opnConfig;

	$alltheboxtxt .= waitingautoTutorial ();
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = '';
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_CHECK);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$bodytext = $opnConfig['cleantext']->FixQuotes ($bodytext);
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$bodytext = $opnConfig['cleantext']->filter_text ($bodytext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$bodytext4pre = $opnConfig['cleantext']->makeClickable ($bodytext);
	$ubb->ubbdecode ($hometext);
	$ubb->ubbdecode ($bodytext);
	$notes4form = $opnConfig['cleantext']->FixQuotes ($notes);
	$notes4form = $opnConfig['cleantext']->filter_text ($notes4form, true, true);
	$notes4pre = $opnConfig['cleantext']->makeClickable ($notes4form);
	opn_nl2br ($notes4pre);
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	$opnConfig['opndate']->now ();
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_180_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre, $bodytext4pre, $notes4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $author, $subject, $topicid, $catid, $ihome, $acomm);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext, $bodytext, $notes4form);
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1, $year, $month, $day, $hour, $min, 'AUTO');
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('qid', $qid);
	$form->AddHidden ('file', $file);
	$form->AddHidden ('uid', $uid);
	$form->SetEndCol ();
	$options = array ();
	$options['DeleteTutorial'] = _TUTADMIN_ADMINDELETETUTORIAL;
	$options['QautoPreview'] = _TUTADMIN_ADMINPREWIEWAGAIN;
	$options['QautoSave'] = _TUTADMIN_ADMINPOSTTUTORIAL;
	$form->SetSameCol ();
	$form->AddSelect ('op', $options, 'QautoPreview');
	$form->AddSubmit ('submit', _TUTADMIN_ADMINOK);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($alltheboxtxt);

}

function QautoSave () {

	global $alltheboxtxt, $opnConfig, $opnTables;

	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$qid = 0;
	get_var ('qid', $qid, 'form', _OOBJ_DTYPE_INT);
	$uid = 0;
	get_var ('uid', $uid, 'form', _OOBJ_DTYPE_INT);
	$author = '';
	get_var ('author', $author, 'form', _OOBJ_DTYPE_CLEAN);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	$myuser = $opnConfig['permission']->GetUserinfo ();
	$aid = $myuser['uname'];
	if ($day<10) {
		$day = "0$day";
	}
	if ($month<10) {
		$month = "0$month";
	}
	$opnConfig['opndate']->setTimestamp ("$year-$month-$day $hour:$min:00");
	$date = '';
	$opnConfig['opndate']->opnDataTosql ($date);
	if ($uid == 1) {
		$author = '';
	}
	if ($hometext == $bodytext) {
		$bodytext = '';
	}
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = make_user_images ($hometext);
		$bodytext = make_user_images ($bodytext);
		$notes = make_user_images ($notes);
	}
	$ubb = & new UBBCode;
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$hometext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($hometext, true, true), 'hometext');
	$bodytext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($bodytext, true, true), 'bodytext');
	$notes = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($notes, true, true), 'notes');
	$notes = $opnConfig['cleantext']->filter_text ($notes, true, true);
	$anid = $opnConfig['opnSQL']->get_new_number ('tutorial_autotutorials', 'anid');
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	if ($myoptions['_tut_op_use_head'] == '*empty*') {
		$myoptions['_tut_op_use_head'] = '';
	}
	if ($myoptions['_tut_op_use_foot'] == '*empty*') {
		$myoptions['_tut_op_use_foot'] = '';
	}
	if (!isset ($myoptions['_tut_op_use_lang']) ) {
		$tut_lang = '0';
	} else {
		$tut_lang = $myoptions['_tut_op_use_lang'];
	}
	if (!isset ($myoptions['_tut_op_use_user_group']) ) {
		$tut_user_group = 0;
	} else {
		$tut_user_group = $myoptions['_tut_op_use_user_group'];
	}
	if (!isset ($myoptions['_tut_op_use_theme_group']) ) {
		$tut_theme_group = 0;
	} else {
		$tut_theme_group = $myoptions['_tut_op_use_theme_group'];
	}
	$_file = $opnConfig['opnSQL']->qstr ($file);
	$_tut_lang = $opnConfig['opnSQL']->qstr ($tut_lang);
	$_aid = $opnConfig['opnSQL']->qstr ($aid);
	$_author = $opnConfig['opnSQL']->qstr ($author);
	$options = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($myoptions) ), 'options');
	$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tutorial_autotutorials'] . " VALUES ($anid, $catid, $_aid, $subject, $date, $hometext, $bodytext, $topicid, $_author, $notes, $ihome, $_file, $options, $_tut_lang, $tut_user_group,$tut_theme_group,$acomm)");
	if ($opnConfig['database']->ErrorNo ()>0) {
		$alltheboxtxt .= $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />';
		return;
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_autotutorials'], 'anid=' . $anid);
	if ($uid != 1) {
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['users'] . " SET counter=counter+1 WHERE uid=$uid");
	}
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_queue'] . ' WHERE qid=' . $qid);
	$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/submissionsadmin.php?op=submissions', false) );
	CloseTheOpnDB ($opnConfig);

}

function autoDelete () {

	global $opnTables, $opnConfig;

	$anid = 0;
	get_var ('anid', $anid, 'url', _OOBJ_DTYPE_INT);
	$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['tutorial_autotutorials'] . ' WHERE anid=' . $anid);

}

function autoEdit () {

	global $alltheboxtxt, $opnConfig, $opnTables;

	$anid = 0;
	get_var ('anid', $anid, 'url', _OOBJ_DTYPE_INT);
	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$result = &$opnConfig['database']->Execute ('SELECT catid, title, wtime, hometext, bodytext, topic, informant, notes, ihome, userfile, options,acomm FROM ' . $opnTables['tutorial_autotutorials'] . ' WHERE anid=' . $anid);
	$catid = $result->fields['catid'];
	$subject = $result->fields['title'];
	$opnConfig['opndate']->sqlToopnData ($result->fields['wtime']);
	$time = '';
	$opnConfig['opndate']->formatTimestamp ($time);
	$hometext = $result->fields['hometext'];
	$bodytext = $result->fields['bodytext'];
	$topicid = $result->fields['topic'];
	$informant = $result->fields['informant'];
	$notes = $result->fields['notes'];
	$ihome = $result->fields['ihome'];
	$file = $result->fields['userfile'];
	$acomm = $result->fields['acomm'];
	if (!is_null ($result->fields['options']) ) {
		$myoptions = unserialize ($result->fields['options']);
	} else {
		$myoptions = '';
	}
	$datetime = '';
	preg_match ('/([0-9]{4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})/', $time, $datetime);
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = de_make_user_images ($hometext);
		$bodytext = de_make_user_images ($bodytext);
		$notes = de_make_user_images ($notes);
	}
	$ubb = & new UBBCode;
	$subject = $opnConfig['cleantext']->FixQuotes ($subject);
	$hometext = $opnConfig['cleantext']->FixQuotes ($hometext);
	$bodytext = $opnConfig['cleantext']->FixQuotes ($bodytext);
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml');
	$hometext = $opnConfig['cleantext']->filter_text ($hometext, true, true);
	$bodytext = $opnConfig['cleantext']->filter_text ($bodytext, true, true);
	$subject4pre = $opnConfig['cleantext']->makeClickable ($subject);
	$hometext4pre = $opnConfig['cleantext']->makeClickable ($hometext);
	$bodytext4pre = $opnConfig['cleantext']->makeClickable ($bodytext);
	$ubb->ubbdecode ($hometext);
	$ubb->ubbdecode ($bodytext);
	$time = $opnConfig['opndate']->now ();
	$alltheboxtxt .= '<div class="extratextbold" align="center">' . _TUTADMIN_ADMINEDITAUTOMATEDTUTORIAL . '</div><br /><br /><br />';
	$form = & new opn_FormularClass ('listalternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_TUTORIAL_190_', 'tutorial');
	$form->Init ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php', 'post', 'coolsus');
	$notes4edit = $opnConfig['cleantext']->FixQuotes ($notes);
	$notes4show = $opnConfig['cleantext']->makeClickable ($notes4edit);
	opn_nl2br ($notes4show);
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText (_TUT_ADMINPREVIEWWINDOW);
	TutorialPreviewPart ($form, $topicid, $file, $subject4pre, $hometext4pre, $bodytext4pre);
	$form->AddChangeRow ();
	TutorialInputHeaderPart ($form, $informant, $subject, $topicid, $catid, $ihome, $acomm);
	$form->AddChangeRow ();
	TutorialInputContentPart ($form, $hometext, $bodytext, $notes4edit);
	$day = $datetime[3];
	$month = $datetime[2];
	$year = $datetime[1];
	$hour = $datetime[4];
	$min = $datetime[5];
	$form->AddChangeRow ();
	TutorialInputDelPart ($form, -1, $year, $month, $day, $hour, $min . 'AUTO');
	$form->AddChangeRow ();
	TutorialInputFooterPart ($myoptions, $form);
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden ('anid', $anid);
	$form->AddHidden ('file', $file);
	$form->AddHidden ('op', 'autoSaveEdit');
	$form->SetEndCol ();
	$form->AddSubmit ('submit', _TUTADMIN_ADMINSAVE);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($alltheboxtxt);

}

function autoSaveEdit () {

	global $opnConfig, $opnTables;

	$anid = 0;
	get_var ('anid', $anid, 'form', _OOBJ_DTYPE_INT);
	$year = 0;
	get_var ('year', $year, 'form', _OOBJ_DTYPE_INT);
	$day = 0;
	get_var ('day', $day, 'form', _OOBJ_DTYPE_INT);
	$month = 0;
	get_var ('month', $month, 'form', _OOBJ_DTYPE_INT);
	$hour = 0;
	get_var ('hour', $hour, 'form', _OOBJ_DTYPE_INT);
	$min = 0;
	get_var ('min', $min, 'form', _OOBJ_DTYPE_INT);
	$subject = '';
	get_var ('subject', $subject, 'form', _OOBJ_DTYPE_CHECK);
	$hometext = '';
	get_var ('hometext', $hometext, 'form', _OOBJ_DTYPE_CHECK);
	$bodytext = '';
	get_var ('bodytext', $bodytext, 'form', _OOBJ_DTYPE_CHECK);
	$topicid = 0;
	get_var ('topicid', $topicid, 'form', _OOBJ_DTYPE_INT);
	$notes = '';
	get_var ('notes', $notes, 'form', _OOBJ_DTYPE_CHECK);
	$catid = 0;
	get_var ('catid', $catid, 'form', _OOBJ_DTYPE_INT);
	$ihome = 0;
	get_var ('ihome', $ihome, 'form', _OOBJ_DTYPE_INT);
	$acomm = 0;
	get_var ('acomm', $acomm, 'form', _OOBJ_DTYPE_INT);
	$file = '';
	get_var ('file', $file, 'form', _OOBJ_DTYPE_CLEAN);
	if ($day<10) {
		$day = '0' . $day;
	}
	if ($month<10) {
		$month = '0' . $month;
	}
	$sec = '00';
	$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min . ':' . $sec);
	$date = '';
	$opnConfig['opndate']->opnDataTosql ($date);
	if ($opnConfig['installedPlugins']->isplugininstalled ('system/user_images') ) {
		include (_OPN_ROOT_PATH . 'system/user_images/user_images.php');
		$hometext = make_user_images ($hometext);
		$bodytext = make_user_images ($bodytext);
		$notes = make_user_images ($notes);
	}
	$ubb = & new UBBCode;
	$ubb->ubbencode ($hometext);
	$ubb->ubbencode ($bodytext);
	$subject = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($subject, true, true, 'nohtml') );
	$hometext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($hometext, true, true), 'hometext');
	$bodytext = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($bodytext, true, true), 'bodytext');
	$notes = $opnConfig['opnSQL']->qstr ($opnConfig['cleantext']->filter_text ($notes, true, true), 'notes');
	$myoptions = array ();
	get_var ('_tut_op_', $myoptions,'form','',true);
	if ($myoptions['_tut_op_use_head'] == '*empty*') {
		$myoptions['_tut_op_use_head'] = '';
	}
	if ($myoptions['_tut_op_use_foot'] == '*empty*') {
		$myoptions['_tut_op_use_foot'] = '';
	}
	if (!isset ($myoptions['_tut_op_use_lang']) ) {
		$tut_lang = '0';
	} else {
		$tut_lang = $myoptions['_tut_op_use_lang'];
	}
	if (!isset ($myoptions['_tut_op_use_user_group']) ) {
		$tut_user_group = 0;
	} else {
		$tut_user_group = $myoptions['_tut_op_use_user_group'];
	}
	if (!isset ($myoptions['_tut_op_use_theme_group']) ) {
		$tut_theme_group = 0;
	} else {
		$tut_theme_group = $myoptions['_tut_op_use_theme_group'];
	}
	$_tut_lang = $opnConfig['opnSQL']->qstr ($tut_lang);
	$_file = $opnConfig['opnSQL']->qstr ($file);
	$options = $opnConfig['opnSQL']->qstr (serialize ($myoptions), 'options');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['tutorial_autotutorials'] . " SET hometext=$hometext,bodytext=$bodytext,notes=$notes,options=$options,tut_lang=$_tut_lang, tut_user_group=$tut_user_group, tut_theme_group=$tut_theme_group, catid=$catid, title=$subject, wtime=$date, topic=$topicid, ihome=$ihome, userfile=$_file, acomm=$acomm WHERE anid=$anid");
	if ($opnConfig['database']->ErrorNo ()>0) {
		return $opnConfig['database']->ErrorNo () . ': ' . $opnConfig['database']->ErrorMsg () . '<br />';
	}
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['tutorial_autotutorials'], 'anid=' . $anid);
	return '';

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$mover = '';
get_var ('mover', $mover, 'both', _OOBJ_DTYPE_CLEAN);
if ($mover != '') {
	$op = 'movetutorial';
}
$alltheboxtxt = '';
switch ($op) {
	default:
		$alltheboxtxt .= tutorialConfigMain ();
		break;
	case 'movetutorial':
		$alltheboxtxt .= MoveTutorial ();
		break;
	case 'domovetutorial':
		DoMoveTutorial ();
		break;
	case 'DisplayTutorial':
		$alltheboxtxt .= displayTutorial ();
		break;
	case 'PreviewAgain':
		$alltheboxtxt .= previewTutorial ();
		break;
	case 'PostTutorial':
		postTutorial ();
		break;
	case 'EditTutorial':
		$alltheboxtxt .= editTutorial ();
		break;
	case 'RemoveTutorial':
		$txt = removeTutorial ();
		if ($txt == '') {
			$alltheboxtxt .= tutorialConfigMain ();
		} else {
			$alltheboxtxt .= $txt;
		}
		break;
	case 'ChangeTutorial':
		changeTutorial ();
		$alltheboxtxt .= tutorialConfigMain ();
		break;
	case 'ChangeTimeTutorial':
		$sid = 0;
		get_var ('sid', $sid, 'url', _OOBJ_DTYPE_INT);
		$opnConfig['opndate']->now ();
		$now = '';
		$opnConfig['opndate']->opnDataTosql ($now);
		$opnConfig['database']->Execute ('UPDATE ' . $opnTables['tutorial_stories'] . " SET wtime=$now WHERE sid=$sid");
		$alltheboxtxt .= tutorialConfigMain ();
		break;
	case 'DeleteTutorial':
		deleteTutorial ();
		break;
	case 'adminTutorial':
		$alltheboxtxt .= adminTutorial ();
		break;
	case 'PreviewAdminTutorial':
		previewAdminTutorial ();
		break;
	case 'PostAdminTutorial':
		$alltheboxtxt .= postAdminTutorial ();
		$alltheboxtxt .= tutorialConfigMain ();
		break;
	case 'QautoPreview':
		QautoPreview ();
		break;
	case 'QautoTutorial':
		QautoTutorial ();
		break;
	case 'QautoSave':
		QautoSave ();
		break;
	case 'autoTutorial':
		autoTutorial ();
		break;
	case 'autoSaveTutorial':
		autoSaveTutorial ();
		autoTutorial ();
		break;
	case 'autoPreviewTutorial':
		$alltheboxtxt .= autoPreviewTutorial ();
		break;
	case 'autoEdit':
		autoEdit ();
		break;
	case 'autoDelete':
		autodelete ();
		autoTutorial ();
		break;
	case 'autoSaveEdit':
		$alltheboxtxt .= autoSaveEdit ();
		autoTutorial ();
		break;
}
$opnConfig['opnOutput']->EnableJavaScript ();
$opnConfig['opnOutput']->DisplayHead ();
$alltheboxtxt = tutorialConfigHeader () . $alltheboxtxt;
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_TUTORIAL_200_';
$_display_dat['module'] = 'modules/tutorial';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox (_TUTADMIN_ADMINTUTORIALCONFIGURATION, $alltheboxtxt, '');
$opnConfig['opnOutput']->DisplayFoot ();

?>