<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['permission']->HasRights ('modules/tutorial', array (_PERM_SETTING, _PERM_ADMIN) );
$opnConfig['module']->InitModule ('modules/tutorial', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
$pubsettings = $opnConfig['module']->GetPublicSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'modules/tutorial/admin/language/');

function tutorial_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_TUTADMIN_NAVGENERAL] = _TUTADMIN_NAVGENERAL;
	$nav[_TUTADMIN_NAVMAIL] = _TUTADMIN_NAVMAIL;
	$nav[_TUTADMIN_NAVCOMMENTS] = _TUTADMIN_NAVCOMMENTS;
	$nav[_TUTADMIN_NAVMDERATION] = _TUTADMIN_NAVMDERATION;
	$nav[_INPUT_BLANKLINE] = _INPUT_BLANKLINE;
	$nav[_TUTADMIN_SAVE] = _TUTADMIN_SAVE;
	$nav[_TUTADMIN_ADMIN] = _TUTADMIN_ADMIN;
	$nav[$wichSave] = '';
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav,
			'rt' => 5);
	return $values;

}

function tutorialsettings () {

	global $opnConfig, $privsettings, $pubsettings;

	$set = & new MySettings;
	$set->SetModule ('modules/tutorial');
	$set->SetHelpID ('_OPNDOCID_MODULES_TUTORIAL_TUTORIALSETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TUTADMIN_GENERAL);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_TOPICPATH,
			'name' => 'topicpath',
			'value' => $opnConfig['datasave']['tut_topic_path']['url'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_NUMADMIN,
			'name' => 'admart',
			'value' => $pubsettings['admart'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_NUMHOME,
			'name' => 'tutorialhome',
			'value' => $pubsettings['tutorialhome'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_NUMOLD,
			'name' => 'oldnum',
			'value' => $pubsettings['oldnum'],
			'size' => 3,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TUTADMIN_HIDEICONS,
			'name' => 'tut_hideicons',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['tut_hideicons'] == 1?true : false),
			 ($pubsettings['tut_hideicons'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TUTADMIN_SHOWCOMMENTDATE,
			'name' => 'tut_showcommentdate',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['tut_showcommentdate'] == 1?true : false),
			 ($pubsettings['tut_showcommentdate'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TUTADMIN_SHOWTOPICNAMEWHENIMAGE,
			'name' => 'tut_showtopicnamewhenimage',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['tut_showtopicnamewhenimage'] == 1?true : false),
			 ($pubsettings['tut_showtopicnamewhenimage'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TUTADMIN_SHOWTOPICDESCRIPTION,
			'name' => 'tut_showtopicdescription',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['tut_showtopicdescription'] == 1?true : false),
			 ($pubsettings['tut_showtopicdescription'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TUTADMIN_USESHORTHEADERINDETAILEDVIEW,
			'name' => 'tut_useshortheaderindetailedview',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['tut_useshortheaderindetailedview'] == 1?true : false),
			 ($privsettings['tut_useshortheaderindetailedview'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TUTADMIN_SHOWARTICLEIMAGEBEFORETEXT,
			'name' => 'tut_showarticleimagebeforetext',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['tut_showarticleimagebeforetext'] == 1?true : false),
			 ($pubsettings['tut_showarticleimagebeforetext'] == 0?true : false) ) );
	$options_file = array ();
	$themelist = get_file_list (_OPN_ROOT_PATH . 'themes' . '/' . $opnConfig['Default_Theme'] . '/tpl/tutorial/', array ('opnliste-') );
	$options_file['&nbsp;'] = '*empty*';
	if (count ($themelist) ) {
		usort ($themelist, 'strnatcasecmp');
		$max = sizeof ($themelist);
		for ($i = 0; $i< $max; $i++) {
			$options_file[$themelist[$i]] = $themelist[$i];
		}
	}
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _TUTADMIN_OP_USE_HEAD_ORG,
			'name' => '_op_tut_use_head_org',
			'options' => $options_file,
			'selected' => $privsettings['_op_tut_use_head_org']);
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _TUTADMIN_OP_USE_FOOT_ORG,
			'name' => '_op_tut_use_foot_org',
			'options' => $options_file,
			'selected' => $privsettings['_op_tut_use_foot_org']);
	$values = array_merge ($values, tutorial_allhiddens (_TUTADMIN_NAVGENERAL) );
	$set->GetTheForm (_TUTADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/tutorial/admin/settings.php', $values);

}

function mailsettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$set->SetModule ('modules/tutorial');
	$set->SetHelpID ('_OPNDOCID_MODULES_TUTORIAL_MAILSETTINGS_');
	$set->UseEditor (false);
	$set->UseWysiwyg (false);
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TUTADMIN_MAIL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TUTADMIN_SUBMISSIONNOTIFY,
			'name' => 'notify',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($privsettings['notify'] == 1?true : false),
			 ($privsettings['notify'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_EMAIL,
			'name' => 'notify_email',
			'value' => $privsettings['notify_email'],
			'size' => 30,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_EMAILSUBJECT,
			'name' => 'notify_subject',
			'value' => $privsettings['notify_subject'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXTAREA,
			'display' => _TUTADMIN_MESSAGE,
			'name' => 'notify_message',
			'value' => $privsettings['notify_message'],
			'wrap' => '',
			'cols' => 40,
			'rows' => 8);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_MAILACCOUNT,
			'name' => 'tut_notify_from',
			'value' => $privsettings['tut_notify_from'],
			'size' => 15,
			'maxlength' => 25);
	$values = array_merge ($values, tutorial_allhiddens (_TUTADMIN_NAVMAIL) );
	$set->GetTheForm (_TUTADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/tutorial/admin/settings.php', $values);

}

function commentsettings () {

	global $opnConfig, $pubsettings, $privsettings;

	$set = & new MySettings;
	$set->SetModule ('modules/tutorial');
	$set->SetHelpID ('_OPNDOCID_MODULES_TUTORIAL_COMMENTSETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TUTADMIN_COMMENTS);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_COMMENTLIMIT,
			'name' => 'commentlimit',
			'value' => $pubsettings['commentlimit'],
			'size' => 11,
			'maxlength' => 10);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_ANONNAME,
			'name' => 'anonymous',
			'value' => $pubsettings['anonymous'],
			'size' => 15,
			'maxlength' => 25);
	if ($opnConfig['opn_activate_email'] == 1) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => _TUTADMIN_COMMENTMAIL,
				'name' => 'opn_new_comment_tutorial_notify',
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($privsettings['opn_new_comment_tutorial_notify'] == 1?true : false),
				 ($privsettings['opn_new_comment_tutorial_notify'] == 0?true : false) ) );
	} else {
		$values[] = array ('type' => _INPUT_HIDDEN,
				'name' => 'opn_new_comment_tutorial_notify',
				'value' => 0);
	}
	$values = array_merge ($values, tutorial_allhiddens (_TUTADMIN_NAVCOMMENTS) );
	$set->GetTheForm (_TUTADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/tutorial/admin/settings.php', $values);

}

function moderatesettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$set->SetModule ('modules/tutorial');
	$set->SetHelpID ('_OPNDOCID_MODULES_TUTORIAL_MODERATESETTINGS_');
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TUTADMIN_MODERATION);
	$options[_TUTADMIN_NOMODERATION] = 0;
	$options[_TUTADMIN_ADMINMODERATION] = 1;
	$options[_TUTADMIN_USERMODERATION] = 2;
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _TUTADMIN_MODERATIONTYPE,
			'name' => 'moderate',
			'options' => $options,
			'selected' => $pubsettings['moderate']);
	if (isset ($pubsettings['reasons']) ) {
		for ($i = 0; $i<count ($pubsettings['reasons']); $i++) {
			$values[] = array ('type' => _INPUT_TEXT,
					'display' => _TUTADMIN_REASON,
					'name' => 'reason' . $i,
					'value' => $pubsettings['reasons'][$i],
					'size' => 15,
					'maxlength' => 25);
		}
	}
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _TUTADMIN_BADREASON,
			'name' => 'badreasons',
			'value' => $pubsettings['badreasons'],
			'size' => 4,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _TUTADMIN_ADDREASON);
	$values = array_merge ($values, tutorial_allhiddens (_TUTADMIN_NAVMDERATION) );
	$set->GetTheForm (_TUTADMIN_SETTINGS, $opnConfig['opn_url'] . '/modules/tutorial/admin/settings.php', $values);

}

function tutorial_dosavesettings () {

	global $opnConfig, $privsettings, $pubsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePrivateSettings ();
	$opnConfig['module']->SavePublicsettings ();

}

function tutorial_dosavetutorial ($vars) {

	global $privsettings, $pubsettings;

	$pubsettings['topicpath'] = $vars['topicpath'];
	$pubsettings['admart'] = $vars['admart'];
	$pubsettings['oldnum'] = $vars['oldnum'];
	$pubsettings['tutorialhome'] = $vars['tutorialhome'];
	$pubsettings['tut_hideicons'] = $vars['tut_hideicons'];
	$pubsettings['tut_showcommentdate'] = $vars['tut_showcommentdate'];
	$pubsettings['tut_showtopicnamewhenimage'] = $vars['tut_showtopicnamewhenimage'];
	$pubsettings['tut_showtopicdescription'] = $vars['tut_showtopicdescription'];
	$pubsettings['tut_showarticleimagebeforetext'] = $vars['tut_showarticleimagebeforetext'];
	if ($vars['_op_tut_use_head_org'] == '*empty*') {
		$vars['_op_tut_use_head_org'] = '';
	}
	if ($vars['_op_tut_use_foot_org'] == '*empty*') {
		$vars['_op_tut_use_foot_org'] = '';
	}
	$privsettings['tut_useshortheaderindetailedview'] = $vars['tut_useshortheaderindetailedview'];
	$privsettings['_op_tut_use_head_org'] = $vars['_op_tut_use_head_org'];
	$privsettings['_op_tut_use_foot_org'] = $vars['_op_tut_use_foot_org'];
	tutorial_dosavesettings ();

}

function tutorial_dosavemail ($vars) {

	global $privsettings;

	$privsettings['notify'] = $vars['notify'];
	$privsettings['notify_email'] = $vars['notify_email'];
	$privsettings['notify_subject'] = $vars['notify_subject'];
	$privsettings['notify_message'] = $vars['notify_message'];
	$privsettings['tut_notify_from'] = $vars['tut_notify_from'];
	tutorial_dosavesettings ();

}

function tutorial_dosavecomment ($vars) {

	global $privsettings, $pubsettings;

	$pubsettings['commentlimit'] = $vars['commentlimit'];
	$pubsettings['anonymous'] = $vars['anonymous'];
	$privsettings['opn_new_comment_tutorial_notify'] = $vars['opn_new_comment_tutorial_notify'];
	tutorial_dosavesettings ();

}

function tutorial_dosavemoderate ($vars) {

	global $pubsettings;

	$pubsettings['moderate'] = $vars['moderate'];
	if (isset ($pubsettings['reasons']) ) {
		for ($i = 0; $i<count ($pubsettings['reasons']); $i++) {
			$pubsettings['reasons'][$i] = $vars['reason' . $i];
		}
	}
	$pubsettings['badreasons'] = $vars['badreasons'];
	tutorial_dosavesettings ();

}

function tutorial_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _TUTADMIN_NAVGENERAL:
			tutorial_dosavetutorial ($returns);
			break;
		case _TUTADMIN_NAVMAIL:
			tutorial_dosavemail ($returns);
			break;
		case _TUTADMIN_NAVCOMMENTS:
			tutorial_dosavecomment ($returns);
			break;
		case _TUTADMIN_NAVMDERATION:
			tutorial_dosavemoderate ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		tutorial_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _TUTADMIN_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/modules/tutorial/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _TUTADMIN_ADMIN:
		$opnConfig['opnOutput']->Redirect (encodeurl ($opnConfig['opn_url'] . '/modules/tutorial/admin/index.php') );
		CloseTheOpnDB ($opnConfig);
		break;
	case _TUTADMIN_ADDREASON:
		$pubsettings['reasons'][count ($pubsettings['reasons'])] = 'New';
		tutorial_dosavesettings ();
		moderatesettings ();
		break;
	case _TUTADMIN_NAVMAIL:
		mailsettings ();
		break;
	case _TUTADMIN_NAVCOMMENTS:
		commentsettings ();
		break;
	case _TUTADMIN_NAVMDERATION:
		moderatesettings ();
		break;
	default:
		tutorialsettings ();
		break;
}

?>