<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'modules/tutorial/plugin/middlebox/recenttutorials/language/');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');

function send_middlebox_edit (&$box_array_dat) {

	global $opnTables, $opnConfig, $opnTheme;

	$mf = & new MyFunctions;
	$mf->table = $opnTables['tutorial_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	if (!isset ($box_array_dat['box_options']['title']) ) {
		$box_array_dat['box_options']['title'] = _RECENTTUTORIALS_MID_TITLE;
		// default title
	}
	if (!isset ($box_array_dat['box_options']['limit']) ) {
		$box_array_dat['box_options']['limit'] = 5;
	}
	if (!isset ($box_array_dat['box_options']['startatpos']) ) {
		$box_array_dat['box_options']['startatpos'] = '0';
	}
	if (!isset ($box_array_dat['box_options']['mode']) ) {
		$box_array_dat['box_options']['mode'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['use_this_themegroup']) ) {
		$box_array_dat['box_options']['use_this_themegroup'] = -2;
	}
	if (!isset ($box_array_dat['box_options']['topicid']) ) {
		$box_array_dat['box_options']['topicid'] = '';
	}
	if (!isset ($box_array_dat['box_options']['strlength']) ) {
		$box_array_dat['box_options']['strlength'] = 22;
	}
	if (!isset ($box_array_dat['box_options']['use_tpl']) ) {
		$box_array_dat['box_options']['use_tpl'] = '';
	}
	if (!isset ($box_array_dat['box_options']['dothetitle']) ) {
		$box_array_dat['box_options']['dothetitle'] = 1;
	}
	if (!isset ($box_array_dat['box_options']['dothetitle_max']) ) {
		$box_array_dat['box_options']['dothetitle_max'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['dothebody']) ) {
		$box_array_dat['box_options']['dothebody'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['dothebody_max']) ) {
		$box_array_dat['box_options']['dothebody_max'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['dothefooter']) ) {
		$box_array_dat['box_options']['dothefooter'] = 1;
	}
	if (!isset ($box_array_dat['box_options']['dothefooter_max']) ) {
		$box_array_dat['box_options']['dothefooter_max'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['showtopic']) ) {
		$box_array_dat['box_options']['showtopic'] = 1;
	}
	if (!isset ($box_array_dat['box_options']['showfulllink']) ) {
		$box_array_dat['box_options']['showfulllink'] = 1;
	}
	$box_array_dat['box_form']->AddOpenRow ();
	$box_array_dat['box_form']->AddLabel ('limit', _RECENTTUTORIALS_MID_LIMIT);
	$box_array_dat['box_form']->AddTextfield ('limit', 10, 10, $box_array_dat['box_options']['limit']);
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddLabel ('startatpos', _RECENTTUTORIALS_MID_STARTATPOS);
	$box_array_dat['box_form']->AddTextfield ('startatpos', 10, 10, $box_array_dat['box_options']['startatpos']);
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddLabel ('topicid', _RECENTTUTORIALS_MID_TOPIC);
	$mf->makeMySelBox ($box_array_dat['box_options']['topicid'], $box_array_dat['box_form'], 1);
	$options = array ();
	$options[-2] = 'Ignore';
	$options[-1] = 'From User';
	$groups = $opnConfig['theme_groups'];
	foreach ($groups as $group) {
		$options[$group['theme_group_id']] = $group['theme_group_text'];
	}
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddLabel ('use_this_themegroup', _RECENTTUTORIALS_MID_USETHEMEGROUP);
	$box_array_dat['box_form']->AddSelect ('use_this_themegroup', $options, $box_array_dat['box_options']['use_this_themegroup']);
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddLabel ('strlength', _RECENTTUTORIALS_MID_STRLENGTH);
	$box_array_dat['box_form']->AddTextfield ('strlength', 10, 10, $box_array_dat['box_options']['strlength']);
	$options = array ();
	if ($opnConfig['_THEME_HAVE_opnliste'] == 0) {
		GetFileChooseOption ($options, _OPN_ROOT_PATH . 'themes/opn_themes_include/tpl/', 'opnliste-');
	} else {
		GetFileChooseOption ($options, _OPN_ROOT_PATH . 'themes/' . $opnTheme['thename'] . '/tpl/', 'opnliste-');
	}
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddLabel ('use_tpl', _MID_USETPL . ':');
	$box_array_dat['box_form']->AddSelect ('use_tpl', $options, $box_array_dat['box_options']['use_tpl']);
	$box_array_dat['box_form']->AddChangeRow ();
	$options = array ();
	$options[0] = _RECENTTUTORIALS_MID_MODE_TITLE;
	$options[1] = _RECENTTUTORIALS_MID_MODE_FULL;
	$options[2] = _RECENTTUTORIALS_MID_MODE_FULL_CENTER;
	$box_array_dat['box_form']->AddLabel ('mode', _RECENTTUTORIALS_MID_MODE);
	$box_array_dat['box_form']->AddSelect ('mode', $options, $box_array_dat['box_options']['mode']);
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_RECENTTUTORIALS_MID_TITLE_SHOW);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('dothetitle', 1, ($box_array_dat['box_options']['dothetitle'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothetitle', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('dothetitle', 0, ($box_array_dat['box_options']['dothetitle'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothetitle', _NO, 1);
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddLabel ('dothetitle_max', _RECENTTUTORIALS_MID_STRLENGTH_TITLE);
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddTextfield ('dothetitle_max', 10, 10, $box_array_dat['box_options']['dothetitle_max']);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_RECENTTUTORIALS_MID_BODY);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('dothebody', 1, ($box_array_dat['box_options']['dothebody'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothebody', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('dothebody', 0, ($box_array_dat['box_options']['dothebody'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothebody', _NO, 1);
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddLabel ('dothebody_max', _RECENTTUTORIALS_MID_STRLENGTH_BODY);
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddTextfield ('dothebody_max', 10, 10, $box_array_dat['box_options']['dothebody_max']);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_RECENTTUTORIALS_MID_FOOTER);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('dothefooter', 1, ($box_array_dat['box_options']['dothefooter'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothefooter', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('dothefooter', 0, ($box_array_dat['box_options']['dothefooter'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothefooter', _NO, 1);
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddLabel ('dothefooter_max', _RECENTTUTORIALS_MID_STRLENGTH_FOOTER);
	$box_array_dat['box_form']->AddText ('<br />');
	$box_array_dat['box_form']->AddTextfield ('dothefooter_max', 10, 10, $box_array_dat['box_options']['dothefooter_max']);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_RECENTTUTORIALS_MID_SHOWTOPIC);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('showtopic', 1, ($box_array_dat['box_options']['showtopic'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('showtopic', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('showtopic', 0, ($box_array_dat['box_options']['showtopic'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('showtopic', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_RECENTTUTORIALS_MID_SHOWFULLLINK);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('showfulllink', 1, ($box_array_dat['box_options']['showfulllink'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('showfulllink', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('showfulllink', 0, ($box_array_dat['box_options']['showfulllink'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('showfulllink', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddCloseRow ();

}

?>