<?php
/**
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

getLanguageDef (_OPN_ROOT_PATH . 'modules/webdir/admin/language/');
$boxtitle = _WBDIR_TITLE . ' ';
$boxtxt = '';
$homedir = $opnConfig['webdir_homedir'];
$dirpermission = $opnConfig['webdir_dirpermission'];
$error = '';
$notice = '';
$opn_get_vars = ${$opnConfig['opn_get_vars']};
$opn_request_vars = ${$opnConfig['opn_request_vars']};
$opn_post_vars = ${$opnConfig['opn_post_vars']};

/* Set current directory */

$showscript = false;
echo '<br />';
if (!isset ($_SESSION['dir']) ) {
	$_SESSION['dir'] = $homedir;
	$showscript = true;
}
if (!empty ($opn_request_vars['dir']) ) {
	$newdir = relpathtoabspath ($opn_request_vars['dir'], $_SESSION['dir']);
	if ($_SESSION['dir'] != $newdir) {
		$_SESSION['dir'] = $newdir;
		$showscript = true;
	}
}
$opn_session_vars = ${$opnConfig['opn_session_vars']};

function perror ($str) {

	$temp = '';
	OpenTable ($temp);
	$temp .= '<span class="alerttext"><br />' . $str . '<br /><br /></span>';
	CloseTable ($temp);
	return $temp;

}

function pnotice ($str) {

	$temp = '';
	OpenTable ($temp);
	$temp .= '<span class="normaltextbold"><br />' . $str . '<br /><br /></span>';
	CloseTable ($temp);
	return $temp;

}

function strip (&$str) {

	$str = stripslashes ($str);

}

/* Get a string from the octal permission */

function octtostr ($mode) {
	if ( ($mode&0xC000) === 0xC000) {
		$type = 's';

		/* Unix domain socket */
	} elseif ( ($mode&0x4000) === 0x4000) {
		$type = 'd';

		/* Directory */
	} elseif ( ($mode&0xA000) === 0xA000) {
		$type = 'l';

		/* Symbolic link */
	} elseif ( ($mode&0x8000) === 0x8000) {
		$type = ' - ';

		/* Regular file */
	} elseif ( ($mode&0x6000) === 0x6000) {
		$type = 'b';

		/* Block special file */
	} elseif ( ($mode&0x2000) === 0x2000) {
		$type = 'c';

		/* Character special file */
	} elseif ( ($mode&0x1000) === 0x1000) {
		$type = 'p';

		/* Named pipe */
	} else {
		$type = '?';

		/* Unknown */
	}
	$owner = ($mode&00400)?'r' : ' - ';
	$owner .= ($mode&00200)?'w' : ' - ';
	if ($mode&0x800) {
		$owner .= ($mode&00100)?'s' : 'S';
	} else {
		$owner .= ($mode&00100)?'x' : ' - ';
	}
	$group = ($mode&00040)?'r' : ' - ';
	$group .= ($mode&00020)?'w' : ' - ';
	if ($mode&0x400) {
		$group .= ($mode&00010)?'s' : 'S';
	} else {
		$group .= ($mode&00010)?'x' : ' - ';
	}
	$other = ($mode&00004)?'r' : ' - ';
	$other .= ($mode&00002)?'w' : ' - ';
	if ($mode&0x200) {
		$other .= ($mode&00001)?'t' : 'T';
	} else {
		$other .= ($mode&00001)?'x' : ' - ';
	}
	return $type . $owner . $group . $other;

}

/* Sort directory listing (quick sort) */

function sortfield ($field, $column, $reverse, $left, $right) {

	$g = $field[(int) ( ($left+ $right)/2)][$column];
	$l = $left;
	$r = $right;
	while ($l<= $r) {
		if ($reverse) {
			while ( ($l< $right) && ($field[$l][$column]> $g) ) $l++; while ( ($r> $left) && ($field[$r][$column]< $g) ) $r--;
		} else {
			while ( ($l< $right) && ($field[$l][$column]< $g) ) $l++; while ( ($r> $left) && ($field[$r][$column]> $g) ) $r--;
		}
		if ($l<$r) {
			$tmp = $field[$r];
			$field[$r] = $field[$l];
			$field[$l] = $tmp;
			$r--;
			$l++;
		} else {
			$l++;
		}
	}
	if ($r>$left) {
		$field = sortfield ($field, $column, $reverse, $left, $r);
	}
	if ($r+1<$right) {
		$field = sortfield ($field, $column, $reverse, $r+1, $right);
	}
	return $field;

}

/**
* Turn a relative path to an absolute path
*/

function relpathtoabspath ($file, $dir) {

	$file = str_replace ('\\', '/', $file);
	$file = str_replace ('//', '/', $file);
	if ( (substr ($file, 0, 1) != '/') AND (substr ($file, 1, 1) != ':') ) {
		$file = $dir . $file;
	}
	if (!@is_link ($file) && ($r = realpath ($file) ) != false) {
		$file = $r;
	}
	if (@is_dir ($file) && substr ($file, strlen ($file)-1, 1) != '/') {
		$file .= '/';
	}
	return $file;

}

/* Replace all numbers in a string with the corresponding value of an array */

function buildphrase ($repl, $str) {
	if (!is_array ($repl) ) {
		$repl = array ($repl);
	}
	$newstr = '';
	$max = strlen ($str);
	for ($i = 0; $i<$max; $i++) {
		$z = substr ($str, $i, 1);
		if ( ((int) $z)>0 && ((int) $z)<=count ($repl) ) {
			$newstr .= $repl[ ((int) $z)-1];
		} else {
			$newstr .= $z;
		}
	}
	return $newstr;

}

function getmimetype ($file) {

	$ext = substr ($file, strrpos ($file, ' . ')+1);
	$mime = 'application / octet - stream';
	if (@is_readable (' / etc / mime . types') ) {
		$f = fopen (' / etc / mime . types', 'r');
		while (!feof ($f) ) {
			$line = fgets ($f, 4096);
			$found = false;
			$mim = strtok ($line, " \n\t");
			$ex = strtok (" \n\t");
			while ($ex && ! $found) {
				if (strtolower ($ex) == strtolower ($ext) ) {
					$found = true;
					$mime = $mim;
					break;
				}
				$ex = strtok (" \n\t");
			}
			if ($found) {
				break;
			}
		}
		fclose ($f);
	}
	return $mime;

}

/**
* Read a file and output it
*/

function showwebdir ($file) {
	if (@is_readable ($file) && @is_file ($file) ) {
		header ('Content-Disposition: filename=' . basename ($file) );
		header ('Content-Type: ' . getmimetype ($file) );
		if (@readfile ($file) !== false) {
			return true;
		}
	}
	return false;

}

/**
* Read a file and output it with syntax highlighting
*/

function show_highlight ($file) {
	if (@is_readable ($file) && @is_file ($file) ) {
		header ('Content-Disposition: filename=' . basename ($file) );
		echo ("<html>\n");
		echo ('<head><title>' . buildphrase (array ('&quot;' . htmlentities (basename ($file) ) . '&quot;'),
							_WBDIR_SOURCEOF) . "</title></head>\n");
		echo ("<body>\n");
		$shown = @highlight_file ($file);
		echo ("\n");
		echo ("</body>\n");
		echo ("</html>");
		if ($shown) {
			return true;
		}
	}
	return false;

}

/**
* Show a listing of the current directory
*/

function dirlisting ($error = '', $notice = '') {

	global $homedir;

	global $opnConfig, $opn_get_vars, $opn_session_vars;

	$boxtxt = '';
	if (function_exists ('posix_getuid') ) {
		$uid = @posix_getuid ();
	} else {
		$uid = '';
	}
	if (!isset ($opn_get_vars['sort']) ) {
		$sort = 'filename';
	} else {
		$sort = $opn_get_vars['sort'];
	}
	if ( (isset ($opn_get_vars['reverse']) ) ) {
		$reverse = @ $opn_get_vars['reverse'];
	} else {
		$reverse = FALSE;
	}
	if (!empty ($error) ) {
		$boxtxt = perror ($error);
	}
	if (!empty ($notice) ) {
		$boxtxt = pnotice ($notice);
	}
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_10_', 'webdir');
	$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
	$form->AddHidden (session_name (), session_id () );
	$form->AddOpenTable ();
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText ('<span class="normaltextbold">' . htmlentities ($_SERVER['SERVER_NAME']) . '</span>');
	$form->AddText ('<span class="normaltext">' . htmlentities ($_SERVER['SERVER_SOFTWARE']) . '</span>');
	$form->AddChangeRow ();
	$form->AddText ('<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
									'dir' => $homedir,
									session_name () => session_id () ) ) . '">' . _WBDIR_DIR . '</a>:&nbsp;');
	$form->SetSameCol ();
	$form->AddTextfield ('dir', 50, 250, htmlentities ($opn_session_vars['dir']) );
	$form->AddSubmit ('submit', _WBDIR_CHANGE);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseTable ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	if (@is_writable ($opn_session_vars['dir']) ) {
		$form = & new opn_FormularClass ('default');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_20_', 'webdir');
		$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'post', '', 'multipart/form-data');
		$form->AddOpenTable ();
		$form->AddTable ();
		$form->AddCols (array ('20%', '60%', '20%') );
		$form->AddOpenRow ();
		$form->AddText ('<span class="normaltext">' . _WBDIR_FILE . '</span>');
		$form->AddFile ('upload', 'textbox', 0, 50);
		$form->SetSameCol ();
		$form->AddHidden (session_name (), session_id () );
		$form->AddHidden ('dir', htmlentities ($opn_session_vars['dir']) );
		$form->AddSubmit ('submit', _WBDIR_UPLOAD);
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddCloseTable ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$form = & new opn_FormularClass ('default');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_30_', 'webdir');
		$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
		$form->AddOpenTable ();
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$optio = array ('file' => _WBDIR_FILE,
				'dir' => _WBDIR_DIR,
				'symlink' => _WBDIR_SYMLINK);
		$form->AddSelect ('type', $optio, 'dir');
		$form->SetSameCol ();
		$form->AddTextfield ('create', 50, 250);
		$form->AddHidden (session_name (), session_id () );
		$form->AddHidden ('dir', htmlentities ($opn_session_vars['dir']) );
		$form->AddSubmit ('submit', _WBDIR_CREATE);
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddCloseTable ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
	$table = & new opn_TableClass ('alternator');
	if ($dirstream = @opendir ($opn_session_vars['dir']) ) {
		$table->AddOpenHeadRow ();
		$table->AddHeaderCol ($opn_session_vars['dir'], '', '6');
		$table->AddCloseRow ();
		$showsize = false;
		for ($n = 0; ($filename = readdir ($dirstream) ) !== false; $n++) {
			$fullfilename = relpathtoabspath ($filename, $opn_session_vars['dir']);
			$stat = @lstat ("{$opn_session_vars['dir']
		}








		$filename");
		$linkpermission = 'lrwxrwxrwx';
		$files[$n] = array ('filename' => $filename,
				'fullfilename' => $fullfilename,
				'is_dir' => $isdir = @is_dir ($fullfilename),
				'is_file' => @is_file ($fullfilename),
				'is_link' => $islink = @is_link ($opn_session_vars['dir'] . $filename),
				'is_readable' => @is_readable ($fullfilename),
				'is_writable' => @is_writable ($fullfilename),
				'is_executable' => (function_exists ('s_executable') )?@is_executable ($fullfilename) : 0,
				'permission' => $islink? $linkpermission : octtostr (@fileperms ($opn_session_vars['dir'] . $filename) ),
				'readlink' => (function_exists ('readlink') && is_link ($opn_session_vars['dir'] . $filename) )? $readlink = @readlink ($opn_session_vars['dir'] . $filename) : 0,
				'linkinfo' => (function_exists ('linkinfo') )?@linkinfo ($opn_session_vars['dir'] . $filename) : 0,
				'size' => ($isdir || $islink)?-1 : @ $stat['size'],
				'owner' => ($owner = @ $stat['uid']),
				'group' => ($group = @ $stat['gid']),
				'nowner' => (function_exists ('linkinfo') )?@reset (posix_getpwuid ($owner) ) : 0,
				'ngroup' => (function_exists ('linkinfo') )?@reset (posix_getgrgid ($group) ) : 0);
		if ($files[$n]['size'] != -1 && $files[$n]['is_file']) {
			$showsize = true;
		}
	}
	$files = sortfield ($files, $sort, $reverse, 0, $n-1);
	if ($sort != 'filename') {
		$old = $files[0][$sort];
		$oldpos = 0;
		$max = sizeof ($files);
		for ($i = 1; $i<$max; $i++) {
			if ($old != $files[$i][$sort]) {
				if ($oldpos != ($i-1) ) {
					$files = sortfield ($files, 'filename', $reverse, $oldpos, $i-1);
				}
				$oldpos = $i;
			}
			$old = $files[$i][$sort];
		}
		if ($oldpos< ($i-1) ) {
			$files = sortfield ($files, 'filename', $reverse, $oldpos, $i-1);
		}
	}
	$table->AddOpenHeadRow ();
	$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
										'noupdate' => true,
										'dir' => $opn_session_vars['dir'],
										'sort' => 'filename',
										'reverse' => ( ($sort == 'filename')?! $reverse : 0),
										session_name () => session_id () ) ) . '">' . _WBDIR_FILENAME . '</a>');
	$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
										'noupdate' => true,
										'dir' => $opn_session_vars['dir'],
										'sort' => 'size',
										'reverse' => ( ($sort == 'size')?! $reverse : 0),
										session_name () => session_id () ) ) . '">' . _WBDIR_SIZE . '</a>');
	$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
										'noupdate' => true,
										'dir' => $opn_session_vars['dir'],
										'sort' => 'permission',
										'reverse' => ( ($sort == 'permission')?! $reverse : 0),
										session_name () => session_id () ) ) . '">' . _WBDIR_PERMISSION . '</a>');
	$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
										'noupdate' => true,
										'dir' => $opn_session_vars['dir'],
										'sort' => 'owner',
										'reverse' => ( ($sort == 'owner')?! $reverse : 0),
										session_name () => session_id () ) ) . '">' . _WBDIR_OWNER . '</a>');
	$table->AddHeaderCol ('<a class="alternatorhead" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
										'noupdate' => true,
										'dir' => $opn_session_vars['dir'],
										'sort' => 'group',
										'reverse' => ( ($sort == 'group')?! $reverse : 0),
										session_name () => session_id () ) ) . '">' . _WBDIR_GROUP . '</a>');
	$table->AddHeaderCol (_WBDIR_FUNCTIONS);
	$table->AddCloseRow ();
	$i = 0;
	foreach ($files as $file) {
		$i++;
		$a = $i%2;
		$table->AddOpenRow ();
		$hlp = '';
		if ($file['is_link']) {
			if ($file['is_dir']) {
				$hlp .= '[ ';
			}
			$hlp .= $file['filename'];
			if ($file['is_dir']) {
				$hlp .= ' ]';
			}
			$hlp .= ' -&gt; ';
			if ($file['is_dir']) {
				$hlp .= '[ ';
				if ($file['is_readable']) $hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
															'dir' => $file['readlink'],
															session_name () => session_id () ) ) . '">';
				$hlp .= htmlentities ($file['readlink']);
				if ($file['is_readable']) $hlp .= '</a>';
				$hlp .= ' ]';
			} else {
				if (dirname ($file['readlink']) != '.') {
					if ($file['is_readable']) $hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
																'dir' => dirname ($file['readlink']),
																session_name () => session_id () ) ) . '">';
					$hlp .= htmlentities (dirname ($file['readlink']) ) . '/';
					if ($file['is_readable']) $hlp .= '</a>';
				}
				if (strlen (basename ($file['readlink']) ) != 0) {
					if ($file['is_file'] && $file['is_readable']) $hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
																		'show' => $file['fullfilename']) ) . '">';
					$hlp .= htmlentities (basename ($file['readlink']) );
					if ($file['is_file'] && $file['is_readable']) $hlp .= '</a>';
				}
				if ($file['is_file'] && preg_match ('/.php[3-4]?$/', $file['readlink']) ) $hlp .= ' <a clas="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
																				'showh' => $file['fullfilename']) ) . '">*</a>';
			}
			$table->AddDataCol ($hlp);
			$hlp = '&nbsp;';
		} elseif ($file['is_dir']) {
			$hlp .= '[ ';
			if ($file['is_readable']) $hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
														'dir' => $file['fullfilename'],
														session_name () => session_id () ) ) . '">';
			$hlp .= htmlentities ($file['filename']);
			if ($file['is_readable']) {
				$hlp .= '</a>';
			}
			$hlp .= ' ]';
			$table->AddDataCol ($hlp);
			$hlp = '&nbsp;';
		} else {
			if ($file['is_readable'] && $file['is_file']) $hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
																'show' => $file['fullfilename']) ) . '">';
			$hlp .= htmlentities ($file['filename']);
			if ($file['is_readable'] && $file['is_file']) $hlp .= '</a>';
			if ($file['is_file'] && preg_match ('/.php[3-4]?$/', $file['filename']) ) $hlp .= ' <a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
																			'showh' => $file['fullfilename']) ) . '">*</a>';
			$table->AddDataCol ($hlp);
			if ($file['is_file']) {
				$hlp = number_format ($file['size'], 0, _WBDIR_DEC_POINT, _WBDIR_THOUSANDS_SEP) . ' B';
			} else {
				$hlp = '&nbsp;';
			}
		}
		$table->AddDataCol ($hlp, 'right');
		$hlp = '';
		if ($uid == $file['owner'] && !$file['is_link']) $hlp .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
															'permission' => $file['fullfilename'],
															session_name () => session_id () ) ) . '">';
		$hlp .= $file['permission'];
		if ($uid == $file['owner'] && !$file['is_link']) {
			$hlp .= '</a>';
		}
		$table->AddDataCol ($hlp, 'center');
		$owner = ($file['nowner'] == null)? $file['owner'] : $file['nowner'];
		$group = ($file['ngroup'] == null)? $file['group'] : $file['ngroup'];
		$table->AddDataCol ($owner . '&nbsp;&nbsp;', 'right');
		$table->AddDataCol ($group . '&nbsp;&nbsp;', 'right');
		$f = '';
		if ($file['filename'] != '.' && $file['filename'] != '..') {
			if ($file['is_readable'] && $file['is_file']) {
				$f .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
											'copy' => $file['fullfilename'],
											session_name () => session_id () ) ) . '">' . _WBDIR_COPY . '</a> | ';
			}
			if ($uid == $file['owner']) {
				$f .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
											'move' => $file['fullfilename'],
											session_name () => session_id () ) ) . '">' . _WBDIR_MOVE . '</a> | ';
				$f .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
											'delete' => $file['fullfilename'],
											session_name () => session_id () ) ) . '">' . _WBDIR_DELETE . '</a> | ';
			}
			if ($file['is_writable'] && $file['is_file']) {
				$f .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
											'edit' => $file['fullfilename'],
											session_name () => session_id () ) ) . '">' . _WBDIR_EDIT . '</a> | ';
			}
		}
		if ($file['is_dir'] && @is_file ($file['fullfilename'] . '.htaccess') && @is_writable ($file['fullfilename'] . '.htaccess') ) {
			$f .= '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
										'edit' => $file['fullfilename'] . '.htaccess',
										session_name () => session_id () ) ) . '">' . _WBDIR_CONFIGURE . '</a> | ';
		}
		if (!empty ($f) ) {
			$f = substr ($f, 0, strlen ($f)-3);
		} else {
			$f = '&nbsp;';
		}
		$table->AddDataCol ($f, 'left');
		$table->AddCloseRow ();
	}
	closedir ($dirstream);
	$table->GetTable ($boxtxt);

} else {
	$boxtxt .= '<table><tr><td bgcolor="FFCCCC">' . buildphrase ('&quot;<strong>' . htmlentities ($opn_session_vars['dir']) . '</strong>&quot', _WBDIR_READINGERROR) . '</td></tr></table>';
}
return $boxtxt;
}
$opn_get_vars = ${$opnConfig['opn_get_vars']};
$opn_request_vars = ${$opnConfig['opn_request_vars']};
$opn_post_vars = ${$opnConfig['opn_post_vars']};
$opn_session_vars = ${$opnConfig['opn_session_vars']};

/**
* Show file
*/
if (!empty ($opn_get_vars['show']) ) {
if (!showwebdir ($opn_get_vars['show']) ) {
	$error = buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['show']) . '</strong>&quot;', _WBDIR_CANTBESHOWN);
} else {
	exit;
}
}

/* Show file syntax highlighted */
if (!empty ($opn_get_vars['showh']) ) {
if (!show_highlight ($opn_get_vars['showh']) ) {
	$error = buildphrase ('&quot; < b > ' . htmlentities ($opn_get_vars['showh']) . ' < / b > &quot;', _WBDIR_CANTBESHOWN);
} else {
	exit;
}
}

/**
* Upload file
*/
if (isset ($_FILES['upload']) && !empty ($opn_post_vars['dir']) ) {
if (@is_dir ($opn_post_vars['dir']) && @is_writable ($opn_post_vars['dir']) && @move_uploaded_file ($_FILES['upload']['tmp_name'], $opn_post_vars['dir'] . $_FILES['upload']['name']) ) {
	$notice = buildphrase (array ('&quot;<strong>' . htmlentities ($_FILES['upload']['name']) . '</strong>&quot;',
					'&quot;<strong>' . htmlentities ($opn_post_vars['dir']) . '</strong>&quot;'),
					_WBDIR_UPLOADED);
} else {
	$error = buildphrase (array ('&quot;<strong> ' . htmlentities ($_FILES['upload']['name']) . ' </strong>&quot;',
				'&quot;<strong>' . htmlentities ($opn_post_vars['dir']) . '</strong>&quot;'),
				_WBDIR_NOTUPLOADED);
}
}

/**
* Create file
*/
if (!empty ($opn_get_vars['dir']) && !empty ($opn_get_vars['create']) && @$opn_get_vars['type'] == 'file') {
$file = $opn_get_vars['dir'] . $opn_get_vars['create'];
if (@touch ($file) ) {
	$notice = buildphrase ('&quot;<strong>' . htmlentities ($file) . '</strong>&quot;', _WBDIR_CREATED);
} else {
	$error = buildphrase ('&quot; <strong>' . htmlentities ($file) . '</strong>&quot;', _WBDIR_NOTCREATED);
}
}

/**
* Create directory
*/
if (!empty ($opn_get_vars['dir']) && !empty ($opn_get_vars['create']) && @$opn_get_vars['type'] == 'dir') {
$file = $opn_get_vars['dir'] . $opn_get_vars['create'];
if (@mkdir ($file, $dirpermission) ) {
	$notice = buildphrase ('&quot;<strong>' . htmlentities ($file) . '</strong>&quot;', _WBDIR_CREATED);
} else {
	$error = buildphrase ('&quot;<strong>' . htmlentities ($file) . '</strong>&quot;', _WBDIR_NOTCREATED);
}
}

/**
* Ask symlink target
*/
if (!empty ($opn_get_vars['dir']) && !empty ($opn_get_vars['create']) && @$opn_get_vars['type'] == 'symlink') {
$opn_get_vars['dir'] = str_replace ('\\\\', '\\', $opn_get_vars['dir']);
$file = $opn_get_vars['dir'] . $opn_get_vars['create'];
$boxtitle .= _WBDIR_SYMLINK;
$form = & new opn_FormularClass ('default');
$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_40_', 'webdir');
$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
$form->AddOpenTable ();
$form->AddTable ();
$form->AddCols (array ('20%', '80%') );
$form->AddOpenRow ();
$form->AddText ('<span class="normaltextbold">' . htmlentities ($_SERVER['SERVER_NAME']) . '</span>');
$form->AddText (htmlentities ($_SERVER['SERVER_SOFTWARE']) );
$form->AddChangeRow ();
$form->AddLabel ('copy', _WBDIR_SYMLINK . ':');
$form->AddTextfield ('copy', 50, 250, htmlentities ($file) );
$form->AddChangeRow ();
$form->AddLabel ('target', _WBDIR_TARGET);
$form->AddTextfield ('target', 50, 250, htmlentities (@basename ($file) ) );
$form->AddChangeRow ();
$form->AddHidden (session_name (), $opn_request_vars[session_name ()]);
$form->AddSubmit ('submit', _WBDIR_CREATE);
$form->AddCloseRow ();
$form->AddTableClose ();
$form->AddCloseTable ();
$form->AddFormEnd ();
$form->GetFormular ($boxtxt);
}

/**
* Create symlink
*/
if (!empty ($opn_get_vars['create']) && !empty ($opn_get_vars['target']) ) {
$opn_get_vars['create'] = str_replace ('\\\\', '\\', $opn_get_vars['create']);
if (@symlink ($opn_get_vars['target'], $opn_get_vars['create']) ) {
	$notice = buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['create']) . '</strong>&quot;', _WBDIR_CREATED);
} else {
	$error = buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['create']) . '</strong>&quot;', _WBDIR_NOTCREATED);
}
}

/**
* Delete file
*/
if (!empty ($opn_get_vars['delete']) ) {
$opn_get_vars['delete'] = str_replace ('\\\\', '\\', $opn_get_vars['delete']);
if ( (isset ($opn_get_vars['sure']) ) && ($opn_get_vars['sure'] == 'true') ) {
	if (@is_dir ($opn_get_vars['delete']) && !@is_link ($opn_get_vars['delete']) ) {
		$x = @rmdir ($opn_get_vars['delete']);
	} else {
		$x = @unlink ($opn_get_vars['delete']);
	}
	if ($x) {
		$notice = buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['delete']) . '</strong>&quot;', _WBDIR_DELETED);
	} else {
		$error = buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['delete']) . '</strong>&quot;', _WBDIR_NOTDELETED);
	}
} else {
	$boxtitle .= _WBDIR_DELETE;
	$table = & new opn_TableClass ('default');
	$table->AddCols (array ('20%', '80%') );
	$table->AddOpenRow ();
	$table->AddDataCol ('<span class="normaltextbold">' . htmlentities ($_SERVER['SERVER_NAME']) . '</span>');
	$table->AddDataCol (htmlentities ($_SERVER['SERVER_SOFTWARE']) );
	$table->AddChangeRow ();
	$table->AddDataCol (buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['delete']) . '</strong>&quot;', _WBDIR_SUREDELETE), '', '2');
	$table->AddChangeRow ();
	$hlp = '&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
											session_name () => $opn_request_vars[session_name ()],
											'delete' => $opn_get_vars['delete'],
											'sure' => true) );
	$hlp .= '">[ ' . _WBDIR_YES . ' ]</a>&nbsp;&nbsp;&nbsp;';
	$hlp .= '<a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php',
								session_name () => $opn_request_vars[session_name ()]) );
	$hlp .= '">[ ' . _WBDIR_NO . ' ]</a>';
	$table->AddDataCol ($hlp, '', '2');
	$table->AddCloseRow ();
	$table->GetTable ($boxtxt);
}
}

/* Change permission */
if (!empty ($opn_get_vars['permission']) ) {
$opn_get_vars['permission'] = str_replace ('\\\\', '\\', $opn_get_vars['permission']);
if ($p = @fileperms ($opn_get_vars['permission']) ) {
	if (!empty ($opn_get_vars['set']) ) {
		$p = 0;
		if (isset ($opn_get_vars['ur']) ) {
			$p |= 0400;
		}
		if (isset ($opn_get_vars['uw']) ) {
			$p |= 0200;
		}
		if (isset ($opn_get_vars['ux']) ) {
			$p |= 0100;
		}
		if (isset ($opn_get_vars['gr']) ) {
			$p |= 0040;
		}
		if (isset ($opn_get_vars['gw']) ) {
			$p |= 0020;
		}
		if (isset ($opn_get_vars['gx']) ) {
			$p |= 0010;
		}
		if (isset ($opn_get_vars['or']) ) {
			$p |= 0004;
		}
		if (isset ($opn_get_vars['ow']) ) {
			$p |= 0002;
		}
		if (isset ($opn_get_vars['ox']) ) {
			$p |= 0001;
		}
		if (@chmod ($opn_get_vars['permission'], $p) ) {
			$notice = buildphrase (array ('&quot<strong>' . htmlentities ($opn_get_vars['permission']) . '</strong>&quot;',
							'&quot;<strong>' . substr (octtostr ('0' . $p),
							1) . '</strong> &quot;(<strong>' . decoct ($p) . '</strong>)'),
							_WBDIR_PERMSSET);
		} else {
			$error = buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['permission']) . '</strong>&quot;', _WBDIR_PERMSNOTSET);
		}
	} else {
		$boxtitle .= _WBDIR_PERMISSION;
		$form = & new opn_FormularClass ('default');
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_50_', 'webdir');
		$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
		$form->AddOpenTable ();
		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->AddOpenRow ();
		$form->AddText ('<span class="normaltextbold">' . htmlentities ($_SERVER['SERVER_NAME']) . '</span>');
		$form->AddText (htmlentities ($_SERVER['SERVER_SOFTWARE']) );
		$form->AddChangeRow ();
		$form->AddLabel ('permission', _WBDIR_FILE);
		$form->SetSameCol ();
		$form->AddTextfield ('permission', 50, 250, htmlentities ($opn_get_vars['permission']) );
		$form->AddHidden (session_name (), $opn_request_vars[session_name ()]);
		$form->AddSubmit ('submit', _WBDIR_CHANGE);
		$form->SetEndCol ();
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddCloseTable ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
		$form = & new opn_FormularClass ('alternator');
		$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
		$form->AddHidden (session_name (), $opn_request_vars[session_name ()]);
		$form->AddHidden ('permission', htmlentities ($opn_get_vars['permission']) );
		$form->AddHidden ('set', 'true');
		$form->AddOpenTable ();
		$form->AddText ('<span class="normaltextbold">' . _WBDIR_PERMISSION . ':&nbsp;' . htmlentities ($opn_get_vars['permission']) . '</span><br /><br />');
		$form->AddTable ();
		$form->AddHeaderRow (array ('&nbsp;', _WBDIR_OWNER, _WBDIR_GROUP, _WBDIR_OTHER) );
		$form->AddOpenRow ();
		$form->AddText (_WBDIR_READ);
		$form->SetAlign ('center');
		$form->AddCheckbox ('ur', '1', ($p&00400)?1 : 0);
		$form->AddCheckbox ('gr', '1', ($p&00040)?1 : 0);
		$form->AddCheckbox ('or', '1', ($p&00004)?1 : 0);
		$form->SetAlign ('');
		$form->AddChangeRow ();
		$form->AddText (_WBDIR_WRITE);
		$form->SetAlign ('center');
		$form->AddCheckbox ('uw', '1', ($p&00200)?1 : 0);
		$form->AddCheckbox ('gw', '1', ($p&00020)?1 : 0);
		$form->AddCheckbox ('ow', '1', ($p&00002)?1 : 0);
		$form->SetAlign ('');
		$form->AddChangeRow ();
		$form->AddText (_WBDIR_EXEC);
		$form->SetAlign ('center');
		$form->AddCheckbox ('ux', '1', ($p&00100)?1 : 0);
		$form->AddCheckbox ('gx', '1', ($p&00010)?1 : 0);
		$form->AddCheckbox ('ox', '1', ($p&00001)?1 : 0);
		$form->SetAlign ('');
		$form->AddChangeRow ();
		$form->SetColspan ('4');
		$form->AddSubmit ('submit', _WBDIR_SETPERMS);
		$form->SetColspan ('');
		$form->AddCloseRow ();
		$form->AddTableClose ();
		$form->AddCloseTable ();
		$form->AddFormEnd ();
		$form->GetFormular ($boxtxt);
	}
} else {
	$error = buildphrase ('&quot;<strong>' . htmlentities ($opn_get_vars['permission']) . '</strong>&quot;', _WBDIR_PERMSNOTSET);
}
}

/* Move file */
if (!empty ($opn_get_vars['move']) ) {
$opn_get_vars['move'] = str_replace ('\\\\', '\\', $opn_get_vars['move']);
if (!empty ($opn_get_vars['destination']) ) {
	$opn_get_vars['destination'] = str_replace ('\\\\', '\\', $opn_get_vars['destination']);
	if (@is_dir ($opn_get_vars['destination']) ) {
		$dir = $opn_get_vars['destination'];
		if (substr ($dir, strlen ($dir)-1, 1) != ' / ') $dir .= ' / ';
		$destination = $dir . basename ($opn_get_vars['move']);
	} else {
		$destination = $opn_get_vars['destination'];
	}
	if (@rename ($opn_get_vars['move'], $destination) ) {
		$notice = buildphrase (array ('&quot;<strong>' . htmlentities ($opn_get_vars['move']) . '</strong>&quot;',
						'&quot;<strong>' . htmlentities ($destination) . '</strong> &quot;'),
						_WBDIR_MOVED);
	} else {
		$error = buildphrase (array ('&quot;<strong>' . htmlentities ($opn_get_vars['move']) . '</strong>&quot;',
					'&quot;<strong>' . htmlentities ($destination) . '</strong>&quot;'),
					_WBDIR_NOTMOVED);
	}
} else {
	$boxtitle .= _WBDIR_MOVE;
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_60_', 'webdir');
	$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
	$form->AddOpenTable ();
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText ('<span class="normaltextbold">' . htmlentities ($_SERVER['SERVER_NAME']) . '</span>');
	$form->AddText (htmlentities ($_SERVER['SERVER_SOFTWARE']) );
	$form->AddChangeRow ();
	$form->AddLabel ('move', _WBDIR_FILE . ':');
	$form->AddTextfield ('move', 50, 250, htmlentities ($opn_get_vars['move']) );
	$form->AddChangeRow ();
	$form->AddLabel ('destination', _WBDIR_MOVETO . ':');
	$form->AddTextfield ('destination', 50, 250, htmlentities ($opn_get_vars['move']) );
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden (session_name (), $opn_request_vars[session_name ()]);
	$form->AddSubmit ('submit');
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseTable ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
}
}

/* Copy file */
if (!empty ($opn_get_vars['copy']) ) {
$opn_get_vars['copy'] = str_replace ('\\\\', '\\', $opn_get_vars['copy']);
if (!empty ($opn_get_vars['destination']) ) {
	$opn_get_vars['destination'] = str_replace ('\\\\', '\\', $opn_get_vars['destination']);
	if (@is_dir ($opn_get_vars['destination']) ) {
		$dir = $opn_get_vars['destination'];
		if (substr ($dir, strlen ($dir)-1, 1) != ' / ') $dir .= ' / ';
		$destination = $dir . basename ($opn_get_vars['copy']);
	} else {
		$destination = $opn_get_vars['destination'];
	}
	if (@copy ($opn_get_vars['copy'], $destination) ) {
		$notice = buildphrase (array ('&quot;<strong>' . htmlentities ($opn_get_vars['copy']) . '</strong>&quot;',
						'&quot;<strong>' . htmlentities ($destination) . '</strong> &quot;'),
						_WBDIR_COPIED);
	} else {
		$error = buildphrase (array ('&quot;<strong>' . htmlentities ($opn_get_vars['copy']) . '</strong>&quot;',
					'&quot;<strong>' . htmlentities ($destination) . '</strong>&quot;'),
					_WBDIR_NOTCOPIED);
	}
} else {
	$boxtitle .= _WBDIR_COPY;
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_70_', 'webdir');
	$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
	$form->AddOpenTable ();
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText ('<span class="normaltextbold">' . htmlentities ($_SERVER['SERVER_NAME']) . '</span>');
	$form->AddText (htmlentities ($_SERVER['SERVER_SOFTWARE']) );
	$form->AddChangeRow ();
	$form->AddLabel ('copy', _WBDIR_FILE . ':');
	$form->AddTextfield ('copy', 50, 250, htmlentities ($opn_get_vars['copy']) );
	$form->AddChangeRow ();
	$form->AddLabel ('destination', _WBDIR_COPYTO . ':');
	$form->AddTextfield ('destination', 50, 250, htmlentities ($opn_get_vars['copy']) );
	$form->AddChangeRow ();
	$form->SetSameCol ();
	$form->AddHidden (session_name (), $opn_request_vars[session_name ()]);
	$form->AddSubmit ('submit', _WBDIR_COPY);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseTable ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
}
}

/* Save edited file */
if (!empty ($opn_post_vars['edit']) && isset ($opn_post_vars['save']) ) {
$opn_post_vars['edit'] = str_replace ('\\\\', '\\', $opn_post_vars['edit']);
if ($f = @fopen ($opn_post_vars['edit'], 'w') ) {

	/* write file with unix-like word-wrap */

	fwrite ($f, str_replace ("\r\n", "\n", $opn_post_vars['content']) );
	fclose ($f);
	$notice = buildphrase ('&quot;<strong>' . htmlentities ($opn_post_vars['edit']) . '</strong>&quot;', _WBDIR_SAVED);
} else {
	$error = buildphrase ('&quot;<strong>' . htmlentities ($opn_post_vars['edit']) . '</strong>&quot;', _WBDIR_NOTSDAVED);
}
}

/* Edit file */
if (isset ($opn_request_vars['edit']) && !isset ($opn_post_vars['save']) ) {
$file = str_replace ('\\\\', '\\', $opn_request_vars['edit']);
if (!@is_dir ($file) && $f = @fopen ($file, 'r') ) {
	$boxtitle .= _WBDIR_EDIT;
	$tempfile = str_replace ('\\', '/', $file);
	$tempfile = str_replace ('.htaccess', '.htpasswd', $tempfile);
	$boxtxt .= '<script type="text/javascript">' . _OPN_HTML_NL . '	<!--' . _OPN_HTML_NL . '	function autheinf () {' . _OPN_HTML_NL . '		document.f.content.value += "Authtype Basic\n' . 'AuthName \"Restricted Directory\"\n' . 'AuthUserFile ' . htmlentities ($tempfile) . '\n' . 'Require valid-user";' . _OPN_HTML_NL . '	}' . _OPN_HTML_NL . '	//-->' . _OPN_HTML_NL . '</script>';
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_MODULES_WEBDIR_80_', 'webdir');
	$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'get');
	$form->AddOpenTable ();
	$form->AddTable ();
	$form->AddCols (array ('20%', '80%') );
	$form->AddOpenRow ();
	$form->AddText ('<span class="normaltextbold">' . htmlentities ($_SERVER['SERVER_NAME']) . '</span>');
	$form->AddText (htmlentities ($_SERVER['SERVER_SOFTWARE']) );
	$form->AddChangeRow ();
	$form->AddLabel ('edit', _WBDIR_FILE);
	$form->SetSameCol ();
	$form->AddTextfield ('edit', 50, 250, htmlentities ($file) );
	$form->AddHidden (session_name (), $opn_request_vars[session_name ()]);
	$form->AddSubmit ('submit', _WBDIR_CHANGE);
	$form->SetEndCol ();
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddCloseTable ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$form->Init ($opnConfig['opn_url'] . '/modules/webdir/admin/index.php', 'post', 'f');
	$form->AddOpenTable ();
	if (!isset ($opn_post_vars['content']) ) {
		$temp = htmlentities (fread ($f, filesize ($file) ) );
	} else {
		$temp = htmlentities ($opn_post_vars['content']);
		if (isset ($opn_post_vars['add']) && !empty ($opn_post_vars['username']) && !empty ($opn_post_vars['password']) ) {
			$temp .= "\n" . htmlentities ($opn_post_vars['username'] . ':' . crypt ($opn_post_vars['password']) );
		}
	}
	fclose ($f);
	$form->UseEditor (false);
	$form->UseWysiwyg (false);
	$form->AddTextarea ('content', 0, 0, '', $temp);
	if (basename ($file) == '.htpasswd') {

		/* specials with htpasswd */

		$form->AddTable ();
		$form->AddCols (array ('20%', '80%') );
		$form->AddOpenRow ();
		$form->AddLabel ('username', _WBDIR_USERNAME . ':');
		$form->AddTextfield ('username', 15, 25);
		$form->AddChangeRow ();
		$form->AddLabel ('password', _WBDIR_PASSWORD . ':');
		$form->AddPassword ('password', 15, 25);
		$form->AddChangeRow ();
		$form->AddSubmit ('add', _WBDIR_ADD);
		$form->AddCloseRow ();
		$form->AddTableClose ();
	}
	$form->AddNewline ();
	$form->AddHidden (session_name (), $opn_request_vars[session_name ()]);
	$form->AddHidden ('edit', htmlentities ($file) );
	$form->AddHidden ('set', 'true');
	if (basename ($file) == '.htaccess') {

		/* specials with htaccess */

		$form->AddButton ('addauth', _WBDIR_ADDAUTH, '', '', 'autheinf();');
		$form->AddText ('<br />');
	}
	$form->AddButton ('fieldreset', _WBDIR_RESET, '', '', 'document.f.reset();');
	$form->AddButton ('clearfield', _WBDIR_CLEAR, '', '', 'document.f.content.value=\'\'');
	$form->AddSubmit ('save', _WBDIR_SAVE);
	$form->AddCloseTable ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
} else {
	$error = buildphrase ('&quot; < b > ' . htmlentities ($file) . ' < / b > &quot;', _WBDIR_NOTOPENED);
}
}
if ($boxtxt == '') {
$boxtxt = dirlisting ($error, $notice);
}
if ($boxtxt != '') {
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WEBDIR_90_';
$_display_dat['module'] = 'pro/pro_outboundmanager';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayHead ();
$menu = & new OPN_Adminmenu (_WBDIR_TITLEMENU);
$menu->InsertEntry (_WBDIR_TITLE, $opnConfig['opn_url'] . '/modules/webdir/admin/index.php?');
$menu->InsertEntry (_WBDIR_GENERALSETTINGS, $opnConfig['opn_url'] . '/modules/webdir/admin/settings.php', '', 1);
$menu->SetAdminLink ();
$menu->DisplayMenu ();
unset ($menu);
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_MODULES_WEBDIR_100_';
$_display_dat['module'] = 'modules/webdir';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayCenterbox ($boxtitle, $boxtxt);
$opnConfig['opnOutput']->DisplayFoot ();
}

?>