<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_domain_class_INCLUDED') ) {
	define ('_domain_class_INCLUDED', 1);

	class domain {
		var $domain = '';

		/*******************************
		* Initializing server variables
		* array(top level domain,whois_Server,not_found_string or MAX number of CHARS: MAXCHARS:n)
		**/
		var $servers = array ();
		var $idn = array (224,
				225,
				226,
				227,
				228,
				229,
				230,
				231,
				232,
				233,
				234,
				235,
				240,
				236,
				237,
				238,
				239,
				241,
				242,
				243,
				244,
				245,
				246,
				248,
				254,
				249,
				250,
				251,
				252,
				253,
				255);

		/**
		* Constructor of class domain
		* @param string	$str_domainname	the full name of the domain
		* @desc Constructor of class domain
		*/

		function domain ($str_domainname) {

			global $opnConfig, $opnTables;

			$this->servers = array ();
			$result = &$opnConfig['database']->Execute ('SELECT domain_name,domain_server,domain_notfound FROM ' . $opnTables['whois_domain'] . ' WHERE domain_visible=1 ORDER BY domain_name');
			if ($result !== false) {
				while (! $result->EOF) {
					$this->servers[] = array ($result->fields['domain_name'],
								$result->fields['domain_server'],
								$result->fields['domain_notfound']);
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$this->domain = $str_domainname;

		}

		/**
		* Returns the whois data of the domain
		* @return string $whoisdata Whois data as string
		* @desc Returns the whois data of the domain
		*/

		function info () {
			if ($this->is_valid () ) {
				$tldname = $this->get_tld ();
				$domainname = $this->get_domain ();
				$whois_server = $this->get_whois_server ();
				// If tldname have been found
				if ($whois_server != '') {
					// Getting whois information
					$errno = 0;
					$errstr = '';
					$fp = @fsockopen ($whois_server, 43, $errno, $errstr, 5);
					if (!$fp) {
						$string = 'error: ' . $errstr . ' (' . $errno . ')<br />';
					} else {
						$dom = $domainname . '.' . $tldname;
						fputs ($fp, $dom . "\r\n");
						// Getting string
						$string = '';
						// Checking whois server for .com and .net
						if ($tldname == 'com' || $tldname == 'net' || $tldname == 'edu') {
							while (!feof ($fp) ) {
								$line = trim (fgets ($fp, 128) );
								$string .= $line;
								$lineArr = split (':', $line);
								if (strtolower ($lineArr[0]) == 'whois server') {
									$whois_server = trim ($lineArr[1]);
								}
							}
							// Getting whois information
							$fp = fsockopen ($whois_server, 43);
							$dom = $domainname . '.' . $tldname;
							fputs ($fp, $dom . "\r\n");
							// Getting string
							$string = '';
							while (!feof ($fp) ) {
								$string .= fgets ($fp, 128);
							}
							// Checking for other tld's
						} else {
							while (!feof ($fp) ) {
								$string .= fgets ($fp, 128);
							}
						}
						fclose ($fp);
					}
					return $string;
				}
				return 'No whois server for this tld in list!';
			}
			return 'Domainname isn\'t valid!';

		}

		/**
		* Returns the whois data of the domain in HTML format
		* @return string $whoisdata Whois data as string in HTML
		* @desc Returns the whois data of the domain  in HTML format
		*/

		function html_info () {
			return nl2br ($this->info () );

		}

		/**
		* Returns name of the whois server of the tld
		* @return string $server the whois servers hostname
		* @desc Returns name of the whois server of the tld
		*/

		function get_whois_server () {

			$server = '';
			$tldname = $this->get_tld ();
			$max = count ($this->servers);
			for ($i = 0; $i< $max; $i++) {
				if ($this->servers[$i][0] == $tldname) {
					$server = $this->servers[$i][1];
					// $full_dom=$this->servers[$i][3];
				}
			}
			return $server;

		}

		/**
		* Returns the tld of the domain without domain name
		* @return string $tldname the tlds name without domain name
		* @desc Returns the tld of the domain without domain name
		*/

		function get_tld () {
			// Splitting domainname
			$domain = split ('\.', $this->domain);
			if (count ($domain)>2) {
				// $domainname=$domain[0];
				$max = count ($domain);
				for ($i = 1; $i< $max; $i++) {
					if ($i == 1) {
						$tldname = $domain[$i];
					} else {
						$tldname .= '.' . $domain[$i];
					}
				}
			} else {
				// $domainname=$domain[0];
				$tldname = $domain[1];
			}
			return $tldname;

		}

		/**
		* Returns all tlds which are supported by the class
		* @return array $tlds all tlds as array
		* @desc Returns all tlds which are supported by the class
		*/

		function get_tlds () {

			$tlds = '';
			$max = count ($this->servers);
			for ($i = 0; $i< $max; $i++) {
				$tlds[$i] = $this->servers[$i][0];
			}
			return $tlds;

		}

		/**
		* Returns the name of the domain without tld
		* @return string $domain the domains name without tld name
		* @desc Returns the name of the domain without tld
		*/

		function get_domain () {
			// Splitting domainname
			$domain = explode ('.', $this->domain);
			if (substr_count (strtolower ($this->domain), 'www.') != 0) {
				return $domain[0] . '.' . $domain[1];
			}
			return $domain[0];

		}

		/**
		* Returns the string which will be returned by the whois server of the tld if a domain is avalable
		* @return string $notfound  the string which will be returned by the whois server of the tld if a domain is avalable
		* @desc Returns the string which will be returned by the whois server of the tld if a domain is avalable
		*/

		function get_notfound_string () {

			$notfound = false;
			$tldname = $this->get_tld ();
			$max = count ($this->servers);
			for ($i = 0; $i< $max; $i++) {
				if ($this->servers[$i][0] == $tldname) {
					$notfound = $this->servers[$i][2];
				}
			}
			return $notfound;

		}

		/**
		* Returns if the domain is available for registering
		* @return boolean $is_available Returns 1 if domain is available and 0 if domain isn't available
		* @desc Returns if the domain is available for registering
		*/

		function is_available () {

			$whois_string = $this->info ();
			$not_found_string = $this->get_notfound_string ();
			$domain = $this->domain;
			$whois_string2 = preg_replace ('/' . $domain . '/', '', $whois_string);
			$whois_string = preg_replace ("/\s+/", ' ', $whois_string);
			// Replace whitespace with single space
			$array = split (':', $not_found_string);
			if (substr_count ($whois_string, 'error:')>0) {
				return false;
			}
			if ($array[0] == 'MAXCHARS') {
				if (strlen ($whois_string2)<=$array[1]) {
					return true;
				}
				return false;
			}
			if (preg_match ('/' . $not_found_string . '/i', $whois_string) ) {
				return true;
			}
			return false;

		}

		/**
		* Returns if the domain name is valid
		* @return boolean $is_valid Returns 1 if domain is valid and 0 if domain isn't valid
		* @desc Returns if the domain name is valid
		*/

		function is_valid () {

			$domain = $this->get_domain ();
			if (substr_count (strtolower ($domain), 'www.') != 0) {
				return false;
			}
			$domainArr = split ("\.", $this->domain);
			// If it's a tld with two Strings (like co.uk)
			if (count ($domainArr) == 3) {
				$tld = $domainArr[1] . "." . $domainArr[2];
				$found = false;
				$max = count ($this->servers);
				for ($i = 0; $i< $max; $i++) {
					if ($this->servers[$i][0] == $tld) {
						$found = true;
						break;
					}
				}
				if (!$found) {
					return false;
				}
			} elseif (count ($domainArr)>3) {
				return false;
			}
			if ($this->get_tld () == "de") {
				$idn = '';
				for ($i = 0, $max = count (count ($this->idn) ); $i< $max; $i++) {
					$idn .= chr ($this->idn[$i]);
				}
				$pattern = "/^[a-z" . $idn . "0-9\-]{3,}$/";
			} else {
				$pattern = "/^[a-zA-Z0-9\-]{3,}$/";
			}
			if (preg_match ($pattern, strtolower ($domain) ) && !preg_match ("/--/", strtolower ($domain) ) ) {
				return true;
			}
			return false;

		}

	}
}

?>