<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function whois_repair_sql_table () {

	global $opnConfig;

	$opn_plugin_sql_table['table']['whois_domain']['domain_id'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['whois_domain']['domain_name'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 20, "");
	$opn_plugin_sql_table['table']['whois_domain']['domain_server'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_VARCHAR, 200, "");
	$opn_plugin_sql_table['table']['whois_domain']['domain_notfound'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_TEXT);
	$opn_plugin_sql_table['table']['whois_domain']['domain_visible'] = $opnConfig['opnSQL']->GetDBType (_OPNSQL_INT, 11, 0);
	$opn_plugin_sql_table['table']['whois_domain']['___opn_key1'] = $opnConfig['opnSQL']->GetPrimaryKey (Array ('domain_id'),
														'whois_domain');
	return $opn_plugin_sql_table;

}

function whois_repair_sql_index () {

	$opn_plugin_sql_index['index']['whois_domain']['___opn_key1'] = 'domain_name';
	$opn_plugin_sql_index['index']['whois_domain']['___opn_key2'] = 'domain_visible,domain_name';
	return $opn_plugin_sql_index;

}

function whois_repair_sql_data () {

	$opn_plugin_sql_data['data']['whois_domain'][] = "1,'ac.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "2,'ac.jp','whois.nic.ad.jp','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "3,'ac.uk','whois.ja.net','no entries',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "4,'ad.jp','whois.nic.ad.jp','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "5,'adm.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "6,'adv.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "7,'aero','whois.information.aero','is available',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "8,'ag','whois.nic.ag','does not exist',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "9,'agr.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "10,'ah.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "11,'al','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "12,'am.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "13,'arq.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "14,'at','whois.nic.at','nothing found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "15,'au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "16,'art.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "17,'as','whois.nic.as','Domain Not Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "18,'asn.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "19,'ato.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "20,'be','whois.geektools.com','No such domain',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "21,'bg','whois.digsys.bg','does not exist',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "22,'bio.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "23,'biz','whois.biz','Not found',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "24,'bj.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "25,'bmd.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "26,'br','whois.registro.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "27,'ca','whois.cira.ca','Status: AVAIL',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "28,'cc','whois.nic.cc','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "29,'cd','whois.cd','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "30,'ch','whois.nic.ch','We do not have an entry',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "31,'cim.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "32,'ck','whois.ck-nic.org.ck','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "33,'cl','whois.nic.cl','no existe',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "34,'cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "35,'cng.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "36,'cnt.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "37,'com','whois.crsnic.net','No match',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "38,'com.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "39,'com.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "40,'com.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "41,'com.eg','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "42,'com.hk','whois.hknic.net.hk','No Match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "43,'com.mx','whois.nic.mx','Nombre del Dominio',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "44,'com.ru','whois.ripn.ru','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "45,'com.tw','whois.twnic.net','NO MATCH TIP',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "46,'conf.au','whois.aunic.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "47,'co.jp','whois.nic.ad.jp','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "48,'co.uk','whois.nic.uk','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "49,'cq.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "50,'csiro.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "51,'cx','whois.nic.cx','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "52,'cz','whois.nic.cz','No data found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "53,'de','whois.denic.de','free',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "54,'dk','whois.dk-hostmaster.dk','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "55,'ecn.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "56,'ee','whois.eenet.ee','NOT FOUND',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "57,'edu','whois.crsnic.net','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "58,'edu.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "59,'edu.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "60,'eg','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "61,'es','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "62,'esp.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "63,'etc.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "64,'eti.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "65,'eun.eg','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "66,'emu.id.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "67,'eng.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "68,'far.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "69,'fi','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "70,'fj','whois.usp.ac.fj','',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "71,'fj.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "72,'fm.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "73,'fnd.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "74,'fo','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "75,'fot.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "76,'fst.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "77,'fr','whois.nic.fr','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "78,'g12.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "79,'gd.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "80,'ge','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "81,'ggf.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "82,'gl','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "83,'gr','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "84,'gr.jp','whois.nic.ad.jp','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "85,'gs','whois.adamsnames.tc','is not registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "86,'gs.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "87,'gov.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "88,'gov.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "89,'gov.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "90,'gov.hk','whois.hknic.net.hk','No Match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "91,'gob.mx','whois.nic.mx','Nombre del Dominio',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "92,'gs','whois.adamsnames.tc','is not registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "93,'gz.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "94,'gx.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "95,'he.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "96,'ha.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "97,'hb.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "98,'hi.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "99,'hl.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "100,'hn.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "101,'hm','whois.registry.hm','(null)',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "102,'hk','whois.hknic.net.hk','No Match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "103,'hk.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "104,'hu','whois.ripe.net','MAXCHARS:500',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "105,'id.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "106,'ie','whois.domainregistry.ie','no match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "107,'ind.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "108,'imb.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "109,'inf.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "110,'info','whois.afilias.info','Not found',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "111,'info.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "112,'it','whois.nic.it','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "113,'idv.tw','whois.twnic.net','NO MATCH TIP',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "114,'int','whois.iana.org','not found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "115,'is','whois.isnic.is','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "116,'il','whois.isoc.org.il','No data was found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "117,'jl.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "118,'jor.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "119,'jp','whois.nic.ad.jp','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "120,'js.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "121,'jx.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "122,'kr','whois.krnic.net','is not registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "123,'la','whois.nic.la','NO MATCH',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "124,'lel.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "125,'li','whois.nic.ch','We do not have an entry',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "126,'lk','whois.nic.lk','No domain registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "127,'ln.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "128,'lt','ns.litnet.lt','No matches found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "129,'lu','whois.dns.lu','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "130,'lv','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "131,'ltd.uk','whois.nic.uk','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "132,'mat.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "133,'mc','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "134,'med.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "135,'mil','whois.nic.mil','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "136,'mil.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "137,'mn','whois.nic.mn','Domain not found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "138,'mo.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "139,'ms','whois.adamsnames.tc','is not registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "140,'mus.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "141,'mx','whois.nic.mx','Nombre del Dominio',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "142,'name','whois.nic.name','No match',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "143,'ne.jp','whois.nic.ad.jp','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "144,'net','whois.crsnic.net','No match',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "145,'net.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "146,'net.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "147,'net.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "148,'net.eg','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "149,'net.hk','whois.hknic.net.hk','No Match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "150,'net.lu','whois.dns.lu','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "151,'net.mx','whois.nic.mx','Nombre del Dominio',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "152,'net.uk','whois.nic.uk','No match for ',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "153,'net.ru','whois.ripn.ru','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "154,'net.tw','whois.twnic.net','NO MATCH TIP',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "155,'nl','whois.domain-registry.nl','is not a registered domain',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "156,'nm.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "157,'no','whois.norid.no','no matches',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "158,'nom.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "159,'not.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "160,'ntr.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "161,'nx.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "162,'nz','whois.domainz.net.nz','Not Listed',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "163,'plc.uk','whois.nic.uk','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "164,'odo.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "165,'oop.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "166,'or.jp','whois.nic.ad.jp','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "167,'org','whois.pir.org','NOT FOUND',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "168,'org.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "169,'org.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "170,'org.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "171,'org.hk','whois.hknic.net.hk','No Match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "172,'org.lu','whois.dns.lu','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "173,'org.ru','whois.ripn.ru','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "174,'org.tw','whois.twnic.net','NO MATCH TIP',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "175,'org.uk','whois.nic.uk','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "176,'pl','whois.ripe.net','No information about',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "177,'pp.ru','whois.ripn.ru','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "178,'ppg.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "179,'pro.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "180,'psi.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "181,'psc.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "182,'pt','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "183,'qh.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "184,'qsl.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "185,'rec.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "186,'ro','whois.ripe.ro','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "187,'ru','whois.ripn.ru','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "188,'sc.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "189,'sd.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "190,'se','whois.nic-se.se','No data found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "191,'sg','whois.nic.net.sg','NO entry found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "192,'sh','whois.nic.sh','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "193,'sh.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "194,'si','whois.arnes.si','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "195,'sk','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "196,'slg.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "197,'sm','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "198,'sn.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "199,'srv.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "200,'st','whois.nic.st','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "201,'sx.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "202,'tc','whois.adamsnames.tc','is not registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "203,'th','whois.nic.uk','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "204,'tj.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "205,'tmp.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "206,'to','whois.tonic.to','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "207,'tr','whois.ripe.net','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "208,'trd.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "209,'tur.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "210,'tv','whois.tv','MAXCHARS:75',1";
	$opn_plugin_sql_data['data']['whois_domain'][] = "211,'tv.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "212,'tw','whois.twnic.net','NO MATCH TIP',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "213,'tw.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "214,'uk','whois.thnic.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "215,'va','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "216,'vet.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "217,'vg','whois.adamsnames.tc','is not registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "218,'wattle.id.au','whois.aunic.net','No Data Found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "219,'ws','whois.worldsite.ws','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "220,'xj.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "221,'xz.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "222,'yn.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "223,'zlg.br','whois.nic.br','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "224,'zj.cn','whois.cnnic.net.cn','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "225,'arpa','whois.internic.net','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "226,'coop','whois.internic.net','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "227,'museum','whois.internic.net','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "228,'ac','whois.nic.ac','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "229,'am','whois.amnic.net','No match',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "230,'az','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "231,'ba','whois.ripe.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "232,'by','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "233,'cy','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "234,'dz','whois.ripe.net','no entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "235,'gb','whois.ripe.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "236,'gb.com','whois.nomination.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "237,'gb.net','whois.nomination.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "238,'ke','whois.rg.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "239,'ma','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "240,'md','whois.ripe.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "241,'me.uk','whois.nic.uk','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "242,'mk','whois.ripe.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "243,'mt','whois.ripe.net','No Entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "244,'no.com','whois.nomination.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "245,'nu','whois.nic.nu','NO MATCH for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "246,'pk','whois.pknic.net','is not registered',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "247,'se.com','whois.nomination.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "248,'se.net','whois.nomination.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "249,'su','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "250,'tm','whois.nic.tm','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "251,'tn','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "252,'ua','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "253,'uk.com','whois.nomination.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "254,'uk.net','whois.nomination.net','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "255,'us','whois.nic.us','Not found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "256,'yu','whois.ripe.net','No entries found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "257,'za','whois.frd.ac.za','No match for',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "258,'tel.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "259,'web.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "260,'av.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "261,'bel.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "262,'biz.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "263,'com.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "264,'dr.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "265,'edu.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "266,'gen.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "267,'gov.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "268,'info.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "269,'k12.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "270,'mil.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "271,'name.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "272,'net.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "273,'org.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "274,'pol.tr','whois.nic.tr','Not found in database',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "275,'co.at','whois.nic.at','nothing found',0";
	$opn_plugin_sql_data['data']['whois_domain'][] = "276,'or.at','whois.nic.at','nothing found',0";
	return $opn_plugin_sql_data;

}

?>