<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/anypage/language/');

function buildMonthSelect ($month) {

	$options = array ();
	for ($i = 1; $i<=12; $i++) {
		$options[$i] = $i;
	}
	$form = & new opn_FormularClass ();
	$form->AddSelect ('mymonth', $options, $month);
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt . '</div>';

}

function buildDaySelect ($day) {

	$options = array ();
	for ($i = 1; $i<=31; $i++) {
		$options[$i] = $i;
	}
	$form = & new opn_FormularClass ();
	$form->AddSelect ('myday', $options, $day);
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt . '</div>';

}

function buildYearSelect ($year) {

	$options = array ();
	for ($i = 2001; $i<=2030; $i++) {
		$options[$i] = $i;
	}
	$form = & new opn_FormularClass ();
	$form->AddSelect ('myyear', $options, $year);
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt . '</div>';

}

function buildHourSelect ($hour) {

	global $opnConfig;
	if (!isset ($opnConfig['anypage_time24Hour']) ) {
		$opnConfig['anypage_time24Hour'] = 0;
	}
	$options = array ();
	if (! ($opnConfig['anypage_time24Hour']) ) {
		if (intval ($hour)>12) {
			$hour = $hour-12;
		}
		for ($i = 1; $i<=12; $i++) {
			$temp = sprintf ('%02d', $i);
			$options[$temp] = $temp;
		}
	} else {
		for ($i = 0; $i<=23; $i++) {
			$temp = sprintf ('%02d', $i);
			$options[$temp] = $temp;
		}
	}
	$hour = sprintf ('%02d', $hour);
	$form = & new opn_FormularClass ();
	$form->AddSelect ('myhour', $options, $hour);
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt . '</div>';

}

function buildMinSelect ($min) {

	$options = array ();
	for ($i = 0; $i<=45; ) {
		$temp = sprintf ('%02d', $i);
		$options[$temp] = ':' . $temp;
		$i = $i+15;
	}
	$form = & new opn_FormularClass ();
	$min = sprintf ('%02d', floor ($min/15)*15);
	$form->AddSelect ('mymin', $options, $min);
	$boxtxt = '';
	$form->GetFormular ($boxtxt);
	return $boxtxt . '</div>';

}

function load_pagedata ($id, $isadmin, $random = false) {

	global $opnConfig, $opnTables;

	$myarr = array ();
	$myarr['use_tpl_key'] = '';
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$where = '';
	if (!$isadmin) {
		if ($random) {
		} else {
			$where = " AND (status='V')";
		}
	}
	$sql = 'SELECT pagename, title, footline, shortdesc, wpage, status, lastmod FROM ' . $opnTables['anypage_page'] . ' WHERE (id=' . $id . ') AND (user_group IN (' . $checkerlist . ')' . $where . ')';
	$result = $opnConfig['database']->Execute ($sql);
	if (is_object ($result) ) {
		$result_count = $result->RecordCount ();
	} else {
		$result_count = 0;
	}
	if ($result_count == 0) {
		$myarr['text'] = _ANYP_NOTHINGFOUND;
	} else {
		$myarr['id'] = $id;
		$myarr['pagename'] = $result->fields['pagename'];
		$myarr['title'] = $result->fields['title'];
		$myarr['footline'] = $result->fields['footline'];
		$myarr['shortdesc'] = $result->fields['shortdesc'];
		$myarr['page'] = $result->fields['wpage'];
		$myarr['pagestatus'] = $result->fields['status'];
		$myarr['lastmod'] = $result->fields['lastmod'];
		$myarr['page_random'] = false;
		$result->Close ();
		$sql = 'SELECT use_opn_nl_to_br, use_opn_user_images, use_opn_link_pos, use_opn_print_page, use_opn_random_page, use_meta_keywords, use_tpl_key, use_meta_title FROM ' . $opnTables['anypage_page_features'] . ' WHERE (id=' . $id . ')';
		$result = $opnConfig['database']->Execute ($sql);
		if ( ($result !== false) && (!$result->EOF) ) {
			if ($result->fields['use_opn_nl_to_br'] == 1) {
				opn_nl2br ($myarr['page']);
				if ( (substr_count ($myarr['page'], '<table')>0) || (substr_count ($myarr['page'], '<TABLE')>0) || (substr_count ($myarr['page'], '<td')>0) ) {
					$tables = array ();
					replace_tag ($myarr['page'], 'td', $tables);
					$search = array ('<br>',
							_OPN_HTML_NL,
							_OPN_HTML_TAB);
					$replace = array ('<br />',
							'<br />',
							'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;');
					$max = count ($tables[0]);
					for ($i = 0; $i< $max; $i++) {
						$tables[0][$i] = str_replace ($search, $replace, $tables[0][$i]);
					}
					restore_tag ($myarr['page'], 'td', $tables);
				}
			}
			if ($result->fields['use_meta_keywords'] != '') {
				$opnConfig['makekeywords'] = $result->fields['use_meta_keywords'];
			}
			if ($result->fields['use_meta_title'] != '') {
				$opnConfig['opn_generateautomatictitle'] = 1;
				define ('_OPN_ADDTOTITLE', $result->fields['use_meta_title']);
			}
			if ($result->fields['use_tpl_key'] != '') {
				$myarr['use_tpl_key'] = $result->fields['use_tpl_key'];
			}
			if ($result->fields['use_opn_user_images'] == 1) {
			}
			if ($result->fields['use_opn_link_pos'] == 1) {
			}
			if ($result->fields['use_opn_random_page'] == 1) {
				$myarr['page_random'] = true;
			}
			if ($result->fields['use_opn_print_page'] == 1) {
				$myarr['footline'] .= '<br />';
				$myarr['footline'] .= '<a class="opncenterboxfoot" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/anypage/printpage.php',
														'id' => $id) ) . '" title="' . _ANYP_PRINTFRIENDLYPAGE . '" target="_blank">';
				$myarr['footline'] .= '<img src="' . $opnConfig['opn_default_images'] . 'print.gif" class="imgtag" alt="' . _ANYP_PRINTFRIENDLYPAGE . '" />';
				$myarr['footline'] .= '</a>';
			}
		}
	}
	return $myarr;

}

function build_pagenamearr () {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$sql = 'SELECT pagename FROM ' . $opnTables['anypage_page'] . ' WHERE (id>0) AND (user_group IN (' . $checkerlist . ')) ORDER BY pagename';
	$result = $opnConfig['database']->Execute ($sql);
	$myarr['text'] = '';
	if (is_object ($result) ) {
		$result_count = $result->RecordCount ();
	} else {
		$result_count = 0;
	}
	if ($result_count == 0) {
		$myarr['text'] .= _ANYP_NOTHINGFOUND;
	} else {
		while (! $result->EOF) {
			$myarr[] = $result->fields['pagename'];
			$result->MoveNext ();
		}
	}
	return $myarr;

}

function build_pagestatusimage ($id, $pagestatus, $path = '/admin') {

	global $opnConfig;
	$link =array ($opnConfig['opn_url'] . '/system/anypage' . $path . '/index.php',
							'op' => 'switchstatus',
							'id' => $id,
							'pagestatus' => $pagestatus);
	if ($pagestatus == 'V') {
		$mystatus = $opnConfig['defimages']->get_activate_link ($link );
	} elseif ($pagestatus == 'R') {
		$mystatus = $opnConfig['defimages']->get_inherit_link ($link, 2, '', '*' );
	} else {
		$mystatus = $opnConfig['defimages']->get_deactivate_link ($link );
	}
	return $mystatus;

}

function get_cat_name ($catid) {

	global $opnConfig, $opnTables;

	$result = $opnConfig['database']->SelectLimit ('SELECT name FROM ' . $opnTables['anypage_page_cat'] . ' WHERE id=' . $catid, 1);
	$anypage_cat_name = $result->fields['name'];
	$result->Close ();
	unset ($result);
	return $anypage_cat_name;

}

function get_cat_dat ($catid) {

	global $opnConfig, $opnTables;

	$result = $opnConfig['database']->SelectLimit ('SELECT name, text, image FROM ' . $opnTables['anypage_page_cat'] . ' WHERE id=' . $catid, 1);
	$anypage_cat_dat = array();
	$anypage_cat_dat['name'] = $result->fields['name'];
	$anypage_cat_dat['text'] = $result->fields['text'];
	$anypage_cat_dat['image'] = $result->fields['image'];
	$result->Close ();
	unset ($result);
	return $anypage_cat_dat;

}

function get_cat_id ($id) {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = $opnConfig['database']->SelectLimit ('SELECT anypage_cat FROM ' . $opnTables['anypage_page'] . ' WHERE (id=' . $id . ') AND (user_group IN (' . $checkerlist . '))', 1);
	$anypage_cat = $result->fields['anypage_cat'];
	$result->Close ();
	unset ($result);
	return $anypage_cat;

}

?>