<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/article/plugin/middlebox/singlearticle/language/');

function build_articleselect (&$defaultid) {

	global $opnConfig, $opnTables;

	$sql = 'SELECT sid, title FROM ' . $opnTables['article_stories'] . ' WHERE sid>0 ORDER BY wtime DESC';
	$result = $opnConfig['database']->Execute ($sql);
	if (is_object ($result) ) {
		$result_count = $result->RecordCount ();
	} else {
		$result_count = 0;
	}
	if ($result_count == 0) {
		$options = _SINGLEARTICLE_MIDDLEBOX_NOTHINGFOUND;
	} else {
		while (! $result->EOF) {
			$sid = $result->fields['sid'];
			if ($defaultid == '') {
				$defaultid = $sid;
			}
			$title = $result->fields['title'];
			$opnConfig['cleantext']->opn_shortentext ($title, 40);
			$options[$sid] = $title;
			$result->MoveNext ();
		}
	}
	return $options;

}

function send_middlebox_edit (&$box_array_dat) {
	if (!isset ($box_array_dat['box_options']['title']) ) {
		$box_array_dat['box_options']['title'] = _SINGLEARTICLE_MIDDLEBOX_TITLE;
		// default title
	}
	if (!isset ($box_array_dat['box_options']['art_number']) ) {
		$box_array_dat['box_options']['art_number'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['dothetitle']) ) {
		$box_array_dat['box_options']['dothetitle'] = 1;
	}
	if (!isset ($box_array_dat['box_options']['dothebody']) ) {
		$box_array_dat['box_options']['dothebody'] = 0;
	}
	if (!isset ($box_array_dat['box_options']['dothefooter']) ) {
		$box_array_dat['box_options']['dothefooter'] = 1;
	}
	$options = build_articleselect ($box_array_dat['box_options']['art_number']);
	$box_array_dat['box_form']->AddOpenRow ();
	if (is_array ($options) ) {
		$box_array_dat['box_form']->AddLabel ('art_number', _SINGLEARTICLE_MIDDLEBOX_ART_NUMBER);
		$box_array_dat['box_form']->AddSelect ('art_number', $options, $box_array_dat['box_options']['art_number']);
	} else {
		$box_array_dat['box_form']->AddText (_SINGLEARTICLE_MIDDLEBOX_ART_NUMBER);
		$box_array_dat['box_form']->AddText ($options);
	}
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_SINGLEARTICLE_MIDDLEBOX_TITLE_SHOW);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('dothetitle', 1, ($box_array_dat['box_options']['dothetitle'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothetitle', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('dothetitle', 0, ($box_array_dat['box_options']['dothetitle'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothetitle', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_SINGLEARTICLE_MIDDLEBOX_BODY);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('dothebody', 1, ($box_array_dat['box_options']['dothebody'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothebody', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('dothebody', 0, ($box_array_dat['box_options']['dothebody'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothebody', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddChangeRow ();
	$box_array_dat['box_form']->AddText (_SINGLEARTICLE_MIDDLEBOX_FOOTER);
	$box_array_dat['box_form']->SetSameCol ();
	$box_array_dat['box_form']->AddRadio ('dothefooter', 1, ($box_array_dat['box_options']['dothefooter'] == 1?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothefooter', _YES . '&nbsp;&nbsp;&nbsp;&nbsp;', 1);
	$box_array_dat['box_form']->AddRadio ('dothefooter', 0, ($box_array_dat['box_options']['dothefooter'] == 0?1 : 0) );
	$box_array_dat['box_form']->AddLabel ('dothefooter', _NO, 1);
	$box_array_dat['box_form']->SetEndCol ();
	$box_array_dat['box_form']->AddCloseRow ();

}

?>