<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.myfunctions.php');

function topics_get_data ($result, $box_array_dat, $css, &$data) {

	global $opnConfig, $opnTables;

	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$mf = & new MyFunctions;
	$mf->table = $opnTables['article_topics'];
	$mf->id = 'topicid';
	$mf->title = 'topictext';
	$mf->where = '(user_group IN (' . $checkerlist . '))';
	$i = 0;
	while (! $result->EOF) {
		$dbcatid = $result->fields['topicid'];
		$ctitle = $result->fields['topictext'];
		$title = $ctitle;
		$opnConfig['cleantext']->opn_shortentext ($ctitle, $box_array_dat['box_options']['strlength']);
		$data[$i]['link'] = '<a class="' . $css . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/topics.php',
											'topic' => $dbcatid) ) . '" title="' . $title . '">' . $ctitle . '</a>';
		$mf->pos = 'topicpos';
		$arr = $mf->getChildTreeArray ($dbcatid);
		$mf->pos = '';
		$arr1 = array ();
		$max = count ($arr);
		for ($j = 0; $j< $max; $j++) {
			$catpath = $mf->getPathFromId ($arr[$j][2]);
			$catpath = substr ($catpath, 1);
			$title = $catpath;
			$opnConfig['cleantext']->opn_shortentext ($catpath, $box_array_dat['box_options']['strlength']);
			$arr1[$j] = '<a class="' . $css . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/article/topics.php',
											'topic' => $arr[$j][2]) ) . '" title="' . $title . '">' . $catpath . '</a>';
		}
		unset ($arr);
		$data[$i]['childs'] = $arr1;
		unset ($arr1);
		$i++;
		$result->MoveNext ();
	}

}

function topics_get_middlebox_result (&$box_array_dat) {

	global $opnConfig, $opnTables;
	if (!isset ($box_array_dat['box_options']['use_tpl']) ) {
		$box_array_dat['box_options']['use_tpl'] = '';
	}
	if (!isset ($box_array_dat['box_options']['strlength']) ) {
		$box_array_dat['box_options']['strlength'] = 22;
	}
	$css = 'opn' . $box_array_dat['box_options']['opnbox_class'] . 'box';
	$css1 = '';
	$css2 = '';
	if ($box_array_dat['box_options']['opnbox_class'] == 'side') {
		$css1 = '<span class="sideboxsmalltext">';
		$css2 = '</span>';
	}
	$boxstuff = $box_array_dat['box_options']['textbefore'];
	$checkerlist = $opnConfig['permission']->GetUserGroups ();
	$result = &$opnConfig['database']->Execute ('SELECT topicid, topictext FROM ' . $opnTables['article_topics'] . ' WHERE topicid>0 and pid=0 AND (user_group IN(' . $checkerlist . ')) ORDER BY topicpos');
	if ($result !== false) {
		$numrows = $result->RecordCount ();
	} else {
		$numrows = 0;
	}
	if ($numrows != 0) {
		$data = array ();
		topics_get_data ($result, $box_array_dat, $css, $data);
		if ($box_array_dat['box_options']['use_tpl'] == '') {
			$boxstuff .= '<ul class="' . $css . '">';
			foreach ($data as $val) {
				$boxstuff .= '<li class="' . $css . '">' . $css1 . $val['link'] . $css2;
				$arr = $val['childs'];
				$content = '';
				$max = count ($arr);
				for ($i = 0; $i< $max; $i++) {
					$content .= '<li clas="' . $css . '">' . $css1 . $arr[$i] . $css2 . '</li>';
				}
				if ($content != '') {
					$boxstuff .= '<ul class="' . $css . '">' . $content . '</ul>';
				}
				unset ($arr);
				$boxstuff .= '</li>';
			}
			$boxstuff .= '</ul>';
		} else {
			$pos = 0;
			$dcol1 = '2';
			$dcol2 = '1';
			$a = 0;
			$opnliste = array ();
			foreach ($data as $val) {
				$dcolor = ($a == 0? $dcol1 : $dcol2);
				$opnliste[$pos]['topic'] = $val['link'];
				$arr = $val['childs'];
				$opnliste[$pos]['case'] = 'nosubtopic';
				$opnliste[$pos]['alternator'] = $dcolor;
				$opnliste[$pos]['image'] = '<img src="' . $opnConfig['opn_default_images'] . 'recent.gif" alt="" /> ';
				$max = count ($arr);
				for ($i = 0; $i< $max; $i++) {
					$opnliste[$pos]['subtopic'][$i] = $arr[$i];
					$opnliste[$pos]['case'] = 'subtopic';
				}
				unset ($arr);
				$pos++;
				$a = ($dcolor == $dcol1?1 : 0);
			}
			get_box_template ($box_array_dat, array ('subtopic',
								'nosubtopic'),
								$opnliste,
								0,
								0,
								$boxstuff);
		}
		unset ($data);
		$result->Close ();
	}
	$boxstuff .= $box_array_dat['box_options']['textafter'];
	$box_array_dat['box_result']['skip'] = false;
	$box_array_dat['box_result']['title'] = $box_array_dat['box_options']['title'];
	$box_array_dat['box_result']['content'] = $boxstuff;
	unset ($boxstuff);

}

?>