<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/backend', true);
$privsettings = $opnConfig['module']->GetPrivateSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'system/backend/admin/language/');

function backend_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_BACKENDADM_SAVE] = _BACKENDADM_SAVE;
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav);
	return $values;

}

function backendsettings () {

	global $opnConfig, $privsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _BACKENDADM_GENERAL);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_BACKENDTITLE,
			'name' => 'backend_title',
			'value' => $privsettings['backend_title'],
			'size' => 50,
			'maxlength' => 100);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_BACKENDLANG,
			'name' => 'backend_language',
			'value' => $privsettings['backend_language'],
			'size' => 10,
			'maxlength' => 10);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_BACKENDIMAGEURL,
			'name' => 'backend_image',
			'value' => $privsettings['backend_image'],
			'size' => 50,
			'maxlength' => 200);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_BACKENDIMAGEWIDTH,
			'name' => 'backend_width',
			'value' => $privsettings['backend_width'],
			'size' => 4,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_BACKENDIMAGEHEIGHT,
			'name' => 'backend_height',
			'value' => $privsettings['backend_height'],
			'size' => 4,
			'maxlength' => 3);
	$values[] = array ('type' => _INPUT_BLANKLINE);
	$version = array ();
	$version['HTML'] = 'html';
	$version['2.0'] = (string)'200';
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_ADMINPASS,
			'name' => 'backend_pass',
			'value' => $privsettings['backend_pass'],
			'size' => 20,
			'maxlength' => 20);
	$values[] = array ('type' => _INPUT_SELECT_KEY,
			'display' => _BACKEND_RSSVERSION,
			'name' => 'backend_version',
			'options' => $version,
			'selected' => (string) $privsettings['backend_version']);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_LIMIT,
			'name' => 'backend_limit',
			'value' => $privsettings['backend_limit'],
			'size' => 4,
			'maxlength' => 4);
	$values[] = array ('type' => _INPUT_TEXT,
			'display' => _BACKENDADM_MAXLIMIT,
			'name' => 'backend_max_limit',
			'value' => $privsettings['backend_max_limit'],
			'size' => 4,
			'maxlength' => 4);
	$plugs = array ();
	$opnConfig['installedPlugins']->getplugin ($plugs,
								'backend');
	$name = array ();
	foreach ($plugs as $plug) {
		if (!isset ($privsettings['backend_showinhead'][$plug['plugin']]) ) {
			$privsettings['backend_showinhead'][$plug['plugin']] = 0;
		}
		if (!isset ($privsettings['backend_allow'][$plug['plugin']]) ) {
			if ($plug['plugin'] == 'system/admin') {
				$privsettings['backend_allow'][$plug['plugin']] = 0;
			} else {
				$privsettings['backend_allow'][$plug['plugin']] = 1;
			}
		}
		include_once (_OPN_ROOT_PATH . $plug['plugin'] . '/plugin/backend/index.php');
		$myfunc = $plug['module'] . '_get_backend_modulename';
		$modulename = '';
		$myfunc ($modulename);
		$name[$plug['plugin']]['name'] = $modulename;
		$name[$plug['plugin']]['module'] = $plug['plugin'];
	}
	$values[] = array ('type' => _INPUT_BLANKLINE);
	foreach ($name as $nam) {
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => sprintf (_BACKEND_ALLOW,
				$nam['name']),
				'name' => 'backend_allow_' . $nam['module'],
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($privsettings['backend_allow'][$nam['module']] == 1?true : false),
				 ($privsettings['backend_allow'][$nam['module']] == 0?true : false) ) );
		$values[] = array ('type' => _INPUT_RADIO,
				'display' => sprintf (_BACKEND_SHOWINHEAD,
				$nam['name']),
				'name' => 'backend_showinhead_' . $nam['module'],
				'values' => array (1,
				0),
				'titles' => array (_YES,
				_NO),
				'checked' => array ( ($privsettings['backend_showinhead'][$nam['module']] == 1?true : false),
				 ($privsettings['backend_showinhead'][$nam['module']] == 0?true : false) ) );
		$values[] = array ('type' => _INPUT_BLANKLINE);
	}
	$values = array_merge ($values, backend_allhiddens (_BACKENDADM_GENERAL) );
	$set->GetTheForm (_BACKENDADM_SETTINGS, $opnConfig['opn_url'] . '/system/backend/admin/settings.php', $values);

}

function backend_dosavesettings () {

	global $opnConfig, $privsettings;

	$opnConfig['module']->SetPrivateSettings ($privsettings);
	$opnConfig['module']->SavePrivateSettings ();

}

function backend_dosavebackend ($vars) {

	global $privsettings, $opnConfig, $opnTables;

	$privsettings['backend_title'] = $vars['backend_title'];
	$privsettings['backend_language'] = $vars['backend_language'];
	$privsettings['backend_image'] = $vars['backend_image'];
	$privsettings['backend_width'] = $vars['backend_width'];
	$privsettings['backend_height'] = $vars['backend_height'];
	$privsettings['backend_version'] = $vars['backend_version'];
	$privsettings['backend_limit'] = $vars['backend_limit'];
	$privsettings['backend_max_limit'] = $vars['backend_max_limit'];
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'backend_showinhead_')>0) {
			$key = str_replace ('backend_showinhead_', '', $key);
			if ($key == 'admin') {
				$privsettings['backend_showinhead'][$key] = 0;
			} else {
				$privsettings['backend_showinhead'][$key] = $value;
			}
		}
		if (substr_count ($key, 'backend_allow_')>0) {
			$key = str_replace ('backend_allow_', '', $key);
			if ($key == 'admin') {
				$privsettings['backend_allow'][$key] = 0;
			} else {
				$privsettings['backend_allow'][$key] = $value;
			}
		}
	}
	$result = $opnConfig['database']->Execute ('SELECT options FROM ' . $opnTables['opn_meta_tags_option'] . ' WHERE tag_id=1');
	$option = $result->fields['options'];
	$result->Close ();
	$option = stripslashesinarray (unserialize ($option) );
	$plugs = array();
	$opnConfig['installedPlugins']->getplugin ($plugs, 'backend');
	$mtautomatic = '';
	if (is_array ($plugs) ) {
		foreach ($plugs as $plug) {
			if ( (isset ($privsettings['backend_showinhead'][$plug['plugin']]) ) AND ($privsettings['backend_showinhead'][$plug['plugin']] == 1) ) {
				include_once (_OPN_ROOT_PATH . $plug['plugin'] . '/plugin/backend/index.php');
				$myfunc = $plug['module'] . '_get_backend_header';
				$title = $opnConfig['sitename'];
				$myfunc ($title);
				$mtautomatic .= '<link href="' . $opnConfig['opn_url'] . '/system/backend/backend.php?version=' . $privsettings['backend_version'] . '&amp;limit=' . $privsettings['backend_limit'] . '&amp;module=' . $plug['plugin'] . '" rel="alternate" type="application/rss+xml" title="' . htmlspecialchars ($title) . '" />' . _OPN_HTML_NL;
			}
		}
	}
	$option['mtautomatic'] = $mtautomatic;
	$option = $opnConfig['opnSQL']->qstr (serialize (addslashesinarray ($option) ) , 'options');
	$opnConfig['database']->Execute ('UPDATE ' . $opnTables['opn_meta_tags_option'] . " SET options=$option WHERE tag_id=1");
	$opnConfig['opnSQL']->UpdateBlobs ($opnTables['opn_meta_tags_option'], 'tag_id=1');
	unset ($option);
	backend_dosavesettings ();

}

function backend_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _BACKENDADM_GENERAL:
			backend_dosavebackend ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		backend_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _BACKENDADM_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/backend/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	default:
		backendsettings ();
		break;
}

?>