<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;
if ($opnConfig['permission']->HasRights ('system/backend', array (_PERM_READ, _PERM_BOT) ) ) {
	$opnConfig['module']->InitModule ('system/backend');
	$opnConfig['opnOutput']->setMetaPageName ('system/backend');
	getLanguageDef (_OPN_ROOT_PATH . 'system/backend/language/');
	$titletext = _BACKEND_BACKENDLIST;
	$version = '';
	get_var ('version', $version, 'url');
	switch ($version) {
		case '200':
			$titletext .= ' ' . _BACKEND_VERSION200;
			break;
		case 'atom':
			$titletext .= ' ' . _BACKEND_VERSIONATOM;
			break;
		case 'html':
			$titletext .= ' ' . _BACKEND_VERSIONHTML;
			break;
	}
	// switch
	$plugs = array ();
	$opnConfig['installedPlugins']->getplugin ($plugs,
								'backend');
	$table = & new opn_TableClass ('alternator');
	if ($version == '') {
		$table->AddCols (array ('25%', '25%', '25%', '25%', '25%') );
		$table->AddHeaderRow (array (_BACKEND_MODULE, _BACKEND_VERSION200, _BACKEND_VERSIONATOM, _BACKEND_VERSIONHTML) );
	} else {
		$table->AddCols (array ('50%', '50%') );
		$table->AddHeaderRow (array (_BACKEND_MODULE, _BACKEND_BACKEND) );
	}
	foreach ($plugs as $plug) {
		if (!isset ($opnConfig['backend_allow'][$plug['plugin']]) ) {
			$stop = 1;
		} elseif ($opnConfig['backend_allow'][$plug['plugin']]) {
			$stop = 0;
		} else {
			$stop = 1;
		}
		include_once (_OPN_ROOT_PATH . $plug['plugin'] . '/plugin/backend/index.php');
		$myfunc = $plug['module'] . '_get_backend_modulename';
		$modulename = '';
		$myfunc ($modulename);
		$go = false;
		if ($stop == 0) {
			$link = $opnConfig['opn_url'] . '/system/backend/backend.php?version=%s&limit=' . $opnConfig['backend_limit'] . '&module=' . $plug['plugin'];
			$go = true;
		} elseif ( ($stop == 1) && ($opnConfig['permission']->HasRight ('admin/openphpnuke', _PERM_ADMIN, true) ) ) {
			$link = $opnConfig['opn_url'] . '/system/backend/backend.php?version=%s&limit=' . $opnConfig['backend_limit'] . '&module=' . $plug['plugin'] . '&pass=' . $opnConfig['backend_pass'];
			$go = true;
			$modulename = '<span class="alerttext">' . $modulename . '</span>';
		}
		if ($go) {
			$table->AddOpenRow ();
			$table->AddDataCol ($modulename);
			if ($version == '') {
				$table->AddDataCol ('<a class="%alternate%" href="' . htmlentities (sprintf ($link, '200') ) . '" target="_blank">' . _BACKEND_BACKEND . '</a>');
				$table->AddDataCol ('<a class="%alternate%" href="' . htmlentities (sprintf ($link, 'atom') ) . '" target="_blank">' . _BACKEND_BACKEND . '</a>');
				$table->AddDataCol ('<a class="%alternate%" href="' . htmlentities (sprintf ($link, 'html') ) . '" target="_blank">' . _BACKEND_BACKEND . '</a>');
			} else {
				$table->AddDataCol ('<a class="%alternate%" href="' . htmlentities (sprintf ($link, $version) ) . '" target="_blank">' . _BACKEND_BACKEND . '</a>');
			}
			$table->AddCloseRow ();
		}
	}
	$text = '';
	$table->GetTable ($text);
	$text .= '<br /><div class="normaltext">' . _BACKEND_LIMIT . '</div>';
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_BACKEND_10_';
	$_display_dat['module'] = 'system/backend';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($titletext, $text);
}

?>