<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

global $opnConfig;
if (!function_exists ('get_var') ) {

	function get_var ($key, &$value, $type, $check = '', $prefix = false) {

		global $opnConfig, ${$opnConfig['opn_post_vars']}, ${$opnConfig['opn_get_vars']}, ${$opnConfig['opn_server_vars']}, ${$opnConfig['opn_file_vars']}, ${$opnConfig['opn_cookie_vars']}, ${$opnConfig['opn_session_vars']}, ${$opnConfig['opn_request_vars']}, ${$opnConfig['opn_env_vars']};

		$t = $check;
		$t = $prefix;
		$vars = array ();
		switch ($type) {
			case 'url':
				$vars = ${$opnConfig['opn_get_vars']};
				break;
			case 'form':
				$vars = ${$opnConfig['opn_post_vars']};
				break;
			case 'both':
				$vars = ${$opnConfig['opn_request_vars']};
				break;
			case 'server':
				$vars = ${$opnConfig['opn_server_vars']};
				break;
			case 'cookie':
				$vars = ${$opnConfig['opn_cookie_vars']};
				break;
			case 'session':
				$vars = ${$opnConfig['opn_session_vars']};
				break;
			case 'env':
				$vars = ${$opnConfig['opn_env_vars']};
				break;
			case 'file':
				$vars = ${$opnConfig['opn_file_vars']};
				break;
		}
		// switch
		if (isset ($vars[$key]) ) {
			$val = $vars[$key];
			unset ($vars);
			$value = $val;
		}

	}
}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
if ($op != '') {
	if ($op == 'send') {
		define ('_OPN_SKIP_COMPRESSION', 'TRUE');
		if (!defined ('_OPN_XP_ERRORTYPE') ) {
			define ('_OPN_XP_ERRORTYPE', 1);
		}
		define ('_SQLLAYER_ERROR_HANDLER_NO', 1);
		if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
			include ('../../../mainfile.php');
		}
		$opnConfig['module']->InitModule ('system/dbbackup', true);
	} else {
		include ('admin_header.php');
	}
} else {
	include ('admin_header.php');
}
$showcolumns = true;
getLanguageDef (_OPN_ROOT_PATH . 'system/dbbackup/admin/language/');
$boxtitle = _DBBACKUP_TITLE . $opnConfig['dbname'];

function dbbackupConfigHeader () {

	global $opnConfig;

	$opnConfig['opnOutput']->DisplayHead ();
	$menu = & new OPN_Adminmenu (_DBBACKUP_TITLE);
	$menu->InsertEntry (_DBBACKUP_DOIT1, array ($opnConfig['opn_url'] . '/system/dbbackup/admin/index.php',
						'op' => 'send',
						'mode' => 'complete') );
	$menu->InsertEntry (_DBBACKUP_DOIT2, array ($opnConfig['opn_url'] . '/system/dbbackup/admin/index.php',
						'op' => 'send',
						'mode' => 'opnonly') );
	$menu->SetAdminLink ();
	$menu->DisplayMenu ();
	unset ($menu);

}
// Return $table's CREATE definition
// Returns a string containing the CREATE statement on success

function get_table_def ($table, $crlf) {

	global $opnConfig;

	$schema_create = 'DROP TABLE IF EXISTS ' . $table . ';' . $crlf;
	$schema_create .= 'CREATE TABLE ' . $table . ' (' . $crlf;
	$fields = $opnConfig['database']->MetaColumns ($table);
	foreach ($fields as $row) {
		$schema_create .= '   ' . $row->name . ' ';
		if ($row->max_length != -1) {
			$schema_create .= $row->type . '(' . $row->max_length . ')';
		} else {
			$schema_create .= $row->type;
		}
		if ($row->has_default == 1) {
			$schema_create .= " DEFAULT '" . $row->default_value . "'";
		}
		if ($row->not_null == 1) {
			$schema_create .= ' NOT NULL';
		}
		$schema_create .= ',' . $crlf;
	}
	$schema_create = preg_replace ('/,' . $crlf . '$/', '', $schema_create);
	$index = $opnConfig['database']->MetaIndexes ($table, true);
	if (is_array ($index) ) {
		foreach ($index as $key => $value) {
			$schema_create .= ',' . $crlf;
			if ($key == 'PRIMARY') {
				$schema_create .= '   PRIMARY KEY (' . implode ($value['columns'], ', ') . ')';
			} elseif ($value['unique']) {
				$schema_create .= '   UNIQUE ' . $key . ' (' . implode ($value['columns'], ', ') . ')';
			} else {
				$schema_create .= '   KEY ' . $key . ' (' . implode ($value['columns'], ', ') . ')';
			}
		}
	}
	$schema_create .= $crlf . ')';
	return (stripslashes ($schema_create) );

}
// Get the content of $table as a series of INSERT statements.
// After every row, a custom callback function $handler gets called.
// $handler must accept one parameter ($sql_insert);

function get_table_content ($table, $crlf) {

	global $opnConfig;

	$result = &$opnConfig['database']->Execute ('SELECT * FROM ' . $table);
	$i = 0;
	$collector = '';
	while (! $result->EOF) {
		$table_list = '(';
		$num_fields = $result->FieldCount ();
		for ($j = 0; $j< $num_fields; $j++) {
			$field = $result->FetchField ($j);
			$table_list .= $field->name . ', ';
		}
		$table_list = substr ($table_list, 0, -2);
		$table_list .= ')';
		if (isset ($GLOBALS['showcolumns']) ) {
			$schema_insert = 'INSERT INTO ' . $table . ' ' . $table_list . ' VALUES (';
		} else {
			$schema_insert = 'INSERT INTO ' . $table . ' VALUES (';
		}
		for ($j = 0; $j< $num_fields; $j++) {
			if (!isset ($result->fields[$j]) ) {
				$schema_insert .= ' NULL,';
			} elseif ($result->fields[$j] != '') {
				$schema_insert .= " '" . addslashes ($result->fields[$j]) . "',";
			} else {
				$schema_insert .= " '',";
			}
		}
		$schema_insert = preg_replace ('/,$/', '', $schema_insert);
		$schema_insert .= ')';
		$collector .= trim ($schema_insert) . ';' . $crlf;
		$i++;
		$result->MoveNext ();
	}
	return $collector;
	// return (true);

}

function dobackup ($backupdate) {

	global $opnConfig, $mode;
	// get the system
	// later! we can use $opnConfig['ossystem']
	$client = getenv ('HTTP_USER_AGENT');
	$crlf = _OPN_HTML_NL;
	$regs = '';
	if (preg_match ('/[^(]*\((.*)\)[^)]*/', $client, $regs) ) {
		$os = $regs[1];
		if (preg_match ('/Win/i', $os) ) {
			$crlf = _OPN_HTML_CRLF;
		} elseif (preg_match ("/Mac/i", $os) ) {
			$crlf = _OPN_HTML_LF;
		} else {
			$crlf = _OPN_HTML_NL;
		}
	}
	$userinfo = $opnConfig['permission']->GetUserinfo ();
	$tables = $opnConfig['database']->MetaTables ();
	$num_tables = count ($tables);
	if ($num_tables == 0) {
		echo _DBBACKUP_NOTABLESFOUND;
		die ();
	} else {
		$heure_jour = date ('H:i');
		$buffer = '# ========================================================' . $crlf;
		$buffer .= '# This Backup was made with OPN DB-Backup                 ' . $crlf;
		$buffer .= '# http://www.openphpnuke.info                             ' . $crlf;
		$buffer .= '#                                                         ' . $crlf;
		$buffer .= '# ' . _DBBACKUP_NAME . ' : ' . $opnConfig['dbname'] . '           ' . $crlf;
		$buffer .= '# ' . _DBBACKUP_DONE . ' ' . $backupdate . '&nbsp;' . _DBBACKUP_AT . ' ' . $heure_jour . '&nbsp;' . _DBBACKUP_BY . ' ' . $userinfo['uname'] . '!' . $crlf;
		$buffer .= '#                                                         ' . $crlf;
		$buffer .= '# ========================================================' . $crlf;
		$buffer .= $crlf;
		echo $buffer;
		foreach ($tables as $table) {
			if ($mode == 'opnonly') {
				$pos = strpos ($table, $opnConfig['tableprefix']);
				if ($pos === false) {
					$dobackup = false;
				} else {
					$dobackup = true;
				}
			} else {
				$dobackup = true;
			}
			if ($dobackup) {
				echo $crlf;
				echo '# --------------------------------------------------------' . $crlf;
				echo '#' . $crlf;
				echo '# ' . _DBBACKUP_TABLESTRUCTURE . ' "' . $table . '"' . $crlf;
				echo '#' . $crlf;
				echo $crlf;
				echo get_table_def ($table, $crlf) . ';' . $crlf . $crlf;
				echo '#' . $crlf;
				echo '# ' . _DBBACKUP_DUMPINGDATA . ' "' . $table . '"' . $crlf;
				echo '#' . $crlf;
				echo $crlf;
				echo get_table_content ($table, $crlf);
			}
		}
		// return $buffer;
	}

}

function dosend () {

	global $opnConfig;
	if (!$opnConfig['opn_host_use_safemode']) {
		@set_time_limit (600);
	}
	$opnConfig['opndate']->now ();
	$backupdate = '';
	$opnConfig['opndate']->formatTimestamp ($backupdate, _DATE_DATESTRING6);
	$filename = _DBBACKUP_FILENAME . '_(' . $opnConfig['dbname'] . ')_' . $backupdate . '.sql';

	/* PLEASE DON'T TOUCH THIS !
	* I know it should be a octet-stream and this an that, but some Browser will not display the
	* download dialog. Using this (found in phpmyadmin (thank you guys !)
	* seems to work on known browsers (for me).
	* Alex (xweber)
	*/
	// loic1: 'application/octet-stream' is the registered IANA type but
	// MSIE and Opera seems to prefer 'application/octetstream'
	$ISIE = FALSE;
	$ISOPERA = FALSE;
	if (isset ($opnConfig['opnOption']['client']) ) {
		switch ($opnConfig['opnOption']['client']->property ('long_name') ) {
			case 'msie':
				$ISIE = TRUE;
				break;
			case 'opera':
				$ISOPERA = TRUE;
				break;
		}
	}
	if ( ($ISIE) OR ($ISOPERA) ) {
		header ('content-type: application/octetstream');
	} else {
		header ('content-type: application/octet-stream; name="' . $filename . '"');
	}
	// if($ISIE) {
	// header ('content-disposition: inline; filename="'.$filename.'"');
	// header ('expires: 0');
	// header ('cache-control: must-revalidate, post-check=0, pre-check=0');
	// header ('pragma: public');
	// } else {
	header ('content-disposition: attachment; filename="' . $filename . '"');
	header ('expires: 0');
	header ('pragma: no-cache');
	// }
	dobackup ($backupdate);

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
switch ($op) {
	case 'send':
		dosend ();
		break;
	default:
		dbbackupConfigHeader ();
		$opnConfig['opnOutput']->DisplayFoot ();
		break;
}

?>