<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/forum/plugin/search/language/');

function forum_is_user_ein_moderator ($user_id) {

	global $opnTables, $opnConfig;

	$sql = 'SELECT uid FROM ' . $opnTables['users_status'] . ' WHERE (level1 = ' . _PERM_USER_STATUS_MODERATOR . ' AND uid = ' . $user_id . ')';
	$result = &$opnConfig['database']->Execute ($sql);
	if ($result === false) {
		return 0;
	}
	$myrow = $result->GetRowAssoc ('0');
	if ($myrow['uid'] != '') {
		return 1;
	}
	return 0;

}

function forum_Get_user_access_OK_for_Forum ($user_id, $forum_id) {

	global $opnTables, $opnConfig;

	$sql = 'SELECT forum_id, forum_access FROM ' . $opnTables['forum'] . ' WHERE forum_id=' . $forum_id . ' AND forum_type=0';
	$result = &$opnConfig['database']->Execute ($sql);
	$myrow = $result->GetRowAssoc ('0');
	if ($myrow['forum_id'] != '') {
		if ($myrow['forum_access'] == '0') {
			return 1;
		}
		if ($myrow['forum_access'] == '1') {
			if (! ( ($user_id == '') OR ($user_id == '1') ) ) {
				return 1;
			}
		} elseif ($myrow['forum_access'] == '2') {
			if ( (forum_is_user_ein_moderator ($user_id) ) OR ($opnConfig['permission']->HasRight ('system/forum', _PERM_ADMIN, true) ) ) {
				return 1;
			}
		}
	} else {
		$sql = 'SELECT group_id FROM ' . $opnTables['forum_access_groups'] . ' WHERE forum_id=' . $forum_id;
		$result = &$opnConfig['database']->Execute ($sql);
		while (! $result->EOF) {
			if ($opnConfig['permission']->CheckUserGroup ($result->fields['group_id']) ) {
				return 1;
			}
			$result->MoveNext ();
		}
		// while
		$sql = 'SELECT forum_id FROM ' . $opnTables['forum_access_user'] . ' WHERE user_id=' . $user_id . ' AND forum_id=' . $forum_id;
		$result = &$opnConfig['database']->Execute ($sql);
		$myrow = $result->GetRowAssoc ('0');
		if ($myrow['forum_id'] != '') {
			if ( ($user_id == '') OR ($user_id == '1') ) {
				return 0;
			}
			return 1;
		}
	}
	return 0;

}

function forum_retrieve_searchbuttons (&$buttons) {

	$button['name'] = 'forum';
	$button['sel'] = 0;
	$button['label'] = _FORUM_SEARCH_FORUM;
	$buttons[] = $button;
	unset ($button);

}

function forum_retrieve_search ($type, $query, &$data, &$sap) {
	switch ($type) {
		case 'forum':
			forum_retrieve_all ($query, $data, $sap);
		}
	}

	function forum_retrieve_all ($query, &$data, &$sap) {

		global $opnConfig;

		$ui = $opnConfig['permission']->GetUserinfo ();
		$q = forum_get_query ($query);
		$q .= forum_get_orderby ();
		$result = &$opnConfig['database']->Execute ($q);
		if ($result !== false) {
			$nrows = $result->RecordCount ();
		} else {
			$nrows = 0;
		}
		$hlp1 = array ();
		if ($nrows>0) {
			$hlp1['data'] = _FORUM_SEARCH_FORUM;
			$hlp1['ishead'] = true;
			$data[] = $hlp1;
			while (! $result->EOF) {
				$forum_id = $result->fields['forum_id'];
				$topic_id = $result->fields['topic_id'];
				$uname = $result->fields['uname'];
				$post_time = $result->fields['post_time'];
				$topic_title = $result->fields['topic_title'];
				if ($topic_title == '') {
					$topic_title = '---';
				}
				if (forum_Get_user_access_OK_for_Forum ($ui['uid'], $forum_id) ) {
					$hlp1['data'] = forum_build_link ($forum_id, $topic_id, $uname, $post_time, $topic_title);
					$hlp1['ishead'] = false;
					$data[] = $hlp1;
				}
				$result->MoveNext ();
			}
			unset ($hlp1);
			$sap++;
			$result->Close ();
		}

	}

	function forum_get_query ($query) {

		global $opnTables, $opnConfig;

		$opnConfig['opn_searching_class']->init ();
		$opnConfig['opn_searching_class']->SetFields (array ('f.forum_id AS forum_id',
								'p.topic_id AS topic_id',
								'u.uname AS uname',
								'p.post_time AS post_time',
								't.topic_title AS topic_title') );
		$opnConfig['opn_searching_class']->SetTable ($opnTables['forum_posts'] . ' p, ' . $opnTables['users'] . ' u, ' . $opnTables['forum'] . ' f,' . $opnTables['forum_topics'] . ' t ');
		$opnConfig['opn_searching_class']->SetWhere ('((p.topic_id = t.topic_id) AND (p.forum_id = f.forum_id) AND (p.poster_id = u.uid)) AND');
		$opnConfig['opn_searching_class']->SetQuery ($query);
		$opnConfig['opn_searching_class']->SetSearchfields (array ('p.post_text',
									'u.uname',
									't.topic_title',
									'f.forum_name') );
		return $opnConfig['opn_searching_class']->GetSQL ();

}

function forum_get_orderby () {
	return ' ORDER BY p.post_time DESC';

}

function forum_build_link ($forum_id, $topic_id, $uname, $post_time, $topic_title) {

	global $opnConfig;

	$furl = encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
				'topic' => $topic_id,
				'forum' => $forum_id) );
	$surl = encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
				'op' => 'userinfo',
				'uname' => $uname) );
	$hlp = '<a class="%linkclass%" href="' . $furl . '">' . stripslashes ($topic_title) . '</a> ';
	$hlp .= _FORUM_SEARCH_BY . ' <a class="%linkclass%" href="' . $surl . '">' . $uname . '</a> ';
	$opnConfig['opndate']->sqlToopnData ($post_time);
	$temp = '';
	$opnConfig['opndate']->formatTimestamp ($temp, _DATE_DATESTRING5);
	$hlp .= _FORUM_SEARCH_ON . ' ' . $temp;
	return $hlp;

}

?>