<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function forum_show_the_user_addon_info ($usernr, &$func) {

	global $opnTables, $opnConfig;

	getLanguageDef (_OPN_ROOT_PATH . 'system/forum/plugin/user/language/');
	include_once (_OPN_ROOT_PATH . 'system/forum/functions.php');
	$ui = $opnConfig['permission']->GetUser ($usernr, 'useruid', '');
	$uname = $ui['uname'];
	$help = '<span class="normaltextbold">' . _FORUM_LAST10POSTINGS . ' ' . $uname . '</span><br />';
	$inlist = get_forumlist_user_can_see ();
	$num = 0;
	if ($inlist != '') {
		$i = explode (',', $inlist);
		$query = 'SELECT post_text, forum_id, topic_id FROM ' . $opnTables['forum_posts'] . ' WHERE ';
		$query .= ' (forum_id IN (' . $inlist . '))';
		$query .= ' AND (poster_id=' . $usernr . ') ORDER BY post_time DESC';
		unset ($inlist);
		$result = &$opnConfig['database']->SelectLimit ($query, 10);
		if ($result !== false) {
			while (! $result->EOF) {
				$post_text = strip_tags ($result->fields['post_text']);
				$post_text = str_replace ('[addsig]', '', $post_text);
				$opnConfig['cleantext']->opn_shortentext ($post_text, 100, false, true);
				$forum_id = $result->fields['forum_id'];
				$topic_id = $result->fields['topic_id'];
				$help .= '&bull; <a class="opncenterbox" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/forum/viewtopic.php',
												'topic' => $topic_id,
												'forum' => $forum_id) ) . '">' . $post_text . '</a><br />';
				$num++;
				$result->MoveNext ();
			}
			$result->Close ();
		}
		unset ($result);
	}
	$boxtext = '';
	if ($num != 0) {
		$boxtext .= '<br />' . $help;
	}
	$func['position'] = 100;
	return $boxtext;

}

function forum_show_short_the_user_addon_info ($user_id) {

	global $opnTables, $opnConfig;

	static $specialrangs = array ();
	if (count ($specialrangs) == 0) {
		$result_url = $opnConfig['database']->Execute ('SELECT nummer, specialrang_url FROM ' . $opnTables['forum_specialrang'] . ' ORDER BY nummer');
		if ($result_url !== false) {
			while (! $result_url->EOF) {
				$specialrangs[$result_url->fields['nummer']] = $result_url->fields['specialrang_url'];
				$result_url->MoveNext ();
			}
			$result_url->Close ();
			if (count ($specialrangs) == 0) {
				$specialrangs[0] = 'N/A';
			}
		} else {
			$specialrangs[0] = 'N/A';
		}
		unset ($result_url);
	}
	if ($user_id >= 2) {
		$ui = $opnConfig['permission']->GetUser ($user_id, 'useruid', '');
		$level = $ui['level1'];
		$specialrang = $ui['specialrang'];
		$groups = $opnConfig['permission']->GetUserGroupsUser ($user_id);
		unset ($ui);
	} else {
		return '';
	}
	$txt = '';
	if ($level == 2) {
		$txt .= '<img class="imgtag" src="' . $opnConfig['opn_url'] . '/system/forum/images/forum/specialrang/mod.gif" alt="" />';
	}
	if ( ($specialrang != '0') && ($specialrang != '') && ($specialrang != 'Moderator') ) {
		if (isset ($specialrangs[$specialrang]) ) {
			$txt .= '<img class="imgtag" src="' . $opnConfig['datasave']['forum_specialrang']['url'] . '/' . $specialrangs[$specialrang] . '" alt="" />';
		}
		$txt .= '<img class="imgtag" src="' . $opnConfig['datasave']['forum_specialrang']['url'] . '/' . $specialrang . '" alt="" />';
	}
	if ($groups != '') {
		$result = $opnConfig['database']->Execute ('SELECT specialrang FROM ' . $opnTables['forum_group_special'] . ' WHERE gid IN (' . $groups . ')');
		if ($result !== false) {
			while (! $result->EOF) {
				$specialrang = $result->fields['specialrang'];
				if ($specialrang != '') {
					$txt .= '<img class="imgtag" src="' . $opnConfig['datasave']['forum_specialrang']['url'] . '/' . $specialrang . '" alt="" />';
				}
				$result->MoveNext ();
			}
			$result->Close ();
		}
	}
	return $txt;

}

function forum_api (&$option) {

	$op = $option['op'];
	$uid = $option['uid'];
	switch ($op) {
		case 'show_page':
			$option['content'] = forum_show_the_user_addon_info ($uid, $option['data']);
			break;
		case 'show_uname_add':
			$option['content'] = forum_show_short_the_user_addon_info ($uid);
			break;
		default:
			break;
	}

}

?>