<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

getLanguageDef (_OPN_ROOT_PATH . 'system/lastseen/language/');

function makeLastSeen (&$body, $limit, $cssc = 'smalltext', $short = false) {

	global $opnConfig, $opnTables;

	$lang = array ();
	if ($short) {
		$lang['_LSEEN_DAY'] = _LSEEN_DAY_SHORT;
		$lang['_LSEEN_DAYS'] = _LSEEN_DAYS_SHORT;
		$lang['_LSEEN_HOUR'] = _LSEEN_HOUR_SHORT;
		$lang['_LSEEN_HOURS'] = _LSEEN_HOURS_SHORT;
		$lang['_LSEEN_MINUTE'] = _LSEEN_MINUTE_SHORT;
		$lang['_LSEEN_MINUTES'] = _LSEEN_MINUTES_SHORT;
		$lang['_LSEEN_SECONDS'] = _LSEEN_SECONDS_SHORT;
	} else {
		$lang['_LSEEN_DAY'] = _LSEEN_DAY;
		$lang['_LSEEN_DAYS'] = _LSEEN_DAYS;
		$lang['_LSEEN_HOUR'] = _LSEEN_HOUR;
		$lang['_LSEEN_HOURS'] = _LSEEN_HOURS;
		$lang['_LSEEN_MINUTE'] = _LSEEN_MINUTE;
		$lang['_LSEEN_MINUTES'] = _LSEEN_MINUTES;
		$lang['_LSEEN_SECONDS'] = _LSEEN_SECONDS;
	}
	if ($opnConfig['opnOption']['user_login']) {
		$ui = $opnConfig['permission']->GetUserinfo ();
		$username = $ui['uname'];
		if ($username == $opnConfig['opn_anonymous_name']) {
			$username = '';
		}
	} else {
		$username = '';
	}
	$days = 0;
	$hours = 0;
	$mins = 0;
	$_username = $opnConfig['opnSQL']->qstr ($username);
	$result = &$opnConfig['database']->SelectLimit ('SELECT ul.username AS username, ul.lastseendate AS lastseendate FROM ' . $opnTables['lastseen'] . ' ul, ' . $opnTables['users_status'] . ' us, ' . $opnTables['users'] . ' u WHERE ((us.level1<>' . _PERM_USER_STATUS_DELETE . ') and (us.uid=u.uid) and (ul.username=u.uname) and (ul.username<>' . $_username . ') and (u.uname<>' . $_username . ') AND (u.uid<>' . $opnConfig['opn_anonymous_id'] . ')) ORDER BY ul.lastseendate DESC', $limit);
	if ($result !== false) {
		$body .= '<span class="' . $cssc . '">' . _OPN_HTML_NL;
		if ($result->EOF) {
			$body .= '&nbsp;';
		}
		while (! $result->EOF) {
			$uname = $result->fields['username'];
			$date = $result->fields['lastseendate'];
			$realtime = time ()- $date;
			$dont = false;
			// how many days ago?
			if ($realtime >= (172800) ) {
				// if it's been more than 2 days
				$days = floor ($realtime/ (86400) );
				$dont = true;
			} else
			if ($realtime >= (86400) ) {
				// if it's been less than 2 days
				$days = 1;
				$realtime -= (86400);
			}
			if (!$dont) {
				// how many hours ago?
				if ($realtime >= (3600) ) {
					// $body .= " ($realtime) ";
					$hours = floor ($realtime/ (3600) );
					$realtime -= (3600* $hours);
				}
				// how many minutes ago?
				if ($realtime >= 60) {
					$mins = floor ($realtime/60);
					$realtime -= (60* $mins);
				}
				// just a little precation, although I don't *think* mins will ever be 60...
				if ($mins == 60) {
					$mins = 0;
					$hours += 1;
				}
			}
			$body .= '<a class="' . $cssc . '" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
											'op' => 'userinfo',
											'uname' => $uname) ) . '">' . $uname . '</a>';
			$body .= ':  ';
			if ($dont) {
				$body .= ' ' . $days . '&nbsp;' . $lang['_LSEEN_DAYS'];
			} else {
				if ($days>0) {
					$body .= ' ' . $days . '&nbsp;' . $lang['_LSEEN_DAY'] . ( ($hours == 0 && $mins == 0)? ('') : (',') );
				}
				if ($hours>0) {
					$body .= ' ' . $hours . ' ' . ( ($hours>1)? ($lang['_LSEEN_HOURS']) : ($lang['_LSEEN_HOUR']) ) . ( ($mins == 0)? ('') : (',') );
				}
				if ($mins>0) {
					$body .= ' ' . $mins . ' ' . ( ($mins>1)? ($lang['_LSEEN_MINUTES']) : ($lang['_LSEEN_MINUTE']) );
				} else {
					// less than a minute :)
					$body .= ' ' . $realtime . '&nbsp;' . $lang['_LSEEN_SECONDS'];
				}
			}
			$body .= '<br />';
			$days = 0;
			$hours = 0;
			$mins = 0;
			$dont = false;
			$result->MoveNext ();
		}
		$body .= '</span>' . _OPN_HTML_NL;
		$result->Close ();
	}

}

?>