<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_MODULE_CLASS_PM_MSG_ACTION_INCLUDED') ) {
	define ('_MODULE_CLASS_PM_MSG_ACTION_INCLUDED', 1);
	getLanguageDef (_OPN_ROOT_PATH . 'system/pm_msg/class/language/');

	class pm_msg_action_handle {
		var $_ui = false;
		var $_eh = false;

		/**
		*
		* @return void
		*/

		function pm_msg_action_handle () {

			global $opnConfig;

			$this->_ui = $opnConfig['permission']->GetUserinfo ();
			$this->_eh = & new opn_errorhandler;
			// opn_errorhandler object
			$this->_eh->SetErrorMsg ('PMMSG_0001', _PMMSG_CLASS_ERROR_PMMSG_0001);
			$this->_eh->SetErrorMsg ('PMMSG_0002', _PMMSG_CLASS_ERROR_PMMSG_0002);
			$this->_eh->SetErrorMsg ('PMMSG_0003', _PMMSG_CLASS_ERROR_PMMSG_0003);
			$this->_eh->SetErrorMsg ('PMMSG_0004', _PMMSG_CLASS_ERROR_PMMSG_0004);
			$this->_eh->SetErrorMsg ('PMMSG_0005', _PMMSG_CLASS_ERROR_PMMSG_0005);
			$this->_eh->SetErrorMsg ('PMMSG_0006', _PMMSG_CLASS_ERROR_PMMSG_0006);
			$this->_eh->SetErrorMsg ('PMMSG_0007', _PMMSG_CLASS_ERROR_PMMSG_0007);
			$this->_eh->SetErrorMsg ('PMMSG_0008', _PMMSG_CLASS_ERROR_PMMSG_0008);
			$this->_eh->SetErrorMsg ('PMMSG_0009', _PMMSG_CLASS_ERROR_PMMSG_0009);
			$this->_eh->SetErrorMsg ('PMMSG_0010', _PMMSG_CLASS_ERROR_PMMSG_0010);
			if (!isset ($opnConfig['pm_max_folder_size']) ) {
				$opnConfig['pm_max_folder_size'] = 33;
			}

		}

		/**
		*
		* @param $options
		* @return void
		*/

		function delete_all_messages ($options) {

			global $opnConfig, $opnTables;

			$where = '';
			$day = $options['day'];
			$year = $options['year'];
			$month = $options['month'];
			if ( ($year != 0) && ($day != 0) && ($month != 0) ) {
				if ($day<10) {
					$day = '0' . $day;
				}
				$opnConfig['opndate']->setTimestamp ($year . '-' . $month . '-' . $day . ' 12:00:00');
				$date = '';
				$opnConfig['opndate']->opnDataTosql ($date);
				$where .= ' AND (msg_time<=' . $date . ') ';
			}
			if ($options['nonread_messages'] == 1) {
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['priv_msgs'] . ' WHERE (read_msg=0)' . $where);
			}
			if ($options['read_messages'] == 1) {
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_id<>0)' . $where);
				$opnConfig['database']->Execute ('DELETE FROM ' . $opnTables['priv_msgs'] . ' WHERE (read_msg=1)' . $where);
			}

		}

		/**
		*
		* @param $msg_id
		* @param $msg_cat
		* @param $safty
		* @return string
		*/

		function msg_id_delete ($msg_id, $msg_cat, $safty = true) {

			global $opnConfig, $opnTables;

			$boxtxt = '';
			if ( ($msg_cat != 5) && ($safty) ) {
				$this->_copy ($msg_id, $msg_cat, 5);
			}
			if ($msg_cat == 1) {
				$sql = 'DELETE FROM ' . $opnTables['priv_msgs'] . ' WHERE msg_id=' . $msg_id . ' AND to_userid=' . $this->_ui['uid'];
			} else {
				$sql = 'DELETE FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_id=' . $msg_id . ') AND (msg_cat=' . $msg_cat . ')';
			}
			$opnConfig['database']->Execute ($sql);
			$boxtxt .= '<div class="centertag">' . _PMMSG_YOUR_MESSAGES_HAS_BEEN_DELETED . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/pm_msg/index.php">' . _PMMSG_CLASS_YOU_CAN_CLICK_HERE_TO_VIEW_YOUR_PRIVATE_MESSAGES . '</a></div>';
			return $boxtxt;

		}

		/**
		*
		* @return string
		*/

		function fw_messages () {

			global $opnConfig, $opnTables;

			$boxtxt = '';
			$total_messages = 0;
			get_var ('total_messages', $total_messages, 'form', _OOBJ_DTYPE_INT);
			$msg_cat = 1;
			get_var ('msg_cat', $msg_cat, 'form', _OOBJ_DTYPE_INT);
			$query = &$opnConfig['database']->Execute ('SELECT allowedemail, allowedpmmail, secret FROM ' . $opnTables['priv_msgs_userdatas'] . ' WHERE uid=' . $this->_ui['uid']);
			if ($query !== false) {
				if ($query->RecordCount () == 1) {
					$allowedemail = $query->fields['allowedemail'];
					$allowedpmmail = $query->fields['allowedpmmail'];
					$secret = $query->fields['secret'];
				}
				$query->Close ();
			}
			$time = '';
			for ($i = 0; $i< $total_messages; $i++) {
				$myhelpvar2 = '';
				get_var ('msg_id_' . $i, $myhelpvar2, 'form', _OOBJ_DTYPE_CLEAN);
				if ($myhelpvar2 <> '') {
					if ($msg_cat == 1) {
						$sql = 'SELECT msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text FROM ' . $opnTables['priv_msgs'] . ' WHERE (msg_id=' . $myhelpvar2 . ') AND (to_userid = ' . $this->_ui['uid'] . ') ';
					} else {
						$sql = 'SELECT msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_id=' . $myhelpvar2 . ') AND (msg_cat=' . $msg_cat . ') AND (uid_id = ' . $this->_ui['uid'] . ') ';
					}
					$result = &$opnConfig['database']->Execute ($sql);
					if ($result === false) {
						$this->_eh->show ('PMMSG_0007');
					}
					$row = $result->GetRowAssoc ('0');
					if (!$row) {
						$this->_eh->show ('PMMSG_0008');
					}
					$fromuserdata = $opnConfig['permission']->GetUser ($row['from_userid'], 'userid', '');
					$touserdata = $opnConfig['permission']->GetUser ($row['to_userid'], 'userid', '');
					if ( ($opnConfig['opnOption']['user_login']) && ($this->_ui['uid'] != $touserdata['uid']) ) {
						$this->_eh->show ('PMMSG_0009');
					}
					$status = 1;
					if (!isset ($secret) ) {
						$secret = 0;
					}
					if ($secret == 1) {
						$row['msg_text'] = open_the_secret ($this->_ui['pass'], $row['msg_text']);
					}
					$text = $row['msg_text'];
					$text = opn_br2nl ($text);
					$Mmessage = $text . _OPN_HTML_NL;
					$Mmessage = preg_replace ('/<!--.+?-->/', '', $text);
					$Mmessage = preg_replace ('/<([^>]|\n)*>/', '', $Mmessage);
					$opnConfig['opndate']->sqlToopnData ($row['msg_time']);
					$opnConfig['opndate']->formatTimestamp ($time, _DATE_FORUMDATESTRING2);
					$subject = $row['subject'];
					$opnConfig['cleantext']->un_htmlentities ($subject);
					$opnConfig['cleantext']->un_htmlentities ($Mmessage);
					$subject = $fromuserdata['uname'] . ' (' . $time . '):' . $subject;
					if (!defined ('_OPN_MAILER_INCLUDED') ) {
						include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'mail/class.mail.php');
					}
					$mail = & new opn_mailer ();
					$mail->opn_mail_fill ($this->_ui['email'], $subject, '', '', $Mmessage, $fromuserdata['uname'], $fromuserdata['email'], true);
					$mail->send ();
					$mail->init ();
				}
				// if
			}
			OpenTable ($boxtxt);
			$boxtxt .= '<div align="center" class="normaltext">' . _PMMSG_CLASS_YOUR_MESSAGES_HAS_BEEN_PASSON . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/pm_msg/index.php">' . _PMMSG_CLASS_YOU_CAN_CLICK_HERE_TO_VIEW_YOUR_PRIVATE_MESSAGES . '</a></div>';
			CloseTable ($boxtxt);
			return $boxtxt;

		}

		/**
		*
		* @param $msg_id
		* @param $msg_cat_old
		* @param $msg_cat_new
		* @return void
		*/

		function _copy ($msg_id, $msg_cat_old, $msg_cat_new) {

			global $opnConfig, $opnTables;
			if ($msg_cat_old == 1) {
				$sql = 'SELECT msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text FROM ' . $opnTables['priv_msgs'] . ' WHERE (msg_id=' . $msg_id . ') AND (to_userid = ' . $this->_ui['uid'] . ') ';
			} else {
				$sql = 'SELECT msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_id=' . $msg_id . ') AND (msg_cat=' . $msg_cat_old . ') AND (uid_id = ' . $this->_ui['uid'] . ') ';
			}
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (!$result->EOF) ) {
				$row = $result->GetRowAssoc ('0');
				$message = $opnConfig['opnSQL']->qstr ($row['msg_text'], 'msg_text');
				$subject = $opnConfig['opnSQL']->qstr ($row['subject']);
				$msgiconselect = $opnConfig['opnSQL']->qstr ($row['msg_image']);
				if ($msg_cat_new == 1) {
					$msg_id = $opnConfig['opnSQL']->get_new_number ('priv_msgs', 'msg_id');
					$sql = 'INSERT INTO ' . $opnTables['priv_msgs'] . ' VALUES (' . $msg_id . ', ' . $msgiconselect . ', ' . $subject . ', ' . $row['from_userid'] . ', ' . $row['to_userid'] . ', ' . $row['msg_time'] . ', ' . $message . ', 1)';
					$opnConfig['database']->Execute ($sql);
					$opnConfig['opnSQL']->UpdateBlobs ($opnTables['priv_msgs'], 'msg_id=' . $msg_id);
				} else {
					$msg_id = $opnConfig['opnSQL']->get_new_number ('priv_msgs_save', 'msg_id');
					$sql = 'INSERT INTO ' . $opnTables['priv_msgs_save'] . ' VALUES (' . $this->_ui['uid'] . ', ' . $msg_id . ', ' . $msgiconselect . ', ' . $subject . ', ' . $row['from_userid'] . ', ' . $row['to_userid'] . ', ' . $row['msg_time'] . ', ' . $message . ', ' . $msg_cat_new . ')';
					$opnConfig['database']->Execute ($sql);
					$opnConfig['opnSQL']->UpdateBlobs ($opnTables['priv_msgs_save'], 'msg_id=' . $msg_id);
				}
			}

		}

		/**
		*
		* @return string
		*/

		function move_messages () {

			global $opnConfig;

			$boxtxt = '';
			$total_messages = 0;
			get_var ('total_messages', $total_messages, 'form', _OOBJ_DTYPE_INT);
			$new_msg_cat = 1;
			get_var ('new_msg_cat', $new_msg_cat, 'form', _OOBJ_DTYPE_INT);
			$msg_cat = 1;
			get_var ('msg_cat', $msg_cat, 'form', _OOBJ_DTYPE_INT);
			if ($new_msg_cat <> $msg_cat) {
				for ($i = 0; $i< $total_messages; $i++) {
					$myhelpvar2 = '';
					get_var ('msg_id_' . $i, $myhelpvar2, 'form', _OOBJ_DTYPE_CLEAN);
					if ($myhelpvar2 <> '') {
						$this->_copy ($myhelpvar2, $msg_cat, $new_msg_cat);
						$this->msg_id_delete ($myhelpvar2, $msg_cat, false);
					}
				}
			}
			OpenTable ($boxtxt);
			$boxtxt .= '<div align="center" class="normaltext">' . _PMMSG_CLASS_YOUR_MESSAGES_HAS_BEEN_MOVED . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/pm_msg/index.php">' . _PMMSG_CLASS_YOU_CAN_CLICK_HERE_TO_VIEW_YOUR_PRIVATE_MESSAGES . '</a></div>';
			CloseTable ($boxtxt);
			return $boxtxt;

		}

		/**
		*
		* @param $safty
		* @return string
		*/

		function delete_messages ($safty = true) {

			global $opnConfig;

			$boxtxt = '';
			$total_messages = 0;
			get_var ('total_messages', $total_messages, 'form', _OOBJ_DTYPE_INT);
			$msg_cat = 1;
			get_var ('msg_cat', $msg_cat, 'form', _OOBJ_DTYPE_INT);
			for ($i = 0; $i< $total_messages; $i++) {
				$myhelpvar2 = '';
				get_var ('msg_id_' . $i, $myhelpvar2, 'form', _OOBJ_DTYPE_CLEAN);
				if ($myhelpvar2 <> '') {
					$this->msg_id_delete ($myhelpvar2, $msg_cat, $safty);
				}
			}
			OpenTable ($boxtxt);
			$boxtxt .= '<div class="centertag">' . _PMMSG_CLASS_YOUR_MESSAGES_HAS_BEEN_DELETED . '<br /><a class="opncenterbox" href="' . $opnConfig['opn_url'] . '/system/pm_msg/index.php">' . _PMMSG_CLASS_YOU_CAN_CLICK_HERE_TO_VIEW_YOUR_PRIVATE_MESSAGES . '</a></div>';
			CloseTable ($boxtxt);
			return $boxtxt;

		}

	}
}

?>