<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_MODULE_CLASS_PM_MSG_FOLDER_INCLUDED') ) {
	define ('_MODULE_CLASS_PM_MSG_FOLDER_INCLUDED', 1);
	include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
	getLanguageDef (_OPN_ROOT_PATH . 'system/pm_msg/class/language/');

	class pm_msg_folder_handle {
		var $_ui = false;
		var $_eh = false;
		var $_all_messages = 0;
		var $_admin = false;
		var $_script_url = '';
		var $_categorie = array ();

		function pm_msg_folder_handle ($admin = false) {

			global $opnConfig, $opnTables;

			$this->_ui = $opnConfig['permission']->GetUserinfo ();
			$this->_admin = $admin;
			$this->_eh = & new opn_errorhandler;
			// opn_errorhandler object
			$this->_eh->SetErrorMsg ('PMMSG_0001', _PMMSG_CLASS_ERROR_PMMSG_0001);
			$this->_eh->SetErrorMsg ('PMMSG_0002', _PMMSG_CLASS_ERROR_PMMSG_0002);
			$this->_eh->SetErrorMsg ('PMMSG_0003', _PMMSG_CLASS_ERROR_PMMSG_0003);
			$this->_eh->SetErrorMsg ('PMMSG_0004', _PMMSG_CLASS_ERROR_PMMSG_0004);
			$this->_eh->SetErrorMsg ('PMMSG_0005', _PMMSG_CLASS_ERROR_PMMSG_0005);
			$this->_eh->SetErrorMsg ('PMMSG_0006', _PMMSG_CLASS_ERROR_PMMSG_0006);
			$this->_eh->SetErrorMsg ('PMMSG_0007', _PMMSG_CLASS_ERROR_PMMSG_0007);
			$this->_eh->SetErrorMsg ('PMMSG_0008', _PMMSG_CLASS_ERROR_PMMSG_0008);
			$this->_eh->SetErrorMsg ('PMMSG_0009', _PMMSG_CLASS_ERROR_PMMSG_0009);
			$this->_eh->SetErrorMsg ('PMMSG_0010', _PMMSG_CLASS_ERROR_PMMSG_0010);
			if ($this->_admin) {
				$sql = 'SELECT uid, title, msg_cat FROM ' . $opnTables['priv_msgs_categorie'] . ' ORDER BY msg_cat';
			} else {
				$sql = 'SELECT uid, title, msg_cat FROM ' . $opnTables['priv_msgs_categorie'] . ' WHERE (uid=0) OR (uid=' . $this->_ui['uid'] . ') ORDER BY msg_cat';
			}
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (!$result->EOF) ) {
				while (! $result->EOF) {
					$title = $result->fields['title'];
					$msg_cat = $result->fields['msg_cat'];
					$uid = $result->fields['uid'];
					$count = $this->_count_messages_in_cat ($msg_cat);
					$this->_categorie[$msg_cat] = $title . ' (' . $count . ')';
					$this->_all_messages = $this->_all_messages+ $count;
					if ( ($this->_admin) && ($uid != 0) ) {
						$ui_d = $opnConfig['permission']->GetUser ($uid, 'useruid', '');
						$this->_categorie[$msg_cat] .= ' [' . $ui_d['uname'] . ']';
					}
					$result->MoveNext ();
				}
			}
			if (!isset ($opnConfig['pm_max_folder_size']) ) {
				$opnConfig['pm_max_folder_size'] = 33;
			}

		}

		function SetScript ($url) {

			$this->_script_url = $url;

		}

		function _count_messages_in_cat ($msg_cat) {

			global $opnConfig, $opnTables;

			$count = 0;
			if ($this->_admin) {
				if ($msg_cat == 1) {
					$sql = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs'];
				} else {
					$sql = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_cat=' . $msg_cat . ')';
				}
			} else {
				if ($msg_cat == 1) {
					$sql = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs'] . ' WHERE (to_userid = ' . $this->_ui['uid'] . ') ';
				} else {
					$sql = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_cat=' . $msg_cat . ') AND (uid_id = ' . $this->_ui['uid'] . ') ';
				}
			}
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (!$result->EOF) && ($result->RecordCount () != 0) ) {
				while (! $result->EOF) {
					$count = $result->fields['counter'];
					$result->MoveNext ();
				}
			}
			return $count;

		}

		function mk_bar ($myperc, $mycolor, $tbheight = 10, $tbwidth = '100%') {

			$rmyperc = round ($myperc, 0);
			// $mycolor1=($mycolor=='alternator2'? 'alternator4' : 'alternator3');
			$boxtxt = '<table  width="' . $tbwidth . '" style="height:' . $tbheight . 'px" border="0" cellspacing="0" cellpadding="0">' . _OPN_HTML_NL;
			if ($myperc >= 100) {
				$boxtxt .= '<tr class="' . $mycolor . '"><td width="100%" class="' . $mycolor . 'bg">';
			} elseif ($myperc<=0) {
				$boxtxt .= '<tr><td width="100%"><span class="smalltext">&nbsp;</span>';
			} else {
				$boxtxt .= '<tr class="' . $mycolor . '">' . '<td width="' . $rmyperc . '%" class="' . $mycolor . 'bg">' . '</td><td width="' . (100- $rmyperc) . '%">';
			}
			$boxtxt .= '</td></tr></table>';
			return $boxtxt;

		}

		function view_folder () {

			global $opnConfig, $opnTables;

			$boxtxt = '';
			$sortby = 'desc_pm.msg_time';
			get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
			$msg_cat = 1;
			get_var ('msg_cat', $msg_cat, 'both', _OOBJ_DTYPE_INT);
			$offset = 0;
			get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
			$url = $this->_script_url;
			$url['msg_cat'] = $msg_cat;
			$order = '';
			$newsortby = $sortby;
			OpenTable ($boxtxt);
			$boxtxt .= '<div align="left">';
			$boxtxt .= _PMMSG_CLASS_PRIVATE_MESSAGE . ' ';
			if (isset ($this->_categorie[$msg_cat]) ) {
				$boxtxt .= _PMMSG_CLASS_FOLDER . ' ';
				$boxtxt .= $this->_categorie[$msg_cat];
			}
			$boxtxt .= '</div>';
			if (!$this->_admin) {
				$boxtxt .= '<div align="right">';
				$percent = ($opnConfig['pm_max_folder_size'] <> 0?round ( ( (100* $this->_all_messages)/ $opnConfig['pm_max_folder_size']), 2) : 0);
				$boxtxt .= sprintf (_PMMSG_CLASS_BOX_FILL, number_format ($percent, 2, _DEC_POINT, _THOUSANDS_SEP) . ' %');
				$boxtxt .= $this->mk_bar ($percent, 'alternator2', 10, '100%');
				$boxtxt .= '</div>';
			}
			CloseTable ($boxtxt);
			$boxtxt .= '<br />';
			$form = & new opn_FormularClass ('alternator');
			$form->get_sort_order ($order, array ('pm.subject',
								'usb.uname',
								'usa.uname',
								'pm.msg_time'),
								$newsortby);
			if ($this->_admin) {
				if ($msg_cat == 1) {
					$sql = 'SELECT pm.msg_id as msg_id, pm.msg_image as msg_image, pm.subject as subject, pm.from_userid as from_userid, usa.uname as from_uname,pm.to_userid to_useruid, usb.uname as to_uname,pm.msg_time as msg_time, pm.msg_text as msg_text, pm.read_msg as read_msg FROM ' . $opnTables['priv_msgs'] . ' pm, ' . $opnTables['users'] . ' usa, ' . $opnTables['users'] . ' usb WHERE pm.from_userid=usa.uid and pm.to_userid=usb.uid ' . $order;
					$sql_counter = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs'];
				} else {
					$sql = 'SELECT pm.msg_id as msg_id, pm.msg_image as msg_image, pm.subject as subject, pm.from_userid as from_userid, usa.uname as from_uname,pm.to_userid to_useruid, usb.uname as to_uname,pm.msg_time as msg_time, pm.msg_text as msg_text FROM ' . $opnTables['priv_msgs_save'] . ' pm, ' . $opnTables['users'] . ' usa, ' . $opnTables['users'] . ' usb WHERE pm.from_userid=usa.uid and pm.to_userid=usb.uid AND (msg_cat=' . $msg_cat . ') ' . $order;
					$sql_counter = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_cat=' . $msg_cat . ') ';
				}
			} else {
				if ($msg_cat == 1) {
					$sql = 'SELECT pm.msg_id as msg_id, pm.msg_image as msg_image, pm.subject as subject, pm.from_userid as from_userid, usa.uname as from_uname,pm.to_userid to_useruid, usb.uname as to_uname,pm.msg_time as msg_time, pm.msg_text as msg_text, pm.read_msg as read_msg FROM ' . $opnTables['priv_msgs'] . ' pm, ' . $opnTables['users'] . ' usa, ' . $opnTables['users'] . ' usb WHERE pm.from_userid=usa.uid and pm.to_userid=usb.uid AND (to_userid = ' . $this->_ui['uid'] . ') ' . $order;
					$sql_counter = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs'] . ' WHERE (to_userid = ' . $this->_ui['uid'] . ') ';
				} else {
					$sql = 'SELECT pm.msg_id as msg_id, pm.msg_image as msg_image, pm.subject as subject, pm.from_userid as from_userid, usa.uname as from_uname,pm.to_userid to_useruid, usb.uname as to_uname,pm.msg_time as msg_time, pm.msg_text as msg_text FROM ' . $opnTables['priv_msgs_save'] . ' pm, ' . $opnTables['users'] . ' usa, ' . $opnTables['users'] . ' usb WHERE pm.from_userid=usa.uid and pm.to_userid=usb.uid AND (pm.msg_cat=' . $msg_cat . ') AND (pm.uid_id = ' . $this->_ui['uid'] . ') ' . $order;
					$sql_counter = 'SELECT COUNT(msg_id) AS counter FROM ' . $opnTables['priv_msgs_save'] . ' WHERE (msg_cat=' . $msg_cat . ') AND (uid_id = ' . $this->_ui['uid'] . ') ';
				}
			}
			$justforcounting = &$opnConfig['database']->Execute ($sql_counter);
			if ( (is_object ($justforcounting) ) && (isset ($justforcounting->fields['counter']) ) ) {
				$reccount = $justforcounting->fields['counter'];
			} else {
				$reccount = 0;
			}
			unset ($justforcounting);
			$result = &$opnConfig['database']->SelectLimit ($sql, $opnConfig['opn_gfx_defaultlistrows'], $offset);
			if ( ($result !== false) && (!$result->EOF) && ($result->RecordCount () != 0) ) {
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_PM_MSG_130_', 'pm_msg');
				$form->Init ($opnConfig['opn_url'] . '/system/pm_msg/pm_action.php', 'post', 'prvmsg');
				$form->AddTable ();
				$form->AddCols (array ('2%', '5%', '5%', '5%', '10%', '57%', '16%') );
				$form->SetIsHeader (true);
				$form->AddOpenHeadRow ();
				if (!$this->_admin) {
					$form->AddCheckbox ('allbox', 'Check All', 0, 'CheckAll(\'prvmsg\',\'allbox\');');
				} else {
					$form->AddText ('&nbsp;');
				}
				$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/download.gif" alt="" />');
				$form->AddText ('&nbsp;');
				$form->AddText ($form->get_sort_feld ('usb.uname', _PMMSG_CLASS_TO, $url) );
				$form->AddText ($form->get_sort_feld ('usa.uname', _PMMSG_CLASS_FROM, $url) );
				$form->AddText ($form->get_sort_feld ('pm.subject', _PMMSG_CLASS_SUBJECT, $url) );
				$form->AddText ($form->get_sort_feld ('pm.msg_time', _PMMSG_CLASS_DATE, $url) );
				$form->AddCloseRow ();
				$form->SetIsHeader (false);
				$count = 0;
				$total_messages = $result->RecordCount ();
				$time = '';
				while (! $result->EOF) {
					$myrow = $result->GetRowAssoc ('0');
					$form->AddOpenRow ();
					$form->SetAlign ('center');
					if (!$this->_admin) {
						$form->AddCheckbox ('msg_id_' . $count, $myrow['msg_id'], 0, 'CheckCheckAll(\'prvmsg\',\'allbox\');');
					} else {
						$form->AddText ('&nbsp;');
					}
					if ( (!isset ($myrow['read_msg']) ) OR ($myrow['read_msg'] == 1) ) {
						$form->AddText ('&nbsp;');
					} else {
						$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/read.gif" class="imgtag" alt="' . _PMMSG_CLASS_NOTREAD . '" title="' . _PMMSG_CLASS_NOTREAD . '" />');
					}
					if ($myrow['msg_image'] != '') {
						$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/system/pm_msg/images/subject/' . $myrow['msg_image'] . '" class="imgtag" alt="" />');
					} else {
						$form->AddText ('&nbsp;');
					}
					$form->AddText ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
													'op' => 'userinfo',
													'uname' => $myrow['to_uname']) ) . '">' . api_user_name ($myrow['to_uname']) . '</a>');
					$form->AddText ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user/index.php',
													'op' => 'userinfo',
													'uname' => $myrow['from_uname']) ) . '">' . api_user_name ($myrow['from_uname']) . '</a>');
					$form->SetAlign ('left');
					if (!$this->_admin) {
						$form->AddText ('<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/pm_msg/readpmsg.php',
														'start' => $count,
														'total_messages' => $total_messages,
														_OPN_VAR_TABLE_SORT_VAR => $sortby,
														'msg_id' => $myrow['msg_id'],
														'msg_cat' => $msg_cat) ) . '">' . $myrow['subject'] . '</a>');
					} else {
						$d_arr = $this->_script_url;
						$d_arr['start'] = $count;
						$d_arr['total_messages'] = $total_messages;
						$d_arr[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
						$d_arr['msg_id'] = $myrow['msg_id'];
						$d_arr['msg_cat'] = $msg_cat;
						$form->AddText ('<a class="%alternate%" href="' . encodeurl ($d_arr) . '">' . $myrow['subject'] . '</a>');
					}
					$form->SetAlign ('center');
					$opnConfig['opndate']->sqlToopnData ($myrow['msg_time']);
					$opnConfig['opndate']->formatTimestamp ($time, _DATE_FORUMDATESTRING2);
					$form->AddText ($time);
					$form->AddCloseRow ();
					$count++;
					$result->MoveNext ();
				}
				if (!$this->_admin) {
					$form->AddOpenRow ();
					$form->SetAlign ('left');
					$form->SetColspan ('7');
					$form->SetSameCol ();
					$form->AddSubmit ('delete_messages', _PMMSG_CLASS_DELETE_PM);
					$form->AddText ('&nbsp;');
					$form->AddSubmit ('fw_messages', _PMMSG_CLASS_FORWARD_PM);
					$form->AddText ('&nbsp;');
					$form->AddSubmit ('hard_delete_messages', _PMMSG_CLASS_HARD_DELETE_PM);
					$form->AddHidden ('total_messages', $total_messages);
					$form->AddHidden ('msg_cat', $msg_cat);
					$form->SetEndCol ();
					$form->AddCloseRow ();
					$form->AddOpenRow ();
					$form->SetAlign ('left');
					$form->SetColspan ('7');
					$form->SetSameCol ();
					$form->AddSubmit ('move_messages', _PMMSG_CLASS_MOVE);
					$form->AddText ('&nbsp;');
					$form->AddText (_PMMSG_CLASS_MOVE_TO);
					$form->AddText ('&nbsp;');
					$form->AddSelect ('new_msg_cat', $this->_categorie, $msg_cat);
					$form->AddHidden ('total_messages', $total_messages);
					$form->AddHidden ('msg_cat', $msg_cat);
					$form->SetEndCol ();
					$form->AddCloseRow ();
				}
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$form->GetFormular ($boxtxt);
			} else {
				OpenTable ($boxtxt);
				$boxtxt .= '<div align="center" class="normaltextbold">';
				$boxtxt .= _PMMSG_CLASS_NO_PM;
				if (isset ($this->_categorie[$msg_cat]) ) {
					$boxtxt .= _PMMSG_CLASS_IN_FOLDER . ' ';
					$boxtxt .= $this->_categorie[$msg_cat];
				}
				$boxtxt .= '</div>';
				CloseTable ($boxtxt);
			}
			if (!$this->_admin) {
				$form = & new opn_FormularClass ('listalternator');
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_PM_MSG_140_', 'pm_msg');
				$form->Init ($opnConfig['opn_url'] . '/system/pm_msg/replypmsg.php');
				$form->AddTable ();
				$form->AddCols (array ('100%') );
				$form->AddOpenRow ();
				$form->SetAlign ('left');
				$form->AddSubmit ('send', _PMMSG_CLASS_NEW_PM);
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$form->GetFormular ($boxtxt);
			}
			$form = & new opn_FormularClass ('listalternator');
			$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_PM_MSG_150_', 'pm_msg');
			$form->Init ($this->_script_url[0]);
			$form->AddTable ();
			$form->AddCols (array ('10%', '90%') );
			$form->AddOpenRow ();
			$form->AddLabel ('msg_cat', _PMMSG_CLASS_JUMP_TO_FOLDER . ' ');
			$form->SetSameCol ();
			$form->AddSelect ('msg_cat', $this->_categorie, $msg_cat);
			$form->AddText ('&nbsp;');
			$form->AddSubmit ('submit', _PMMSG_CLASS_JUMP);
			$form->SetEndCol ();
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$d_arr = $this->_script_url;
			$d_arr[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
			$d_arr['msg_cat'] = $msg_cat;
			$boxtxt .= build_pagebar ($d_arr, $reccount, $opnConfig['opn_gfx_defaultlistrows'], $offset);
			return $boxtxt;

		}

	}
}

?>