<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig, $opnTables;
if ($opnConfig['permission']->HasRights ('system/search', array (_PERM_READ, _PERM_BOT) ) ) {
	$opnConfig['module']->InitModule ('system/search');
	$opnConfig['opnOutput']->setMetaPageName ('system/search');
	getLanguageDef (_OPN_ROOT_PATH . 'system/search/language/');
	include_once (_OPN_ROOT_PATH . 'system/search/function.php');
	include_once (_OPN_ROOT_PATH . 'api/user_name.php');
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_searching.php');
	$plug = array ();
	$opnConfig['installedPlugins']->getplugin ($plug,
								'search');
	foreach ($plug as $var) {
		include_once (_OPN_ROOT_PATH . $var['plugin'] . '/plugin/search/index.php');
	}
	$opnConfig['opn_searching_class'] = & new opn_opnsearching;
	$searchAdds = retrieve_search_addons ();
	$pagesize = $opnConfig['opn_gfx_defaultlistrows'];
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_CLEAN);
	$query = '';
	get_var ('query', $query, 'both');
	$type = '';
	get_var ('type', $type, 'both', _OOBJ_DTYPE_CLEAN);
	$types = '';
	get_var ('types', $types, 'both', _OOBJ_DTYPE_CLEAN);
	if ($type != '') {
		if ( (substr_count ($type, '}')>0) OR (substr_count ($type, '%')>0) ) {
			$types = unserialize (stripslashes ($type) );
		}
		unset ($type);
	}
	if ($types == '') {
		$types[] = 'all';
	}
	$query = $opnConfig['cleantext']->filter_searchtext ($query);

	function search_get_count ($data) {

		$count = 0;
		$max = count ($data);
		for ($i = 0; $i< $max; $i++) {
			$count += count ($data[$i]['data']);
		}
		return $count;

	}

	function do_print_search ($data, $sap, $min, $max, $pagesize, $offset, $query, $types, &$boxtext) {

		global $opnConfig;

		$table = & new opn_TableClass ('alternator');
		if (count ($data)>0) {
			$maxrows = search_get_count ($data)- $sap;
			$hlp1 = array_slice ($data, $min, $max);
			foreach ($hlp1 as $value) {
				$output = str_replace ('%linkclass%', '%alternate%', $value['data']);
				if ($value['ishead']) {
					$table->AddHeaderRow (array ($output) );
					$table->ResetAlternate ();
				} else {
					$table->AddDataRow (array ($output), array ('left') );
				}
			}
		} else {
			$maxrows = 0;
			$table->AddDataRow (array ('<span class="alerttextcolor">' . _SEARCH_NO_ENTRIES . '</span>'), array ('center') );
		}
		$table->GetTable ($boxtext);
		$boxtext .= '<br />';
		include_once (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
		$boxtext .= build_pagebar (array ($opnConfig['opn_url'] . '/system/search/index.php',
						'query' => $query,
						'type' => serialize ($types) ),
						$maxrows,
						$pagesize,
						$offset);

	}
	if ( ($query != '') && ($opnConfig['search_save_searching']) ) {
		if ($opnConfig['permission']->IsUser () ) {
			$ui = $opnConfig['permission']->GetUserinfo ();
		}
		if (!isset ($ui['uid']) ) {
			$ui['uid'] = 0;
		}
		$sid = $opnConfig['opnSQL']->get_new_number ('search', 'sid');
		$searchtext = $opnConfig['opnSQL']->qstr ($query);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['search'] . " values ($sid, $searchtext, " . $ui['uid'] . ")");
	}
	$topictext = '' . _SEARCH_CONFIGDESC . '';
	$topicimage = 'AllTopics.gif';
	$boxtext = '';
	$boxtitle = $topictext;
	$boxtext .= '<script type="text/javascript">' . _OPN_HTML_NL . '<!--' . _OPN_HTML_NL . 'function TestCheckbox(thischeck) {' . _OPN_HTML_NL . '	for (var h=0;h<document.mainsearch.elements.length;h++) {' . _OPN_HTML_NL . '		var ee = document.mainsearch.elements[h];' . _OPN_HTML_NL . '		if ((ee.type=="checkbox") && (ee.value=="all")) {' . _OPN_HTML_NL . '			var allbox = document.mainsearch.elements[h];' . _OPN_HTML_NL . '		}' . _OPN_HTML_NL . '	}' . _OPN_HTML_NL . '	if (thischeck.value !="all") {' . _OPN_HTML_NL . '		var TotalOn = 0;' . _OPN_HTML_NL . '		for (var ii=0;ii<document.mainsearch.elements.length;ii++) {' . _OPN_HTML_NL . '			var eh = document.mainsearch.elements[ii];' . _OPN_HTML_NL . '			if ((eh.type=="checkbox") && (eh.value!="all")) {' . _OPN_HTML_NL . '				if (eh.checked) {' . _OPN_HTML_NL . '					TotalOn++;' . _OPN_HTML_NL . '				}' . _OPN_HTML_NL . '			}' . _OPN_HTML_NL . '		}' . _OPN_HTML_NL . '		if (TotalOn > 0) {' . _OPN_HTML_NL . '			allbox.checked=false;' . _OPN_HTML_NL . '		}' . _OPN_HTML_NL . '	} else {' . _OPN_HTML_NL . '		allbox.checked=true;' . _OPN_HTML_NL . '		for (var hh=0;hh<document.mainsearch.elements.length;hh++) {' . _OPN_HTML_NL . '			var u = document.mainsearch.elements[hh];' . _OPN_HTML_NL . '			if ((u.type=="checkbox") && (u.value!="all")) {' . _OPN_HTML_NL . '				u.checked = false;' . _OPN_HTML_NL . '			}' . _OPN_HTML_NL . '		}' . _OPN_HTML_NL . '	}' . _OPN_HTML_NL . '}' . _OPN_HTML_NL . _OPN_HTML_NL . '//-->' . _OPN_HTML_NL . '</script>' . _OPN_HTML_NL;
	$button['name'] = 'all';
	$button['sel'] = 0;
	$button['label'] = _SEARCH_ALL;
	$searchbuttons[] = $button;
	unset ($button);
	$form = & new opn_FormularClass ('default');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_SEARCH_30_', 'search');
	$form->Init ($opnConfig['opn_url'] . '/system/search/index.php', 'post', 'mainsearch');
	$form->AddTable ();
	$form->AddCols (array ('10%', '10%', '80%') );
	$form->AddOpenRow ();
	$form->AddTextfield ('query', 25, 0, $query);
	$form->AddSubmit ('submit', _SEARCH_SEARCH);
	$form->AddText ('<img src="' . $opnConfig['opn_url'] . '/system/search/images/AllTopics.gif" class="imgtag" align="right" alt="" title="" />');
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddTable ();
	$form->AddCols (array ('3%', '22%', '3%', '22%', '3%', '22%', '3%', '22%') );
	$form->AddOpenRow ();
	$form->SetColspan ('8');
	$form->AddText (_SEARCH_SEARCH_ON);
	$form->SetColspan ('');
	$form->AddChangeRow ();
	$max = count ($searchAdds);
	for ($i = 0; $i< $max; $i++) {
		$myfunc = $searchAdds[$i] . '_retrieve_searchbuttons';
		$myfunc ($searchbuttons);
	}
	$max = count ($searchbuttons);
	for ($i = 0; $i< $max; $i++) {
		$max1 = count ($types);
		for ($j = 0; $j< $max1; $j++) {
			if ($searchbuttons[$i]['name'] == $types[$j]) {
				$searchbuttons[$i]['sel'] = 1;
			}
		}
	}
	$cnt = 0;
	$max = count ($searchbuttons);
	for ($i = 0; $i< $max; $i++) {
		if ($cnt>3) {
			$form->AddChangeRow ();
			$cnt = 0;
		}
		$form->AddCheckbox ('types[]', $searchbuttons[$i]['name'], $searchbuttons[$i]['sel'], 'TestCheckbox(this);');
		$form->AddLabel ('types[]', $searchbuttons[$i]['label'], 1);
		$cnt++;
	}
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtext);
	$boxtext .= '<br />';
	$min = $offset;
	// This is WHERE we start our record set from
	$max = $pagesize;
	// This is how many rows to select
	$data = array ();
	$sap = 0;
	if ($types[0] != 'all') {
		$maxi = count ($searchAdds);
		for ($i = 0; $i< $maxi; $i++) {
			$myfunc = $searchAdds[$i] . '_retrieve_search';
			$max1 = count ($types);
			for ($j = 0; $j< $max1; $j++) {
				$mytemp = $myfunc ($types[$j], $query, $data, $sap);
			}
		}
		do_print_search ($data, $sap, $min, $max, $pagesize, $offset, $query, $types, $boxtext);
	} else {
		if ($query != '') {
			$maxi = count ($searchAdds);
			for ($i = 0; $i< $maxi; $i++) {
				$myfunc = $searchAdds[$i] . '_retrieve_all';
				$myfunc ($query, $data, $sap);
			}
			do_print_search ($data, $sap, $min, $max, $pagesize, $offset, $query, $types, $boxtext);
		}
	}
	$_display_dat = array ();
	$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_SEARCH_40_';
	$_display_dat['module'] = 'system/search';
	$opnConfig['opnOutput']->SetDisplay ($_display_dat);
	unset ($_display_dat);
	$opnConfig['opnOutput']->DisplayContent ($boxtitle, $boxtext);
}

?>