<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

include ('admin_header.php');
global $opnConfig;

$opnConfig['module']->InitModule ('system/tracking', true);
$pubsettings = array ();
$pubsettings = $opnConfig['module']->GetPublicSettings ();
getLanguageDef (_OPN_ROOT_PATH . 'system/tracking/admin/language/');

function tracking_allhiddens ($wichSave) {

	$values[] = array ('type' => _INPUT_BLANKLINE,
			'noautotable' => 1);
	$values[] = array ('type' => _INPUT_HIDDEN,
			'name' => 'save',
			'value' => urlencode ($wichSave) );
	$nav[_TRACKADMIN_NAVGENERAL] = _TRACKADMIN_NAVGENERAL;
	$nav[_TRACKADMIN_NAVIPEXCLUDE] = _TRACKADMIN_NAVIPEXCLUDE;
	$nav[_TRACKADMIN_NAVUSEREXCLUDE] = _TRACKADMIN_NAVUSEREXCLUDE;
	$nav[_TRACKADMIN_NAVURLEXCLUDE] = _TRACKADMIN_NAVURLEXCLUDE;
	$nav[_INPUT_BLANKLINE] = _INPUT_BLANKLINE;
	$nav[_TRACKADMIN_SAVE] = _TRACKADMIN_SAVE;
	$nav[_TRACKADMIN_ADMIN] = _TRACKADMIN_ADMIN;
	$nav[$wichSave] = '';
	$values[] = array ('type' => _INPUT_NAV_BAR,
			'urls' => $nav,
			'rt' => 5);
	return $values;

}

function trackingsettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TRACKADMIN_GENERAL);
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TRACKADMIN_HFDEBUG,
			'name' => 'hf_debug',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['hf_debug'] == 1?true : false),
			 ($pubsettings['hf_debug'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TRACKADMIN_HFEXCLUDE,
			'name' => 'hf_exclude',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['hf_exclude'] == 1?true : false),
			 ($pubsettings['hf_exclude'] == 0?true : false) ) );
	$values[] = array ('type' => _INPUT_RADIO,
			'display' => _TRACKADMIN_TRACKCOOKIE,
			'name' => 'track_cookie',
			'values' => array (1,
			0),
			'titles' => array (_YES,
			_NO),
			'checked' => array ( ($pubsettings['track_cookie'] == 1?true : false),
			 ($pubsettings['track_cookie'] == 0?true : false) ) );
	$values = array_merge ($values, tracking_allhiddens (_TRACKADMIN_NAVGENERAL) );
	$set->GetTheForm (_TRACKADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/tracking/admin/settings.php', $values);

}

function ipsettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TRACKADMIN_IPEXCLUDE);
	for ($i = 0; $i<count ($pubsettings['exclude_ip']); $i++) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _TRACKADMIN_IPEX,
				'name' => 'exclude_ip_' . $i,
				'value' => $pubsettings['exclude_ip'][$i],
				'size' => 15,
				'maxlength' => 15);
	}
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _TRACKADMIN_ADDIP);
	$values = array_merge ($values, tracking_allhiddens (_TRACKADMIN_NAVIPEXCLUDE) );
	$set->GetTheForm (_TRACKADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/tracking/admin/settings.php', $values);

}

function usersettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TRACKADMIN_USEREXCLUDE);
	for ($i = 0; $i<count ($pubsettings['exclude_user']); $i++) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _TRACKADMIN_USEREX,
				'name' => "exclude_user_$i",
				'value' => $pubsettings['exclude_user'][$i],
				'size' => 25,
				'maxlength' => 25);
	}
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _TRACKADMIN_ADDUSER);
	$values = array_merge ($values, tracking_allhiddens (_TRACKADMIN_NAVUSEREXCLUDE) );
	$set->GetTheForm (_TRACKADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/tracking/admin/settings.php', $values);

}

function urlsettings () {

	global $opnConfig, $pubsettings;

	$set = & new MySettings;
	$values[] = array ('type' => _INPUT_TITLE,
			'title' => _TRACKADMIN_URLEXCLUDE);
	for ($i = 0; $i<count ($pubsettings['exclude_url']); $i++) {
		$values[] = array ('type' => _INPUT_TEXT,
				'display' => _TRACKADMIN_URLEX,
				'name' => "exclude_url_$i",
				'value' => $pubsettings['exclude_url'][$i],
				'size' => 50,
				'maxlength' => 100);
	}
	$values[] = array ('type' => _INPUT_SUBMIT,
			'name' => 'op',
			'value' => _TRACKADMIN_ADDURL);
	$values = array_merge ($values, tracking_allhiddens (_TRACKADMIN_NAVURLEXCLUDE) );
	$set->GetTheForm (_TRACKADMIN_SETTINGS, $opnConfig['opn_url'] . '/system/tracking/admin/settings.php', $values);

}

function tracking_dosavesettings () {

	global $opnConfig, $pubsettings;

	$opnConfig['module']->SetPublicSettings ($pubsettings);
	$opnConfig['module']->SavePublicSettings ();

}

function tracking_dosavetracking ($vars) {

	global $pubsettings;

	$pubsettings['hf_debug'] = $vars['hf_debug'];
	$pubsettings['hf_exclude'] = $vars['hf_exclude'];
	$pubsettings['track_cookie'] = $vars['track_cookie'];
	tracking_dosavesettings ();

}

function tracking_dosaveip ($vars) {

	global $pubsettings;

	$pubsettings['exclude_ip'] = array ();
	$i = 0;
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'exclude_ip')>0) {
			if ($value != '') {
				$pubsettings['exclude_ip'][$i] = $value;
				$i++;
			}
		}
	}
	tracking_dosavesettings ();

}

function tracking_dosaveuser ($vars) {

	global $pubsettings;

	$pubsettings['exclude_user'] = array ();
	$i = 0;
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'exclude_user')>0) {
			if ($value != '') {
				$pubsettings['exclude_user'][$i] = $value;
				$i++;
			}
		}
	}
	tracking_dosavesettings ();

}

function tracking_dosaveurl ($vars) {

	global $pubsettings;

	$pubsettings['exclude_url'] = array ();
	$i = 0;
	foreach ($vars as $key => $value) {
		if (substr_count ($key, 'exclude_url')>0) {
			if ($value != '') {
				$pubsettings['exclude_url'][$i] = $value;
				$i++;
			}
		}
	}
	tracking_dosavesettings ();

}

function tracking_dosave ($returns) {

	$op = urldecode ($returns['save']);
	switch ($op) {
		case _TRACKADMIN_NAVGENERAL:
			tracking_dosavetracking ($returns);
			break;
		case _TRACKADMIN_NAVIPEXCLUDE:
			tracking_dosaveip ($returns);
			break;
		case _TRACKADMIN_NAVUSEREXCLUDE:
			tracking_dosaveuser ($returns);
			break;
		case _TRACKADMIN_NAVURLEXCLUDE:
			tracking_dosaveurl ($returns);
			break;
	}

}
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
$result = '';
if (!empty (${$opnConfig['opn_post_vars']}) ) {
	$result = ${$opnConfig['opn_post_vars']};
	if (isset ($result['save']) ) {
		tracking_dosave ($result);
	} else {
		$result = '';
	}
}
$op = urldecode ($op);
switch ($op) {
	case _TRACKADMIN_SAVE:
		$opnConfig['opnOutput']->Redirect (encodeurl (array ($opnConfig['opn_url'] . '/system/tracking/admin/settings.php',
								'op' => $result['save']),
								false) );
		CloseTheOpnDB ($opnConfig);
		break;
	case _TRACKADMIN_ADMIN:
		$opnConfig['opnOutput']->Redirect ('/system/tracking/admin/index.php');
		CloseTheOpnDB ($opnConfig);
		break;
	case _TRACKADMIN_ADDIP:
		$pubsettings['exclude_ip'][count ($pubsettings['exclude_ip'])] = '0.0.0.0';
		tracking_dosavesettings ();
		ipsettings ();
		break;
	case _TRACKADMIN_ADDUSER:
		$pubsettings['exclude_user'][count ($pubsettings['exclude_user'])] = '??????????';
		tracking_dosavesettings ();
		usersettings ();
		break;
	case _TRACKADMIN_ADDURL:
		$pubsettings['exclude_url'][count ($pubsettings['exclude_url'])] = '/';
		tracking_dosavesettings ();
		urlsettings ();
		break;
	case _TRACKADMIN_NAVIPEXCLUDE:
		ipsettings ();
		break;
	case _TRACKADMIN_NAVUSEREXCLUDE:
		usersettings ();
		break;
	case _TRACKADMIN_NAVURLEXCLUDE:
		urlsettings ();
		break;
	default:
		trackingsettings ();
		break;
}

?>