<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function tracking_every_header () {

	global $opnConfig, $opnTables;

	#,${$opnConfig['opn_cookie_vars']};
	// get user ID if logged in
	if ($opnConfig['opnOption']['user_login']) {
		$userinfo = $opnConfig['permission']->GetUserinfo ();
		$uid = $userinfo['uid'];
		$uname = $userinfo['uname'];
	} else {
		$uname = '';
		$uid = 0;
	}
	if ($opnConfig['hf_debug'] == 1) {
		opnErrorHandler (E_USER_NOTICE, 'here is opntracking for uid=' . $uid . ' uname=' . $uname, '', '');
	}
	if ($opnConfig['track_cookie'] == 1) {
		// should we work with cookies?
		if ($opnConfig['hf_debug'] == 1) {
			opnErrorHandler (E_USER_NOTICE, 'we are working with cookies', '', '');
		}
		$anno = '';
		get_var ('anno', $anno, 'cookie', _OOBJ_DTYPE_CLEAN);
		if ($anno == '') {
			$trackid = date ("ymdHis", time () );
			$cookie_encode = base64_encode ($trackid . ':' . $uid);
			$opnConfig['opnOption']['opnsession']->setopncookie ('anno', $cookie_encode, time ()+31449600);
			if ($opnConfig['hf_debug'] == 1) {
				opnErrorHandler (E_USER_NOTICE, "No cookie anno found. I've set one with trackid=" . $trackid . " and uid=" . $uid, '', '');
			}
		} else {
			$anno = base64_decode ($anno);
			// read cookie for annonymus
			$track_cookie = explode (':', $anno);
			$trackid = $track_cookie[0];
			// unique user ID from cookie
			if (!isset($track_cookie[1])) {
				$track_cookie[1] = 0;
			}
			// old uid
			if ($opnConfig['hf_debug'] == '1') {
				$track_uid = $track_cookie[1];
				opnErrorHandler (E_USER_NOTICE, "cookie anno found with trackid=" . $trackid . " track_uid=" . $track_uid, '', '');
			}
			// create new trackid if it in the cookie was empty
			if ($track_cookie[0] == '') {
				// trackid empty
				$trackid = date ('ymdHis', time () );
				$cookie_encode = base64_encode ($trackid . ':' . $uid);
				$opnConfig['opnOption']['opnsession']->setopncookie ('anno', $cookie_encode, time ()+31449600);
				if ($opnConfig['hf_debug'] == 1) {
					opnErrorHandler (E_USER_NOTICE, "Trackid in cookie was empthy. Create new one with trackid=" . $trackid . " and uid=" . $uid, '', '');
				}
			}
			// remember new user id if it in the cookie was a different one
			if ( ($uid != 0) && ($track_cookie[1] != $uid) ) {
				// remember new used uid
				$cookie_encode = base64_encode ($track_cookie[1] . ':' . $uid);
				$opnConfig['opnOption']['opnsession']->setopncookie ('anno', $cookie_encode, time ()+31449600);
				if ($opnConfig['hf_debug'] == 1) {
					opnErrorHandler (E_USER_NOTICE, 'Uid in cookie was different. Create new one with trackid=' . $trackid . ' and uid=' . $uid, '', '');
				}
			}
		}
		// Thats it, now we have in
		// $track_anno:   an uniqe ID from the first contact to that client
		// $track_uid:    the uid from the last logon
		// we can report the $track_ano if uid==0
		// we could report if now is a different uid used than before
	}
	// END IF track_cookie==1
	if (!isset ($trackid) ) {
		$trackid = date ("ymdHis", time () );
	}
	// REQUEST_URI is not working becaus at some servers you get the PHP.EXE
	// path at the beginning of the string (I at my lokal WIN98 intallation :-)
	$PATH_INFO = getenv ('PATH_INFO');
	if ($PATH_INFO != '') {
		$QUERY_STRING = '';
		get_var ('QUERY_STRING', $QUERY_STRING, 'server');
		if ($QUERY_STRING != '') {
			$requri = $PATH_INFO . "?" . $QUERY_STRING;
			if ($opnConfig['hf_debug'] == 1) {
				opnErrorHandler (E_USER_NOTICE, "i use from PATH_INFO requri=" . $requri, '', '');
			}
		} else {
			$requri = $PATH_INFO;
			if ($opnConfig['hf_debug'] == 1) {
				opnErrorHandler (E_USER_NOTICE, "i use from PATH_INFO requri=" . $requri, '', '');
			}
			// WM010828
		}
	} else {
		$requri = '';
		get_var ('REQUEST_URI', $requri, 'server');
		if ($opnConfig['hf_debug'] == 1) {
			opnErrorHandler (E_USER_NOTICE, "i use from REQUEST_URI requri=" . $requri, '', '');
		}
		// WM010828
	}
	$ip = get_real_IP ();
	// get remote IP
	$server = '';
	get_var ('SERVER_NAME', $server, 'server');
	$referer = '';
	get_var ('HTTP_REFERER', $referer, 'server');
	$tracktime = date ("Y-m-d H:i:s", time () );
	// check for excludes
	if (is_array ($opnConfig['exclude_ip']) ) {
		foreach ($opnConfig['exclude_ip'] as $value) {
			if ($value != '') {
				if ($ip == $value) {
					if ($opnConfig['hf_debug'] == 1) {
						opnErrorHandler (E_USER_NOTICE, 'exclude from tracking remote_addr=' . $ip, '', '');
					}
					$hf_exclude = 1;
				}
			}
		}
	}
	foreach ($opnConfig['exclude_user'] as $value) {
		if ($value != '') {
			if ($uname == $value) {
				if ($opnConfig['hf_debug'] == 1) {
					opnErrorHandler (E_USER_NOTICE, "exclude from tracking uname=" . $uname, '', '');
				}
				$hf_exclude = 1;
			}
		}
	}
	foreach ($opnConfig['exclude_url'] as $value) {
		if ($value != '') {
			if (stristr ($requri, $value) ) {
				if ($opnConfig['hf_debug'] == 1) {
					opnErrorHandler (E_USER_NOTICE, "exclude from tracking requri=" . $requri, '', '');
				}
				$hf_exclude = 1;
			}
		}
	}
	// update only if no exclude before
	if (!isset ($hf_exclude) ) {
		$hf_exclude = "";
	}
	if (!isset ($opnConfig['hf_exclude']) ) {
		$opnConfig['hf_exclude'] = "";
	}
	if ( ($opnConfig['hf_exclude'] != 1) && ($hf_exclude != 1) ) {
		// reduce different mainpage names to index.php
		switch ($requri) {
			case '/':
				// Mainpage
				$requri = '/index.php';
				break;
			case '/index.php':
				// Mainpage
				$requri = '/index.php';
				break;
		}
		if ($opnConfig['hf_debug'] == 1) {
			$_tracktime = $opnConfig['opnSQL']->qstr ($tracktime);
			$_trackid = $opnConfig['opnSQL']->qstr ($trackid);
			$_requri = $opnConfig['opnSQL']->qstr ($requri);
			$_ip = $opnConfig['opnSQL']->qstr ($ip);
			$_server = $opnConfig['opnSQL']->qstr ($server);
			$_referer = $opnConfig['opnSQL']->qstr ($referer);
			$myselect = 'SELECT COUNT(uid) AS counter FROM ' . $opnTables['tracking'] . " WHERE tracktime=$_tracktime AND ip=$_ip AND uid=$uid AND server=$_server AND referer=$_referer AND requrl=$_requri AND trackid=$_trackid";
			$result = $opnConfig['database']->Execute ($myselect);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$result_count_before = $result->fields['counter'];
			} else {
				$result_count_before = 0;
			}
		}
		$_tracktime = $opnConfig['opnSQL']->qstr ($tracktime);
		$_ip = $opnConfig['opnSQL']->qstr ($ip);
		$checkresult = $opnConfig['database']->SelectLimit ('SELECT COUNT(tracktime) AS counter FROM ' . $opnTables['tracking'] . " WHERE tracktime=$_tracktime AND ip=$_ip", 1);
		if ( ($checkresult !== false) && (isset ($checkresult->fields['counter']) ) ) {
			$check_count_before = $checkresult->fields['counter'];
			$checkresult->Close ();
		} else {
			$check_count_before = 0;
		}
		if ($check_count_before == 0) {
			$_trackid = $opnConfig['opnSQL']->qstr ($trackid);
			$_requri = $opnConfig['opnSQL']->qstr ($requri);
			$_referer = $opnConfig['opnSQL']->qstr ($referer);
			$_server = $opnConfig['opnSQL']->qstr ($server);
			$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['tracking'] . " VALUES ($_tracktime, $_ip, $uid, $_server, $_referer, $_requri, $_trackid) ");
		}
		if ($opnConfig['hf_debug'] == 1) {
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$result_count_after = $result->fields['counter'];
			} else {
				$result_count_after = 0;
			}
			$res_count = $result_count_after- $result_count_before;
			opnErrorHandler (E_USER_NOTICE, "tracking write to database, affected rows:" . $res_count . "<br /> Errno:" . $opnConfig['database']->ErrorNo () . " Errortext:" . $opnConfig['database']->ErrorMsg (), '', '');
			opnErrorHandler (E_USER_NOTICE, "values tracktime=" . $tracktime . " remote_addr=" . $ip . " uid=" . $uid . " server=" . $server . " referer=" . $referer . " requri=" . $requri . " trackid=" . $trackid . '', '');
		}
		// END if hf_debug
	}
	// END IF hf_exclude

}
// function tracking_every_header

function tracking_every_header_box_pos () {
	return 0;

}

?>