<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_MAINFILE_INCLUDED') ) {
	include ('../../mainfile.php');
}
global $opnConfig;

$opnConfig['permission']->InitPermissions ('system/user_images');
$opnConfig['permission']->HasRights ('system/user_images', array (_PERM_READ, _PERM_WRITE, _PERM_ADMIN) );
$opnConfig['module']->InitModule ('system/user_images');
include (_OPN_ROOT_PATH . 'include/module.build_pagebar.php');
include (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.opn_images.php');
include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
getLanguageDef (_OPN_ROOT_PATH . 'system/user_images/language/');

function UserImageAdmin () {

	global $opnConfig, $opnTables;

	$ui = $opnConfig['permission']->GetUserinfo ();
	$maxperpage = $opnConfig['opn_gfx_defaultlistrows'];
	$sortby = 'desc_images_id';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'both', _OOBJ_DTYPE_INT);
	$showstatus = -1;
	get_var ('showstatus', $showstatus, 'both', _OOBJ_DTYPE_CLEAN);
	$query = '';
	get_var ('query', $query, 'both', _OOBJ_DTYPE_CLEAN);
	$search = 0;
	get_var ('search', $search, 'both', _OOBJ_DTYPE_INT);
	$show_image_online = 0;
	get_var ('show_image_online', $show_image_online, 'both', _OOBJ_DTYPE_INT);
	$show_image_online_hidden = 0;
	get_var ('show_image_online_hidden', $show_image_online_hidden, 'both', _OOBJ_DTYPE_INT);
	$show_image_delete = 0;
	get_var ('show_image_delete', $show_image_delete, 'both', _OOBJ_DTYPE_INT);
	$show_image_delete_hidden = 0;
	get_var ('show_image_delete_hidden', $show_image_delete_hidden, 'both', _OOBJ_DTYPE_INT);
	if (!$show_image_online_hidden) {
		$show_image_online = 1;
	}
	if (!$show_image_delete_hidden) {
		$show_image_delete = 0;
	}
	if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
		$sql = 'SELECT COUNT(images_id) AS counter FROM ' . $opnTables['user_images_dat'];
		$get_sql = 'SELECT images_id, images_css, images_url, images_text, images_code, images_user, images_status FROM ' . $opnTables['user_images_dat'];
		$zusatz = array ();
		if ($show_image_online == 0) {
			$zusatz[] = '(images_status<>1)';
		}
		if ($show_image_delete == 0) {
			$zusatz[] = '(images_status<>0)';
		}
		if ($showstatus != -1) {
			$zusatz[] = '(images_status=' . $showstatus . ')';
		}
		if ($showuser != 0) {
			$zusatz[] = '(images_user=' . $showuser . ')';
		}
		if ($query != '') {
			switch ($search) {
				case 1:
					$q = " (images_text LIKE '%$query%') ";
					break;
				case 2:
					$result = $opnConfig['database']->Execute ('SELECT uid FROM ' . $opnTables['users'] . " WHERE uname LIKE '%$query%'");
					$ids = array ();
					while (! $result->EOF) {
						$ids[] = $result->fields['uid'];
						$result->MoveNext ();
					}
					if (count ($ids) ) {
						$ids = implode (',', $ids);
						$q = ' images_user IN (' . $ids . ')';
					} else {
						$q = ' images_user = 0';
					}
					break;
				default:
					$q = " (images_code LIKE '%$query%') ";
					break;
			}

			/* switch */
			$zusatz[] = $q;
		}
		if (count ($zusatz) ) {
			$sql .= ' WHERE ' . implode (' AND ', $zusatz);
			$get_sql .= ' WHERE ' . implode (' AND ', $zusatz);
		}
	} else {
		$sql = 'SELECT COUNT(images_id) AS counter FROM ' . $opnTables['user_images_dat'] . ' WHERE (images_user=' . $ui['uid'] . ') AND (images_status=1)';
		$get_sql = 'SELECT images_id, images_css, images_url, images_text, images_code, images_user, images_status FROM ' . $opnTables['user_images_dat'] . ' WHERE (images_user=' . $ui['uid'] . ') AND (images_status=1)';
	}
	$justforcounting = &$opnConfig['database']->Execute ($sql);
	if ( ($justforcounting !== false) && (isset ($justforcounting->fields['counter']) ) ) {
		$reccount = $justforcounting->fields['counter'];
	} else {
		$reccount = 0;
	}
	unset ($justforcounting);
	$order = '';
	$oldsortby = $sortby;
	$boxtxt = '<br />';
	$boxtxt .= '<div align="center" class="smalltext">';
	$form = & new opn_FormularClass ('alternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_IMAGES_USERADMIN_SEARCH_', 'user_images');
	$form->Init ($opnConfig['opn_url'] . '/system/user_images/index.php');
	$form->AddLabel ('query', _UIMA_SEARCH_TERM . '&nbsp;');
	$form->AddTextfield ('query', 25, 50, $query);
	$form->AddText ('&nbsp;');
	$form->AddLabel ('search', _UIMA_SEARCH_IN . '&nbsp;');
	$options[0] = _UIMA_SEARCH_CODE;
	$options[1] = _UIMA_SEARCH_TEXT;
	$options[2] = _UIMA_SEARCH_USER;
	$form->AddSelect ('search', $options, $search);
	$form->AddHidden ('offest', $offset);
	$form->AddHidden ('showuser', $showuser);
	$form->AddHidden ('showstatus', $showstatus);
	$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, $sortby);
	$form->AddHidden ('show_image_online_hidden', 1);
	$form->AddHidden ('show_image_delete_hidden', 1);
	$form->AddText ('&nbsp;');
	$form->AddSubmit ('op', _UIMA_SEARCH);
	$form->AddText ('<br />');
	$form->AddText ('<br />');
	$form->AddText (_UIMA_SEARCH_SHOW_IMAGE);
	$form->AddText ('&nbsp;');
	$form->AddCheckbox ('show_image_online', 1, ($show_image_online == 1?true : false) );
	$form->AddLabel ('show_image_online', '&nbsp;' . _UIMA_SEARCH_SHOW_IMAGE_ONLINE, 1);
	$form->AddText ('&nbsp;&nbsp;&nbsp;');
	$form->AddCheckbox ('show_image_delete', 1, ($show_image_delete == 1?true : false) );
	$form->AddLabel ('show_image_delete', '&nbsp;' . _UIMA_SEARCH_SHOW_IMAGE_DELETE, 1);
	$form->AddText ('&nbsp;&nbsp;&nbsp;');
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt);
	$boxtxt .= '</div><br /><br />';
	$form = & new opn_FormularClass ('alternator');
	$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_IMAGES_USERADMIN_', 'user_images');
	$form->Init ($opnConfig['opn_url'] . '/system/user_images/index.php', 'post', 'images');
	$form->get_sort_order ($order, array ('images_id',
						'images_text',
						'images_user'),
						$sortby);
	$progurl = array ($opnConfig['opn_url'] . '/system/user_images/index.php');
	$progurl['showuser'] = $showuser;
	$progurl['query'] = $query;
	$progurl['search'] = $search;
	$progurl['show_image_online_hidden'] = 1;
	$progurl['show_image_delete_hidden'] = 1;
	$progurl['show_image_online'] = $show_image_online;
	$progurl['show_image_delete'] = $show_image_delete;
	$temp_progurl = $progurl;
	$temp_progurl['showstatus'] = $showstatus;
	$colspan = 3;
	$form->AddTable ();
	$form->AddOpenHeadRow ();
	$form->SetIsHeader (true);
	$form->AddCheckbox ('allbox', 'Check All', 0, 'CheckAll(\'images\',\'allbox\');');
	$form->AddText ($form->get_sort_feld ('images_id', _USIG_ID, $temp_progurl) );
	$form->AddText ($form->get_sort_feld ('images_text', _USIG_ADMIN_IMAGETEXT, $temp_progurl) );
	if ($opnConfig['permission']->HasRight ('system/user_images', _USER_IMAGES_PERM_SETCSS, true) ) {
		$form->AddText ('&nbsp;');
		$colspan++;
	}
	if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
		$form->AddText ($form->get_sort_feld ('images_user', _USIG_ADMIN_USER, $temp_progurl) );
		$form->AddText (_USIG_ADMIN_STATUS);
		$colspan = $colspan+2;
	}
	$form->AddText ('&nbsp;');
	$form->SetIsHeader (false);
	$form->AddCloseRow ();
	if ($getUserImage = &$opnConfig['database']->SelectLimit ($get_sql . $order, $maxperpage, $offset) ) {
		$numUserImage = $getUserImage->RecordCount ();
		if ($numUserImage == 0) {
			$form->AddOpenRow ();
			$form->SetColspan ($colspan+1);
			$form->AddText ('<span class="normaltext">' . sprintf (_USIG_ADMIN_NOIMAGES, encodeurl ($opnConfig['opn_url'] . '/system/user_images/index.php') ) . '</span>');
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
		} else {
			$form->SetAlign ('center');
			while (! $getUserImage->EOF) {
				$UserImage = $getUserImage->GetRowAssoc ('0');
				$form->AddOpenRow ();
				$datei = str_replace ($opnConfig['datasave']['user_images_url']['url'] . '/', '', $UserImage['images_url']);
				$form->AddCheckbox ('id[]', $UserImage['images_id'], 0, 'CheckCheckAll(\'images\',\'allbox\');');
				$temp_progurl = $progurl;
				$temp_progurl['showstatus'] = $showstatus;
				$temp_progurl['offset'] = $offset;
				$temp_progurl[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
				$temp_progurl['op'] = 'UserImageShow';
				$temp_progurl['id'] = $UserImage['images_id'];
				$hlp = '<a class="%alternate%" href="' . encodeurl ($temp_progurl) . '">';
				if (file_exists ($opnConfig['datasave']['user_images_url']['path'] . $datei . '.opn_tbm_.jpg') ) {
					$hlp .= '<img src="' . $opnConfig['datasave']['user_images_url']['url'] . '/' . $datei . '.opn_tbm_.jpg' . '" class="imgtag" alt="" />';
				} else {
					$hlp .= '<img src="' . $UserImage['images_url'] . '" class="imgtag" alt="" />';
				}
				$hlp .= '</a>';
				$form->AddText ($hlp);
				$form->AddText ($UserImage['images_text'], 'center');
				if ($opnConfig['permission']->HasRight ('system/user_images', _USER_IMAGES_PERM_SETCSS, true) ) {
					$form->AddText ($UserImage['images_css']);
				}
				if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
					if ($UserImage['images_user'] != 1) {
						$tui = $opnConfig['permission']->GetUser ($UserImage['images_user'], 'uid', '');
						$name = '<a class="%alternate%" href="' . encodeurl (array ($opnConfig['opn_url'] . '/system/user_images/index.php',
													'showuser' => $UserImage['images_user'],
													'showstatus' => $showstatus) ) . '">';
						$name .= $tui['uname'];
						$name .= '</a>';
					} else {
						$name = _SEARCH_ALL;
					}
					$form->AddText ($name);
				}
				$hlp = '';
				if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
					$temp_progurl = $progurl;
					if ($UserImage['images_status'] == 0) {
						$temp_progurl['showstatus'] = 1;
						$hlp = '<a class="%alternate%" href="' . encodeurl ($temp_progurl) . '">' . _USIG_ADMIN_IMG_DEL . '</a>';
					} else {
						$temp_progurl['showstatus'] = 0;
						$hlp = '<a class="%alternate%" href="' . encodeurl ($temp_progurl) . '">' . _USIG_ADMIN_IMG_ONLINE . '</a>';
					}
					$form->AddText ($hlp, 'center');
				}
				$temp_progurl = $progurl;
				$temp_progurl['showstatus'] = $UserImage['images_status'];
				$temp_progurl['offset'] = $offset;
				$temp_progurl[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
				$temp_progurl['op'] = 'UserImageEdit';
				$temp_progurl['id'] = $UserImage['images_id'];
				$hlp = $opnConfig['defimages']->get_edit_link ($temp_progurl);
				$form->AddText ($hlp);
				$form->AddCloseRow ();
				$getUserImage->MoveNext ();
			}
			$form->AddOpenRow ();
			$options = array ();
			$options['UserImageResize'] = _USIG_ADMIN_RESIZE;
			$options['UserImageDel'] = _USIG_ADMIN_DELETE;
			if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
				$options['UserImageDelReally'] = _USIG_ADMIN_DELETE2;
				$options['UserImageDelReallyHD'] = _USIG_ADMIN_DELETE_HD;
			}
			$form->AddText ('&nbsp;');
			$form->SetAlign ('left');
			$form->SetColspan ($colspan);
			$form->SetSameCol ();
			$form->AddSelect ('op', $options);
			$form->AddHidden ('offest', $offset);
			$form->AddHidden ('showuser', $showuser);
			$form->AddHidden ('showstatus', $showstatus);
			$form->AddHidden ('show_image_online', $show_image_online);
			$form->AddHidden ('show_image_delete', $show_image_delete);
			$form->AddHidden ('show_image_online_hidden', 1);
			$form->AddHidden ('show_image_delete_hidden', 1);
			$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, $sortby);
			$form->AddText ('&nbsp;');
			$form->AddSubmit ('submitty', _UIMA_SEND);
			$form->SetEndCol ();
			$form->SetColspan ('');
			$form->AddCloseRow ();
			$form->AddTableClose ();
			$form->AddFormEnd ();
			$form->GetFormular ($boxtxt);
		}
	} else {
		$boxtxt .= _USIG_ADMIN_ERRORDB;
	}
	$boxtxt .= '<br /><br />';
	$temp_progurl = $progurl;
	$temp_progurl['showstatus'] = $showstatus;
	$temp_progurl[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
	$boxtxt .= build_pagebar ($temp_progurl, $reccount, $maxperpage, $offset, _USIG_ALLIMAGESINOURDATABASEARE . _USIG_ADMIN_IMAGE);
	$boxtxt1 = '<div class="normaltext">' . _OPN_HTML_NL;
	$form = & new opn_FormularClass ('listalternator');
	if ($opnConfig['permission']->HasRights ('system/user_images', array (_PERM_WRITE, _PERM_ADMIN), true) ) {
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_IMAGES_10_',
											'user_images');
		$form->Init ($opnConfig['opn_url'] . '/system/user_images/index.php', 'post', '', 'multipart/form-data');
	} else {
		$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_IMAGES_20_', 'user_images');
		$form->Init ($opnConfig['opn_url'] . '/system/user_images/index.php');
	}
	$form->AddTable ();
	$form->AddCols (array ('10%', '90%') );
	$form->AddOpenRow ();
	$form->AddLabel ('image_text', _USIG_ADMIN_IMAGETEXT);
	$form->AddTextfield ('image_text', 50, 250);
	$form->AddOpenRow ();
	$form->AddLabel ('image_url', _USIG_ADMIN_IMAGEURL);
	$form->AddTextfield ('image_url', 50, 250);
	if ($opnConfig['permission']->HasRights ('system/user_images', array (_PERM_WRITE, _PERM_ADMIN), true) ) {
		$form->AddChangeRow ();
		$form->AddLabel ('userupload', _USIG_ADMIN_IMAGEUPLOAD);
		$form->SetSameCol ();
		$form->AddFile ('userupload');
		$form->AddText ('&nbsp;max:&nbsp;' . $opnConfig['opn_upload_size_limit'] . '&nbsp;bytes');
		$form->SetEndCol ();
	}
	if ($opnConfig['permission']->HasRight ('system/user_images', _USER_IMAGES_PERM_SETCSS, true) ) {
		$form->AddChangeRow ();
		$form->AddLabel ('image_css', _USIG_ADMIN_IMAGECSS);
		$form->AddTextfield ('image_css', 50, 250);
	}
	$form->AddChangeRow ();
	$form->AddLabel ('image_code', _USIG_ADMIN_CODE);
	$form->AddTextfield ('image_code', 50, 250);
	$form->AddChangeRow ();
	$form->AddHidden ('op', 'UserImageAdd');
	$form->AddSubmit ('submit', _USIG_ADMIN_ADD);
	$form->AddCloseRow ();
	$form->AddTableClose ();
	$form->AddFormEnd ();
	$form->GetFormular ($boxtxt1);
	$boxtxt1 .= '</div>';
	if ($opnConfig['ui_display_input_bottom']) {
		$boxtxt .= '<br />' . $boxtxt1;
	} else {
		$boxtxt = $boxtxt1 . '<br />' . $boxtxt;
	}
	return $boxtxt;

}

function UserImageShow () {

	global $opnConfig, $opnTables;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'url', _OOBJ_DTYPE_INT);
	$showstatus = 0;
	get_var ('showstatus', $showstatus, 'url', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUserinfo ();
	$sql = 'SELECT images_url, images_text FROM ' . $opnTables['user_images_dat'] . " WHERE (images_id = $id)";
	if (!$opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
		$sql .= ' AND (images_user=' . $ui['uid'] . ') AND (images_status=1)';
	}
	$result = $opnConfig['database']->Execute ($sql);
	$url = $result->fields['images_url'];
	$result->Close ();
	$plug = array ();
	$opnConfig['installedPlugins']->getplugin ($plug,
								'user_images');
	ksort ($plug);
	reset ($plug);
	$boxtxt = '';
	$inner = '';
	foreach ($plug as $var1) {
		if (file_exists (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/user_images/index.php') ) {
			include (_OPN_ROOT_PATH . $var1['plugin'] . '/plugin/user_images/index.php');
			$func = $var1['module'] . '_get_user_images';
			$data = array ();
			$title = '';
			$func ($url, $data, $title);
			if (count ($data) ) {
				$inner .= '<dt>' . $title . '</dt>' . _OPN_HTML_NL;
				foreach ($data as $value) {
					$inner .= '<dd>' . $value . '</dd>' . _OPN_HTML_NL;
				}
			}
		}
	}
	if ($inner != '') {
		$boxtxt = '<dl>' . $inner . '</dl>' . _OPN_HTML_NL;
	} else {
		$boxtxt = '<div class="normaltextbold">' . _UIMA_NO_DATA . '</div>';
	}
	return $boxtxt;

}

function UserImageEdit () {

	global $opnTables, $opnConfig;

	$id = 0;
	get_var ('id', $id, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'url', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'url', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'url', _OOBJ_DTYPE_INT);
	$showstatus = 0;
	get_var ('showstatus', $showstatus, 'both', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUserinfo ();
	$boxtxt = '';
	$sql = 'SELECT images_id, images_url, images_css, images_text, images_code, images_user, images_status FROM ' . $opnTables['user_images_dat'] . " WHERE (images_id = $id)";
	if (!$opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
		$sql .= ' AND (images_user=' . $ui['uid'] . ') AND (images_status=1)';
	}
	if ($getUserImage = &$opnConfig['database']->SelectLimit ($sql, 1) ) {
		$numUserImage = $getUserImage->RecordCount ();
		if ($numUserImage == 0) {
			$boxtxt .= sprintf (_USIG_ADMIN_NOIMAGES, $opnConfig['opn_url'] . '/system/user_images/index.php');
		} else {
			$UserImage = $getUserImage->GetRowAssoc ('0');
			if ($UserImage) {
				$form = & new opn_FormularClass ('listalternator');
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_IMAGES_30_', 'user_images');
				$form->Init ($opnConfig['opn_url'] . '/system/user_images/index.php');
				$form->AddTable ();
				$form->AddCols (array ('10%', '90%') );
				$form->AddOpenRow ();
				$form->AddLabel ('image_url', _USIG_ADMIN_IMAGEURL);
				$form->AddTextfield ('image_url', 50, 250, $UserImage['images_url']);
				$form->AddChangeRow ();
				$form->AddLabel ('image_text', _USIG_ADMIN_IMAGETEXT);
				$form->AddTextfield ('image_text', 50, 250, $UserImage['images_text']);
				if ($opnConfig['permission']->HasRight ('system/user_images', _USER_IMAGES_PERM_SETCSS, true) ) {
					$form->AddChangeRow ();
					$form->AddLabel ('image_css', _USIG_ADMIN_IMAGECSS);
					$form->AddTextfield ('image_css', 50, 250, $UserImage['images_css']);
				}
				$form->AddChangeRow ();
				$form->AddLabel ('image_code', _USIG_ADMIN_CODE);
				$form->AddTextfield ('image_code', 50, 250, $UserImage['images_code']);
				$form->AddChangeRow ();
				if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
					$options = array ();
					$sql = 'SELECT u.uid AS uid, u.uname AS uname FROM ' . $opnTables['users'] . ' u, ' . $opnTables['users_status'] . ' s WHERE u.uid = s.uid AND u.uid != -1 AND s.level1 != -1 AND u.uid = s.uid ORDER BY u.uname';
					$r = &$opnConfig['database']->Execute ($sql);
					$row = '';
					if ($r !== false) {
						$row = $r->GetRowAssoc ('0');
					}
					if (is_array ($row) ) {
						while (! $r->EOF) {
							$row = $r->GetRowAssoc ('0');
							$options[$row['uid']] = $row['uname'];
							$r->MoveNext ();
						}
					} else {
						$options[0] = _NONE;
					}
					$form->AddLabel ('images_user', _USIG_ADMIN_USER);
					$form->AddSelect ('images_user', $options, $UserImage['images_user']);
				} else {
					$form->AddText ('&nbsp;');
					$form->AddHidden ('images_user', $ui['uid']);
				}
				$form->AddChangeRow ();
				$form->SetSameCol ();
				$form->AddHidden ('id', $UserImage['images_id']);
				$form->AddHidden ('op', 'UserImageSave');
				$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, $sortby);
				$form->AddHidden ('offset', $offset);
				$form->AddHidden ('showuser', $showuser);
				$form->AddHidden ('showstatus', $showstatus);
				$form->SetEndCol ();
				$form->AddSubmit ('submit', _USIG_ADMIN_SAVE);
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$form->GetFormular ($boxtxt);
			}
			$boxtxt .= '<br />';
			$boxtxt .= '<br />';
			$boxtxt .= '<img src="' . $UserImage['images_url'] . '" class="imgtag" alt="" />';
		}
	} else {
		$boxtxt .= _USIG_ADMIN_ERRORDB;
	}
	return $boxtxt;

}

function UserImageResize () {

	global $opnTables, $opnConfig;

	$id = array ();
	get_var ('id', $id,'form',_OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'form', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'form', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'form', _OOBJ_DTYPE_INT);
	$showstatus = -1;
	get_var ('showstatus', $showstatus, 'both', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUserinfo ();
	$boxtxt = '';
	if (count ($id) ) {
		$ids = implode (',', $id);
		$sql = 'SELECT images_id, images_url, images_text, images_code, images_user, images_status FROM ' . $opnTables['user_images_dat'] . ' WHERE (images_id IN (' . $ids . '))';
		if (!$opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
			$sql .= ' AND (images_user=' . $ui['uid'] . ') AND (images_status=1)';
		}
		if ($getUserImage = &$opnConfig['database']->Execute ($sql) ) {
			$numUserImage = $getUserImage->RecordCount ();
			if ($numUserImage == 0) {
				$boxtxt .= sprintf (_USIG_ADMIN_NOIMAGES, $opnConfig['opn_url'] . '/system/user_images/index.php');
			} else {
				$form = & new opn_FormularClass ('listalternator');
				$opnConfig['opnOutput']->SetOnlineHelpFlagTo ('_OPNDOCID_SYSTEM_USER_IMAGES_40_', 'user_images');
				$form->Init ($opnConfig['opn_url'] . '/system/user_images/index.php');
				$form->AddTable ();
				$form->AddCols (array ('10%', '90%') );
				while (! $getUserImage->EOF) {
					$UserImage = $getUserImage->GetRowAssoc ('0');
					if ($UserImage) {
						$datei = str_replace ($opnConfig['datasave']['user_images_url']['url'] . '/', '', $UserImage['images_url']);
						if ($UserImage['images_url'] != $datei) {
							$UserImage['images_url'] = str_replace ($opnConfig['datasave']['user_images_url']['url'] . '/', '', $UserImage['images_url']);
							$ImageWork = & new ImageWork ($UserImage['images_url'], $opnConfig['datasave']['user_images_url']['path']);
							$form->AddOpenRow ();
							$form->AddText (_USIG_ADMIN_IMAGETEXT);
							$form->SetSameCol ();
							$form->AddText ($UserImage['images_text']);
							$form->AddHidden ('id[]', $UserImage['images_id']);
							$form->SetEndCol ();
							$form->AddChangeRow ();
							$form->AddLabel ('resize_x[]', _USIG_ADMIN_SIZE_X);
							$form->AddTextfield ('resize_x[]', 50, 250, $ImageWork->getWidth () );
							$form->AddChangeRow ();
							$form->AddLabel ('resize_y[]', _USIG_ADMIN_SIZE_Y);
							$form->AddTextfield ('resize_y[]', 50, 250, $ImageWork->getHeight () );
							$form->AddChangeRow ();
							$form->AddText ('&nbsp;');
							$form->AddText ('&nbsp;');
							$form->AddCloseRow ();
						}
						$getUserImage->MoveNext ();
					}
				}
				$form->AddOpenRow ();
				$form->SetSameCol ();
				$form->AddHidden ('op', 'UserImageResizeDo');
				$form->AddHidden (_OPN_VAR_TABLE_SORT_VAR, $sortby);
				$form->AddHidden ('offset', $offset);
				$form->AddHidden ('showuser', $showuser);
				$form->AddHidden ('showstatus', $showstatus);
				$form->SetEndCol ();
				$form->AddSubmit ('submit', _USIG_ADMIN_SAVE);
				$form->AddCloseRow ();
				$form->AddTableClose ();
				$form->AddFormEnd ();
				$form->GetFormular ($boxtxt);
				$getUserImage->Close ();
			}
		} else {
			$boxtxt .= _USIG_ADMIN_ERRORDB;
		}
	} else {
		$boxtxt .= _USIG_ADMIN_ERRORDB;
	}
	return $boxtxt;

}

function UserImageResizeDo () {

	global $opnTables, $opnConfig;

	$id = array ();
	get_var ('id', $id,'both',_OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'both', _OOBJ_DTYPE_INT);
	$showstatus = 0;
	get_var ('showstatus', $showstatus, 'both', _OOBJ_DTYPE_INT);
	$resize_x = array ();
	get_var ('resize_x', $resize_x,'both',_OOBJ_DTYPE_INT);
	$resize_y = array ();
	get_var ('resize_y', $resize_y,'both',_OOBJ_DTYPE_INT);
	$keys = array_keys ($id);
	foreach ($keys as $key) {
		$sql = 'SELECT images_id, images_url, images_text, images_code, images_user, images_status FROM ' . $opnTables['user_images_dat'] . ' WHERE images_id = ' . $id[$key];
		$getUserImage = &$opnConfig['database']->SelectLimit ($sql, 1);
		$UserImage = $getUserImage->GetRowAssoc ('0');
		if ($UserImage) {
			$UserImage['images_url'] = str_replace ($opnConfig['datasave']['user_images_url']['url'] . '/', '', $UserImage['images_url']);
			$org = $UserImage['images_url'];
			$ImageWork = & new ImageWork ($UserImage['images_url'], $opnConfig['datasave']['user_images_url']['path']);
			if ( ($ImageWork->getWidth () != $resize_x[$key]) || ($ImageWork->getHeight () != $resize_y[$key]) ) {
				$UserImage['images_url'] = 'new_' . $UserImage['images_url'];
				$ImageWork->resize ($resize_x[$key], $resize_y[$key]);
				$ImageWork->outputFile ($UserImage['images_url'], $opnConfig['datasave']['user_images_url']['path']);
				$image_text = $UserImage['images_text'];
				$image_code = $UserImage['images_code'];
				$image_user = $UserImage['images_user'];
				$image_code = $opnConfig['opnSQL']->qstr ($image_code);
				$image_text = $opnConfig['opnSQL']->qstr ($image_text);
				$tmb_save_path = $opnConfig['datasave']['user_images_url']['path'] . $UserImage['images_url'] . '.opn_tbm_.jpg';
				$tmb_load_path = $opnConfig['datasave']['user_images_url']['path'] . $UserImage['images_url'];
				$UserImage['images_url'] = $opnConfig['opnSQL']->qstr ($opnConfig['datasave']['user_images_url']['url'] . '/' . $UserImage['images_url']);
				if ($org != $UserImage['images_url']) {
					$id = $opnConfig['opnSQL']->get_new_number ('user_images_dat', 'images_id');
					$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_images_dat'] . " (images_id, images_url, images_text, images_code, images_user, images_status) VALUES ($id, " . $UserImage['images_url'] . ", $image_text, $image_code, $image_user, 1)");
					$neu = & new ImgThumb ($tmb_load_path, 100, 100, $tmb_save_path, 0, 255, 255, 255);
				}
			}
		}
		$getUserImage->Close ();
	}

}

function UserImageDelReally () {

	global $opnTables, $opnConfig;

	$ui = $opnConfig['permission']->GetUserinfo ();
	$id = array ();
	get_var ('id', $id,'both',_OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'both', _OOBJ_DTYPE_INT);
	$showstatus = 0;
	get_var ('showstatus', $showstatus, 'both', _OOBJ_DTYPE_INT);
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		if (count ($id) ) {
			$ids = implode (',', $id);
			if ($opnConfig['permission']->HasRights ('system/user_images', _PERM_ADMIN, true) ) {
				$sql = 'DELETE FROM ' . $opnTables['user_images_dat'] . ' WHERE images_id IN (' . $ids . ')';
			} else {
				$sql = 'DELETE FROM ' . $opnTables['user_images_dat'] . ' WHERE (images_user=' . $ui['uid'] . ') AND (images_id IN (' . $ids . '))';
			}
			$opnConfig['database']->Execute ($sql);
		}
		return '';
	}
	$url[0] = $opnConfig['opn_url'] . '/system/user_images/index.php';
	$url['op'] = 'UserImageDelReally';
	$count = 0;
	foreach ($id as $value) {
		$url['id[' . $count . ']'] = $value;
		$count++;
	}
	$url['ok'] = 1;
	$url['offset'] = $offset;
	$url[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
	$url['showuser'] = $showuser;
	$url['showstatus'] = $showstatus;
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">' . _USIG_ADMIN_WARNING2 . '</span>';
	$boxtxt .= '<br /><br />';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($url) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_images/index.php?op=UserImageAdmin') . '">' . _NO . '</a><br /><br /></div>' . _OPN_HTML_NL;
	return $boxtxt;

}

function UserImageDelReallyHD () {

	global $opnTables, $opnConfig;

	$ui = $opnConfig['permission']->GetUserinfo ();
	$id = 0;
	get_var ('id', $id,'both',_OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'both', _OOBJ_DTYPE_INT);
	$showstatus = 0;
	get_var ('showstatus', $showstatus, 'both', _OOBJ_DTYPE_INT);
	if ($id == 0) {
		$boxtxt = '<div class="centertag"><br />';
		$boxtxt .= '<span class="alerttext">' . _UIMA_NO_DATA_SET . '</span>';
		$boxtxt .= '</div>';
		return $boxtxt;
	}
	if ( ($ok == 1) OR ($opnConfig['opn_expert_mode'] == 1) ) {
		if (count ($id) ) {
			$ids = implode (',', $id);
			if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
				$sql = 'SELECT images_id, images_url FROM ' . $opnTables['user_images_dat'] . ' WHERE images_id IN (' . $ids . ')';
			} else {
				$sql = 'SELECT images_id, images_url FROM ' . $opnTables['user_images_dat'] . ' WHERE (images_user=' . $ui['uid'] . ') AND (images_id IN (' . $ids . '))';
			}
			$delid = array ();
			if ($getUserImage = &$opnConfig['database']->Execute ($sql) ) {
				$numUserImage = $getUserImage->RecordCount ();
				if ($numUserImage != 0) {
					while (! $getUserImage->EOF) {
						$UserImage = $getUserImage->GetRowAssoc ('0');
						if ($UserImage) {
							$datei = str_replace ($opnConfig['datasave']['user_images_url']['url'] . '/', '', $UserImage['images_url']);
							if ($UserImage['images_url'] != $datei) {
								$UserImage['images_url'] = str_replace ($opnConfig['datasave']['user_images_url']['url'] . '/', '', $UserImage['images_url']);
								if ($UserImage['images_url'] != '') {
									$File = & new opnFile;
									$File->delete_File ($opnConfig['datasave']['user_images_url']['path'] . $UserImage['images_url']);
									$File->delete_File ($opnConfig['datasave']['user_images_url']['path'] . $UserImage['images_url'] . '.opn_tbm_.jpg');
									$delid[] = $UserImage['images_id'];
								}
							}
						}
						$getUserImage->MoveNext ();
					}
					$getUserImage->Close ();
				}
			}
			if (count ($delid) ) {
				$ids = implode (',', $delid);
				if ($opnConfig['permission']->HasRights ('system/user_images', _PERM_ADMIN, true) ) {
					$sql = 'delete FROM ' . $opnTables['user_images_dat'] . ' WHERE images_id IN (' . $ids . ')';
				} else {
					$sql = 'delete FROM ' . $opnTables['user_images_dat'] . ' WHERE (images_user=' . $ui['uid'] . ') AND (images_id IN (' . $ids . '))';
				}
				$opnConfig['database']->Execute ($sql);
			}
		}
		return '';
	}
	$url[0] = $opnConfig['opn_url'] . '/system/user_images/index.php';
	$url['op'] = 'UserImageDelReallyHD';
	$count = 0;
	foreach ($id as $value) {
		$url['id[' . $count . ']'] = $value;
		$count++;
	}
	$url['ok'] = 1;
	$url['offset'] = $offset;
	$url[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
	$url['showuser'] = $showuser;
	$url['showstatus'] = $showstatus;
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">' . _USIG_ADMIN_WARNING2 . '</span>';
	$boxtxt .= '<br /><br />';
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($url) . '">' . _YES . '</a>&nbsp;&nbsp;&nbsp;<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_images/index.php?op=UserImageAdmin') . '">' . _NO . '</a><br /><br /></div>' . _OPN_HTML_NL;
	return $boxtxt;

}

function UserImageDel () {

	global $opnTables, $opnConfig;

	$id = array ();
	get_var ('id', $id,'both',_OOBJ_DTYPE_INT);
	$ok = 0;
	get_var ('ok', $ok, 'url', _OOBJ_DTYPE_INT);
	$sortby = '';
	get_var (_OPN_VAR_TABLE_SORT_VAR, $sortby, 'both', _OOBJ_DTYPE_CLEAN);
	$offset = 0;
	get_var ('offset', $offset, 'both', _OOBJ_DTYPE_INT);
	$showuser = 0;
	get_var ('showuser', $showuser, 'both', _OOBJ_DTYPE_INT);
	$showstatus = 0;
	get_var ('showstatus', $showstatus, 'both', _OOBJ_DTYPE_INT);
	$ui = $opnConfig['permission']->GetUserinfo ();
	if ($ok == 1) {
		if (count ($id) ) {
			$ids = implode (',', $id);
			if ($opnConfig['permission']->HasRights ('system/user_images', _PERM_ADMIN, true) ) {
				$sql = 'UPDATE ' . $opnTables['user_images_dat'] . ' SET images_status = 0 WHERE images_id IN (' . $ids . ')';
			} else {
				$sql = 'UPDATE ' . $opnTables['user_images_dat'] . ' SET images_status = 0 WHERE (images_user=' . $ui['uid'] . ') AND (images_id IN (' . $ids . '))';
			}
			$opnConfig['database']->Execute ($sql);
		}
		return '';
	}
	$boxtxt = '<div class="centertag"><br />';
	$boxtxt .= '<span class="alerttext">' . _USIG_ADMIN_WARNING . '</span>';
	$boxtxt .= '<br /><br />';
	$url[0] = $opnConfig['opn_url'] . '/system/user_images/index.php';
	$url['op'] = 'UserImageDel';
	$count = 0;
	foreach ($id as $value) {
		$url['id[' . $count . ']'] = $value;
		$count++;
	}
	$url['ok'] = 1;
	$url['offset'] = $offset;
	$url[_OPN_VAR_TABLE_SORT_VAR] = $sortby;
	$url['showuser'] = $showuser;
	$url['showstatus'] = $showstatus;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($url) . '">' . _YES . '</a>' . _OPN_HTML_NL;
	$boxtxt .= '&nbsp;&nbsp;&nbsp;' . _OPN_HTML_NL;
	$boxtxt .= '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_images/index.php?op=UserImageAdmin') . '">' . _NO . '</a>' . _OPN_HTML_NL;
	$boxtxt .= '<br /><br /></div>' . _OPN_HTML_NL;
	return $boxtxt;

}

function UserImageAdd () {

	global $opnTables, $opnConfig;

	$ui = $opnConfig['permission']->GetUserinfo ();
	$image_url = '';
	get_var ('image_url', $image_url, 'form', _OOBJ_DTYPE_URL);
	$image_text = '';
	get_var ('image_text', $image_text, 'form', _OOBJ_DTYPE_CLEAN);
	$image_code = '';
	get_var ('image_code', $image_code, 'form', _OOBJ_DTYPE_CLEAN);
	$image_css = '';
	get_var ('image_css', $image_css, 'form', _OOBJ_DTYPE_CLEAN);
	$userupload = 'none';
	get_var ('userupload', $userupload, 'file');
	$skipsave = FALSE;
	$make_tmb = false;
	if (substr_count ($image_url, 'http://')>0) {
		$image_url = $opnConfig['opnSQL']->qstr ($image_url);
	} else {
		// if (!(file_exists($opnConfig['datasave']['user_images_url']['path'].'/'.$image_url))) {
		if ($userupload == '') {
			$userupload = 'none';
		}
		$userupload = check_upload ($userupload);
		if ($userupload <> 'none') {
			require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
			$upload = & new file_upload_class;
			$upload->max_filesize ($opnConfig['opn_upload_size_limit']);
			if ($upload->upload ('userupload', 'image', '') ) {
				if ($upload->save_file ($opnConfig['datasave']['user_images_url']['path'], 3) ) {
					$file = $upload->new_file;
					$filename = $upload->file['name'];
				}
			}
			if (isset ($upload->errors) ) {
				$boxtxt = '';
				foreach ($upload->errors as $var) {
					$boxtxt = '<br /><br />' . $var . '<br />';
					$skipsave = TRUE;
				}
			}
			$make_tmb = true;
		}
		if (isset ($filename) ) {
			$image_url = $filename;
		}
		// }
		$tmb_save_path = $opnConfig['datasave']['user_images_url']['path'] . $image_url . '.opn_tbm_.jpg';

		#		$tmb_load_url = $opnConfig['datasave']['user_images_url']['url'].'/'.$image_url;

		$tmb_load_path = $opnConfig['datasave']['user_images_url']['path'] . $image_url;
		$image_url = $opnConfig['opnSQL']->qstr ($opnConfig['datasave']['user_images_url']['url'] . '/' . $image_url);

		#		$image_path = $opnConfig['opnSQL']->qstr($opnConfig['datasave']['user_images_url']['path'].$image_url);
	}
	if ($skipsave == FALSE) {
		$id = $opnConfig['opnSQL']->get_new_number ('user_images_dat', 'images_id');
		if ($image_code == '') {
			$image_code = $id;
		}
		$image_code = $opnConfig['opnSQL']->qstr ($image_code);
		$image_css = $opnConfig['opnSQL']->qstr ($image_css);
		$image_text = $opnConfig['opnSQL']->qstr ($image_text);
		$opnConfig['database']->Execute ('INSERT INTO ' . $opnTables['user_images_dat'] . " (images_id, images_url, images_text, images_code, images_user, images_status, images_css) VALUES ($id, $image_url,$image_text,$image_code," . $ui['uid'] . ",1, $image_css)");
		if ($opnConfig['database']->ErrorNo ()>0) {
			$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
			return $boxtxt;
		}
		if ($make_tmb) {
			// $temp = $opnConfig['opn_url'].'/system/user_images/show_image.php?filename='.$tmb_load_url.'&newxsize=100&newysize=100&fileout='.$tmb_save_path.'&maxsize=0&bgred=255&bggreen=255&bgblue=255';
			// echo $temp;
			// $boxtxt = '<img src="'.$temp.'" class="imgtag" alt="" />';
			// echo $boxtxt;
			$neu = & new ImgThumb ($tmb_load_path, 100, 100, $tmb_save_path, 0, 255, 255, 255);
		}
	} else {
		return $boxtxt;
	}
	return '';

}

function UserImageSave () {

	global $opnTables, $opnConfig;

	$ui = $opnConfig['permission']->GetUserinfo ();
	$id = 0;
	get_var ('id', $id, 'form', _OOBJ_DTYPE_INT);
	$image_url = '';
	get_var ('image_url', $image_url, 'form', _OOBJ_DTYPE_URL);
	$image_text = '';
	get_var ('image_text', $image_text, 'form', _OOBJ_DTYPE_CLEAN);
	$image_code = '';
	get_var ('image_code', $image_code, 'form', _OOBJ_DTYPE_CLEAN);
	$image_css = '';
	get_var ('image_css', $image_css, 'form', _OOBJ_DTYPE_CLEAN);
	$images_user = 0;
	get_var ('images_user', $images_user, 'form', _OOBJ_DTYPE_INT);
	if ($image_code == '') {
		$image_code = $id;
	}
	$image_url = $opnConfig['opnSQL']->qstr ($image_url);
	$image_text = $opnConfig['opnSQL']->qstr ($image_text);
	$image_css = $opnConfig['opnSQL']->qstr ($image_css);
	$image_code = $opnConfig['opnSQL']->qstr ($image_code);
	if ($opnConfig['permission']->HasRight ('system/user_images', _PERM_ADMIN, true) ) {
		$sql = 'UPDATE ' . $opnTables['user_images_dat'] . " SET images_url = $image_url, images_text = $image_text, images_code = $image_code, images_css = $image_css WHERE (images_id = $id)";
		$opnConfig['database']->Execute ($sql);
		if ($images_user != 0) {
			$sql = 'UPDATE ' . $opnTables['user_images_dat'] . " SET images_user = $images_user WHERE (images_id = $id)";
			$opnConfig['database']->Execute ($sql);
		}
	} else {
		$sql = 'UPDATE ' . $opnTables['user_images_dat'] . " SET images_url = $image_url, images_text = $image_text, images_code = $image_code, images_css = $image_css WHERE (images_user=" . $ui['uid'] . ") AND (images_id = $id)";
		$opnConfig['database']->Execute ($sql);
	}
	if ($opnConfig['database']->ErrorNo ()>0) {
		$boxtxt = $opnConfig['database']->ErrorNo () . ' --- ' . $opnConfig['database']->ErrorMsg () . '<br />';
		return $boxtxt;
	}
	return '';

}
$boxtxt = '';
$op = '';
get_var ('op', $op, 'both', _OOBJ_DTYPE_CLEAN);
if (! ($opnConfig['opnOption']['user_login']) ) {
	$op = 'nologin';
}
switch ($op) {
	case 'nologin':
		$boxtxt .= '';
		break;
	default:
		$boxtxt .= UserImageAdmin ();
		break;
	case 'UserImageAdmin':
		$boxtxt .= UserImageAdmin ();
		break;
	case 'UserImageEdit':
		$boxtxt .= UserImageEdit ();
		break;
	case 'UserImageResize':
		$boxtxt .= UserImageResize ();
		break;
	case 'UserImageResizeDo':
		UserImageResizeDo ();
		$boxtxt .= UserImageAdmin ();
		break;
	case 'UserImageDel':
		$txt = UserImageDel ();
		if ($txt == '') {
			$boxtxt .= UserImageAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserImageDelReally':
		$txt = UserImageDelReally ();
		if ($txt == '') {
			$boxtxt .= UserImageAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserImageDelReallyHD':
		$txt = UserImageDelReallyHD ();
		if ($txt == '') {
			$boxtxt .= UserImageAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserImageAdd':
		$txt = UserImageAdd ();
		if ($txt == '') {
			$boxtxt .= UserImageAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserImageSave':
		$txt = UserImageSave ();
		if ($txt == '') {
			$boxtxt .= UserImageAdmin ();
		} else {
			$boxtxt .= $txt;
		}
		break;
	case 'UserImageShow':
		$boxtxt .= UserImageShow ();
		break;
}
$_display_dat = array ();
$_display_dat['title_help_id'] = '_OPNDOCID_SYSTEM_USER_IMAGES_50_';
$_display_dat['module'] = 'system/user_images';
$opnConfig['opnOutput']->SetDisplay ($_display_dat);
unset ($_display_dat);
$opnConfig['opnOutput']->DisplayContent (_USIG_ADMIN_IMAGES, $boxtxt, '<a class="opncenterbox" href="' . encodeurl ($opnConfig['opn_url'] . '/system/user_images/index.php?op=UserImageAdmin') . '">' . _USIG_ADMIN_CONFIG . '</a>');

?>