<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

function Write_User_Points ($points, $uid) {

	global $opnConfig, $opnTables;

	$sql = 'SELECT id FROM ' . $opnTables['user_points'] . ' WHERE uid=' . $uid;
	$update = 'UPDATE ' . $opnTables['user_points'] . " SET points=$points WHERE uid=$uid";
	$insert = 'INSERT INTO ' . $opnTables['user_points'] . " (id,uid,points) values (%s,$uid,$points)";
	$opnConfig['opnSQL']->ensure_dbwrite ($sql, $update, $insert, 'user_points', 'id');
	unset ($sql);
	unset ($update);
	unset ($insert);

}

function Count_Points ($uid) {

	$cpoints = Count_User_Points_DB ($uid);
	$ppoints = Count_Special_Points ($uid);
	$cpoints += $ppoints;
	Write_User_Points ($cpoints, $uid);
	return $cpoints;

}

function Count_Special_Points ($uid) {

	global $opnConfig, $opnTables;

	$result = &$opnConfig['database']->Execute ('SELECT specialpoints FROM ' . $opnTables['user_points'] . ' WHERE uid=' . $uid);
	if ($result->RecordCount ()>0) {
		$help = $result->fields['specialpoints'];
	} else {
		$help = 0;
	}
	$result->Close ();
	unset ($result);
	return $help;

}

function Count_User_Points_DB ($uid) {

	global $opnConfig, $opnTables;

	$userinfo = $opnConfig['permission']->GetUser ($uid, '', '');
	$date1 = $opnConfig['user_points_date'];
	$getinfos = $opnConfig['database']->Execute ('SELECT tablename, userfield, datefield, uidoruname, points FROM ' . $opnTables['user_points_tables']);
	$getpoints = 0;
	while (! $getinfos->EOF) {
		$tablename = $getinfos->fields['tablename'];
		$userfield = $getinfos->fields['userfield'];
		$datefield = $getinfos->fields['datefield'];
		$uidoruname = $getinfos->fields['uidoruname'];
		$points = $getinfos->fields['points'];
		if ($uidoruname == 1) {
			$unameid = $opnConfig['opnSQL']->qstr ($userinfo['uname']);
		} else {
			$unameid = $uid;
		}
		if ($opnConfig['opnSQL']->isTable ($opnConfig['tableprefix'] . $tablename) ) {
			if (isset ($opnTables[$tablename])) {
				$result = $opnConfig['database']->Execute ('SELECT COUNT(' . $datefield . ') AS counter FROM ' . $opnTables[$tablename] . " WHERE $userfield=$unameid and $datefield>$date1");
				if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
					$pointdate = $result->fields['counter'];
				} else {
					$pointdate = 0;
				}
				$getpoints += ($pointdate* $points);
			}
		}
		$getinfos->MoveNext ();
	}
	$getinfos->Close ();
	unset ($getinfos);
	unset ($userinfo);
	return $getpoints;

}

?>